﻿/**
 * Created by zj on 2015/10/27 0027.
 * ˮ��
 */

var EffectWave = cc.Class.extend({
    ctor:function(){
        this.isActive = false;
        this.renderIndex = 0;
        this.fTime = 0;
        this.activeTime = 0;
        this.blendFunc = {src: cc.BLEND_SRC, dst: cc.BLEND_DST};
        this.resolution = cc.p(cc.winSize.width, cc.winSize.height);
        this._CreateProgram();
    },

    OnWinResize:function(w, h){
        this.resolution.x = w;
        this.resolution.y = h;
    },

    _CreateProgram:function(){
        var program = Filter.GetWaveFullProgram();
        this.uniformResolution = program.getUniformLocationForName("resolution");
        this.uniformTime = program.getUniformLocationForName("time");
        this.shaderProgram = program;
    },

    OnFrame:function(){
        var curTime = TimerUtil.GetTimer();
        this.fTime += (curTime - this.activeTime) / 1000;
        this.activeTime = curTime;
    },

    Active:function(active){
        this.isActive = active;
        this.activeTime = TimerUtil.GetTimer();
        this.fTime = 0;
    },

    Dispose:function(){
        this.shaderProgram = null;
        this.uniformTime = null;
        this.uniformResolution = null;
    }
});