﻿/**
 * Created by zj on 2015/10/22 0022.
 */
var EmitterLineProxy = cc.Class.extend({

    ctor:function(){
        this._oLineLength = null;
        this._listPoints = null;
    },

    SetInitData:function(config){
        this._oLineLength = config.emiterLineLength;
        if (config.emitterPointW > 0){
            this._listPoints = [];
            for ( var i=0; i < config.emitterPointW; ++i)
            {
                this._listPoints.push(new cc.p(0, 0));
            }
        }
    },

    InitParticle:function(p, life){
        var len = this._oLineLength.ToValue(life);
        if (this._listPoints != null)
        {
            var offX = (this._listPoints.length > 1 ? (len / (this._listPoints.length - 1)) : 0);
            var left = -(len >> 1);
            for ( var i=0; i < this._listPoints.length; ++i)
            {
                this._listPoints[i].x = left + offX * i;
                this._listPoints[i].y = 0;
            }

            p.emitterOffX = this._listPoints[p.pointIndex].x;
            p.emitterOffY = this._listPoints[p.pointIndex].y;
        }
        else
        {
            p.emitterOffX = Math.random() * len - (len >> 1);
            p.emitterOffY = 0;
        }
    },

    GetNumPoint:function(){
        return this._listPoints != null ? this._listPoints.length : 1;
    }
})
