﻿


var EffectUtil = EffectUtil || {
	/**命中**/
	ENUM_TYPE_HIT:0,
	/**弹道**/
	ENUM_TYPE_LOCUS:1,
	/**特殊**/
	ENUM_TYPE_OTHER:2, 
	/**场景**/
	ENUM_TYPE_SCENE:3,
	/**施法**/
	ENUM_TYPE_UER:4,
	/**UI**/
	ENUM_TYPE_UI:5,
	/**武器特效**/
	ENUM_TYPE_WEP:6,
	/**buff持续特效**/
	ENUM_TYPE_BUFF:7,
	/**怪物特效**/
	ENUM_TYPE_MONSTER:8,

	oDirMap:null,

	GetEffectUrl:function(type, index, appendDic){
		if (appendDic == undefined || appendDic == null)
			appendDic = "";

		if (this.oDirMap == null) {
			var rootp = "res/animation/effect/";
			this.oDirMap = {};
			this.oDirMap[this.ENUM_TYPE_HIT] = rootp + "hit/";
			this.oDirMap[this.ENUM_TYPE_LOCUS] = rootp + "locus/";
			this.oDirMap[this.ENUM_TYPE_OTHER] = rootp + "other/";
			this.oDirMap[this.ENUM_TYPE_SCENE] = rootp + "scene/";
			this.oDirMap[this.ENUM_TYPE_UER] = rootp + "uer/";
			this.oDirMap[this.ENUM_TYPE_UI] = rootp + "ui/";
			this.oDirMap[this.ENUM_TYPE_WEP] = rootp + "wep/";
			this.oDirMap[this.ENUM_TYPE_BUFF] = rootp + "buff/";
			this.oDirMap[this.ENUM_TYPE_MONSTER] = rootp + "monsters/";
		}
		
		return this.oDirMap[type] + appendDic + (index.toString());
	},

	LevelUpEffect:function( obj ){
		FightUtil.ShowBodySkillEffect( obj, EnumEffectId.PLAYER_LEVEL_UP_UP, false, false, 1, this.ENUM_TYPE_OTHER );
	},

	GetShowEffect:function( effid, type, isStand5 ,lifetime){
        if(effid == null) return

		isStand5 = isStand5 || false;
		if (lifetime == undefined )
		{
			lifetime = 0;
		}
		var eff = SkillEffect.Create(effid, type, isStand5, -1,lifetime, 0);
		return eff;
	}
};