﻿

/*
 * 
 * 场景特效对象，不会被鼠标选中
 * 
 */

var SceneEffectObject = DisplayNode.extend({
	oAnimObject:null,
	oData:null,
	Init:function() {
		this._super();
		this.setName("SceneEffectObject");
		
//		var nd = ToolBase.CreateRectNode(4, 4, cc.color(255,255,128, 255));
//		this.addChild(nd);
	},

	Dispose:function(){
		if (this.oAnimObject != null){
			this.oAnimObject.Dispose();
			this.oAnimObject = null;
		}
		
		this._super();
	},

	OnFrame:function(curTime){	
		// 这里会优化视野外的隐藏吧
	},

	SetData:function(data){
		if (this.bDispose)
			return;
		
		this.oData = data;
		if (data.type == 0){
			if (data.dir == undefined)
				data.dir = MDirection.UP;
			if (data.effecttype == undefined)
				data.effecttype = EffectUtil.ENUM_TYPE_SCENE;
			if (data.actionname == undefined)
				data.actionname = EnumActionName.STAND5;
			
			// 帧动画对象
			this.oAnimObject = new MAnimationObject();
			this.addChild(this.oAnimObject);
			this.SetPixPt(data.pt);
			
			this.oAnimObject.SetResUrlBase(EffectUtil.GetEffectUrl(data.effecttype, data.effectid));
			this.oAnimObject.DoAction(data.actionname, data.dir);
		}
	}

});