﻿/*
 * 场景地面物品
 * tyevlag
 */

var SceneItem = SceneBaseObject.extend({

	_itemIcon:null,
	itemModelId:0,
	ownerId:null,
	worldPos:null,
	itemScale:1,
	Init:function() {
		this._super();
		this.setName("SceneItem");
	},

	Dispose:function(){
		this.worldPos = this._itemIcon.convertToWorldSpace(this._itemIcon.getPosition());
		if(this._itemIcon)
			this._itemIcon.removeFromParent();
		this._super();
		this._itemIcon = null;
	},

	OnRecycle:function(){
		this.worldPos = this._itemIcon.convertToWorldSpace(this._itemIcon.getPosition());
		if(this._itemIcon)
			this._itemIcon.removeFromParent();
		this._super();
		this._itemIcon = null;
	},
	OnRevert:function(){
		this._super();
	},

	OnFrame:function(curTime){
		this._super(curTime);
	},
	
	SetDataWithBean:function(msgb){
		this._super(msgb);

		var info = msgb;

		this.itemModelId = info.itemModelId;
		this.ownerId = info.ownerId;
		this.dropTime = info.dropTime;
		this.intensify = info.intensify;
		this.attributs = info.attributs;
		this.oSid = info.dropGoodsId;
		this.nGid = info.dropGoodsId.toGID();

		var gridpt = ToolMap.PixPt2GridPt(info.x, info.y);
		this.SetServPt(gridpt);
		this.SetGridPt(gridpt);

		if(this._itemIcon)
			this._itemIcon.removeFromParent();
		this._itemIcon = ItemUtil.GetItemIcon( this.itemModelId );
		this._itemIcon.scale = 0.4;
		this.itemScale = this._itemIcon.scale;
		this.addChild(this._itemIcon);
		this.worldPos = this._itemIcon.convertToWorldSpace(this._itemIcon.getPosition());
	}
});