﻿/*
 * 
 * 场景层级管理
 * tyevlag
 * 
 */

var SceneLayerMgr = SceneLayerMgr || {
	oSceneRoot:null,
	
	oLayerMap:null,
	
	oDebugLayer:null,
	
	oLayerBottom:null,
	oLayerMiddle:null,
	oLayerTop:null,
	oLayerName:null,
	
	//private SceneObjSortter objSortter = new SceneObjSortter();
	
	Init:function(gamelayer){
		this.oSceneRoot = new MLLayer();/*new cc.Layer();*/

		gamelayer.addChild(this.oSceneRoot);
		
		this.oLayerMap = new cc.Layer();
		this.oDebugLayer = new cc.Layer();
		this.oLayerBottom = new cc.Layer();
		this.oLayerMiddle = new cc.Layer();
		this.oLayerTop = new cc.Layer();
		this.oLayerName = new cc.Layer();
		this.oSceneRoot.setAnchorPoint(0, 0);
		this.oSceneRoot.addChild(this.oLayerMap);
		if (this.oDebugLayer != null){
			this.oSceneRoot.addChild(this.oDebugLayer);
		}
		
		this.oSceneRoot.addChild(this.oLayerBottom);
		this.oSceneRoot.addChild(this.oLayerMiddle);
		this.oSceneRoot.addChild(this.oLayerTop);
		this.oSceneRoot.addChild(this.oLayerName);
		return this;
	},

	SetLayers:function(top, middle, bottom, nam){
		this.oLayerBottom = bottom;
		this.oLayerMiddle = middle;
		this.oLayerTop = top;
		this.oLayerName = nam;
	},

	OnWinResize:function(w, h){
		this.oSceneRoot.OnWinResize(w, h);
	},

	OnFrame:function(){
		// 最简单的摄像机跟随
		var ltar = Mgr.sceneMap.oMapShow.oLookTarget;
		if (ltar != null){
			var winw = ToolBase.GetWinWidth();
			var winh = ToolBase.GetWinHeight();
			
			var tmpX = -(ltar.x - ( winw / 2 ) );
			var tmpY = -(ltar.y - ( winh / 2 ) );

			if (tmpX > 0)
				tmpX = 0;
			
			if (tmpX < -(Mgr.sceneMap.GetSceneWidth() - winw))
				tmpX = -(Mgr.sceneMap.GetSceneWidth() - winw);

			if (tmpY < winh)
				tmpY = winh;
			
			if (tmpY > (Mgr.sceneMap.GetSceneHeight()))
				tmpY = (Mgr.sceneMap.GetSceneHeight());

			this.oSceneRoot.x = tmpX;
			this.oSceneRoot.y = tmpY;
		}

		this.oSceneRoot.OnFrame();
	},

	SortingMiddleObjByYX:function(){
		//this.oLayerMiddle.sort(objSortter);
	},

	AddMiddle:function(dis){
		this.oLayerMiddle.addChild(dis);
	},

	AddTop:function(dis){
		this.oLayerTop.addChild(dis);
	},

	AddBottom:function(dis){
		this.oLayerBottom.addChild(dis);
	},

	RemoveMiddle:function(dis)
	{
		this.oLayerMiddle.removeChild(dis);
	},

	RemoveTop:function(dis){
		this.oLayerTop.removeChild(dis);
	},

	RemoveBottom:function(dis){
		this.oLayerBottom.removeChild(dis);
	},

	GetMiddle:function(){
		return oLayerMiddle.gameObject;
	}

	
};