var Q_activities_drop = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 索引不要重复（无用） */
        self.q_id = data.ReadInt();
        /** 平台ID列表（37wan|aaa|xxx）不写表示所有平台 */
        self.q_platform = data.ReadString();
        /** 活动ID（写0不检查） */
        self.q_activityid = data.ReadInt();
        /** 开区天数(小于X天不掉落) */
        self.q_openday = data.ReadInt();
        /** 掉落时间范围[[2013],[1],[15,18],[-1],[0,2359],[-1]],如果只写[1,7]表示开区1到7天掉落 年 月区间 日区间 时间   注意：如果不是跨月的话，只需要填一个月就可 如：[[2016],[4],[1,4],[-1],[0,2359],[-1]] */
        self.q_time_interval = data.ReadString();
        /** 掉落道具列表（平均随机一个）[100,222,333,4444,555] */
        self.q_drop_items = data.ReadString();
        /** 掉落几率（分母） */
        self.q_probability = data.ReadInt();
        /** 道具过期时间  2013-1-9 23:59:59 (不写就无设置);5(开服第5天过期) */
        self.q_expired = data.ReadString();
        /** 怪物等级衰减区间，（写0不检查） */
        self.q_monlevel_Interval = data.ReadInt();
        /** 其他 */
        self.q_other = data.ReadString();
        /** 掉落所需怪物最低等级 */
        self.q_monster_level = data.ReadInt();
        /** 掉落拾取方式(0：掉落地面，1：直接进包） */
        self.q_drop_type = data.ReadInt();
        /** 掉落区域（0：通用，1：副本不掉落） */
        self.q_zone = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_activities_drop.list = Q_activities_drop.list|| [];
	/** 配置数据索引*/
	Q_activities_drop.map = Q_activities_drop.map || {};
	
	/** 设置配置数据*/
	Q_activities_drop.SetData = Q_activities_drop.SetData || function( data ){

		var list = Q_activities_drop.list;
		var map = Q_activities_drop.map;

		Q_activities_drop.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_activities_drop();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_activities_drop.GetList = Q_activities_drop.GetList || function(){
		return Q_activities_drop.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_activities_drop.Get = Q_activities_drop.Get || function( id ){
		return Q_activities_drop.map[ id ];
	};
})();