var Q_artifact = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 神器编号 */
        self.q_id = data.ReadInt();
        /** 神器名称 */
        self.q_name = data.ReadString();
        /** 分类（1：虚空之阵，2：失却之阵） */
        self.q_type = data.ReadInt();
        /** 界面排序 */
        self.q_order = data.ReadInt();
        /** 神器图标 */
        self.q_icon = data.ReadInt();
        /** 绑定符鬼ID */
        self.q_ghost = data.ReadInt();
        /** 神器技能 */
        self.q_skill = data.ReadInt();
        /** 生命值 */
        self.q_maxHp = data.ReadInt();
        /** 攻击力 */
        self.q_attack = data.ReadInt();
        /** 防御力 */
        self.q_defense = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadInt();
        /** 神器面板展示用资源模型编号 */
        self.q_ui_show = data.ReadInt();
        /** 神器转换成时装特效编号 */
        self.q_ui_effect = data.ReadInt();
        /** 神器对应人物动作编号 */
        self.q_motion = data.ReadInt();
        /** 场景使用神器资源编号 */
        self.q_sence_show = data.ReadInt();
        /** 神器界面神器名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 神器激活签到次数 */
        self.q_activate_SignIn = data.ReadInt();
        /** 神器激活任务编号 填写任务编号时格式为(实例：01 02 0003，01代表大章节编号，02代表大章节中小章节编号，0003代表任务编号) */
        self.q_activate_task = data.ReadInt();
        /** 神器描述文本 */
        self.q_introduce = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_artifact.list = Q_artifact.list|| [];
	/** 配置数据索引*/
	Q_artifact.map = Q_artifact.map || {};
	
	/** 设置配置数据*/
	Q_artifact.SetData = Q_artifact.SetData || function( data ){

		var list = Q_artifact.list;
		var map = Q_artifact.map;

		Q_artifact.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_artifact();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_artifact.GetList = Q_artifact.GetList || function(){
		return Q_artifact.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_artifact.Get = Q_artifact.Get || function( id ){
		return Q_artifact.map[ id ];
	};
})();