var Q_base_activities = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 活动编号 */
        self.q_id = data.ReadInt();
        /** 活动名称 */
        self.q_name = data.ReadString();
        /** 活动主类型(1-进阶，2-购买，3充值，4消耗，5兑换，1000其他) */
        self.q_maintype = data.ReadInt();
        /** 活动类型，前端用 */
        self.q_type = data.ReadInt();
        /** 活动组合(同一组合只可以完成一个任务) */
        self.q_group = data.ReadInt();
        /** 活动显示类型（1为活动领奖之后不显示，2为活动不可领奖是不显示， 3为1和2组合） */
        self.q_show = data.ReadInt();
        /** 同面板内的活动ID关联 */
        self.q_mainicon = data.ReadString();
        /** （0无奖励，1玩家领取，2账号领取） */
        self.q_reward_type = data.ReadInt();
        /** 区别老新服（1新区,2旧） */
        self.q_server = data.ReadInt();
        /** 是否为推荐活动（0为不推荐，1为推荐） */
        self.q_tuijian = data.ReadInt();
        /** 计数类型（0不限【如果此列为0，则q_times无效】，1每天计数，2活动期间计数） */
        self.q_times_type = data.ReadInt();
        /** 可领奖次数 */
        self.q_times = data.ReadInt();
        /** 世界计数类型（0不限【如果此列为0，则q_world_times无效】，1每天计数，2活动期间计数） */
        self.q_world_type = data.ReadInt();
        /** 世界计数类型 1-单服 2-全服  3为1和2组合 */
        self.q_world_count_type = data.ReadInt();
        /** 世界领奖次数 */
        self.q_world_times = data.ReadInt();
        /** 单服计数类型（0不限【如果此列为0，则q_world_times无效】，1每天计数，2活动期间计数） */
        self.q_server_type = data.ReadInt();
        /** 单服领奖次数 */
        self.q_server_times = data.ReadInt();
        /** 开放时间[[2012],[1,10],[22],[-1],[101,2358],[-1(区间)，-2(开服)，10(间隔时间)]] */
        self.q_timingstart = data.ReadString();
        /** 活动内容介绍 */
        self.q_info = data.ReadString();
        /** 奖励道具（道具ID,数量,性别（0通，1男，2女）,绑定（0,1绑定）,(1212311059消失时间),强化等级,附加属性(类型|值);道具ID,数量） */
        self.q_items = data.ReadString();
        /** 充值送活动配置 */
        self.q_chongzhi = data.ReadString();
        /** 消耗送活动配置 */
        self.q_xiaohao = data.ReadString();
        /** 进阶送活动配置 */
        self.q_jinjie = data.ReadString();
        /** 兑换活动配置 */
        self.q_duihuan = data.ReadString();
        /** 商城活动配置 */
        self.q_shangcheng = data.ReadString();
        /** 排行榜活动配置 */
        self.q_paihang = data.ReadString();
        /** 消耗排行榜活动配置 */
        self.q_xiaohaopaihang = data.ReadString();
        /** 链接活动配置 */
        self.q_lianjie = data.ReadString();
        /** 类型检测 */
        self.q_flag = data.ReadString();
        /** 活动资源控制 */
        self.q_resflag = data.ReadString();
        /** 检测系统判断是否开启活动（例：1（检测骑兵活动是否开启——1;2（检测骑兵，暗器是否开启，必须全部开启才能显示活动） */
        self.q_system_examine = data.ReadString();
        /** 检测活动是否有分页。（例： [1,坐骑排行榜] 表示：[分页，分页的名字]） */
        self.q_pagination = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_base_activities.list = Q_base_activities.list|| [];
	/** 配置数据索引*/
	Q_base_activities.map = Q_base_activities.map || {};
	
	/** 设置配置数据*/
	Q_base_activities.SetData = Q_base_activities.SetData || function( data ){

		var list = Q_base_activities.list;
		var map = Q_base_activities.map;

		Q_base_activities.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_base_activities();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_base_activities.GetList = Q_base_activities.GetList || function(){
		return Q_base_activities.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_base_activities.Get = Q_base_activities.Get || function( id ){
		return Q_base_activities.map[ id ];
	};
})();