var Q_chapter_append = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 章节ID */
        self.q_chapter = data.ReadInt();
        /** 本章节完成后获得 */
        self.q_name = data.ReadString();
        /** 增加血量上限 */
        self.q_maxhp = data.ReadInt();
        /** 增加内力上限 */
        self.q_maxmp = data.ReadInt();
        /** 增加体力上限 */
        self.q_maxsp = data.ReadInt();
        /** 增加攻击 */
        self.q_attack = data.ReadInt();
        /** 增加防御 */
        self.q_defence = data.ReadInt();
        /** 增加闪避 */
        self.q_dodge = data.ReadInt();
        /** 增加暴击 */
        self.q_crit = data.ReadInt();
        /** 增加幸运 */
        self.q_luck = data.ReadInt();
        /** 增加攻速 */
        self.q_attack_speed = data.ReadInt();
        /** 增加移速 */
        self.q_movespeed = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_chapter_append.list = Q_chapter_append.list|| [];
	/** 配置数据索引*/
	Q_chapter_append.map = Q_chapter_append.map || {};
	
	/** 设置配置数据*/
	Q_chapter_append.SetData = Q_chapter_append.SetData || function( data ){

		var list = Q_chapter_append.list;
		var map = Q_chapter_append.map;

		Q_chapter_append.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_chapter_append();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_chapter)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_chapter_append.GetList = Q_chapter_append.GetList || function(){
		return Q_chapter_append.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_chapter_append.Get = Q_chapter_append.Get || function( id ){
		return Q_chapter_append.map[ id ];
	};
})();