var Q_cloak = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 披风编号 */
        self.q_id = data.ReadInt();
        /** 披风名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 披风界面披风名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 是否可被攻击(0不允许，1允许） */
        self.q_hit = data.ReadInt();
        /** 被攻击最大损失血量（无论是什么攻击都仅扣除1滴血） */
        self.q_hp_lose = data.ReadInt();
        /** 披风头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 披风面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用披风造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 披风特效 */
        self.q_effect = data.ReadInt();
        /** 披风描述文本 */
        self.q_introduce = data.ReadString();
        /** 对应的技能格子的技能可被激活 */
        self.q_skill = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_cloak.list = Q_cloak.list|| [];
	/** 配置数据索引*/
	Q_cloak.map = Q_cloak.map || {};
	
	/** 设置配置数据*/
	Q_cloak.SetData = Q_cloak.SetData || function( data ){

		var list = Q_cloak.list;
		var map = Q_cloak.map;

		Q_cloak.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_cloak();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_cloak.GetList = Q_cloak.GetList || function(){
		return Q_cloak.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_cloak.Get = Q_cloak.Get || function( id ){
		return Q_cloak.map[ id ];
	};
})();