var Q_clone_activity = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 副本编号 */
        self.q_id = data.ReadInt();
        /** 副本类型(小标签)，1小地图副本，2活动日常,3多人活动，4七曜，5跨服6经典战役 */
        self.q_zone_type = data.ReadInt();
        /** 副本关联地图编号[xxxx,xxxx] */
        self.q_mapid = data.ReadString();
        /** 副本名称（支持HTML） */
        self.q_duplicate_name = data.ReadString();
        /** 副本存在时间（毫秒） */
        self.q_exist_time = data.ReadInt();
        /** 开放时间 */
        self.q_open_time = data.ReadString();
        /** 副本重置时间(type=1日，2=周，3=月)time=秒数 */
        self.q_reset_time = data.ReadString();
        /** 进入所需最小等级 */
        self.q_min_lv = data.ReadInt();
        /** 最高等级进入限制 */
        self.q_max_lv = data.ReadInt();
        /** 进入最少人数限制 */
        self.q_min_num = data.ReadInt();
        /** 进入最多人数限制 */
        self.q_max_num = data.ReadInt();
        /** 进入状态（1为单人，2为组队，3为单人组队不限，4为报名，5为报名组队） */
        self.q_type = data.ReadInt();
        /** 每日手动挑战次数(-1表示未开放) */
        self.q_manual_num = data.ReadInt();
        /** 每日扫荡次数 */
        self.q_raids_num = data.ReadInt();
        /** 扫荡收取元宝 */
        self.q_raids_yuanbao = data.ReadInt();
        /** 扫荡每分钟所需元宝 */
        self.q_raids_min_yuanbao = data.ReadInt();
        /** 通关奖励(-1到-5)和ITEM表里的对应(-1铜币，-2元宝，-3真气，-4经验  -5绑定元宝，-10声望) */
        self.q_reward = data.ReadString();
        /** 副本时间评价（填写时间，精确到毫秒，如果玩家通关时间小于填写时间，则获得一颗星） */
        self.q_time_evaluate = data.ReadInt();
        /** 副本说明（支持HTML） */
        self.q_explain = data.ReadString();
        /** 进入地图的默认坐标x */
        self.q_x = data.ReadInt();
        /** 进入地图的默认坐标y */
        self.q_y = data.ReadInt();
        /** 是否调用脚本,1调用，0不用 */
        self.q_isscript = data.ReadInt();
        /** 活动参与奖励 */
        self.q_Participation_Award = data.ReadString();
        /** 通关随机奖励描述 */
        self.q_Random_Description = data.ReadString();
        /** 地图存在的BOSS（BOSSid,x,y） */
        self.q_map_boss = data.ReadString();
        /** 是否分为多组，0不分组，>1 表示分为几组 */
        self.q_map_group = data.ReadInt();
        /** 首通奖励 */
        self.q_first_reward = data.ReadString();
        /** 沙场百战帮助人奖励 */
        self.q_helper_reward = data.ReadString();
        /** 推荐战斗力 */
        self.q_combat_power = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_clone_activity.list = Q_clone_activity.list|| [];
	/** 配置数据索引*/
	Q_clone_activity.map = Q_clone_activity.map || {};
	
	/** 设置配置数据*/
	Q_clone_activity.SetData = Q_clone_activity.SetData || function( data ){

		var list = Q_clone_activity.list;
		var map = Q_clone_activity.map;

		Q_clone_activity.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_clone_activity();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_clone_activity.GetList = Q_clone_activity.GetList || function(){
		return Q_clone_activity.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_clone_activity.Get = Q_clone_activity.Get || function( id ){
		return Q_clone_activity.map[ id ];
	};
})();