var Q_ghost_addition = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 神器等阶_属性位 */
        self.q_id = data.ReadString();
        /** 神器ID */
        self.q_ghost = data.ReadInt();
        /** 神器阶数 */
        self.q_level = data.ReadInt();
        /** 神器属性位 */
        self.q_num = data.ReadInt();
        /** 生命值 */
        self.q_maxHp = data.ReadInt();
        /** 攻击力 */
        self.q_attack = data.ReadInt();
        /** 防御力 */
        self.q_defense = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadInt();
        /** 激活所需真气 */
        self.q_gas = data.ReadInt();
        /** 激活所需银两 */
        self.q_cost = data.ReadInt();
        /** 激活成功率（百分比分子） */
        self.q_success = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_ghost_addition.list = Q_ghost_addition.list|| [];
	/** 配置数据索引*/
	Q_ghost_addition.map = Q_ghost_addition.map || {};
	
	/** 设置配置数据*/
	Q_ghost_addition.SetData = Q_ghost_addition.SetData || function( data ){

		var list = Q_ghost_addition.list;
		var map = Q_ghost_addition.map;

		Q_ghost_addition.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_ghost_addition();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_ghost_addition.GetList = Q_ghost_addition.GetList || function(){
		return Q_ghost_addition.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_ghost_addition.Get = Q_ghost_addition.Get || function( id ){
		return Q_ghost_addition.map[ id ];
	};
})();