var Q_gift = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 礼包ID */
        self.q_gift_id = data.ReadInt();
        /** 消耗货币 格式：[[货币类型,货币数量],[货币类型,货币数量]] */
        self.q_money = data.ReadString();
        /** 开启宝箱所需道具JON 字符串 */
        self.q_need_item = data.ReadString();
        /** 礼包类型(1：进阶材料礼包   2：选择礼包) */
        self.q_gift_type = data.ReadInt();
        /** 标题美术资源 */
        self.q_title = data.ReadString();
        /** 面板描述文本信息 */
        self.q_introduce = data.ReadString();
        /** 全部给予，格式：JSON字符串（默认给予，付费礼包的为免费给予） */
        self.q_gift_data = data.ReadString();
        /** 付费给予 */
        self.q_gift_data_gold = data.ReadString();
        /** 互斥随机道具(格式：几率_JSON字符串；几率_JSON字符串) 几率分母为几率合  */
        self.q_huchi_random_gift_data = data.ReadString();
        /** 互相独立随机道具(格式：几率_JSON字符串；几率_JSON字符串) 几率分母为 10000 都没随机则给予几率最高的道具。 */
        self.q_random_gift_data = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_gift.list = Q_gift.list|| [];
	/** 配置数据索引*/
	Q_gift.map = Q_gift.map || {};
	
	/** 设置配置数据*/
	Q_gift.SetData = Q_gift.SetData || function( data ){

		var list = Q_gift.list;
		var map = Q_gift.map;

		Q_gift.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_gift();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_gift_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_gift.GetList = Q_gift.GetList || function(){
		return Q_gift.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_gift.Get = Q_gift.Get || function( id ){
		return Q_gift.map[ id ];
	};
})();