var Q_goldenbody = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 金身等阶_属性点顺序 */
        self.q_id = data.ReadString();
        /** 金身等阶 */
        self.q_level = data.ReadInt();
        /** 属性点顺序 */
        self.q_order = data.ReadInt();
        /** 激活所需材料ID */
        self.q_item = data.ReadInt();
        /** 激活所需材料数量 */
        self.q_num = data.ReadInt();
        /** 激活所需玩家等级 */
        self.q_role_level = data.ReadInt();
        /** 生命值 */
        self.q_maxHp = data.ReadInt();
        /** 攻击力 */
        self.q_attack = data.ReadInt();
        /** 防御力 */
        self.q_defense = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_goldenbody.list = Q_goldenbody.list|| [];
	/** 配置数据索引*/
	Q_goldenbody.map = Q_goldenbody.map || {};
	
	/** 设置配置数据*/
	Q_goldenbody.SetData = Q_goldenbody.SetData || function( data ){

		var list = Q_goldenbody.list;
		var map = Q_goldenbody.map;

		Q_goldenbody.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_goldenbody();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_goldenbody.GetList = Q_goldenbody.GetList || function(){
		return Q_goldenbody.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_goldenbody.Get = Q_goldenbody.Get || function( id ){
		return Q_goldenbody.map[ id ];
	};
})();