var Q_item_forge = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 物品ID */
        self.q_item_id = data.ReadInt();
        /** 主标签页 */
        self.q_main_type = data.ReadInt();
        /** 主标签页名字 */
        self.q_main_name = data.ReadString();
        /** 合成级别 */
        self.q_level = data.ReadInt();
        /** 名字 */
        self.q_name = data.ReadString();
        /** 显示所需职业（0通用，1：男角色，2：女角色） */
        self.q_job = data.ReadInt();
        /** 合成主材料 */
        self.q_material_main = data.ReadInt();
        /** 主材料数量 */
        self.q_material_main_num = data.ReadInt();
        /** 副材料1 */
        self.q_material_minor_one = data.ReadInt();
        /** 副材料1数量 */
        self.q_material_minor_one_num = data.ReadInt();
        /** 副材料2 */
        self.q_material_minor_two = data.ReadInt();
        /** 副材料2数量 */
        self.q_material_minor_two_num = data.ReadInt();
        /** 合成成功率（万分比分子） */
        self.q_success = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_item_forge.list = Q_item_forge.list|| [];
	/** 配置数据索引*/
	Q_item_forge.map = Q_item_forge.map || {};
	
	/** 设置配置数据*/
	Q_item_forge.SetData = Q_item_forge.SetData || function( data ){

		var list = Q_item_forge.list;
		var map = Q_item_forge.map;

		Q_item_forge.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_item_forge();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_item_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_item_forge.GetList = Q_item_forge.GetList || function(){
		return Q_item_forge.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_item_forge.Get = Q_item_forge.Get || function( id ){
		return Q_item_forge.map[ id ];
	};
})();