var Q_lucky_draw = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 顺序 */
        self.q_id = data.ReadInt();
        /** 寻宝类型（1：元宝寻宝，2：神机宝箱   3 幸运抽奖  4:开服充值抽奖  5：正常充值抽奖  6:金鼓助威） */
        self.q_type = data.ReadInt();
        /** 道具生成 */
        self.q_item_set = data.ReadString();
        /** 掉落比重 */
        self.q_rate = data.ReadInt();
        /** 寻宝次数间隔进入掉落列表 */
        self.q_possible_period = data.ReadInt();
        /** 最多叠加次数 */
        self.q_max_total = data.ReadInt();
        /** 寻宝次数间隔必定出该道具 */
        self.q_sure_period = data.ReadInt();
        /** 首次掉落该道具所需寻宝次数（仅生效一次，总次数重置后才可继续生效） */
        self.q_first_period = data.ReadInt();
        /** 掉落所需最低等级 */
        self.q_level_min = data.ReadInt();
        /** 掉落所需最高等级 */
        self.q_level_max = data.ReadInt();
        /** 掉落所需服务器开服天数 [初始天数（包含），结束天数（包含)] */
        self.q_server_day = data.ReadString();
        /** 是否公告（1：本服公告，0：否  2：全平台） */
        self.q_notice = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_lucky_draw.list = Q_lucky_draw.list|| [];
	/** 配置数据索引*/
	Q_lucky_draw.map = Q_lucky_draw.map || {};
	
	/** 设置配置数据*/
	Q_lucky_draw.SetData = Q_lucky_draw.SetData || function( data ){

		var list = Q_lucky_draw.list;
		var map = Q_lucky_draw.map;

		Q_lucky_draw.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_lucky_draw();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_lucky_draw.GetList = Q_lucky_draw.GetList || function(){
		return Q_lucky_draw.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_lucky_draw.Get = Q_lucky_draw.Get || function( id ){
		return Q_lucky_draw.map[ id ];
	};
})();