var Q_magical_addition = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** id=神兵编号_星阶 */
        self.q_id = data.ReadString();
        /** 神兵名称 */
        self.q_name = data.ReadString();
        /** 神兵编号 */
        self.q_modelID = data.ReadInt();
        /** 神兵星级阶数 */
        self.q_level = data.ReadInt();
        /** 神兵技能编号 */
        self.q_skillId = data.ReadInt();
        /** 基础生命值 */
        self.q_maxHp = data.ReadInt();
        /** 基础物理攻击 */
        self.q_attack = data.ReadInt();
        /** 基础物理防御 */
        self.q_defense = data.ReadInt();
        /** 基础魔法攻击 */
        self.q_magAttack = data.ReadInt();
        /** 基础魔法防御 */
        self.q_magDefense = data.ReadInt();
        /** 生命值成长率（百分比的分子） */
        self.q_growth_maxHp = data.ReadInt();
        /** 物理攻击成长率（百分比的分子） */
        self.q_growth_attack_physical = data.ReadInt();
        /** 物理防御成长率（百分比的分子） */
        self.q_growth_defense_physical = data.ReadInt();
        /** 魔法攻击成长率（百分比的分子） */
        self.q_growth_attack_magic = data.ReadInt();
        /** 魔法防御成长率（百分比的分子） */
        self.q_growth_defence_magic = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_magical_addition.list = Q_magical_addition.list|| [];
	/** 配置数据索引*/
	Q_magical_addition.map = Q_magical_addition.map || {};
	
	/** 设置配置数据*/
	Q_magical_addition.SetData = Q_magical_addition.SetData || function( data ){

		var list = Q_magical_addition.list;
		var map = Q_magical_addition.map;

		Q_magical_addition.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_magical_addition();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_magical_addition.GetList = Q_magical_addition.GetList || function(){
		return Q_magical_addition.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_magical_addition.Get = Q_magical_addition.Get || function( id ){
		return Q_magical_addition.map[ id ];
	};
})();