var Q_map_bonus = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 地图ID */
        self.q_id = data.ReadInt();
        /** 添加类型（1：固定增长，2：打坐倍数） */
        self.q_type = data.ReadInt();
        /** 间隔时间(单位：秒） */
        self.q_period = data.ReadInt();
        /** 自动增加经验 */
        self.q_exp = data.ReadInt();
        /** 打坐收益倍数（此处与打坐无关，仅取打坐的配置数据作为地图停留奖励的依据） */
        self.q_rest_time = data.ReadInt();
        /** 进入地图添加BUFF（退出地图删除） */
        self.q_buff = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_map_bonus.list = Q_map_bonus.list|| [];
	/** 配置数据索引*/
	Q_map_bonus.map = Q_map_bonus.map || {};
	
	/** 设置配置数据*/
	Q_map_bonus.SetData = Q_map_bonus.SetData || function( data ){

		var list = Q_map_bonus.list;
		var map = Q_map_bonus.map;

		Q_map_bonus.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_map_bonus();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_map_bonus.GetList = Q_map_bonus.GetList || function(){
		return Q_map_bonus.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_map_bonus.Get = Q_map_bonus.Get || function( id ){
		return Q_map_bonus.map[ id ];
	};
})();