var Q_map_transfer = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 传送点编号 */
        self.q_tran_id = data.ReadInt();
        /** 开始传送地图ID */
        self.q_tran_from_map = data.ReadInt();
        /** 传送出发点坐标X */
        self.q_tran_from_x = data.ReadInt();
        /** 传送出发点坐标Y */
        self.q_tran_from_y = data.ReadInt();
        /** 触发范围半径(格子） */
        self.q_tran_from_range = data.ReadInt();
        /** 传送至地图ID */
        self.q_tran_to_map = data.ReadInt();
        /** 传送至坐标点x */
        self.q_tran_to_x = data.ReadInt();
        /** 传送至坐标点y */
        self.q_tran_to_y = data.ReadInt();
        /** 范围半径(格子） */
        self.q_tran_to_range = data.ReadInt();
        /** 传送点造型资源编号 */
        self.q_tran_icon = data.ReadString();
        /** 是否隐藏传送点（1是隐藏，0是不隐藏） */
        self.q_tran_hide = data.ReadInt();
        /** 地图名称描述（小地图TIPS，支持xml） */
        self.q_mapdesc = data.ReadInt();
        /** 传送类型 */
        self.q_tran_type = data.ReadInt();
        /** 脚本调用（填写后传送至坐标点将无效） */
        self.q_scriptid = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_map_transfer.list = Q_map_transfer.list|| [];
	/** 配置数据索引*/
	Q_map_transfer.map = Q_map_transfer.map || {};
	
	/** 设置配置数据*/
	Q_map_transfer.SetData = Q_map_transfer.SetData || function( data ){

		var list = Q_map_transfer.list;
		var map = Q_map_transfer.map;

		Q_map_transfer.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_map_transfer();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_tran_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_map_transfer.GetList = Q_map_transfer.GetList || function(){
		return Q_map_transfer.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_map_transfer.Get = Q_map_transfer.Get || function( id ){
		return Q_map_transfer.map[ id ];
	};
})();