var Q_mission_base = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 任务主id(10000-20000）主线 30000剧情，40000、60000 日常50000、70000帮会日常  */
        self.q_mission_id = data.ReadInt();
        /** 任务名称 */
        self.q_name = data.ReadString();
        /** 章节ID */
        self.q_party_id = data.ReadInt();
        /** 章节名 */
        self.q_party_name = data.ReadString();
        /** 任务名称 */
        self.q_mission_name = data.ReadString();
        /** 任务类型(1主线2日常3帮常4卷轴5支线任务) */
        self.q_mission_mainType = data.ReadInt();
        /** 自动接取的下一个任务ID 0是没有 */
        self.q_next_task = data.ReadInt();
        /** 任务接取条件1——玩家等级（填0 表示没有等级条件限制） */
        self.q_needLevel = data.ReadInt();
        /** 任务接取条件2——前置任务id（前置任务完成时才可接取该任务，填0表示没有前置任务） */
        self.q_needMission = data.ReadInt();
        /** 任务子类型（1为对话类型，2杀怪数量，3杀怪获得道具，4采集获取道具,5使用道具完成任务,6挑战副本（进入即完成）,7挑战副本（通关完成））2/4/6/7类型任务均需自动完成及接取 */
        self.q_mission_type = data.ReadInt();
        /** 任务完成条件,数值类 */
        self.q_finish_information_int = data.ReadInt();
        /** 任务完成条件,字符串类型(道具ID或者怪物ID,数量)(1001,1;1002,1)（副本ID，次数） */
        self.q_finish_information_str = data.ReadString();
        /** 完成任务后是否没收任务道具(0没收,1不收) */
        self.q_finish_iscollectitem = data.ReadInt();
        /** 完成任务需求文字描述  【  为下划线】 */
        self.q_finish_describe = data.ReadString();
        /** 自动寻路信息（地图ID,X,Y,x,y;地图ID,X,Y)需传送用;分开填写坐标即可 */
        self.q_pathing = data.ReadString();
        /** 前段用寻路方式（[[地图ID,[寻路方式,[寻路坐标],寻路方式,[寻路坐标],寻路方式,[寻路坐标]]],[地图ID,[寻路方式,[寻路坐标],寻路方式,[寻路坐标],寻路方式,[寻路坐标]]]]） */
        self.q_coordinate = data.ReadString();
        /** 任务奖励信息id(调用t_mission_reword表) */
        self.q_reword_id = data.ReadInt();
        /** 接任务阶段信息的对话（任务对话id。可配置多个id‘,’隔开） */
        self.q_receive_mission = data.ReadString();
        /** 接任务阶段气泡信息（填写对话气泡id，分割） */
        self.q_receive_bubble = data.ReadString();
        /** 进行中而未完成任务对话信息（当任务处于进行中而未完成状态时，点击完成任务npc时显示的对话信息） */
        self.q_undeal_mission = data.ReadString();
        /** 任务中的冒泡 */
        self.q_undeal_bubble = data.ReadString();
        /** 任务完成阶段信息（任务对话id） */
        self.q_deal_mission = data.ReadString();
        /** 任务完成阶段气泡信息（填写对话气泡id，可填写多个） */
        self.q_deal_bubble = data.ReadString();
        /** 任务描述（可控制部分字体颜色，使用<font color='16进制颜色'>文本</font>） */
        self.q_describe = data.ReadString();
        /** 接受时显示npc(逗号隔开) */
        self.q_acc_show_npc = data.ReadString();
        /** 接受时隐藏npc */
        self.q_acc_hide_npc = data.ReadString();
        /** 完成时显示npc */
        self.q_end_show_npc = data.ReadString();
        /** 完成时隐藏npc */
        self.q_end_hide_npc = data.ReadString();
        /** 达成条件后显示npc */
        self.q_accomplish_show_npc = data.ReadString();
        /** 达成条件后隐藏npc */
        self.q_accomplish_hide_npc = data.ReadString();
        /** 接任务后的剧情怪物(怪物ID,数量,地图,ID,坐标),如果只写怪物ID,就会在接任务后在玩家附近刷1个怪物 */
        self.q_drama_monster = data.ReadString();
        /** 任务完成时限(秒,0无时限) */
        self.q_time_limit = data.ReadInt();
        /** 组包ID（1：主线任务，2：日常任务，3：帮会任务，5支线任务） */
        self.q_group = data.ReadInt();
        /** 一个周期内可接次数 */
        self.q_accept = data.ReadInt();
        /** 一个周期内可完成次数 */
        self.q_completions = data.ReadInt();
        /** 任务重置周期,0永久,1每天,2每周,3每月 */
        self.q_reset_period = data.ReadInt();
        /** 是否可重复完成 */
        self.q_complete_more = data.ReadInt();
        /** 是否可重复接受 */
        self.q_accept_more = data.ReadInt();
        /** 是否自动完成 */
        self.q_self_motion = data.ReadInt();
        /** 是否自动接取下一个（后端自动接取） */
        self.q_auto_next = data.ReadInt();
        /** 是否自动跑（0自动继续任务，1跑到指定位置打怪） */
        self.q_auto_run = data.ReadInt();
        /** 对话美术字ID（NPC任务对话时主界面显示，有就配，没有不配） */
        self.q_npcword = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_mission_base.list = Q_mission_base.list|| [];
	/** 配置数据索引*/
	Q_mission_base.map = Q_mission_base.map || {};
	
	/** 设置配置数据*/
	Q_mission_base.SetData = Q_mission_base.SetData || function( data ){

		var list = Q_mission_base.list;
		var map = Q_mission_base.map;

		Q_mission_base.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_mission_base();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_mission_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_mission_base.GetList = Q_mission_base.GetList || function(){
		return Q_mission_base.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_mission_base.Get = Q_mission_base.Get || function( id ){
		return Q_mission_base.map[ id ];
	};
})();