var Q_monster = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 怪物ID */
        self.q_id = data.ReadInt();
        /** 怪物名字 */
        self.q_name = data.ReadString();
        /** 默认是否显示名字（1是，0否）显示名字会默认显示血条非BOSS类不要显示 */
        self.q_monster_dropdesc = data.ReadString();
        /** 是否在小地图中显示（1是，2否） */
        self.q_isminimap = data.ReadInt();
        /** 怪物类型(1普通小怪,2精英,3世界野外BOSS,4只跑不打,5帮会野外BOSS) */
        self.q_monster_type = data.ReadInt();
        /** 怪物掉落归属（0：最后一击，1：伤害排行最高玩家，2：无主掉落，3：服务器最高伤害掉落归属   4：个人拾取 ）    类型为1的为 15秒最高伤害 */
        self.q_drop_type = data.ReadInt();
        /** 掉落是否自动进包（0：否，1;是) */
        self.q_is_enter_bag = data.ReadInt();
        /** 怪物攻击模式(1主动攻击,2被动攻击，3木桩类怪物) */
        self.q_evasive_style = data.ReadInt();
        /** 怪物造型资源编号 */
        self.q_sculpt_resid = data.ReadString();
        /** 怪物头像资源编号（注意：精英怪 取普通怪的ID） */
        self.q_head_resid = data.ReadString();
        /** 攻击时音效编号（怪物模型ID_10) */
        self.q_fire_soundid = data.ReadString();
        /** 被攻击时音效编号(怪物模型ID_30) */
        self.q_underfire_soundid = data.ReadString();
        /** 死亡时音效编号(怪物模型ID_20) */
        self.q_die_soundid = data.ReadString();
        /** 方向是否固定(-2固定方向前端控制,-1随机方向，0-7顺时针方向后端控制0朝向12点钟方向，4朝向6点钟方向) */
        self.q_is_direction_fixed = data.ReadInt();
        /** 怪物在场景中的发言频率间隔(单位：毫秒) */
        self.q_tosay_timeinterval = data.ReadInt();
        /** 怪物在场景中的发言内容(多句以分号分隔) */
        self.q_say_condition = data.ReadString();
        /** 怪物血量倍数（0：不加倍，1：加1倍，2：加2倍，类推）处理大于20Y血量的情况 */
        self.q_hprate = data.ReadInt();
        /** 怪物等级 */
        self.q_grade = data.ReadInt();
        /** 生命值 */
        self.q_maxhp = data.ReadLong();
        /** 无视防御伤害 */
        self.q_holyDamage = data.ReadInt();
        /** BUFF免疫类型（格式：[类型1，类型2] */
        self.q_immunity_buff = data.ReadString();
        /** 攻击力 */
        self.q_attack = data.ReadLong();
        /** 防御力 */
        self.q_defense = data.ReadLong();
        /** 暴击值 */
        self.q_crt = data.ReadLong();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadLong();
        /** 命中值 */
        self.q_hit = data.ReadLong();
        /** 闪避值 */
        self.q_dodge = data.ReadLong();
        /** 攻击速度 */
        self.q_attack_speed = data.ReadInt();
        /** 移动速度 */
        self.q_speed = data.ReadInt();
        /** 怪物生命恢复方式（0不恢复，1脱离战斗恢复，2掉血后就持续恢复,3表示脱离战斗后持续恢复生命） */
        self.q_recover_hp_type = data.ReadInt();
        /** 怪物恢复血量的间隔(单位：毫秒） */
        self.q_recover_hp_period = data.ReadInt();
        /** 怪物间隔时间恢复的生命值 */
        self.q_auto_recover_hp = data.ReadInt();
        /** 视野距离半径(单位：格子数) */
        self.q_eyeshot = data.ReadInt();
        /** 巡逻距离半径(单位：格子数) */
        self.q_patrol = data.ReadInt();
        /** 巡逻间隔时间（毫秒） */
        self.q_patrol_time = data.ReadInt();
        /** 巡逻几率（万分比）最高不能超过2000 */
        self.q_patrol_pro = data.ReadInt();
        /** 追击距离半径(单位：格子数)本距离值不得小于怪物的巡逻距离值   0：不追踪    -1：不返回出生点 */
        self.q_pursuit = data.ReadInt();
        /** 怪物攻击时使用的默认技能(格式：技能ID_技能等级） */
        self.q_default_skill = data.ReadString();
        /** 怪物使用的特殊技能ID与触发几率列表（格式：技能ID_技能等级|触发权重;技能ID_技能等级|触发权重;） */
        self.q_special_skill = data.ReadString();
        /** 怪物被攻击时是否固定少血(0否,1是) */
        self.q_fixed_hurt = data.ReadInt();
        /** 怪物被攻击时固定少血值 */
        self.q_fiexd_value = data.ReadInt();
        /** 怪物携带经验 */
        self.q_carry_exp = data.ReadInt();
        /** 是否排除在经验衰减规则之外（1不排除，0排除在经验衰减规则之外） */
        self.q_isexclude = data.ReadInt();
        /** BOSS类怪物，固定刷新时间定义[年][月][日][周][11:10-12:00] */
        self.q_refreshtime = data.ReadString();
        /** 怪物的重生时间(单位：秒) */
        self.q_revive_time = data.ReadInt();
        /** 怪物存活时间 */
        self.q_survival_time = data.ReadInt();
        /** 关联的AI脚本ID */
        self.q_script_id = data.ReadInt();
        /** 是否同步显示详细信息（是否显示在BOSS争夺界面） */
        self.q_info_sync = data.ReadInt();
        /** 是否统计显示伤害排行榜(0:不统计，1：统计并前端显示，2：统计但不显示） */
        self.q_rank_show = data.ReadInt();
        /** 是否计入排行榜BOSS击杀(0:不，1：是） */
        self.q_kill = data.ReadInt();
        /** 造型是否翻转（0：否，1：是） */
        self.q_exchange = data.ReadInt();
        /** BOSS技能AI */
        self.q_ai = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_monster.list = Q_monster.list|| [];
	/** 配置数据索引*/
	Q_monster.map = Q_monster.map || {};
	
	/** 设置配置数据*/
	Q_monster.SetData = Q_monster.SetData || function( data ){

		var list = Q_monster.list;
		var map = Q_monster.map;

		Q_monster.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_monster();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_monster.GetList = Q_monster.GetList || function(){
		return Q_monster.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_monster.Get = Q_monster.Get || function( id ){
		return Q_monster.map[ id ];
	};
})();