var Q_monster_dropgroup = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 组包编号 */
        self.q_id = data.ReadInt();
        /** 组包内容按照顺序掉落(填写格式：物品1；物品2；物品3） */
        self.q_groups = data.ReadString();
        /** 时间类型（0：永久，1：天，2：周） */
        self.q_time_type = data.ReadInt();
        /** 每日显示掉落次数（24时重置次数） */
        self.q_time = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_monster_dropgroup.list = Q_monster_dropgroup.list|| [];
	/** 配置数据索引*/
	Q_monster_dropgroup.map = Q_monster_dropgroup.map || {};
	
	/** 设置配置数据*/
	Q_monster_dropgroup.SetData = Q_monster_dropgroup.SetData || function( data ){

		var list = Q_monster_dropgroup.list;
		var map = Q_monster_dropgroup.map;

		Q_monster_dropgroup.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_monster_dropgroup();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_monster_dropgroup.GetList = Q_monster_dropgroup.GetList || function(){
		return Q_monster_dropgroup.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_monster_dropgroup.Get = Q_monster_dropgroup.Get || function( id ){
		return Q_monster_dropgroup.map[ id ];
	};
})();