var Q_qqshare_quest = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** id */
        self.q_id = data.ReadInt();
        /** 领奖类型（0：1次性任务；1：每天） */
        self.q_reward_type = data.ReadInt();
        /** 标签页(1：每日任务； 2：等级目标 ；3：进阶目标） */
        self.q_title = data.ReadInt();
        /** 资源路径 */
        self.q_title_url = data.ReadString();
        /** 任务类型说明 */
        self.q_introduce = data.ReadString();
        /** 任务类型（1：单人副本通关次数；2：竞技场挑战次数；3：完成日常任务个数；4：完成帮会任务个数；5：护送战车次数；6：参与魔界中原；7：等级；8：坐骑进阶；9：美人进阶；10：骑兵进阶；11：光翼进阶） */
        self.q_quest_type = data.ReadInt();
        /** 次数 */
        self.q_time = data.ReadInt();
        /** 奖励的道具（JSON） */
        self.q_reward = data.ReadString();
        /** 弹框中用户输入的默认分享内容 */
        self.q_content = data.ReadString();
        /** 故事摘要，建议生动的文字描述 */
        self.q_story = data.ReadString();
        /** 分享的标题 */
        self.q_name = data.ReadString();
        /** 弹框中显示的应用图片URL */
        self.q_url = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_qqshare_quest.list = Q_qqshare_quest.list|| [];
	/** 配置数据索引*/
	Q_qqshare_quest.map = Q_qqshare_quest.map || {};
	
	/** 设置配置数据*/
	Q_qqshare_quest.SetData = Q_qqshare_quest.SetData || function( data ){

		var list = Q_qqshare_quest.list;
		var map = Q_qqshare_quest.map;

		Q_qqshare_quest.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_qqshare_quest();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_qqshare_quest.GetList = Q_qqshare_quest.GetList || function(){
		return Q_qqshare_quest.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_qqshare_quest.Get = Q_qqshare_quest.Get || function( id ){
		return Q_qqshare_quest.map[ id ];
	};
})();