var Q_quest_guide = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 顺序 */
        self.q_id = data.ReadInt();
        /** 标题资源（美术字体） */
        self.q_title = data.ReadInt();
        /** 描述信息 */
        self.q_des = data.ReadString();
        /** 对应的任务ID[任务ID，任务ID]    第一个任务ID为开启显示条件 */
        self.q_quest_id = data.ReadString();
        /** 等级达到对应级别 */
        self.q_level = data.ReadString();
        /** 奖励（1：装备，2：坐骑，3：符鬼)（配置格式：类型_ID） */
        self.q_item_show = data.ReadString();
        /** 奖励的道具 */
        self.q_reward = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_quest_guide.list = Q_quest_guide.list|| [];
	/** 配置数据索引*/
	Q_quest_guide.map = Q_quest_guide.map || {};
	
	/** 设置配置数据*/
	Q_quest_guide.SetData = Q_quest_guide.SetData || function( data ){

		var list = Q_quest_guide.list;
		var map = Q_quest_guide.map;

		Q_quest_guide.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_quest_guide();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_quest_guide.GetList = Q_quest_guide.GetList || function(){
		return Q_quest_guide.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_quest_guide.Get = Q_quest_guide.Get || function( id ){
		return Q_quest_guide.map[ id ];
	};
})();