var Q_resline_up = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 资源线类型_资源线阶数_星级 */
        self.q_modelID = data.ReadString();
        /** 名称 */
        self.q_name = data.ReadString();
        /** 是否是最高等阶(0:不是；1：是） */
        self.q_ismax = data.ReadInt();
        /** 进阶操作所需人物等级 */
        self.q_up_figure_level = data.ReadInt();
        /** 等级上限 */
        self.q_level_max = data.ReadInt();
        /** 开启的总技能格子数 */
        self.q_skill_num = data.ReadInt();
        /** 祝福值是否指定时间重置（0:不重置，1：指定多少小时后重置, 2隔天重置） */
        self.q_reset_type = data.ReadInt();
        /** 祝福值重置时间(小时)(比如指定36小时后重置,或者隔天0点重置) */
        self.q_reset_time = data.ReadInt();
        /** 进阶消耗材料ID */
        self.q_up_item_id = data.ReadInt();
        /** 每次消耗材料数量 */
        self.q_up_item_num = data.ReadInt();
        /** 进阶成功所需进阶次数min */
        self.q_up_num_min = data.ReadInt();
        /** 进阶成功所需进阶次数max */
        self.q_up_num_max = data.ReadInt();
        /** 服务器端计算用进阶成功几率（万分比） */
        self.q_up_probability = data.ReadInt();
        /** 每次失败增加祝福值区间min */
        self.q_blessnum_min = data.ReadInt();
        /** 每次失败增加祝福值区间max */
        self.q_blessnum_max = data.ReadInt();
        /** 祝福值上限值 */
        self.q_blessnum_limit = data.ReadInt();
        /** 替代进阶道具  [道具ID,道具ID2] */
        self.q_replace_item = data.ReadString();
        /** 强化道具使用数量上限[[潜能丹ID,使用上限],[幻化丹ID,使用上限]] */
        self.q_intensify_item = data.ReadString();
        /** 元宝升阶自动购买的道具对应的序列号【绑定元宝，元宝】  PS: 一定要绑定元宝在前 */
        self.q_shop_data = data.ReadString();
        /** 进阶到该级别是否全服公告（0不公告，1公告） */
        self.q_notice = data.ReadInt();
        /** 每次失败增加人物经验 */
        self.q_up_fail_addexp = data.ReadInt();
        /** 本阶升到下一阶奖励道具 */
        self.q_reward = data.ReadString();
        /** 本阶升到下一阶返还道具ID */
        self.q_return_item = data.ReadInt();
        /** 吞噬表对应ID[1,2,3,4,5] */
        self.q_remove = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_resline_up.list = Q_resline_up.list|| [];
	/** 配置数据索引*/
	Q_resline_up.map = Q_resline_up.map || {};
	
	/** 设置配置数据*/
	Q_resline_up.SetData = Q_resline_up.SetData || function( data ){

		var list = Q_resline_up.list;
		var map = Q_resline_up.map;

		Q_resline_up.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_resline_up();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_modelID)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_resline_up.GetList = Q_resline_up.GetList || function(){
		return Q_resline_up.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_resline_up.Get = Q_resline_up.Get || function( id ){
		return Q_resline_up.map[ id ];
	};
})();