var Q_resources_recovery = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 回收编号 */
        self.q_id = data.ReadInt();
        /** 对应的功能编号 */
        self.q_newfunc = data.ReadInt();
        /** 系统名称 */
        self.q_name = data.ReadString();
        /** 所需等级 */
        self.q_level = data.ReadInt();
        /** 标题美术资源编号 */
        self.q_name_artistic = data.ReadInt();
        /** 展示的道具ID */
        self.q_show_item = data.ReadInt();
        /** 每天最多可完成次数 */
        self.q_max_num = data.ReadInt();
        /** 单个所需元宝 */
        self.q_cost_gold = data.ReadInt();
        /** 单次免费找回给予的奖励 */
        self.q_reward_silver = data.ReadString();
        /** 单次元宝找回给予的奖励 */
        self.q_reward_gold = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_resources_recovery.list = Q_resources_recovery.list|| [];
	/** 配置数据索引*/
	Q_resources_recovery.map = Q_resources_recovery.map || {};
	
	/** 设置配置数据*/
	Q_resources_recovery.SetData = Q_resources_recovery.SetData || function( data ){

		var list = Q_resources_recovery.list;
		var map = Q_resources_recovery.map;

		Q_resources_recovery.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_resources_recovery();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_resources_recovery.GetList = Q_resources_recovery.GetList || function(){
		return Q_resources_recovery.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_resources_recovery.Get = Q_resources_recovery.Get || function( id ){
		return Q_resources_recovery.map[ id ];
	};
})();