var Q_scene_monter_zone = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 刷怪编号（不重复即可） */
        self.q_id = data.ReadInt();
        /** 刷新条件（1：前一波全灭，2：时间轴） */
        self.q_refresh = data.ReadInt();
        /** 刷新时间（副本创建后，单位：秒） */
        self.q_time = data.ReadInt();
        /** 副本ID */
        self.q_zone = data.ReadInt();
        /** 波数 */
        self.q_order = data.ReadInt();
        /** 怪物ID */
        self.q_monster = data.ReadInt();
        /** 刷怪数量 */
        self.q_num = data.ReadInt();
        /** 刷新坐标X（格子） */
        self.q_center_x = data.ReadInt();
        /** 刷新坐标Y（格子） */
        self.q_center_y = data.ReadInt();
        /** 刷怪范围(刷新数量大于1起效）格子 */
        self.q_radius = data.ReadInt();
        /** 刷新起跳坐标点 */
        self.q_location_jump = data.ReadString();
        /** 刷新落脚坐标点 */
        self.q_location_appear = data.ReadString();
        /** 下次刷怪间隔时间(只有在Q_refresh=1的时候有效) */
        self.q_nextTime = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_scene_monter_zone.list = Q_scene_monter_zone.list|| [];
	/** 配置数据索引*/
	Q_scene_monter_zone.map = Q_scene_monter_zone.map || {};
	
	/** 设置配置数据*/
	Q_scene_monter_zone.SetData = Q_scene_monter_zone.SetData || function( data ){

		var list = Q_scene_monter_zone.list;
		var map = Q_scene_monter_zone.map;

		Q_scene_monter_zone.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_scene_monter_zone();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_scene_monter_zone.GetList = Q_scene_monter_zone.GetList || function(){
		return Q_scene_monter_zone.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_scene_monter_zone.Get = Q_scene_monter_zone.Get || function( id ){
		return Q_scene_monter_zone.map[ id ];
	};
})();