var Q_scene_obj = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** id */
        self.q_id = data.ReadInt();
        /** [[怪物ID,数量],[怪物ID,数量]] */
        self.q_monster_id = data.ReadString();
        /** 刷新时间 */
        self.q_refresh_time = data.ReadString();
        /** 刷新地图 */
        self.q_refresh_map = data.ReadInt();
        /** 地图线路（-1所有线路，>0指定线路） */
        self.q_map_line = data.ReadInt();
        /** 刷新坐标 */
        self.q_refresh_coordinate = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_scene_obj.list = Q_scene_obj.list|| [];
	/** 配置数据索引*/
	Q_scene_obj.map = Q_scene_obj.map || {};
	
	/** 设置配置数据*/
	Q_scene_obj.SetData = Q_scene_obj.SetData || function( data ){

		var list = Q_scene_obj.list;
		var map = Q_scene_obj.map;

		Q_scene_obj.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_scene_obj();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_scene_obj.GetList = Q_scene_obj.GetList || function(){
		return Q_scene_obj.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_scene_obj.Get = Q_scene_obj.Get || function( id ){
		return Q_scene_obj.map[ id ];
	};
})();