var Q_shop = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 检测系统判断是否开启活动（例：1（检测骑兵活动是否开启——1;2（检测骑兵，暗器是否开启，必须全部开启才能显示活动） */
        self.q_system_examine = data.ReadString();
        /** 绑定元宝原价显示为 */
        self.q_show_bindgold = data.ReadInt();
        /** 刷新限制最高人物等级 */
        self.q_level_max = data.ReadInt();
        /** 游戏币价格修正为 */
        self.q_coin = data.ReadInt();
        /** 刷新数量 */
        self.q_num = data.ReadInt();
        /** 显示顺序 */
        self.q_index = data.ReadInt();
        /** 商店出售模板编号 */
        self.q_model_id = data.ReadInt();
        /** 开服时间上架表达式0-6开服前六天,h0-100开服前100个小时 */
        self.q_openserver_rack = data.ReadString();
        /** 所属商店子页编号 */
        self.q_page = data.ReadInt();
        /** 限购上限 */
        self.q_shop_limit = data.ReadInt();
        /** 物品附加属性定义（类型|百分比的分子;类型|百分比的分子;） */
        self.q_append = data.ReadString();
        /** 本表索引编号（会影响到该物品在标签页中的排序） */
        self.q_id = data.ReadInt();
        /** 热销标识(0无热销，1热销中，2折扣，3热销+折扣) */
        self.q_hot = data.ReadInt();
        /** 出售物品ID */
        self.q_sell = data.ReadInt();
        /** 打折比例(百分比) */
        self.q_sale_rate = data.ReadInt();
        /** 购买后离自动失效前的存在时间（单位：秒） */
        self.q_duration = data.ReadInt();
        /** 刷新权重 */
        self.q_weight = data.ReadInt();
        /** 商店类型（0随身商店，1NPC商店，2元宝道具商城，3帮会商城，4竞技场商城，5组队副本商城，6,跨服副本商城） */
        self.q_shop_type = data.ReadInt();
        /** 游戏币原价显示为 */
        self.q_show_coin = data.ReadInt();
        /** 影响区服字段    区服；区服-区服；区服-&（无限大） */
        self.q_service_area = data.ReadString();
        /** 标签页开放性别需求（0通用，1主角1，2主角2，3主角3，4主角4） */
        self.q_page_sex = data.ReadInt();
        /** 绑定元宝价格 */
        self.q_bindgold = data.ReadInt();
        /** 开服时间打折表达式 */
        self.q_openserver_discount = data.ReadString();
        /** 显示所需人物累计消耗元宝数 */
        self.q_show_cost = data.ReadInt();
        /** 显示所需人物等级 */
        self.q_show_level = data.ReadInt();
        /** 商店标题 */
        self.q_shop_name = data.ReadString();
        /** 允许使用的货币类型类型（1游戏币，2元宝，4绑定元宝，6元宝与绑定元宝可购买，7三种货币均可购买）需重新定义 */
        self.q_money_type = data.ReadInt();
        /** 打折时间表达式 */
        self.q_discount_time = data.ReadString();
        /** 物品在商城面板中的文字描述（需支持html语法） */
        self.q_describe = data.ReadString();
        /** 元宝原价显示为 */
        self.q_show_gold = data.ReadInt();
        /** 刷新限制最低人物等级 */
        self.q_level_min = data.ReadInt();
        /** 元宝价格 */
        self.q_gold = data.ReadInt();
        /** 购买时是否立刻绑定（0不是，1是立刻绑定） */
        self.q_buy_bind = data.ReadInt();
        /** 上架时间段(-1下架，0正常在架，[时间格式写法]限时上架的时间) */
        self.q_rack = data.ReadString();
        /** 商店子页标签名称 */
        self.q_page_name = data.ReadString();
        /** 购买后的过期时间点（格式 yyyy-mm-dd hh:mm:ss） */
        self.q_losttime = data.ReadString();
        /** 物品强化等级定义 */
        self.q_strengthen = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_shop.list = Q_shop.list|| [];
	/** 配置数据索引*/
	Q_shop.map = Q_shop.map || {};
	
	/** 设置配置数据*/
	Q_shop.SetData = Q_shop.SetData || function( data ){

		var list = Q_shop.list;
		var map = Q_shop.map;

		Q_shop.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_shop();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_shop.GetList = Q_shop.GetList || function(){
		return Q_shop.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_shop.Get = Q_shop.Get || function( id ){
		return Q_shop.map[ id ];
	};
})();