var Q_skill_public = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 技能编号 */
        self.q_skillID = data.ReadInt();
        /** 使用者（0通用，1：男 2：女） */
        self.q_job = data.ReadInt();
        /** 调用脚本编号 1000014：必定暴击 */
        self.q_skill_script = data.ReadInt();
        /** 技能小图标编号 */
        self.q_small_ico = data.ReadInt();
        /** 面板上的技能描述（需支持加色，换行，加粗Html语法） */
        self.q_desc = data.ReadString();
        /** 技能类型 */
        self.q_tips = data.ReadString();
        /** 产出途径描述 */
        self.q_output = data.ReadString();
        /** 技能调用攻击动作编号（使用该技能需要调用的攻击动作对应美术资源相应的attack动作当要调用attack2或者attack3等包的时候才需要填attack后面的数字） */
        self.q_attack_id = data.ReadInt();
        /** 技能施法特效编号 */
        self.q_use_effect = data.ReadString();
        /** 特效是否翻转(0:不反转，1：反转） */
        self.q_turn_effect = data.ReadInt();
        /** 技能特效类型——1：在一个点上放的特效；2：在一个范围内随机播放特效的技能；3：播放一个线性特效；其他值为普通弹道类 */
        self.q_use_effecttype = data.ReadInt();
        /** 调用的特效类型（默认填0，根据想调用的特效类型填写看想调用的资源是stand5就填个1） */
        self.q_use_effkey = data.ReadInt();
        /** q_use_effecttype为1或者2时：参数为0或1，0是特效出现在施法者的坐标，1是目标点坐标；q_use_effecttype为3时填线的行数(0仅一行，1就3行，2就五行以此类推） */
        self.q_use_efftar = data.ReadInt();
        /** 随机范围内播放的个数（线性技能的话就是一条线上会播放的特效的个数(上限是12,线性上线是5) */
        self.q_use_effectnums = data.ReadInt();
        /** effecttype为2时填随机范围半径，为3时填线性间距（单位：像素） */
        self.q_use_effradius = data.ReadInt();
        /** 需要加起手特效才填（施法者释放技能的时候在其身上播放的特效） */
        self.q_hands_effid = data.ReadInt();
        /** 调用的特效类型（同q_use_effactionkey） */
        self.q_hands_effkey = data.ReadInt();
        /** 技能弹道特效编号 */
        self.q_trajectory_effect = data.ReadString();
        /** 技能命中特效编号 */
        self.q_hit_effect = data.ReadString();
        /** 技能持续特效编号 */
        self.q_series_effect = data.ReadString();
        /** 技能施法音效 */
        self.q_use_sound = data.ReadString();
        /** 技能命中音效 */
        self.q_hit_sound = data.ReadString();
        /** 面板上显示的SWF动画 */
        self.q_swf = data.ReadString();
        /** 是否可以注册快捷栏（1可以，2不可以） */
        self.q_shortcut = data.ReadInt();
        /** 位置编号（0:不在人物面板,，1：人物主动技能面板，2：人物被动技能面板，3，心法技能  4：易容技能） */
        self.q_index = data.ReadInt();
        /** 是否可以设为默认技能（0不可设为默认技能，1可以设为默认技能） */
        self.q_default_enable = data.ReadInt();
        /** 击杀怪物死亡飞行速度 */
        self.q_die_fly_speed = data.ReadInt();
        /** 击杀怪物死亡飞行时间(单位：毫秒） */
        self.q_die_fly_time = data.ReadInt();
        /** 激活技能所需玩家等级 */
        self.q_activate_level = data.ReadInt();
        /** 激活技能所需道具ID */
        self.q_activate_item = data.ReadInt();
        /** 技能标示 */
        self.q_mark = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_skill_public.list = Q_skill_public.list|| [];
	/** 配置数据索引*/
	Q_skill_public.map = Q_skill_public.map || {};
	
	/** 设置配置数据*/
	Q_skill_public.SetData = Q_skill_public.SetData || function( data ){

		var list = Q_skill_public.list;
		var map = Q_skill_public.map;

		Q_skill_public.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_skill_public();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_skillID)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_skill_public.GetList = Q_skill_public.GetList || function(){
		return Q_skill_public.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_skill_public.Get = Q_skill_public.Get || function( id ){
		return Q_skill_public.map[ id ];
	};
})();