var Q_task_conquer = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 讨伐任务编号 */
        self.q_id = data.ReadInt();
        /** 玩家等级区间min */
        self.q_mingrade = data.ReadInt();
        /** 玩家等级区间max */
        self.q_maxgrade = data.ReadInt();
        /** 卷轴颜色（0白色，1黄色，2绿色，3蓝色，4紫色）颜色越高则完成难度越低，而且奖励越高 */
        self.q_scroll_type = data.ReadInt();
        /** 美术图片资源编号 */
        self.q_image = data.ReadInt();
        /** 任务条件检测杀死怪物序列（怪物ID_需求数量_寻径链接） */
        self.q_monstercount = data.ReadString();
        /** 任务接取时需检测达成某成就序列（成就编号;成就编号） */
        self.q_accept_needAchieve = data.ReadString();
        /** 接取任务时发送的屏幕提示信息文字 */
        self.q_accept_prompt = data.ReadString();
        /** 任务奖励达成某成就序列（成就编号;成就编号） */
        self.q_rewards_achieve = data.ReadString();
        /** 任务奖励经验 */
        self.q_rewards_exp = data.ReadInt();
        /** 任务奖励铜钱 */
        self.q_rewards_coin = data.ReadInt();
        /** 任务奖励真气 */
        self.q_rewards_zq = data.ReadInt();
        /** 任务奖励声望 */
        self.q_rewards_prestige = data.ReadInt();
        /** 任务奖励绑定元宝 */
        self.q_rewards_bindyuanbao = data.ReadInt();
        /** 互斥几率_道具ID,数量,性别（0通，1男，2女）,绑定（0,1绑定）,消失时间,强化等级,附加属性(类型|值); */
        self.q_rewards_goods = data.ReadString();
        /** 男互斥几率_道具ID_数量_性别（0通，1男，2女）_绑定（0,1绑定）_消失时间_强化等级_N5(附加属性条数)或者附加属性(类型|值); */
        self.q_man_rewards_goods = data.ReadString();
        /** 女互斥几率_道具ID_数量_性别（0通，1男，2女）_绑定（0,1绑定）_消失时间_强化等级_N5(附加属性条数)或者附加属性(类型|值); */
        self.q_women_rewards_goods = data.ReadString();
        /** 是否允许被吞噬（0不允许，1允许） */
        self.q_devour_able = data.ReadInt();
        /** 被吞噬后的奖励合并比例幅度 */
        self.q_devour_prop = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_task_conquer.list = Q_task_conquer.list|| [];
	/** 配置数据索引*/
	Q_task_conquer.map = Q_task_conquer.map || {};
	
	/** 设置配置数据*/
	Q_task_conquer.SetData = Q_task_conquer.SetData || function( data ){

		var list = Q_task_conquer.list;
		var map = Q_task_conquer.map;

		Q_task_conquer.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_task_conquer();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_task_conquer.GetList = Q_task_conquer.GetList || function(){
		return Q_task_conquer.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_task_conquer.Get = Q_task_conquer.Get || function( id ){
		return Q_task_conquer.map[ id ];
	};
})();