var Q_timing = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 活动ID */
        self.q_id = data.ReadInt();
        /** 界面排序 */
        self.q_order = data.ReadInt();
        /** 活动名称 */
        self.q_name = data.ReadString();
        /** 时间（仅是周几，-1 指每天，星期天是7）  [2,4,6] */
        self.q_day = data.ReadString();
        /** 活动类型（与q_system_activity对应） */
        self.q_type = data.ReadInt();
        /** 活动时间 */
        self.q_time = data.ReadString();
        /** 是否关联开服活动 */
        self.q_time_type = data.ReadInt();
        /** 是否周末翻倍（0：不，1：是） */
        self.q_double_weekend = data.ReadInt();
        /** 等级需求 */
        self.q_level = data.ReadInt();
        /** 标题美术字体资源 */
        self.q_title = data.ReadInt();
        /** 标题底图资源 */
        self.q_background = data.ReadInt();
        /** 右边活动展示资源 */
        self.q_show = data.ReadInt();
        /** 活动描述 */
        self.q_introduce = data.ReadString();
        /** 道具展示 */
        self.q_item_show = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_timing.list = Q_timing.list|| [];
	/** 配置数据索引*/
	Q_timing.map = Q_timing.map || {};
	
	/** 设置配置数据*/
	Q_timing.SetData = Q_timing.SetData || function( data ){

		var list = Q_timing.list;
		var map = Q_timing.map;

		Q_timing.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_timing();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_timing.GetList = Q_timing.GetList || function(){
		return Q_timing.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_timing.Get = Q_timing.Get || function( id ){
		return Q_timing.map[ id ];
	};
})();