var Q_ufenshen = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 焚神编号 */
        self.q_id = data.ReadInt();
        /** 焚神名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 焚神界面焚神名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 是否可被攻击(0不允许，1允许） */
        self.q_hit = data.ReadInt();
        /** 被攻击最大损失血量（无论是什么攻击都仅扣除1滴血） */
        self.q_hp_lose = data.ReadInt();
        /** 焚神头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 焚神面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用焚神造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 焚神特效 */
        self.q_effect = data.ReadInt();
        /** 焚神描述文本 */
        self.q_introduce = data.ReadString();
        /** 对应的技能格子的技能可被激活 */
        self.q_skill = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_ufenshen.list = Q_ufenshen.list|| [];
	/** 配置数据索引*/
	Q_ufenshen.map = Q_ufenshen.map || {};
	
	/** 设置配置数据*/
	Q_ufenshen.SetData = Q_ufenshen.SetData || function( data ){

		var list = Q_ufenshen.list;
		var map = Q_ufenshen.map;

		Q_ufenshen.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_ufenshen();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_ufenshen.GetList = Q_ufenshen.GetList || function(){
		return Q_ufenshen.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_ufenshen.Get = Q_ufenshen.Get || function( id ){
		return Q_ufenshen.map[ id ];
	};
})();