var Q_uxionglu = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 凶戮编号 */
        self.q_id = data.ReadInt();
        /** 凶戮名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 凶戮界面凶戮名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 是否可被攻击(0不允许，1允许） */
        self.q_hit = data.ReadInt();
        /** 被攻击最大损失血量（无论是什么攻击都仅扣除1滴血） */
        self.q_hp_lose = data.ReadInt();
        /** 凶戮头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 凶戮面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用凶戮造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 凶戮特效 */
        self.q_effect = data.ReadInt();
        /** 凶戮描述文本 */
        self.q_introduce = data.ReadString();
        /** 对应的技能格子的技能可被激活 */
        self.q_skill = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_uxionglu.list = Q_uxionglu.list|| [];
	/** 配置数据索引*/
	Q_uxionglu.map = Q_uxionglu.map || {};
	
	/** 设置配置数据*/
	Q_uxionglu.SetData = Q_uxionglu.SetData || function( data ){

		var list = Q_uxionglu.list;
		var map = Q_uxionglu.map;

		Q_uxionglu.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_uxionglu();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_uxionglu.GetList = Q_uxionglu.GetList || function(){
		return Q_uxionglu.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_uxionglu.Get = Q_uxionglu.Get || function( id ){
		return Q_uxionglu.map[ id ];
	};
})();