var Q_weaponride = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 骑兵编号*100+幻化编号(幻化1为默认造型） */
        self.q_id = data.ReadInt();
        /** 骑兵编号 */
        self.q_modelID = data.ReadInt();
        /** 幻化编号(幻化1为默认造型） */
        self.q_transformation_id = data.ReadInt();
        /** 骑兵名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 骑兵界面骑兵名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 加成属性是否需要骑乘坐骑(0不需要，1需要） */
        self.q_is_riding = data.ReadInt();
        /** 购买所需元宝 */
        self.q_buy_cost = data.ReadInt();
        /** 持续时间(单位：秒，-1表示永久） */
        self.q_time_last = data.ReadInt();
        /** 骑兵头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 骑兵掉落场景ICON资源编号 */
        self.q_icon_drop_id = data.ReadInt();
        /** 骑兵面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用骑兵造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 骑兵特效资源编号 */
        self.q_effect = data.ReadInt();
        /** 骑兵描述文本 */
        self.q_introduce = data.ReadString();
        /** 激活骑兵途径（神兵名称需下划线并有TIPS） */
        self.q_guide = data.ReadString();
        /** 炼化所需灵魂碎片ID */
        self.q_soulID = data.ReadInt();
        /** 灵魂碎片数量 */
        self.q_soul_num = data.ReadInt();
        /** 幻化对应获取的技能ID */
        self.q_skill = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_weaponride.list = Q_weaponride.list|| [];
	/** 配置数据索引*/
	Q_weaponride.map = Q_weaponride.map || {};
	
	/** 设置配置数据*/
	Q_weaponride.SetData = Q_weaponride.SetData || function( data ){

		var list = Q_weaponride.list;
		var map = Q_weaponride.map;

		Q_weaponride.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_weaponride();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_weaponride.GetList = Q_weaponride.GetList || function(){
		return Q_weaponride.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_weaponride.Get = Q_weaponride.Get || function( id ){
		return Q_weaponride.map[ id ];
	};
})();