var Q_weaponride_addition = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 骑兵编号_骑兵等级 */
        self.q_modelID = data.ReadString();
        /** 骑兵编号 */
        self.q_id = data.ReadInt();
        /** 骑兵等级 */
        self.q_level = data.ReadInt();
        /** 骑兵名称 */
        self.q_name = data.ReadString();
        /** 生命值 */
        self.q_maxHp = data.ReadInt();
        /** 攻击力 */
        self.q_attack = data.ReadInt();
        /** 防御力 */
        self.q_defense = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_weaponride_addition.list = Q_weaponride_addition.list|| [];
	/** 配置数据索引*/
	Q_weaponride_addition.map = Q_weaponride_addition.map || {};
	
	/** 设置配置数据*/
	Q_weaponride_addition.SetData = Q_weaponride_addition.SetData || function( data ){

		var list = Q_weaponride_addition.list;
		var map = Q_weaponride_addition.map;

		Q_weaponride_addition.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_weaponride_addition();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_modelID)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_weaponride_addition.GetList = Q_weaponride_addition.GetList || function(){
		return Q_weaponride_addition.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_weaponride_addition.Get = Q_weaponride_addition.Get || function( id ){
		return Q_weaponride_addition.map[ id ];
	};
})();