var Q_zone = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 副本编号 */
        self.q_id = data.ReadInt();
        /** 副本类型 */
        self.q_zone_type = data.ReadInt();
        /** 副本关联地图编号[xxxx,xxxx] */
        self.q_mapid = data.ReadString();
        /** 副本名称 */
        self.q_name = data.ReadString();
        /** UI界面副本名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 副本UI界面背景图资源编号 */
        self.q_inset = data.ReadInt();
        /** 副本存在时间（毫秒） */
        self.q_exist_time = data.ReadInt();
        /** 副本没有人后删除副本时间（毫秒） 0表示没人也不删除 至少需要存在1分钟 */
        self.q_check_time = data.ReadInt();
        /** 副本重置时间 [年][月][日][周][1110,1200] */
        self.q_reset_time = data.ReadString();
        /** 进入等级限制 */
        self.q_level = data.ReadInt();
        /** 进入最少人数限制 */
        self.q_min_num = data.ReadInt();
        /** 进入最多人数限制 */
        self.q_max_num = data.ReadInt();
        /** 脚本编号（0是没有的） */
        self.q_isscript = data.ReadInt();
        /** 进入地图的默认坐标x */
        self.q_x = data.ReadInt();
        /** 进入地图的默认坐标y */
        self.q_y = data.ReadInt();
        /** 进入副本所需的VIP等级 */
        self.q_vip = data.ReadInt();
        /** 前端用说明文本 */
        self.q_Explain = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_zone.list = Q_zone.list|| [];
	/** 配置数据索引*/
	Q_zone.map = Q_zone.map || {};
	
	/** 设置配置数据*/
	Q_zone.SetData = Q_zone.SetData || function( data ){

		var list = Q_zone.list;
		var map = Q_zone.map;

		Q_zone.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_zone();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_zone.GetList = Q_zone.GetList || function(){
		return Q_zone.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_zone.Get = Q_zone.Get || function( id ){
		return Q_zone.map[ id ];
	};
})();