/**
 * 游戏自定义事件
 * @author ty
 */

var EnumEventType = EnumEventType || {};
// 点击NPC
EnumEventType.GAME_MAP_NPC_SELECT  = "game_map_npc_select";
// 移动至目标 (带回调)
EnumEventType.GAME_MOVE_TO_TARGET = "game_move_to_target";
// 主玩家自动任务寻路结束
EnumEventType.GAME_AUTO_TASK_END_MOVE = "game_auto_task_end_move";
// 主玩家自动杀怪
EnumEventType.GAME_KILL_MONSTER = "game_kill_monster";
// 主玩家自动采集
EnumEventType.GAME_AUTO_COLLECT = "game_auto_collect";
// 主玩家移动结束
EnumEventType.GAME_END_MOVE = "game_end_move";

EnumEventType.GAME_EQUIP_CHANGED = "game_equip_changed";    // 装备物品改变时
EnumEventType.GAME_REFINING_RESULT = "game_refining_result";    //

EnumEventType.GAME_EQUIP_REFINING_SUIT_CHANGED = "game_equip_refining_suit_changed";    //
/// 更新队伍信息
EnumEventType.GAME_ZONETEAM_UPDATE_TEAMINFO = "game_zoneteam_update_teaminfo"




var GameEventMgr =  GameEventMgr || ({
        cache : [], // 缓存集中推送

        //事件监听
        AddEventListener:function (target, type, func) {
            //监听事件
            var listener = cc.EventListener.create({
                event: cc.EventListener.CUSTOM,
                eventName: type,
                callback: function(event){
                    var data = event.getUserData();
                    func.call(target, data);
                }
            });
            cc.eventManager.addListener(listener, target);
        },

        DispatchEvent:function (type, data) {
            //var index = this.cache.findIndex(function(v){ return v[0] == type; });
            //if(index > -1){
            //    this.cache[index][1] = data;
            //}else{
            //    this.cache.push([type,data]);
            //}

            cc.eventManager.dispatchCustomEvent(type,data);
        },

        //移除监听
        RemoveEventListener:function (target) {
            cc.eventManager.removeListeners(target);
        },

        OnFrame:function(){
            //this.cache.forEach(v=>cc.eventManager.dispatchCustomEvent(v[0],v[1]))
            //this.cache.length = 0;
        },
    });

var GameEvent =  GameEvent || ({

        Init:function(){
            GameEvent.playerLevelUp = new signals.Signal();
            GameEvent.changeMapEnd = new signals.Signal();
        }
    });