﻿/**
 * 游戏模块总管理器
 * */
var Mgr = Mgr || {

	Init:function(stagelayer){
		this.sceneLayer = SceneLayerMgr.Init(stagelayer);
		this.sceneObj = SceneObjectMgr.Init();
		this.sceneMap = SceneMapMgr.Init();
		this.sceneAction = SceneActionMgr.Init();
		this.msgMgr = new GameMsgMgr();
		this.dataMgr = GameDataMgr.Init();
		this.robotMgr = RobotMgr.Init();
		this.keyboardMgr = KeyboardMgr.Init();
		this.particleMgr = ParticleManager.Init("res/particle/");
		this.gameSoundMgr = new GameSoundMgr();
        this.arena = new ArenaModMgr();
		this.attributeMgr = new AttributeMgr();
		this.achievement = new AchievementModMgr();
		this.dailyactivity = new DailyactivitiesModMgr();
		this.backpack = new BackpackModMgr();
		this.buff = new BuffModMgr();
		this.bank = new BankModMgr();
		this.card = new CardModMgr();
		this.chat = new ChatModMgr();
		this.client = new ClientModMgr();
		this.dazuo = new DazuoModMgr();
		this.demonstar = new DemonstarModMgr();
		this.drop = new DropModMgr();
		this.earthemperor = new EarthemperorModMgr();
		this.equip = new EquipModMgr();
		this.fight = new FightModMgr();
		this.fightpower = new FightpowerModMgr();
		this.friend = new FriendModMgr();
		this.melting = new MeltingModMgr();
		this.gm = new GmModMgr();
		this.goldcard = new GoldcardModMgr();
		this.guild = new GuildModMgr();
		this.hydrangea = new HydrangeaModMgr();
		this.imperialwar = new ImperialwarModMgr();
		this.kreed = new KreedModMgr();
		this.equipRefine = new EquipRefineModMgr();
		this.login = new LoginModMgr();
		this.mail = new MailModMgr();
		this.resequip = new ResourceequipModMgr();
		this.majorevents = new MajoreventsModMgr();
		this.map = new MapModMgr();
		this.marriage = new MarriageModMgr();
		this.marriageres = new MarriageresModMgr();
		this.monster = new MonsterModMgr();
		this.gem = new GemModMgr();
		this.npc = new NpcModMgr();
		this.offlineres = new OfflineresModMgr();
		// this.platform = new PlatformModMgr();
		this.player = new PlayerModMgr();
        this.recharge = new RechargeModMgr();
		this.plugset = new PlugsetModMgr();
		this.refining = new RefiningModMgr();
		this.resline = new ReslineModMgr();
		this.resourceequip= new ResourceequipModMgr();
		this.selectgift = new SelectgiftModMgr();
		this.server = new ServerModMgr();
		this.shop = new ShopModMgr();
		this.shortcutbar = new ShortcutbarModMgr();
		this.sign = new SignModMgr();
		this.skill = new SkillModMgr();
		this.stall = new StallModMgr();
		this.store = new StoreModMgr();
		this.task = new TaskModMgr();
		this.dropEffect = new DropGoodsModMgr();
		this.team = new TeamModMgr();
		this.title = new TitleModMgr();
		this.top = new TopModMgr();
		this.tips = new TipsModMgr();
		this.transactions = new TransactionsModMgr();
		this.vacant = new VacantModMgr();
		this.vip = new VipModMgr();
		this.vitality = new VitalityModMgr();
		this.weal = new WealModMgr();
		this.zone = new ZoneModMgr();
		this.zork = new ZorkModMgr();
		this.cross = new CrossModMgr();
		this.crossteam = new CrossteamModMgr();
		this.crosszone = new CrosszoneModMgr();
		this.crossbf = new CrossbfModMgr();
		this.pickMgr=new PickMgr();
		this.resourceequip = new ResourceequipModMgr();
		this.tujian = new TujianModMgr();
		this.fasion = new FasionModMgr();
		this.zonejianghu = new ZonejianghuModMgr();
		this.zoneteam = new ZoneteamModMgr();
		this.gossip = new GossipModMgr();
		this.disguise = new DisguiseModMgr();
		this.luckydraw = new LuckydrawModMgr();
		this.guardcpital = new GuardcpitalModMgr();
		this.sword = new SwordModMgr();
		this.mainPlayer = null;
		this.uiMgr = EngineMgr.uiMgr.Init( stagelayer );
		this.armor = new ArmorModMgr();
		this.activeMark = new ActiveMarkModMgr();
		this.strong = new StrongModMgr();
		this.kingguild = new KingguildModMgr();
		this.kingneutral = new KingneutralModMgr();
		this.convoy = new ConvoyModMgr();
		this.particleRain = new ParticleRain();
		this.redpacket = new RedpacketModMgr();
		this.illusion = new IllusionModMgr();
		this.godarm = new GodarmModMgr();
        this.special = new SpecialModMgr();
        this.step = new StepModMgr();
		this.dazzling = new DazzlingModMgr();
		this.wedding = new WeddingModMgr();

        this.touchEffectLayer = new SceneTouchEffectLayer();
        stagelayer.addChild(this.touchEffectLayer);
	},

    /// 重置，暂时用在退出登录
    Reset:function(){
        this.monster.isFirst = true;
        this.sceneMap.SetLookMapMiddle(null);
        this.sceneMap.nMapId = 0;
        this.zone.SetCurrentZoneType(0)
		Mgr.task.aLastTaskId = Mgr.task.aCurTaskId = Mgr.task.aNextTaskId = 0;
    }

}