var AchievementSelExt = AchievementSel.extend ( {
	_className:"AchievementSelExt",
    labArr:null,
    barArr:null,
	btnArr:null,
    proLabArr:null,
	achievementPanel:null,
    infoList:null,
    showMode:null,
	ctor:function(){
		this._super();
		this.infoList = [];
	},

    Init:function() {
        AchievementSel.prototype.Init.call(this);
        var self = this;

        this.labArr = [this.labChengzhang, this.labDianshu2, this.labDianshu3, this.labDianshu4, this.labDianshu5, this.labDianshu6, this.labDianshu7, this.labDianshu8];
        this.barArr = [this.progJindutiao1, this.progJindutiao2, this.progJindutiao3, this.progJindutiao4, this.progJindutiao5, this.progJindutiao6, this.progJindutiao7, this.progJindutiao8];
        this.btnArr = [this.btn1, this.btn2, this.btn3, this.btn4, this.btn5, this.btn6, this.btn7, this.btn71];

        var list = Q_achievement.GetList();
        for(var i = 0; i < list.length; i++){
            if(list[i].q_subfield == 1){
                this.infoList.push(list[i]);
            }
        }

        this.labCue11.setTouchEnabled(true);
        this.labCue11.addTouchEventListener(function(sender,type){
			if ( type == ccui.Widget.TOUCH_ENDED )
			{
				Mgr.uiMgr.ShowPanelByType(ChengHaoPanelExt.PanelName);
			}
		});

        this.btnWenhao.addClickEventListener(function (target) {
            Mgr.uiMgr.ShowPanelByType(ChengHaoPanelExt.PanelName);
        });

        for(var i = 0, len = this.btnArr.length; i < len; i++){
            this.btnArr[i].index = i + 1;
            this.btnArr[i].addClickEventListener(function (target) {
                self.achievementPanel.InitCell(self.achievementPanel.buttonList[target.index].sbtn1);
            });
        }
    },

    SetData:function (type, idArr) {
		this.UpdateAllPoint();
		this.UpdateOtherPoint();
    },

    UpdateAllPoint:function () {
	    cc.log("======UpdateAllPoint========")
        var pointKeyList = Mgr.achievement.AchievementTypePointHash().Keys();
        var totalNum = Mgr.achievement.AchievementTypePointHash().Get(pointKeyList[0]);
        this.labCue2.SetText(TextUtil.FormatStr(this.labCue2.GetHtmlText(),[totalNum]));

        var nowNum = Mgr.achievement.allAchievementTypeNowPoint;
        // var maxNum = Mgr.achievement.AchievementTypePointHash().Get(1);
        var maxNum = 0, showInfo;
        for(var i = 0; i<this.infoList.length; i++){
            if(this.infoList[i].q_value > nowNum){
                maxNum = this.infoList[i].q_value;
                showInfo = this.infoList[i];
                break;
            }
        }
        this.progJindutiao.setPercent(nowNum/maxNum*100);
        this.labNumber.SetText(TextUtil.FormatStr( this.labNumber.GetHtmlText(), [ nowNum, maxNum ] ));
        this.labNumber.EnableOutline(EnumFontFormat.COMMON_COLOR11,1);

        var data = Q_title.Get(showInfo.q_title_show);
        if(this.showMode){
            SkillEffect.Delete(this.showMode);
        }
        this.showMode = EffectUtil.GetShowEffect(data.q_art, EffectUtil.ENUM_TYPE_UI, true ,-1);
        this.showMode.x = this.imgChenghao.uiWidth / 2;
        this.showMode.y = this.imgChenghao.uiHeight / 2;
        this.imgChenghao.addChild(this.showMode);
    },

    UpdateOtherPoint:function () {
        var pointKeyList = Mgr.achievement.AchievementTypePointHash().Keys();
        for(var i = 1, len = pointKeyList.length; i < len; i++){
            var totalNum = Mgr.achievement.AchievementTypePointHash().Get(pointKeyList[i]);
            var nowNum = Mgr.achievement.achievementTypeNowPointHash.Get(pointKeyList[i - 1]);
            if(!nowNum){
                nowNum = 0;
            }
            this.barArr[i - 1].setPercent(nowNum/totalNum*100);
            this.labArr[i - 1].SetText(TextUtil.FormatStr( this.labArr[i - 1].GetHtmlText(), [ nowNum, totalNum ] ));
        }
    },
} );
AchievementSelExt.PanelName = "AchievementSelExt";
PanelClassDic["AchievementSelExt"] = AchievementSelExt;
