var ArenaWinExt = FubenWinExt.extend ( {
    _className:"ArenaWinExt",
    _rawardCon:null,
    _timerNum:0,
    _time:0,
    _nowWave:0,
    ctor:function(){
        this._super();
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.setSwallowTouches(true);
    },

    Init:function(){
        this._super();
        this.btnOk.addClickEventListener(this.OnConfirm.bind(this));
    },
    OnShow:function(){
        this.ShowActive();

    },
    OnHide:function(){
        this.HideAction();
        TimerUtil.ClearTimeUpdate(this._timerNum, this);
        this._timerNum = null;
    },
    OnTimer:function () {
        this._time--;
        if( this._time == 0 ){
            TimerUtil.ClearTimeUpdate(this._timerNum, this);
            this._timerNum = null;

            this.OnConfirm();
            return;
        }
        this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ this._time ] ));
    },

    OnConfirm:function(){
        if(this.callback && this.target) this.callback.call(this.target);
        Mgr.uiMgr.HidePanel(this);
    },
    SetData:function(data,callback,target){
        this.callback = callback;
        this.target = target;

        this.btnGo.setVisible(false);
        this.btnOk.x = (this.imgBg.uiWidth - this.btnOk.uiWidth)/2;
        this.btnOk.setTitleText("我知道了");

        this.UpdateRaward(data.itemInfos);

        this._time = 5;
        this.OnTimer();
        TimerUtil.ClearTimeUpdate(this._timerNum, this);
        this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
    },

    UpdateRaward:function(items){
        if(this._rawardCon == null){
            UIUtil.UIRemoveSelf(this.gridItem);
            this._rawardCon = new TaskRewardsGridCon();
            this.imgBg.addChild(this._rawardCon);
        }
        this._rawardCon.Clear();

        if(!(items && items.length > 0)){
            this._rawardCon.setVisible(false);
            this.labJiangli.setVisible(false);
            return
        }
        this._rawardCon.setVisible(true);
        this.labJiangli.setVisible(true);

        for(var i = 0;i<items.length;++i){
            var v = items[i];
            var item =  ItemUtil.ItemIdToItem(v.mod || v.itemModelId,v.num);
            this._rawardCon.AddComItem(item,this.gridItem);
        }

        var count = items.length;
        this._rawardCon.Layout( this.gridItem.uiWidth * count, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight );
        this._rawardCon.x = ( this.imgBg.uiWidth - this.gridItem.uiWidth * count ) / 2;
        this._rawardCon.y = this.gridItem.y;
    },
} );
ArenaWinExt.PanelName = "ArenaWinExt";
PanelClassDic["ArenaWinExt"] = ArenaWinExt;


var ArenaDefeatedExt = FubenDefeatedExt.extend ( {
    _className:"ArenaDefeatedExt",
    ctor:function(){
        this._super();
    },
    Init:function(){
        this._super();
        this.btnOut.addClickEventListener(this.OnConfirm.bind(this));
    },

    OnShow:function(){
        this.ShowActive();
        this._time = 5;
        this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ this._time ] ));
        TimerUtil.ClearTimeUpdate(this._timerNum, this);
        this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
    },
    OnTimer:function () {
        this._time--;
        if( this._time == 0 ){
            this.OnConfirm();
            return;
        }
        this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ this._time ] ));
    },

    OnConfirm:function(){
        if(this.callback && this.target) this.callback.call(this.target);
        Mgr.uiMgr.HidePanel(this);
    },

    SetData:function(data,callback,target){
        this.callback = callback;
        this.target = target;
    },
} );
ArenaDefeatedExt.PanelName = "ArenaDefeatedExt";
PanelClassDic["ArenaDefeatedExt"] = ArenaDefeatedExt;
