﻿/**
 * @author wing
 * 能渲染 装备和 普通物品 的格子类
 * 用 setShowData 来渲染
 */
var GridItem = MUIGrid.extend ( {
	_className:"GridItem",
	_item:null,
	_itemTipsData:null,
	_openType:0,
	dragDropEnable:false,
	colorfulIcon:false,
	_selected:false,
	index:0,
	ctor:function(){
		this._super();
		this._itemTipsData = {};
		this.setTouchEnabled( true );
	},
	SetItemInfo:function (item , gridType , showLock, size){
		if(showLock == null)
			showLock = 0;
		this._item = item;
		var itemSize=arguments[3]?arguments[3]:ResUrl.ITEM_SIZE_46;

		GridUtil.SetItemGrid( this,this._item,itemSize,true,true,false);
		if ( item == null )
			return;

		switch ( gridType )
		{
			case GridTypeEnum.BACKPACK:
				if ( !item.itemislocked && !(Mgr.backpack.showLock == 1 && item.itemBind == 1))
				{
					this.setTouchEnabled(true);
					this.colorfulIcon = true;
				}
				else
				{
					//this.setTouchEnabled(false);
					this.colorfulIcon = false;
				}
				break;
		}

        GridUtil.AddOverdueTime(this,item);
	},
	GetItem:function(){
		return this._item;
	},
	SetOpenType:function (opentype , gridtype , time , remainTime ){
		if(time == null)
			time = -1;
		if(remainTime == null)
			remainTime = -1;
		this._openType = opentype;
		this.dragDropEnable = true;
		this.colorfulIcon = true;
		
		switch(opentype){
			case GridOpenTypeEnum.noSelect:
				this.dragDropEnable = false;
				this.colorfulIcon = false;
				break;
			case GridOpenTypeEnum.opening:
				//this.Clean();
				break;
			case GridOpenTypeEnum.locked:
				// this.Clean();
				break;
			case GridOpenTypeEnum.vipDown:
				this.Clean();
				break;
			default:
				this.Clean();
				break;
		}
	},
	Clear:function(){
		MUIGrid.prototype.Clear.call( this );
		
		
		
		
	},
	GetOpenType:function (){
		return this._openType;
	},
	Selected:function (){
		return this._selected;
	},
} );
