﻿var ChatModMgr = ChatModMgr || cc.Class.extend({
		curChatChannel:EnumChatChannelType.MANY,
		itemShowList:[],
		_chatPanel:null,
		MAXCHATTEXTLENGTH:85,
		//消息记录
		historyList:[],
		privateList:[],
		isCancelSend:false,
		recordList:null,
		isChatPanelOpen:false,
        notOnlineList:null,
		chatAniRes:null,
		tempEditContent:"",
		ctor:function() {
            this.notOnlineList = new HashMap();
            this.chatAniRes = new HashMap();
		},
		SetPanel:function (Panel)
		{
			this._chatPanel = Panel;
		},
		SendChantMsg:function ( type,str,extraReqInfo){
			if( str.toLowerCase() == "&debugpanel" ){
				Mgr.uiMgr.ShowHidePanelByType( DebugPanelExt.PanelName );
				return;
			}
			if( str.toLowerCase() == "&exp" ){
				Mgr.chat.isShowRole = true;
				return;
			}
			var regexp = /\n/g;
			str = str.replace(regexp,"");
			if(str.length>Mgr.chat.MAXCHATTEXTLENGTH)
			{
				str = str.substring(0,Mgr.chat.MAXCHATTEXTLENGTH);
			}
			this.tempEditContent = str;
			if(Mgr.chat.curChatChannel == EnumChatChannelType.SYSTEM || str.indexOf("&") == 0){
				// 服务器命令
				var msg = new ReqGmCommandMessage();
				msg.command = "&TEST_NOTIFY 3 "+str;
				if(str.indexOf("&") == 0)
				{
					msg.command = str;
					cc.log("GM_commander--- "+str);
				}
				Mgr.msgMgr.Send( msg );
			}
			else {
				this.ReqChatRequestMessage(type,str,extraReqInfo);
			}
		},
		/**
		 * 请求发聊天消息
		 */
		ReqChatRequestMessage:function (type,str,extraReqInfo ){
			var msg = new ReqChatMessage();
			msg.type = type;
			msg.extraReqInfo = extraReqInfo||new ExtraReqInfo();
			if (type == EnumChatChannelType.MANY)
			{
				msg.type = EnumChatChannelType.WORLD;
			}
			//msg.chatText = str;
			//cc.log("=======================================send chat msg" , JSON.stringify(msg));
			//Mgr.msgMgr.Send( msg );
			//添加玩家所在地图及位置
			//this._AddMapShowToInput();
			//var len = this.itemShowList.length;
			//for (var i = 0; i < len; i++)
			//{
			//	var showvo = this.itemShowList[i];
			//	var itemreq = new HyperInfo();
			//	itemreq.hyperType = showvo.type;
			//	itemreq.params_ = showvo.hexsid;
			//	itemreq.index = showvo.pos;
			//	itemreq.clientUseText = showvo.str;
			//	msg.extraReqInfo.hyperInfos.push( itemreq );
			// 	str+=showvo.str;
			//}
			msg.chatText = str;
			//this.itemShowList.splice(0);
			Mgr.msgMgr.Send( msg );
		},

        /// 客户端自己模拟发送消息
        OnRecvClientMesage:function(type,content){
//            var data = TextUtil.AnalyzeHtmlInfo({
//                content : content,
//                values : [],
//            });
//            var str = data.text;
            var msg = {
                playerId:new Long(), // 玩家ID
//                name:TextUtil.RemoveHTMLTag(data.obj.values[0]), // 玩家名字
                name:"", // 玩家名字
                type:type, // 聊天类型
                //chatText:str, // 聊天内容
                chatText:content, // 聊天内容
                j_content:content, // 聊天内容
                //linkText:data.linktext,
                //color:data.color,
                //lData:data.lData,
                targetPlayerId:null, // 聊天目标id
                extraResInfo:{
                    "__instanceId": 19681,
                    "targetPlayerName": null,
                    "viplevel": 0,
                    "guildOfficial": 0,
                    "plamtVip": 0,
                    "domain": 0,
                    "hyperInfos": [],
                    "itemInfos": []
                }
            }

            this.OnRecvChatMessage(msg);
        },
        OnRecvChatMessage:function(msg){
            //私聊消息
            if(msg.type == EnumChatChannelType.PRIVATE){
                if(!Mgr.plugset.GetSysSetInfo().banPrivateChat)
                {
                    this.privateList.push(msg);
                    Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName ).GetNewFriendChatInfo(msg);
                    var panel = Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName);
                    if(panel&&panel.visible)
                    {
                        panel.friendPanel.ReceiveChatInfomation(msg);
                    }
                }
            }else{
                if(Mgr.plugset.IsReceiveCurrentChannelChatInfo(msg.type))
                {
                    this.historyList.push(msg);
                    if(this.historyList.length > 80){
                        this.historyList.shift();
                    }
                    this.UpdataChatInfo(msg);
                }
            }
        },

        RecvResChatMessage:function(msg) {
            // 屏蔽黑名单聊天
            if(Mgr.friend.JugementIsBlacklistPlayer(msg.playerId,msg.name)){
                return;
            }

            // START 玩家发送的消息，删除掉html标签，且不能影响后续对于item和hyper的判断解析
            var char = String.fromCharCode(0xFF);
            var text = msg.chatText.replace(/<.*?>/g, function(v){
                return new Array(v.length - 1).join(char);
            });

            msg.j_content = text;
            msg.j_content = ChatUtil.getChatContent(msg);
            msg.j_content = msg.j_content.replace(new RegExp(char,"g"),"")
            // END

            this.OnRecvChatMessage(msg);
        },
		UpdataChatInfo:function(msg)
		{
			if (this._chatPanel)
			{
				this._chatPanel.UpdateChatListInfo(msg);
			}
            Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName ).UpdateBottomChatMessage(msg);
		},
		Callback:function(data,sender)
		{
			switch(Number(data.hyperType))
			{
				case EnumLinkType.TEAM_APPLY:
				{
					var l = new Long();
					l.StringValue( data.params_ );
					Mgr.team.SendReqJoinTeamMessage( l );
					break;
				}
                case EnumLinkType.ITEM_HTML:
                    var tempArr = data.data[1].split("@");
                    ItemUtil.ShowTips({
                        itemModelId : tempArr[0],
                    },-1);
                    break;
                case EnumLinkType.ITEM:
                {
                    ItemUtil.ShowTips(data,-1);
                    break;
                }
				case EnumLinkType.PLAYER:
				{
					//Mgr.player.SendReqPlayerBriefMessage([data.playerId],EnumBriefType.PAIHANB);
                    // TODO 如果要打开聊天栏就打开下面
                    //Mgr.chat.ShowHideChatPanel(true);
					if(data.playerId.toGID() != Mgr.player.mainPlayer.sid.toGID())
					{

//						var pos = cc.p(this._chatPanel.width-40,cc.winSize.height/2);
						var pos = cc.p(0,0);
                        if(sender && sys.isObjectValid(sender)){
                            pos = sender.convertToWorldSpace(cc.p(0,0))
                            pos.y = cc.winSize.height/2;
                        }
						EngineMgr.uiMgr.ShowHidePanelByType(MenuPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
						Mgr.uiMgr.GetPanelByType(MenuPanelExt.PanelName).SetInformation(data,pos);
						Mgr.uiMgr.HidePanelByType(MenuPanelExt.PanelName);

                        Mgr.player.SendReqPlayerBriefMessage([data.playerId],EnumBriefType.HEAD_MENUE);
					}
					break;
				}
                case EnumLinkType.CHAT_GUIDE:
                {
                    this.OnChatGuide(data);
                    break;
                }
				default : break;
			}
		},
		GetChatItem:function(msg,isMainUI,lineHeight)
		{
			var isYuying = this.JugementYuyingInfo(msg);
			var chatItem = null;
			if (msg.type == EnumChatChannelType.MANY
				|| msg.type == EnumChatChannelType.SYSTEM
				|| msg.type == EnumChatChannelType.NEWSYSTEM
				|| msg.type == EnumChatChannelType.SOUND
				|| isMainUI)
			{
				if(isYuying)
				{
					msg.chatText = "语音消息";
				}
				if ( msg.type == EnumSystemInfoType.CHAT_TEAM )   //队伍提示
				{
					chatItem = new ChatTeamTopicExt(msg);
					chatItem.LoadPanel();
				}
				else {
					chatItem = new ChatItem(this.Callback, this,lineHeight);
					chatItem.CreateItem(msg, isMainUI);
				}
			}
			else if ( msg.type == EnumSystemInfoType.CHAT_TEAM )   //队伍提示
			{
				chatItem = new ChatTeamTopicExt(msg);
				chatItem.LoadPanel();
			}
			else if( msg.type == EnumSystemInfoType.GUILD_ANSWER )//帮会答题
			{
				chatItem = new ChatTopicExt(msg);
				chatItem.LoadPanel();
			}
			else
			{
				chatItem = new ChatQipaoExt(msg,lineHeight);
				chatItem.LoadPanel();
			}
			if(msg.type == EnumChatChannelType.SOUND && isMainUI)
			{//广播传音
				msg.type = EnumChatChannelType.SOUND_GUANGBO;
				var item = new ChatItem(this.Callback,this);
				item.CreateItem(msg,isMainUI);
				var ft = new SlippingTipsPanelExt();
				ft.SetItem(item);
				var str = "占位";
				str+=msg.name + ":"
				str+=this.tempEditContent;
				ft.SetData(str, 10);
				Mgr.uiMgr.GetTipsLayer().addChild(ft);
			}
			return chatItem;
		},
		//判断是否为语音消息
		JugementYuyingInfo:function(msg)
		{
			var extraResInfo = msg.extraResInfo;
			if(extraResInfo.hyperInfos.length == 1)
			{
				var item = extraResInfo.hyperInfos[0];
				if(item.hyperType == EnumLinkType.YUYING)
				{
					return true;
				}
			}
			return false;
		},

		ShowHideChatPanel:function ( value ) {
			if( Mgr.chat.isChatPanelOpen === value )
				return;
			Mgr.chat.isChatPanelOpen = value;
			if( this._chatPanel ){
				this._chatPanel.ShowHidePanel(value);
			}
			if( Mgr.player.shortPanel )
				Mgr.player.shortPanel.CheckShowChatBg();
		},
        //聊天记录
		RecvResChatRecordMessage:function(msg) {
			var panel = Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName);
			if(panel&&panel.friendPanel.visible)
			{
				panel.friendPanel.HandleChatRecordInfo(msg);
			}
            if(this.notOnlineList.Get(msg.playerId))
            {
                Mgr.chat.Remove(msg.playerId);
                Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName ).SetNotOnlineChatInfoCount();
            }
		},
		// 发送离线信息条数
		RecvResOfflineChatCountMessage:function(msg) {
			//cc.log("发送离线信息条数====> "+JSON.stringify(msg));
            this.notOnlineList.Put(msg.sourceId,msg);
            Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName ).SetNotOnlineChatInfoCount(msg);
		},
        GetNotOnlineChatCount:function()
        {
            var list = this.notOnlineList.Values();
            var count = 0;
            for(var i = 0, len =list.length; i < len; i++ )
            {
                count += list[i].count;
            }
            return count;
        },
		RecvResWorldChatNumsMessage:function(msg) {
		},

		SendReqChatMessage:function(msg) {
		},

		SendReqReportPlayerMessage:function(msg) {
		},

		//申请聊天记录
		SendReqChatRecordMessage:function(playerId) {
			//cc.log("请求聊天记录------------ "+JSON.stringify(playerId));
			if(!this.recordList)
			{
				this.recordList = new HashMap();
			}
			if(this.recordList.Get(playerId))
			{
				return;
			}
			else
			{
				this.recordList.Put(playerId,playerId);
			}
			var msg = new ReqChatRecordMessage();
			msg.targetId = playerId;
			Mgr.msgMgr.Send(msg);
		},
		//地理位置展示
		_AddMapShowToInput:function()
		{
			var currentMapId = Mgr.sceneMap.nMapId;
			var mapInfo = Q_map.Get(currentMapId);
			var pos = Mgr.mainPlayer.oMoveRule._object.GetGridPt();
			var itemVo = new ShowHyperVo();
			itemVo.type = EnumLinkType.MAP;
			itemVo.hexsid = EnumLinkType.MAP + '_' + Mgr.player.mainPlayer.sid.hexValue + '_0_' + currentMapId + '_'+ /*Mgr.mainPlayer.curLine*/1 +'_' + pos.x + '_' + pos.y;
			itemVo.mid = 0;
			itemVo.str = mapInfo.q_map_name+"["+pos.x+","+pos.y+"]";
			itemVo.color = ColorUtil.N_GREEN_STR;
			itemVo.pos = this._chatPanel.editCue.string.length;
			this._chatPanel.editCue.setString(this._chatPanel.editCue.string+itemVo.str);
			this.itemShowList.push(itemVo);
		},
		faceAniRes:["017","015","016","007","018","036","037","038","043","072","087"],
		GetChatAnimationByIndex:function(i)
		{
			var listHead = Mgr.chat.faceAniRes;
			var obj = new MAnimationObject();
			obj.sResUrlBase = "res/animation/swf/face/"+listHead[i];
			obj.DoAction("stand5", 0);
			obj.scale = 0.7;
			obj.setContentSize(cc.size(36,30));
			return obj;
		},
		//触摸区域是否在聊天栏
		IsInChatArea:function(pos)
		{
			var panel = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName);
			if( panel ){
				var box = panel.imgChatBg1.getContentSize();
				var imgWorldPos = panel.imgChatBg1.getWorldPosition();
				var rect = cc.rect(imgWorldPos.x,imgWorldPos.y,box.width,box.height);
				if(cc.rectContainsPoint(rect,pos))
				{
					return true;
				}
			}
			return false;
		},
		_GetData:function(linktype,arr)
		{
			var data = {};
			data.hyperType = linktype;
			switch (linktype)
			{
				case EnumLinkType.PLAYER:
				{
					data.playerId = new Long(arr[1]);
					break;
				}
                case EnumLinkType.CHAT_GUIDE:
                {
                    data.data = arr;
                    break;
                }
				case EnumLinkType.ITEM_HTML:
				{
                    data.data = arr;
					break;
				}
				default:
                    data.data = arr;
					break;
			}
			return data;
		},
        OnChatGuide:function CM__OCG(o){
            var type = parseInt(o.data[1]);

            switch(type){
                case EnumChatGuide.GUILD_JOIN:
                    OpenFuncUtil.OpenGuild();
                    break;
                case EnumChatGuide.GOLD_CARD: break;

                case EnumChatGuide.BOSS:
                    OpenFuncUtil.OpenWorldBoss();
                    break;
                case EnumChatGuide.CROSS_ZONE:
                    OpenFuncUtil.OpenCrossZone(o);
                    break;
                case EnumChatGuide.TREASUREHUNT:
                    OpenFuncUtil.OpenTreasureHunt();
                    break;
                case EnumChatGuide.VIP:
                    OpenFuncUtil.OpenVip();
                    break;
                case EnumChatGuide.FIRSTRECHARGE:
                    OpenFuncUtil.OpenFirstRecharge();
                    break;
                case EnumChatGuide.LUCKYSHENJIBOX: break;
                case EnumChatGuide.ZONE_TEAM:
                    OpenFuncUtil.OpenZoneTeam(o);
                    break;
                case EnumChatGuide.LUCKDAYGOLDCOST: break;
                case EnumChatGuide.KINGDRUM_DRAW: break;
                case EnumChatGuide.RECHARGE_OPEN_DRAW:
                    OpenFuncUtil.OpenChoujiang();
                    break;
                case EnumChatGuide.EXCHANGE_ACT:
                    OpenFuncUtil.OpenTehui();
                    break;
                case EnumChatGuide.RECHARGE_ONE: break;
                case EnumChatGuide.WULINQINDIAN:
                	OpenFuncUtil.OpenWuLinQingDian();
                	break;
                case EnumChatGuide.ZHUANSHENG: break;
                case EnumChatGuide.NEWYEARLUCK: break;
                case EnumChatGuide.SPECIAL:
                    OpenFuncUtil.OpenSpecial();
                    break;
                case EnumChatGuide.NIANSHOURUQIN: break;
                case EnumChatGuide.BLESSLUCKDRAW: break;
                case EnumChatGuide.HUNYAN:
                    MarriageUtil.GoForHunyan()
                    break;
                case EnumChatGuide.HORSE           :
                case EnumChatGuide.WEAPONRIDE      :
                case EnumChatGuide.BEAUTY          :
                case EnumChatGuide.BEAUTY_HORSE    :
                case EnumChatGuide.WING            :
                case EnumChatGuide.WUXUE           :
                case EnumChatGuide.SCABBARD        :
                case EnumChatGuide.STEP            :
                    var r = type % 1000;
                    OpenFuncUtil.OpenResline(r);
                    break;
            }
        },
	});


 /**************************************************************************
 * 需要上层在startRecord stopRecord playOnline playEnd 时控制其他背景音量
 * 在playOnline stopPlay时控制播放状态 播放下一个时需要先stopPlay
 * 如果有其他接口需求再添加
 **************************************************************************/
var yaya = yaya || {};
yaya.loginSDK = function(id){};
yaya.startRecord = function(info){};//这里info参数就加上了 时长，url，识别结果，识别错误信息 后在stopRecord时返回
yaya.stopRecord = function() {};
yaya.playOnline = function(url) {};
yaya.stopPlay = function(){};
/**
 * 语音聊天，上传语音信息成功后的回调，还回信息
 * @param info
 * {
 * sendtime:"",发送时间
 * filePath:"",录音文件保存路径
 * audiotime:"",录音时长，毫秒
 * text:"",录音识别文本
 * channelType:"",频道
 * }
 * @constructor
 * @params 这里参数就是录音传入的参数 加上了 时长，url，识别结果，识别错误信息
 */
yaya.SendYuYinMsg = function(channelType,type,name)
{
	//这里中文要转下编码
	//cc.log(yaya.Utf8ToGBK(arguments[3]));	//识别结果
	//cc.log(yaya.Utf8ToGBK(arguments[4]));	//错误信息
	//yaya.playOnline( arguments[2] );	//播放测试
	if(Number(channelType) == EnumChatChannelType.MANY)
	{
		channelType = EnumChatChannelType.WORLD;
	}
	var info = {
		"url": arguments[2],
		"text": yaya.Utf8ToGBK(arguments[3]),
		"channelType": channelType,
		"audiotime": arguments[1]
	}
	if(!Mgr.chat.isCancelSend)
	{
		var msg = new ReqChatMessage();
		var extraReqInfo = new ExtraReqInfo();
		extraReqInfo.targetPlayerName = "嘻嘻";
		msg.type = channelType;
		msg.extraReqInfo = extraReqInfo;

		var hyperInfo = new HyperInfo();
		hyperInfo.hyperType = EnumLinkType.YUYING;
		hyperInfo.index = 0;
		hyperInfo.clientUseText = JSON.stringify(info);
		msg.extraReqInfo.hyperInfos.push( hyperInfo );
		msg.chatText = info.text;
		Mgr.msgMgr.Send( msg );
	}
}
yaya.Utf8ToGBK = function(utf8Str) {
	var gbkStr, i, len, c;
	var char2, char3;

	gbkStr = "";
	len = utf8Str.length;
	i = 0;
	while(i < len) {
		c = utf8Str.charCodeAt(i++);
		switch(c >> 4)
		{
			case 0: case 1: case 2: case 3: case 4: case 5: case 6: case 7:
			// 0xxxxxxx
			gbkStr += String.fromCharCode(c);
			break;
			case 12: case 13:
			// 110x xxxx   10xx xxxx
			char2 = utf8Str.charCodeAt(i++);
			gbkStr += String.fromCharCode(((c & 0x1F) << 6) | (char2 & 0x3F));
			break;
			case 14:
				// 1110 xxxx  10xx xxxx  10xx xxxx
				char2 = utf8Str.charCodeAt(i++);
				char3 = utf8Str.charCodeAt(i++);
				gbkStr += String.fromCharCode(((c & 0x0F) << 12) |
					((char2 & 0x3F) << 6) |
					((char3 & 0x3F) << 0));
				break;
		}
	}

	return gbkStr;
},
yaya.OnYuYinPlayEnd = function(){
	cc.log("语音播放完毕，修改语音显示状态与音量");
	Mgr.gameSoundMgr.ResumeSound();
}

/**
 * 录音超时回调
 * @param info
 * {
 * content:"",//超时信息
 * }
 * @constructor
 */
function OutTimeCallBack(info)
{
	//TODO 取消语音发送
	Mgr.chat.isCancelSend = true;
}
/*
	sougou yuyin
 */

var Sougou = Sougou || {}

Sougou.Startlistening = function()
{
	Startlistening();
}

Sougou.StopListening = function()
{
	StopListening();
}
Sougou.CancelListening = function()
{
	CancelListening();
}

Sougou._sogouTimeId = 0;
Sougou._startTime = 0;
Sougou.HandleYuyin = function(target,state)
{
	var now = TimerUtil.GetTimer();
	if (state == ccui.Widget.TOUCH_BEGAN)
	{
		Mgr.gameSoundMgr.PauseSound();
		//yaya.startRecord(Mgr.chat.curChatChannel.toString());
		if( cc.sys.isNative )
		{
			this._startTime = now;
			this._sogouTimeId = TimerUtil.SetTimeout( this, function(){
				Sougou.Startlistening();
			}, 100 );
		}
	}
	else if(state == ccui.Widget.TOUCH_ENDED && ( now - this._startTime > 500 ))
	{
		if( this._sogouTimeId )
			TimerUtil.ClearTimeout( this._sogouTimeId );
		this._sogouTimeId = 0;
		Mgr.gameSoundMgr.ResumeSound();
		if( cc.sys.isNative )
		{
			Sougou.StopListening();
		}
	}
	else if(state == ccui.Widget.TOUCH_CANCELED || ( state == ccui.Widget.TOUCH_ENDED && ( now - this._startTime < 500 ) ))
	{
		if( this._sogouTimeId )
			TimerUtil.ClearTimeout( this._sogouTimeId );
		Mgr.gameSoundMgr.ResumeSound();
		if( cc.sys.isNative )
		{
			Sougou.CancelListening();
		}
	}
};

//sougou yuyin call
function SougouListenCallbackJS(info)
{
	if(Mgr.chat.curChatChannel != EnumChatChannelType.PRIVATE)
	{
		var panel = EngineMgr.uiMgr.GetPanelByType(ChatPanelExt.PanelName);
		if(panel)
		{
			panel.OnSendMsg(info);
		}
	}
	else
	{
		var panel = EngineMgr.uiMgr.GetPanelByType(FriendPanelExt.PanelName);
		if(panel && panel.visible)
		{
			panel.SendChatInfo(info);
		}
	}
}






