
var ChatUtil = ChatUtil || {

    /**
     * 聊天冷却
     *
     */
    InitChatChannelCoolHash:function ()
    {
        var arr = new Array(14);
        var config = Q_global.Get(382);
        if (config)
            arr[0] = config.q_int_value;
        config = Q_global.Get(380);
        if (config)
            arr[1] = config.q_int_value;
        config = Q_global.Get(381);
        if (config)
            arr[2] = config.q_int_value;
        config = Q_global.Get(383);
        if (config)
            arr[4] = config.q_int_value;
        config = Q_global.Get(384);
        if (config)
            arr[5] = config.q_int_value;
        config = Q_global.Get(385);
        if (config)
            arr[12] = config.q_int_value;
        config = Q_global.Get(386);
        if (config)
            arr[6] = config.q_int_value;
        config = Q_global.Get(395);
        if (config)
            arr[13] = config.q_int_value;
        return arr;
    },

    TransformShowHyperVoList:function ( items, hypers )
    {
        var list = [];
        var i;
        var vo;
        if (items != null)
        {
            for (i = 0; i < items.length; i++)
            {
                vo = new ShowHyperVo();
                vo.itemInfo = items[i].itemInfos;
                vo.pos = items[i].index;
                vo.type = EnumLinkType.ITEM;
                list.push( vo);
            }
        }

        if (hypers != null)
        {
            for (i = 0; i < hypers.length; i++)
            {
                vo = new ShowHyperVo();
                vo.type = hypers[i].hyperType;
                vo.pos = hypers[i].index;
                vo.hexsid = hypers[i].params;
                vo.str = hypers[i].clientUseText;
                list.push( vo);
            }
        }

        return list;
    },

    /**
     * 创建带物品链接的说话消息
     * @param orginfo
     * @param items
     * @return
     *
     */
    CreateMsgInfoWithItem:function ( orginfo, items, sendName )
    {
    //     if (items.length == 0)
    //         return orginfo;
    //
    //     items = items.sort(this.SortByPos);
    //     var MAGIC = 0;// 破坏格式自动组合的魔数
    //     for (var i = 0; i < items.length; i++)
    //     {
    //         var res = items[i];
    //         var link;
    //         var color;
    //         if (items[i].type == EnumLinkType.ITEM)
    //         {
    //             var mid = res.itemInfo.itemModelId;
    //             var name = ItemUtil.itemInfoToItem(res.itemInfo).name;//ItemUtil.getItemName(mid);
    //             var sid:String = res.itemInfo.itemId.hexValue + "|" + (MAGIC++).toString();
    //             link = createItemLink(name, sid, mid);
    //
    //             var item:Item = ItemUtil.itemInfoToItem(res.itemInfo);//Mgr.backpackMgr.fromItemInfoToItem(res.itemInfo);
    //             item.ownname = sendName;
    //
    //             Mgr.chatMgr.chatItemHash.put(item.itemId.hexValue, item);
    //
    //             color = ColorUtil.NumToHtmlC(ItemUtil.getItemNamecolor(item));
    //             link = TextUtil.getHtmlStr(link, color, -1);
    //             res.str = "[" + item.name + "]";
    // //					orginfo = orginfo.replace("[" + item.name + "]", link);
    // //					orginfo = orginfo.replace(String.fromCharCode(0xc), link);
    //         }
    //         else
    //         {
    //             link = createNormalLink(res.str, res.hexsid);
    //             color = ColorUtil.N_GREEN_STR;
    //             link = TextUtil.getHtmlStr( link, color, -1);
    // //					orginfo = orginfo.replace(res.str, link);
    // //					orginfo = orginfo.replace(String.fromCharCode(0xc), link);
    //         }
    //         var str:String = orginfo.substr(res.pos).replace(res.str, link);
    //         orginfo = orginfo.substr(0,res.pos) + str;
    //     }
    //
    //     return orginfo;
    },

    SortByPos:function (it1, it2)
    {
        if (it1.pos > it2.pos)
        {
            return -1;
        }
        else if (it1.pos < it2.pos)
        {
            return 1;
        }

        return 0;
    },

    createRichText:function(msg,sendName){
        var richText = new MUIRichText();
//        var content = this.getChatContent(msg);
        var content = (sendName || "") + msg.j_content;
        richText.SetCustomNodeCallback(this.onRichText_CustomNode,this);
        richText.SetOpenUrlCallback(this.onRichText_OpenUrl,this);
        richText.SetParseTextCallback(this.onRichText_ParseText,this);
        var color = ChatItem.prototype.GetContentColor(msg.type);
        var newColor = UIUtil.GetCCColor(color);

        richText.SetColor(newColor);
        richText.SetString(content);
        richText.SetHyperlinkBreakLine(true);
        richText.SetUserData(msg);

        return richText;
    },

    // 聊天背景图片
    getChannelBgName:function(type){
        var url = null;
        switch (type){
            case EnumChatChannelType.SYSTEM://系统
                url = "other/liaotian/image/biaoqian/xitong.png";
                break;
            case EnumChatChannelType.WORLD://世界
                url = "other/liaotian/image/biaoqian/shijie.png";
                break;
            case EnumChatChannelType.NEWSYSTEM://公告
                url = "other/liaotian/image/biaoqian/gonggao.png";
                break;
            case EnumChatChannelType.TEAM://队伍
                url = "other/liaotian/image/biaoqian/duiwu.png";
                break;
            case EnumChatChannelType.FACTION://帮会
                url = "other/liaotian/image/biaoqian/banghui.png";
                break;
            case EnumChatChannelType.SOUND://传音
            case EnumChatChannelType.SOUND_GUANGBO://传音
                url = "other/liaotian/image/biaoqian/chuanyin.png";
                break;
        }
        return url;
    },

    getAvatarByData:function(data){
        //var job = data.extraResInfo.guildOfficial << 4;
        var job = data.extraResInfo.job;
        return job == 2 ? "other/liaotian/image/touxiang1.png" : "other/liaotian/image/touxiang2.png";
    },

    getChatItemColor:function(v){
        var color = EnumFontFormat.COMMON_COLOR01;

        var cItem = Q_item.Get(v.itemInfos.itemModelId);
        if(cItem){
            //颜色
            switch(cItem.q_default){
                case 1:color = EnumFontFormat.COMMON_COLOR04    ;   break;
                case 2:color = EnumFontFormat.LINK_NAME_COLOR   ;   break;
                case 3:color = EnumFontFormat.LINK_ITEM_COLOR   ;   break;
                case 4:color = EnumFontFormat.LINK_OTHER_COLOR  ;   break;
                case 5:color = EnumFontFormat.COMMON_COLOR09    ;   break;
            }
        }

        return color;
    },
    getChatHyperColor:function(v){
        //颜色
        var color = EnumFontFormat.LINK_OTHER_COLOR;
        switch(v.hyperType){
            case EnumLinkType.TEAM_APPLY:  color = EnumFontFormat.LINK_OTHER_COLOR; break;
            case EnumLinkType.TEAM_APPLY_LF:  color = EnumFontFormat.LINK_OTHER_COLOR; break;
        }
        return color;
    },

    getChatContent:function(msg){
        // 建立缓存替换链接,匹配道具,匹配超链接
        var temp = [];
        for(var i=0;i!=msg.extraResInfo.hyperInfos.length;++i){
            var v = msg.extraResInfo.hyperInfos[i];
            temp.push({
                type : 0,
                index : v.index,
                text : v.clientUseText,
                data : v,
            })
        }
        for(var i=0;i!=msg.extraResInfo.itemInfos.length;++i){
            var v = msg.extraResInfo.itemInfos[i];
            var cItem = Q_item.Get(v.itemInfos.itemModelId);
            if(!cItem) continue;
            var name = "[" + cItem.q_name + "]";
            temp.push({
                type : 1,
                index : v.index,
                text : name,
                data : v,
            })
        }
        temp.sort(function(a,b){ return a.index - b.index; });

        var text = msg.j_content;
        var index = 0;
        var result = "";

        for(var i=0;i<temp.length;++i){
            var v = temp[i];
            result += text.substring(0,v.index + index);
            text = text.substring(v.index + index ,text.length);
            index = -v.index;

            var r = text.indexOf(v.text);
            if(r == 0){
                var color = v.type ? this.getChatItemColor(v.data) : this.getChatHyperColor(v.data);
                var title = v.type ? "item" : "hyper";
                result += "<a href=\"" + title + ":" + v.index + "\"><font color=\"" + color.replace("0x","#") +"\">" + v.text + "</font></a>";
                index -= v.text.length;
                text = text.substring(v.text.length ,text.length);
            }
        }
        result += text;

        // 匹配表情并替换
        result = result.replace(/\#[0-9]{5}/g,function(v){
            var num = parseInt(v.substring(1,v.length));
            if(10001 <= num && num <= 10023){
                return "<custom href=\"" + v + "\">"
            }
            return v
        });
        return result;
    },

    onRichText_CustomNode:function(v,sender){
        var index = parseInt(v.substring(1,v.length)) %10000;
        var sp = Mgr.chat.GetChatAnimationByIndex(index - 1);           
        return sp;
    },
    onRichText_OpenUrl:function(v,sender){
        /// 匹配自定义规则
        var ret = v.match(/(\w+):(.+)/);
        if(ret){
            var msg = sender.GetUserData();
            var type = ret[1];
            var data = ret[2];

            switch(type){
                case "item":{
                    var index = parseInt(data);
                    var items = msg.extraResInfo.itemInfos;
                    for(var i=0;i!=items.length;++i){
                        var v = items[i];
                        if(v.index == index){
                            ItemUtil.ShowTips(v.itemInfos,-1);
                            break;
                        }
                    }
                }break;
                case "hyper":{
                    var index = parseInt(data);
                    var hyperInfos = msg.extraResInfo.hyperInfos;
                    for(var i=0;i!=hyperInfos.length;++i){
                        var v = hyperInfos[i];
                        if(v.index == index){
                            Mgr.chat.Callback(v,sender);
                            break;
                        }
                    }
                }
                case "event":{
                    var ssss = data.split("_");
                    var linkType = Number(ssss[0]);
                    var lData = Mgr.chat._GetData(linkType,ssss);

                    Mgr.chat.Callback(lData,sender);
                }
                break;
            }
        }
    },
    onRichText_ParseText:function(data){
        // 在这里替换颜色
        // 也可以做超链接的预解析

        return data;
    },
}