///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//CrossPlayerinfo 玩家跨服数据信息
//JoinSyncToPublicinfo 连接public后同步信息(可扩展)

// 请求消息
//250201,ReqLoginFightServerClientToFight 前端开始登录战斗服
//250202,ReqQuitClientToFight 前端请求退出跨服
//250203,ReqEnterCrossClientToGame 前端请求进跨服(test)

// 接收消息
//250101,ResChangeServerGameToClient 通知前端登录战斗服


var CrossPlayerinfo = cc.Class.extend({
	ctor:function(){
		this.playerId = null; // 角色id
        this.userId = null; // 账号
        this.oldserverkey = 0; // 原服Serverkey
        this.fightServerKey = 0; // 战斗服ServerKey
        this.data = null; // 玩家数据
        this.guildname = null; // 帮会名字
        this.expand = null; // 扩展数据
        this.marriageData = null; // 结婚数据
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteLong(this.userId);
        _buf.WriteVarInt(this.oldserverkey);
        _buf.WriteVarInt(this.fightServerKey);
        _buf.WriteString(this.data);
        _buf.WriteString(this.guildname);
        _buf.WriteString(this.expand);
        _buf.WriteString(this.marriageData);
	},
	
	reading:function( _buf ){
		this.playerId = _buf.ReadLong();
        this.userId = _buf.ReadLong();
        this.oldserverkey = _buf.ReadVarInt();
        this.fightServerKey = _buf.ReadVarInt();
        this.data = _buf.ReadString();
        this.guildname = _buf.ReadString();
        this.expand = _buf.ReadString();
        this.marriageData = _buf.ReadString();
	},
});
var JoinSyncToPublicinfo = cc.Class.extend({
	ctor:function(){
		this.openTime = null; // 开区时间
        this.serverkey = 0; // Serverkey
	},

	writing:function( _buf ){
		_buf.WriteLong(this.openTime);
        _buf.WriteVarInt(this.serverkey);
	},
	
	reading:function( _buf ){
		this.openTime = _buf.ReadLong();
        this.serverkey = _buf.ReadVarInt();
	},
});
////////////////////
// 通知前端登录战斗服 //
////////////////////
var ResChangeServerGameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 角色id
        this.userId = null; // 账号id
        this.oldserverKey = 0; // 原服Serverkey
        this.fightServerKey = 0; // 战斗服ServerKey
        this.serverIp = null; // 战斗游戏服务器Ip
        this.serverPort = 0; // 战斗游戏服务器port
        this.serverSSLPort = 0; // 战斗游戏服务器sslport
        this.fighttype = 0; // 战斗类型(1.10v10 2.多人副本)
        this.expand = null; // 参数(多人副本表示副本model)
	},

	getId:function(){
		return 250101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteLong(this.userId);
        _buf.WriteVarInt(this.oldserverKey);
        _buf.WriteVarInt(this.fightServerKey);
        _buf.WriteString(this.serverIp);
        _buf.WriteVarInt(this.serverPort);
        _buf.WriteVarInt(this.serverSSLPort);
        _buf.WriteVarInt(this.fighttype);
        _buf.WriteString(this.expand);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.userId = _buf.ReadLong();
        this.oldserverKey = _buf.ReadVarInt();
        this.fightServerKey = _buf.ReadVarInt();
        this.serverIp = _buf.ReadString();
        this.serverPort = _buf.ReadVarInt();
        this.serverSSLPort = _buf.ReadVarInt();
        this.fighttype = _buf.ReadVarInt();
        this.expand = _buf.ReadString();
	},

	action:function(){
		Mgr.cross.RecvResChangeServerGameToClientMessage(this);
	},

});
////////////////////
// 前端开始登录战斗服 //
////////////////////
var ReqLoginFightServerClientToFightMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 角色id
        this.userId = null; // 账号id
        this.oldserverKey = 0; // 原服Serverkey
        this.fightServerKey = 0; // 战斗服ServerKey
	},

	getId:function(){
		return 250201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteLong(this.userId);
        _buf.WriteVarInt(this.oldserverKey);
        _buf.WriteVarInt(this.fightServerKey);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.userId = _buf.ReadLong();
        this.oldserverKey = _buf.ReadVarInt();
        this.fightServerKey = _buf.ReadVarInt();
	},

});
////////////////////
// 前端请求退出跨服 //
////////////////////
var ReqQuitClientToFightMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 250202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 前端请求进跨服(test) //
////////////////////
var ReqEnterCrossClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 跨服活动类型
	},

	getId:function(){
		return 250203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(250101, ResChangeServerGameToClientMessage);

