var EnumCrossteamType = EnumCrossteamType ||
{
	TEAM_CAPTAIN:0,//0队长，1,2,3,4普通成员
	STATE_READY:1,//1准备，0未准备
	STATE_READY_NOT:0,//1准备，0未准备
	TEAM_MEM_NUMBER:3,//队伍队员数量
	TEAM_ALLOW:1,//只允许邀请的玩家加入队伍 1:是，0否
	TEAM_NOY_ALLOW:0
}
var CrossteamModMgr = CrossteamModMgr || cc.Class.extend({
	_zoneListData:null,
	isInteam:false,
	teamListview:null,
	teamList:null,
	myTeam:null,
	_timerIndex:0,
	isTeamMaster:false,
	isCancelReady:false,
	curzoneModelId:null,
	isAutoRepeat:true,
	ctor:function() {
		this._zoneListData = new HashMap();
		this.teamListview = new HashMap();
		this.teamList = new HashMap();
	},
	//更新队伍信息
	RecvResCrossTeamInfoGameToClinetMessage:function(msg){
		if(msg.teamInfo.memberinfo.length > 0)
		{
			this._SetMyteam([msg.teamInfo]);
			this._UpdateTheTeamInfo(msg);
		}
	},
	//team list
	RecvResCrossTeamsForZoneModelGameToClinetMessage:function(msg) {
		//cc.log("----- 返回跨服副本队伍信息 ----------- "+JSON.stringify(msg));
		msg.teamInfo.sort(function(a,b){return a.memberinfo.length - b.memberinfo.length;});

		// updata team
		var panel = Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName);
		if (panel && panel.curSubType == TeamEnum.PANEL_TEAM_QUICK_TEAM)
			panel.curSubPanel.SetCrossTeamData(msg.teamInfo);

		var teamlist = msg.teamInfo;
		this._SetMyteam(msg.teamInfo);
		var len = teamlist.length;
		var panel = this._GetDuorenPanel();
		if(len>0 && panel&&panel.visible)
		{
			panel.mainPanel.SetTeamlistData(msg);
		}
		else if(len == 0 && panel&&panel.visible)
		{
			var zoneModelId = this._GetDuorenPanel().mainPanel.selectedItem.data.base.zoneModelid;
			var listview = this.teamListview.Get(zoneModelId);
			if(listview)
			{
				listview.removeAllItems();
			}
		}
		this.teamList.Clear();
		for(var i = 0; i < len; i++ )
		{
			this.teamList.Put(teamlist[i].teamId,teamlist[i]);
		}
	},
	//
	RecvResLeaveCrossTeamGameToClinetMessage:function(msg) {
		this._UpdateLeaveTeamInfo(msg);
	},

	RecvResInviteZoneNoticeGameToClinetMessage:function(msg) {
	},
	//邀请玩家
	RecvResCrossTeamInvitePlayerGameToClinetMessage:function(msg) {
		if(Mgr.plugset.GetSysSetInfo().banInviteTeam)
		{
			return;
		}
		EngineMgr.uiMgr.ShowPanelByType(YaoqingCueExt.PanelName,UIMgr.PANEL_LAYER_TOP);
		var panel = Mgr.uiMgr.GetPanelByType(YaoqingCueExt.PanelName);
		if(panel)
		{
			panel.SetInformation(msg);
		}
	},
	//request team list
	SendReqCrossTeamsForZoneModelClientToGameMessage:function(data) {
		cc.log("-------- 跨服副本队伍信息--------------")
		var msg = new ReqCrossTeamsForZoneModelClientToGameMessage();
		msg.zoneModelId = data.zoneModelId; // 绑定副本模版(0表示所有副本)
		msg.startNum = data.startNum; // 第几个开始
		msg.num = data.num; // 需要显示几个
		msg.type = data.type; // 0所有 1允许加入的队伍
		Mgr.msgMgr.Send(msg);
	},
	//create team
	SendReqCreateCrossTeamClientToGameMessage:function(data) {
		var msg = new ReqCreateCrossTeamClientToGameMessage();
		msg.zoneModelId = data.zoneModelId; // 绑定副本模版
		msg.needFightpower = data.needFightpower; // 所需战斗力
		msg.autoStart = data.autoStart; // 是否自动开始
		msg.passWord = data.passWord; // 队伍密码
		msg.autoLoop = this.isAutoRepeat;
		Mgr.msgMgr.Send(msg);
	},
	//join team
	SendReqJoinCrossTeamClientToGameMessage:function(data,isYaoqingPlayer) {
		var msg = new ReqJoinCrossTeamClientToGameMessage();
		msg.teamid = data.teamid; // 队伍Id（id为0表示快速加入）
		msg.zoneModelId = data.zoneModelId; // 副本模版
		msg.passWord = data.passWord; // 队伍密码
		var listview = Mgr.crossteam.teamListview.Get(data.zoneModelId);
		var isYaoqing = false;
		if (listview && !isYaoqingPlayer)
		{
			var items = listview.getItems();
			for(var i = 0;i <items.length;i++)
			{
				if(items[i].data.teamId.toGID() == data.teamid.toGID())
				{
					if(items[i].data.needCheck == 1)
					{
						isYaoqing = true;
					}
				}
			}
		}
		if(!isYaoqing)
		{
			Mgr.msgMgr.Send(msg);
		}
		else
		{
			Mgr.tips.ShowNotice("只允许邀请玩家加入");
		}
	},
	//leave team
	SendReqLeaveCrossTeamClientToGameMessage:function(msg) {
		var msg = new ReqLeaveCrossTeamClientToGameMessage();
		Mgr.msgMgr.Send(msg);
	},
	// 把玩家踢出队伍
	SendReqKickMemberClientToGameMessage:function(playerid) {
		var msg = new ReqKickMemberClientToGameMessage();
		msg.playerid = playerid;
		Mgr.msgMgr.Send(msg);
	},
	//change state
	SendReqChangeStateClientToGameMessage:function(isReady, zoneModelId) {
		cc.log("=========改变准备状态=========" + zoneModelId,this.myTeam.zoneModelId)
		//组队的队友  在这里记录当前挑战的多人副本id
		if(isReady)
            this.curzoneModelId = this.myTeam ? this.myTeam.zoneModelId : zoneModelId;
		var msg = new ReqChangeStateClientToGameMessage();
		msg.isReady = isReady;
		msg.zoneModelId = zoneModelId;
		Mgr.msgMgr.Send(msg);
	},
	//开始副本
	SendReqStartCrossTeamZoneClientToGameMessage:function(zoneModelId) {
		this.curzoneModelId = this.myTeam ? this.myTeam.zoneModelId : zoneModelId;
		cc.log("===========开始副本==========" + this.curzoneModelId)
		var msg = new ReqStartCrossTeamZoneClientToGameMessage();
		msg.zoneModelId = zoneModelId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqInviteZoneNoticeClinetToGameMessage:function(msg) {
		var msg = new ReqInviteZoneNoticeClinetToGameMessage();
		Mgr.msgMgr.Send(msg);
	},
	//是否只允许邀请玩家加入队伍
	SendReqChangeCrossTeamConfigToGameMessage:function(type,type01) {
		var msg = new ReqChangeCrossTeamConfigToGameMessage();
		msg.onlyInvite = type;
		msg.autoStart = type01;
		msg.autoLoop = this.isAutoRepeat;
		Mgr.msgMgr.Send(msg);
	},
	//邀请玩家
	SendReqCrossTeamInvitePlayerToGameMessage:function(invitePlayerId) {
		var msg = new ReqCrossTeamInvitePlayerToGameMessage();
		msg.invitePlayerId = invitePlayerId;
		Mgr.msgMgr.Send(msg);
	},
	RequestZoneListData:function()
	{
		Mgr.zone.SendReqZoneBasicObtainToGameMessage(EnumZoneType.TYPE_KFDR);
	},
	HandleZoneListData:function(data)
	{
		for(var i = 0; i < data.length; i++ )
		{
			var obj = {base:data[i],detail:Q_zone.Get(data[i].zoneModelid),item:Q_raid.Get(data[i].zoneModelid)};
			this._zoneListData.Put(data[i].zoneModelid,obj);
		}
		this.SetZonelistData(this._zoneListData);
	},
	//副本列表信息处理
	SetZonelistData:function(data)
	{
		var panel = this._GetDuorenPanel();
		if(!panel){return;}
		this._ClearInfo();
		var mainPanel = panel.mainPanel;
		var type = panel.zonetype;
		if(type == EnumZoneType.TYPE_KFDR)
		{
			var zoneScrollview = mainPanel.zoneScrollview;
			zoneScrollview.jumpToTop();
			var itemArr = mainPanel.itemArr;
			var da = data.Values();
			var len= da.length;
			var childes = zoneScrollview.getChildren();
			cc.log("child-len=============== "+len);
			cc.log("child-len=============== "+childes.length);
			if(childes.length < 1)
			{
				var height = mainPanel.itemNormalHeight*(len-1)+mainPanel.itemSelectedHeight;
				if(height<480)
				{
					height = 480;
				}
				var innerSize = cc.size(zoneScrollview.getContentSize().width,height);
				zoneScrollview.setInnerContainerSize(innerSize);
				//Profiler.Start("start---------------------------------------xixixii__0");
				for (var i = 0; i < len; i++ )
				{
					//Profiler.Start("start---------------------------------------xixixii__0");
					var item = new DuorenSmallListInfoExt(da[i]);
					item.LoadPanel();
					item.SetIndex(i);
					item.y = innerSize.height-item.height*(i+1);
					zoneScrollview.addChild(item);
					itemArr.push(item);
					//Profiler.Stop("start---------------------------------------xixixii__0");
				}
				//Profiler.Stop("start---------------------------------------xixixii__0");
			}
			else
			{
				//刷新副本列表信息
				for( var i = 0; i < len; i++ )
				{
					for ( var j = 0; j < childes.length; j++ )
					{
						if(childes[i])
						{
							childes[i].SetData(da[i]);
							childes[i].visible = true;
						}
					}
				}
			}
			itemArr[0].ShowDetailEvent(null,2);
			mainPanel.ShowDefaultZoneItem();
			mainPanel.ShowOrHideComponent(false);
		}
		else if(type == EnumZoneType.TYPE_LFDR)
		{
			mainPanel.ShowOrHideTeamlist(data.Values()[0].base.zoneModelid);
			var obj ={data:data.Values()[0]};
			mainPanel.UpdateInformation(obj);
			mainPanel.ShowOrHideComponent(true);
		}
	},
	RefreshScrollviewSize:function(index)
	{
		var panel = this._GetDuorenPanel();
		if(!panel){return;}
		var mainPanel = panel.mainPanel;
		var len = mainPanel.itemArr.length;
		for(var i = 0; i <len; i++)
		{
			var normalHeight = mainPanel.itemArr[0].height-10;
			if(index == mainPanel.itemArr[i].index)
			{
				mainPanel.itemArr[i].y -= normalHeight;
				mainPanel.UpdateInformation(mainPanel.itemArr[i]);
			}
			else
			{
				mainPanel.itemArr[i].UpdateContentSize(false);
			}
			var size = mainPanel.zoneScrollview.getInnerContainerSize();
			mainPanel.itemArr[0].y = size.height-mainPanel.itemArr[0].height;
		}
		for(var i = 1; i < len; i++ )
		{
			var gap = mainPanel.itemArr[i].y -mainPanel.itemArr[i-1].y + mainPanel.itemArr[i].height;
			mainPanel.itemArr[i].y -= gap;
		}
	},
	_GetDuorenPanel:function()
	{
		var pl = Mgr.uiMgr.GetPanelByType(DuorenPanelExt.PanelName);
		return pl
	},
	GetListview:function(width,height)
	{
		var listView = new ccui.ListView();
		listView.setContentSize(cc.size(width,height));
		listView.setBounceEnabled(true);
		listView.setSwallowTouches(false);
		listView.setScrollBarEnabled(false);
		return listView;
	},
	GetScrollView:function()
	{
		var contentSize = cc.size(653,495);
		var sc = ccui.ScrollView.create();
		sc.setContentSize(contentSize);
		sc.setDirection(ccui.ScrollView.DIR_VERTICAL);
		sc.setScrollBarEnabled(false);
		sc.setBounceEnabled(true);
		return sc;
	},
	_SetMyteam:function(msg)
	{
		var panel = this._GetDuorenPanel();
		if(!panel){return;}
		var mainPanel = panel.mainPanel;
		if(!msg)
		{
			this.isInteam = false;
			this.myTeam = null;
			if(mainPanel &&mainPanel.visible)
			{
				mainPanel.UpdateInformation(mainPanel.selectedItem);
			}
			return;
		}
		var teamlist = msg;
		var len = teamlist.length;
		var pId = Mgr.player.mainPlayer.sid.toGID();
		for ( var i = 0; i < len; i++ )
		{
			var memberlist = teamlist[i].memberinfo;
			var len2 = memberlist.length;
			for ( var j = 0; j < len2; j++ )
			{
				if(memberlist[j].memberId.toGID() == pId)
				{
					this.isInteam = true;
					this.myTeam =teamlist[i];
					if(memberlist[j].job == EnumCrossteamType.TEAM_CAPTAIN)//队长，自动准备
					{
						this.SendReqChangeStateClientToGameMessage(EnumCrossteamType.STATE_READY, mainPanel.selectedItem.data.base.zoneModelid);
					}
					if(mainPanel &&mainPanel.visible)
					{
						mainPanel.labFBname.SetString(Q_zone.Get(teamlist[i].zoneModelId ).q_name);//q_name
					}
					var yqMainPanel = Mgr.uiMgr.GetPanelByType(YaoqingMainExt.PanelName);
					if(yqMainPanel && yqMainPanel.visible)
					{
						yqMainPanel.RequiestPlayerData();
					}
					return;
				}
			}
		}
	},
		//更新当前副本队伍列表信息
		UpdateTeamlist:function(data,listview)
		{
			var teamlist = data.teamInfo;
			var len01 = teamlist.length;
			var items = listview.getItems();
			var len02 = items.length;
			for ( var i = 0; i < len01; i++ )
			{
				//for(var j = 0; j < len02; j++ )
				//{
				//	if(teamlist[i].teamId.toGID() == items[j].data.teamId.toGID())
				//	{
				//		items[j].UpdateFrameData(teamlist[i]);
				//		break;
				//	}
				//	else if( j == len02-1 )
					{
						var item = new DuorenFrameExt(teamlist[i]);
						item.LoadPanel();
						listview.pushBackCustomItem(item);
					}
				//}
			}
		},
		//更新某只队伍信息
		_UpdateTheTeamInfo:function(data)//ShowOrHideTeamlist
		{
			var panel = this._GetDuorenPanel();
			if(!panel){return;}
			var teamData = data.teamInfo;
			var mainPanel = panel.mainPanel;
			//玩家所在队伍
			if(teamData.teamId.toGID() == this.myTeam.teamId.toGID())
			{
				var myTeamList = mainPanel.myTeamList;//listview
				if(myTeamList&&myTeamList.getItems().length>0)
				{
					var oldList = myTeamList.getItems();
					var newList = teamData.memberinfo;
					for( var i = 0; i < EnumCrossteamType.TEAM_MEM_NUMBER; i++)
					{
						oldList[i].UpdateFrameData(newList[i]);
					}
					mainPanel.SetAutoStartFuben(teamData.memberinfo);
				}
				else
				{
					mainPanel.ShowOrHideTeamlist(teamData.zoneModelId);
				}
				mainPanel.SetYaoQingCheckBoxState(data.teamInfo.needCheck);
				mainPanel.SetManYuanKaiShiCheckBoxState(data.teamInfo.autoStart);
			}
			//非玩家所在队伍,1:找到队伍所在副本,2:找到队列中的该队伍
			var listView = this.teamListview.Get(teamData.zoneModelId);
			if(listView)
			{
				var items = listView.getItems();
				for(var i = 0; i < items.length; i++ )
				{
					if(items[i].data.teamId.toGID() == teamData.teamId.toGID())
					{
						items[i].UpdateFrameData(teamData);
						break;
					}
				}
			}
		},
		//玩家离开，更新队伍信息
		_UpdateLeaveTeamInfo:function(data)
		{
			var panel = this._GetDuorenPanel();
			if(!panel){return;}
			var pId = Mgr.player.mainPlayer.sid.toGID();
			var lId = data.playerid.toGID();
			if(pId == lId)
			{
				this._SetMyteam(false);
			}
			else
			{
				var mainPanel = panel.mainPanel;
				var myTeamList = mainPanel.myTeamList;//listview
				var items = myTeamList.getItems();
				for (var i = 0; i < EnumCrossteamType.TEAM_MEM_NUMBER; i ++)
				{
					var item = items[i];
					if(item)
					{
						var da = item.data;
						if(da)
						{
							if(da.memberId.toGID() == lId)
							{
								items[i].UpdateFrameData(null);
							}
						}
					}
					if(i<this.myTeam.memberinfo.length)
					{
						if(lId == this.myTeam.memberinfo[i].memberId.toGID())
						{
							this.myTeam.memberinfo.splice(i, 1);
							break;
						}
					}
				}
			}
			this._UpdatePlayerTeamlist();
		},
		_UpdatePlayerTeamlist:function()
		{
			var panel = this._GetDuorenPanel();
			if(!panel){return;}
			var mainPanel = panel.mainPanel;
			var listview = mainPanel.myTeamList;//listview
			if ( this.isInteam )
			{
				var myTeamInfo = this.myTeam;
				var items = listview.getItems();
				for (var i = 0; i < EnumCrossteamType.TEAM_MEM_NUMBER; i ++)
				{
					items[i].UpdateFrameData( myTeamInfo.memberinfo[i] );
				}
			}
			else
			{
				listview.removeAllItems();
				listview.visible = false;
				mainPanel.ChangeVisible();
				//mainPanel.RefreshScrollviewSize(mainPanel.selectedItem.index);
				//var teamList = this.teamListview.Get(mainPanel.selectedItem.data.base.zoneModelid);
			}
		},
		//筛选出可以加入的队伍
		FilterCanJoinTeam:function()
		{
			var panel = this._GetDuorenPanel();
			if(!panel){return;}
			var mainPanel = panel.mainPanel;
			this.RefreshScrollviewSize(mainPanel.selectedItem.index);
			var teamList = this.teamListview.Get(mainPanel.selectedItem.data.base.zoneModelid);
			if(teamList)
			{
				var items = teamList.getItems();
				var len = items.length;
				if(mainPanel.isJoin && len)
				{
					for ( var i = 0; i < len; i++ )
					{
						if(items[i].data.memberinfo.length == EnumCrossteamType.TEAM_MEM_NUMBER)
						{
							items[i].visible = false;
						}
					}
				}
				else
				{
					for(var i = 0; i < items.length;i++)
					{
						items[i].visible = true;
					}
				}
			}
		},
		_ClearInfo:function()
		{
			var panel = this._GetDuorenPanel();
			if(!panel){return;}
			var mainPanel = panel.mainPanel;
			var childes = mainPanel.zoneScrollview.getChildren();
			for(var i = 0; i < childes.length; i++ )
			{
				childes[i].visible = false;
			}
			//mainPanel.zoneScrollview.removeAllChildren();
			if(mainPanel.myTeamList)
			{
				mainPanel.myTeamList.removeAllItems();
			}
			//mainPanel.itemArr.splice(0);
			var teamlist = this.teamListview.Values();
			var len = teamlist.length;
			for(var i = 0; i < len; i++ )
			{
				teamlist[i].removeFromParent();
			}
			this.teamListview.Clear();
			this.isInteam = false;
		},
		ClearPlayerPanelInZone:function()
		{
			this._SetMyteam(false);
		},
		JugementTeamMaster:function()
		{
			var panel = this._GetDuorenPanel();
			if(!panel){return;}
			var listview = panel.mainPanel.myTeamList
			if(listview && listview.getItems().length>0)
			{
				var items = listview.getItems();
				for(var i = 0; i<items.length;i++)
				{
					if(items[i].labDuizhang.visible)
					{
						var pId = Mgr.player.mainPlayer.sid.toGID();
						var data = items[i].data;
						if(data && pId == data.memberId.toGID())
						{
							this.isTeamMaster = true;
							return this.isTeamMaster;
						}
					}
				}
			}
			this.isTeamMaster = false;
			return this.isTeamMaster;
		},
		//邀请好友同意加入接口
		AgreementInterface:function(data,isYaoqingPlayer,type)
		{
			var msg =
			{
				teamid: data.teamId , // 队伍Id（id为0表示快速加入）
				zoneModelId: data.zoneModel , // 副本模版
				passWord: null , // 队伍密码
			}
			if ( type == EnumZoneType.TYPE_LFDR )
			{
				var readyNum = 1;// this.isAutoReady ? 1 : 0;
				Mgr.zoneteam.SendReqZoneTeamJoinClientToGameMessage( data.teamId , readyNum );
			}
			else if ( type == EnumZoneType.TYPE_KFDR )
			{
				Mgr.crossteam.SendReqJoinCrossTeamClientToGameMessage( msg , isYaoqingPlayer );
			}
		}
});












