var ChouJiangMainExt = ChouJiangMain.extend ( {
	_className:"ChouJiangMainExt",
	ctor:function(){
		this._super();
	},

	Init:function () {
		var self = this;
		ChouJiangMain.prototype.Init.call(this);
        this.grid_selected.setPosition(this.grid1.x - 5, this.grid1.y - 5);
		this.btn1.addClickEventListener(function (target) {
            if(target.count > 0){
                Mgr.luckydraw.type = EnumLucky.RECHARGEOPENDRAW;
                Mgr.luckydraw.num = target.count;
                Mgr.luckydraw.SendReqLuckyDrawPerformClientToGameMessage(EnumLucky.RECHARGEOPENDRAW, target.count);
            }else {
                Mgr.tips.ShowNotice("你的抽奖次数不足");
            }
        });
        this.imgNum.visible = false;
        this.labCue.SetHtmlText("充值满 200 元宝，即可获得一次抽奖机会！");

        this.sbtnGouxuan.setTouchEnabled(true);
        this.sbtnGouxuan.addClickEventListener(function (target) {
			var state = target.GetState();
			if(state == "check"){
                self.btn1.count = Math.min(100,target.allCount);
			}else {
				self.btn1.count = 1;
			}
        });
        this.btn1.count = 1;

        Mgr.luckydraw.SendReqLuckyDrawInfoClientToGameMessage(EnumLucky.RECHARGEOPENDRAW);
    },

	RefreshPanel:function (info) {
        if(info.luckyDrawNums > 0){
            //this.btn1.count = 1;
            this.sbtnGouxuan.allCount = info.luckyDrawNums;
        }else {
            this.btn1.count = 0;
        }

        this.labCue1.SetText(TextUtil.FormatStr(this.labCue1.GetHtmlText(), [info.luckyDrawNums]));
    },

	SetActivityList:function (infoList, isOpen) {
		this.activityList = infoList;

		this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        var arr = this.GetRewardsConfig();
        for(var i = 0; i < arr.length; i++){
            var v = arr[i];
            var item = ItemUtil.ItemIdToItem(v.mod, v.num);
            GridUtil.SetItemGrid(this["grid" + (i + 1)], item);
        }
    },

    GetRewardsConfig:function(){
        if(!this._rewards){
            var arr = [];
            var awards = Q_lucky_draw.GetList();
            for(var i = 0, len = awards.length; i < len; i++){
                var award = awards[i];
                if(award.q_type == 4){
                    var data = JSON.parse(award.q_item_set);
                    arr.push(data[0]);
                }
            }
            this._rewards = arr;
        }

        return this._rewards;
    },

    //物品入背包动画
    DoEffectAction:function (items) {
        var index = 0;
        var rewards = this.GetRewardsConfig();
        if(items.length == 1){
            for(var i = 0, len = rewards.length; i < len; i++){
                var v = rewards[i];
                if(v.mod == items[0].mod && v.num == items[0].num){
                    index = i + 1;
                    break;
                }
            }
        }
        /// 单个奖励跑圈圈动画
        if(index && !this._running){
            this._running = true;
            this.btn1.setTouchEnabled(false);

            this._index = this._index || 1;

            var step = rewards.length * 4 + index - this._index;

            /// 整个简单点的
            var before = [0,0.4,0.3,,0.2,0.1];
            var interval = 0.03;
            var after = [1,0.8,0.6,0.5,0.4,0.3,0.2,0.1];

            var i = 1;
            var j =  this._index;
            this._index = index;
            var doAction = function (){
                if(!sys.isObjectValid(this)) return;

                var dt = 0;
                if(i < before.length) dt = before[i];
                if(i > step - after.length) dt = after[step - i];
                dt = dt || interval;

                var cur = (j + i - 1) % rewards.length + 1;
                var pos = this["grid" + cur].getPosition();
                this.grid_selected.setPosition(pos.x - 5, pos.y - 5);

                i++;
                if(i <= step){
                    TimerUtil.SetTimeout(this,doAction,dt * 1000);
                }else{
                    this._running = false;
                    this.btn1.setTouchEnabled(true);
                    var panel=EngineMgr.uiMgr.ShowPanelByType(IncomePanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
                    panel.ShowEffect();
                    // Mgr.backpack.AddNewItemFlyTobackpack({
                    //     itemModelId:items[0].mod,
                    //     num:items[0].num,
                    //     isbind:items[0].isbind,
                    // })
                }
            }
            doAction.call(this);

            // 隐藏
            EngineMgr.uiMgr.HidePanelByType(IncomePanelExt.PanelName);
        }else{
            //var panel = EngineMgr.uiMgr.ShowPanelByType(AwardZhanshiExt.PanelName,UIMgr.PANEL_LAYER_POP);
            //panel.UpdateWithItemDisplay({
            //    type:0,
            //    title:"幸运抽奖",
            //    content:"恭喜了抽中了大奖",
            //    items:items,
            //});

            // TIP 更换为寻宝界面
            var panel=EngineMgr.uiMgr.ShowPanelByType(IncomePanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
            panel.ShowEffect();
        }
    },
    OnHide:function () {
        
    }
} );
ChouJiangMainExt.PanelName = "ChouJiangMainExt";
PanelClassDic["ChouJiangMainExt"] = ChouJiangMainExt;
