var TuangouMainExt = TuangouMain.extend ( {
	_className:"TuangouMainExt",
    buttonList:null,
    cellList:null,
    cellPanel:null,
    totalNum:null,
	ctor:function(){
		this._super();
	},

    Init:function () {
        TuangouMain.prototype.Init.call(this);
        var panel = Mgr.uiMgr.GetPanelByType(ActivitiesBackGroundExt.PanelName);
        this.buttonList = [];
        this.parentPanel = panel;
        this.sbtnCue.visible = false;

        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.uiWidth=this.imgBg1.uiWidth;
            tableView.uiHeight=this.imgBg1.uiHeight;
            this.cellPanel=tableView;
            this.imgBg1.addChild(tableView);
        }
    },

    SetActivityList:function (infoList, isOpen) {
        this.activityList = infoList;

        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){

        this.UpdateButton();
        if( isOpen ){
            var last = this.buttonList.length - 1;
            this.buttonList[last].SetButtonState( MUICheckBox.STATE_CHECK, true );
            this.UpdateCell(this.buttonList[last].data);
        }
    },

    UpdateSingleActivity:function (info) {
        this.cellPanel.reloadData();
    },

    UpdateButton:function(){
        var self = this;
        var hash = ActivityUtil.GetTabHashByKey( this.activityList, "thirdPanelKey" );
        var keys = hash.Keys();
        for(var i = 0, len = keys.length; i < len; i++){
            var key = keys[i];
            var group = hash.Get(key);
            var button = new MUICheckBox();
            button.data = group;
            button.ParseJson(this.sbtnCue.jsonobj);
            button.Init();
            button.setTouchEnabled(true);
            button.SetText(group[0].thirdPanelName);
            button.SetButtonState(MUICheckBox.STATE_UNCHECK);
            button._group = 999;
            button.addClickEventListener(function (target) {
                self.UpdateCell(target.data);
            });
            button.x = this.sbtnCue.x + this.sbtnCue.uiWidth * i;
            button.y = this.sbtnCue.y;
            this.addChild(button);
            this.buttonList.push(button);
        }
    },

    UpdateCell:function (infoList) {
        this.cellList = ActivityUtil.GetListByCorrelation(infoList);
        this.totalNum = this.cellList.length;
        this.cellPanel.reloadData();
    },

    OnHide:function () {

    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(805,150);
    },
    tableCellAtIndex: function (table, idx) {
        var item;
        var ac = this.cellList[idx];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            item = new TuanGouListExt();
            item.LoadPanel();
            item.SetData(ac);
            item.setTouchEnabled(false);
            cell.item = item;
            item.x = -4;
            cell.addChild(item);
        }
        cell.item.SetData(ac);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    },
    OnHide:function(){

    }
} );
TuangouMainExt.PanelName = "TuangouMainExt";
PanelClassDic["TuangouMainExt"] = TuangouMainExt;
