var LianXuChongZhiListExt = LianXuChongZhiList.extend ( {
	_className:"LianXuChongZhiListExt",
	ctor:function(){
		this._super();
	},

	Init:function () {
		var self = this;
		LianXuChongZhiList.prototype.Init.call(this);
		this.grid1.visible = false;
		this.btn1.addClickEventListener(function (target) {
			if(self.detail.status == 2){
				OpenFuncUtil.OpenRecharge();
			}
			else if( self.detail.gold ){
				if(self.detail.status == 0){
					Mgr.dailyactivity.SendReqGradeTebateGetRewardToGameMessage(self.detail.activityId, self.detail.gold);
				}
			}
			else if(self.detail.status == 1){
				Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.detail.activityId, 1);
			}
		});
		this.btn1.setSwallowTouches(false);
	},

	SetData:function (info) {
		this.detail = info;			//只有通过gold来区分单笔充值  正常活动数据结构没有gold字段
		this.lab1.SetHtmlText( info.gold ? info.info : info.introduction);
		this.SetRewards();
		this.SetButtonStatus( (info.gold && info.status != 2) ? info.status^1 : info.status);
		this.SetProgress();
	},

	SetRewards:function(){
		this.ClearGrid();
		var awards = this.detail.gold ? ItemUtil.GetItemRewards(JSON.parse(this.detail.reward)) : this.detail.GetRewardList();
		for(var i = 0, len = awards.length; i < len; i++){
			var grid = new MUIGrid();
			grid.ParseJson(this.grid1.jsonobj);
			grid.Init();
			grid.x = this.grid1.x + (this.grid1.uiWidth + 2) * i;
			grid.setSwallowTouches(false);
			GridUtil.SetItemGrid(grid, awards[i]);
			this.addChild(grid);
			this.awardList.push(grid);
		}
	},

	ClearGrid:function(){
		if(this.awardList && this.awardList.length > 0){
			for(var i = 0; i < this.awardList.length; i++){
				this.awardList[i].removeFromParent();
			}
		}
		this.awardList = [];
	},

	SetButtonStatus:function (status) {
		this.imgLingQu.visible = false;
		this.btn1.visible = true;
		switch (status){
			case 0:
				this.imgLingQu.visible = true;
				this.btn1.visible = false;
				break;
			case 1:
				this.btn1.setTitleText("领奖");
				break;
			case 2:
				this.btn1.setTitleText("前往充值");
				break;
		}
	},

	SetProgress:function(){
		if( this.detail.gold ){
			this.labTime.visible = false;
			return;
		}
		this.labTime.SetTextAlign(LableAlign.CENTER);
		var str = "";
		var special = this.detail.special[0];
		switch(special.type){
			case EnumSpecialType.RECHARGE:
				str = "进度：" + special.beanInfo.gold + "/" + special.beanInfo.need;
				break;
			case EnumSpecialType.SERIES_RECHARGE:
				str = "连续天数：" + special.beanInfo.day + "/" + special.beanInfo.needDay;
				break;
		}
		this.labTime.SetText(str);
	}
} );
LianXuChongZhiListExt.PanelName = "LianXuChongZhiListExt";
PanelClassDic["LianXuChongZhiListExt"] = LianXuChongZhiListExt;
