var HuanhuaMainExt = HuanhuaMain.extend ( {
	_className:"HuanhuaMainExt",

    model:null,
	id:null,
	mianNeedNum:null,
	mainItemList:null,
    minorNeedNum:null,
	minorItemList:null,


	ctor:function(){
		this._super();
	},

    Init:function (){
        HuanhuaMain.prototype.Init.call( this );

        var self = this;
        this.btnRonglian.addClickEventListener(function(){
        	if(self.mianNeedNum <= self.mainItemList.length && self.minorNeedNum <= self.minorItemList.length){
        		var list = [];
        		list.push(self.mainItemList[0].itemId);
                list.push(self.minorItemList[0].itemId);
                Mgr.refining.SendReqComposeGodEquipMessage(0, self.id, 1, list);
			}
			else{
                Mgr.tips.ShowNotice("材料不足");
			}
		});
    },

	SetData:function(info){
		if(info){
            this.labAttack.SetText(info.attack);
            this.labDef.SetText(info.defense);
            this.labHp.SetText(info.hp);
            this.labJianmian.SetText(info.spAttriStr);
            this.labJianmian_Value1.SetText(info.spAttriNum);
            this.ShowModel(info.modelId);
            this.InitGrid(info.needItemId);
		}
	},

	InitGrid:function(needItemId){
		this.id = needItemId;
		cc.log("----- " + needItemId)
		var info = Q_item_forge.Get(needItemId);
        var gridInfo = Q_item.Get(needItemId);
        var coinInfo = {};
        coinInfo.itemModelId = needItemId;
        coinInfo.itemNum = 1;
        coinInfo.itemBind = gridInfo.q_bind;
        GridUtil.SetItemGrid(this.gridItem111, coinInfo);
        this.labName.SetText(gridInfo.q_name);

        var mainInfo = Q_item.Get(parseInt(info.q_material_main));
        coinInfo = {};
        coinInfo.itemModelId = info.q_material_main;
        coinInfo.itemNum = info.q_material_main_num;
        coinInfo.itemBind = mainInfo.q_bind;
        GridUtil.SetItemGrid(this.gridItem, coinInfo);
        this.mianNeedNum = info.q_material_main_num;
        this.mainItemList = Mgr.backpack.GetItemsByMid(info.q_material_main);
        this.labName1.SetText(mainInfo.q_name + this.mainItemList.length + "/" + info.q_material_main_num);


        var minorInfo = Q_item.Get(parseInt(info.q_material_minor_one));
        coinInfo = {};
        coinInfo.itemModelId = info.q_material_minor_one;
        coinInfo.itemNum = info.q_material_minor_one_num;
        coinInfo.itemBind = minorInfo.q_bind;
        GridUtil.SetItemGrid(this.gridItem1, coinInfo);
        this.minorNeedNum = info.q_material_minor_one_num;
        this.minorItemList = Mgr.backpack.GetItemsByMid(info.q_material_minor_one);
        this.labName2.SetText(minorInfo.q_name + this.minorItemList.length + "/" + info.q_material_minor_one_num);
	},

    ShowModel:function(showId){
        if(!this.model){
            var model = new MAnimationObject();
            this.imgModel.addChild(model);
            model.x = this.imgModel.uiWidth/2 - 30;
            this.model = model;
        }
        this.model.sCurActionName = null;
        this.model.sResUrlBase = "res/animation/parts/pifeng/" + (Mgr.mainPlayer.nJobId*1000 + showId);
        this.model.DoAction("stand", 4);
    },

} );
HuanhuaMainExt.PanelName = "HuanhuaMainExt";
PanelClassDic["HuanhuaMainExt"] = HuanhuaMainExt;
