var BianqiangMainExt = BianqiangMain.extend ( {
	_className:"BianqiangMainExt",

	_listView:null,
	_buttons:null,

	ctor:function(){
		this._super();
        this.layoutCom.layoutType = MLLAYOUT_RB;
        this.layoutCom.layoutOffy = 200;
        this.layoutCom.layoutOffx = -318;
		this._buttons = {};
		this.setLocalZOrder(-1);
	},

	Init:function() {
		var self = this;
		BianqiangMain.prototype.Init.call(this);

		this.InitParam();

		this.btnClose.addClickEventListener(function (event) {
			Mgr.uiMgr.HidePanel(self);
		});
	},

	InitParam:function () {
		this.btnCue.visible = false;
		this._CreateListView();
	},

	_CreateListView:function () {
		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg.width, this.imgBg.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.setItemsMargin(2);
		//list.setAnchorPoint(0, 0);
		//list.setPosition(0,0);
		//list.addEventListener(this._SelectedItemEvent);
		this.imgBg.addChild(list);
		this._listView = list;
	},

	OnShow:function () {
		this.LoadList();
	},

	LoadList:function () {
		this._listView.removeAllItems();
		var types = Mgr.strong.GetTypes();
		for ( var i = 0; i != types.length; i++ ) {
			this.Contain(types[i]);
		}
	},

	Contain:function (type) {
		var button = this._buttons[type];
		if ( !button ) {
			button = new MUIButton();
			button.ParseJson(this.btnCue.jsonobj);
			button.Init();
			button.retain();
			button.type = type;
			button.setTitleText( this.GetNameByType(type) );
			button.addClickEventListener(this._CallBackFunc);
			this._buttons[type] = button;
		}
		if ( !button.getParent() ){
			//按钮被移除的时候 没有回到原来状态  这儿新加的时候先让他到初始状态
            // var action = cc.tintTo(0.05, 255,255,255);
            // button.runAction(action);
            button.setColor(cc.color(255,255,255))
            this._listView.pushBackCustomItem(button);
		}
	},

	Except:function (type) {
		var button = this._buttons[type];
		var items = this._listView.getItems();
		var index = items.indexOf(button);
		if(index > -1)
			this._listView.removeChild(button);

	},

	_CallBackFunc:function (event) {
        Mgr.strong.Except(event.type);
		switch( event.type ){
			case ElseStrongEnum.ELSE_BAOQI:
				Mgr.uiMgr.ShowPanelByType(ShuTongPanelExt.PanelName).ChangePanel(EnumResline.BAOQI);
				break;
			case ElseStrongEnum.ELSE_CHENGHAO:
				EngineMgr.uiMgr.ShowPanelByType(ChengHaoPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
				break;
			case ElseStrongEnum.ELSE_COMPOSE:
				//Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_COMPOSE);
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_COMPOSE_NEW);
				break;
			case ElseStrongEnum.ELSE_GUANGWU:
				Mgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName).ChangePage(EnumResline.GUANGWU);
				break;
			case ElseStrongEnum.ELSE_GUILDSKILL:
				Mgr.uiMgr.ShowPanelByType(GuildPanelExt.PanelName).ChangePanel(GuildEnum.PANEL_SKILL);
				break;
			case ElseStrongEnum.ELSE_INLAY:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_INLAY);
				break;
			case ElseStrongEnum.ELSE_MELTING:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_MELTING);
				break;
			case ElseStrongEnum.ELSE_REFINE:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_REFINE);
				break;
			case ElseStrongEnum.ELSE_RIDE:
				Mgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName).ChangePage(EnumResline.HORSE);
				break;
			case ElseStrongEnum.ELSE_SHIZHUANG:
                Mgr.fasion.SendReqFashionPanelMessage();
				break;
			case ElseStrongEnum.ELSE_SHUTONG:
				Mgr.uiMgr.ShowPanelByType(ShuTongPanelExt.PanelName).ChangePanel(EnumResline.SHUTONG);
				break;
			case ElseStrongEnum.ELSE_SKILL:
				Mgr.uiMgr.ShowPanelByType(SkillPanelExt.PanelName).ChangePanel(SkillPanelType.PANEL_STATIC );;
				break;
			case ElseStrongEnum.ELSE_SUIT:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_SUIT);
				break;
			case ElseStrongEnum.ELSE_TAIJI:
				EngineMgr.uiMgr.ShowPanelByType(TaijiPanelExt.PanelName);
				Mgr.gossip.taijiPanel.ShowType(EnumGrossipType.TYPE_DAY);
				break;
			case ElseStrongEnum.ELSE_TOUXIAN:
				EngineMgr.uiMgr.ShowPanelByType(TouXianPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
				break;
			case ElseStrongEnum.ELSE_TUJIAN:
				EngineMgr.uiMgr.ShowPanelByType( TujianPanelExt.PanelName );
				break;
			case ElseStrongEnum.ELSE_UP:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_UP);
				break;
			case ElseStrongEnum.ELSE_DRAGON:
				Mgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName).ChangePage(EnumResline.DRAGON);
				break;
			case ElseStrongEnum.ELSE_YIRONG:
				EngineMgr.uiMgr.ShowPanelByType(YiRongPanelExt.PanelName);
				break;
			case ElseStrongEnum.ELSE_ZHANJIA:
				EngineMgr.uiMgr.ShowHidePanelByType( PlayerPanelExt.PanelName );
				var panel = Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName);
				if(panel)
				{
					panel.ChangePage(0);
				}
				break;
			case ElseStrongEnum.ELSE_WUXUE:
				Mgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName).ChangePage(EnumResline.WUXUE);
				break;
			case ElseStrongEnum.ELSE_SHENBING:
				Mgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName).ChangePage(-2);
				break;
			case ElseStrongEnum.ELSE_JIANLING:
				Mgr.uiMgr.ShowPanelByType(ShuTongPanelExt.PanelName).ChangePanel(EnumResline.JIANLING);
				break;
			case ElseStrongEnum.ELSE_JIANZAHO:
				Mgr.uiMgr.ShowPanelByType(ShuTongPanelExt.PanelName).ChangePanel(EnumResline.ZHAOSHI);
				break;
			case ElseStrongEnum.ELSE_STEP:
				Mgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName).ChangePanel(EnumResline.STEP);
				break;
			default:
				break;
		}
		Mgr.uiMgr.HidePanelByType(BianqiangMainExt.PanelName);
	},

	GetNameByType:function (type) {
		var name = "未知名称"
		if ( type == ElseStrongEnum.ELSE_BAOQI )
			name = "宝骑进阶"
		else if ( type == ElseStrongEnum.ELSE_CHENGHAO )
			name = "角色称号"
		else if ( type == ElseStrongEnum.ELSE_COMPOSE )
			name = "宝石合成"
		else if ( type == ElseStrongEnum.ELSE_GUANGWU )
			name = "光武进阶"
		else if ( type == ElseStrongEnum.ELSE_GUILDSKILL )
			name = "帮会技能"
		else if ( type == ElseStrongEnum.ELSE_INLAY )
			name = "宝石镶嵌"
		else if ( type == ElseStrongEnum.ELSE_MELTING )
			name = "装备熔炼"
		else if ( type == ElseStrongEnum.ELSE_REFINE )
			name = "装备精炼"
		else if ( type == ElseStrongEnum.ELSE_RIDE )
			name = "坐骑进阶"
		else if ( type == ElseStrongEnum.ELSE_SHIZHUANG )
			name = "角色时装"
		else if ( type == ElseStrongEnum.ELSE_SHUTONG )
			name = "书童进阶"
		else if ( type == ElseStrongEnum.ELSE_SKILL )
			name = "被动技能"
		else if ( type == ElseStrongEnum.ELSE_SUIT )
			name = "套装打造"
		else if ( type == ElseStrongEnum.ELSE_TAIJI )
			name = "VIP升级"
		else if ( type == ElseStrongEnum.ELSE_TOUXIAN )
			name = "角色头衔"
		else if ( type == ElseStrongEnum.ELSE_TUJIAN )
			name = "怪物图鉴"
		else if ( type == ElseStrongEnum.ELSE_UP )
			name = "装备强化"
		else if ( type == ElseStrongEnum.ELSE_DRAGON )
			name = "法器进阶"
		else if ( type == ElseStrongEnum.ELSE_YIRONG )
			name = "角色易容"
		else if ( type == ElseStrongEnum.ELSE_ZHANJIA )
			name = "光羽淬炼"
		else if ( type == ElseStrongEnum.ELSE_WUXUE )
			name = "武学进阶"
        else if ( type == ElseStrongEnum.ELSE_SHENBING )
			name = "神兵锤炼"
        else if ( type == ElseStrongEnum.ELSE_JIANLING )
			name = "剑灵进阶"

		return name;
	},
} );
BianqiangMainExt.PanelName = "BianqiangMainExt";
PanelClassDic["BianqiangMainExt"] = BianqiangMainExt;

var StrongModMgr = StrongModMgr || cc.Class.extend({

		_typeList:null,
		_openTypeList:null,   // 自动弹出类型

		ctor:function () {
			this._typeList = [];
			this._viewList = [];
			this._markCache = {};
			this._openTypeList = [ElseStrongEnum.ELSE_RIDE, ElseStrongEnum.ELSE_GUANGWU, ElseStrongEnum.ELSE_SHUTONG,
				ElseStrongEnum.ELSE_BAOQI, ElseStrongEnum.ELSE_DRAGON, ElseStrongEnum.ELSE_UP];
		},

		OnPanelShown:function(panelName){

		},
		OnPanelHided:function(panelName){
			var type_list = [];
			switch( panelName){
				case ShuTongPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_BAOQI);
					type_list.push(ElseStrongEnum.ELSE_SHUTONG);
					type_list.push(ElseStrongEnum.ELSE_JIANZAHO);
					type_list.push(ElseStrongEnum.ELSE_JIANLING);
					break;
				case ChengHaoPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_CHENGHAO);
					break;
				case DuanzaoPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_COMPOSE);
					type_list.push(ElseStrongEnum.ELSE_INLAY);
					type_list.push(ElseStrongEnum.ELSE_MELTING);
					type_list.push(ElseStrongEnum.ELSE_REFINE);
					type_list.push(ElseStrongEnum.ELSE_SUIT);
					type_list.push(ElseStrongEnum.ELSE_UP);
					break;
				case PlayerPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_GUANGWU);
					type_list.push(ElseStrongEnum.ELSE_RIDE);
					type_list.push(ElseStrongEnum.ELSE_DRAGON);
					type_list.push(ElseStrongEnum.ELSE_ZHANJIA);
					type_list.push(ElseStrongEnum.ELSE_WUXUE);
					type_list.push(ElseStrongEnum.ELSE_SHENBING);
					type_list.push(ElseStrongEnum.ELSE_STEP);
					break;
				case GuildPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_GUILDSKILL);
					break;
				case SkillPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_SKILL);
					break;
				case TaijiPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_TAIJI);
					break;
				case TouXianPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_TOUXIAN);
					break;
				case TujianPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_TUJIAN);
					break;
				case YiRongPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_YIRONG);
					break;
				case ShizhuangPanelExt.PanelName:
					type_list.push(ElseStrongEnum.ELSE_SHIZHUANG);
					break;
			}
			for(var i = 0;i != type_list.length; ++i){
				this.HideMarkView(type_list[i]);
			}
		},

		Contain:function (type) {

		},
		Con__tain:function (type,v) {
			// 判断是否开启
			if ( this.CheckFuncOpen(type) ) {
                var initMark = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).GetInitMark();
                if(initMark == false){
                	this.UpdateMarkViewState(type,true,v);
                }else{
					this.UpdateMarkViewState(type,true,v,true);
                }

				if (!this.IsIner(type)) {
					this._typeList.push(type);
					this.SortButtons();

					// 初始登录标记
//					if (initMark == false ) {
//						//新功能开启展示出来的不弹出
//						if( Mgr.uiMgr.IsPanelShowByName(NewFuncCueExt.PanelName)
//							|| Mgr.uiMgr.IsPanelShowByName(NewFuncCue1Ext.PanelName))
//							return;
//						// 指定自动弹出面板类型
//						this.CheckOpenTypes(type);
//					}
				}
			}
			this.UpdataWarn();
		},

		Except:function (type) {

		},
		Exc__ept:function (type,v) {
            this.UpdateMarkViewState(type,false,v);

			var index = this._typeList.indexOf(type);
			if(index > -1) {
				this._typeList.splice(index, 1);
				this.SortButtons();
			}
            this.UpdataWarn();
		},

		UpdataWarn:function(){
			var panel = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName);
			if(panel){
				if(this._typeList.length > 0)
					panel.UpdataBianQianWarn(true);
				else
					panel.UpdataBianQianWarn(false);
			}
		},

		SortButtons:function () {
			// 快捷图标是否显示
			var _visible = this._typeList.length > 0;
            let p = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName)
            if(p) p.ShowAndHideStrong(_visible);
			// 面板更新
			var panel = Mgr.uiMgr.GetPanelByType(BianqiangMainExt.PanelName);
			if ( panel && panel.visible ) {
				panel.LoadList();
			}
			if( !_visible )
				Mgr.uiMgr.HidePanelByType(BianqiangMainExt.PanelName);
		},

		IsIner:function (type) {
			var len = this._typeList.length;
			for ( var i = 0; i != len; i++ ) {
				var _type = this._typeList[i];
				if ( _type == type )
					return true;
			}
			return false;
		},

		CheckFuncOpen:function (type) {
			var main, sub;
			switch( type ) {
				case ElseStrongEnum.ELSE_BAOQI:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_BAOQI;
					break;
				case ElseStrongEnum.ELSE_CHENGHAO:
					main = BtnGroupUtil.M_ROLE;
					sub = BtnGroupUtil.ROLE_TITLE;
					break;
				case ElseStrongEnum.ELSE_COMPOSE:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_COMPOSE;
					break;
				case ElseStrongEnum.ELSE_GUANGWU:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_GUANGWU;
					break;
				case ElseStrongEnum.ELSE_GUILDSKILL:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_GUILD;
					break;
				case ElseStrongEnum.ELSE_INLAY:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_INLAY;
					break;
				case ElseStrongEnum.ELSE_MELTING:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_MELT;
					break;
				case ElseStrongEnum.ELSE_REFINE:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_REFINE;
					break;
				case ElseStrongEnum.ELSE_RIDE:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_HOURSE;
					break;
				case ElseStrongEnum.ELSE_SHIZHUANG:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_FASHION;
					break;
				case ElseStrongEnum.ELSE_SHUTONG:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_SHUTONG;
					break;
				case ElseStrongEnum.ELSE_SKILL:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_SKILL;
					break;
				case ElseStrongEnum.ELSE_SUIT:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_SUIT;
					break;
				case ElseStrongEnum.ELSE_TAIJI:
					main = BtnGroupUtil.M_TAIJI;
					sub = BtnGroupUtil.TAIJI_TAIJI;
					break;
				case ElseStrongEnum.ELSE_TOUXIAN:
					main = BtnGroupUtil.M_ROLE;
					sub = BtnGroupUtil.ROLE_HONOR;
					break;
				case ElseStrongEnum.ELSE_TUJIAN:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_POKEDEX;
					break;
				case ElseStrongEnum.ELSE_UP:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_UP;
					break;
				case ElseStrongEnum.ELSE_DRAGON:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_FAQI;
					break;
				case ElseStrongEnum.ELSE_YIRONG:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_DISGUISE;
					break;
				case ElseStrongEnum.ELSE_ZHANJIA:
					main = BtnGroupUtil.M_ROLE;
					sub = BtnGroupUtil.ROLE_ARMOR;
					break;
				case ElseStrongEnum.ELSE_WUXUE:
					main = BtnGroupUtil.M_ROLE;
					sub = BtnGroupUtil.ROLE_WUXUE;
					break;
				case ElseStrongEnum.ELSE_SHENBING:
					main = BtnGroupUtil.M_ROLE;
					sub = BtnGroupUtil.ROLE_SHNEBING;
					break;
				case ElseStrongEnum.ELSE_JIANLING:
					main = BtnGroupUtil.M_SHUTONG;
					sub = BtnGroupUtil.SHUTONG_JIANLING;
					break;
				default:
					break;
			}
			if (BtnGroupUtil.IsFunctionOpen(main, sub)) {
				return true;
			}
			return false;
		},

		GetTypes:function () {
			return this._typeList;
		},

		CheckOpenTypes:function(type){
			var list = this._openTypeList;
			for (var i = 0; i != list.length; i++) {
				if (type == list[i]) {
					var panel = Mgr.uiMgr.ShowPanelByType(BianqiangMainExt.PanelName);
					var winSize = cc.director.getWinSize();
					panel.x = winSize.width - panel.width * 2.5;
					panel.y = 200;
					break;
				}
			}
		},

        CheckMarkView:function(){
            return true;
        },

        GetTypeIcon:function(type){
			var url
			switch(type){
				case ElseStrongEnum.ELSE_ZHANJIA:
					url = "other/xingongnengkaiqi/image/tubiao/guangyi.png";
					break;
				case ElseStrongEnum.ELSE_SKILL:
					url = "other/xingongnengkaiqi/image/tubiao/jinengjinjie.png";
					break;
				case ElseStrongEnum.ELSE_UP:
					url = "other/xingongnengkaiqi/image/tubiao/qianghua.png";
					break;
				case ElseStrongEnum.ELSE_INLAY:
					url = "other/xingongnengkaiqi/image/tubiao/xiangqian.png";
					break;
				case ElseStrongEnum.ELSE_COMPOSE:
					url = "other/xingongnengkaiqi/image/tubiao/hecheng.png";
					break;
				case ElseStrongEnum.ELSE_MELTING:
					url = "other/xingongnengkaiqi/image/tubiao/ronglian.png";
					break;
				case ElseStrongEnum.ELSE_REFINE:
					url = "other/xingongnengkaiqi/image/tubiao/jinglian.png";
					break;
				case ElseStrongEnum.ELSE_SUIT:
					url = "other/xingongnengkaiqi/image/tubiao/taozhuang.png";
					break;
				case ElseStrongEnum.ELSE_GUILDSKILL:
					url = "other/xingongnengkaiqi/image/tubiao/banghui.png";
					break;
				case ElseStrongEnum.ELSE_TUJIAN:
					url = "other/xingongnengkaiqi/image/tubiao/tujian.png";
					break;
				case ElseStrongEnum.ELSE_TOUXIAN:
					url = "other/xingongnengkaiqi/image/tubiao/touxian.png";
					break;
				case ElseStrongEnum.ELSE_CHENGHAO:
					url = "other/xingongnengkaiqi/image/tubiao/chenghao.png";
					break;
				case ElseStrongEnum.ELSE_TAIJI:
					url = "other/zhujiemian/huodongicon/vip_btn.png";
					break;
				case ElseStrongEnum.ELSE_YIRONG:
					url = "other/xingongnengkaiqi/image/tubiao/yirong.png";
					break;
				case ElseStrongEnum.ELSE_SHIZHUANG:
					url = "other/xingongnengkaiqi/image/tubiao/shizhuang.png";
					break;
				case ElseStrongEnum.ELSE_RIDE:
					url = "other/xingongnengkaiqi/image/tubiao/zuoqi.png";
					break;
				case ElseStrongEnum.ELSE_DRAGON:
					url = "other/xingongnengkaiqi/image/tubiao/faqi.png";
					break;
				case ElseStrongEnum.ELSE_GUANGWU:
					url = "other/xingongnengkaiqi/image/tubiao/guangwu.png";
					break;
				case ElseStrongEnum.ELSE_SHUTONG:
					url = "other/xingongnengkaiqi/image/tubiao/shutong.png";
					break;
				case ElseStrongEnum.ELSE_BAOQI:
					url = "other/xingongnengkaiqi/image/tubiao/baoqi.png";
					break;
				case ElseStrongEnum.ELSE_WUXUE:
					url = "other/xingongnengkaiqi/image/tubiao/wuxue.png";
					break;
				case ElseStrongEnum.ELSE_SHENBING:
					url = "other/xingongnengkaiqi/image/tubiao/shenbing.png";
					break;
				case ElseStrongEnum.ELSE_JIANLING:
					url = "other/xingongnengkaiqi/image/tubiao/jianling.png";
					break;
				case ElseStrongEnum.ELSE_STEP:
					url = "other/xingongnengkaiqi/image/tubiao/jiaoyin.png";
					break;
			}
			return url;
        },

		HideMarkView:function(type){
			// 已经显示
			if(Mgr.uiMgr.IsPanelShowByName(BecomeStrongerMarkExt.PanelName)){
				var p = Mgr.uiMgr.GetPanelByType(BecomeStrongerMarkExt.PanelName);
				var data = p.GetUserDate();
				if(data.type == type){
					Mgr.uiMgr.HidePanelByType(BecomeStrongerMarkExt.PanelName);
					return;
				}
			}
			// 加入了列表
			for(var i=0;i!=this._viewList.length;++i){
				var v = this._viewList[i];
				if(v.type == type){
					this._viewList.splice(i,1);
					return;
				}
			}
		},

		ClearAll:function(){
			this._typeList.length = 0;
			this._viewList.length = 0;
			this._markCache = {};
			Mgr.uiMgr.HidePanelByType(BecomeStrongerMarkExt.PanelName);
			this.SortButtons();
			this.UpdataWarn();
		},

        UpdateMarkViewState:function(type,show,conf,init){
            if(this._markCache[type] == show) return;
            this._markCache[type] = show;

            if(init) return;

            // 已经显示
            if(Mgr.uiMgr.IsPanelShowByName(BecomeStrongerMarkExt.PanelName)){
                var p = Mgr.uiMgr.GetPanelByType(BecomeStrongerMarkExt.PanelName);
                var data = p.GetUserDate();
                if(data.type == type){
                    if(!show){
                        Mgr.uiMgr.HidePanelByType(BecomeStrongerMarkExt.PanelName);
                    }
                    return;
                }
            }

            // 加入了列表
            for(var i=0;i!=this._viewList.length;++i){
                var v = this._viewList[i];
                if(v.type == v){
                    if(!show){
                        this._viewList.splice(i,1);
                    }
                    return;
                }
            }

            // 隐藏返回
            if(!show) return;

			var resLine = 0;
			switch(type){
				case ElseStrongEnum.ELSE_RIDE:
					resLine = EnumResline.HORSE;
					break;
				case ElseStrongEnum.ELSE_DRAGON:
					resLine = EnumResline.DRAGON;
					break;
				case ElseStrongEnum.ELSE_GUANGWU:
					resLine = EnumResline.GUANGWU;
					break;
				case ElseStrongEnum.ELSE_SHUTONG:
					resLine = EnumResline.SHUTONG;
					break;
				case ElseStrongEnum.ELSE_BAOQI:
					resLine = EnumResline.BAOQI;
					break;
				case ElseStrongEnum.ELSE_WUXUE:
					resLine = EnumResline.WUXUE;
					break;
				case ElseStrongEnum.ELSE_STEP:
					resLine = EnumResline.STEP;
					break;
			}
			if( resLine ){
				var mgr = Mgr.resline.GetMgrByType( resLine );
				var showkey = resLine + "_" + mgr.GetMaxModelId();
				var beltBasicData = Q_resline.Get( showkey );
				showkey = beltBasicData.q_id.toString() + "_" + mgr.GetStars().toString();
				var beltUp = Q_resline_up.Get( showkey );
				if(beltUp.q_reset_time > 0){
					return;
				}
			}

            var title = conf.title;
            var btn_text = conf.btn_text;
            var content = conf.content;
            var callback = function(type){
                BianqiangMainExt.prototype._CallBackFunc({type : type});
            }.bind(this,type);

            var url = this.GetTypeIcon(type);

            EngineMgr.uiMgr.LoadOtherRes("other/xingongnengkaiqi",{
                Callback:function(){},
                ErrCallback:function(){},
            });

            var data = {
                type : type,
                title : title,
                content : content,
                btn_text : btn_text,
                url : url,
                callback : callback,
            }
            this._viewList.push(data);

            this.UpdateMarkView();
        },

        UpdateMarkView:function(){
            if(Mgr.uiMgr.IsPanelShowByName(BecomeStrongerMarkExt.PanelName)) return;

            //cc.log("当前缓存的", this._viewList.length)

            var v
            do{
                v = this._viewList.pop();
                v = this.CheckMarkView(v) ? v : null;
            }while(!v && this._viewList.length);

            if(!v) return;

            //cc.log("当前缓存的 剩余", this._viewList.length)
            var p = Mgr.uiMgr.ShowPanelByType(BecomeStrongerMarkExt.PanelName);
            if(p) p.UpdateView(v);
        },
	});

var ShowTipsBox = ShowTipsBox || cc.Class.extend({
    _tipBoxNameList:null,// 自动弹出提示框类型

    ctor:function () {
        this._tipBoxNameList = [];
    },

    Contain:function(name, callback){
        var info = {panelName:name, callback:callback};
        var index = this._getInfoIndex(info);
        if(index == -1) {
            this._tipBoxNameList.push(info);
        }
        else{
            this._tipBoxNameList[index] = info;
		}
        this.ShowTipBox();
	},

    Except:function (name) {
        var index = this._tipBoxNameList.indexOf(name);
        Mgr.uiMgr.HidePanelByType(name);
        if(index > -1) {
            this._tipBoxNameList.splice(index, 1);
        }
        this.ShowTipBox();
    },

	_getInfoIndex:function(info){
    	for(var i = 0; i<this._tipBoxNameList.length; i++){
    		if(this._tipBoxNameList[i].panelName == info.panelName){
    			return i;
			}
		}
		return -1;
	},

	ShowTipBox:function(){
    	if(this._tipBoxNameList.length > 0){
            var panel = Mgr.uiMgr.ShowPanelByType(this._tipBoxNameList[0].panelName);
            var callback = this._tipBoxNameList[0].callback;
            if(callback)
            	callback(panel);
		}
	}

});

var BecomeStrongerMarkExt = GuildBossMark.extend({
    _className:"BecomeStrongerMarkExt",

    ctor:function(){
        this._super();
        this.layoutCom.layoutType = MLLAYOUT_RB;
        this.layoutCom.layoutOffy = 200;
        this.layoutCom.layoutOffx = -318;
        this.setLocalZOrder(-1);
    },

    Init:function() {
        var self = this;
        GuildBossMark.prototype.Init.call(this);

        this.btnClose.addClickEventListener(function (event) {
            Mgr.uiMgr.HidePanel(self);
        });
        this.btnJoin.addClickEventListener(function (event) {
            Mgr.uiMgr.HidePanel(self);
            if(self.data && self.data.callback) self.data.callback();
        });
    },

    OnShow:function(){
        this._super();
    },
    OnHide:function(){
        this._super();
        if(this._itemGrid){
            this._itemGrid.removeFromParent();
            this._itemGrid = null;
        }

        TimerUtil.SetTimeout(Mgr.strong,Mgr.strong.UpdateMarkView,500);
    },

    GetUserDate:function(){
        return this.data;
    },

    //data{ type,title,content,btn_text,url,equip,callback }
    UpdateView:function(data){
        data = data || {};
        this.data = data;

        this.labName.SetString(data.title || "???");
        this.lab2.SetString(data.content || "???");
        this.btnJoin.setTitleText(data.btn_text || "???");

        this.imgIcon.visible = false;
        if(this._itemGrid) this._itemGrid.removeFromParent();

        if(data.url){
            UIUtil.LoadImage(this.imgIcon,data.url,false,true);
            this.imgIcon.visible = true;
        }

        if(data.equip){
            var itemGrid = GridUtil.SetItemGrid(this._itemGrid,data.equip,null,null,null,null,false);
            itemGrid.setPosition(this.imgIcon.getPosition());
            this.addChild(itemGrid,100);
            this._itemGrid = itemGrid;
        }
    },

});
BecomeStrongerMarkExt.PanelName = "BecomeStrongerMarkExt";
PanelClassDic["BecomeStrongerMarkExt"] = BecomeStrongerMarkExt;