var NewEquipWarnExt = NewEquipWarn.extend ( {
	_className:"NewEquipWarnExt",

	_itemInfo:null,
	_orgPt:null,

	ctor:function(){
		this._super();
        this.layoutCom.layoutType = MLLAYOUT_RB;
        this.layoutCom.layoutOffy = 200;
        this.layoutCom.layoutOffx = -318;
	},

	Init:function() {
		var self = this;
		NewEquipWarn.prototype.Init.call(this);

		this._orgPt = this.gridEquip.getPosition();

		this.btnClose.addClickEventListener(function (event) {
			var newItem = self.GetShowItem();
			if(newItem){
				self.ShowNewEquip(newItem);
			}else {
                EngineMgr.uiMgr.HidePanel(self);
			}
			// var list = Mgr.backpack.newResEquipList;
			// if(list.length > 0){
			// 	var newItem = list.shift();
			// 	cc.log("newItem "  +  JSON.stringify(newItem));
			// 	Mgr.uiMgr.ShowPanelByType(NewEquipWarnExt.PanelName).ShowNewEquip(newItem);
			// }
		});

		this.btnGet.addClickEventListener(function (event) {
			self.WearResEquip();
		});
	},

	GetShowItem:function () {
		var isFind = false;
        var list = Mgr.backpack.newResEquipList;
        while (!isFind && list.length > 0){
            var itemInfo = list.shift();
            var item = Q_item.Get(itemInfo.itemModelId);
            var mgr = Mgr.resline.GetMgrByType(item.q_type);
            var equips = mgr._equips;
            for(var i = 0, len = equips.length; i < len; i++){
                var equip = equips[i];
                if (equip.itemModelId > 0 && item.q_type == Q_item.Get(equip.itemModelId).q_type
                    && Q_item.Get(item.q_id).q_kind == Q_item.Get(equip.itemModelId).q_kind) {
                    var newFighting = DuanzaoUtil.GetEquipFighting(itemInfo.itemModelId, itemInfo.strenthenLv);
                    var curFighting = DuanzaoUtil.GetEquipFighting(equip.itemModelId, equip.strenthenLv);
                    if(newFighting > curFighting){
                    	isFind = true;
                    	return itemInfo;
					}
                }
                return itemInfo;
            }
		}
		return null;
    },

	FlyTo:function (resline) {
		var grid;
		var panel = Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName)/*._ShowResline(resline);*/
		var grids = panel._reslinePanelDic[resline]._gridVec1;
		for ( var i = 0; i != grids.length; i++ ) {
			if (!grids[i].gridData) {
				grid = grids[i];
				break;
			}
		}
		var pt = cc.p( grid.x, grid.y );
		pt = UIUtil.LocalToGlobel( grid.parent, pt, Mgr.uiMgr.GetLayerByType(this.showLayerType) );

		//Mgr.uiMgr.GetLayerByType(this.showLayerType).reorderChild(this, 100);

		// action
		var actionTo = cc.moveBy(1, pt);
		var scale = cc.ScaleBy(0.3);
		var action = cc.spawn(actionTo, scale);
		var trace = cc.callFunc(this._OnTrace, this);
		var rep = cc.sequence(action, trace);

		this.gridEquip.runAction(rep);
	},

	_OnTrace:function () {
		this.gridEquip.setPosition(this._orgPt);
		this.gridEquip.SetScale(1.0);
	},

	WearResEquip:function () {
		var model = Q_item.Get(this._itemInfo.itemModelId);
		if(ItemUtil.IsEquip(model.q_type)) {
			var resLineType, type, subtype, str;
			if (model.q_type == 31) {
				str = "坐骑";
				type = BtnGroupUtil.M_JINJIE
				subtype = BtnGroupUtil.JINJIE_HOURSE;
				resLineType = EnumResline.HORSE;
			} else if (model.q_type == 32) {
				str = "光武";
				type = BtnGroupUtil.M_JINJIE
				subtype = BtnGroupUtil.JINJIE_GUANGWU;
				resLineType = EnumResline.GUANGWU;
			} else if (model.q_type == 33) {
				str = "书童";
				type = BtnGroupUtil.M_JINJIE
				subtype = BtnGroupUtil.JINJIE_SHUTONG;
				resLineType = EnumResline.SHUTONG;
			} else if (model.q_type == 34) {
				str = "宝骑";
				type = BtnGroupUtil.M_JINJIE
				subtype = BtnGroupUtil.JINJIE_BAOQI;
				resLineType = EnumResline.BAOQI;
			} else if (model.q_type == 35) {
				str = "法器";
				type = BtnGroupUtil.M_JINJIE
				subtype = BtnGroupUtil.JINJIE_FAQI;
				resLineType = EnumResline.DRAGON;
			}else if(model.q_type == 36){
				str = "武学";
				type = BtnGroupUtil.M_ROLE
				subtype = BtnGroupUtil.ROLE_WUXUE;
				resLineType = EnumResline.WUXUE;
			}else if(model.q_type == 40){
				str = "脚印";
				type = BtnGroupUtil.M_SHUTONG
				subtype = BtnGroupUtil.SHUTONG_JIAOYING;
				resLineType = EnumResline.STEP;
			}
			if (BtnGroupUtil.unOpenAseert(type, subtype)) {

				//this.FlyTo(resLineType);

				Mgr.resequip.SendReqResourceEquipSetToGameMessage(resLineType, model.q_kind, this._itemInfo.itemId);
			}
		}
	},

	ShowNewEquip:function (itemInfo) {
		this._itemInfo = itemInfo;
		// grid
		var grid = this.gridEquip;
		// var icon = ItemUtil.GetItemIcon(itemInfo.itemModelId)
		// icon.x = (grid.uiWidth - icon.width) / 2;
		// icon.y = (grid.uiHeight - icon.height) / 2;
		// grid.SetGridIcon(icon);
        var coinInfo = {};
        coinInfo.itemModelId = itemInfo.itemModelId;
        // coinInfo.itemNum = price;
        // coinInfo.itemBind = itemInfo.q_bind;
        GridUtil.SetItemGrid(grid,coinInfo);

		var itemC = Q_item.Get(itemInfo.itemModelId);
		cc.assert(null != itemC, "data is unexist in Q_item!  mid: " + itemInfo.itemModelId);
		UIUtil.ConnectLabelHtmlText(this.labCue, [itemC.q_name]);
	},
} );
NewEquipWarnExt.PanelName = "NewEquipWarnExt";
PanelClassDic["NewEquipWarnExt"] = NewEquipWarnExt;
