var NewFuncCue1Ext = NewFuncCue1.extend({
    _className: "NewFuncCue1Ext",
    _main: null,
    _autoTimeId : -1,

    _sub: null,
    _target: null,
    _callback: null,
    _showPannel: null,

    _imgTubiaoPos: null,
    _labNamePos: null,
    _img1Pos: null,
    ctor: function() {
        this._super();
        this.modelPanelType = MUIPanelModelType.ALPHABLACK;
        this.layoutCom.layoutOffy = -25;
    },
    Init: function() {
        NewFuncCue1.prototype.Init.call(this);
        var self = this;
        this.btnBg.setTouchEnabled(false);
        this.addClickEventListener(function() {
            self.doAction_Move();
        });

        this._imgTubiaoPos = this.imgTubiao. getPosition();
    },
    OnShow: function() {
        this._super();
        Mgr.task.StopAutoTask();

        this.imgTubiao.setPosition(this._imgTubiaoPos);
        this.imgTubiao.stopAllActions();

        this.imgBg.visible = true;
        this.btnBg.visible = true;
        this.labWenZi.visible = true;
        this.labName.visible = true;
    },
    OnHide: function() {
        this._super();
        TimerUtil.ClearTimeout(this._autoTimeId);
        this._autoTimeId = -1;

        if(!this._showPannel) Mgr.task.StartAutoTask();
    },
    OnAnimationFinished: function() {
        EngineMgr.uiMgr.HidePanelByType(NewFuncCue1Ext.PanelName);

        if (this._callback) this._callback(this._main, this._sub);
    },
    doAction_Move: function() {
        if (this._target) {
            var pos = this._target.convertToWorldSpace(cc.p(this._target.width / 2, this._target.height / 2));
            pos = this.imgTubiao.parent.convertToNodeSpace(pos);

            this.imgTubiao.setPosition(this._imgTubiaoPos);

            pos.x -= this._imgTubiaoPos.x;
            pos.y -= this._imgTubiaoPos.y;
            pos.x -= this.imgTubiao.width / 2;
            pos.y -= this.imgTubiao.height / 2;

            var action = cc.EaseSineIn.create(cc.moveBy(1, pos));
            var self = this
            this.imgTubiao.runAction(cc.sequence(action, cc.callFunc(function() {
                self.OnAnimationFinished();
            })));

            this.imgBg.visible = false;
            this.btnBg.visible = false;
            this.labWenZi.visible = false;
            this.labName.visible = false;
       
        } else {
            this.OnAnimationFinished();
        }
    },
    UpdateView: function(main, sub, target, showPannel,callback) {
        this._autoTimeId = TimerUtil.SetTimeout(this, this.doAction_Move, 20000);

        this._main = main;
        this._sub = sub;
        this._target = target;
        this._showPannel = showPannel;
        this._callback = callback;

        var key = BtnGroupUtil.toKey(main, sub);
        var model = Q_newfunc.Get(key);
        if (!(model && model.q_img_url)) this.OnAnimationFinished();


        var str = model.q_img_url.split(";");
        if (!model.q_img_url) self.OnAnimationFinished(main, sub, type);
        var urlTubiao = "other/xingongnengkaiqi/image/tubiao/" + str[0];

        UIUtil.LoadImage(this.imgTubiao, urlTubiao);
        this.labName.SetText(model.q_string_name);
    },
});
NewFuncCue1Ext.PanelName = "NewFuncCue1Ext";
PanelClassDic["NewFuncCue1Ext"] = NewFuncCue1Ext;