///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//107201,WearEquip 穿着装备
//107202,UnwearEquip 卸下装备

// 接收消息
//107101,WearEquipItem 穿着装备信息
//107102,UnwearEquipItem 卸下装备信息


////////////////////
// 穿着装备信息 //
////////////////////
var WearEquipItemMessage = cc.Class.extend( {
	ctor:function(){
		this.equip = null; // 装备信息
        this.itemType = 0; // 物品类型
	},

	getId:function(){
		return 107101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.equip);
        _buf.WriteVarInt(this.itemType);
	},
	
	reading:function( _buf ){
        this.equip = _buf.ReadBean(ItemInfo);
        this.itemType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.equip.RecvWearEquipItemMessage(this);
	},

});
////////////////////
// 卸下装备信息 //
////////////////////
var UnwearEquipItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.gridId = 0; // 格子Id
        this.itemType = 0; // 物品类型
	},

	getId:function(){
		return 107102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.gridId);
        _buf.WriteVarInt(this.itemType);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.gridId = _buf.ReadVarInt();
        this.itemType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.equip.RecvUnwearEquipItemMessage(this);
	},

});
////////////////////
// 穿着装备 //
////////////////////
var WearEquipMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
	},

	getId:function(){
		return 107201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
	},

});
////////////////////
// 卸下装备 //
////////////////////
var UnwearEquipMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.cellId = 0; // 放到背包的格子
        this.itemType = 0; // 物品类型
	},

	getId:function(){
		return 107202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.cellId);
        _buf.WriteVarInt(this.itemType);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.cellId = _buf.ReadVarInt();
        this.itemType = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(107101, WearEquipItemMessage);
MESSAGE_POOL.Add(107102, UnwearEquipItemMessage);

