var ShizhuangPanelExt = ShizhuangPanel.extend ( {
	_className:"ShizhuangPanelExt",
	menuPanel:null,
	fashionList:null,
	centerPanel:null,
	pCountFashion:null,         //总共的时装
	wCountFashion:null,
	effect:null,
	bType:1,
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
		Mgr.fasion.fashionPanel=this;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -30;
	},
	Init:function(){
		ShizhuangPanel.prototype.Init.call( this );
		this.pCountFashion=[];
		this.wCountFashion=[];
		var list=Q_fashion.GetList();
		for(var i=0;i<list.length;++i){
			if( list[i].q_id > 100 )
				this.wCountFashion.push(list[i]);
			else if( list[i].q_id > 0 )
				this.pCountFashion.push(list[i]);
		}

		this.fashionList=this.pCountFashion;
		this.sbtnJvese.SetButtonState("check");

		this.sbtnJvese.buttonText.x-=8;
		this.sbtnZuoqi.buttonText.x-=8;

		this.menuPanel = new cc.TableView(this,cc.size(325,510));
		this.menuPanel.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
		this.menuPanel.setDelegate(this);
		this.menuPanel.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
		this.menuPanel.y=-510;
		this.menuPanel.x=47;
		this.imgTitle.addChild(this.menuPanel);
		this.menuPanel.reloadData();
		this.menuPanel.setBounceable(false);
		this.centerPanel=new ShizhuangMainExt();
		this.centerPanel.LoadPanel();
		this.centerPanel.y=5;
		this.addChild(this.centerPanel);
		var self=this;
		this.btnClose.addClickEventListener(function(){
			EngineMgr.uiMgr.HidePanelByType(ShizhuangPanelExt.PanelName);
		});
		this.sbtnJvese.addClickEventListener(function(){
			self.fashionList=self.pCountFashion;
			Mgr.fasion.chooseId=self.fashionList[0].q_id;
			self.menuPanel.reloadData();
			self.UpdateMain();
		});
		this.sbtnZuoqi.addClickEventListener(function(){
			self.fashionList=self.wCountFashion;
			Mgr.fasion.chooseId=self.fashionList[0].q_id;
			self.menuPanel.reloadData();
			self.UpdateMain();
		});
		this.sbtnGouxuan.addClickEventListener(function(){
			Mgr.fasion.SendReqHiddenFashionMessage(this.GetState()=="check");
		});
		this.btnChuandai.addClickEventListener(function(){
			if(self.bType==EnumButtonType.JIHUO) {
				var condition = Q_fashion.Get(Mgr.fasion.chooseId).q_activate_item;
				condition = JSON.parse(condition);
				if (Mgr.backpack.GetItemNumber(condition[0][0]) >= condition[0][1])
					Mgr.fasion.SendReqActivateFashionMessage(Mgr.fasion.chooseId);
				else  Mgr.tips.ShowNotice( "材料不足");
			}
			else if(self.bType==EnumButtonType.CHUANDAI){
				Mgr.fasion.SendReqWearFashionMessage(Mgr.fasion.chooseId);
			}
			else if(self.bType==EnumButtonType.TUOXIA){
				Mgr.fasion.SendReqWearFashionMessage(Mgr.fasion.chooseId);
			}
		});
	},
	Update:function(){
		for(var i=0;i<this.fashionList.length;++i) {
			var cell = this.menuPanel.cellAtIndex(i);
			if (cell) {
				cell.item.Update();
			}
		}
		this.UpdateMain();
	},
	UpdateMain:function(){
		this.centerPanel.Update();
		this.UpdateButton();
	},
	UpdateButton:function(){
		if(!Mgr.fasion.IsHave(Mgr.fasion.chooseId)){
			this.btnChuandai.setTitleText("激活");
			this.centerPanel.SetState("未激活");
			this.bType=EnumButtonType.JIHUO;
		}
		else if(!Mgr.fasion.IsWear(Mgr.fasion.chooseId)){
			this.btnChuandai.setTitleText("穿戴");
			this.centerPanel.SetState("未穿戴");
			this.bType=EnumButtonType.CHUANDAI;
		}
		else {
			this.btnChuandai.setTitleText("脱下");
			this.centerPanel.SetState("穿戴中");
			this.bType=EnumButtonType.TUOXIA;
		}
	},
	ShowEffect:function(){
		if(!this.effect){
			this.effect=new JihuoCueExt();
			this.effect.LoadPanel();
			this.effect.y=-60;
			this.effect.x=-135;
			this.btnChuandai.addChild(this.effect);
		}
		this.effect.setOpacity(255);
		this.effect.runAction(cc.Sequence( cc.Spawn(new cc.FadeOut(2),cc.MoveBy(2,cc.p(0,100))),cc.MoveBy(0,cc.p(0,-100))));
	},
	tableCellTouched: function (table, cell) {
		Mgr.fasion.chooseId=cell.item.fId;
		this.Update();
	},
	tableCellSizeForIndex: function (table, idx) {
		return cc.size(323,118);
	},
	tableCellAtIndex: function (table, idx) {
		var cell = table.dequeueCell();
		if (!cell) {
			cell=cc.Sprite();
			var item = new ShizhuangFrameExt();
			item.LoadPanel();
			item.SetBaseData(this.fashionList[idx]);
			cell.item=item;
			cell.addChild(item);
		} else {
			cell.item.SetBaseData(this.fashionList[idx]);
		}
		return cell;
	},
	numberOfCellsInTableView: function (table) {
		return this.fashionList.length;
	}
} );
ShizhuangPanelExt.PanelName = "ShizhuangPanelExt";
PanelClassDic["ShizhuangPanelExt"] = ShizhuangPanelExt;
