var LixianExpMainExt = LixianExpMain.extend ( {
	_className:"LixianExpMainExt",

    _vScrollView:null,
    _btnCallHash:null,


	ctor:function(){
		this._super();
	},

    Init:function(){
        LixianExpMain.prototype.Init.call(this);

        this._btnCallHash = new HashMap();

    },

    InitView:function(){
        if(!this._vScrollView){
            this._vScrollView = new ccui.ScrollView();
            this._vScrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._vScrollView.setTouchEnabled(true);					//触摸开启
            this._vScrollView.inertiaScrollEnabled = true; 			//滚动惯性
            this._vScrollView.setScrollBarEnabled(false);				//滚动条
            this._vScrollView.setBounceEnabled(true);					//边界回弹
            // this._vScrollView.setScrollBarAutoHideTime(1);
            this.imgBg.addChild(this._vScrollView);
        }
    },

    InitTime:function(totalTime){
        // this.imglabNum.SetString(parseInt(totalTime/3600));
        // this.imglabNum1.SetString(parseInt(totalTime/60)%60);
        // this.imglabNum2.SetString(totalTime%60);
        this.labTime.SetText(parseInt(totalTime/3600) + "小时" + parseInt(totalTime/60)%60 + "分" + totalTime%60 + "秒");
    },

    OnShow:function(){
        Mgr.offlineres.SendReqOpenOfflineAwardPanelMessage();
    },

    ShowFrame:function(exp, totalTime){
        //this.ClearVScrollView();
        var list = Q_global.Get(110).q_string_value;
        list=JSON.parse(list);
        for(var i = 0; i != list.length; i++){
            if(!this._btnCallHash.Get(i)){
                var btnCall = new LixianExpFrameExt();
                btnCall.LoadPanel();
                btnCall.x = 0;
                btnCall.y = btnCall.uiHeight*(list.length-i-1);

                this._height = btnCall.uiHeight;

                this._btnCallHash.Put(i, btnCall);
                this._vScrollView.addChild(btnCall);
            }
            this._btnCallHash.Get(i).SetData(exp, list[i], totalTime);
        }

        this._vScrollView.setSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
        this._vScrollView.setInnerContainerSize(cc.size(this.imgBg.uiWidth, list.length * this._height));
        this.countHight = list.length * this._height;
    },

    scrollToIId:function (id) {
        // var prent=this._curSelectBtn.y/this.countHight;
        // var prent = (this.countHight - this._btnCallHash.Get(id).y - 114)/(this.countHight);
        // this._vScrollView.scrollToPercentVertical((prent*100), 0.5, true);
        var pos = cc.p(0, -this._btnCallHash.Get(id).y + this.imgBg.uiHeight - this._height)
        this._vScrollView.setInnerContainerPosition(pos);
    },

    ClearVScrollView:function(){
        var list = this._btnCallHash.Keys();
        for(var i = 0; i<list.length; i++){
            this._btnCallHash.Get(list[i]).OnHide();
            UIUtil.UIRemoveSelf(this._btnCallHash.Get(list[i]));
            this._btnCallHash.Remove(list[i]);
        }
    },

    SetData:function(totalTime, exp){
        this.InitView();
        this.InitTime(totalTime);
        this.ShowFrame(exp, totalTime);
        var id = 0;
        if(Mgr.player.mainPlayer.VIP < 2)
            id = 0;
        else if(Mgr.player.mainPlayer.VIP >= 2 && Mgr.player.mainPlayer.VIP < 4)
            id = 0;
        else if(Mgr.player.mainPlayer.VIP >= 4 && Mgr.player.mainPlayer.VIP < 6)
            id = 0;
        else if(Mgr.player.mainPlayer.VIP >= 6)
            id = 1;
        this.scrollToIId(id);
	},

    OnHide:function(){
        this._super();
        //this.ClearVScrollView();
    }
} );
LixianExpMainExt.PanelName = "LixianExpMainExt";
PanelClassDic["LixianExpMainExt"] = LixianExpMainExt;
