///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//161201,ReqGoldCardPanel 请求元宝卡面板信息
//161202,ReqOnlineAward 请求领取封测在线奖励

// 接收消息
//161101,ResGoldCardPanel 发送元宝卡面板信息
//161102,ResOnlineAwardResult 封测在线奖励领奖结果信息


////////////////////
// 发送元宝卡面板信息 //
////////////////////
var ResGoldCardPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.count = 0; // 累计元宝数量
	},

	getId:function(){
		return 161101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.count);
	},
	
	reading:function( _buf ){
        this.count = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.goldcard.RecvResGoldCardPanelMessage(this);
	},

});
////////////////////
// 封测在线奖励领奖结果信息 //
////////////////////
var ResOnlineAwardResultMessage = cc.Class.extend( {
	ctor:function(){
		this.nums = 0; // 今日已领取次数
	},

	getId:function(){
		return 161102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.nums);
	},
	
	reading:function( _buf ){
        this.nums = _buf.ReadByte();
	},

	action:function(){
		Mgr.goldcard.RecvResOnlineAwardResultMessage(this);
	},

});
////////////////////
// 请求元宝卡面板信息 //
////////////////////
var ReqGoldCardPanelMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 161201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取封测在线奖励 //
////////////////////
var ReqOnlineAwardMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 161202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(161101, ResGoldCardPanelMessage);
MESSAGE_POOL.Add(161102, ResOnlineAwardResultMessage);

