var TaijiActivitiesMainExt = TaijiActivitiesMain.extend ( {
	_className:"TaijiActivitiesMainExt",
	_rawardCon:null,
	_curDay:-1,//当前显示星期几的活动
	_curShowId:0,
	_scrollView:null,
	_gridList:null,
	_listView:null,
	ctor:function(){
		this._super();
		this._gridList = [];
		this.data = [];
	},
	
	Init:function(){
		TaijiActivitiesMain.prototype.Init.call( this );

		this.InitListView();
	},

	InitPanel:function(){
		this.gridItem.visible = false;
		// this._rawardCon = new TaskRewardsGridCon();
		// this.addChild(this._rawardCon);
		// this._rawardCon.x = this.gridItem.x;
		// this._rawardCon.y = this.gridItem.y;

		this.InitPageView();
		// this.InitItems();
	},

	InitPageView:function(){

        var size = this.imgBg1.getContentSize();
        var tableView = new cc.TableView(this,size);
        tableView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        tableView.setDelegate(this);
        tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
        tableView.setBounceable(true);
        this.imgBg1.addChild(tableView);
        this.tableView = tableView;

		
		this._scrollView = ccui.ScrollView();
		this._scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
		this._scrollView.setTouchEnabled(true);
		this._scrollView.inertiaScrollEnabled=false;
		this._scrollView.setScrollBarEnabled(false);
		this._scrollView.setBounceEnabled(true);
		this._scrollView.x = this.labCue2.x;
		this._scrollView.y = this.labCue2.y;
		cc.log("this.labCue2.width:"+this.labCue2.width + " " + this.labCue2.height);
		this._scrollView.setSize(cc.size(this.labCue2.width, this.labCue2.height));
		this.addChild(this._scrollView);
		UIUtil.UIRemoveSelf(this.labCue2);
		this.labCue2.x = 0;
		this.labCue2.y = 0;
		this._scrollView.addChild(this.labCue2);
	},

	InitListView:function(){
        this._listView = new ccui.ListView();
        this._listView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);//视图滚动方向
        this._listView.setTouchEnabled(true);					//触摸开启
        this._listView.inertiaScrollEnabled = false; 			//滚动惯性
        this._listView.setScrollBarEnabled(false);				//滚动条
        this._listView.setBounceEnabled(true);					//边界回弹
        this.imgBg2.addChild(this._listView);
	},


	SetCurActiveShow:function (id) {
        if(id == this._curShowId) return;
        this._curShowId = id;

        UIUtil.LoadImage( this.imgBg, "other/richangrenwu/image/bgyou/" + id + ".png");

        var container = this.tableView.getContainer();
        var cells = container.getChildren();
        for(var i=0;i!=cells.length;++i){
            var cell = cells[i]._cell;
            cell.SetSelected(id == cell._id);
        }

		var data = Q_timing.Get(id);
		this.labTitle.SetHtmlText(TextUtil.FormatStr( this.labTitle.GetHtmlText(), [ data.q_name ] ));
		this.labCue2.SetHtmlText(TextUtil.LineFeedStr(TextUtil.FormatStr( this.labCue2.GetHtmlText(), [ data.q_introduce ] )));
		var textH = ( this.labCue2._rowCount - 1 ) * ( this.labCue2._textHeight + this.labCue2._leading ) + this.labCue2._textHeight;
		cc.log("this.labCue2.textHeight:"+textH + " " + Math.abs(textH - this.labCue2.GetHeight()));
		this._scrollView.setInnerContainerSize(cc.size(this.labCue2.width, textH));
		this.labCue2.y = (textH > this.labCue2.GetHeight() ? textH - this.labCue2.GetHeight() : 0);
		
		// this._rawardCon.Clear();
		var rawardStr = data.q_item_show;
		if( rawardStr == "" ){
			this._listView.setVisible(false);
		}
		else{
			var rawards = JSON.parse( rawardStr );
			if( rawards ){
				// for ( var i = 0; i < rawards.length ; i ++){
				// 	var item = ItemUtil.ItemIdToItem(rawards[ i ].mod,rawards[ i ].num,0);
				// 	this._rawardCon.AddComItem(item,this.gridItem);
				// }
                //
				// if ( rawards.length > 0 ){
				// 	this._rawardCon.Layout( this.gridItem.uiWidth * rawards.length, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight );
				// }
                this._listView.setSize(cc.size(this.imgBg2.uiWidth, this.imgBg2.uiHeight));
                this._listView.setInnerContainerSize(cc.size(rawards.length * this.gridItem.uiWidth, this.imgBg2.uiHeight));
                var i = 0;
                for(; i < rawards.length; i++){
                    if(!this._gridList[i]){
                        var grid = new MUIGrid();
                        grid.ParseJson(this.gridItem.jsonobj);
                        grid.Init();
                        // grid.x = this.gridItem.x + grid.gridItem * i;
                        this._listView.pushBackCustomItem(grid);
                        this._gridList.push(grid);
                    }
                    var coinInfo = {};
                    this._gridList[i].visible = true;
                    this._gridList[i].setPosition(cc.p(this.gridItem.x + this.gridItem.uiWidth*i, 4));
                    coinInfo.itemModelId = rawards[i].mod;
                    coinInfo.itemNum = rawards[i].num;
                    coinInfo.itemBind = rawards[i].bind;
                    GridUtil.SetItemGrid(this._gridList[i],coinInfo);
                }
                for(;i < this._gridList.length; i++){
                    this._gridList[i].visible = false;
				}
			}
		}
	},

	OnShow:function(){
        var oldid = this._curShowId;
        this._curShowId = 0;
        this.SetCurActiveShow(oldid);

        this.Reload();


        /// 如果留在该界面，每整5分钟刷一次。
        var date = Mgr.login.GetServerDate();
        var interval = 5;
        var delay = 60 * interval - date.getMinutes() % interval * 60 - date.getSeconds();
        if(this._timerId) TimerUtil.ClearTimeUpdate(this._timerId);
        this._timerId = TimerUtil.SetTimeout(this,function(){
            this.Reload();

            if(this._timerId) TimerUtil.ClearTimeUpdate(this._timerId);
            this._timerId = TimerUtil.TimeUpdate(this.Reload,this,60 * interval,cc.REPEAT_FOREVER,0);
        }.bind(this),delay * 1000);
    },

    OnHide:function(){
        this._super();

        if(this._timerId) TimerUtil.ClearTimeUpdate(this._timerId);
        this._timerId = null;
    },

    GetActivityNextStartDate:function(data){
        var date = Mgr.login.GetServerDate();

        // 下次开启时间
        var nextDate = null;
        var nextTime = null;

        /// 首先判断开服和合服后的活动时间
        do{
            var onlineTime = Mgr.player.TotalOnlineTime;
            if(!onlineTime) break;

            var sysAct = Q_system_activity.Get(data.q_type);
            if(!sysAct) break;

            var q_open_days = JSON.parse(sysAct.q_open_days);
            if(!q_open_days) break;
            if(q_open_days.length == 0)break;

            // 最近的触发时间
            var nearTime = sysAct.q_isjoinday ? Math.max(onlineTime.openTime,onlineTime.joinTime) : onlineTime.openTime;
            var nearDate = new Date(nearTime * 1000);

            var _day = Math.floor(nearTime / 86400);
            var _day1 = Math.floor(date.getTime() / 1000 / 86400);

            var nearDay = _day1 - _day;

            q_open_days.sort(function(a,b){
                return a[0] - b[0];
            })
            var conf = q_open_days.find(function(v){
                return nearDay <= v[0];
            })

            if(!conf) break;

            // 开服合服有下一次开启时间
            nextDate = new Date((nearTime + (conf[0] - 1) * 86400) * 1000);
            nextDate.setHours(conf[1]);
            nextDate.setMinutes(conf[2]);
            var endDate = new Date(nextDate.getTime() + sysAct.q_time_limit * 1000);
            nextTime = conf[1] + ":" + conf[2] + "-" + endDate.getHours() + ":" + (endDate.getMinutes() || "00");
        }while(false);

        // 普通情况的判定
        do{
            // 开服的有了
            if(nextDate) break;

            var day = date.getDay();
            var dayArr = JSON.parse(data.q_day);
            var minDay = 0xFF;
            dayArr.find(function(v){
                v = v == 7 ? 0 : parseInt(v);
                minDay = v === -1 ? 0 : Math.min(minDay, (v + 7 - day) % 7);
                return v === -1 || day == v;
            })
            // 获取下一次活动时间
            nextDate = new Date(date.getTime() + minDay * 86400000);
            nextTime = data.q_time;
        }while(false);

        var nextDay = Math.floor(nextDate.getTime() / 1000 / 86400);
        var today = Math.floor(date.getTime() / 1000 / 86400);

        return {
            nextDate: nextDate,
            nextTime: nextTime,
            isToday: nextDay == today,
        }
    },

    GetActivityState:function(v){
        var date = Mgr.login.GetServerDate();
        var timeInMinutes = date.getHours() * 60 + date.getMinutes();

        var state = 3;
        if(v.isToday){
            if(timeInMinutes < v.startTime){
            //                return "活动即将开启！活动时间：" + data.q_time;
                state = 2;
            }else if(timeInMinutes >= v.endTime){
                //return "今日活动已经结束！活动时间：" + data.q_time;
                state = 4;
            }else{
                //return "火热进行中";
                state = 0;
            }
        }

        var level = Mgr.player.mainPlayer.attributeData.level;
        if(v.data.q_level > level) state = 5;

        return state;
    },

    Reload:function(){
        var curDate = Mgr.login.GetServerDate();
        var day = curDate.getDay();
        // 按天来更新活动状态
        if(true || this._curDay != day){
            this._curDay = day;

            this.data.length = 0;
            var data = Q_timing.GetList();

            for(var i=0;i!=data.length;++i){
                var v = data[i];
                var conf = this.GetActivityNextStartDate(v);

                var time = conf.nextTime.match(/(\d+):(\d+)-(\d+):(\d+)/);
                var startTime = time ? time[1] * 60 + parseInt(time[2]) : 0;
                var endTime = time ? time[3] * 60 + parseInt(time[4]) : 0;

                this.data.push({
                    data : v,
                    nextDate : conf.nextDate,
                    nextTime : conf.nextTime,
                    startTime : startTime,
                    endTime : endTime,
                    isToday : conf.isToday,
                })
            }
        }

        // 平常刷新只刷新排序
        var level = Mgr.player.mainPlayer.attributeData.level;
        var self = this;
        // 处理状态
        this.data.forEach((v,k)=>{
            v.state = this.GetActivityState(v);
        });
        // 特殊处理即将开始的状态
        var nextDate,best;
        this.data.forEach((v,k)=>{

            if(v.state == 2 && (!nextDate || nextDate > v.nextDate)){
                best = v;
                nextDate = v.nextDat;
            }
        });
        if(best) best.state = 1;

        // 排序
        this.data.sort(function(a,b){
            if(a.state == b.state){
                return a.data.q_order - b.data.q_order
            }
            return a.state - b.state;
        })

        this.tableView.reloadData();

        if(this._curShowId == 0 && this.data.length > 0) this.SetCurActiveShow(this.data[0].data.q_id);
    },

    tableCellSizeForIndex:function(sender,index){
        return cc.size(sender.width,130);
    },

    tableCellAtIndex:function(sender,index){
        var cell = sender.dequeueCell();
        if (!cell) {
            cell = new cc.TableViewCell();
        }

        try{
            if(!cell._cell) {
                var temp = new TaijiActivitiesListExt();
                temp.LoadPanel();
                cell.addChild(temp);
                cell._cell = temp;
            }
            cell._cell.SetActivityId(this.data[index]);
        }catch(err){
            ToolBase.LogError(err);
        }
        return cell;
    },

    numberOfCellsInTableView:function(sender){
        return this.data.length;
    },
} );
TaijiActivitiesMainExt.PanelName = "TaijiActivitiesMainExt";
PanelClassDic["TaijiActivitiesMainExt"] = TaijiActivitiesMainExt;
