var GuildSkillItemExt = GuildSkillItem.extend ( {
	_className:"GuildSkillItemExt",

	_info:null,
	_isLearn:null,

	ctor:function(){
		this._super();
		this._isLearn = false;
	},

	Init:function() {
		var self = this;
		GuildSkillItem.prototype.Init.call(this);
	},

	SetData:function (data) {
		this.Clear();

		var mid = data.mid;
		var sid = mid + "_" + data.level;
		var info = Q_guild_skill.Get(sid);
		if ( !info ) {
			zz.Error( "读取配置（Q_guild_skill）出错！ key: " + sid );
		}
		else {
			this._info = info;
			this._isLearn = data.isLearn;

			// icon
			var url = "other/banghui/skill/image/icon/";
			url = url + mid + ".png";
			var imgSkill = this.imgSkill;
			EngineMgr.uiMgr.GetAsynResByUrl(url, function () {
				imgSkill.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
			}, imgSkill);

			// name
			var str = info.q_name;
			this.labName.SetString(str);

			// level
			str = "Lv." + info.q_level;
			this.labLevel.SetString(str);
			this.labLevel.setVisible(this._isLearn);

			// state
			this.labLevel1.setVisible(!this._isLearn);
		}
	},

	GetData:function () {
		return this._info;
	},

	IsLearn:function () {
		return this._isLearn;
	},

	SetSelect:function (sel) {
		this.sbtn1.SetButtonState( sel == true ? "check" : "uncheck");
	},

	Clear:function () {
		this.sbtn1.SetButtonState("uncheck");

		this.labName.SetString("");
		this.labLevel.SetString("");
		this.labLevel1.setVisible(false);
	},
} );
GuildSkillItemExt.PanelName = "GuildSkillItemExt";
PanelClassDic["GuildSkillItemExt"] = GuildSkillItemExt;
