﻿var RoleHeadPanelExt = RoleHeadPanel.extend ( {
	_className:"RoleHeadPanelExt",
	myPlayerInfo:null,
	buffIconHash:null,
	buffBox:null,
	isShowBoss:false,
    bossHpPercent:100,
    normalHpPercent:100,
    bossId:null,
	hpRate:0,
	hpBgcount01:5,
	hpBgcount02:4,
	bloodLockPercent:100,
	bloodpercent:0,
	bloodGap:0,
	count:0,
	countGap:3,
	tempPercent:0,
	bloodRecord:0,
	isbarSchedule:false,
	_loadingBarBai:null,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_LU;
		this.layoutCom.layoutOffy = -5;
		this.layoutCom.layoutOffx = 4;
		this.buffBox= new ccui.Layout();
		this.buffBox.x=170;
		this.addChild(this.buffBox);
		this.buffIconHash = new HashMap();
		//this.myPlayerInfo = new MyPlayerInfo();

        BtnGroupUtil.registerNewFuncOpenedCallback(this, BtnGroupUtil.M_ROLE, BtnGroupUtil.ROLE_CONFESSION);
        BtnGroupUtil.registerNewFuncOpenedCallback(this, BtnGroupUtil.M_ROLE, BtnGroupUtil.ROLE_MARRIAGE);
	},
	Init:function (){
		var self = this;
		RoleHeadPanel.prototype.Init.call( this );
		this.imageNormalHp.visible=false;
		this.imageBossHp.visible=false;
        this.imageNormalDun.visible = false;
		this.labBossLv.SetAlign(LableAlign.CENTER);
		this.setbosslabvisible(false);
		this._InitBloodBarSprite();
		TimerUtil.TimeUpdate(this.OnFrame,this,1);
		Mgr.player.roleHeadPanel = this;
		// this.labNumber.SetScale(1.5);
		this.btnPKmode.addClickEventListener(function()
		{
			EngineMgr.uiMgr.ShowPanelByType(MoshiMainExt.PanelName);
		});
		this.imgHead.setTouchEnabled(true);
		this.imgHead.addClickEventListener(function()
		{
			EngineMgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName);
		});
		this.btnChongZhi.addClickEventListener(function(){
			EngineMgr.uiMgr.ShowPanelByType(RechargePanelExt.PanelName);
		});

        this.btnMarriage.addClickEventListener(function(){
            EngineMgr.uiMgr.ShowPanelByType(MarriagePanelExt.PanelName);
        });

        this.imgBuff.removeFromParent();
        this.imgBuff1.removeFromParent();

        this.UpdateMarriageShow()
    },

    UpdateMarriageShow:function(){
        if(!BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_ROLE, BtnGroupUtil.ROLE_CONFESSION)){
            this.btnMarriage.visible = false;
            return
        }
        this.btnMarriage.visible = true;

        var MI = Mgr.marriage.GetMarriageInfo()
        if(MI){
            UIUtil.LoadButtonImage(this.btnMarriage,"other/zhujiemian/huodongicon/woyaobiaobai.png");
        }else{
            UIUtil.LoadButtonImage(this.btnMarriage,"other/zhujiemian/huodongicon/woyaotuodan.png");
        }
    },
    OnNewFuncOpened:function(){
        this.UpdateOpenFunction();
    },
    UpdateOpenFunction:function(){
        this.UpdateMarriageShow()
    },
	UpdateChargeShow:function(){
		this.btnChongZhi.visible = (ActivityUtil.IsActivityFinishedStatus(EnumActivityKey.M_SHOU_CHONG) && Mgr.player.rechargeInfo.all > 0);
	},
	_InitBloodBarSprite:function()
	{
		this.progBaiHP.visible = false;
		var url="other/zhujiemian/image/xuetiao_boss_xiaoguai/bantoubai.png";
		var sp = new cc.Sprite();
		sp.initWithSpriteFrameName(url);
		var loadingBarBai = new cc.ProgressTimer(sp);
		loadingBarBai.anchorX = 0;
		loadingBarBai.anchorY = 0;
		loadingBarBai.type = cc.ProgressTimer.TYPE_BAR;
		loadingBarBai.midPoint = cc.p(0, 0);
		loadingBarBai.barChangeRate = cc.p(1, 0);
		loadingBarBai.setPosition(this.progBaiHP.getPosition());
		this.imageBossHp.addChild(loadingBarBai);
		this._loadingBarBai = loadingBarBai;
		var zorder = 100;
		this.progBossHpBar.setLocalZOrder(zorder/2-2);
		this._loadingBarBai.setLocalZOrder(zorder/2-1);
		this.progBossHpBar1.setLocalZOrder(zorder/2);
		this.img1.setLocalZOrder(zorder);
		this.labBossName.setLocalZOrder(zorder);
		this.labBossBloodCount.setLocalZOrder(zorder);
		this.imgBossHead.setLocalZOrder(zorder);
		this.imgHedeGrid.setLocalZOrder(zorder-1);
	},
	OnShow:function(){
		this.UpdatePanel();
        GameEventMgr.AddEventListener(this,new ResMarriagePanelMessage().getId(),this.UpdateMarriageShow.bind(this))
	},
	OnHide:function(){
        GameEventMgr.RemoveEventListener(this);
	},
	UpdatePanel:function (){
		if(!Mgr.player.mainPlayer)
			return ;
		this.UpdateName();
		this.UpdateFightPower();
		this.UpdateGold();
		this.UpdateHpBar();
		this.UpdateHead();
		//this.UpdateVip();
	},
	RemoveBuff:function(sid){
		var old=this.buffIconHash.Get(sid);
		if(old){
			this.buffBox.removeChild(old);
			this.buffIconHash.Remove(sid);
		}
		this.ReposBuffIcon();
	},
	AddBuff:function(vo){
		return; //暂时屏蔽buff图标 等策划出方案后再添加
		var old = this.buffIconHash.Get(vo.Sid());
		if(old){
			this.buffIconHash.Remove(vo.Sid());
			this.buffBox.removeChild(old);
		}
		 var buffIco = BuffUtil.GetBuffIco(2001);                   //先暂时全部用2001的图标
		buffIco.endTime=vo.EndTime();
		this.buffIconHash.Put(buffIco,vo.Sid());
		this.buffBox.addChild(buffIco);
		this.ReposBuffIcon();
	},
	ReposBuffIcon:function(){
		var arrayBuff=this.buffIconHash.Values();
		var posX = 0;
		var posY = 0;
		for(var i=0;i<arrayBuff.length;++i){
			var ico = arrayBuff[i];
			ico.x=posX;
			ico.y=posY;
			posX+=40;
			if(posX>200){
				posX=0;
				posY-=20;
			}
		}
	},
	UpdateName:function(){
		// this.labName.SetText( Mgr.player.mainPlayer.name );
	},
	UpdateGold:function(){
		// var mainPlayer = Mgr.player.mainPlayer;

		// if(mainPlayer.attributeData.gold<100000)
		// 	this.labGold.SetText( mainPlayer.attributeData.gold );
		// else
		// 	this.labGold.SetText(  Math.floor( mainPlayer.attributeData.gold/10000)+"万" );
		// if(mainPlayer.attributeData.bind_gold<100000)
		// 	this.labBangdingGold.SetText( mainPlayer.attributeData.bind_gold );
		// else
		// 	this.labGold.SetText(  Math.floor( mainPlayer.attributeData.bind_gold/10000)+"万" );

	},
	UpdateHead:function(){
		UIUtil.LoadImage( this.imgHead, ResUrl.GetPlayerHeadUrl(Mgr.player.mainPlayer.job));
	},
	UpdateVip:function (){
		// this.btnVip.removeAllNodes();
		// var url = "other/zhujiemian/touxiang/word/vip/vip_"+Mgr.player.mainPlayer.VIP+".png";
		// var img = UIUtil.GetAsynImageByUrl( url );
		// img.x = this.imgVip.x;
		// img.y = this.imgVip.y;
		// this.btnVip.addNode( img );
	},
	UpdateFightPower:function(){
		this.labNumber.SetText(Mgr.fightpower.fightPower);
	},
	Recharge:function (){
		GlobalFunction.IWantGiveMoney();
	},
	setbosslabvisible:function(bool)
	{
		this.labBossName.visible = bool;
		this.labBossBloodCount.visible = bool;
		this.labBossLv.visible = bool;
	},
	UpdateHpBar:function(){
		if( Mgr.mainPlayer )
			this.progHp.setPercent(Mgr.mainPlayer.nCurHp/Mgr.mainPlayer.nMaxHp * 100);
	},
	OnFrame:function(){
		var time = TimerUtil.GetTimer();
		var icoIdArray=this.buffIconHash.Keys();
		for(var i=0;i<icoIdArray.length;++i){
			var ico=this.buffIconHash.Get(icoIdArray[i]);
			if(ico.endTime<time){
				this.buffIconHash.Remove(icoIdArray[i]);
				this.buffBox.removeChild(ico);
			}
		}
	},

	/********************************************** target 血条处理 ********************************************************/
	_curTarget:null,
	SetTarget:function(target){
		this.imageNormalHp.visible = false;
		this.imageBossHp.visible = false;
		this.setbosslabvisible(false);
		this.labName.visible = false;
		this.isShowBoss=false;
		if( target )
		{
			//cc.log("name==> "+target.sBaseName+" level==> "+target.nCurLevel+" chp==> "+target.nCurHp+" mhp==> "+target.nMaxHp+" target.hpRate==> "+target.hpRate);
			if(target instanceof SceneMonster)
			{
				if( target.IsNormalMonster() )
				{
                    this.labName.visible = true;
					this.imageNormalHp.visible = true;
                    this.labName.SetText( target.sBaseName );
				}
				else
				{
					this.progBossHpBar.visible=true;
					this.imageBossHp.visible = true;
					this.setbosslabvisible(true);
					this.labBossName.SetText( target.sBaseName );
					this.labBossLv.SetText( target.nCurLevel );
					var url = "other/shijieboss/image/head/" + Q_monster.Get(target.nBodyModelId).q_head_resid + ".png";
                    UIUtil.LoadImage(this.imgBossHead, url , false, true);
					this.isShowBoss=true;
					if( this._curTarget != target ){
						Mgr.player.ShowShortChatState();
					}
				}
			}
			this.UpdateTargetHp(target);
			this.UpdateTargeBuff(target);
		}
		if( this._curTarget != target)
		{
			Mgr.map.miniMapPanel.ShowBossState(this.isShowBoss);
		}
		this._curTarget = target;
	},
	BossDie:function (boss) {
		if(boss.nGid==this.bossId)
		{
			this._StopBloodBar();
			this.imageBossHp.visible = false;
			this.setbosslabvisible(false);
			this.imageNormalHp.visible = false;
		}
    },

	UpdateTargetHp:function(target){
		//cc.log("-------name==> "+target.sBaseName+" level==> "+target.nCurLevel+" chp==> "+target.nCurHp+" mhp==> "+target.nMaxHp+" target.hpRate==> "+target.hpRate);
		if(target instanceof SceneMonster)
		{
			if( target.IsNormalMonster() )
			{
				this.normalHpPercent= target.nMaxHp ? target.nCurHp / target.nMaxHp * 100 : 0;
				this.progNormalHp.setPercent(this.normalHpPercent);
				this.bossId=target.nGid;
			}
			else
			{
				this._HandleMonsterBloodbar(target);
                this.bossId=target.nGid;
			}
		}
	},

    UpdateTargeBuff:function(target){
        this.imageNormalDun.visible = false;
		if(target instanceof SceneMonster){
			if(target.IsNormalMonster()){
			}
			else{
                for(var i = 0; i < target.buffs.length; i++){
					var info = target.buffs[i].Model();
					if(info.q_action_type == BuffType.BUFF_SHIELD_1 || info.q_action_type == BuffType.BUFF_SHIELD_2){
					   this.imageNormalDun.visible = true;
					   this.progNormalDun.setPercent(target.buffs[i].Value() / info.q_effect_maxvalue * 100);
					}
				}
			}
		}
	},

	_HandleMonsterBloodbar:function(target)
	{
		var hpRate = target.hpRate;
		var count = this.hpRate - hpRate;
		if(count>1)
		{
			this._SetBaseBlood();
			this.SetBoosHpColor(hpRate);
			this.labBossBloodCount.SetString("x" + (hpRate+1));
		}
		else if(count == 1)
		{
			this._SetBaseBlood();
			this.SetBoosHpColor(hpRate);
			this.labBossBloodCount.SetString("x" + (hpRate+1));
		}
		else
		{
			this.SetBoosHpColor(hpRate);
			this.labBossBloodCount.SetString("x" + (hpRate+1));
		}
		this.hpRate = hpRate;
		this._HandleHpPercent(target);
	},
	_SetBaseBlood:function()
	{
		this.bloodRecord = 0;
		this.progBossHpBar1.setPercent(this.bloodLockPercent);
		this._StartloadingBarBai(this.bloodLockPercent,this.bloodLockPercent);
	},
	_HandleHpPercent:function(target)
	{
		var bossHpPercent= target.nMaxHp ? target.nCurHp / target.nMaxHp * 100 : 0;
		if(this.bloodRecord>0)
		{
			this.bloodGap = (this.bloodRecord - bossHpPercent)/3;
		}
		else
		{
			this.bloodGap = (this.bloodLockPercent - bossHpPercent)/3;
		}
		this.bloodRecord = bossHpPercent;
		this.tempPercent = bossHpPercent+this.bloodGap*this.countGap;
		this.bloodpercent = bossHpPercent+this.bloodGap*this.countGap;
		this._StartBloodBar01();
		if(this.bloodGap<2)
		{
			this.progBossHpBar1.setPercent(bossHpPercent);
			return;
		}
		this.progBossHpBar1.setPercent(this.bloodpercent);
		//
		this.count = 0;
		this._StopBloodBar();
		this._StartBloodBar();
		this.schedule(this._StartBloodBar,0.3,1);
	},
	_StopBloodBar:function()
	{
		if(this.isbarSchedule)
		{
			this.isbarSchedule = false;
			this.unschedule(this._StartBloodBar);
		}
	},
	_StartBloodBar:function()
	{
		this.isbarSchedule = true;
		this.count++;
		var percent = this.bloodpercent - this.bloodGap*this.count;
		this.progBossHpBar1.setPercent(percent);
	},
	_StartBloodBar01:function()
	{
		var percent = this.countGap*this.bloodGap;
		this._StartloadingBarBai(this.tempPercent,this.bloodpercent-percent);
	},
	_StartloadingBarBai:function(fromNum,toNum)
	{
		this._loadingBarBai.stopAllActions();
		if(!fromNum) {return;}
		var to = cc.sequence(cc.progressTo(0, fromNum), cc.progressTo(1, toNum));
		this._loadingBarBai.runAction(to);
	},

	ChangeModelText:function(type)
	{
		var url = "other/zhujiemian/word/zthe.png";
		switch (type)
		{
			case EnumPkMode.PK_MODE_PEACE:
				break;
			case EnumPkMode.PK_MODE_GUILD:
				url = "other/zhujiemian/word/ztbang.png";
				break;
			case EnumPkMode.PK_MODE_ALL:
				url = "other/zhujiemian/word/ztquan.png";
				break;
			case EnumPkMode.PK_MODE_SERVER:
				url = "other/zhujiemian/word/ztfu.png";
				break;
			default:
				break;
		}
		// var self = this;
        UIUtil.LoadImage(this.imgmodel,url);
		// EngineMgr.uiMgr.GetAsynResByUrl(url, function () {
		// 	self.imgmodel.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
		// }, self.imgmodel);
	},

    SetBoosHpColor:function (num)
	{
		if(num<0){return;}

        var nn=num%5+1;
        var url="other/zhujiemian/image/xuetiao_boss_xiaoguai/";
        this.progBossHpBar1.ChangeRes(url+nn+".png");
        if(nn-1)
            this.progBossHpBar.ChangeRes(url+(nn-1)+".png");
        else
            this.progBossHpBar.ChangeRes(url+(nn-1+5)+".png");
        if(num>0){
            this.progBossHpBar.setVisible(true);
        }
        else
            this.progBossHpBar.setVisible(false);

		// if(this.hpBgcount01<1)
		// {
		// 	this.hpBgcount01 = 5;
		// }
		// if(this.hpBgcount02<1)
		// {
		// 	this.hpBgcount02 = 5;
		// }
		// var url="other/zhujiemian/image/xuetiao_boss_xiaoguai/";
		// this.progBossHpBar1.ChangeRes(url+this.hpBgcount01+".png");
        // if(num>0){
         //    this.progBossHpBar.visible=true;
         //    this.progBossHpBar.ChangeRes(url+this.hpBgcount02+".png");
		// }
        // else
		// {
		// 	this.hpBgcount01 = 5;
		// 	this.hpBgcount02 = 4;
		// 	this.progBossHpBar.visible=false;
		// }
		// this.hpBgcount01--;
		// this.hpBgcount02--;
    }
	/********************************************** target		end ********************************************************/
} );
RoleHeadPanelExt.PanelName = "RoleHeadPanelExt";
PanelClassDic["RoleHeadPanelExt"] = RoleHeadPanelExt;

