var PifengPanelExt = PifengPanel.extend ( {
	_className:"PifengPanelExt",

	_cloakPanel:null,

	ctor:function(){
        this.modelPanelType = MUIPanelModelType.BLUR;
		this._super();
	},

    Init:function (){
        GenChongPanel.prototype.Init.call( this );
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -28;

        var self = this;
        this.btnClose.addClickEventListener(function()
        {
            EngineMgr.uiMgr.HidePanel(self);
        });

        this._cloakPanel = new PifengMainExt();
        this._cloakPanel.LoadPanel();
        this.imgBg.addChild(this._cloakPanel);
        this.sbtnShenwu.addClickEventListener(function(){
            self.ChangePanel(HuanhuaType.TYPE_WEAPON);
        });
        this.sbtnPifeng.addClickEventListener(function(){
            self.ChangePanel(HuanhuaType.TYPE_CLOAK);
        });

    },

    OnShow:function(){
        this.sbtnPifeng.visible = BtnGroupUtil.IsFunctionOpen( BtnGroupUtil.M_SHORTCUT, BtnGroupUtil.SHORT_CLOAK );
        this.sbtnShenwu.SetButtonState("check");
        this.ChangePanel(HuanhuaType.TYPE_WEAPON);
        this._cloakPanel.OnShow();
        this.UpdateWarning();
        Mgr.illusion.onIllusionDataChange.add(this.UpdateWarning, this);
    },

    UpdateWarning:function(){
        this.imgWarnShenwu.visible = Mgr.illusion.GetWarnType(HuanhuaType.TYPE_WEAPON);
        this.imgWarnPifeng.visible = Mgr.illusion.GetWarnType(HuanhuaType.TYPE_CLOAK);
    },

    ChangePanel:function(type){
        UIUtil.LoadImage(this.imgTitle1, type == HuanhuaType.TYPE_WEAPON ?"other/shizhuang/word/shizhuang.png" : "other/shizhuang/word/pifeng.png")
        this._cloakPanel.SetType( type );
    },

    OnHide:function(){
        this._super();
        this._cloakPanel.OnHide();
        Mgr.illusion.onIllusionDataChange.remove(this.UpdateWarning, this);
    }
} );
PifengPanelExt.PanelName = "PifengPanelExt";
PanelClassDic["PifengPanelExt"] = PifengPanelExt;
