var PaiHangBangExt = PaiHangBang.extend ( {
	_className:"PaiHangBangExt",
	ctor:function(){
		this._super();
	},

	Init:function () {
		PaiHangBang.prototype.Init.call(this);

		this.lab1.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
		this.lab2.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
		this.lab3.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);

		this.myIndex = -1;
		this.myCost = 0;
        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgContent.uiWidth, this.imgContent.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            this.cellPanel=tableView;
            this.imgContent.addChild(tableView);
        }

        var self = this;
        this.labChakan.setTouchEnabled(true);
        this.labChakan.addTouchEventListener(function (sender, type) {
            if(type == ccui.Widget.TOUCH_ENDED){
                var panel = Mgr.uiMgr.ShowPanelByType(PaiHangApplyListExt.PanelName);
                panel.SetData(self.activityList);
            }
        });
    },

    SetActivityList:function (infoList, isOpen) {
        this.activityList = infoList;
        this.totalNum = infoList.length;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        var allRankInfos = [];
        for(var i = 0; i < this.activityList.length; i++) {
            var rankInfos = this.activityList[i].special[0].beanInfo.rankInfos;
            if(rankInfos && rankInfos.length > 0){
                allRankInfos = allRankInfos.concat(rankInfos);
            }
        }

        for(var k = 0; k < allRankInfos.length; k++){
            var rankInfo = allRankInfos[k];
            if(rankInfo.playerid.toGID() == Mgr.player.mainPlayer.sid.toGID()){
                this.myIndex = k+1;
                break;
            }
        }

        var need = 0;
        var beanInfo = this.activityList[0].special[1].beanInfo;
		if(beanInfo){
            this.myCost = beanInfo.gold;
            need = beanInfo.need;
		}
		if(this.myIndex > 0){
			this.labWeishangbang.SetHtmlText("<font color=\"#3a2707\">" + this.myIndex);
		}else {
            this.labWeishangbang.SetHtmlText("<font color=\"#dc143c\">未上榜");
        }
        this.labYuanbao.SetText(this.myCost);
		UIUtil.ConnectLabelHtmlText(this.labLeiji, [need]);
        UIUtil.ConnectLabelHtmlText(this.lab1, ["暂无"]);
        UIUtil.ConnectLabelHtmlText(this.lab2, ["暂无"]);
        UIUtil.ConnectLabelHtmlText(this.lab3, ["暂无"]);
        if(allRankInfos[0]) UIUtil.ConnectLabelHtmlText(this.lab1, [allRankInfos[0].playername]);
        if(allRankInfos[1]) UIUtil.ConnectLabelHtmlText(this.lab2, [allRankInfos[1].playername]);
        if(allRankInfos[2]) UIUtil.ConnectLabelHtmlText(this.lab3, [allRankInfos[2].playername]);
		this.cellPanel.reloadData();
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(571,95);
    },
    tableCellAtIndex: function (table, idx) {
        var data = this.activityList[idx];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item = new PaiHangZhanShiExt();
            item.LoadPanel();
            item.setTouchEnabled(false);
            cell.item = item;
            cell.addChild(item);
        }
        cell.item.SetData(data, idx);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    }
} );
PaiHangBangExt.PanelName = "PaiHangBangExt";
PanelClassDic["PaiHangBangExt"] = PaiHangBangExt;
