///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//162201,ReqHydrangeaEnterToGame 进入抢绣球地图
//162202,ReqHydrangeaQuitToGame 退出抢绣球地图

// 接收消息
//162101,ResHydrangeaNoticeInfo 抢绣球活动信息 
//162102,ResHydrangeaEnd 抢绣球活动结束 
//162103,ResGatherHydrangeaResult 采集绣球结果 
//162104,ResHydrangeaStart 通知活动开启（弹图标）


////////////////////
// 抢绣球活动信息  //
////////////////////
var ResHydrangeaNoticeInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.startTime = 0; // 活动剩余时间(秒)
        this.nextRefreshTime = 0; // 下一波绣球刷新时间(秒)
        this.playerName = null; // 第一名名字
        this.num = 0; // 第一名数量
	},

	getId:function(){
		return 162101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.startTime);
        _buf.WriteVarInt(this.nextRefreshTime);
        _buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.startTime = _buf.ReadVarInt();
        this.nextRefreshTime = _buf.ReadVarInt();
        this.playerName = _buf.ReadString();
        this.num = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.hydrangea.RecvResHydrangeaNoticeInfoMessage(this);
	},

});
////////////////////
// 抢绣球活动结束  //
////////////////////
var ResHydrangeaEndMessage = cc.Class.extend( {
	ctor:function(){
		this.nextTime = 0; // 下一次活动时间(时间戳秒)
	},

	getId:function(){
		return 162102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.nextTime);
	},
	
	reading:function( _buf ){
        this.nextTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.hydrangea.RecvResHydrangeaEndMessage(this);
	},

});
////////////////////
// 采集绣球结果  //
////////////////////
var ResGatherHydrangeaResultMessage = cc.Class.extend( {
	ctor:function(){
		this.posX = 0; // x坐标
        this.posY = 0; // y坐标
        this.gatherResult = 0; // 采集结果(0失败 1成功)
	},

	getId:function(){
		return 162103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort(this.posX);
        _buf.WriteShort(this.posY);
        _buf.WriteByte(this.gatherResult);
	},
	
	reading:function( _buf ){
        this.posX = _buf.ReadShort();
        this.posY = _buf.ReadShort();
        this.gatherResult = _buf.ReadByte();
	},

	action:function(){
		Mgr.hydrangea.RecvResGatherHydrangeaResultMessage(this);
	},

});
////////////////////
// 通知活动开启（弹图标） //
////////////////////
var ResHydrangeaStartMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 162104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.hydrangea.RecvResHydrangeaStartMessage(this);
	},

});
////////////////////
// 进入抢绣球地图 //
////////////////////
var ReqHydrangeaEnterToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 162201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 退出抢绣球地图 //
////////////////////
var ReqHydrangeaQuitToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 162202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(162101, ResHydrangeaNoticeInfoMessage);
MESSAGE_POOL.Add(162102, ResHydrangeaEndMessage);
MESSAGE_POOL.Add(162103, ResGatherHydrangeaResultMessage);
MESSAGE_POOL.Add(162104, ResHydrangeaStartMessage);

