var MonthCardInvestRewardItemExt = MonthCardInvestRewardItem.extend ( {
	_className:"MonthCardInvestRewardItemExt",

	_order:null,
	_golden:null,
	_status:null,

	ctor:function(){
		this._super();
		this._golden = 0;
	},

	Init:function() {
		var self = this;
		MonthCardInvestRewardItem.prototype.Init.call(this);
		this.labState.setVisible(false);
		this.setSwallowTouches(false);

		this.btnGet.addClickEventListener(function (event) {
			Mgr.bank.SendReqBankMonthAwardToGameMessage(self._order);
		});
	},

	SetData:function ( order, status ) {
		this.Clear();

		this._order = order;
		this._status = status;

		var info = JSON.parse(Q_play_freely.Get(order).q_reward);
        this._golden = info[0].num;
		var str;
		if ( order == 0 ) {  // 投资立即返利
			str = "投资立即返利";
		}
		else {
			str = "第 <font color='#5abb5c'>" + order + "</font> 天可领取奖励";
		}
		this.labDes.SetString(str);
		this.labGongxian.SetString(this._golden);
        //
		// if ( order == 0 )
		// 	this.labState.visible = true;
		// status
		if ( status == InvestTypeEnum.INVEST_STATUS_ENGET )
			this.btnGet.visible = true;
		else if ( status == InvestTypeEnum.INVEST_STATUS_UNREACH )
			this.imgUnReach.visible = true;
		else if ( status == InvestTypeEnum.INVEST_STATUS_GETED ) {
			this.imgGeted.visible = true;
		}
	},

	GetStatus:function () {
		return this._status;
	},

	GetItemOrder:function () {
		return this._order;
	},

	GetGolden:function () {
		return this._golden;
	},

	Clear:function () {
		this.labState.visible = false;
		this.imgGeted.visible = false;
		this.imgUnReach.visible = false;
		this.btnGet.visible = false;
	}
} );
MonthCardInvestRewardItemExt.PanelName = "MonthCardInvestRewardItemExt";
PanelClassDic["MonthCardInvestRewardItemExt"] = MonthCardInvestRewardItemExt;
