var jianghuyingxiongbangExt = jianghuyingxiongbang.extend ( {
    _className:"jianghuyingxiongbangExt",
    ctor:function(){
        this._super();

        Mgr.arena._jjPnael = this;
    },
    Init: function() {
        this._super();

        this.imgYuanBao.ignoreContentAdaptWithSize(true);
        this.imgYuanBao1.ignoreContentAdaptWithSize(true);
        this.imgYuanBao.scale = 0.4;
        this.imgYuanBao1.scale = 0.4;

        var imageRes = ResUrl.GetItemIconKey(-8);
        this.imgYuanBao.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
        this.imgYuanBao1.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);

        this.btnJia.addClickEventListener(function(){
            if(!Mgr.arena.CheckBuyChallengeCount()) return;

            var totalGold = Mgr.mainPlayer.attributeData.TotalGold();
            if ( 50 > totalGold ) {
                AlertExt.NoEnoughGold(50 - totalGold);
                return;
            }

            AlertExt.Show(TextUtil.FormatStr("是否花费{@}元宝购买挑战次数?", [50]),TipsEnum.BUTTON_SURE_AND_FALSE, {
                _onFunc:function(){
                    Mgr.arena.SendReqBuyJoinArenaCountMessage();
                },
            },1);
        });
        this.btnDaoJiShi.addClickEventListener(function(){
            if(!Mgr.arena.CheckNeedClearCoolDown()) return;

            var gold = Mgr.arena.GetCoolDownCostGold();
            var totalGold = Mgr.mainPlayer.attributeData.TotalGold();
            if ( gold > totalGold ) {
                AlertExt.NoEnoughGold(gold - totalGold);
                return;
            }

            AlertExt.Show(TextUtil.FormatStr("是否花费{@}元宝清除冷却时间?", [gold]),TipsEnum.BUTTON_SURE_AND_FALSE, {
                _onFunc:function(){
                    Mgr.arena.SendReqClearArenaCoolDownMessage();
                },
            },1);
        });
        this.btnShuaXing.addClickEventListener(function(){
            var timeNow = TimerUtil.GetGameTimer();
            if(this._lastTime && timeNow - this._lastTime < 2000) {
                // 刷新太频繁了
                return;
            }
            this._lastTime = timeNow;
            Mgr.arena.SendReqArenaInfoMessage();
            Mgr.arena.SendReqArenalistToGameMessage({
                type : 0,
                start : 0,
                length : 4,
            });
        }.bind(this));


        this.sbtnGangYu.addClickEventListener(function(sender){
            this.UpdateView();
        }.bind(this));

//        imgLists

        var tableView = new cc.TableView(this,cc.size(this.imgLists.uiWidth, this.imgLists.uiHeight));
        tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
        tableView.setDelegate(this);
        tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
        tableView.setTouchEnabled(true);
        this.imgLists.addChild(tableView);
        this.tableView = tableView;
        this.tableView.reloadData();
    },

    OnShow:function(){
        if(!Mgr.arena._arenaInfo) Mgr.arena.SendReqArenaInfoMessage();
        if(!Mgr.arena._arenaRankInfo){
            Mgr.arena.SendReqArenalistToGameMessage({
                type : 0,
                start : 0,
                length : 4,
            });
        }

        if(!this._timerId) this._timerId = TimerUtil.TimeUpdate(this.onTimer,this,1);
        this.onTimer();

        this.UpdateView();
    },
    OnHide:function(){
        this._super();

        if(this._timerId) TimerUtil.ClearTimeUpdate(this._timerId);
        this._timerId = null;
    },

    RequestUpdateView:function(){
        if(!this._timer4update){
            this._timer4update = TimerUtil.SetTimeout(this,this.UpdateView,100);
        }else{
            //cc.log("repeated")
        }
    },

    RequestUpdateRankView:function(){
        if(!this._timer4updateRank){
            this._timer4updateRank = TimerUtil.SetTimeout(this,this.UpdateRankView,100);
        }else{
            //cc.log("repeated")
        }
    },

    UpdateView:function(){
        this._timer4update = null;

        var arenaInfo = Mgr.arena._arenaInfo || {};

        //imgLists

        // 我的信息
        UIUtil.ConnectLabelHtmlText(this.labZhanLiZhi, [Mgr.fightpower.fightPower]);
        UIUtil.ConnectLabelHtmlText(this.labPaiMingZhi, ["第 "
            + (arenaInfo.rank || "???") +" 名"]);

        var result = Mgr.arena.GetAwardByRank(arenaInfo.rank);
        var award1 = result[0] ? JSON.parse(result[0])[0].num : 0;
        var award2 = result[1] ? JSON.parse(result[1])[0].num : 0;

        UIUtil.ConnectLabelHtmlText(this.labJiangLiZhi, [award1]);
        UIUtil.ConnectLabelHtmlText(this.labJiangLiZhi2, [award2]);

        // 挑战次数
        var challengeCount = Mgr.arena.GetAvailableChallengeCount();
        UIUtil.ConnectLabelHtmlText(this.labCiShu, [challengeCount]);

        var players = arenaInfo.arenaInfos || [];
        var config = [
            { rank:this.labKeTiaoZhan11,name:this.labName11111,fightpower:this.labZhanDouLi11111,model:this.imgModel2 },
            { rank:this.labKeTiaoZhan1,name:this.labName1111,fightpower:this.labZhanDouLi1111,model:this.imgModel },
            { rank:this.labKeTiaoZhan111,name:this.labName111111,fightpower:this.labZhanDouLi111111,model:this.imgModel3 },
        ]

        var showGuangyu = this.sbtnGangYu.GetState() == "uncheck";
        for(var k=0,v=config[k];k!=config.length;v=config[++k]){
            var player = players[k];
            var modelKey = "_uiModel" + k;

            var fightPower = player && player.playerid.toGID() == Mgr.mainPlayer.nGid
                    ? Mgr.fightpower.fightPower : (player ? player.fightpower : "???");

            UIUtil.ConnectLabelHtmlText(v.rank,      [player ? player.rank : "???"]);
            UIUtil.ConnectLabelHtmlText(v.name,      [player ? player.name : "???"]);
            UIUtil.ConnectLabelHtmlText(v.fightpower,[fightPower]);

            if(!player) continue;
            var uiModel = this[modelKey];
            if(!uiModel){
                uiModel = new UIModel(SceneObjUtil.GetBodyIdByInfo(player));
                uiModel.x = v.model.width / 2;
                uiModel.y = -25;
                uiModel.setScale(0.8);
                this[modelKey] = uiModel;

                v.model.height = 270;
                v.model.addChild(uiModel);
                v.model.setTouchEnabled(true);
                v.model.addClickEventListener(this.onBtnClicked_StartArena.bind(this));
            }else uiModel.SetModelId(SceneObjUtil.GetBodyIdByInfo(player));
            v.model.player = player;

            uiModel._animGroup.RemoveAllBindPart();

            if(player.brief){
                for( var i = 0; i < player.brief.reslineInfo.length; i++ ){
                    var resline = player.brief.reslineInfo[i];
                    if( resline.reslineType == EnumResline.GUANGWU )
                        uiModel.AddWeapon(SceneObjUtil.GetGodWeaponResId(player.brief.illusionDataInfos) || resline.reslineModelId, player.job);
                }
                if(showGuangyu && player.brief.armorShowId > 0){
                    var wingId = ScenePlayer.prototype._Getnresid(player.brief.armorShowId);
                    uiModel.AddWing(wingId);
                }

                uiModel.SetModelId(SceneObjUtil.GetBodyIdByInfo(player.brief));
            }else{
                uiModel.AddWeapon(1, 1);
            }

            uiModel._animGroup.CheckPartZOrder();
        }
    },

    UpdateRankView:function(){
        this._timer4updateRank = null;

        this.data = Mgr.arena._arenaRankInfo.arenaInfolist;
        this.tableView.reloadData();
    },

    onBtnClicked_StartArena:function(sender){
        if(!sender.player) return;

        var player = sender.player;

        Mgr.arena.SendReqStartArenaMessage({
            index : player.rank,
            personId : player.playerid,
        })

        Mgr.arena.SendReqArenaMonsterInfoMessage({
            arenaId : player.playerid
        });
    },

    onTimer:function(dt){
        var countdown = Mgr.arena.GetCountdown();
        countdown = Math.max(0,countdown);
        var leftTime = TimeUtil.SecondToDHMS2(countdown);
        UIUtil.ConnectLabelHtmlText(this.labShiJian2, [leftTime]);
        this.labShiJian2.SetColor(Mgr.arena.CheckNeedClearCoolDown(true)
            ? EnumFontFormat.COMMON_COLOR09 : EnumFontFormat.COMMON_COLOR04);
    },

    tableCellTouched:function(sender,cell){
        var index = cell.getIdx();
        var data = this.data[index];

        this.onBtnClicked_StartArena({
            player : data,
        });
    },

    tableCellSizeForIndex:function(sender,index){
        // 加点间距
        return cc.size(sender.width,89);
    },

    tableCellAtIndex:function(sender,index){
        var cell = sender.dequeueCell();
        if (!cell) {
            cell = new cc.TableViewCell();
        }
        if(!cell.item){
            var item=new jianghuyingxiongbangListsExt();
            item.LoadPanel();

            cell.addChild(item)
            cell.item = item;
        }
        var data = this.data[index];
        cell.item.SetData(data);
        return cell;
    },

    numberOfCellsInTableView:function(sender){
        return this.data ? this.data.length : 0;
    },
} );
jianghuyingxiongbangExt.PanelName = "jianghuyingxiongbangExt";
PanelClassDic["jianghuyingxiongbangExt"] = jianghuyingxiongbangExt;
