var KingneutralModMgr = KingneutralModMgr || cc.Class.extend({

    stateInfo: null,
    battleInfo : null,

    ctor: function() {},

    RecvReskingneutralGameToClinetMessage: function(msg) {
        cc.log("-----------------1 " + JSON.stringify(msg));

        this.stateInfo = msg;

        var panel = Mgr.uiMgr.GetPanelByType(TaijiPanelExt.PanelName);
        if (panel) {
            panel.UpdateView(EnumGrossipType.TYPE_GUILD);
        }
    },

    RecvReskingneutralTopGameToClinetMessage: function(msg) {
        cc.log("-----------------2 " + JSON.stringify(msg));

    },

    RecvReskingneutralTaskGameToClinetMessage: function(msg) {
        cc.log("-----------------3 " + JSON.stringify(msg));
        this.battleInfo = msg;

        this.battleInfo.__remandtime = Mgr.login.GetServerTime()/1000  + msg.remandtime;
        this.battleInfo.__npcOwnTime = Mgr.login.GetServerTime()/1000  - msg.npcOwnTime;
    },

    SendReqkingneutralClientToGameMessage: function(msg) {
        var msg = new ReqkingneutralClientToGameMessage();
        Mgr.msgMgr.Send(msg);
    },

    SendReqkingneutralEnterClientToGameMessage: function(msg) {
        var msg = new ReqkingneutralEnterClientToGameMessage();
        Mgr.msgMgr.Send(msg);
    },

    SendReqGetkingNeutralAwardClientToGameMessage: function(msg) {
        var msg = new ReqGetkingNeutralAwardClientToGameMessage();
        Mgr.msgMgr.Send(msg);
    },

    OnMapStartChanged:function(mapId,type){
       if(type == -1) return;

        // 如果飞进了皇城战副本
        var zoneType = Mgr.sceneMap.GetZoneTypeByMapId(mapId);
        if(zoneType == EnumZoneType.TYPE_KINGNEUTRAL){
            Mgr.uiMgr.HidePanelByType(TaijiPanelExt.PanelName);
        }
    },
    OnMapReadyChanged:function(){
        // 如果飞进了皇城战副本
        if(Mgr.sceneMap.ZoneType() != EnumZoneType.TYPE_KINGNEUTRAL){
            return;
        }
    },
    OnMapChanged:function(){
        // 如果飞进了皇城战副本
        if(Mgr.sceneMap.ZoneType() != EnumZoneType.TYPE_KINGNEUTRAL){
            return;
        }
        // 找点怪打打
        var list = Mgr.sceneObj.oRoundMonsterList.oHashList.aList;
        var boss,normal
        for(var v of list){
            if(!v.IsDeadState()){
                if( v.IsBoss() ){
                    boss = v;
                }else{
                    normal = v;
                }
            }
        }
        if(boss) {
            Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(Mgr.sceneMap.nMapId, boss.oServPt, AutoPathParam.CreateAutoFight());
        }else if(normal) {
            Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(Mgr.sceneMap.nMapId, normal.oServPt, AutoPathParam.CreateAutoFight());
        }
    },
});