var CreateRolePanelExt = CreateRolePanel.extend ( {
	_className:"CreateRolePanelExt",
    job:null,
    playerName:null,
    nextName:null,
    lastName:null,
    firstName:null,
    mode:null,
    buttonFirework:null,
    sexEffect:null,
    starList:null,
    flowerList:null,
    sunBg:null,
    sexImgB:null,
    sexImg:null,
    flowN:2,
    nameImg:null,
    textList:null,
    timerId:null,
	ctor:function(){
		this._super();
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.nextName=[];
        this.lastName=[];
        this.firstName=[];
        this.starList=[];
        this.flowerList=[];
        this.job=1;
	},
    Init:function (){
        var self =this;
        CreateRolePanel.prototype.Init.call( this );
        this.InitPosition();
        this.textList=[this.imgText1,this.imgText2,this.imgText3,this.imgText4];
        this.imgText1.py=this.imgText1.y;
        this.imgText2.py=this.imgText2.y;
        this.imgText3.py=this.imgText3.y;
        this.imgText4.py=this.imgText4.y;
        this.btnAdd.setVisible(false);
        this.labLevel.setVisible(false);
        this.btnDelete.setVisible(false);
        this.labTime.setVisible(false);
        this.btnLogin.setVisible(false);               //一个号只有一个角色

        //获取名字表
        this.GetNameList();
        //设置按钮回调
        self.edit1.setPlaceHolder("点击输入名字");
        self.edit1.setMaxLength(8);
        self.edit1.y-=5;
        this.sbtn1.SetButtonState(MUICheckBox.STATE_CHECK);
        self.btnBack.addClickEventListener(function(event){
            Mgr.uiMgr.HidePanelByType( CreateRolePanelExt.PanelName);
            Mgr.uiMgr.ShowPanelByType(DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
            Mgr.msgMgr.CloseSocket(false);  //返回选服界面要关闭当前socket
        });

        self.sbtn1.addClickEventListener(function(event){
            self.ButtonChose(1);
        });
        self.sbtn2.addClickEventListener(function(event){
            self.ButtonChose(2);
        });
        self.imgMan.setTouchEnabled(true);
        self.imgMan.addClickEventListener(function(event){
            self.ButtonChose(1);
        });
        self.imgGirl.setTouchEnabled(true);
        self.imgGirl.addClickEventListener(function(event){
            self.ButtonChose(2);
        });
        self.img1.setTouchEnabled(true);
        //开始按钮
        self.btnCreate.addTouchEventListener(function(event,type){
            switch (type){
                case 0:
                    self.btnEff.setScale(0.97);
                    break;
                case 2:
                    self.playerName=self.edit1.getString();
                    if( self.playerName.length<2){
                        Mgr.tips.ShowNotice( "名字长度不正确", 0, cc.p( 300, 300));
                        return;
                    }
                    //发送消息
                    self.btnEff.setScale(1);
                    Mgr.login.SendReqCreateCharacterMessage(self.job,self.playerName);
                    break;
                case 3:
                    self.btnEff.setScale(1);
                    break;
            }


        });
        //随机名字
        var RandomName = function(event){
            var firstNum =  Math.floor(Math.random()*self.firstName.length);
            var nextNum = Math.floor(Math.random()*self.nextName.length);
            var secondNum = Math.floor(Math.random()*self.lastName.length);
            self.playerName=self.firstName[firstNum]+self.nextName[nextNum]+self.lastName[secondNum];
            self.edit1.setString(self.playerName);
        };
        RandomName();
        self.btnChange.addClickEventListener(RandomName);

        this.buttonFirework=new cc.Sprite();
        this.buttonFirework.x=this.sbtn1.x+60;
        this.buttonFirework.y=this.sbtn1.y+60;
        this.addChild(this.buttonFirework);

        this.AddSexEffect();
        this.AddTextEffect();
    },
    //根据分辨率大小动态调整组件位置
    InitPosition:function(){
        var size = cc.winSize;
        this.x = ( size.width - this.width ) * 0.5;
        this.y = ( size.height - this.height ) * 0.5;
        this.sbtn1.x = this.sbtn1.initX - this.x;
        this.sbtn1.y = this.sbtn1.initY + this.y;
        this.sbtn2.x = this.sbtn2.initX - this.x;
        this.sbtn2.y = this.sbtn2.initY + this.y;
        this.imgLevel.x = this.imgLevel.initX - this.x;
        this.imgLevel.y = this.imgLevel.initY + this.y;
        this.btnAdd.x = this.btnAdd.initX - this.x;
        this.btnAdd.y = this.btnAdd.initY + this.y;
        this.btnBack.x = this.btnBack.initX - this.x;
        this.btnBack.y = this.btnBack.initY - this.y;
        this.imgAllText.x = this.imgAllText.initX + this.x;
        this.imgAllText.y = this.imgAllText.initY + this.y;
        this.btnDelete.x = this.btnDelete.initX + this.x;
        this.btnDelete.y = this.btnDelete.initY - this.y;
        this.btnCreate.x = this.btnCreate.initX + this.x;
        this.btnCreate.y = this.btnCreate.initY - this.y;
        this.btnLogin.x = this.btnLogin.initX + this.x;
        this.btnLogin.y = this.btnLogin.initY - this.y;
        this.labTime.x = this.labTime.initX + this.x;
        this.labTime.y = this.labTime.initY - this.y;
        this.img1.y = this.img1.initY - this.y;
        this.edit1.y = this.edit1.initY - this.y;
        this.btnChange.y = this.btnChange.initY - this.y;
    },
    AddSexEffect:function () {
        var eff=this.buttonFirework;
        var line1 = new cc.Sprite();
        var line2 = new cc.Sprite();
        var line3 = new cc.Sprite();

        var urlL="other/denglu/btn/line.png";
        EngineMgr.uiMgr.GetAsynResByUrl(urlL, function(bg1,bg2,bg3){
            bg1.initWithSpriteFrameName(urlL);
            bg2.initWithSpriteFrameName(urlL);
            bg3.initWithSpriteFrameName(urlL);
            bg1.y=40;
            bg1.x=-20;
            bg2.y=20;
            bg2.x=10;
            bg1.setScaleX(0.3);
            bg2.setScaleX(0.7);
            bg1.setScaleY(0.3);
            bg2.setScaleY(0.5);
            bg3.setScaleY(0.5);
        },this, line1,line2,line3);
        eff.addChild(line1);
        eff.addChild(line2);
        eff.addChild(line3);

        var loop1= new cc.Sprite();
        var urlB="other/denglu/btn/downbtn2.png";
        EngineMgr.uiMgr.GetAsynResByUrl(urlB, function(bg){
            bg.initWithSpriteFrameName(urlB);
        },this, loop1);
        eff.addChild(loop1);

        var loop= new cc.Sprite();
        var urlLoop="other/denglu/btn/lineround.png";
        EngineMgr.uiMgr.GetAsynResByUrl(urlLoop, function(pp){
            pp.initWithSpriteFrameName(urlLoop);
        },this, loop);
        loop.setScale(0.6);
        eff.addChild(loop);
        //这里加个空的放烟那些
        this.sunBg=new cc.Sprite();
        eff.addChild(this.sunBg);


        var sun= new cc.Sprite();
        var urlSun="other/denglu/btn/downbtn1.png";
        EngineMgr.uiMgr.GetAsynResByUrl(urlSun, function(bg){
            bg.initWithSpriteFrameName(urlSun);
        },this, sun);
        eff.addChild(sun);


        var sexB= new cc.Sprite();
        var sex= new cc.Sprite();
        var urlSe="other/denglu/btn/boy.png";
        EngineMgr.uiMgr.GetAsynResByUrl(urlSe, function(pp){
            pp.initWithSpriteFrameName(urlSe);
            pp.setOpacity(0);
        },this,sex);

        var urlSexB="other/denglu/btn/boy.png";
        EngineMgr.uiMgr.GetAsynResByUrl(urlSexB, function(pp){
            pp.initWithSpriteFrameName(urlSexB);
        },this,sexB);

        eff.addChild(sexB);
        eff.addChild(sex);
        this.sexImg=sex;
        this.sexImgB=sexB;

        var act1=cc.Spawn(cc.ScaleTo(0.5,1.5),cc.FadeOut(0.5));
        var act2=cc.ScaleTo(0,1);
        var act=cc.Sequence(cc.DelayTime(4),cc.FadeIn(0),act1,act2);
        sex.runAction(cc.repeatForever(act));
        var actLoop1=cc.Spawn(cc.ScaleTo(2,1),cc.FadeOut(2));
        var actLoop2=cc.ScaleTo(0,0.6);
        var actLoop=cc.Sequence(cc.DelayTime(6),cc.FadeIn(0),actLoop1,actLoop2);
        loop.runAction(cc.repeatForever(actLoop));
    },
    AddFlower:function () {
        var flower=this.flowerList.pop();
        if(!flower){
            flower=new Flower();
            flower.y=700 - this.y;
            flower.x=Math.random()*1334 - this.x;
            this.addChild(flower);
        }
       flower.StartMove(this.flowerList);
    },
    ButtonChose:function(num){
        var url="";
        var urlB="";
        var urlF="";
        switch(num){
            case 1:
                this.job=1;
                url="other/denglu/btn/boy.png";
                urlB="other/denglu/btn/boy.png";
                urlF="other/denglu/word/biwangchuan.png";
                this.buttonFirework.x=this.sbtn1.x+60;
                this.buttonFirework.y=this.sbtn1.y+60;
                this.imgMan.opacity = 255;
                this.imgGirl.opacity = 1;
                break;
            case 2:
                this.job=2;
                url="other/denglu/btn/girl.png";
                urlB="other/denglu/btn/girl.png";
                urlF="other/denglu/word/luohuangquan.png";
                this.buttonFirework.x=this.sbtn2.x+60;
                this.buttonFirework.y=this.sbtn2.y+60;
                this.imgMan.opacity = 1;
                this.imgGirl.opacity = 255;
                break;
        }
        EngineMgr.uiMgr.GetAsynResByUrl(url, function(pp){
            var texture = EngineMgr.uiMgr.GetResByUrl( url );
            pp.setSpriteFrame(texture);
            pp.setOpacity(0);
        },this, this.sexImg);

        EngineMgr.uiMgr.GetAsynResByUrl(urlB, function(pp){
            var texture = EngineMgr.uiMgr.GetResByUrl( urlB );
            pp.setSpriteFrame(texture);
        },this,this.sexImgB);

        EngineMgr.uiMgr.GetAsynResByUrl(urlF, function(pp1,pp2){
            pp1.setSpriteFrame(urlF);
            pp2.setSpriteFrame(urlF);
            // pp1.setAnchorPoint(0,0);
            // pp2.setAnchorPoint(0,0);
        },this, this.nameImg,this.nameEff);
        this.ShowTextEffect();
    },
	OnShow:function () {
    	this._super();
        Mgr.uiMgr.HidePanelByType( DengLuPanelExt.PanelName);
        this.InitPosition();
    	this.ShowTextEffect();

        this.timerId = TimerUtil.TimeUpdate(this.OnFrame,this,0.3);

        if(!this.modelMan){
            this.modelMan = new MAnimationObject();
            this.modelMan.x = 302;
            this.modelMan.y = 281;
            this.modelMan.sResUrlBase = "res/animation/effect/ui/create/5";
            this.modelMan.DoAction("stand5", 0, EnumDefaultResType.NONE);
            this.imgMan.addChild(this.modelMan);
        }

        if(!this.modelGirl){
            this.modelGirl = new MAnimationObject();
            this.modelGirl.x = 236;
            this.modelGirl.y = 434;
            this.modelGirl.sResUrlBase = "res/animation/effect/ui/create/6";
            this.modelGirl.DoAction("stand5", 0, EnumDefaultResType.NONE);
            this.imgGirl.addChild(this.modelGirl);
        }

        if(!this.riverEff){
            this.riverEff = new MAnimationObject();
            this.riverEff.x = 816;
            this.riverEff.y = 428;
            this.riverEff.sResUrlBase = "res/animation/effect/ui/create/7";
            this.riverEff.DoAction("stand5", 0, EnumDefaultResType.NONE);
            this.addChild(this.riverEff);
        }

        if(!this.btnEff){
            this.btnEff = new MAnimationObject();
            this.btnEff.x = 111;
            this.btnEff.y = 35;
            this.btnEff.sResUrlBase = "res/animation/effect/ui/create/8";
            this.btnEff.DoAction("stand5", 0, EnumDefaultResType.NONE);
            this.btnCreate.addChild(this.btnEff);
        }
    },
    OnHide:function () {
        if( this.modelMan ){
            this.modelMan.Dispose();
        }
        if( this.modelGirl ){
            this.modelGirl.Dispose();
        }
        if( this.riverEff ){
            this.riverEff.Dispose();
        }
        if( this.btnEff ){
            this.btnEff.Dispose();
        }
        this.modelMan = null;
        this.modelGirl = null;
        this.riverEff = null;
        this.btnEff = null;

        for(var i=0;i<this.flowerList.length;++i){
            this.flowerList[i].Dispose();
        }
        this.flowerList.length=0;
        TimerUtil.ClearTimeUpdate(this.timerId,this);
    },
    GetNameList:function(){
        var namelist=Q_role_random_name.GetList();

        for(var k in namelist)
        {
            var type=namelist[k].q_type;
            var value=namelist[k].q_value;
            if(type==2)
            {
                this.nextName.push(value);
            }
            else if(type==3)
            {
                this.lastName.push(value);
            }
            else
            {
                this.firstName.push(value);
            }
        }

    },
    RunSunEffect:function (node) {
        //先随机一个角度
        var angel=Math.ceil(360*Math.random());
        var toX=Math.sin(angel)*70;
        var toY=Math.cos(angel)*70;
        //颜色太淡 先移动一点在淡出
        var act1= cc.Sequence(cc.MoveBy(0,cc.p(toX*0.5,toY*0.5)),cc.Spawn(cc.MoveBy(3,cc.p(toX*0.5,toY*0.5)),cc.FadeOut(3)));
        var act2= cc.CallFunc(function (nn,ww) {
            nn.x=0;
            nn.y=0;
            nn.setOpacity(250);
            ww.starList.push(nn);
        },node,this);
        node.runAction(cc.Sequence(act1,act2));
    },
    AddTextEffect:function () {
        var text=new cc.Sprite();
        text.y= this.imgName.y + 128;
        text.x= this.imgName.x + 50;
        this.imgAllText.addChild(text);
        var clip=new cc.ClippingNode();
        clip.setInverted(false);
        clip.x=text.x;
        clip.y=text.y;
        clip.setAlphaThreshold(0.7);
        this.imgAllText.addChild(clip);
        this.imgName.removeFromParent();
        var pp=new cc.Sprite();
        var url="other/denglu/image/ray.png";
        EngineMgr.uiMgr.GetAsynResByUrl(url, function(pp1){
            pp1.initWithSpriteFrameName(url);
        },this, pp);

        var node = new cc.Node();
        var ss=new cc.Sprite();
        node.addChild(ss);
        clip.setStencil(node);
        clip.addChild(pp);
        pp.y=128;
        var act = cc.Sequence(cc.DelayTime(5),cc.MoveTo(4,cc.p(0,-266)),cc.DelayTime(1),cc.MoveTo(2,cc.p(0,128)));
        pp.runAction(cc.RepeatForever(act));

        var urlF="other/denglu/word/biwangchuan.png";
        EngineMgr.uiMgr.GetAsynResByUrl(urlF, function(pp1,pp2){
            pp1.initWithSpriteFrameName(urlF);
            pp2.initWithSpriteFrameName(urlF);
        },this, ss,text);
        this.imgMan.opacity = 255;
        this.imgGirl.opacity = 1;
        this.imgEyeB.opacity = this.imgGM.opacity = this.imgGA.opacity = 0;
        this.nameImg=text;
        this.nameEff=ss;
    },
    ShowTextEffect:function () {
        //this.blurN=20;
        //Filter.WinterBlur(this.nameImg);              //每次都要渲染一次
        //this.nameImg.getGLProgramState().setUniformFloat("blurRadius", this.blurN);
        this.nameImg.setOpacity(0);
        this.nameImg.stopAllActions();
        this.nameEff.setVisible(false);
        this.nameImg.setScaleY(1.5);
        for(var i=0;i<4;++i){
            this.textList[i].setOpacity(0);
            this.textList[i].stopAllActions();
            if(i%2==0){
                this.textList[i].y=this.textList[i].py+5;
            }else {
                this.textList[i].y=this.textList[i].py-5;
            }
        }
        var act= cc.CallFunc(this.ShowFadeText,0,[0,this]);
        this.nameImg.runAction(cc.Sequence(cc.Spawn(cc.FadeIn(0.5),cc.ScaleTo(0.5,1)),act));
    },
    ShowFadeText:function (tar,arg) {
        var index=arg[0];
        if(index>3){
            return;
        }
        var self=arg[1];
        self.nameEff.setVisible(true);
        if(index>3)
            return;
        var y=5;
        if(index%2==0){
            y=-5;
        }
        self.textList[index].runAction(cc.Sequence( cc.Spawn(cc.FadeIn(1),cc.MoveBy(1,cc.p(0,y))),cc.CallFunc(self.ShowFadeText,0,[++index,self] ) ));
    },
    OnFrame:function () {
        this.DoBlink(); //眨眼
        //星星
        var star=this.starList.pop();
        if(!star){
            star=new cc.Sprite();
            var urlSe="other/denglu/btn/star.png";
            EngineMgr.uiMgr.GetAsynResByUrl(urlSe, function(pp){
                pp.initWithSpriteFrameName(urlSe);
            },this, star);
            star.typeName="star";
            this.sunBg.addChild(star);
        }
        this.RunSunEffect(star);

        if(this.flowN==2){
            this.AddFlower();
            this.flowN=0;
        }
        this.flowN++;
    },

    DoBlink:function(){
        var time = TimerUtil.GetTimer();
        if( this.lastBlinkTime && time < this.lastBlinkTime )
            return;

        var fadeIn = cc.fadeIn(0.1);
        var fadeOut = cc.fadeOut(0.1);
        if( this.job == 1 ){
            var action = cc.sequence( fadeIn, fadeOut );
            this.imgEyeB.runAction(action);
        }
        else{
            var action = cc.sequence( fadeIn, fadeOut, fadeIn, fadeOut );
            this.imgGM.runAction(action);
            var action = cc.sequence( cc.delayTime(0.2), fadeIn, fadeOut );
            this.imgGA.runAction(action);
        }
        this.lastBlinkTime = time + ToolBase.RamdonRangeInt(2000, 5000);
    }
} );
CreateRolePanelExt.PanelName = "CreateRolePanelExt";
PanelClassDic["CreateRolePanelExt"] = CreateRolePanelExt;

var Flower=MAnimationObject.extend({
    ctor:function () {
        this._super();
        this.SetResUrlBase("res/animation/effect/ui/create/4");
        this.DoAction("stand5", 5, 0);
    },
    StartMove:function (list) {
        var size = cc.winSize;
        var toX=Math.random()*1334 - (size.width - 1650) * 0.5;
        var toY=Math.random()*500-100 - (size.height - 1000) * 0.5;       //这个线以下再消失
        this.x = toX-Math.random()*400;
        this.setScale(0.3+Math.random()*0.5);
        this.setOpacity(50+Math.random()*200);
        var speedTime = 2.5+Math.random()*2.5;
        this.runAction(cc.Sequence( cc.MoveTo(speedTime,toX,toY) ,cc.Spawn(cc.FadeOut(1),cc.MoveTo(1,toX + Math.random()*100,toY-(Math.abs(800-toY)*0.2))),cc.CallFunc(function (pp,list) {
            pp.y=700 - (size.height - 1000) * 0.5;
            list.push(pp);
        },this,list)));
    },
});


