var DengLuPanelExt = DengLuPanel.extend ( {
	_className:"DengLuPanelExt",
    severButton:null,
    currentProgress:0,
    totalProgress:1,
    loginTime:0,
	ctor:function(){
        this._super();
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.showLayerType = UIMgr.PANEL_LAYER_TOP;
        Mgr.login.loginPanel=this;
	},
    Init:function(){
        DengLuPanel.prototype.Init.call( this );
        this.imgJiaZai.visible = false;
        this.imgJiaZai1.visible = false;
        var self=this;
        self.editName.setPlaceHolder("");
        self.editPassward.setPlaceHolder("");
        this.setLocalZOrder(999);
        var ceshi=sys.localStorage.getItem("username");
        if(ceshi!=null)
        {
            self.editName.setString(ceshi);
        }

        self.btn1.addClickEventListener(function(event){
            var now = TimerUtil.GetTimer();
            if( now < self.loginTime )
                return;
            self.loginTime = now + 3000;
            GameConfig.current.USER_NAME = self.editName.getString();
            GameConfig.current.PASSWORD = self.editPassward.getString();
            var obj = {uid:"123465",nickname:GameConfig.current.USER_NAME,isLocalTest:true,countTime:15};
            var str = JSON.stringify(obj);
            //yaya.loginSDK(cc.MD5.GetMD5OfString(str));
            sys.localStorage.setItem("username", GameConfig.current.USER_NAME);
            sys.localStorage.setItem(( GameConfig.u8login ? GameConfig.u8login.sdkUserID : "" ) + "sever", GameConfig.current.SERVER_ID);
            EnterGameMgr.ConnectServer();
        });
        this.labLunTai.setTouchEnabled(true);
        this.labLunTai.addClickEventListener(function () {
            sys.openURL("www.37.com");
        });

        this.img2.setTouchEnabled(true);
        self.img2.addClickEventListener(function(event){
            var panel=Mgr.uiMgr.ShowPanelByType(ChooseServerPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
            panel.UpdateSever(GameConfig.serverList);
        });

        this.labSpeed1.EnableOutline();
        this.labBanBen.EnableOutline();
        this.labEngine.EnableOutline();
        this.labName.x = 70;
        this.labChange.x = 300;
    },
    ChangeSever:function (button,server) {
        this.OnCurrentServerChanged(server);
    },

    /// 检查GameConfig.current 并作对应的处理
    OnCurrentServerChanged:function(server){
        this.labName.SetString(server.NAME);

        GameConfig.current = server;
        ChannelUtil.OnGame_ServerSelected()

        var loginType = server.LOGIN_TYPE;

        switch(loginType){
            case EnumLoginType.App:
                this.imgPas.visible = false;
                this.imgUser.visible = false;
                break;
            default:
                this.imgPas.visible = true;
                this.imgUser.visible = true;
                break;
        }
    },

    ShowDeluUI:function () {
        this.imgJiaZai1.visible = false;
        this.imgJiaZai.visible = false;

        this.img2.visible = true;
        this.img3.visible = false;
        this.imgPas.visible = true;
        this.imgUser.visible = true;
        this.labBanBen.visible = true;
        this.labEngine.visible = true;
        this.btn1.visible = true;

        var list = GameConfig.serverList;
        if(list && list.length > 0){
            this.img2.visible = true;
            // this.img3.visible = true;
            this.imgPas.visible = true;
            this.imgUser.visible = true;
            this.labBanBen.visible = true;
            this.labEngine.visible = true;
            this.btn1.visible = true;

            var aSever = sys.localStorage.getItem( ( GameConfig.u8login ? GameConfig.u8login.sdkUserID : "" ) + "sever");
            var curServer = null;
            var list = GameConfig.serverList;

            var openTime = 0;
            var bestServer = null;
            for(var i=0;i<list.length;++i){
                var v = list[i];
                if(aSever == v.SERVER_ID){
                    curServer = v;
                    break;
                }
                if(v.OPEN_TIME >= openTime){
                    bestServer = v;
                    openTime = v.OPEN_TIME;
                }
            }
            // 选择默认
            curServer = curServer || bestServer || list[0];

            this.OnCurrentServerChanged(curServer);
        }else{
            this.img2.visible = false;
            this.imgPas.visible = false;
            this.imgUser.visible = false;
            this.labBanBen.visible = false;
            this.labEngine.visible = false;
            this.btn1.visible = false;
        }
    },

    ShowProgress:function ( total ) {
        this.imgJiaZai1.visible = true;

        this.img2.visible = false;
        this.img3.visible = false;
        this.imgJiaZai.visible = false;
        this.imgPas.visible = false;
        this.imgUser.visible = false;
        this.labBanBen.visible = false;
        this.labEngine.visible = false;
        this.btn1.visible = false;

        this.currentProgress = -1;
        this.totalProgress = total;
        this.SetProgress();
        this.virtualProgress = 0;
        this.progressTimeId = TimerUtil.TimeUpdate( this.ProgressUpdate, this );
    },
    OnShow:function () {
        this.InitPosition();
        UIUtil.ConnectLabelText( this.labBanBen, [projectVersion]);
        UIUtil.ConnectLabelText( this.labEngine, [GameConfig.engineVersion]);

        this.ShowDeluUI();
    },
    InitPosition:function(){
        this.labBanBen.x = this.labBanBen.initX - this.x;
        this.labBanBen.y = this.labBanBen.initY - this.y;
        this.labEngine.x = this.labEngine.initX - this.x;
        this.labEngine.y = this.labEngine.initY - this.y;
        this.img3.y = this.img3.initY - this.y;
        this.imgJiaZai1.y = this.imgJiaZai1.initY - this.y;
    },
    OnHide:function(){
        this._super();
        if( this.progressTimeId ){
            TimerUtil.ClearTimeUpdate( this.progressTimeId );
            this.progressTimeId = 0;
        }
    },
    SetProgress:function (value) {
        value = value || 1;
        this.currentProgress += value;
    },

    ProgressUpdate:function(){
        if( this.virtualProgress < this.currentProgress )
            this.virtualProgress += 0.18;
        else
            this.virtualProgress += 0.15;

        var percent = this.virtualProgress * 100 / this.totalProgress;
        percent = Math.min(percent, 100)
        this.prog1.setPercent( percent );
        UIUtil.ConnectLabelText(this.labNum1, [ percent.toFixed(2) ]);
    },

} );
DengLuPanelExt.PanelName = "DengLuPanelExt";
PanelClassDic["DengLuPanelExt"] = DengLuPanelExt;
