var BiaoBaiQiangFrameExt = (function(){
    var Cell = cc.TableViewCell.extend({
        ctor:function(){
            this._super();
        },
        SetData:function(){
            if(!this.container){
                let c = new BiaoBaiQiangList1Ext();
                c.LoadPanel();
                this.addChild(c)
                this.container = c
            }

            this.container.SetData.apply(this.container,arguments)
        },
    })

    return BiaoBaiQiangFrame.extend ( {
        _className:"BiaoBaiQiangFrameExt",
        ctor:function(){
            this._super();
        },
        Init:function(){
            this._super();
            this.setTouchEnabled(false);

            var size = this.imgContent1.getContentSize();
            size.height -= 130
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(ccui.ScrollView.DIR_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.reloadData();
            tableView.y = 124
            tableView.CellHeight = 130
            tableView.CellClass = Cell

            this.imgContent1.addChild(tableView);
            this.tableView = tableView;
//            imgModel
            /// 我的固定
            var c = new BiaoBaiQiangList1Ext();
            c.LoadPanel();
            c.y = -10
            this.imgContent1.addChild(c)
            this.$cellThis = c
        },
        OnShow:function(){
            this._super();
            GameEventMgr.AddEventListener(this,new ResConfessionRankingMessage().getId(),this.OnResConfessionRankingMessage.bind(this))

            this.OnTimer()
            this.$timer = TimerUtil.TimeUpdate(this.OnTimer, this, 1, cc.REPEAT_FOREVER);
        },
        OnHide:function(){
            this._super();
            GameEventMgr.RemoveEventListener(this);
            if(this.$timer) TimerUtil.ClearTimeUpdate(this.$timer);
        },
        OnTimer:function(){
            var describe = MarriageUtil.GetActivityTime()
            UIUtil.ConnectLabelHtmlText(this.labTime,[describe])
        },
        OnResConfessionRankingMessage:function(msg){
            this.ReloadTab(msg)
        },
        SetData:function(type){
            /// TODO 时装属性
            var disguiseId = 0
            var rankType = 0
            switch(type){
                case 4 : disguiseId = 103;rankType = 1;break;
                case 5 : disguiseId = 104;rankType = 2;break;
            }
            this.$rankType = rankType
            /// 拉取表白排行榜信息
            Mgr.marriage.SendReqConfessionRanking(rankType);

            var disguiseC = Q_disguise.Get(disguiseId);
            var resId = disguiseC.q_show
            if( !this._uiModel ){
                this._uiModel = new UIModel(resId);
                this.imgModel.addChild(this._uiModel);
            }
            else{
                this._uiModel.SetModelId(resId);
            }

            /// 战斗力
            var fightpower = Mgr.fightpower.GetFightPower(disguiseC.q_attribute)
            this.imglab1.SetText(fightpower)
        },
        ReloadTab:function(msg){
            /// 区分男女榜
            var size = this.imgContent1.getContentSize();
            if(this.$rankType == Mgr.player.mainPlayer.job){
                size.height -= 130
                this.$cellThis.visible = true
                this.$cellThis.SetData(msg.myRank,true)
                this.tableView.y = 124
            }else{
                size.height += 5
                this.$cellThis.visible = false
                this.tableView.y = -10
            }
            this.tableView.setViewSize(size)

            /// data
            this.tableView.CellData = msg.ranks
            this.tableView.reloadData()
        },
        tableCellSizeForIndex:function(sender,index){
            return cc.size(sender.width,sender.CellHeight);
        },
        tableCellAtIndex:function(sender,index){
            var cell = sender.dequeueCell();
            if (!cell) {
               cell = new sender.CellClass(sender.width,sender.CellHeight);
            }

            cell.SetData(sender.CellData[index]);
            return cell;
        },
        numberOfCellsInTableView:function(sender){
            return sender.CellData ? sender.CellData.length : 0;
        },
    } );
})()
BiaoBaiQiangFrameExt.PanelName = "BiaoBaiQiangFrameExt";
PanelClassDic["BiaoBaiQiangFrameExt"] = BiaoBaiQiangFrameExt;
