var HaoHuaExt = HaoHua.extend ( {
    _className:"HaoHuaExt",
    ctor:function(){
        this._super();
    },
    Init:function(){
        this._super();


        var globalC24 = Q_global.Get(20024)
        var allAw = JSON.parse(globalC24.q_string_value)
        allAw = allAw[2]

        let illAW = allAw.filter(v=>Mgr.illusion.GetIllusionByItemItem(v.mod))

        let awards = allAw.filter(v=>Mgr.disguise.GetDisguiseByItemItem(v.mod))
        awards.sort(function(a,b){ return a.job - b.job; });

        [this.imgNan,this.imgLv].forEach((v,k)=>{
            if(!v.uiModel){
                v.uiModel = new UIModel();
                v.addChild(v.uiModel);
            }
            v.uiModel.RemoveAll();

            let AW = awards[k]
            /// 光武
            if(illAW.length != 0){
                let illusionC = Mgr.illusion.GetIllusionByItemItem(illAW[0].mod)
                v.uiModel.AddWeapon(illusionC.q_show, AW.job);
            }

            let disguiseC = Mgr.disguise.GetDisguiseByItemItem(AW.mod)
            v.uiModel.SetModelId(disguiseC.q_show)
        })

        /// 战斗力
        var fightpower = 0
        allAw.forEach(v=>{
            if(v.job == null || v.job == 1){
                fightpower += ItemUtil.GetItemFightPower(v.mod)
            }
        })
        this.imglab1.SetText(fightpower)

        var item = ItemUtil.ItemIdToItem(50007);
        GridUtil.SetItemGrid(this.grid1,item);
    },
    OnShow:function(){
        this._super();
    },
    OnHide:function(){
        this._super();
    },
} );
HaoHuaExt.PanelName = "HaoHuaExt";
PanelClassDic["HaoHuaExt"] = HaoHuaExt;
