var XiJieLiangYuanFrameExt = XiJieLiangYuanFrame.extend ( {
    _className:"XiJieLiangYuanFrameExt",
    ctor:function(){
        this._super();
    },
    Init:function(){
        this._super();


        this.btn1.addClickEventListener(this.OnReqMarry.bind(this));
        this.btnBiaoBai.addClickEventListener(_=>{
            var p = EngineMgr.uiMgr.ShowPanelByType(BiaoBaiFrameExt.PanelName)
            if(p) p.SetCallback(this.OnChosen.bind(this),1)
        });

        this.typeArr = [ this.imgflagyellow,this.imgflagpink,this.imgflagviolet,]
        this.typeArr.forEach((v,k)=>{
            v.x += v.width / 2
            v.y += v.height / 2
            v.setAnchorPoint(cc.p(0.5,0.5))
            v.setTouchEnabled(true)

            v.addTouchEventListener(function(index,sender,type){
                if ( type == ccui.Widget.TOUCH_ENDED )
                {
                    this.OnTypeSelected(index,true)
                }
            }.bind(this,k));
        })

        //this.imgArr = [ this.imgxin, this.imgxin1, this.imgxin11,]
        this.imgArr = [ this.sbtnLv,this.sbtnOnline,this.sbtnMoney,]
        this.gridArr = [
            {
                labnum : this.labnum,
                grid : [ this.grid111 ],
                labFightpower : this.imglab1,
            },
            {
                labnum : this.labnum1,
                grid : [ this.grid11111,this.grid111111 ],
                labFightpower : this.imglab11,
            },
            {
                labnum : this.labnum11,
                grid : [ this.grid11111111,this.grid111111111 ],
                labFightpower : this.imglab111,
            },
        ]

        this.InitView()
    },
    InitView:function(){
        var globalC23 = Q_global.Get(20023)
        var globalC24 = Q_global.Get(20024)

        UIUtil.ConnectLabelHtmlText(this.lab1	,[globalC23.q_int_value])

        /// 奖励显示筛选==去重
        var awards = JSON.parse(globalC24.q_string_value)
        var sameAwards = []
        awards = awards.map((v,k)=>{
            /// 筛选job
            v = v.filter(vv=>{
                return vv.job == null || vv.job == Mgr.player.mainPlayer.job;
            })
            /// 筛选上次奖励已有的
            v = v.filter(vv=>sameAwards.indexOf(vv.mod) == -1)
            /// 缓存已存在的奖励
            v.forEach(vv=>{
                sameAwards.push(vv.mod)
            })

            return v;
        })

        var gold = []
        try{
            gold = JSON.parse(globalC23.q_string_value)
        }catch(e){}

        this.$level = globalC23.q_int_value
        this.$gold = gold
        var fightpower = 0;
        this.gridArr.forEach((v,k)=>{
            UIUtil.ConnectLabelHtmlText(v.labnum	,[gold[k]])
            /// 道具
            v.grid.forEach((vv,kk)=>{
                let item = ItemUtil.ItemConfigToItem(awards[k][kk]);
                GridUtil.SetItemGrid(vv,item);

                fightpower += ItemUtil.GetItemFightPower(item.itemModelId)
            })
            /// 战斗力
            v.labFightpower.SetText(fightpower)
        })
    },
    OnShow:function(){
        this._super();

        GameEventMgr.AddEventListener(this,new ResMarriagePanelMessage().getId(),_=>{
            EngineMgr.uiMgr.HidePanelByType(AfterMarriageMainExt.PanelName);
        })
        GameEventMgr.AddEventListener(this,new ResProposeValidSucMessage().getId(),_=>{
            EngineMgr.uiMgr.HidePanelByType(AfterMarriageMainExt.PanelName);
        })

        /// 界面调整
        var MI = Mgr.marriage.GetMarriageInfo()
        if(MI){
            /// 只能选取比现在在更高级的
            this.typeArr.forEach((v,k)=>{
                v.setTouchEnabled(k > MI.marriageType)
                if(k > MI.marriageType){
                    Filter.UnGray(v);
                }else{
                    Filter.GrayScale(v);
                }
            })

            var p = Mgr.friend.GetFriendById(MI.getTargetId())

            this.OnChosen(p)
            this.OnTypeSelected(MI.marriageType + 1)
            this.btnBiaoBai.setTouchEnabled(false)
        }else{
           this.typeArr.forEach((v,k)=>{
                v.setTouchEnabled(true)
                Filter.UnGray(v);
            })

            this.OnChosen()
            this.OnTypeSelected(0)
            this.btnBiaoBai.setTouchEnabled(true)
        }
    },
    OnHide:function(){
        this._super();

        GameEventMgr.RemoveEventListener(this);
    },
    OnChosen:function(data){
        this.$chosenTarget = data;

        UIUtil.LoadImage( this.imgHead1, ResUrl.GetSmallPlayerHeadUrl(Mgr.player.mainPlayer.job),false,true);
        UIUtil.ConnectLabelHtmlText(this.labName		,[Mgr.player.mainPlayer.name])

        if(data){
            this.imgHead11.visible = true
            this.labName1.visible = true

            UIUtil.LoadImage( this.imgHead11, ResUrl.GetSmallPlayerHeadUrl(data.icon),false,true);
            UIUtil.ConnectLabelHtmlText(this.labName1		,[data.name])
        }else{
            this.imgHead11.visible = false
            this.labName1.visible = false
        }

        this.UpdateCondition()
    },
    OnReqMarry:function(){
        if(!this.$chosenTarget){
            Mgr.tips.ShowNotice("请先选择个对象！");
            return
        }

        var config = [
            "结婚需要双方等级达到" + this.$level + "级!!!",
            "结婚时必须双方玩家在线!!!",
            "您的元宝不足!!",
        ]
        var index = this.imgArr.findIndex(v=>!v.$enabled)
        if(index != -1){
            Mgr.tips.ShowNotice(config[index]);
            return
        }

        var MI = Mgr.marriage.GetMarriageInfo()
        if(MI){
            Mgr.marriage.SendReqAgainProposeMessage(this.$chosenTarget.playerId,this.$index,0)
        }else{
            Mgr.marriage.SendReqProposeMessage(this.$chosenTarget.playerId,this.$index,0)
        }
    },
    OnTypeSelected:function(index,handle){
        this.$index = index;

        this.typeArr.forEach((v,k)=>{
            v.setScale((k == index) ? 1.1 : 1)
        })

        this.UpdateCondition()

        if(handle){
            let p = Mgr.uiMgr.ShowPanelByType(AfterMarriageMain2Ext.PanelName);
            p.ShowAfterMarriageView(index)
        }
    },
    /// 更新条件
    UpdateCondition:function(){
        this.imgArr.forEach((v,k)=>{
            var enabled = false
            switch(k){
                case 0:{
                    enabled = Mgr.player.mainPlayer.attributeData.level >= this.$level
                        && this.$chosenTarget
                        && (this.$chosenTarget.level >= this.$level)
                    break;
                }
                case 1:{
                    enabled = this.$chosenTarget && (this.$chosenTarget.state == 1)
                    break;
                }
                case 2:{
                    let bindMoney = ShopUtil.GetMoneyByShop(EnumShopType.BINDGOLD_SHOP);
                    let money = ShopUtil.GetMoneyByShop(EnumShopType.GOLD_SHOP);

                    enabled = bindMoney + money > this.$gold[this.$index]
                    break;
                }
            }

            v.$enabled = enabled;
            v.SetButtonState(enabled ? "check" : "uncheck")
            //UIUtil.LoadImage(v,
            //    enabled ? "other/marriageres/image/xijieliangyuan/redheart.png"
            //        : "other/marriageres/image/xijieliangyuan/grayheart.png"
            //    ,false,true);
        })
    },
} );
XiJieLiangYuanFrameExt.PanelName = "XiJieLiangYuanFrameExt";
PanelClassDic["XiJieLiangYuanFrameExt"] = XiJieLiangYuanFrameExt;
