var MarriageCongratulateExt = MarriageCongratulate.extend ( {
    _className:"MarriageCongratulateExt",
    ctor:function(){
        this._super();
        this.modelPanelType = 2
    },
    Init:function(){
        this._super();

        this.imgTianMi.visible = false

        this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));

        this.btnZhuFu.addClickEventListener(this.ReqZhufu.bind(this,1));
        this.btnFlower.addClickEventListener(this.ReqZhufu.bind(this,2));
    },
    OnShow:function(){
        this._super();
    },
    OnHide:function(){
        this._super();
    },
    ReqZhufu:function(opType){
        if(opType == 1){
            Mgr.marriage.SendReqMarriageZhuFuMessage(this.$data.marryId,opType)
            EngineMgr.uiMgr.HidePanel(this)
            return
        }

        var C = Q_global.Get(20029)

        var str = TextUtil.FormatStr("是否花费{@}元宝为{@}和{@}{@}？",[
            C ? C.q_int_value : 0
            , this.$data.playerName1
            , this.$data.playerName2
            , opType == 1 ? "送祝福" : "送花"

        ]);

        var self = this
        AlertExt.Show(str, TipsEnum.BUTTON_SURE_AND_FALSE, {
            _onFunc: function() {
                Mgr.marriage.SendReqMarriageZhuFuMessage(self.$data.marryId,opType)
                EngineMgr.uiMgr.HidePanel(self)
            }.bind(this),
            _offFunc: function() {}
        });
    },
    SetData:function(data){
        this.$data = data;

        UIUtil.ConnectLabelHtmlText(this.labGongXi,[data.playerName1,data.playerName2])
        UIUtil.LoadImage(this.imgHead, ResUrl.GetSmallPlayerHeadUrl(data.playerJob1),false,true);
        UIUtil.LoadImage(this.imgHead1, ResUrl.GetSmallPlayerHeadUrl(data.playerJob2),false,true);
    },
} );
MarriageCongratulateExt.PanelName = "MarriageCongratulateExt";
PanelClassDic["MarriageCongratulateExt"] = MarriageCongratulateExt;
