var MarriageresModMgr = MarriageresModMgr || cc.Class.extend({

	ctor:function() {
		this.reslineHash = new HashMap();
	},

    GetResInfoByType:function(type){
        return this.reslineHash.Get(type)
    },

	/**
	 *
	 * @param msg
	 * @constructor
	 */
	RecvResMarriageResInfoToClientMessage:function(msg) {
		this.reslineHash.Put(msg.marriageResInfo.marriageResType, msg.marriageResInfo);
		cc.log("收到资源线信息：" + JSON.stringify(msg.marriageResInfo));

        GameEventMgr.DispatchEvent(msg.getId())
	},

	/**
	 *
	 * @param msg
	 * @constructor
	 */
	RecvResMarriageResResultToClientMessage:function(msg) {
		cc.log("进阶结果: " + msg.marriageResType + "  " + msg.result);
        GameEventMgr.DispatchEvent(msg.getId(),msg)
	},

	/**
	 * 激活成功
	 * @param msg
	 * @constructor
	 */
	RecvResMarriageResAddResultToClientMessage:function(msg) {
		cc.log("激活成功: " + msg.marriageResType);
	},

	/**
	 * 请求结婚资源线信息
	 * @param type
	 * @constructor
	 */
	SendReqMarriageResInfoToGameMessage:function(type) {
		var msg = new ReqMarriageResInfoToGameMessage  ();
		msg.marriageResType = type;
		Mgr.msgMgr.Send(msg);

        //TimerUtil.SetTimeout(this,function(){
        //    var msg = new ResMarriageResInfoToClientMessage()
        //    msg.marriageResInfo = new MarriageResInfo()
        //    msg.marriageResInfo.marriageResType = type
        //    msg.marriageResInfo.level = 1
        //    msg.marriageResInfo.exp = 5000
        //    this.RecvResMarriageResInfoToClientMessage(msg)
        //},100)
	},

	/**
	 * 激活
	 * @param type
	 * @constructor
	 */
	SendReqMarriageResAddToGameMessage:function(type) {
		var msg = new ReqMarriageResAddToGameMessage ();
		msg.marriageResType = type;
		cc.log("??????111")
		Mgr.msgMgr.Send(msg);
	},

	/**
	 * 进阶
	 * @param type
	 * @constructor
	 */
	SendReqMarriageResUpToGameMessage:function(type,costType) {
		var msg = new ReqMarriageResUpToGameMessage();
		msg.marriageResType = type;
		msg.costType = costType;
		Mgr.msgMgr.Send(msg);
	}
});
var EnumMarryResline = EnumMarryResline || {};
EnumMarryResline.RING = 1;		//婚戒
EnumMarryResline.TALK = 2;		//表白
EnumMarryResline.MISS = 3;		//相思
EnumMarryResline.HALO = 4;		//光环