///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//135201,ReqEnterMaterial 前段请求进入物资争夺战
//135202,ReqMaterialPanel 请求物资争夺战面板信息

// 接收消息
//135101,ResMaterialZoneTrack 副本追踪面板
//135102,ResMaterialZoneResult 副本结束消息
//135103,ResMaterialPanel 返回物资争夺战面板信息


////////////////////
// 前段请求进入物资争夺战 //
////////////////////
var ReqEnterMaterialMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 135201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求物资争夺战面板信息 //
////////////////////
var ReqMaterialPanelMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 135202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 副本追踪面板 //
////////////////////
var ResMaterialZoneTrackMessage = cc.Class.extend( {
	ctor:function(){
		this.materialMonsterA = 0; // A组物资怪剩余
        this.materialMonsterB = 0; // B组物资怪剩余
	},

	getId:function(){
		return 135101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.materialMonsterA);
        _buf.WriteVarInt(this.materialMonsterB);
	},
	
	reading:function( _buf ){
        this.materialMonsterA = _buf.ReadVarInt();
        this.materialMonsterB = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.material.RecvResMaterialZoneTrackMessage(this);
	},

});
////////////////////
// 副本结束消息 //
////////////////////
var ResMaterialZoneResultMessage = cc.Class.extend( {
	ctor:function(){
		this.winner = 0; // 胜利方阵营
	},

	getId:function(){
		return 135102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.winner);
	},
	
	reading:function( _buf ){
        this.winner = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.material.RecvResMaterialZoneResultMessage(this);
	},

});
////////////////////
// 返回物资争夺战面板信息 //
////////////////////
var ResMaterialPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.guildName = null; // 胜利帮会名字
        this.bangzhuName = null; // 胜利帮主名字
	},

	getId:function(){
		return 135103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.guildName);
        _buf.WriteString(this.bangzhuName);
	},
	
	reading:function( _buf ){
        this.guildName = _buf.ReadString();
        this.bangzhuName = _buf.ReadString();
	},

	action:function(){
		Mgr.material.RecvResMaterialPanelMessage(this);
	},

});
// 接收消息注册
MESSAGE_POOL.Add(135101, ResMaterialZoneTrackMessage);
MESSAGE_POOL.Add(135102, ResMaterialZoneResultMessage);
MESSAGE_POOL.Add(135103, ResMaterialPanelMessage);

