///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//117201,ReqMeltingToGame 请求熔炼
//117202,ReqOpenMeltingToGame 请求打开淬炼面板

// 接收消息
//117101,ResMeltingInfoToClient 发送熔炼相关信息


////////////////////
// 发送熔炼相关信息 //
////////////////////
var ResMeltingInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.meltingLevel = 0; // 当前淬炼值
        this.meltingExp = 0; // 当前的熔炼经验
	},

	getId:function(){
		return 117101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.meltingLevel);
        _buf.WriteVarInt(this.meltingExp);
	},
	
	reading:function( _buf ){
        this.meltingLevel = _buf.ReadVarInt();
        this.meltingExp = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.melting.RecvResMeltingInfoToClientMessage(this);
	},

});
////////////////////
// 请求熔炼 //
////////////////////
var ReqMeltingToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.itemList = []; // 物品列表 long
	},

	getId:function(){
		return 117201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.itemList.length );
        for (var i = 0; i < this.itemList.length; i++) {
            _buf.WriteLong(this.itemList[i]);
        }
	},
	
	reading:function( _buf ){
        var itemList_length = _buf.ReadShort();
        for (var i = 0; i < itemList_length; i++) {
            this.itemList[i] = _buf.ReadLong();
        }
	},

});
////////////////////
// 请求打开淬炼面板 //
////////////////////
var ReqOpenMeltingToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 117202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(117101, ResMeltingInfoToClientMessage);

