var BossRollPanelExt = BossRollPanel.extend ( {
	_className:"BossRollPanelExt",
	ctor:function(){
		this._super();
	},

	Init:function(){
        BossRollPanel.prototype.Init.call( this );
        this.labNumber1.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
	},

	SetData:function(rollInfo){
		var self = this;
		this.uniqueId = rollInfo.uniqueId;

        var coinInfo = {};
        coinInfo.itemModelId = rollInfo.tempItemInfo.mod;
        coinInfo.itemNum = rollInfo.tempItemInfo.num;
        coinInfo.itemBind = rollInfo.tempItemInfo.isbind;
        GridUtil.SetItemGrid(this.gridAward,coinInfo);

        var info = Q_item.Get(rollInfo.tempItemInfo.mod);
        this.labGiftName.SetText(info.q_name);

		this.btnClose.addClickEventListener(function(event){
            if (self.timerId) TimerUtil.ClearTimeUpdate(self.timerId, self);
            Mgr.drop.SendReqRollPointMessage(self.uniqueId, 2);
            EngineMgr.uiMgr.HidePanel(self);
		});

        this.btnRoll.setTouchEnabled(true);
        this.btnRoll.addTouchEventListener(function(target,state)
        {
            if(state == ccui.Widget.TOUCH_ENDED)
            {
                if (self.timerId) TimerUtil.ClearTimeUpdate(self.timerId, self);
                Mgr.drop.SendReqRollPointMessage(self.uniqueId, 0);
                EngineMgr.uiMgr.HidePanel(self);
            }
        });

        this.btnOut.addClickEventListener(function(event){
            if (self.timerId) TimerUtil.ClearTimeUpdate(self.timerId, self);
            Mgr.drop.SendReqRollPointMessage(self.uniqueId, 2);
            EngineMgr.uiMgr.HidePanel(self);
        });

        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
        this.time = 10;
	},

    OnTimer:function(){
        this.time -= 1;
        if(this.time > 0){
            this.labNumber1.SetText(this.time);
            this.progJindutiao1.setPercent(this.time/10*100);
        }
        else{
            TimerUtil.ClearTimeUpdate(this.timerId, this);
            EngineMgr.uiMgr.HidePanel(this);
		}
    },
} );
BossRollPanelExt.PanelName = "BossRollPanelExt";
PanelClassDic["BossRollPanelExt"] = BossRollPanelExt;
