﻿var EquipPanelExt = EquipPanel.extend({
    _className: "EquipPanelExt",
    q_titleData: [],
    btnJinDan: null,
    subBtnArr: null,

    ctor: function () {
        this._super();
    },
    Init: function () {
        var self = this;
        EquipPanel.prototype.Init.call(this);
        this._SetLocalProperty();
        this._SetBaseProperty();
        this._HandleButton();
        this.ShowTouxianRedPoint();
        this.btnShuxing.visible = false;
        // this.gridEquip.InitGrid(GridTypeEnum.EQUIPWARED);
        // this.gridEquip2.InitGrid(GridTypeEnum.EQUIPWARED);
        // this.gridEquip3.InitGrid(GridTypeEnum.EQUIPWARED);
        // this.gridEquip4.InitGrid(GridTypeEnum.EQUIPWARED);
        // this.gridEquip5.InitGrid(GridTypeEnum.EQUIPWARED);
        // this.gridEquip6.InitGrid(GridTypeEnum.EQUIPWARED);
        // this.gridEquip7.InitGrid(GridTypeEnum.EQUIPWARED);
        // this.gridEquip8.InitGrid(GridTypeEnum.EQUIPWARED);
        // this.gridEquip9.InitGrid(GridTypeEnum.EQUIPWARED);
        // this.gridEquip10.InitGrid(GridTypeEnum.EQUIPWARED);
    },
    _SetLocalProperty: function () {
        this._gridEquipArr = [
            {obj: this.gridEquip,  type: EnumEquipPos.EQUIP_WEAPONS,    lab:this.labWuqi,},//武器0
            {obj: this.gridEquip2, type: EnumEquipPos.EQUIP_CLOTHES,    lab:this.labYifu,},//衣服1
            {obj: this.gridEquip3, type: EnumEquipPos.EQUIP_BRACELET_LEFT,      lab:this.labHushou ,},//护腿4
            {obj: this.gridEquip7, type: EnumEquipPos.EQUIP_HUFU_LEFT,  lab:this.labHufu,}, //左护符6
            {obj: this.gridEquip8, type: EnumEquipPos.EQUIP_RING_LEFT,  lab:this.labJiezhi,}, //左戒指8

            {obj: this.gridEquip4, type: EnumEquipPos.EQUIP_BELT,       lab:this.labToukui,},//头盔3
            {obj: this.gridEquip5, type: EnumEquipPos.EQUIP_SHOES,      lab:this.labXiezi,},//手镯2
            {obj: this.gridEquip6, type: EnumEquipPos.EQUIP_HUTUI,      lab:this.labHutui,}, //鞋子5
            {obj: this.gridEquip9, type: EnumEquipPos.EQUIP_HUFU_RIGHT, lab:this.labHufu1,}, //右护符7
            {obj: this.gridEquip10, type: EnumEquipPos.EQUIP_RING_RIGHT,lab:this.labJiezhi1,}, //右戒指9
            {obj: this.gridEquip11, type: EnumEquipPos.EQUIP_YITIAN,    lab:this.labYitian,}, //倚天
            {obj: this.gridEquip13, type: EnumEquipPos.EQUIP_TULONG,    lab:this.labTulong,}, //屠龙
            {obj: this.gridEquip12, type: EnumEquipPos.EQUIP_TAIJI,     lab:this.labTaiji,}, //太极
            {obj: this.gridEquip14, type: EnumEquipPos.EQUIP_QIANKUN,   lab:this.labQiankun,}, //乾坤
        ];
        var addFunc = function (nn) {
            nn.obj.InitGrid(GridTypeEnum.EQUIPWARED);
            nn.obj.setTouchEnabled(true);
            nn.obj.addClickEventListener(function (target) {
                if(!target.gridData){
                    return;
                }
                var gem = Mgr.gem.GetInlayStones(nn.type);
                var refine = DuanzaoUtil.GetRefineStoneHash(nn.obj.gridData.itemModelId);
                var equips = Mgr.equip.GetEquipsByType(EnumItemType.Equip);
                var suit = SuitMakeUtil.GetSuitAttr(equips);
                var panel = Mgr.uiMgr.ShowPanelByType(EquipTipsPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
                panel.setLocalZOrder(10000);
                panel.Updatedata(nn.obj.gridData, nn.obj.gridType, {gem: gem, refine: refine, suit: suit});
            })
        };
        for (var i = 0; i < this._gridEquipArr.length; ++i) {
            addFunc(this._gridEquipArr[i]);
        }

    },
    _HandleButton: function () {
        var self = this;

        this.btnVip.setTitleText("神兵");
        //神兵按钮
        this.btnVip.addClickEventListener(function (target) {
            // self._ShowChangeNamePanel();
            var isOpen = BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_ROLE, BtnGroupUtil.ROLE_SHNEBING);
            if(isOpen){
                var panel =  Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName)
                panel.ChangePage(-2);
                panel.imgTitleSt.visible = false;
            }
        });
        //称号按钮
        this.btnVip1.addClickEventListener(function (target) {
            self._ShowChenghaoPanel();
        });
        //头衔按钮
        this.btnTouXian.addClickEventListener(function (target) {
            self._ShowTouxianPanel();
        });
        //金丹
        this.btnTouXian1.addClickEventListener(function (taarget) {
            self._ShowJinDanPanel();
        });
        this.btnShuxing.setTitleText("装备获取");
        this.btnShuxing.addClickEventListener(function (event) {
            self.ShowShuxingCue();
        });
    },
    UpdateInfo: function () {
        this._InitMyPlayerInfo();
        this._AddEquipIco();
        this.ShowChengHaoRedPoint();
        this.ShowTouxianRedPoint();
        this.ShowJinDanRedPoint();
        //神兵红点
        this.img11.visible = Mgr.godarm.IsEnableUp()
    },
    _AddEquipIco: function () {
        var equips = Mgr.equip.GetEquips();
        for (var i = 0; i < this._gridEquipArr.length; i++) {
            this._gridEquipArr[i].obj.gridData = null;
            this._gridEquipArr[i].obj.Clean();
            this._gridEquipArr[i].lab.visible = true;
            for (var j = 0; j < equips.length; j++) {
                if (this._gridEquipArr[i].type == equips[j].typeObj.q_kind) {
                    var item = equips[j].item;
                    GridUtil.SetItemGrid(this._gridEquipArr[i].obj, item, item.itemModelId, false, null, false, false, false, false, null, true);
                    this._gridEquipArr[i].lab.visible = false;
                    break;
                }
            }
        }
    },
    //初始化玩家基本信息
    _InitMyPlayerInfo: function (data) {
        var info02 = Mgr.player.mainPlayer.attributeData;
        this.labName.SetString(Mgr.player.mainPlayer.name);
        this.labNumber.SetString(Mgr.fightpower.fightPower);
        this.labAttack.SetString(info02.GetAttribute(EnumAttribute.ATTACK, AttributeData.Fight));//攻击
        this.labDef.SetString(info02.GetAttribute(EnumAttribute.DEFEND, AttributeData.Fight));//防御
        this.labHp.SetString(info02.GetAttribute(EnumAttribute.MAX_BASEHP, AttributeData.Fight));//生命

        var c = info02.GetAttribute(EnumAttribute.CRIT, AttributeData.Fight);
        var cb = info02.GetAttribute(EnumAttribute.CRIT_DAMAGE_BONUS, AttributeData.Fight);
        var db = info02.GetAttribute(EnumAttribute.DAMAGE_BONUS, AttributeData.Fight);
        var dr = info02.GetAttribute(EnumAttribute.DAMAGE_REDUCE, AttributeData.Fight);
        this.labBaoji_Value.SetString(c);//暴击值
        this.labBaoji1_Value.SetString((cb / 100).toFixed(2) + "%");//暴击伤害
        this.labJiacheng_Value.SetString((db / 100).toFixed(2) + "%");//伤害加成
        this.labJianmian_Value1.SetString((dr / 100).toFixed(2) + "%");//伤害减免
    },
    AddPlayerModule: function () {
        var info = Mgr.player.mainPlayer;
        this._playerModel = new UIModel(SceneObjUtil.GetBodyIdByInfo(info));
        for( var i = 0; i < info.playerResLineInfo.length; i++ ){
            var resline = info.playerResLineInfo[i];
            if( resline.type == EnumResline.GUANGWU ){
                this._playerModel.AddWeapon(SceneObjUtil.GetGodWeaponResId(info.showIllusionInfo, true) || resline.modelid, info.job);
                break;
            }
        }
        this.imgModel.addChild(this._playerModel);
    },
    _SetBaseProperty: function () {
        var color01 = EnumFontFormat.COMMON_COLOR02, fontsize01 = EnumFontFormat.FONTSIZE_NORMAL;
        this.labName.SetColor(color01);
        this.labName.SetFontSize(fontsize01);
        this.labZhandouli.SetColor(color01);
        this.labZhandouli.SetFontSize(fontsize01);
        this.labGongji.SetColor(color01);
        this.labGongji.SetFontSize(fontsize01);
        this.labGongji.x = this.labZhandouli.x;
        this.labFangyu.SetColor(color01);
        this.labFangyu.SetFontSize(fontsize01);
        this.labFangyu.x = this.labZhandouli.x;
        this.labShengming.SetColor(color01);
        this.labShengming.SetFontSize(fontsize01);
        this.labShengming.x = this.labZhandouli.x;
        this.labCue.SetColor(color01);
        this.labCue.SetFontSize(fontsize01);
        this.labCue.setPosition(this.imgFrame1.width - this.labCue.width >> 1, -1);
        this.labCue1.SetColor(color01);
        this.labCue1.SetFontSize(fontsize01);
        this.labCue1.setPosition(this.imgFrame11.width - this.labCue1.width >> 1, -1);
        this.labBaoji.SetColor(color01);
        this.labBaoji.SetFontSize(fontsize01);
        this.labBaoji.x = this.labZhandouli.x;
        this.labBaoji1.SetColor(color01);
        this.labBaoji1.SetFontSize(fontsize01);
        this.labBaoji1.x = this.labZhandouli.x;
        this.labJiacheng.SetColor(color01);
        this.labJiacheng.SetFontSize(fontsize01);
        this.labJiacheng.x = this.labZhandouli.x;
        this.labJianmian.SetColor(color01);
        this.labJianmian.SetFontSize(fontsize01);
        this.labJianmian.x = this.labZhandouli.x;
        this.btnVip.setTitleFontSize(EnumFontFormat.FONTSIZE_BUTTON);
        this.btnVip.setTitleColor(UIUtil.GetCCColor(color01));
        this.btnVip1.setTitleFontSize(EnumFontFormat.FONTSIZE_BUTTON);
        this.btnVip1.setTitleColor(UIUtil.GetCCColor(color01));
        this.btnTouXian.setTitleFontSize(EnumFontFormat.FONTSIZE_BUTTON);
        this.btnTouXian.setTitleColor(UIUtil.GetCCColor(color01));

        var color02 = "0x853d07", fontsize02 = EnumFontFormat.FONTSIZE_NORMAL;
        this.labNumber.SetColor(color02);
        this.labNumber.SetFontSize(fontsize02);
        this.labAttack.SetColor(color02);
        this.labAttack.SetFontSize(fontsize02);
        this.labAttack.x = this.labNumber.x;
        this.labDef.SetColor(color02);
        this.labDef.SetFontSize(fontsize02);
        this.labDef.x = this.labNumber.x;
        this.labHp.SetColor(color02);
        this.labHp.SetFontSize(fontsize02);
        this.labHp.x = this.labNumber.x;
        this.labBaoji_Value.SetColor(color02);
        this.labBaoji_Value.SetFontSize(fontsize02);
        this.labBaoji_Value.x = this.labNumber.x;
        this.labBaoji1_Value.SetColor(color02);
        this.labBaoji1_Value.SetFontSize(fontsize02);
        this.labBaoji1_Value.x = this.labNumber.x;
        this.labJiacheng_Value.SetColor(color02);
        this.labJiacheng_Value.SetFontSize(fontsize02);
        this.labJiacheng_Value.x = this.labNumber.x;
        this.labJianmian_Value1.SetColor(color02);
        this.labJianmian_Value1.SetFontSize(fontsize02);
        this.labJianmian_Value1.x = this.labNumber.x;
        this.btnShuxing.setTitleFontSize(EnumFontFormat.FONTSIZE_BUTTON);
        this.btnShuxing.setTitleColor(UIUtil.GetCCColor(EnumFontFormat.COMMON_COLOR01));
    },
    ShowShuxingCue: function () {
        EngineMgr.uiMgr.ShowPanelByType(EquipGetExt.PanelName, UIMgr.PANEL_LAYER_TOP);
    },
    _ShowChangeNamePanel: function () {
        Mgr.player.SendReqPlayerChangeNameTimeMessage();
    },
    _ShowChenghaoPanel: function () {
        EngineMgr.uiMgr.ShowPanelByType(ChengHaoPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
    },
    _ShowTouxianPanel: function () {
        EngineMgr.uiMgr.ShowPanelByType(TouXianPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
    },

    _ShowJinDanPanel: function () {
        EngineMgr.uiMgr.ShowPanelByType(ShuXingDanMainExt.PanelName);
    },
    ShowChengHaoRedPoint: function () {
        var isShow = Mgr.title.RefreshTitleMgrArr();
        this.img1.visible = isShow;
    },
    ShowTouxianRedPoint: function (data) {
        this._data = data;
        var isShow = Mgr.title.ShowTouxianRedPoint(data);
        this.img2.visible = isShow;
    },
    ShowJinDanRedPoint:function () {
        this.img3.visible = false;
        var data = JSON.parse(Q_global.Get(1190).q_string_value);
        var hold = Mgr.backpack.backpackVO.GetItemInfoHash().Values();
        var used = Mgr.player.mainPlayer.attrItem;
        var holdItemsInfo = new HashMap();
        var usedItemsInfo = new HashMap();

        for(var i = 0; i < data.length; i++){
            var info = data[i];
            var totalCount = 0;
            var curItem = null;
            for(var j = 0, len = hold.length; j < len; j++){
                var item = hold[j];
                if(info[0] == item.itemModelId){
                    totalCount += item.itemNum;
                    curItem = item;
                }
            }
            holdItemsInfo.Put(info[0], [totalCount, curItem]);
        }

        for(var i = 0; i< data.length; i++){
            var usednum = 0;
            var holdnum = holdItemsInfo.Get(data[i][0])[0];
            for(var j = 0; j < used.length; j++){
                var item = used[j];
                if(item.itemModelId == data[i][0]){
                    usednum = item.itemNum;
                }
            }
            usedItemsInfo.Put(data[i][0], [usednum, holdnum]);
        }

        var level = Mgr.mainPlayer.attributeData._GetLevel();
        for(var i = 0, len = data.length; i < len; i++) {
            var info = data[i];
            var base = Q_item.Get(info[0]).q_item_limit;
            var maxLimit = 0;
            if (level > info[1]) {
                maxLimit = base + info[2] * (level - info[1]);
            } else {
                maxLimit = base;
            }

            var usedNum = usedItemsInfo.Get(info[0])[0];
            var holdNum = holdItemsInfo.Get(info[0])[0];
            var need = maxLimit - usedNum;
            var canUse = 0;
            if (need > holdNum) {
                canUse = holdNum;
            } else {
                canUse = need;
            }
            if(canUse > 0){
                this.img3.visible = true;
                break;
            }
        }

    },
    OnShow: function () {
        this.UpdateInfo();
        this.AddPlayerModule();
        Mgr.title.SendReqHeadTitleInfoMessage();
    },
    OnHide: function () {
        if( this._playerModel )
            this._playerModel.Dispose();
        this._playerModel = null;
    }
});
EquipPanelExt.PanelName = "EquipPanelExt";
PanelClassDic["EquipPanelExt"] = EquipPanelExt;














