var JiNengShengJiExt = JiNengShengJi.extend ( {
	_className:"JiNengShengJiExt",
	_skillMid:null,
    _skillLv:null,
	ctor:function(){
		this._super();
	},

	Init:function () {
		JiNengShengJi.prototype.Init.call(this);

		this.labZuo.SetFontSize(20);
		this.labYou.SetFontSize(20);
		var self = this;
		this.btnClose.addClickEventListener(function () {
			Mgr.uiMgr.HidePanel(self);
        });

		this.btn1.addClickEventListener(function (target) {
			if(!target.needInfo || Mgr.backpack.GetItemNumber(target.needInfo[1].q_item) < target.needInfo[1].q_item_num){
				Mgr.tips.ShowNotice("所需道具不足");
				return;
			}
			Mgr.resline.SendReqReslineSkillUpByModelidToGameMessage(target.needInfo[0].skillParameter.reslinetype, target.needInfo[0].skillmid, 1);
        });
    },

    SetData:function (info) {
		this._skillMid = info.skillmid;
		this._skillLv = info.skilllv;
		var curGradeId = info.skillmid + "_" + info.skilllv;
		var nextGradeId = info.skillmid + "_" + (info.skilllv + 1);
        var curModel = Q_skill_model.Get(curGradeId);
        var nextModel = Q_skill_model.Get(nextGradeId);
        var needInfo = Q_resline_skills.Get(curGradeId);
        var needModel = Q_item.Get(needInfo.q_item);
        var needNum = needInfo.q_item_num;

        var html = Q_skill_public.Get(info.skillmid).q_desc;
		var curStr = TextUtil.FormatStr(html, this.HandleStr(curModel.q_introduce));
		var nextStr = TextUtil.FormatStr(html, this.HandleStr(nextModel.q_introduce));

		this.lab1.SetHtmlText(TextUtil.FormatStr(this.lab1.GetHtmlText(), [curModel.q_skillName, info.skilllv]));
        this.lab2.SetHtmlText(TextUtil.FormatStr(this.lab2.GetHtmlText(), [nextModel.q_skillName, info.skilllv + 1]));

        if(Mgr.backpack.GetItemNumber(needInfo.q_item) < needInfo.q_item_num){
            this.labCue1.SetString(TextUtil.AddColor(needModel.q_name + "x" + needNum, ColorUtil.SYS_RED));
		}else {
            this.labCue1.SetString(TextUtil.AddColor(needModel.q_name + "x" + needNum, ColorUtil.SYS_GREEN));
		}

		this.labZuo.SetHtmlText(curStr);
		this.labYou.SetHtmlText(nextStr);
		this.btn1.needInfo = [info, needInfo];

		GridUtil.SetSkillGridByMID(GridInteractionType.RESLINESKILLSHOW, this.grid1, this._skillMid, this._skillLv);
        GridUtil.SetSkillGridByMID(GridInteractionType.RESLINESKILLSHOW, this.grid2, this._skillMid, this._skillLv + 1);
    },

	HandleStr:function (str) {
        str = str.replace("[", "");
        str = str.replace("]", "");
        str = str.replace("{", "");
        str = str.replace("}", "");
        str = str.split(",");
        return str;
    },
} );
JiNengShengJiExt.PanelName = "JiNengShengJiExt";
PanelClassDic["JiNengShengJiExt"] = JiNengShengJiExt;
