var ShuXingDanGridExt = ShuXingDanGrid.extend ( {
	_className:"ShuXingDanGridExt",
	ctor:function(){
		this._super();
	},

	Init:function () {
		ShuXingDanGrid.prototype.Init.call(this);
    },

	SetData:function (data, usednum, holdnum) {
        holdnum = holdnum || 0;
        var level = Mgr.mainPlayer.attributeData._GetLevel();
        var base = Q_item.Get(data[0]).q_item_limit;
        var maxLimit = 0;
        if(level > data[1]){
            maxLimit = base + data[2] * (level - data[1]);
        }else {
            maxLimit = base;
        }
		var itemInfo = Q_item_simpact.Get(data[0]);
        var attribute = itemInfo.q_attribute;
        if(attribute){
            var attributeArr = this.GetAttribute(attribute,usednum);
            this.labCue2.SetText(TextUtil.FormatStr(this.labCue2.GetHtmlText(), attributeArr));
        }else {
            attribute = itemInfo.q_attributeRatios;
            var arr = this.GetAttributeRatios(attribute,usednum);
            this.labCue2.SetText(TextUtil.FormatStr(this.labCue2.GetHtmlText(), arr));
        }
        var item = ItemUtil.ItemIdToItem(data[0]);
        GridUtil.SetItemGrid(this.gridItem, item);
		this.labCue.SetText(TextUtil.FormatStr(this.labCue.GetHtmlText(), [usednum + "/" + maxLimit]));
        this.labCue1.SetText(TextUtil.FormatStr(this.labCue1.GetHtmlText(), [holdnum]));
        this.info = [holdnum, usednum, maxLimit, data];
    },

	GetAttribute:function (attribute,usednum) {
		if(!attribute){
			return [,]
		}
        var str = ParseUtil.FormatFastJsonStr(attribute);
        var jsonData = JSON.parse(str);
        var array = [];
        for ( var keyStr in jsonData )
        {
            array.push( [parseInt(keyStr), parseInt(jsonData[keyStr])] );
        }

        if ( array[0][0] == EnumAttribute.MAX_BASEHP ) {
            str = "气血：";
        }
        else if ( array[0][0] == EnumAttribute.ATTACK ){
            str = "攻击：";
        }
        else if ( array[0][0] == EnumAttribute.DEFEND ) {
            str = "防御：";
        }
        else if ( array[0][0] == EnumAttribute.HIT ) {
            str = "命中：";
        }
        else if ( array[0][0] == EnumAttribute.DODGE ) {
            str = "闪避：";
        }
        else if ( array[0][0] == EnumAttribute.CRIT ) {
            str = "暴击：";
        }
        else if ( array[0][0] == EnumAttribute.ANTI_CRIT ) {
            str = "抗暴击：";
        }

        return [str, array[0][1] * usednum];
    },
    
    GetAttributeRatios:function (attribute,usednum) {
        if(!attribute){
            return[,]
        }
        var data = ParseUtil.DecodAttribute(attribute);
        var num = (data[0].value / 100 * usednum) + "%";
        var str;
        if ( data[0].type == EnumAttribute.MAX_BASEHP ) {
            str = "基础气血：";
        }
        else if ( data[0].type == EnumAttribute.ATTACK ){
            str = "基础攻击：";
        }
        else if ( data[0].type == EnumAttribute.DEFEND ) {
            str = "基础防御：";
        }
        else if ( data[0].type == EnumAttribute.HIT ) {
            str = "基础命中：";
        }
        else if ( data[0].type == EnumAttribute.DODGE ) {
            str = "基础闪避：";
        }
        else if ( data[0].type == EnumAttribute.CRIT ) {
            str = "基础暴击：";
        }
        else if ( data[0].type == EnumAttribute.ANTI_CRIT ) {
            str = "基础抗暴击：";
        }
        return [str, num];
    },
} );
ShuXingDanGridExt.PanelName = "ShuXingDanGridExt";
PanelClassDic["ShuXingDanGridExt"] = ShuXingDanGridExt;
