var SkillTipsExt = SkillTips.extend ( {
	_className:"SkillTipsExt",

    labelHeight:null,
    ctor:function(){
        this._super();
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.modelPanelType = MUIPanelModelType.ALPHABLACK;
        this.isClosePanel = true;
        this.retain();
    },

    Init:function(){
        this._super();

        var self = this;
        this.labelHeight = parseInt(this.labCue.uiHeight);
        this.labCue.uiHeight = null;
        this.btnClose.addClickEventListener( function(e){
            Mgr.uiMgr.HidePanel( self );
        } );
    },

    Updatedata:function ( skillVo, type ) {
        if ( skillVo == undefined )
        {
            ToolBase.LogError("SkillTipsExt:ERROR_skillVo");
            return;
        }
        var skillmid = skillVo.skillmid?skillVo.skillmid:0;//技能mid
        if ( skillmid == 0 )
        {
            ToolBase.LogError("SkillTipsExt:ERROR_MID");
            return;
        }
        var skilllv = skillVo.skilllv?skillVo.skilllv:0;//技能等级
        var skillmodelid = skillmid + "_" + ( skilllv>0?skilllv:1 );
        var q_skill = Q_skill_model.Get( skillmodelid );
        var q_skillpublic = Q_skill_public.Get( skillmid );
        if ( q_skill == null || q_skillpublic == null )
        {
            var str1 = q_skill==null?"q_skillmodel":"";
            var str2 = q_skillpublic==null?"q_skillpublic":"";
            cc.log("SkillTipsExt 配置的技能ID:" + skillmid + " 不存在：" + str1 + str2);
            return;
        }

        GridUtil.SetSkillGridByMID( GridInteractionType.RESLINESKILLSHOW,this.gridIcon, skillmid, skilllv );
        this.gridIcon.setTouchEnabled(false);
        // var img = SkillUtil.GetSkillIcon( skillmid  );
        // // img.x = 10;
        // // img.y = 10;
        // this.gridIcon.SetGridIcon( img );

        this.labName.SetText( q_skill.q_skillName );
        //UIUtil.ConnectLabelHtmlText( this.labZhanli,[ q_skill.q_fight_bonus ] );
        this.labCue.SetText(UIUtil._ConectParam( q_skillpublic.q_desc, TextUtil.StringToArray(q_skill.q_introduce) ));
        this.labCue.y = this.imgXian.y - this.labSkillCue.uiHeight - this.labCue.GetHeight();
        this.imgXian1.y = this.imgXian.y - this.labSkillCue.uiHeight - this.labCue.GetHeight() - 5;
        this.labCue1.y = this.imgXian.y - this.labSkillCue.uiHeight - this.labCue.GetHeight() -  this.labCue1.uiHeight - 8;
        // this.setSize(this.uiWidth, );

        if ( skilllv > 0 ) {
            // this.labCue1.SetColor("0x7dff4f")
            this.labCue1.SetText("已激活");
        } else {
            this.labCue1.SetText("未激活");
        }

        if ( type == GridInteractionType.RESLINESKILLSHOW ) {
            var skillParameter = skillVo.skillParameter;
            if ( !skillParameter )
            {
                ToolBase.LogError("SkillTipsExt:ERROR_skillParameter");
                return;
            }

            var reslinetype = skillParameter.reslinetype;//类型
            var layer = skillParameter.reslinelayer>0?skillParameter.reslinelayer:1;//阶数容错1
            var q_id = reslinetype + "_" + layer;

            if ( skilllv <= 0 ) {
                var reslinename = Mgr.resline.GetNameByType( reslinetype );
                // this.labCue1.SetColor("0x7dff4f");
                this.labCue1.SetHtmlText(UIUtil._ConectParam("{@}进阶到{@}阶开启", [ reslinename, layer ]));
            }
        }
    }
})

SkillTipsExt.PanelName = "SkillTipsExt";
PanelClassDic["SkillTipsExt"] = SkillTipsExt;
