///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//204202,ReqExchangeGodEquip 请求兑换神装
//204203,ReqComposeGodEquip 请求合成神装
//204205,ReqStrengthen 请求强化装备
//204206,ReqMagicGodEquip 请求魔化神装(1魔化 2附魔)
//204207,ReqUprReincarnateEquip 请求升级转生装备
//204208,ReqDismantlrReincarnateEquip 请求分解转生装备
//204209,ReqUpOrDismantlrEquip 请求升级或分解装备

// 接收消息
//204102,ResStrengthenResult 强化装备结果


////////////////////
// 强化装备结果 //
////////////////////
var ResStrengthenResultMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 操作类型(0 强化 1继承 2....6是万能强化)
        this.suc = 0; // 0不成功 1成功
        this.itemInfo = null; // 成功后变动物品你信息
	},

	getId:function(){
		return 204102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteByte(this.suc);
        _buf.WriteBean(this.itemInfo);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.suc = _buf.ReadByte();
        this.itemInfo = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.refining.RecvResStrengthenResultMessage(this);
	},

});
////////////////////
// 请求兑换神装 //
////////////////////
var ReqExchangeGodEquipMessage = cc.Class.extend( {
	ctor:function(){
		this.itemModel = 0; // 物品model
	},

	getId:function(){
		return 204202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.itemModel);
	},
	
	reading:function( _buf ){
        this.itemModel = _buf.ReadVarInt();
	},

});
////////////////////
// 请求合成神装 //
////////////////////
var ReqComposeGodEquipMessage = cc.Class.extend( {
	ctor:function(){
		this.handleType = 0; // 0普通合成(后端自己检测) 1装备合成装备(手动放置)
        this.itemModel = 0; // 物品model
        this.num = 0; // 个数
        this.itemIdList = []; // 玩家指定消耗物品的唯一id列表 long
	},

	getId:function(){
		return 204203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.handleType);
        _buf.WriteVarInt(this.itemModel);
        _buf.WriteVarInt(this.num);
        _buf.WriteUShort( this.itemIdList.length );
        for (var i = 0; i < this.itemIdList.length; i++) {
            _buf.WriteLong(this.itemIdList[i]);
        }
	},
	
	reading:function( _buf ){
        this.handleType = _buf.ReadByte();
        this.itemModel = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        var itemIdList_length = _buf.ReadUShort();
        for (var i = 0; i < itemIdList_length; i++) {
            this.itemIdList[i] = _buf.ReadLong();
        }
	},

});
////////////////////
// 请求强化装备 //
////////////////////
var ReqStrengthenMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品唯一Id
        this.isAuto = 0; // 是否自动(0 否 1是)
        this.type = 0; // 装备类型(0人 1坐骑 2美人)
	},

	getId:function(){
		return 204205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteByte(this.isAuto);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.isAuto = _buf.ReadByte();
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 请求魔化神装(1魔化 2附魔) //
////////////////////
var ReqMagicGodEquipMessage = cc.Class.extend( {
	ctor:function(){
		this.magicType = 0; // 魔化类型：1魔化 2附魔
        this.needItem = null; // 材料
        this.magicItemLocation = 0; // 要魔化（附魔）的物品位置(0包包里  1人身上 2坐骑 3美人)
        this.magicItem = null; // 要魔化（附魔）的物品
        this.opType = 0; // 操作类型：1魔化 2附魔
	},

	getId:function(){
		return 204206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.magicType);
        _buf.WriteLong(this.needItem);
        _buf.WriteByte(this.magicItemLocation);
        _buf.WriteLong(this.magicItem);
        _buf.WriteByte(this.opType);
	},
	
	reading:function( _buf ){
        this.magicType = _buf.ReadByte();
        this.needItem = _buf.ReadLong();
        this.magicItemLocation = _buf.ReadByte();
        this.magicItem = _buf.ReadLong();
        this.opType = _buf.ReadByte();
	},

});
////////////////////
// 请求升级转生装备 //
////////////////////
var ReqUprReincarnateEquipMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品唯一Id
	},

	getId:function(){
		return 204207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
	},

});
////////////////////
// 请求分解转生装备 //
////////////////////
var ReqDismantlrReincarnateEquipMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = []; // 物品唯一Id long
	},

	getId:function(){
		return 204208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.itemId.length );
        for (var i = 0; i < this.itemId.length; i++) {
            _buf.WriteLong(this.itemId[i]);
        }
	},
	
	reading:function( _buf ){
        var itemId_length = _buf.ReadUShort();
        for (var i = 0; i < itemId_length; i++) {
            this.itemId[i] = _buf.ReadLong();
        }
	},

});
////////////////////
// 请求升级或分解装备 //
////////////////////
var ReqUpOrDismantlrEquipMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 合成(0),分解(1)
        this.itemType = 0; // 装备类型(合成用)
        this.itemId = []; // 物品唯一Id long
	},

	getId:function(){
		return 204209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.itemType);
        _buf.WriteUShort( this.itemId.length );
        for (var i = 0; i < this.itemId.length; i++) {
            _buf.WriteLong(this.itemId[i]);
        }
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.itemType = _buf.ReadVarInt();
        var itemId_length = _buf.ReadUShort();
        for (var i = 0; i < itemId_length; i++) {
            this.itemId[i] = _buf.ReadLong();
        }
	},

});
// 接收消息注册
MESSAGE_POOL.Add(204102, ResStrengthenResultMessage);

