///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//164201,ReqSelectGiftInfoToGame 请求多选礼包信息
//164202,ReqUseSelectGiftToGame 请求选择领取多选礼包某一项奖励

// 接收消息
//164101,ResSendSelectGiftInfoToClient 发送多选礼包信息 


////////////////////
// 发送多选礼包信息  //
////////////////////
var ResSendSelectGiftInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.itemGiftId = null; // 多选礼包唯一ID
        this.itemGiftModelId = 0; // 多选礼包模板ID
        this.costTypeList = []; // 多选礼包花费类型列表（对应下面的1-8奖励列表） int
        this.costList = []; // 多选礼包花费列表（对应下面的1-8奖励列表） int
        this.itemInfoList1 = []; // 奖励道具列表1 TempItemInfo
        this.itemInfoList2 = []; // 奖励道具列表2 TempItemInfo
        this.itemInfoList3 = []; // 奖励道具列表3 TempItemInfo
        this.itemInfoList4 = []; // 奖励道具列表4 TempItemInfo
        this.itemInfoList5 = []; // 奖励道具列表5 TempItemInfo
        this.itemInfoList6 = []; // 奖励道具列表6 TempItemInfo
        this.itemInfoList7 = []; // 奖励道具列表7 TempItemInfo
        this.itemInfoList8 = []; // 奖励道具列表8 TempItemInfo
	},

	getId:function(){
		return 164101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemGiftId);
        _buf.WriteVarInt(this.itemGiftModelId);
        _buf.WriteShort( this.costTypeList.length );
        for (var i = 0; i < this.costTypeList.length; i++) {
            _buf.WriteVarInt(this.costTypeList[i]);
        }
        _buf.WriteShort( this.costList.length );
        for (var i = 0; i < this.costList.length; i++) {
            _buf.WriteVarInt(this.costList[i]);
        }
        _buf.WriteShort( this.itemInfoList1.length );
        for (var i = 0; i < this.itemInfoList1.length; i++) {
            _buf.WriteBean(this.itemInfoList1[i]);
        }
        _buf.WriteShort( this.itemInfoList2.length );
        for (var i = 0; i < this.itemInfoList2.length; i++) {
            _buf.WriteBean(this.itemInfoList2[i]);
        }
        _buf.WriteShort( this.itemInfoList3.length );
        for (var i = 0; i < this.itemInfoList3.length; i++) {
            _buf.WriteBean(this.itemInfoList3[i]);
        }
        _buf.WriteShort( this.itemInfoList4.length );
        for (var i = 0; i < this.itemInfoList4.length; i++) {
            _buf.WriteBean(this.itemInfoList4[i]);
        }
        _buf.WriteShort( this.itemInfoList5.length );
        for (var i = 0; i < this.itemInfoList5.length; i++) {
            _buf.WriteBean(this.itemInfoList5[i]);
        }
        _buf.WriteShort( this.itemInfoList6.length );
        for (var i = 0; i < this.itemInfoList6.length; i++) {
            _buf.WriteBean(this.itemInfoList6[i]);
        }
        _buf.WriteShort( this.itemInfoList7.length );
        for (var i = 0; i < this.itemInfoList7.length; i++) {
            _buf.WriteBean(this.itemInfoList7[i]);
        }
        _buf.WriteShort( this.itemInfoList8.length );
        for (var i = 0; i < this.itemInfoList8.length; i++) {
            _buf.WriteBean(this.itemInfoList8[i]);
        }
	},
	
	reading:function( _buf ){
        this.itemGiftId = _buf.ReadLong();
        this.itemGiftModelId = _buf.ReadVarInt();
        var costTypeList_length = _buf.ReadShort();
        for (var i = 0; i < costTypeList_length; i++) {
            this.costTypeList[i] = _buf.ReadVarInt();
        }
        var costList_length = _buf.ReadShort();
        for (var i = 0; i < costList_length; i++) {
            this.costList[i] = _buf.ReadVarInt();
        }
        var itemInfoList1_length = _buf.ReadShort();
        for (var i = 0; i < itemInfoList1_length; i++) {
            this.itemInfoList1[i] = _buf.ReadBean(TempItemInfo);
        }
        var itemInfoList2_length = _buf.ReadShort();
        for (var i = 0; i < itemInfoList2_length; i++) {
            this.itemInfoList2[i] = _buf.ReadBean(TempItemInfo);
        }
        var itemInfoList3_length = _buf.ReadShort();
        for (var i = 0; i < itemInfoList3_length; i++) {
            this.itemInfoList3[i] = _buf.ReadBean(TempItemInfo);
        }
        var itemInfoList4_length = _buf.ReadShort();
        for (var i = 0; i < itemInfoList4_length; i++) {
            this.itemInfoList4[i] = _buf.ReadBean(TempItemInfo);
        }
        var itemInfoList5_length = _buf.ReadShort();
        for (var i = 0; i < itemInfoList5_length; i++) {
            this.itemInfoList5[i] = _buf.ReadBean(TempItemInfo);
        }
        var itemInfoList6_length = _buf.ReadShort();
        for (var i = 0; i < itemInfoList6_length; i++) {
            this.itemInfoList6[i] = _buf.ReadBean(TempItemInfo);
        }
        var itemInfoList7_length = _buf.ReadShort();
        for (var i = 0; i < itemInfoList7_length; i++) {
            this.itemInfoList7[i] = _buf.ReadBean(TempItemInfo);
        }
        var itemInfoList8_length = _buf.ReadShort();
        for (var i = 0; i < itemInfoList8_length; i++) {
            this.itemInfoList8[i] = _buf.ReadBean(TempItemInfo);
        }
	},

	action:function(){
		Mgr.selectgift.RecvResSendSelectGiftInfoToClientMessage(this);
	},

});
////////////////////
// 请求多选礼包信息 //
////////////////////
var ReqSelectGiftInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.itemGiftId = null; // 多选礼包唯一ID
	},

	getId:function(){
		return 164201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemGiftId);
	},
	
	reading:function( _buf ){
        this.itemGiftId = _buf.ReadLong();
	},

});
////////////////////
// 请求选择领取多选礼包某一项奖励 //
////////////////////
var ReqUseSelectGiftToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.itemGiftId = null; // 多选礼包唯一ID
        this.index = 0; // 奖励索引
	},

	getId:function(){
		return 164202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemGiftId);
        _buf.WriteVarInt(this.index);
	},
	
	reading:function( _buf ){
        this.itemGiftId = _buf.ReadLong();
        this.index = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(164101, ResSendSelectGiftInfoToClientMessage);

