var ShopFrameExt = ShopFrame.extend ( {
	_className:"ShopFrameExt",
	ctor:function(){
		this._super();
	},
	Init:function(){
		ShopFrame.prototype.Init.call( this );
		var self =this;
		this.imgGold.ignoreContentAdaptWithSize(true);
		this.imgGold.scale = 0.6;
		this.gridItem.InitGrid(GridTypeEnum.SHOP);
		self.addClickEventListener(function(){
            Mgr.uiMgr.ShowPanelByType( BuyPanelExt.PanelName,UIMgr.PANEL_LAYER_POP);
            Mgr.shop.buyPanel.SetData(self.goods);
		});
	},
	SetGoods:function(goods,shopNum){
		this.goods = goods;
		//物品商店Id
		this.goods.shopNum=shopNum;
		//得到货币图片
		var imageRes = ShopUtil.GetImageRes(shopNum);
        this.imgGold.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
		//var self=this;
		// EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
		// 	self.imgGold.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
		// }, self.imgGold);

		//热销标识 0无热销，1热销中，2折扣，3热销+折扣
		if(goods.hot==1||goods.hot==3)
			this.imgHot.setVisible(true);
		else
			this.imgHot.setVisible(false);
		//价格
		this.labNumber.SetString(goods.price);
		//名字
		this.labName.SetString(goods.name);
		var color=ItemUtil.GetNameColorById(goods.itemModelId);
		//物品ico
		GridUtil.SetItemGrid(this.gridItem,goods);

        this.labDes.visible = false;
        this.labLimit.visible = false;
        do{
            if(!(goods.item && goods.item.parameters)) break;

            var param = JSON.parse(goods.item.parameters);
            UIUtil.ConnectLabelHtmlText(this.labLimit,[param.SHOP_SELL_NUM]);

            this.labDes.visible = true;
            this.labLimit.visible = true;
        }while(false);
	}
} );
ShopFrameExt.PanelName = "ShopFrameExt";
PanelClassDic["ShopFrameExt"] = ShopFrameExt;
