var NewSkillCueExt = NewSkillCue.extend ( {
	_className:"NewSkillCueExt",
	_time:0,
	_timerNum:0,
    _mouseListener:null,
    _mouseListener1:null,
    _skillId:0,

    ctor:function(){
		this._super();
	},

	Init:function(){
        NewSkillCue.prototype.Init.call(this);
	},

	SetKillId:function(skillId){
        this._skillId = skillId;
        var imageUrl = "other/zhujiemian/btn/skill/" + skillId + ".png";
        var nameimageUrl = "other/jinengxuexi/word/" + skillId + ".png";

        UIUtil.LoadImage( this.imgSkill, imageUrl );
        UIUtil.LoadImage( this.imgSkillName, nameimageUrl )
        this._time = 4;
        this.OnTimer();
        this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        var self = this;
        this._mouseListener = cc.EventListener.create({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchEnded:function(touch, event){
                if(self._time >= 0){
                    Mgr.uiMgr.HidePanel(self);
                    TimerUtil.ClearTimeUpdate(self._timerNum, self);

                    return true;
                }
                return true;
            }
        });
        cc.eventManager.addListener(this._mouseListener, Mgr.sceneLayer.oSceneRoot);
	},

    OnShow:function(){
        var self = this;
        this._mouseListener1 = cc.EventListener.create({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            onTouchBegan:function(touch, event){
                if(self._time >= 0){
                    Mgr.uiMgr.HidePanel(self);
                    TimerUtil.ClearTimeUpdate(self._timerNum, self);

                    return true;
                }
                return true;
            }
        });
        cc.eventManager.addListener(this._mouseListener1, this.imgBg);
    },

    DoFly:function(){
        var skillArr = Mgr.player.shortPanel.skillArry;
        var target;
        for( var i = 0; i < skillArr.length; i++ ){
            if( skillArr[i].skillId == this._skillId ){
                target = skillArr[i];
                break;
            }
        }
        if( !target )
            return;
        var pos = target.convertToWorldSpace(cc.p(target.width / 2, target.height / 2));
        var curPos = this.imgSkill.convertToWorldSpace(cc.p(this.imgSkill.width / 2, this.imgSkill.height / 2));

        var imageUrl = "other/zhujiemian/btn/skill/" + this._skillId + ".png";
        var icon = new cc.Sprite( EngineMgr.uiMgr.GetResByUrl( imageUrl ) );
        icon.x = curPos.x;
        icon.y = curPos.y;
        Mgr.uiMgr.addChild(icon);
        var action = cc.EaseSineIn.create(cc.moveTo(1, pos));
        icon.runAction(cc.sequence(action, cc.callFunc(function() {
            icon.removeFromParent();
        })));
    },

	OnTimer:function(){
        this._time--;
		if(this._time == 0){
			Mgr.uiMgr.HidePanel(this);
			TimerUtil.ClearTimeUpdate(this._timerNum, this);
            //cc.eventManager.removeListener(this._mouseListener);
			return;
		}
		this.labCue1.SetHtmlText(TextUtil.FormatStr(this.labCue1.GetHtmlText(),[this._time]));
	},

	OnHide:function(){
        this._super();
        if( this._timerNum )
            TimerUtil.ClearTimeUpdate(this._timerNum, this);
        this._timerNum = 0;
        cc.eventManager.removeListener(this._mouseListener);
        cc.eventManager.removeListener(this._mouseListener1);
        this._mouseListener = null;
        this._mouseListener1 = null;
        this.DoFly();
    }
} );
NewSkillCueExt.PanelName = "NewSkillCueExt";
PanelClassDic["NewSkillCueExt"] = NewSkillCueExt;
