///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//SkillEnchantInfo 技能信息类

// 请求消息
//175201,ReqSkillEnchant 请求技能附魔
//175202,ReqSkillEnchantPanel 请求技能附魔面板

// 接收消息
//175101,ResSkillEnchantPanel 技能附魔面板


var SkillEnchantInfo = cc.Class.extend({
	ctor:function(){
		this.itemModelId = 0; // 附魔物品的ModelId
        this.num = 0; // 附魔物品的当前数量
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.itemModelId);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
		this.itemModelId = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
	},
});
////////////////////
// 技能附魔面板 //
////////////////////
var ResSkillEnchantPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.skillModelId = 0; // 技能modelId
        this.skillType = 0; // 哪里的技能(0人物 1坐骑)
        this.enchantInfos = []; // 附魔信息 SkillEnchantInfo
	},

	getId:function(){
		return 175101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModelId);
        _buf.WriteByte(this.skillType);
        _buf.WriteShort( this.enchantInfos.length );
        for (var i = 0; i < this.enchantInfos.length; i++) {
            _buf.WriteBean(this.enchantInfos[i]);
        }
	},
	
	reading:function( _buf ){
        this.skillModelId = _buf.ReadVarInt();
        this.skillType = _buf.ReadByte();
        var enchantInfos_length = _buf.ReadShort();
        for (var i = 0; i < enchantInfos_length; i++) {
            this.enchantInfos[i] = _buf.ReadBean(SkillEnchantInfo);
        }
	},

	action:function(){
		Mgr.skillenchant.RecvResSkillEnchantPanelMessage(this);
	},

});
////////////////////
// 请求技能附魔 //
////////////////////
var ReqSkillEnchantMessage = cc.Class.extend( {
	ctor:function(){
		this.skillModelId = 0; // 技能modelId
        this.skillType = 0; // 哪里的技能(0人物 1坐骑)
	},

	getId:function(){
		return 175201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModelId);
        _buf.WriteByte(this.skillType);
	},
	
	reading:function( _buf ){
        this.skillModelId = _buf.ReadVarInt();
        this.skillType = _buf.ReadByte();
	},

});
////////////////////
// 请求技能附魔面板 //
////////////////////
var ReqSkillEnchantPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.skillModelId = 0; // 技能modelId
        this.skillType = 0; // 哪里的技能(0人物 1坐骑)
	},

	getId:function(){
		return 175202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModelId);
        _buf.WriteByte(this.skillType);
	},
	
	reading:function( _buf ){
        this.skillModelId = _buf.ReadVarInt();
        this.skillType = _buf.ReadByte();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(175101, ResSkillEnchantPanelMessage);

