var TeamQuickTeamListExt = TeamQuickTeamList.extend ( {
	_className:"TeamQuickTeamListExt",

	_type:null,
	_info:null,
	_restCount:null,

	ctor:function(){
		this._super();
		this._restCount = 0;
	},

	Init:function() {
		var self = this;
		TeamQuickTeamList.prototype.Init.call(this);

		this.btnGo.addClickEventListener(function (event) {
			if ( self._type == TeamEnum.PANEL_CURMAP_FB )
				Mgr.team.SendReqJoinTeamMessage(self._info.teamid);
			else if ( self._type == TeamEnum.PANEL_RAID_FB ) {   // 跨服组队
				if ( self._info.needFightPower > Mgr.fightpower.fightPower ) {
					Mgr.tips.ShowNotice("战斗力不足");
					return;
				}
				if ( self._restCount <= 0 ) {
					Mgr.tips.ShowNotice("没有挑战次数了");
					return;
				}

				// 弹出跨服面板
				var panel = Mgr.uiMgr.ShowPanelByType(DuorenPanelExt.PanelName);
				panel.ShowContentByType(EnumZoneType.TYPE_KFDR);

				// join
				var msg = {
					teamid : self._info.teamId, // 队伍Id（id为0表示快速加入）
					zoneModelId : self._info.zoneModelId, // 副本模版
					passWord : null, // 队伍密码
				}
				Mgr.crossteam.SendReqJoinCrossTeamClientToGameMessage(msg);

				// // 直接跳转
				// EngineMgr.uiMgr.ShowPanelByType(DuorenPanelExt.PanelName);
				// var panel = Mgr.uiMgr.GetPanelByType(DuorenPanelExt.PanelName);
				// panel.ShowContentByType(EnumZoneType.TYPE_KFDR);
				Mgr.uiMgr.HidePanelByType(TeamPanelExt.PanelName);
			}
		});
	},

	SetData:function (data, type, restCount) {
		this._type = type;
		this._info = data;
		this._restCount = restCount;

		if ( type == TeamEnum.PANEL_CURMAP_FB ) {
			// name
			this.labName.SetString(data.captainname);

			// numer
			UIUtil.ConnectLabelHtmlText(this.labNumber,[data.teamnum]);

			this.btnGo.setTitleText("申请入队");
		}
		else if ( type == TeamEnum.PANEL_RAID_FB ) {
			// name
			if(data.memberinfo[0])
			{
				this.labName.SetString(data.memberinfo[0].name);
			}

			// 战力需求
			//this.labNeedPower1.SetString(data.needFightPower);

			// numer
			UIUtil.ConnectLabelHtmlText(this.labNumber, [data.memberinfo.length])
		}
	},

	GetData:function () {
		return this._info;
	},

	GetType:function () {
		return this._type;
	},
} );
TeamQuickTeamListExt.PanelName = "TeamQuickTeamListExt";
PanelClassDic["TeamQuickTeamListExt"] = TeamQuickTeamListExt;
