var TeamTeamPanelExt = TeamTeamPanel.extend ( {
	_className:"TeamTeamPanelExt",
	zisheng:null,
	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		TeamTeamPanel.prototype.Init.call(this);

		this.btnJieSan.addClickEventListener(function (event){
			Mgr.team.SendReqDismissTeamToGameMessage();
		});
		this.btnJiaL.addClickEventListener(function (event){
			Mgr.uiMgr.ShowPanelByType( TeamYaoqingPanelExt.PanelName ).OnShow();
		});
		this.btnJiaR.addClickEventListener(function (event){
			Mgr.uiMgr.ShowPanelByType( TeamYaoqingPanelExt.PanelName ).OnShow();
		});
		this.btnQuit.addClickEventListener(function (event){
			Mgr.team.SendReqLeaveTeamMessage(1);
		});
		this.btnYaoqing.addClickEventListener(function (event){
			Mgr.uiMgr.ShowPanelByType( TeamYaoqingPanelExt.PanelName ).OnShow();
		});
		this.btnKuaisu.addClickEventListener(function (event){

			var panel = Mgr.uiMgr.ShowPanelByType(TeamHanhuaExt.PanelName);
			// pos
			var pt = cc.p( self.btnKuaisu.x + (self.btnKuaisu.width - panel.width)/2, self.btnKuaisu.y + this.height + 5 );
			pt = UIUtil.LocalToGlobel( self.btnKuaisu.parent, pt, Mgr.uiMgr.GetLayerByType(panel.showLayerType) );
			panel.setAnchorPoint(0, 0);
			panel.x = pt.x;
			panel.y = pt.y;
		});

		this._InitParam();
	},

	_InitParam:function () {
		this.btnJieSan.visible = false;
        this.zisheng = new MUIImage();
        this.zisheng.ParseJson(this.imgIconMemberL.jsonobj);
        this.zisheng.Init();
        this.zisheng.retain();
        this.zisheng.setPosition(this.imgIconMemberC.getPosition());
        this.imgMemberC.addChild(this.zisheng);
        this.imgIconMemberC.x -= 40;
	},

	_UpdataPanel:function () {
		if (Mgr.team.teamInfo)
			this._SetMembers();
	},

	_SetMembers:function () {
		// set member
		this._ClearChildren(0);
		this._SetUnJoinState(0);

		this._ClearChildren(1);
		this._SetUnJoinState(1);

		this._ClearChildren(2);
		this._SetUnJoinState(2);

		var len = Mgr.team.teamInfo.memberinfo.length;
		for ( var i = 0; i != len; i++ ) {
			var member = Mgr.team.teamInfo.memberinfo[i];
			this._AddMember( i, member );
		}

		// btn state
		var boo = Mgr.player.mainPlayer.sid.Equal( Mgr.team.leaderId );
		this.btnJieSan.visible = boo;
	},

	_AddMember:function (idx,info) {
		this._ClearChildren(idx);
		this._SetJoinState( info, idx );
	},

	_SetJoinState:function (info, type) {
		// icon flag
		if ( type == 0 ) {
			this.imgIconMemberC.visible = true;
			this.labNameC.SetString(info.memberName);
			this.labLvC.visible = true;
			this.labLvC1.SetString(info.memberLevel);
			this.imgModelC.visible = true;
			// this._AddPlayerModule( this.imgModelC, info.appearanceInfo.job, info.memberId );
			this.AddPlayerModule(this.imgModelC, info.appearanceInfo, info.memberId);
			if ( info.memberId.Equal( Mgr.player.mainPlayer.sid ) ) {
				this.zisheng.visible = true;
            }
		}
		else if ( type == 1 ) {
			this.imgIconMemberC.visible = true;
			this.labNameL.SetString(info.memberName);
			this.labLvL.visible = true;
			this.labLvL1.SetString(info.memberLevel);
			this.imgModelL.visible = true;
			// this._AddPlayerModule( this.imgModelL, info.appearanceInfo.job, info.memberId );
            this.AddPlayerModule(this.imgModelL, info.appearanceInfo, info.memberId);
			if ( info.memberId.Equal( Mgr.player.mainPlayer.sid ) )
				this.imgIconMemberL.visible = true;
		}
		else if ( type == 2 ) {
			this.imgIconMemberC.visible = true;
			this.labNameR.SetString(info.memberName);
			this.labLvR.visible = true;
			this.labLvR1.SetString(info.memberLevel);
			this.imgModelR.visible = true;
			// this._AddPlayerModule( this.imgModelR, info.appearanceInfo.job, info.memberId );
            this.AddPlayerModule(this.imgModelR, info.appearanceInfo, info.memberId);
            if ( info.memberId.Equal( Mgr.player.mainPlayer.sid ) )
                this.imgIconMemberR.visible = true;
		}
	},

	_SetUnJoinState:function (type) {
		if ( type == 0 ) {
			this.btnJiaC.visible = true;
			this.imghuaC.visible = true;
		}
		else if ( type == 1 ) {
			this.btnJiaL.visible = true;
			this.imghuaL.visible = true;
		}
		else if ( type == 2 ) {
			this.btnJiaR.visible = true;
			this.imghuaR.visible = true;
		}
	},

	_AddPlayerModule:function( model, job, memberId )
	{
		cc.log("============_AddPlayerModule========   ")
		if (!model.roleModel){
            model.roleModel = new UIModel(job, EnumResline.PLAYER);
            model.roleModel.x = model.width / 2;
            model.addChild(model.roleModel);
		}
		else
        	model.roleModel.SetModelId(job, EnumResline.PLAYER);
        // for( var i = 0; i < info.playerResLineInfo.length; i++ ){
        //     var resline = info.playerResLineInfo[i];
        //     if( resline.type == EnumResline.GUANGWU ){
        //         obj.AddWeapon(resline.modelid, info.nJobId);
        //         break;
        //     }
        // }
		// obj.width = model.width;
		// obj.height = model.height;

		// event
		model.memberId = memberId;
		model.setTouchEnabled(true);
		model.addTouchEventListener(function(sender, type){
			if (type == ccui.Widget.TOUCH_ENDED) {
				if ( sender.memberId.Equal(Mgr.player.mainPlayer.sid) )
					return;
				var self = sender.parent.parent;
				self._ShowMemberInfoPanel( sender.memberId );
			}
		});
	},

    AddPlayerModule:function( model, info, memberId )
    {
        cc.log("============_AddPlayerModule========   " + JSON.stringify(info))
        if (!model.roleModel){
            model.roleModel = new UIModel(SceneObjUtil.GetBodyIdByInfo(info));
            model.roleModel.x = model.width / 2;
            model.addChild(model.roleModel);
        }
        else {
        	model.roleModel.RemoveAll();
        	model.hasWing = false;
        	model.hasWeapon = false;
            model.roleModel.SetModelId(SceneObjUtil.GetBodyIdByInfo(info));
        }

        if(info.armorId){
        	if(!model.hasWing){
                var wingId = ScenePlayer.prototype._Getnresid(info.armorId);
                model.roleModel.AddWing(wingId);
                model.hasWing = true;
			}
		}else {
        	model.hasWing = false;
		}

        if(info.weaponRideid > 0){
        	if(!model.hasWeapon){
                model.roleModel.AddWeapon(SceneObjUtil.GetGodWeaponResId(info.illusionDataInfos) || info.weaponRideid, info.job);
                model.hasWeapon = true;
			}
		}else {
        	model.hasWeapon = false;
		}
        model.roleModel._animGroup.CheckPartZOrder();

        // for( var i = 0; i < info.playerResLineInfo.length; i++ ){
        //     var resline = info.playerResLineInfo[i];
        //     if( resline.type == EnumResline.GUANGWU ){
        //         obj.AddWeapon(resline.modelid, info.nJobId);
        //         break;
        //     }
        // }
        // obj.width = model.width;
        // obj.height = model.height;

        // event
        model.memberId = memberId;
        model.setTouchEnabled(true);
        model.addTouchEventListener(function(sender, type){
            if (type == ccui.Widget.TOUCH_ENDED) {
                if ( sender.memberId.Equal(Mgr.player.mainPlayer.sid) )
                    return;
                var self = sender.parent.parent;
                self._ShowMemberInfoPanel( sender.memberId );
            }
        });
    },

	_ShowMemberInfoPanel:function (memberId) {
		var panel = Mgr.uiMgr.ShowPanelByType( TeamMemberInfoPanelExt.PanelName );
		panel.SetData(memberId);
	},

	_ClearChildren:function (type) {
		if ( type == 0 ) {  // leader
			this.btnJiaC.visible = false;
			this.imghuaC.visible = false;
			this.imgModelC.visible = false;
			this.labNameC.SetString("");
			this.labLvC.visible = false;
			this.labLvC1.SetString("");
			this.imgIconMemberC.visible = false;
			this.imgIconC.visible = false;
		}
		else if ( type == 1 ) {    // left
			this.btnJiaL.visible = false;
			this.imghuaL.visible = false;
			this.imgModelL.visible = false;
			this.labNameL.SetString("");
			this.labLvL.visible = false;
			this.labLvL1.SetString("");
			this.imgIconMemberL.visible = false;
			this.imgIconL.visible = false;
		}
		else if ( type == 2 ) {  // right
			this.btnJiaR.visible = false;
			this.imghuaR.visible = false;
			this.imgModelR.visible = false;
			this.labNameR.SetString("");
			this.labLvR.visible = false;
			this.labLvR1.SetString("");
			this.imgIconMemberR.visible = false;
			this.imgIconR.visible = false;
		}
	},

	OnShow:function () {
		this._UpdataPanel();
	},
	
	OnHide:function () {
		if(this.imgModelC.roleModel){
			this.imgModelC.roleModel.RemoveAll();
		}

        if(this.imgModelL.roleModel){
            this.imgModelL.roleModel.RemoveAll();
        }

        if(this.imgModelR.roleModel){
            this.imgModelR.roleModel.RemoveAll();
        }
    }

} );
TeamTeamPanelExt.PanelName = "TeamTeamPanelExt";
PanelClassDic["TeamTeamPanelExt"] = TeamTeamPanelExt;
