var ErenguBossMainExt = ErenguBossMain.extend ( {
	_className:"ErenguBossMainExt",

	vip:4,

    _listView:null,
    _itemList:null,

    gridList:null,
    curGridMonsterId:null,

    prevuiousIdex:null,

    countHight:0,
    timerId:null,
    monsterInfoList:null,

	ctor:function(level){
		this._super();
		this.vip = level;
        this._itemList = [];
        this.gridList = [];
    },

	Init:function(){
        ErenguBossMain.prototype.Init.call( this );


        // this.btnGo.visible = false;
        this.gridItem.visible = false;
        this.setTouchEnabled(false);
        this.imgTips1.visible = false;
        this.labCue111.visible = false;

        var list = null;
        if(this.vip == 4){
            list = Mgr.monster.vip4ErenguBossList;
            this.labTimeCue.SetText("进入需要200元宝，V4可免费进入(恶人谷不消耗疲劳值)");
        }
        else{
            list = Mgr.monster.vip10ErenguBossList;
            this.labTimeCue.SetText("进入需要200元宝，V7可免费进入(恶人谷不消耗疲劳值)");
            UIUtil.LoadImage(this.imgBg1,"other/shijieboss/image/bgerengudierceng.png" )
        }
        this.monsterInfoList = list;

        this._HandleButton();
        this.InitView();
        this.InitItem(list);

	},

    InitView:function(){
        if(!this._listView){
            this._listView = new ccui.ScrollView();
            this._listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._listView.setTouchEnabled(true);					//触摸开启
            this._listView.inertiaScrollEnabled = true; 			//滚动惯性
            this._listView.setScrollBarEnabled(false);				//滚动条
            this._listView.setBounceEnabled(true);					//边界回弹
            // this._listView.setItemsMargin(20);
            // this._listView.addEventListener(this._SelectedBtnEvent);

            this._listView.setSize(480,400);
            this._listView.setPosition(16,20);
            this.imgBg.addChild(this._listView);

            var self = this;
            this._listView.addCCSEventListener(function (sender, type) {
                switch(type){
                    case ccui.ScrollView.EVENT_CONTAINER_MOVED:
                        self.UpdateScroll();
                        break;
                    case ccui.ScrollView.EVENT_AUTOSCROLL_ENDED:
                        self.prevuiousIdex = self._curSelectBtn.index;
                    	break;
                }
            });
        }
    },

    InitItem:function(list){
        // this._listView.doLayout(); // 先刷新一次listview   让 _innerContainerDoLayoutDirty = false;  才能自定义 item位置   和  InnerContainerSize
        var self=this;
	    for(var i =0; i<list.length; i++){
            if(!this._itemList[i]){
                var item = new ErenguBossFrameExt();
                item.LoadPanel();
                this._height = item.uiHeight;
                item.x = -10;
                item.y = list.length * (this._height+20) + 150 - (i+1)*(this._height+20);
                item.idx = i;
                this._listView.addChild(item);
                this._itemList.push(item);
                item.setTouchEnabled(true);
                (function(i){
                    item.addClickEventListener(function () {
                        self.ChooseCell(i);
                    });
                })(i);
            }
            this._itemList[i].SetData(i, list[i], this.vip);
        }
        this._listView.setInnerContainerSize(cc.size(400, list.length * (this._height+20) + 300));
        this.countHight =list.length * (this._height+20) + 300;
    },

    _SelectedBtnEvent:function(sender, type){
        switch (type) {
            case ccui.ListView.ON_SELECTED_ITEM_END:
                var parent = sender.parent.parent;
                // if (parent._curSelectBtn != null) {
                //     parent._curSelectBtn.SetSelect(false);
                //     parent._curSelectBtn = null;
                // }

                var idx = sender.getCurSelectedIndex();
                var btnSelect = sender.getItem(idx);
                // parent._curSelectBtn = btnSelect;
                // btnSelect.SetSelect(true);
                parent.ChooseCell(btnSelect.index);
                // parent.btnSelect = btnSelect;
                break;
            default:
        }
    },

    ChooseCell:function(idx){
        if (this._curSelectBtn != null) {
            this._curSelectBtn.SetSelect(false);
            this.prevuiousIdex = this._curSelectBtn.index;
            this._curSelectBtn = null;
        }
        this._curSelectBtn = this._itemList[idx];
        this._curSelectBtn.SetSelect(true);
        this.UpdateGrid();
        this.scrollToICurSelect();
        this.UpdateInfo();
    },

    scrollToICurSelect:function () {
        // var prent=this._curSelectBtn.y/this.countHight;
        var prent = ((this._curSelectBtn.idx + 2)*(this._height+20) - 120)/this.countHight;
        var curItemY = (this.countHight - this._curSelectBtn.y - 300)/(this.countHight-450);
        // cc.log("scrollToICurSelect=====" + this._curSelectBtn.y + "    " + curItemY*100)
        if(curItemY < 0)
            curItemY = 0;
        this._listView.scrollToPercentVertical((curItemY*100), 0.5, true);
        // this._listView.jumpToPercentVertical((curItemY*100));
    },

    UpdateScroll:function () {
        for(var i =0; i < this._itemList.length; i++){
            var pos =this._itemList[i].getWorldPosition();
            if(pos.y>200&&pos.y<355)
            {
                if(this._curSelectBtn &&this._curSelectBtn.index != i && this.prevuiousIdex != i )
                {
                    this.ChooseCell(i);
                }
                break;
            }
        }
    },

    UpdateGrid:function(){
	    var info = this._curSelectBtn.bossInfo;
        var items = JSON.parse(Q_monster_dropprob.Get(info.monsterModelId).q_drop_show);
        if(this.curGridMonsterId == info.monsterModelId)
            return;
        this.curGridMonsterId = info.monsterModelId;

        var i = 0;
        for(; i < items.length; i++){
            if(!this.gridList[i]){
                this.gridList[i] = this.gridItem.Clone();
                this.gridList[i].x=i%4*92+this.gridItem.x;
                if(i<4)
                {
                    this.gridList[i].y=this.gridItem.y;
                }
                else
                {
                    this.gridList[i].y=this.gridItem.y-94;
                }
                this.imgBg11.addChild( this.gridList[i]);
            }
            this.gridList[i].visible = true;
            var coinInfo = {};
            coinInfo.itemModelId = items[i].mod;
            coinInfo.itemNum = items[i].num;
            // coinInfo.itemBind = items[i].isbind;
            GridUtil.SetItemGrid(this.gridList[i], coinInfo);
        }
        for(; i < this.gridList.length; i++){
            this.gridList[i].visible = false;
        }
    },

    UpdateInfo:function(){
	    var list;
        if(this.vip == 4){
            list = Mgr.monster.erenguV4BossList;
        }
        else{
            list = Mgr.monster.erenguV10BossList;
        }
        if(list.Get(this._curSelectBtn.bossInfo.monsterModelId))
        {
            this.sbtnGouxuan.SetButtonState("check");
        }
        else
        {
            this.sbtnGouxuan.SetButtonState("uncheck");
        }
    },

    _HandleButton:function(){
        var self = this;
        this.labCue1.setTouchEnabled(true);
        this.labCue1.addTouchEventListener(function(sender, type){
            if ( type == ccui.Widget.TOUCH_BEGAN )
            {
            }
            else if ( type == ccui.Widget.TOUCH_ENDED )
            {
                if(self.imgTips1.visible)
                    self.imgTips1.visible = false;
                else
                    self.imgTips1.visible = true;
            }
            else if ( type == ccui.Widget.TOUCH_CANCELED )
            {
            }
        });

        this.sbtnGouxuan.addClickEventListener(function()
        {
            var info;
            var type, list;
            if(self.vip == 4){
                type = EnumCustomMsgKey.ERENGUV4;
                list = Mgr.monster.erenguV4BossList;
            }
            else{
                type = EnumCustomMsgKey.ERENGUV10;
                list = Mgr.monster.erenguV10BossList;
            }
            info = self._curSelectBtn.bossInfo;
            if(self.sbtnGouxuan.GetState()=="check")
            {
                list.Put(info.monsterModelId,info);
            }
            else
            {
                list.Remove(info.monsterModelId);
            }
            var value = list.Keys().join(",");
            Mgr.client.SendCustomMsg(type, value);
        });
    },

    OnFrame:function(){
        for(var i=0;i<this._itemList.length;++i){
            var cell=this._itemList[i];
            cell.UpdateTime();
        }
    },

    OnShow:function(){
        if(!this._curSelectBtn){
            this._curSelectBtn = this._itemList[0];
            // this._itemList[0].SetSelect(true);
            this.ChooseCell(0);
        }
        // this.timerId = TimerUtil.TimeUpdate(this.UpdateScroll,this,0.2);
	},

    OnHide:function () {
        // if(this.timerId){
        //     TimerUtil.ClearTimeUpdate(this.timerId,this);
        //     this.timerId = -1;
        // }
    },
} );
ErenguBossMainExt.PanelName = "ErenguBossMainExt";
PanelClassDic["ErenguBossMainExt"] = ErenguBossMainExt;
