//获取途径类型
var APPROACHTYPE = APPROACHTYPE || {
    /**
     *商城
     */
    TYPE_SC : 1,
    /**
     *世界BOSS
     */
    TYPE_WORLD_BOSS : 2,
    /**
     *剧情副本
     */
    TYPE_JQ : 3,
    /**
     *进阶副本
     */
    TYPE_JJ : 4,
    /**
     *组队副本
     */
    TYPE_KFDR : 5,
    /**
     *问鼎江湖
     */
    TYPE_WEN : 6,
    /**
     *太极之巅
     */
    TYPE_TAIJI : 7,
    /**
	 * 挂机
     */
    TYPE_GUAJI : 8,
    /**
	 * 活动·阻击后援
     */
    TYPE_ZUJI : 9,
    /**
	 * 活动·铸剑天下
     */
    TYPE_ZHUJIAN : 10,
	};

var HuoquTujingCueExt = HuoquTujingCue.extend ( {
	_className:"HuoquTujingCueExt",
	btnArr:null,
	posArr:null,

	/***
	 * 依赖面板
	 */
	_dependPanel:null,


	ctor:function(){
		this._super();
	},

	Init:function() {
		HuoquTujingCue.prototype.Init.call(this);
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffx = 227;
		//对应q_get_approach顺序 1：商城，2：世界BOSS，3：剧情副本，4：进阶副本，5：组队副本, 6: 问鼎江湖 , 7: 太极之巅
		this.btnArr = [this.btnTanwei, this.btnWorldBoss, this.btnJuqingFB, this.btnJinjieFB, this.btnZuduiFB, this.btnWendingjianghu, this.btnTaijizhidian];
		this.posArr = new Array();
		var self = this;
		for(var i=0; i < this.btnArr.length; i++){
			self.posArr.push(new Position(self.btnArr[i].x, self.btnArr[i].y));
			(function(j){
				self.btnArr[j].addClickEventListener(function () {
					self.ClickBtn(self.btnArr[j]);
				});
			})(i);
		}

		this.btnColse.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanelByType( HuoquTujingCueExt.PanelName );
			if (Mgr.uiMgr.IsPanelShowByName(ItemTipsExt.PanelName)) {
				Mgr.uiMgr.GetPanelByType(ItemTipsExt.PanelName).x+=150;
			}
			if (Mgr.uiMgr.IsPanelShowByName(ItemTipsPanelExt.PanelName)) {
				Mgr.uiMgr.GetPanelByType(ItemTipsPanelExt.PanelName).x+=150;
			}
		});
	},

	ResetButtonArr:function (arr) {
		if(!arr){
			return;
		}
		for(var i = 0; i< arr.length; i++){
			var key = arr[i];
			this.btnArr[i].type = key;
			switch (key){//暂时加这么多,对应物品表中的approach属性
				case 1:
					UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/huodongicon/sc_btn.png");
					break;
                case 2:
                	UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/huodongicon/sjBOSS_btn.png");
                	break;
                case 3:
                    UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/huodongicon/jqfb_btn.png");
                	break;
                case 4:
                    UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/huodongicon/jjfb_btn.png");
                	break;
                case 5:
                    UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/huodongicon/zdfb_btn.png");
                	break;
                case 6:
                    UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/huodongicon/wdjh_btn.png");
                	break;
                case 7:
                    UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/huodongicon/vip_btn.png");
                	break;
                case 8:
                    UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/btn/kqgj_btn.png");
                	break;
                case 9:
                    //UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/huodongicon/sc_btn.png");
                	break;
                case 10:
                    UIUtil.LoadButtonImage(this.btnArr[i],"other/zhujiemian/huodongicon/zhujiantianxia.png");
                	break;
				default:
					break;
			}
		}
    },

	SetItemMid:function(mid){
		var item = Q_item.Get(mid);
		cc.log("-----------------" + mid + "       " + JSON.stringify(item));
		var approachArr = JSON.parse(item.q_get_approach);
		this.ResetButtonArr(approachArr);
		cc.log("----------------------" + approachArr + "        " + this.btnArr.length);
		for(var i=0; i < this.btnArr.length; i++){
			this.btnArr[i].setVisible(false);
		}
		for(i=0; i < approachArr.length; i++){
			// this.btnArr[approachArr[i]-1].setVisible(true);
			// this.btnArr[approachArr[i]-1].x = this.posArr[i].x;
			// this.btnArr[approachArr[i]-1].y = this.posArr[i].y;
			this.btnArr[i].setVisible(true);
			this.btnArr[i].x = this.posArr[i].x;
			this.btnArr[i].y = this.posArr[i].y;
		}
	},

	ClickBtn:function ( btn ){
		// var type = this.btnArr.indexOf(btn)+1;
		var type = btn.type;
		if( type == APPROACHTYPE.TYPE_SC ){
            if(BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP1,BtnGroupUtil.MINIMAP1_SHOP))
            {
                EngineMgr.uiMgr.ShowPanelByType(ShopMainExt.PanelName);
            }
			//EngineMgr.uiMgr.ShowPanelByType(ShopMainExt.PanelName);
		}else if( type == APPROACHTYPE.TYPE_WORLD_BOSS ){
			var isOpen = BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP1,BtnGroupUtil.MINIMAP1_WORLDBOSS);
			if(isOpen)
			{
				EngineMgr.uiMgr.ShowPanelByType(WorldBossPanelExt.PanelName);
			}
		}else if( type == APPROACHTYPE.TYPE_JQ ){
            if(BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP1,BtnGroupUtil.FB_JUQING)){
                EngineMgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName);
                Mgr.zone.battleZoneBackGroundPanel.ChangeView( EnumZoneType.TYPE_JQ );
            }
			// EngineMgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName);
			// Mgr.zone.battleZoneBackGroundPanel.ChangeView( EnumZoneType.TYPE_JQ );
		}else if( type == APPROACHTYPE.TYPE_JJ ){
            if(BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP1,BtnGroupUtil.FB_JINJIE)) {
                EngineMgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName);
                Mgr.zone.battleZoneBackGroundPanel.ChangeView( EnumZoneType.TYPE_JJ );
            }
			// EngineMgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName);
			// Mgr.zone.battleZoneBackGroundPanel.ChangeView( EnumZoneType.TYPE_JJ );
		}else if( type == APPROACHTYPE.TYPE_KFDR ){
			var isOpen = BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP1,BtnGroupUtil.MINIMAP1_DUORENFB);
			if(isOpen)
			{
				Mgr.crossteam.RequestZoneListData();
			}
		}else if( type == APPROACHTYPE.TYPE_WEN ){
            if(BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP1,BtnGroupUtil.FB_WENDING)) {
                EngineMgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName);
                Mgr.zone.battleZoneBackGroundPanel.ChangeView( EnumZoneType.TYPE_WD );
            }
        }else if( type == APPROACHTYPE.TYPE_TAIJI ){
            if(BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP4,BtnGroupUtil.MINIMAP4_TAIJI)) {
                EngineMgr.uiMgr.ShowPanelByType(TaijiPanelExt.PanelName);
                Mgr.gossip.taijiPanel.ShowType(EnumGrossipType.TYPE_DAY);
            }
        }else if( type == APPROACHTYPE.TYPE_GUAJI ){
            Mgr.player.StartOrStopAutoFight();
        }else if( type == APPROACHTYPE.TYPE_ZUJI ){
            // if(BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP4,BtnGroupUtil.MINIMAP4_TAIJI)) {
            //     EngineMgr.uiMgr.ShowPanelByType(TaijiPanelExt.PanelName);
            //     Mgr.gossip.taijiPanel.ShowType(EnumGrossipType.TYPE_DAY);
            // }
        }else if( type == APPROACHTYPE.TYPE_ZHUJIAN ) {
            var activeInfo = Mgr.majorevents.activityHash.Get(EnumZoneActiveType.TYPE_ZHUJIANTIANXIA);
            if (activeInfo && activeInfo.status == 1) {
                var panel = EngineMgr.uiMgr.ShowPanelByType(WorldBossPanelExt.PanelName);
                panel.ShowZhujian();
            }else {
            	Mgr.tips.ShowNotice("活动尚未开始");
            	return;
			}
        }

		EngineMgr.uiMgr.HidePanelByType( HuoquTujingCueExt.PanelName );
		EngineMgr.uiMgr.HidePanelByType( ItemTipsPanelExt.PanelName );
		EngineMgr.uiMgr.HidePanelByType( ItemTipsExt.PanelName );
		EngineMgr.uiMgr.HidePanelByType( PlayerPanelExt.PanelName );
		EngineMgr.uiMgr.HidePanelByType( QiannengdanTipsExt.PanelName );
		EngineMgr.uiMgr.HidePanelByType( HuanhuadanTipsExt.PanelName );
        EngineMgr.uiMgr.HidePanelByType( ShuXingDanMainExt.PanelName );
	},

	SetDepend:function (widget) {
		this._dependPanel =  widget;
		// pos
		var pt = cc.p( widget.x + widget.width - widget.width/2 , widget.y + (widget.height - this.height)/2 );
		pt = UIUtil.LocalToGlobel( widget.parent, pt, Mgr.uiMgr.GetLayerByType(this.showLayerType) );
		this.x = pt.x;
		this.y = pt.y;
		widget.x -= widget.width/2;
	},

	OnHide:function () {
		if ( this._dependPanel != null ) {
			this._dependPanel.x += this._dependPanel.width/2;
			this._dependPanel = null;
		}
	},
} );
HuoquTujingCueExt.PanelName = "HuoquTujingCueExt";
PanelClassDic["HuoquTujingCueExt"] = HuoquTujingCueExt;
