var ItemTipsExt = ItemTips.extend({
    _className: "ItemTipsExt",
    Info: null,
    dFontSize: 18,
    dHeight: 500,
    btntype: 0,
    modelPanelType: 2,
    isClosePanel: true,
    ctor: function () {
        this._super();
        Mgr.tips.normalTip = this;
    },
    Init: function () {
        ItemTips.prototype.Init.call(this);
        this.labTimedue.visible = false;
        this.labCue2.SetLeading(3);
        this.labCue6.SetLeading(3);
        this.btnClose.addClickEventListener(function () {
            EngineMgr.uiMgr.HidePanelByType(ItemTipsExt.PanelName);
        });
        var self = this;
        this.btnGoumai.addClickEventListener(function (tar) {
            if (self.btntype == EnumButtonType.GOUMAI) {//购买
                if (Mgr.player.mainPlayer.attributeData.gold < self.info.gold) {
                    EngineMgr.uiMgr.HidePanelByType(ItemTipsExt.PanelName);
                    EngineMgr.uiMgr.ShowPanelByType(GoldCueExt.PanelName);
                    return
                }
                Mgr.stall.SendReqStallBuyMessage(self.info.playerId, self.info.goodsIndex, self.info.gold, self.info.iteminfo.num, self.info.iteminfo.itemId);
                Mgr.stall.RefreshGoods();
            } else if (self.btntype == EnumButtonType.SHANGJIA) {       //上架
                EngineMgr.uiMgr.ShowPanelByType(TanweiShangjiaExt.PanelName, UIMgr.PANEL_LAYER_TOP);
                Mgr.stall.itemAdjustmentPanel.SetData(self.info);
                Mgr.stall.itemAdjustmentPanel.UpdatePriceInfo(self.price);
            } else if (self.btntype == EnumButtonType.XIAJIA) {          //下架
                if (!Mgr.backpack.GetEmptyGrid()) {
                    Mgr.tips.ShowNotice("没有空位了", 0, cc.p(300, 300));
                    return;
                }
                Mgr.stall.SendReqStallDeleteGoodsMessage(self.info.iteminfo.itemId);
            } else if (self.btntype == EnumButtonType.SHIYONG) {//使用
                var list = Mgr.backpack.GetItemsByMid(self.info.itemModelId);
                if (list.length > 0)
                    Mgr.backpack.SendReqUseItemMessage(list[0].itemId, list[0].num);
            } else if (self.btntype == EnumButtonType.HUOQU) {//获取
                if (Mgr.uiMgr.IsPanelShowByName(HuoquTujingCueExt.PanelName)) {
                    Mgr.uiMgr.HidePanelByType(HuoquTujingCueExt.PanelName);
                    self.x += 150;
                }
                else {
                    Mgr.uiMgr.ShowPanelByType(HuoquTujingCueExt.PanelName, UIMgr.PANEL_LAYER_TOP);
                    self.x -= 150;
                    Mgr.uiMgr.GetPanelByType(HuoquTujingCueExt.PanelName).SetItemMid(self.info.itemModelId);
                }
                return;
            } else if (self.btntype == EnumButtonType.CUNRU) {
                var panel = Mgr.uiMgr.GetPanelByType(WarehouseMainExt.PanelName);
                var gid = panel.GetWHEmptyGrid();
                Mgr.store.SendReqBagToStoreMessage(self.info.itemId, gid, EnumStore.NORMAL);
            } else if (self.btntype == EnumButtonType.QUCHU) {
                var panel = Mgr.uiMgr.GetPanelByType(WarehouseMainExt.PanelName);
                var gid = panel.GetBPEmptyGrid();
                Mgr.store.SendReqStoreToBagMessage(self.info.itemId, gid, EnumStore.NORMAL);
            } else if (self.btntype == EnumButtonType.XUNBAOQUCHU) {
                var panel = Mgr.uiMgr.GetPanelByType(CangKuPanelExt.PanelName);
                if (Mgr.backpack.GetEmptyGrid()) {
                    if (panel)
                        panel.HideEffect();
                    Mgr.store.SendReqStoreToBagMessage(self.info.itemId, 0, EnumStore.LUCKY);
                } else {
                    Mgr.tips.ShowNotice("角色背包剩余空间不足，无法取出");
                }

            }
            EngineMgr.uiMgr.HidePanelByType(ItemTipsExt.PanelName);
        });

    },
    Updatedata: function (item, gType) {
        this.info = item;
        this.isButtonShow = true;
        this.isPriseShow = true;
        this.isShowInfo = false;
        GridUtil.SetItemGrid(this.gridIcon, item, null, null, null, false, false);
        var q_item = Q_item.Get(item.itemModelId);
        switch (gType) {
            case GridTypeEnum.BACKPACK:
            {
                if (Mgr.backpack.GetItemNumber(item.itemModelId) > 0) {
                    if (q_item.q_type == EnumItemType.GIFT || q_item.q_type == EnumItemType.AUTOUSE || q_item.q_type == EnumItemType.ATTRIBUTE || q_item.q_type == EnumItemType.ADDBUFF
                        || q_item.q_type == EnumItemType.SCRIPT || q_item.q_type == EnumItemType.SELECT_GIFT) {
                        this.btnGoumai.setTitleText("使用");
                        this.btntype = EnumButtonType.SHIYONG;
                    }
                } else {
                    this.btnGoumai.setTitleText("获取");
                    this.btntype = EnumButtonType.HUOQU;
                }
                this.isPriseShow = false;
                break;
            }
            case GridTypeEnum.STALL:
                Mgr.stall.SendReqStallItemPriceMessage(item.itemModelId, StallPriceUpdateEnum.STALL);
                this.btnGoumai.setTitleText("上架");
                this.btntype = 1;
                break;
            case GridTypeEnum.STORE:
                // Mgr.store.choose=item;
		this.isPriseShow=false;
                this.btnGoumai.visible = true;
                this.btnGoumai.setTitleText("取出");
                this.btntype = EnumButtonType.QUCHU;
                // this.isButtonShow=false;
                // this.isPriseShow=false;
                break;
            case GridTypeEnum.STOREBACKPACK:
		this.isPriseShow=false;
                this.btnGoumai.visible = true;
                this.btnGoumai.setTitleText("存入");
                this.btntype = EnumButtonType.CUNRU;
                break;
            case GridTypeEnum.EQUIP:
                this.isButtonShow = false;
                this.isPriseShow = false;
                break;
            case GridTypeEnum.EQUIPOTHER:
                this.isButtonShow = false;
                this.isPriseShow = false;
                break;
            case GridTypeEnum.XUNBAOSTORE:
		this.isPriseShow=false;
                this.btnGoumai.visible = true;
                this.btnGoumai.setTitleText("取出");
                this.btntype = EnumButtonType.XUNBAOQUCHU;
                break;
            default:
                this.isButtonShow = false;
                this.isPriseShow = false;
        }
        this.labName.SetString(q_item.q_name);
        var color = ItemUtil.GetNameColorById(q_item.q_id);
        if (color)
            this.labName.SetColor(color[0]);
        this.labNum.SetString(q_item.q_append);
        if (item.itemBind || item.isbind) {
            this.lab2.setVisible(true);
        } else {
            this.lab2.setVisible(false);
        }
        //道具说明
        var str = q_item.q_describe ? q_item.q_describe : "";
        this.labCue2.SetString(str);
        str = q_item.q_output ? q_item.q_output : "";
        this.labCue6.SetString(str);
        // 时限
        var lostTime = item.GetOverdueTime ? item.GetOverdueTime() : 0;
        if (lostTime > 0) {
            this.labTimedue.visible = true;
            UIUtil.ConnectLabelHtmlText(this.labTimedue, [TimeUtil.GetDateStr(lostTime)]);
        } else {
            this.labTimedue.visible = false;
        }

        if (this._titleModel)
            SkillEffect.Delete(this._titleModel);
        this._titleModel = null;
        if( this.imgTitleLine )
            this.imgTitleLine.visible = false;
        if (q_item.q_type === EnumItemType.TiTle) {
            var title = Mgr.title.GetTitleByItemId(q_item.q_id);
            if (title && title.q_art_type == 1) {
                this._titleModel = EffectUtil.GetShowEffect(title.q_art, EffectUtil.ENUM_TYPE_UI, true, -1);
                this._titleModel.x = this.uiWidth * 0.5;
                this.addChild(this._titleModel);
                if( !this.imgTitleLine ){
                    this.imgTitleLine = this.imgXian1111.clone();
                    this.addChild(this.imgTitleLine);
                }
                this.imgTitleLine.visible = true;
            }
        }

        this._CheckSize();
    },
    Update: function (info, type) {
        this.info = info;
        this.labCue3.SetString("【最近成交价】");
        this.isButtonShow = true;
        this.isPriseShow = true;
        var q_item = null;
        var item = null;
        if (type == 1) {
            item = info.iteminfo;
            q_item = Q_item.Get(info.iteminfo.itemModelId);
            this.labCue3.SetString("【总价】");
            this.labNumber.SetString(info.gold);
            GridUtil.SetItemGrid(this.gridIcon, info.iteminfo, null, null, null, false, false);
            this.btnGoumai.setTitleText("购买");
            this.btntype = EnumButtonType.GOUMAI;
        }
        else if (type == 2) {
            Mgr.stall.SendReqStallItemPriceMessage(info.iteminfo.itemModelId, StallPriceUpdateEnum.STALL);
            item = info.iteminfo;
            q_item = Q_item.Get(info.iteminfo.itemModelId, StallPriceUpdateEnum.STALL);
            GridUtil.SetItemGrid(this.gridIcon, info.iteminfo, null, null, null, false, false);
            this.btntype = EnumButtonType.XIAJIA;
            this.btnGoumai.setTitleText("下架");
        }
        else if (type == 3) {
            item = info;
            q_item = Q_item.Get(info.itemModelId);
            Mgr.stall.SendReqStallItemPriceMessage(info.itemModelId, StallPriceUpdateEnum.STALL);
            GridUtil.SetItemGrid(this.gridIcon, info, null, null, null, false, false);
            this.btnGoumai.setTitleText("上架");
            this.btntype = EnumButtonType.SHANGJIA;
        }
        else if (type == 4) {
            item = info.iteminfo;
            q_item = Q_item.Get(info.iteminfo.itemModelId);
            this.labCue3.SetString("【出售价格】");
            this.labNumber.SetString(info.gold);
            GridUtil.SetItemGrid(this.gridIcon, info.iteminfo, null, null, null, false, false);
            this.isButtonShow = false;
        }
        this.labName.SetString(q_item.q_name);
        var color = ItemUtil.GetNameColorById(q_item.q_id);
        if (color)
            this.labName.SetColor(color[0]);
        this.labNum.SetString(q_item.q_append);
        if (item.itemBind || item.isbind) {
            this.lab2.setVisible(true);
        } else {
            this.lab2.setVisible(false);
        }
        //道具说明
        var str = q_item.q_describe ? q_item.q_describe : "";
        this.labCue2.SetString(str);
        str = q_item.q_output ? q_item.q_output : "";
        this.labCue6.SetString(str);

        // 时限
        this.labTimedue.visible = false;

        if( this.imgTitleLine )
            this.imgTitleLine.visible = false;
        if (q_item.q_type === EnumItemType.TiTle) {
            var title = Mgr.title.GetTitleByItemId(q_item.q_id);
            if (title && title.q_art_type == 1) {
                this._titleModel = EffectUtil.GetShowEffect(title.q_art, EffectUtil.ENUM_TYPE_UI, true, -1);
                this._titleModel.x = this.uiWidth * 0.5;
                this.addChild(this._titleModel);
                if( !this.imgTitleLine ){
                    this.imgTitleLine = this.imgXian1111.clone();
                    this.addChild(this.imgTitleLine);
                }
                this.imgTitleLine.visible = true;
            }
        }

        this._CheckSize();
    },
    UpdatePriceInfo: function (info) {
        this.price = info;
        if (info.lastPrice == 0) {
            this.labNumber.SetString("暂无成交记录");
            this.imgGold.setVisible(false);
        } else {
            this.labNumber.SetString(info.lastPrice);
            this.imgGold.setVisible(true);
        }
    },

    ShowModel: function (model) {                    //展示基础信息的
        this.info = null;
        this.isButtonShow = false;
        this.isPriseShow = false;
        var itemIcon = ItemUtil.GetItemIcon(model, 3);
        itemIcon.x = (this.gridIcon.uiWidth - itemIcon.width) / 2;
        itemIcon.y = (this.gridIcon.uiHeight - itemIcon.height) / 2;
        // 既然用SetGridIcon 就清下吧
        this.gridIcon.Clean();
        this.gridIcon.SetGridIcon(itemIcon);

        var q_item = Q_item.Get(model);
        this.labName.SetString(q_item.q_name);
        var color = ItemUtil.GetNameColorById(q_item.q_id);
        if (color)
            this.labName.SetColor(color[0]);
        this.labNum.SetString(q_item.q_append);
        this.lab2.setVisible(false);
        //道具说明
        var str = q_item.q_describe ? q_item.q_describe : "";
        this.labCue2.SetString(str);
        str = q_item.q_output ? q_item.q_output : "";
        this.labCue6.SetString(str);

        if( this.imgTitleLine )
            this.imgTitleLine.visible = false;
        if (q_item.q_type === EnumItemType.TiTle) {
            var title = Mgr.title.GetTitleByItemId(q_item.q_id);
            if (title && title.q_art_type == 1) {
                this._titleModel = EffectUtil.GetShowEffect(title.q_art, EffectUtil.ENUM_TYPE_UI, true, -1);
                this._titleModel.x = this.uiWidth * 0.5;
                this.addChild(this._titleModel);
                if( !this.imgTitleLine ){
                    this.imgTitleLine = this.imgXian1111.clone();
                    this.addChild(this.imgTitleLine);
                }
                this.imgTitleLine.visible = true;
            }
        }

        this._CheckSize();
    },

    _CheckSize: function () {
        var starY = 14;
        var size1 = 11, size2 = 24, size3 = 26;
        if (this.isButtonShow) {                         //按钮
            this.btnGoumai.setVisible(true);
            starY = Mgr.tips.ChangeSize(this.btnGoumai, starY, 58);
            this.imgXianButton.setVisible(true);
            starY = Mgr.tips.ChangeSize(this.imgXianButton, starY, size1);
        }
        else {
            this.btnGoumai.setVisible(false);
            this.imgXianButton.setVisible(false);
        }
        if (this.isPriseShow) {                           //价格
            this.imgListBg7.setVisible(true);
            this.imgXian.setVisible(true);
            starY = Mgr.tips.ChangeSize(this.imgListBg7, starY, size3);
            starY = Mgr.tips.ChangeSize(this.imgXian, starY, size1);
        }
        else {
            this.imgListBg7.setVisible(false);
            this.imgXian.setVisible(false);
        }
        // 过期时间
        if (this.labTimedue.visible) {
            starY = Mgr.tips.ChangeSize(this.labTimedue, starY, 50);
        }

        if (this.labCue6.GetString() != "") {
            this.labCue6.setVisible(true);
            this.labCue7.setVisible(true);
            this.imgXian111.setVisible(true);
            var row = this.labCue6.GetRows();
            starY += (row - 1) * 21;
            starY = Mgr.tips.ChangeSize(this.labCue6, starY, size2);
            starY = Mgr.tips.ChangeSize(this.labCue7, starY, size3);
            starY = Mgr.tips.ChangeSize(this.imgXian111, starY, size1);
        } else {
            this.labCue6.setVisible(false);
            this.labCue7.setVisible(false);
            this.imgXian111.setVisible(false);
        }

        if (this.labCue1.GetString() != "") {
            this.labCue2.setVisible(true);
            this.labCue1.setVisible(true);
            this.imgXian1111.setVisible(true);
            var row = this.labCue2.GetRows();
            starY += (row - 1) * 21;
            starY = Mgr.tips.ChangeSize(this.labCue2, starY, size2);
            starY = Mgr.tips.ChangeSize(this.labCue1, starY, size3);
            starY = Mgr.tips.ChangeSize(this.imgXian1111, starY, size1);
        } else {
            this.labCue2.setVisible(false);
            this.labCue1.setVisible(false);
            this.imgXian1111.setVisible(false);
        }
        starY = Mgr.tips.ChangeSize(this.imgHead, starY, 95);
        if (this._titleModel) {
            starY = Mgr.tips.ChangeSize(this.imgTitleLine, starY, 10 );
            starY = Mgr.tips.ChangeSize(this._titleModel, starY + 50, 50);
        }
        starY = Mgr.tips.ChangeSize(this.imgTitle, starY, 55);
        this.setSize(379, starY);
        this.y += (this.dHeight - starY) / 2;
        this.dHeight = starY;
    },

    OnHide: function () {
        if (Mgr.uiMgr.IsPanelShowByName(HuoquTujingCueExt.PanelName)) {
            Mgr.uiMgr.HidePanelByType(HuoquTujingCueExt.PanelName);
        }
        if (this._titleModel)
            SkillEffect.Delete(this._titleModel);
        this._titleModel = null;
    }
});
ItemTipsExt.PanelName = "ItemTipsExt";
PanelClassDic["ItemTipsExt"] = ItemTipsExt;
