﻿var TitleModMgr = TitleModMgr || cc.Class.extend({ 

	titleList:null,
	titleData:null,
	titleTool:null,//激活道具
	cTouxian:null,//
	ctor:function() {
		this.titleList = new HashMap();
		this.titleTool = new HashMap();
		this.titleData = new HashMap();
	},

	RecvResTitleInfoMessage:function(msg) {
		var data = msg.titleInfos;
		var len = data.length;
		for ( var i = 0; i < len; i++ )
		{
			this.titleList.Put(data[i].titleModel,data[i]);
		}
	},

	RecvResTitleActivateInfoMessage:function(msg) {
	},

	RecvResActivateTitleMessage:function(msg) {
		this.titleList.Put(msg.actTitleInfo.titleModel,msg.actTitleInfo);
		this.SendReqUseTitleMessage(msg.actTitleInfo.titleModel, 1);	//激活称号自动穿戴
		var panel = Mgr.uiMgr.GetPanelByType(ChengHaoPanelExt.PanelName);
		if(panel && panel.visible)
		{
			panel.RefreshList(0);
		}else {
            panel = Mgr.uiMgr.ShowPanelByType(ChengHaoPanelExt.PanelName);
            panel.index = 0;//0是已获得
            panel.UpdateTableview();
            panel._ChangeButton(0);
		}
	},
	//称号改变
	RecvResTitleChangeMessage:function(msg) {
		var pId = Mgr.player.mainPlayer.sid;
		if(pId.toGID() == msg.playerid.toGID())
		{
			Mgr.player.mainPlayer.titleId = msg.titleModel;
			var panel = Mgr.uiMgr.GetPanelByType(ChengHaoPanelExt.PanelName);
			if(panel && panel.visible)
			{
				panel.RefreshList(0);
			}
		}
		var obj = Mgr.sceneObj.FindObject(msg.playerid.toGID());
		if( obj )
		{
			obj.SetTitleShow(msg.titleModel);
		}
	},

	RecvResTitleLostMessage:function(msg) {	
	},
	//头衔信息
	RecvResHeadTitleInfoMessage:function(msg) {
		this.cTouxian = Q_monicker.Get(msg.headTitleId);
		var panel = Mgr.uiMgr.GetPanelByType(TouXianPanelExt.PanelName);
		if(panel && panel.visible)
		{
			panel.UpdateInformation(this.cTouxian);
		}
		var panel2 = Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName );
		if(panel2 && panel2.visible)
		{
			panel2._equipPanel.ShowTouxianRedPoint(this.cTouxian);
		}
		var panel3 = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName );
		if(panel3)
		{
			panel3.UpDataTouXianWarn();
		}
		//Mgr.player.mainPlayer.headTitleId = msg.headTitleId;
		var pId = Mgr.player.mainPlayer.sid;
		var obj = Mgr.sceneObj.FindObject(pId.toGID());
		if( obj ){
			var name = Mgr.player.mainPlayer.name;
			obj.oHeadTitleId = msg.headTitleId;
			obj.SetNameShow(name, true);
		}
	},
	//称号完成条件信息
	SendReqTitleActivateInfoMessage:function(titleModel) {
		var msg = new ReqTitleActivateInfoMessage();
		msg.titleModel = titleModel;
		Mgr.msgMgr.Send(msg);
	},
	//激活
	SendReqActivateTitleMessage:function(titleModel) {
		var msg = new ReqActivateTitleMessage();
		msg.titleModel = titleModel;
		Mgr.msgMgr.Send(msg);
	},
	//穿戴
	SendReqUseTitleMessage:function(titleModel,type) {
		var msg = new ReqUseTitleMessage();
		msg.titleModel = titleModel;
		msg.type = type;
		Mgr.msgMgr.Send(msg);
	},
	SendReqHeadTitleInfoMessage:function(msg) {
		var msg = new ReqHeadTitleInfoMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqHeadTitleUpLevelMessage:function(msg) {
		var msg = new ReqHeadTitleUpLevelMessage();
		Mgr.msgMgr.Send(msg);
	},
	GetTitleListData:function()
	{
		this.titleData.Clear();
		var list01 = this.titleList.Values();
		for(var i = 0; i < list01.length; i++ )
		{
			var item = Q_title.Get(list01[i].titleModel);
			this.titleData.Put(list01[i].titleModel, item);
		}
		return this.titleData;
	},
	GetTouxianUpItemCount:function(itemModelId)
	{
		return Mgr.backpack.GetItemNumber(itemModelId);
	},
	q_titleData:null,
	GetTitleData:function()
	{
		if( !this.q_titleData ){
			this.q_titleData = [[]];
			var list = 	Q_title.GetList();
			for(var i = 0; i < list.length; i++ )
			{
				var type = list[i].q_subfield;
				if( !list[i].q_web ){
					if( !this.q_titleData[type] )
						this.q_titleData.push([]);
					this.q_titleData[type].push(list[i]);
				}
			}
		}
		return this.q_titleData;
	},
	GetTitleByItemId:function(itemId){
		var list = 	Q_title.GetList();
		for( var i = 0, len  = list.length; i < len; i++ ){
			var title = list[i];
			if( title.q_activate_item ){
				var arr = JSON.parse(title.q_activate_item);
				for( var j = 0; j < arr.length; j++ ){
					if( arr[j][0] == itemId )
						return title;
				}
			}
		}
		return null;
	},
	RefreshTitleMgrArr:function()
	{
		this.GetTitleData();
		return this.ControlEquipPanelRedPoint();
	},
	ControlEquipPanelRedPoint:function()
	{
		var len = this.q_titleData.length;
		for(var i = 1; i < len;i++)
		{
			var item = this.q_titleData[i];
			for(var j = 0,len01=item.length; j<len01; j++)
			{
				var str = item[j].q_activate_item;
				if(str && !this.titleList.Get(item[j].q_id))
				{
					var regexp = /\d+/;
					var id = Number(str.match(regexp));
					var regext1 = /,\d+/;
					var numArr = str.match(regext1);
					var needNum = numArr[0].substring(1,numArr[0].length);
					var cNum = this.GetTouxianUpItemCount(id);
					var bool = this.titleList.Get(id);
					if(cNum>=needNum &&!bool)
					{
						return true;
					}
				}
			}
		}
		return false;
	},
	ShowTouxianRedPoint:function()
	{
	    var data = this.cTouxian;
		var power = Mgr.fightpower.fightPower;
		var isTools = false;
		var isNew = false;
		var needPower = 0;
		if(data)
		{
			needPower = data.q_fighting_capacity
			if(data.q_level + 1 < 10)
			{
				var dataUp = Q_monicker.Get(data.q_level+1);
				needPower = dataUp.q_fighting_capacity
				isTools = this._GetTouxianUpNeedNum(dataUp,data.q_level);
			}
		}
		else
		{
			var dataUp = Q_monicker.Get(1);
			needPower = dataUp.q_fighting_capacity
			isTools = this._GetTouxianUpNeedNum(dataUp,dataUp.q_level);
		}
		if((power>=needPower)&&isTools)
		{
			isNew = true;
		}
		return isNew;
	},
	_GetTouxianUpNeedNum:function(data,cLevel)
	{
		var str = 	data.q_activate_item;
		if(str){
            var mm = str.match(/\[(\d+),(\d+)\]/);
            if(!mm) return true;

            var itemModelId = Number(mm[1]);
            var needItemCount = Number(mm[2]);

            var currentItemCount = this.GetTouxianUpItemCount(itemModelId);
            var len = Q_monicker.GetList().length;

			if(currentItemCount >= needItemCount && cLevel != len)
			{
				return true;
			}
		}
		return false;
	},


    SetTitleImage:function(image,titleId){
        if(!image) return;

        if(image.$titleEffect){
            SkillEffect.Delete(image.$titleEffect);
            image.$titleEffect = null
        }

        image.visible = false

        var titleC = Q_title.Get(titleId)
        if(!titleC) return;

        switch(titleC.q_art_type){
            case 0://图片
            {
                image.visible = true
//                EngineMgr.uiMgr.LoadOtherRes("other/touxian",{ Callback:function(){}, ErrCallback:function(){},});
                let url = "other/zhujiemian/chenghao/" + titleC.q_art + ".png";
                UIUtil.LoadImage(image,url,false,false)
            }break
            case 1://特效
            {
                image.visible = true
                image.loadTexture("", 1);

                let c = EffectUtil.GetShowEffect(titleC.q_art, EffectUtil.ENUM_TYPE_UI, true ,-1);
                if(c){
                    c.x = image.width / 2
                    c.y = image.height / 2
                    image.addChild(c);
                }
            }break
        }
    },
});



















