var PHBPlayerInfoExt = PHBPlayerInfo.extend ( {
	_className:"PHBPlayerInfoExt",
	info:null,
	mod:null,
	modUrl:null,
	wepUrl:null,
	ctor:function(){
		this._super();
		Mgr.top.playInfoPanel=this;
		this.layoutCom.layoutType = MLLAYOUT_C;
	},
	Init:function(){
		PHBPanel.prototype.Init.call( this );
		this.btnClose.addClickEventListener(function(){
			EngineMgr.uiMgr.HidePanelByType(PHBPlayerInfoExt.PanelName);
		});
		var self=this;
		this.mod=new MAnimationGroup();
		this.mod.setScale(2);
		this.imgMondel.addChild(this.mod);
		this.btnTianjia.addClickEventListener(function(){
			Mgr.friend.SendReqApplyFriendMessage(self.info.playerid);
		});
	},
	SetData:function(info){
		this.info=info;
		if(info.guildName)
		    this.labGuildName.SetString(info.guildName);
		else
			this.labGuildName.SetString("无");
		this.labName.SetString(info.playerName);
		this.labNumber.SetString(info.fightpower);
		for(var i=0;i<info.equips.length;++i){
			cc.log("装备有这些："+ Q_item.Get(info.equips[i].itemId).q_name)
		}
		//装备info.equipsinfo  [ItemInfo]
		// info.job ; // 玩家职业
		//info.curFashion  []; 时装Id int;
		var player={};
		//时装先不要
		player.nJobId=info.job;
		var nurl = SceneObjUtil.GetPlayerBodyUrl(info.job);
		if(nurl!=this.modUrl) {
			this.modUrl=nurl;
			this.mod.SetResUrlNoAction(nurl);
			this.mod.DoAction(EnumActionName.STAND, 5, EnumDefaultResType.SCENE_OBJ);
		}
		var wep = SceneObjUtil.GetPlayerWepUrl(info.job);
		if(wep!=this.wepUrl) {
			if(this.wepUrl)
				this.mod.RemoveBindPart(wep);
			this.wepUrl=wep;
			this.mod.AddBindPart(wep);
		}
	}
} );
PHBPlayerInfoExt.PanelName = "PHBPlayerInfoExt";
PanelClassDic["PHBPlayerInfoExt"] = PHBPlayerInfoExt;
