var ShenjiBoxPanelExt = ShenjiBoxPanel.extend ( {
	_className:"ShenjiBoxPanelExt",

	_mid:103,

	//  获奖list
	_listView1 : null,
	_itemList1:null,
	_curSelectItem1:null,

	//  道具list
	_listView2 : null,
	_itemList2:null,
	_curSelectItem2:null,

	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.layoutCom.layoutType = MLLAYOUT_C;

		this._itemList1 = [];
		this._itemList2 = [];
	},

	Init:function() {
		var self = this;
		ShenjiBoxPanel.prototype.Init.call(this);

		this._InitParam();

		this.btnOpenBox.addClickEventListener(function (event){
			var num = Mgr.backpack.GetItemNumber( self._mid );
			if ( num <= 0 ) {
				Mgr.tips.ShowNotice("道具不足");
				return;
			}

			var array = JSON.parse(Q_lucky_draw_total.Get(EnumLucky.GODBOX).q_currency_cost);
			var cost_type = array[0][1];
			var cost_value = array[0][2];
			var value = Mgr.mainPlayer.attributeData.GetAttribute(cost_type, AttributeData.Money);
			if ( value < cost_value ) {
				// Mgr.tips.ShowNotice("元宝不足");
				AlertExt.NoEnoughGold( cost_value - value );
				return;
			}

			Mgr.luckydraw.type = EnumLucky.GODBOX;
			Mgr.luckydraw.index = 0;
			Mgr.luckydraw.SendReqLuckyDrawPerformClientToGameMessage();
		});

		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});
	},

	_InitParam:function () {
		this.gridItem.visible = false;
		this._CreateListView();
	},

	_CreateListView:function () {
		// listView1
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg1.width, this.imgBg1.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		//list.addEventListener(this._SelectedItemEvent1);
		list.setItemsMargin(2);
		this.imgBg1.addChild(list);
		this._listView1 = list;

		// listView2
		var listx = new ccui.ScrollView();
		listx.setDirection(ccui.ScrollView.DIR_VERTICAL);
		listx.setContentSize(cc.size(this.imgBg2.width, this.imgBg2.height));
		listx.setTouchEnabled(true);
		listx.setInertiaScrollEnabled(true);
		listx.setBounceEnabled(true);
		listx.setAnchorPoint(0, 1);
		listx.setPosition(0,this.imgBg2.height);
		this.imgBg2.addChild(listx);
		this._listView2 = listx;
	},

	_LaodListView2:function () {
		// listView2
		this._listView2.removeAllChildren();
		var _total_row = 0;
		var idArr = JSON.parse( Q_global.Get( 1049 ).q_string_value );
		for ( var i = 0; i != idArr.length; i++ ) {
			var grid;
			if ( i < this._itemList2.length )
				grid = this._itemList2[i];
			else {
				grid = new MUIGrid();
				grid.ParseJson(this.gridItem.jsonobj);
				grid.Init();
				grid.retain();
				this._itemList2.push(grid);
			}
			var json = idArr[i];
			var item = ItemUtil.ItemIdToItem(json[0].mod, json[0].num);
			GridUtil.SetItemGrid(grid,item);
			//this._SetGridItem( grid, {mod:510103, num:10}/**/ );

			// pos
			grid.setAnchorPoint(0,1);
			var line = i % 4;
			var row = parseInt(i/4);
			_total_row = parseInt(idArr.length/4);
			if ( idArr.length % 4 > 0 )
				_total_row += 1;
			row = _total_row - row;
			var pos_x = (grid.width + 7)*line;
			var pos_y = (grid.height + 7)*row;
			grid.x = pos_x;
			grid.y = pos_y;
			this._listView2.addChild(grid);
		}

		// set InnerContainerSize size
		var innerContainerHeght = (this.gridItem.height + 7)*_total_row;
		this._listView2.setInnerContainerSize(cc.size(this.imgBg2.width, (this.gridItem.height + 7)*_total_row));

		//超出范围才可滑动
		if ( this._listView2.getContentSize().height >= innerContainerHeght )
			this._listView2.setTouchEnabled(false);
		else
			this._listView2.setTouchEnabled(true);
	},

	SetData:function (records) {
		// 神机宝箱
		var num = Mgr.backpack.GetItemNumber( this._mid );
		this.labBoxNum.SetString(num);

		// 花费
		var str_cost = "开启宝箱需要";
		var array = JSON.parse(Q_lucky_draw_total.Get(EnumLucky.GODBOX).q_currency_cost);
		if ( array[0][1] == EnumMoney.GOLD ) {
			str_cost += array[0][2] + "元宝";
		}
		this.labOpenGold.SetString(str_cost);

		// listView2
		this._LaodListView2();

		// listView1
		this._listView1.removeAllChildren();
		for ( var i = 0; i != records.length; i++ ) {
			var item;
			if ( i < this._itemList1.length )
				item = this._itemList1[i];
			else {
				item = new ShenjiBoxItemExt();
				item.LoadPanel();
				item.retain();
				this._itemList1.push(item);
			}
			item.SetData( records[i] );
			if (this._listView1.getIndex(item) == -1)
				this._listView1.pushBackCustomItem(item);
		}
	},

	SetPlayerBriefMsg:function ( data ) {
		// 角色详情界面
		var panel = Mgr.uiMgr.ShowPanelByType( OtherRolePanelExt.PanelName );
		panel.SetData(data, EnumDetails.OPEN_MODE_NORMAL);
	},

	OnShow:function () {
		Mgr.uiMgr.HidePanelByType(BackpackPanelExt.PanelName);
	},
} );
ShenjiBoxPanelExt.PanelName = "ShenjiBoxPanelExt";
PanelClassDic["ShenjiBoxPanelExt"] = ShenjiBoxPanelExt;
