﻿var VipModMgr = VipModMgr || cc.Class.extend({ 

	ctor:function() {
        this.rewardAvailable = false;
	},

	RecvResVipDataInfoMessage:function(msg) {
		Mgr.player.mainPlayer.VIP = msg.vipInfo.vipLevel;
		var panel = Mgr.uiMgr.GetPanelByType( TaijiPanelExt.PanelName );
		if ( panel ) {
			var page = panel.vipPanel;
			if ( page )
				page.SetData(msg.vipInfo);
		}

        var warned = true;
        var vipInfo = msg.vipInfo || {};
        var levelReward = vipInfo.levelReward || [];
        var vipLevel = vipInfo.vipLevel || 0;

        var list = Q_vip.GetList();
        for(var i=0;i!=list.length;++i){
            var v = list[i];

            if(v.q_level > vipLevel) continue;

            warned = false;
            for(var j=0;j!=levelReward.length;++j){
                if(v.q_level == levelReward[j]){
                    warned = true;
                    break;
                }
            }
            if(!warned) break;
        }

        this.rewardAvailable = !warned;
        var panel = Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName);
        if(panel) panel.UpdateVipWarn(!warned);
        var panel = Mgr.uiMgr.GetPanelByType(TaijiPanelExt.PanelName);
        if(panel) panel.UpdateVipWarn(!warned);
	},

	RecvResPlatformVipRewardStateMessage:function(msg) {
		cc.log("------------- 平台VIP领奖状态 ------------- ");
	},

	SendReqGetWeeklyAwardMessage:function() {
		cc.log("------------- 领取vip周奖励 -------------");
		var msg = new ReqGetWeeklyAwardMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqGetVipAwardMessage:function(v) {
        var msg = new ReqGetVipLevelRewardMessage();
        msg.vipLevel = v.vipLevel;
        Mgr.msgMgr.Send(msg);
	},

	SendReqVipDataInfoMessage:function() {
		cc.log("------------- 请求VIP信息 -------------");
		var msg = new ReqVipDataInfoMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqPlatformVipRewardStateMessage:function(msg) {	
	},

	SendReqGetPlatformVipRewardMessage:function(msg) {	
	}
});