var XingYunZhuanPanPanelExt = XingYunZhuanPanPanel.extend ( {
	_className:"XingYunZhuanPanPanelExt",

	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -30;
	},

	Init:function () {
		XingYunZhuanPanPanel.prototype.Init.call(this);

		Mgr.luckydraw.xingYunPanel = this;
		this.imgTitle2.setVisible(false);
		var self = this;
		this.btnClose.addClickEventListener(function (sender) {
			Mgr.uiMgr.HidePanel(self);
        });
    },

    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        this.mainPanelKey = mainPanelKey;
        var list = Mgr.dailyactivity.GetActivityByKey(this.mainPanelKey);
        this.acInfos = list;

        if(this.luckyDrawPanel && this.luckyDrawPanel.isOpenShoping){
            this.ShowLuckyShop();
        }
    },

    UpdateSingleActivity:function (ac) {
	    for(var i = 0, len = this.acInfos.length; i < len; i++){
	        if(this.acInfos[i].activityId == ac.activityId){
	            this.acInfos[i] = ac;
	            break;
            }
        }

        if(ac.tabKey == 2){
            this.luckyShopPanel.jiFenDuiHuanPanel.RefreshJiFen(ac);
        }else if(ac.tabKey == 3){
            this.luckyShopPanel.jiFenDuiHuanPanel.RefreshShop(ac);
        }
    },

	OnShow:function () {
		this.ShowLuckyDraw();
        Mgr.luckydraw.SendReqLuckyDrawInfoClientToGameMessage(EnumLucky.SPINWIN);
    },

	ShowLuckyDraw:function () {
		if(!this.luckyDrawPanel){
            var panel = new XingYunZhuanPanMainExt();
            panel.LoadPanel();
            panel.retain();
            panel.parentPanel = this;
            this.imgContent.addChild(panel);
            this.luckyDrawPanel = panel;
		}
    },

	ShowLuckyShop:function () {
	    if(this.luckyDrawPanel) this.luckyDrawPanel.isOpenShoping = false;
        this.luckyShopPanel = Mgr.uiMgr.ShowPanelByType(JiFenShangChengMainExt.PanelName);
        this.luckyShopPanel.ShowDetail();
    },
	GetInfosByTabKey:function (key) {// 2 - 积分兑换, 3 - 积分商城
		var temp = [];
		for(var i = 0, len = this.acInfos.length; i < len; i++){
			var ac = this.acInfos[i];
			if(ac.tabKey == key){
				temp.push(ac);
			}
		}
		return temp;
    },
} );
XingYunZhuanPanPanelExt.PanelName = "XingYunZhuanPanPanelExt";
PanelClassDic["XingYunZhuanPanPanelExt"] = XingYunZhuanPanPanelExt;
