var YoujianFrameExt = YoujianFrame.extend ( {
	_className:"YoujianFrameExt",
	_btnStates:[],
	ctor:function(data){
		this._super();
		this.data = data;
		this.isChecked = false;
		this._btnStates = [ MUICheckBox.STATE_CHECK , MUICheckBox.STATE_UNCHECK];
	},
	Init:function()
	{
		var self = this;
		YoujianFrame.prototype.Init.call(this);
		this.sbtnGouxuan.addClickEventListener(function()
		{
			self._HandleGouxuan01(self);
		});
		this.imgFrame.setTouchEnabled(true);
		this.setSwallowTouches(false);
		this.imgFrame.setSwallowTouches(false);
		this.imgFrame.addClickEventListener(function()
		{
			self.ReadMail();
		});
		this.imgCover.setSwallowTouches(false);
		this.imgCover.addClickEventListener(function()
		{
			self.ReadMail();
		});
		this._SetBaseProperty();
		this._SetInfo(this.data);
	},
	_SetBaseProperty:function()
	{
		this.labCue.SetColor(EnumFontFormat.COMMON_COLOR02);
		this.labCue.SetFontSize(18);
		this.labTime.SetColor(EnumFontFormat.COMMON_COLOR03);
		this.labTime.SetFontSize(18);
		this.imgOpen.visible = false;
		this.imgClose.visible = true;
		this.imgCover.visible = false;
	},
	_SetInfo:function(data)
	{
		if(data)
		{
			//cc.log("data==> "+JSON.stringify(data));
			this.HandleGouxuan();
			this.SetSelectedFlag(data.isSelected);
			this._SetReadedFlag(data.isReaded);
			this.labCue.SetString(data.subject);
			var timeStr = TimeUtil.GetTimeStr(data.sendTime );
			timeStr = timeStr.replace("年","-");
			timeStr = timeStr.replace("月","-");
			timeStr = timeStr.replace("日"," ");
			this.labTime.SetString(timeStr);
			if(data.items.length < 1)
			{
				this.imgGift.visible = false;
			}
			if(data.isReceive)
			{
				this.SetReadedFlag();
				this.imgGift.visible = false;
			}
			if(data.items.length>0 && !data.isReceive)
			{
				this.imgGift.visible = true;
			}
		}
	},
	HandleGouxuan:function()
	{
		this.isChecked = this.data.isChecked;
		if( this.isChecked)
		{
			this.sbtnGouxuan.SetButtonState(this._btnStates[0]);
			this._GetMailpanel().selectItemArr.Put(this.data.mailInfoId,this);
		}
		else
		{
			this.sbtnGouxuan.SetButtonState(this._btnStates[1]);
			this._GetMailpanel().selectItemArr.Remove(this.data.mailInfoId);
		}
	},
	_HandleGouxuan01:function()
	{
		this.isChecked = this.data.isChecked;
		if( this.isChecked)
		{
			this.sbtnGouxuan.SetButtonState(this._btnStates[1]);
			this._GetMailpanel().selectItemArr.Remove(this.data.mailInfoId);
		}
		else
		{
			this.sbtnGouxuan.SetButtonState(this._btnStates[0]);
			this._GetMailpanel().selectItemArr.Put(this.data.mailInfoId,this);
			this.ReadMail();
		}
		this.data.isChecked = !this.isChecked;
		Mgr.mail.mailList.Get(this.data.mailInfoId ).isChecked = !this.isChecked;
	},
	ReadMail:function()
	{
		Mgr.mail.SendReqGetMailAttachmentMessage(this.data.mailInfoId);
		var yjPanel = Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName);
		yjPanel.youjianPanel.SetSelectedItem(this);
	},
	UpdateData:function(data)
	{
		this.data = data;
		this.imgGift.visible = false;
	},
	UpdateInfo:function(data)
	{
		if ( data )
		{
			this.data = data;
			this._SetInfo(data);
		}
	},
	SetReadedFlag:function()
	{
		this.imgOpen.visible = true;
		this.imgClose.visible = false;
	},
	_SetReadedFlag:function(isOpen)
	{
		if(isOpen)
		{
			this.imgOpen.visible = true;
			this.imgClose.visible = false;
		}
	},
	SetSelectedFlag:function(isSelected)
	{
		this.imgCover.visible = isSelected;
		this.imgFrame.visible = !isSelected;
		if(isSelected)
		{
			//var yjPanel = Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName);
			//yjPanel.youjianPanel.SetSelectedItem(this);
			this._GetMailpanel().SetSelectedItem(this);
		}
	},
	_GetMailpanel:function()
	{
		if( !this.mailPanel)
		{
			this.mailPanel = Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName);
		}
		return this.mailPanel.youjianPanel;
	}
} );
YoujianFrameExt.PanelName = "YoujianFrameExt";
PanelClassDic["YoujianFrameExt"] = YoujianFrameExt;






















