var BattlePanelExt = BattlePanel.extend ( {
	_className:"BattlePanelExt",
	_panList:null,
	_sbtnList:null,
	_btnTypeArr:null,
	curView:0,
	vipFubenPanel:null,
	storyPanel:null,
	jinjiePanel:null,
	wendingPanel:null,
	_curPanel:null,
	_curBtn:null,
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
	},
	Init:function(){
		BattlePanel.prototype.Init.call( this );
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -28;
		Mgr.zone.battleZoneBackGroundPanel = this;
		this._panList = [];
		this._sbtnList = [this.btnJinjie , this.btnExp , this.btnJuqing ,this.btnWending, this.btnVip ];
		this._btnTypeArr = [EnumZoneType.TYPE_JJ, EnumZoneType.TYPE_JY, EnumZoneType.TYPE_JQ, EnumZoneType.TYPE_WD, EnumZoneType.TYPE_VIP];
		var self = this;
		for(var i=0; i < this._sbtnList.length; i++){
			(function(j){
				self._sbtnList[j].addClickEventListener(function () {
					self.ClickBtn(self._sbtnList[j]);
				});
			})(i);
		}


		var self = this;
//		this.SetDragEnable( true );
		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanelByType( BattlePanelExt.PanelName );
		});
	},

	ClickBtn:function ( btn ){
		if( btn == this.btnJinjie ){
			this.ChangeView( EnumZoneType.TYPE_JJ );
		}else if( btn == this.btnJuqing ){
			this.ChangeView( EnumZoneType.TYPE_JQ );
		}else if( btn == this.btnWending ){
			this.ChangeView(  EnumZoneType.TYPE_WD );
		}else if( btn == this.btnExp ){
			this.ChangeView( EnumZoneType.TYPE_JY );
		}else if( btn == this.btnVip ){
			this.ChangeView( EnumZoneType.TYPE_VIP );
		}
	},
	ChangeView:function ( index, refresh, zoneId){
		if( refresh == null )
			refresh = false;
		if(this.curView == index && refresh == false)
			return;
		this.curView = index;
		if( this._curPanel )
			this._curPanel.OnHide();
		if( this._curBtn )
			this._curBtn.SetButtonState("uncheck");
		this.imgBg3.removeAllChildren(false);
		if( index == EnumZoneType.TYPE_JQ ){
			if( this.storyPanel == null ){
				this.storyPanel = new JuqingFubenMainExt();
				this.storyPanel.LoadPanel();
				this.storyPanel.retain();
				this.storyPanel.InitPanel();
				this.storyPanel.x = 0;
				this.storyPanel.y = 0;
			}	
			this._curPanel = this.storyPanel;
			this._curBtn = this.btnJuqing;
		}else if( index == EnumZoneType.TYPE_JJ ){
			if( this.jinjiePanel == null ){
				this.jinjiePanel = new JinjieFubenMainExt();
				this.jinjiePanel.LoadPanel();
				this.jinjiePanel.retain();
				this.jinjiePanel.InitPanel();
				this.jinjiePanel.x = 0;
				this.jinjiePanel.y = 0;
			}	
			this._curPanel = this.jinjiePanel;
			this._curBtn = this.btnJinjie;
		}else if( index == EnumZoneType.TYPE_JY ){
			if( this.jingyanfubenPanel == null ){
				this.jingyanfubenPanel = new JingyanfubenMainExt();
				this.jingyanfubenPanel.LoadPanel();
				this.jingyanfubenPanel.retain();
				this.jingyanfubenPanel.InitPanel();
				this.jingyanfubenPanel.x = 0;
				this.jingyanfubenPanel.y = 0;
			}	
			this._curPanel = this.jingyanfubenPanel;
			this._curBtn = this.btnExp;
		}else if( index == EnumZoneType.TYPE_WD ){
			if( this.wendingPanel == null ){
				this.wendingPanel = new WendingJianghuMainExt();
				this.wendingPanel.LoadPanel();
				this.wendingPanel.retain();
				this.wendingPanel.InitPanel();
				this.wendingPanel.x = 0;
				this.wendingPanel.y = 0;
			}
			this._curPanel = this.wendingPanel;
			this._curBtn = this.btnWending;
		}else if( index == EnumZoneType.TYPE_VIP ){
			if( this.vipFubenPanel == null ){
				this.vipFubenPanel = new VipFubenMainExt();
				this.vipFubenPanel.LoadPanel();
				this.vipFubenPanel.retain();
				this.vipFubenPanel.InitPanel();
				this.vipFubenPanel.x = 0;
				this.vipFubenPanel.y = 0;
			}	
			this._curPanel = this.vipFubenPanel;
			this._curBtn = this.btnVip;
		}
		else{
			this._curPanel = null;
		}
		if(this._curPanel != null){
			this.imgBg3.addChild(this._curPanel );
			this._curPanel.OnShow(zoneId);
		}
		if( this._curBtn != null ){
			this._curBtn.SetButtonState("check");
		}
//		this._ShowOrHideListview();
	},
//	_ShowOrHideListview:function()
//	{
//		for ( var i = 0; i < this._sbtnList.length; i++ )
//		{
//			if ( this.curView == this._btnTypeArr[i] )
//			{
//				this._sbtnList[i].SetTextColor(EnumFontFormat.BTN_SELECT_COLOR);
//				this._sbtnList[i].SetTextFontSize(EnumFontFormat.CHANNEL_FONTSIZE);
////				this._sbtnList[i].SetEnableOutline(EnumFontFormat.BTN_SELECT_MIAOBIAN_COLOR,EnumFontFormat.MIAOBIAN_SIZE);
////				this._sbtnList[i].buttonText.setPositionY((this._sbtnList[i].height - this._sbtnList[i].buttonText.GetHeight()) * 0.5);
//			}
//			else
//			{
//				this._sbtnList[i].SetTextColor(EnumFontFormat.BTN_NORMAL_COLOR);
//				this._sbtnList[i].SetTextFontSize(EnumFontFormat.CHANNEL_FONTSIZE);
////				this._sbtnList[i].SetEnableOutline(EnumFontFormat.BTN_NORMAL_MIAOBIAN_COLOR,EnumFontFormat.MIAOBIAN_SIZE);
//				this._sbtnList[i].buttonText.setPositionY((this._sbtnList[i].height - this._sbtnList[i].buttonText.GetHeight()) * 0.5 - 5);
//			}
//		}
//	},
	OnShow:function(){
		if(!this._curPanel)
			this.ChangeView(EnumZoneType.TYPE_JJ, true);
		else
        this.ChangeView(this.curView, true);
	},
	OnHide:function(){
		this._super();
		if(this._curPanel != null){
			this._curPanel.OnHide();
		}
		// this.curView = 0;
	}
} );
BattlePanelExt.PanelName = "BattlePanelExt";
PanelClassDic["BattlePanelExt"] = BattlePanelExt;
