var JingyanfubenMainExt = JingyanfubenMain.extend ( {
	_className:"JingyanfubenMainExt",
	_zoneItemHash:null,
	_zoneRawardItemArr:null,
	_zoneRawardItemWaveArr:null,
	_startIndex:0,
	_startRewardIndex:0,
	_zoneItemArr:null,
	_scrollView:null,
	_scrollRewardView:null,
	_cellNum:2,//显示cell个数
	_rewardCellNum:6,//显示cell个数
	cellW:0,
	rewardCellW:170,
	_isScrolling:false,
	_isRewardScrolling:false,
	_btnTxt:null,
	_canGetRawardIndex:-1,//需要显示宝箱对应进度条的索引（已领取 可领取）
	_rawardArr:null,
	_rawardWaveArr:null,
	_isShowpanel:true,//是onshow的时候
	_canSD:false,//是否可扫荡
	_maxLayer:0,//经验副本最高层数
	_isOverMaxLayer:false,//已经通关最高层
	ctor:function(){
		this._super();
	},

	Init:function(){
		JingyanfubenMain.prototype.Init.call( this );
		this._btnTxt = this.btnAgain.getTitleText();
		this.labCue8.SetHtmlText("<font color=\"#3a2707\">副本每日凌晨</font><font color=\"#00ff00\">00:00</font><font color=\"#3a2707\">重置</font>");
	},

	RegisterListeners:function(){
		var self = this;
		this._scrollView.addCCSEventListener(function () {
			self.UpdateProgBar(self);
		});
		this.btnLeft.addClickEventListener(function () {
			self.OnLeftHandler();
		} );
		this.btnRight.addClickEventListener(function () {
			self.OnRightHandler();
		} );
		this._scrollRewardView.addCCSEventListener(function () {
			self.UpdateRewardProgBar();
		});
		this.btnLeft1.addClickEventListener(function () {
			self.OnRewardLeftHandler();
		} );
		this.btnRight1.addClickEventListener(function () {
			self.OnRewardRightHandler();
		} );
		this.btnAgain.addClickEventListener(function () {
			if(this._isOverMaxLayer == true){
				Mgr.tips.ShowNotice("已通关最高层数，请明天再来");
			}else{
				var zoneData = Q_exp_zone.Get(Mgr.zone.jingyanNowWave);
				if(zoneData){
                    var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                    panel.visible = false;
					Mgr.zone.SendReqZoneEnterToGameMessage(zoneData.q_zone);
				}
			}
		} );
		this.btnSaodang.addClickEventListener(function () {
			if(self._canSD)
				Mgr.zone.SendReqBattleZoneSweepToGameMessage(EnumZoneType.TYPE_JY);
			else
				Mgr.tips.ShowNotice("当前已达到历史最高层数！");
		} );
	},

	InitPanel:function(){
		this.InitPageView();
		this.InitItems();
		this.InitRaward();
		this.RegisterListeners();
	},

	InitPageView:function(){
		this._scrollView = ccui.ScrollView();
		this._scrollView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
		this._scrollView.setTouchEnabled(true);
		this._scrollView.inertiaScrollEnabled=false;
		this._scrollView.setScrollBarEnabled(false);
		this._scrollView.setBounceEnabled(true);
		this.imgBg.addChild(this._scrollView);

		this._scrollRewardView = ccui.ScrollView();
		this._scrollRewardView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
		this._scrollRewardView.setTouchEnabled(true);
		this._scrollRewardView.inertiaScrollEnabled=false;
		this._scrollRewardView.setScrollBarEnabled(false);
		this._scrollRewardView.setBounceEnabled(true);
		this.imgBg4.addChild(this._scrollRewardView);
	},
	
	InitRaward:function(){
		var zoneList = Q_exp_zone.GetList();
		var length = zoneList.length;
		this._rawardArr = [];
		this._rawardWaveArr = [];
		for( var i = 0; i < length; i++ ){
			if(zoneList[i].q_reward_first){
				this._rawardArr.push(zoneList[i]);
				this._rawardWaveArr.push(zoneList[i].q_id);
			}
		}

		this._zoneRawardItemArr = [];
		this._zoneRawardItemWaveArr = [];
		// for( i = 0; i < rawardArr.length; i++ ){
		// 	var cell = new JingyanBoxExt();
		// 	cell.LoadPanel();
		// 	cell.retain();
		// 	cell.InitData(rawardArr[i], i);
		// 	cell.x = i * cell.width;
		// 	cell.y = 0;
		// 	this.rewardCellW = cell.width;
		// 	this._scrollRewardView.addChild(cell);
		// 	this._zoneRawardItemHash.Put(rawardArr[i].q_id, cell)
		// }
		this._scrollRewardView.setSize(cc.size(1022, 140));
		this._scrollRewardView.setInnerContainerSize(cc.size(this._rawardArr.length * this.rewardCellW, 140));
	},

	ShowRaward:function (wave) {
		var beginIndex = this._rawardWaveArr.indexOf(wave);
		if( beginIndex == -1 )
			beginIndex = 0;
		var endIndex = 0;
		if( beginIndex + this._rewardCellNum + 1 <= this._rawardWaveArr.length - 1 ){
			endIndex = beginIndex + this._rewardCellNum + 1;
			this._startRewardIndex = beginIndex;
		}else{
			endIndex = this._rawardWaveArr.length - 1;
			this._startRewardIndex = this._rawardWaveArr.length - 1 - this._rewardCellNum;
		}		
		for( i = this._startRewardIndex; i < endIndex; i++ ){
			var cell = this._GetRawardCell(this._rawardWaveArr[i],true);
			cell.InitData(this._rawardArr[i], i);
			cell.x = (i) * cell.width;
			this.rewardCellW = cell.width;
		}
		this._scrollRewardView.jumpToPercentHorizontal(this._startRewardIndex/(this._rawardArr.length-this._rewardCellNum)*100);
		this.UpdataRewardBtnState();
	},

	_GetRawardCell:function (wave, right) {
		var rawardcell = null;
		if( this._zoneRawardItemWaveArr.length >= (this._rewardCellNum+1) ){
			if(right){
				rawardcell = this._zoneRawardItemArr.shift();
				this._zoneRawardItemWaveArr.shift();
			}else{
				rawardcell = this._zoneRawardItemArr.pop();
				this._zoneRawardItemWaveArr.pop();
			}
		}else{
			var cell = new JingyanBoxExt();
			cell.LoadPanel();
			cell.retain();
			cell.y = 0;
			this._scrollRewardView.addChild(cell);
			rawardcell = cell;
		}
		if(right){
			this._zoneRawardItemArr.push(rawardcell);
			this._zoneRawardItemWaveArr.push(wave);
		}else{
			this._zoneRawardItemArr.unshift(rawardcell);
			this._zoneRawardItemWaveArr.unshift(wave);
		}
		return rawardcell;
	},

	InitItems:function(){
		this._zoneItemHash = new HashMap();
		// var zoneList = Mgr.dataMgr.GetZoneList().sort(this.ShortZoneData);
		// var length = zoneList.length;
		var zoneData = null;
		var num = 1;

		UIUtil.UIRemoveSelf(this.img1);
		this._scrollView.addChild(this.img1);
		var lastIma = new MUIImage();
		lastIma.ParseJson( this.img1.jsonobj );
		lastIma.Init();
		lastIma.retain();
		
		var zoneList = Q_exp_zone.GetList();
		this._maxLayer = zoneList.length;
		var maxZoneLv = 0;
		for( var i = 0; i < this._maxLayer; i++ )
		{
			zoneData = zoneList[ i ];
			if( !this._zoneItemHash.Get( zoneData.q_zone ) ){
				var zoneItem = new JingyanFrameExt();
				zoneItem.LoadPanel();
				zoneItem.retain();
				zoneItem.InitData( zoneData.q_zone, num, maxZoneLv );
				maxZoneLv = zoneItem.maxZoneLv;
				zoneItem.y = 0;
				zoneItem.x = this._zoneItemHash.Size() * zoneItem.width + this.img1.x + this.img1.uiWidth;
				this._scrollView.addChild(zoneItem);
				this._zoneItemHash.Put( zoneData.q_zone, zoneItem );
				this.cellW = zoneItem.width;
				num++;
			}
		}

		lastIma.x = this._zoneItemHash.Size() * zoneItem.width + this.img1.x + this.img1.uiWidth;
		this._scrollView.addChild(lastIma);
		this._scrollView.setSize(cc.size(1022, 310));
		this._scrollView.setInnerContainerSize(cc.size(this._zoneItemHash.Values().length * zoneItem.width + this.img1.x * 2 + this.img1.uiWidth * 2, 310));
		this._startIndex = 0;
		this._zoneItemArr = this._zoneItemHash.Values().sort(this.ShortZoneItemData);//?????????????这段是哪来的，需要看看
		this.UpdataBtnState();
	},
	
	UpdateData:function(nowWave, maxWave, fristRewardWave){
		this._canSD = nowWave < maxWave;
		if(this._canSD)
            Mgr.zone.AddbuttonEffect(this.btnSaodang, 996, true);
		else
            Mgr.zone.AddbuttonEffect(this.btnSaodang, 996, false);
		if(nowWave > this._maxLayer){
			this._isOverMaxLayer = true;
			this.btnAgain.setTitleText("已通关最高层");
		}
		else{
			this._isOverMaxLayer = false;			
			this.btnAgain.setTitleText(TextUtil.FormatStr( this._btnTxt, [ nowWave ] ));
		}
		for( var i = 0; i < this._zoneItemHash.Values().length; i++ ){
			this._zoneItemHash.Values()[i].UpdataState();
		}
		for( i = 0; i < this._zoneItemHash.Values().length; i++ ){
			if( this._zoneItemHash.Values()[i].NeedShow() ){
				this._startIndex = this._zoneItemHash.Values()[i].num - 1;
				break;
			}
		}
		this._scrollView.scrollToPercentHorizontal(this._startIndex/(this._zoneItemHash.Values().length-this._cellNum)*100, 0.5, true);
		this.UpdataBtnState();
		if( this._isShowpanel ){
			this.ShowRaward(fristRewardWave[fristRewardWave.length - 1]);
		}
		for( i = 0; i < this._zoneRawardItemArr.length; i++ ){
			this._zoneRawardItemArr[i].UpdateState();
			// if( this._zoneRawardItemHash.Values()[i].IsGetRaward() && this._zoneRawardItemHash.Values()[i].rawardIndex > this._canGetRawardIndex ){
			// 	this._canGetRawardIndex = this._zoneRawardItemHash.Values()[i].rawardIndex;
			// }
		}
		for( i = 0; i <= this._rawardWaveArr.length; i++ ){
			if( maxWave < this._rawardWaveArr[i] )
				break;
			if( this._rawardWaveArr[i] > fristRewardWave[fristRewardWave.length - 1] )
				this._canGetRawardIndex = i;
		}

		this.UpdateRewardProgBar();//这里更新一下进度条显示
	},

	UpdataBtnState:function () {
		if(this._startIndex == 0){
			this.btnLeft.setVisible(false);
		}else{
			this.btnLeft.setVisible(true);
		}
		if((-this._scrollView.getInnerContainerPosition().x) >= this._zoneItemHash.Values().length * this.cellW + this.img1.x*2 + this.img1.uiWidth * 2 - 1022 - 5){
			this.btnRight.setVisible(false);
		}else{
			this.btnRight.setVisible(true);
		}
	},

	UpdateProgBar:function(self){
		self._startIndex = (-self._scrollView.getInnerContainerPosition().x)/self.cellW;
		self.UpdataBtnState();
	},

	_InitIsScroll:function () {
		var self = this;
		TimerUtil.SetTimeout(this, function(){
			self._isScrolling = false;
		}, 500);
	},

	OnLeftHandler:function(){
		if(this._isScrolling)
			return;
		this._isScrolling = true;
		this._InitIsScroll();
		this._startIndex = Math.ceil(this._startIndex);
		if( this._startIndex > 0)
			this._startIndex--;
		else
			return;
		var scrollW = 0;
		if( this._startIndex == 0 ){
			scrollW = 0;
		}else{
			scrollW = this._startIndex * this.cellW;
		}
		this._scrollView.scrollToPercentHorizontal(scrollW/(this._zoneItemHash.Values().length * this.cellW + this.img1.x*2 + this.img1.uiWidth*2 - 1022)*100, 0.5, true);
	},

	OnRightHandler:function(){
		if(this._isScrolling)
			return;
		this._isScrolling = true;
		this._InitIsScroll();
		this._startIndex = Math.floor(this._startIndex);
		if( this._startIndex < (this._zoneItemHash.Values().length-this._cellNum-1))
			this._startIndex++;
		else{
			this._startIndex = this._zoneItemHash.Values().length-this._cellNum;
			this._scrollView.scrollToPercentHorizontal(100, 0.5, true);
			return;
		}
		var scrollW = this._startIndex * this.cellW;
		this._scrollView.scrollToPercentHorizontal(scrollW/(this._zoneItemHash.Values().length * this.cellW + this.img1.x*2 + this.img1.uiWidth*2 - 1022)*100, 0.5, true);
	},

	UpdataRewardBtnState:function () {
		if(this._startRewardIndex == 0){
			this.btnLeft1.setVisible(false);
		}else{
			this.btnLeft1.setVisible(true);
		}
		if(this._startRewardIndex + 0.3 >= (this._rawardWaveArr.length-this._rewardCellNum)){//这里加了0.3的误差
			this.btnRight1.setVisible(false);
		}else{
			this.btnRight1.setVisible(true);
		}
	},

	UpdateRewardProgBar:function(){
		var isRight = false;
		var index = -1;
		var oldStarRawardIndex = this._startRewardIndex;
		this._startRewardIndex = (-this._scrollRewardView.getInnerContainerPosition().x)/this.rewardCellW;
		if( this._startRewardIndex < oldStarRawardIndex ){
			if(this._startRewardIndex%1 < 0.8){
				index = Math.max(Math.ceil(this._startRewardIndex)-1, 0);
			}else{
				index = Math.max(Math.ceil(this._startRewardIndex), 0);
			}
			isRight = false;
		}else if( this._startRewardIndex > oldStarRawardIndex ){
			if(this._startRewardIndex%1 > 0.8){
				index = Math.floor(this._startRewardIndex)+this._rewardCellNum+1;
			}else{
				index = Math.floor(this._startRewardIndex)+this._rewardCellNum;
			}
			isRight = true;
		}
		var beginAddIndex = -1;
		var targetIndex = -2;
		if( isRight ){
			var nowLastIndex = this._rawardWaveArr.indexOf(this._zoneRawardItemWaveArr[this._zoneRawardItemWaveArr.length-1]);
			if( index > nowLastIndex ){
				beginAddIndex = nowLastIndex + 1;
				targetIndex = index;
			}
		}
		else{
			var nowFirstIndex = this._rawardWaveArr.indexOf(this._zoneRawardItemWaveArr[0]);
			if( index < nowFirstIndex && index >= 0 ){
				beginAddIndex = index;
				targetIndex = nowFirstIndex - 1;
			}
		}
		for( beginAddIndex; beginAddIndex <= targetIndex; beginAddIndex++){
			if( beginAddIndex > -1 && this._rawardWaveArr[beginAddIndex] && this._zoneRawardItemWaveArr.indexOf(this._rawardWaveArr[beginAddIndex]) == -1 ){
				var cell = this._GetRawardCell(this._rawardWaveArr[beginAddIndex],isRight);
				cell.InitData(this._rawardArr[beginAddIndex], i);
				cell.x = beginAddIndex * cell.width;
				cell.UpdateState();
			}
		}
		this.UpdataRewardBtnState();
		if( this._canGetRawardIndex < this._startRewardIndex )
			this.progJindutiao.setPercent(0);
		else if( this._canGetRawardIndex > this._startRewardIndex + this._rewardCellNum )
			this.progJindutiao.setPercent(100);
		else{
			this.progJindutiao.setPercent( (this._canGetRawardIndex - this._startRewardIndex + 0.5) / this._rewardCellNum * 100);
		}
	},

	_InitRewardIsScroll:function () {
		var self = this;
		TimerUtil.SetTimeout(this, function(){
			self._isRewardScrolling = false;
		}, 500);
	},

	OnRewardLeftHandler:function(){
		if(this._isRewardScrolling)
			return;
		this._isRewardScrolling = true;
		this._InitRewardIsScroll();
		this._startRewardIndex = Math.ceil(this._startRewardIndex);
		if( this._startRewardIndex > 0)
			this._startRewardIndex-=this._rewardCellNum;
		else
			return;
		if( this._startRewardIndex < 0 )
			this._startRewardIndex = 0;
		this._scrollRewardView.scrollToPercentHorizontal(this._startRewardIndex/(this._rawardWaveArr.length-this._rewardCellNum)*100, 0.5, true);
	},

	OnRewardRightHandler:function(){
		if(this._isRewardScrolling)
			return;
		this._isRewardScrolling = true;
		this._InitRewardIsScroll();
		this._startRewardIndex = Math.floor(this._startRewardIndex);
		if( this._startRewardIndex < (this._rawardWaveArr.length-this._rewardCellNum)){
			this._startRewardIndex+=this._rewardCellNum;
		}
		else
			return;
		if( this._startRewardIndex > this._rawardWaveArr.length-this._rewardCellNum ){
			this._startRewardIndex = this._rawardWaveArr.length-this._rewardCellNum
		}
		this._scrollRewardView.scrollToPercentHorizontal(this._startRewardIndex/(this._rawardWaveArr.length-this._rewardCellNum)*100, 0.5, true);
	},

	OnShow:function(){
		this._isShowpanel = true;
		Mgr.zone.SendReqZoneBasicObtainToGameMessage(EnumZoneType.TYPE_JY);
	},

	OnHide:function(){
		this._super();
		this._isShowpanel = false;
		for(var i = 0; i < this._zoneRawardItemArr.length; i++){
			UIUtil.UIRemoveSelf(this._zoneRawardItemArr.pop());
			this._zoneRawardItemWaveArr.pop()
		}
	}
} );
JingyanfubenMainExt.PanelName = "JingyanfubenMainExt";
PanelClassDic["JingyanfubenMainExt"] = JingyanfubenMainExt;
