var JinjieFubenMainExt = JinjieFubenMain.extend ( {
	_className:"JinjieFubenMainExt",
	_zoneItemHash:null,
	_initXArr:null,
	_startIndex:0,
	_zoneItemArr:null,
	_scrollView:null,
	_cellNum:4,//显示cell个数
	cellW:0,
	ctor:function(){
		this._super();
	},

	Init:function(){
		JinjieFubenMain.prototype.Init.call( this );
		this.imgBg1.setVisible(false);
	},

	RegisterListeners:function(){
		var self = this;
		this._scrollView.addCCSEventListener(function () {
			self.UpdateProgBar(self);
		});
		this.btnLeft.addClickEventListener(function () {
			self.OnLeftHandler();
		} );
		this.btnRight.addClickEventListener(function () {
			self.OnRightHandler();
		} );
	},

	InitPanel:function(){
		this.InitPageView();
		this.InitItems();
		this.RegisterListeners();
	},

	InitPageView:function(){
		this._scrollView = ccui.ScrollView();
		this._scrollView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
		this._scrollView.setTouchEnabled(true);
		this._scrollView.inertiaScrollEnabled=false;
		this._scrollView.setScrollBarEnabled(false);
		this._scrollView.setBounceEnabled(true);
		this.imgBg2.addChild(this._scrollView);

	},

	InitItems:function(){
		this._zoneItemHash = new HashMap();
		var zoneList = Mgr.dataMgr.GetZoneList().sort(this.ShortZoneData);
		var length = zoneList.length;
		var zoneData = null;
		var num = 1;
		this._initXArr = [];
		for( var i = 0; i < length; i++ )
		{
			zoneData = zoneList[ i ];
			if( zoneData.q_zone_type == EnumZoneType.TYPE_JJ )
			{
				if(zoneData.q_id == 10013)//10013为坐骑副本剧情任务，这里过滤掉
					continue;
				var zoneItem = new JinjieFubenFrameExt();
				zoneItem.LoadPanel();
				zoneItem.retain();
				zoneItem.InitData( zoneData.q_id, num );
				zoneItem.y = 0;
				zoneItem.x = this._zoneItemHash.Size() * ( zoneItem.width + 5 );
				this._initXArr.push(zoneItem.x);
				this._scrollView.addChild(zoneItem);
				this._zoneItemHash.Put( zoneData.q_id, zoneItem );
				this.cellW = zoneItem.width;
				num++;
			}
		}
		this._scrollView.setSize(cc.size((zoneItem.width+5)*this._cellNum, zoneItem.height));
		this._scrollView.setInnerContainerSize(cc.size(this._zoneItemHash.Values().length * ( zoneItem.width + 5 ), zoneItem.height));
		this._startIndex = 0;
		this._zoneItemArr = this._zoneItemHash.Values().sort(this.ShortZoneData);
		this.UpdataBtnState();
	},
	
	ShortZoneData:function(p1,p2) {
		if (p1.q_level < p2.q_level)
			return -1;
		else if (p1.q_level == p2.q_level)
			return 0;
		else return 1;
	},

	UpdateData:function( zoneInfos ){
		var zoneInfo = null;
		var zoneItem = null;
		if(zoneInfos)
		{
			for( var i = 0; i < zoneInfos.length; i++ )
			{
				zoneInfo = zoneInfos[i];
				zoneItem = this._zoneItemHash.Get( zoneInfo.zoneModelid );
				if( zoneItem != null )
				{
					zoneItem.UpdateData( zoneInfo );
				}
				else
					continue;
			}
		}
	},

	UpdataBtnState:function () {
		if(this._startIndex == 0){
			this.btnLeft.setVisible(false);
		}else{
			this.btnLeft.setVisible(true);
		}
		if(this._startIndex >= (this._zoneItemHash.Values().length-this._cellNum)){
			this.btnRight.setVisible(false);
		}else{
			this.btnRight.setVisible(true);
		}
	},
	
	UpdateProgBar:function(self){
		self._startIndex = -(self._scrollView.getInnerContainerPosition().x)/self.cellW;
		self.UpdataBtnState();
	},

	OnLeftHandler:function(){
		this._startIndex = Math.floor(this._startIndex);
		if( this._startIndex >= 0)
			this._startIndex--;
		else
			return;
		cc.log(this._startIndex/(this._zoneItemHash.Values().length-this._cellNum)*100);
		this._scrollView.scrollToPercentHorizontal(this._startIndex/(this._zoneItemHash.Values().length-this._cellNum)*100, 0.5, true);
	},

	OnRightHandler:function(){
		this._startIndex = Math.floor(this._startIndex);
		if( this._startIndex < (this._zoneItemHash.Values().length-this._cellNum))
			this._startIndex++;
		else
			return;
		this._scrollView.scrollToPercentHorizontal(this._startIndex/(this._zoneItemHash.Values().length-this._cellNum)*100, 0.5, true);
	},

	OnShow:function(){
		for(var i = 0; i < this._zoneItemHash.Values().length; i++){
			this._zoneItemHash.Values()[i].UpdateState();
			this._zoneItemHash.Values()[i].ShowRaward();
		}
		Mgr.zone.SendReqZoneBasicObtainToGameMessage(EnumZoneType.TYPE_JJ);
	},
	
	OnHide:function(){
		this._super();
		for(var i = 0; i < this._zoneItemHash.Values().length; i++){
			this._zoneItemHash.Values()[i].HideRaward();
		}
	}
} );
JinjieFubenMainExt.PanelName = "JinjieFubenMainExt";
PanelClassDic["JinjieFubenMainExt"] = JinjieFubenMainExt;
