var VipFubenFrameExt = VipFubenFrame.extend ( {
	_className:"VipFubenFrameExt",
	_zoneData:null,
	_vipZoneData:null,
	_zoneId:0,
	_rawardCon:null,
	_dropCon:null,
	_rawards:null,
	_drops:null,
	_zoneModelId:0,
	_crossnum:0,
	ctor:function(){
		this._super();
	},

	InitData:function( zoneid, num ){
		this._rawardCon = new TaskRewardsGridCon();
		this._dropCon = new TaskRewardsGridCon();
		this.addChild(this._rawardCon);
		this.addChild(this._dropCon);

		var imageRes = "other/danrenfuben/image/vipbg/vip" + num + ".png";
		var self=this;
		UIUtil.LoadImage( this.imgBg, imageRes );
		
		this._zoneData = Mgr.dataMgr.GetZoneData(zoneid);
		this._vipZoneData = Q_story.Get(zoneid);
		this._zoneId = zoneid;
		if( this._vipZoneData.q_reward )
			this._rawards = JSON.parse( this._vipZoneData.q_reward );
		if( this._vipZoneData.q_item_show )
			this._drops = JSON.parse( this._vipZoneData.q_item_show );
//		this.ShowRaward();

		var imagelabRes = "other/shizhuang/word/"+this._vipZoneData.q_introduce+".png";
		UIUtil.LoadImage( this.imgNum, imagelabRes );

		UIUtil.UIRemoveSelf(this.gridItem);
		UIUtil.UIRemoveSelf(this.gridItem1);
		UIUtil.UIRemoveSelf(this.gridItem2);

		this.btnChongzhi.addClickEventListener(function (event){
			Mgr.zone.SendReqZoneEnterToGameMessage(self._zoneId);
		});

		this._zoneModelId = this._vipZoneData.q_id;
		this.UpdateState();
	},

	ShowRaward:function(){
//		this.labName.SetText(this._zoneData.q_name);
		if( this._rawards == null ){
			this._rawardCon.setVisible(false);
			this.img1.setVisible(false);
		}
		else{
			this.img1.setVisible(true);
			var count = 0;
			if( this._rawards ){
//				for ( var i = 0; i < this._rawards.length ; i ++){
				for ( var i = 0; i < 1 ; i ++){//东湖要求手游vip副本只显示第一个奖励
					var item = ItemUtil.ItemIdToItem(this._rawards[ i ].mod,this._rawards[ i ].num,this._rawards[ i ].bind);
					this._rawardCon.AddComItem(item,this.gridItem);
					count++;
				}

				if ( count > 0 ){
					this._rawardCon.Layout( this.gridItem.uiWidth * count, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight );
					this._rawardCon.x = ( this.uiWidth - this.gridItem.uiWidth * count ) / 2;
					this._rawardCon.y = this.gridItem.y;
				}
			}
		}

		if( this._drops == null ){
			this._dropCon.setVisible(false);
			this.img2.setVisible(false);
		}
		else{
			this.img2.setVisible(true);
			var count = 0;
			for ( var i = 0; i < this._drops.length ; i ++){
				var item = ItemUtil.ItemIdToItem(this._drops[i][ 0 ],this._drops[i][ 1 ],this._drops[i][ 2 ]);
				this._dropCon.AddComItem(item,this.gridItem2);
				count++;
			}

			if ( count > 0 ){
				this._dropCon.Layout( this.gridItem2.uiWidth * count, this.gridItem2.uiHeight, this.gridItem2.uiWidth, this.gridItem2.uiHeight );
				this._dropCon.x = ( this.uiWidth - this.gridItem2.uiWidth * count ) / 2;
				this._dropCon.y = this.gridItem2.y;
			}
		}
	},

	HideRaward:function(){
		if( this._rawards != null )
			this._rawardCon.Clear();
		if( this._drops != null )
			this._dropCon.Clear();
	},

	UpdateState:function(){
		if(Mgr.player.mainPlayer.VIP < parseInt(this._vipZoneData.q_introduce)){
			this.labCue.setVisible(true);
			this.btnChongzhi.setVisible(false);
			this.labOver.setVisible(false);
		}else{
			if( this._vipZoneData.q_challenge_num - this._crossnum > 0 )
			{
				this.labCue.setVisible(false);
				this.btnChongzhi.setVisible(true);
				this.labOver.setVisible(false);
			}
			else
			{
				this.labCue.setVisible(false);
				this.btnChongzhi.setVisible(false);
				this.labOver.setVisible(true);
			}
		}
	},

	UpdateData:function(zoneInfo){
		if( zoneInfo )
		{
			this._zoneModelId = zoneInfo.zoneModelid;
			this._crossnum = zoneInfo.crossnum;
		}
		this.UpdateState();
	}
} );
VipFubenFrameExt.PanelName = "VipFubenFrameExt";
PanelClassDic["VipFubenFrameExt"] = VipFubenFrameExt;
