var WendingJianghuMainExt = WendingJianghuMain.extend ( {
	_className:"WendingJianghuMainExt",
	_scrollView:null,
	addIdx:0,
	minusIdx:0,
	curShowIndex:0,//当前显示的第一个索引
	cellW:350,
	cellHash:null,
	_curLayer:0,
	_maxLayer:3,
	sweepNums:1,

	_startRewardIndex:0,
	_rewardCellNum:3,//显示cell个数
	_rawardArr:null,
	_rawardWaveArr:null,
	_zoneRawardItemArr:null,
	_zoneRawardItemWaveArr:null,
    modelArr:null,

	ctor:function(){
		this._super();
		this.cellHash = new HashMap();
        this.modelArr = [];
	},

	InitPanel:function(){
		this.InitPageView();
		this.InitRaward();
		
		var self = this;
		this._scrollView.addCCSEventListener(function (sender, type) {
            self.UpdateProgBar(self);
			switch(type){
				case ccui.ScrollView.EVENT_AUTOSCROLL_ENDED:
                    self.UpdateShowModel();
					break;
				// case ccui.ScrollView.EVENT_CONTAINER_MOVED:
                 //    self.UpdateShowModel();
				// 	break;
			}
		});

        Mgr.zone.AddbuttonEffect(this.btnGo1, 996, true);

		this.btnGo.addClickEventListener(function (event){
			Mgr.zone.SendReqZoneEnterToGameMessage(Q_temple.Get(self._curLayer == 0 ? 1 : self._curLayer).q_zone);
		});
		this.btnGo1.addClickEventListener(function (event){
			Mgr.zone.SendReqBattleZoneSweepToGameMessage(EnumZoneType.TYPE_WD);
		});
	},
	
	InitPageView:function(){
		this._scrollView = new ccui.ScrollView();
		this._scrollView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
		this._scrollView.setTouchEnabled(true);
		this._scrollView.inertiaScrollEnabled=true;
		this._scrollView.setScrollBarEnabled(false);
		this._scrollView.setBounceEnabled(true);
//		this._scrollView.setInertiaScrollEnabled(true);
		this.imgBg.addChild(this._scrollView,0);

		//--------------
//		var len = Math.max(3,8);
//		this.addIdx = len-3;
////		this.addIdx = len-8;
//		this.minusIdx = this.addIdx;
//		for(var i = this.addIdx; i < len; i++)
//		{
//			var cell = new WendingFrameExt();
//			cell.LoadPanel();
//			cell.retain();
//			cell.SetInfo(i+1);
//			cell.x = cell.uiWidth*this.addIdx;
//			this.cellHash.Put(this.addIdx, cell);
//			this.addIdx++;
//			this._scrollView.addChild(cell);
//		}
//		_oldMaxLayer = 8;
//		for(var j = this.minusIdx; j < this.addIdx; j++)
//		{
//			var cell = this.cellHash.Get(j);
//			cell.SetInfo(j+1);
//		}
//		this._scrollView.setSize(cc.size(cell.width*3, 592));
//		this._scrollView.setInnerContainerSize(cc.size(len * ( cell.width ), 0));
//		this._scrollView.jumpToPercentHorizontal(100);
//		this.cellW = cell.width;
//		this.innerW = cell.width*3;
	},

	InitRaward:function(){
		var zoneList = Q_temple.GetList();
		var length = zoneList.length;
		this._rawardArr = [];
		this._rawardWaveArr = [];
		for( var i = 0; i < length; i++ ){
			this._rawardArr.push(zoneList[i]);
			var aa = zoneList[i];
			this._rawardWaveArr.push(zoneList[i].q_id);
		}

		this._zoneRawardItemArr = [];
		this._zoneRawardItemWaveArr = [];
		// for( i = 0; i < rawardArr.length; i++ ){
		// 	var cell = new JingyanBoxExt();
		// 	cell.LoadPanel();
		// 	cell.retain();
		// 	cell.InitData(rawardArr[i], i);
		// 	cell.x = i * cell.width;
		// 	cell.y = 0;
		// 	this.cellW = cell.width;
		// 	this._scrollView.addChild(cell);
		// 	this._zoneRawardItemHash.Put(rawardArr[i].q_id, cell)
		// }
		this._scrollView.setSize(cc.size(this.imgBg.width, this.imgBg.height));
		this._scrollView.setInnerContainerSize(cc.size(this._rawardArr.length * this.cellW, this.imgBg.height));
	},

	ShowRaward:function (wave) {
		var beginIndex = this._rawardWaveArr.indexOf(wave);
		if( beginIndex == -1 )
			beginIndex = 0;
		var endIndex = 0;
		if( beginIndex + this._rewardCellNum + 1 <= this._rawardWaveArr.length - 1 ){
			endIndex = beginIndex + this._rewardCellNum + 1;
			this._startRewardIndex = beginIndex;
		}else{
			endIndex = this._rawardWaveArr.length - 1;
			this._startRewardIndex = this._rawardWaveArr.length - 1 - this._rewardCellNum;
		}
		for( var i = this._startRewardIndex; i < endIndex; i++ ){
			var cell = this._GetRawardCell(this._rawardWaveArr[i],true, Q_temple.Get(this._rawardWaveArr[i]).q_model_show);
			cell.SetInfo(this._rawardWaveArr[i]);
			cell.UpdataState();
			cell.x = (i) * this.cellW;
            cell.model.sCurActionName = null;
			var bossStr = Q_temple.Get(this._rawardWaveArr[i]).q_id_boss;
			var bossArr = JSON.parse(bossStr);
			var monster = Q_monster.Get(bossArr[0]);
            cell.model.sResUrlBase = "res/animation/monster/" + monster.q_sculpt_resid;
            cell.model.DoAction("stand", 4);
		}
		this._scrollView.jumpToPercentHorizontal(this._startRewardIndex/(this._rawardArr.length-this._rewardCellNum)*100);
		this.UpdataProgram();
//		this.UpdataRewardBtnState();
	},


    UpdateShowModel:function(){
        this._startRewardIndex = (-this._scrollView.getInnerContainerPosition().x)/this.cellW;
        // cc.log(this._startRewardIndex)
        this._startRewardIndex = Math.floor(this._startRewardIndex);
        // cc.log(this._startRewardIndex)
		var pos = cc.p(-this._startRewardIndex * this.cellW, 0);
		this._scrollView.setInnerContainerPosition(pos);
        // cc.log("UpdateShowModel     " + this._startRewardIndex/(this._zoneRawardItemArr.length-this._rewardCellNum)*100);
        // if( this._startRewardIndex >= 0)
        //     this._startRewardIndex--;
        // else
        //     return;
        // cc.log("scrollToPercentHorizontal")
        // this._scrollView.scrollToPercentHorizontal(this._startRewardIndex/(this._zoneRawardItemArr.length-this._rewardCellNum)*100, 0.5, true);
    },

	ShowModel:function(cell, showId){
        var model = new MAnimationObject();
        cell.addChild(model);
        model.setPosition(cc.p(cell.uiWidth/2, cell.uiHeight*3/5));
        this.modelArr.push(model);
        cell.model = model;
	},

	_GetRawardCell:function (wave, right, modelShow) {
		var rawardcell = null;
		if( this._zoneRawardItemWaveArr.length >= (this._rewardCellNum+1) ){
			if(right){
				rawardcell = this._zoneRawardItemArr.shift();
				this._zoneRawardItemWaveArr.shift();
			}else{
				rawardcell = this._zoneRawardItemArr.pop();
				this._zoneRawardItemWaveArr.pop();
			}
		}else{
			var cell = new WendingFrameExt();
			cell.LoadPanel();
			cell.retain();
			cell.y = 0;
			this._scrollView.addChild(cell);
			rawardcell = cell;
            this.ShowModel(cell, modelShow);
		}
		if(right){
			this._zoneRawardItemArr.push(rawardcell);
			this._zoneRawardItemWaveArr.push(wave);
		}else{
			this._zoneRawardItemArr.unshift(rawardcell);
			this._zoneRawardItemWaveArr.unshift(wave);
		}
		return rawardcell;
	},
	
	UpdateProgBar:function(self){
		var isRight = false;
		var index = -1;
		var oldStarRawardIndex = this._startRewardIndex;
		this._startRewardIndex = (-this._scrollView.getInnerContainerPosition().x)/this.cellW;
		if( this._startRewardIndex < oldStarRawardIndex ){
			if(this._startRewardIndex%1 < 0.8){
				index = Math.max(Math.ceil(this._startRewardIndex)-1, 0);
			}else{
				index = Math.max(Math.ceil(this._startRewardIndex), 0);
			}
			isRight = false;
		}else if( this._startRewardIndex > oldStarRawardIndex ){
			if(this._startRewardIndex%1 > 0.8){
				index = Math.floor(this._startRewardIndex)+this._rewardCellNum+1;
			}else{
				index = Math.floor(this._startRewardIndex)+this._rewardCellNum;
			}
			isRight = true;
		}
		var veginAddIndex = -1;
		var targetIndex = -2;
		if( isRight ){
			var nowLastIndex = this._rawardWaveArr.indexOf(this._zoneRawardItemWaveArr[this._zoneRawardItemWaveArr.length-1]);
			if( index > nowLastIndex ){
				veginAddIndex = nowLastIndex + 1;
				targetIndex = index;
			}
		}
		else{
			var nowFirstIndex = this._rawardWaveArr.indexOf(this._zoneRawardItemWaveArr[0]);
			if( index < nowFirstIndex && index >= 0 ){
				veginAddIndex = index;
				targetIndex = nowFirstIndex - 1;
			}
		}
		for( veginAddIndex; veginAddIndex <= targetIndex; veginAddIndex++){
			if( veginAddIndex > -1 && this._rawardWaveArr[veginAddIndex] && this._zoneRawardItemWaveArr.indexOf(this._rawardWaveArr[veginAddIndex]) == -1 ){
				var cell = this._GetRawardCell(this._rawardWaveArr[veginAddIndex],isRight);
				cell.SetInfo(this._rawardWaveArr[veginAddIndex]);
				cell.UpdataState();
				cell.x = veginAddIndex * cell.width;
                cell.model.sCurActionName = null;
				var bossStr = Q_temple.Get(this._rawardWaveArr[veginAddIndex]).q_id_boss;
				var bossArr = JSON.parse(bossStr);
				var monster = Q_monster.Get(bossArr[0]);
				cell.model.sResUrlBase = "res/animation/monster/" + monster.q_sculpt_resid;
                cell.model.DoAction("stand", 4);
			}
		}
		
		this.UpdataProgram();
	},
	
	UpdataProgram:function(){
		if( this._curLayer < this._startRewardIndex )
			this.progJindutiao.setPercent(0);
		else if( this._curLayer > this._startRewardIndex + this._rewardCellNum )
			this.progJindutiao.setPercent(100);
		else{
			this.progJindutiao.setPercent( (this._curLayer - this._startRewardIndex + 0.5) / this._rewardCellNum * 100);
		}
	},
	
	UpdateData:function(sweepNums, historyMaxStep, nowFinishStep){
		this._curLayer = nowFinishStep;
		this._maxLayer = historyMaxStep;
		this.sweepNums = sweepNums;

		this.ShowRaward(this._curLayer);
		// this.ClearCell();
		// var len = Math.max(3,this._maxLayer);
		// this.addIdx = len-3;
		// this.minusIdx = this.addIdx;
		// for(var i = len-3; i < len; i++)
		// {
		// 	var cell = new WendingFrameExt();
		// 	cell.LoadPanel();
		// 	cell.retain();
		// 	cell.SetInfo(i+1);
		// 	cell.x = cell.uiWidth*i;
		// 	this.cellHash.Put(this.addIdx, cell);
		// 	this.addIdx++;
		// 	this._scrollView.addChild(cell);
		// }
		// for(var j = this.minusIdx; j < this.addIdx; j++)
		// {
		// 	var cell = this.cellHash.Get(j);
		// 	cell.SetInfo(j+1);
		// }
//		this._scrollView.setSize(cc.size(this.cellW*3, 592));
//		this._scrollView.setInnerContainerSize(cc.size(len * ( this.cellW ), 0));
		this.cellW = this.cellW;
		this.innerW = this.cellW*3;
//		this._scrollView.jumpToRight();
		this.curShowIndex = Math.ceil(-(this._scrollView.getInnerContainerPosition().x+1)/this.cellW);
		
		if( this.sweepNums == 0 && this._curLayer < this._maxLayer )
			this.btnGo1.setVisible(true);
		else
			this.btnGo1.setVisible(false);

		if( this._curLayer < Q_temple.GetList().length )
			this.btnGo.setVisible(true);
		else
			this.btnGo.setVisible(false);
	},
	
	ClearCell:function(){
		for( var i = 0; i < this.cellHash.Values().length; i++ ){
			this.cellHash.Values()[i].ClearData();
			this._scrollView.removeChild(this.cellHash.Values()[i]);
			this.addIdx--;
		}
		this.cellHash.Clear();
		this.minusIdx = this.addIdx;
	},
	
	OnShow:function(){
		Mgr.zone.SendReqZoneBasicObtainToGameMessage(EnumZoneType.TYPE_WD);
	},
	
	OnHide:function(){
		this._super();
		this.ClearCell();
//		this._scrollView.setInnerContainerSize(cc.size(5 * ( this.cellW ), 0));
    }
} );
WendingJianghuMainExt.PanelName = "WendingJianghuMainExt";
PanelClassDic["WendingJianghuMainExt"] = WendingJianghuMainExt;
