var DuorenTeamMainExt = DuorenTeamMain.extend({
    _className: "DuorenTeamMainExt",
    zoneScrollview: null,
    myTeamList: null,
    itemNormalHeight: 121,
    itemSelectedHeight: 216,
    itemArr: [],
    fightTotal: 20,
    btnTypeArr: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
    btnArr: [],
    isAutoReady: true,
    isAutoCreate: false,
    isJoin: false,
    isInvite: false,
    _inviteType: 0,
    _autoType: 0,
    isManyuanAutoStart: false,
    checkBoxState: [MUICheckBox.STATE_CHECK, MUICheckBox.STATE_UNCHECK],
    selectedItem: null,
    showTeamnum: 30,
    isReadied: true,
    countTime: 12,
    _gridArr: [],
    ctor: function() {
        this._super();
    },
    Init: function() {
        DuorenTeamMain.prototype.Init.call(this);
        this._InitProperty();
        this._HandleButton();
        this._AddScrollView();
        this.ChangeVisible();
        this.imgBg.loadTexture("");
        this.sbtnGouxuan3.visible = false;
        this.labCue3111.visible = false;
    },

    OnShow: function() {
        // 添加默认勾选 自动开启，
        this.SetAutoReady(true);
        this.SetAutoJoinOrCreateRoom(true);
        this.SetFilterCanJoinTeam(true);
    },

    OnHide: function() {
        this.SetAutoJoinOrCreateRoom(false);
    },

    _InitProperty: function() {
        this.imgB.visible = false;
        this.imgA.visible = true;
        this.imgA.setLocalZOrder(100);
        this.imgB.setLocalZOrder(100);
        this.sbtnGouxuan.SetButtonState(this.checkBoxState[0]);
        this.sbtnGouxuan1.SetButtonState(this.checkBoxState[1]);
        this.sbtnGouxuan21.SetButtonState(this.checkBoxState[1]);
        this.sbtnGouxuan2.SetButtonState(this.checkBoxState[1]);
        // this.labCue.SetColor(EnumFontFormat.COMMON_COLOR04);
        this.labCue.visible = false;
        this.labCue11.SetColor(EnumFontFormat.COMMON_COLOR04);
        this.labCue11.SetHtmlText("<u>发送寻求战友公告</u>");
        var str = "12";
        this.labTime.SetString(str);
        this.labTime.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
        this._gridArr = [this.gridItem, this.gridItem1, this.gridItem2];
    },
    _HandleButton: function() {
        var self = this;
        this.btnArr = [
            this.btnChuangjian1, //创建房间
            this.btnJiaru1, //快速加入
            this.btnGo, //开始
            this.btnJiaru, //离开房间
            this.btnChuangjian, //取消准备
            this.sbtnGouxuan, //自动准备
            this.sbtnGouxuan1, //12s倒计时
            this.sbtnGouxuan21, //只显示可加入房间
            this.sbtnGouxuan2, //只允许邀请的玩家加入
            this.sbtnGouxuan211, //满员后自动开始
            //this.sbtnGouxuan3,//自动重复挑战
        ];
        var len = this.btnArr.length;
        for (var i = 0; i < len; i++) {
            this.btnArr[i].type = i;
            this.btnArr[i].addTouchEventListener(function(target, state) {
                if (state == ccui.Widget.TOUCH_ENDED) {
                    self._ButtonEventFunc(target.type);
                }
            });
        }
        this.labCue11.setTouchEnabled(true);
        this.labCue11.addClickEventListener(function() {
            var isTeamer = self._GetTeamer();
            if (!isTeamer) {
                Mgr.tips.ShowNotice("无权限");
                return;
            }
            var type = self._GetZoneType();
            if (type == EnumZoneType.TYPE_LFDR) {
                Mgr.zoneteam.SendReqZoneTeamInviteNoticeClinetToGameMessage();
            } else if (type == EnumZoneType.TYPE_KFDR) {
                Mgr.crossteam.SendReqInviteZoneNoticeClinetToGameMessage(); //组队公告
            }
        });
    },
    _AddScrollView: function() {
        var sc = Mgr.crossteam.GetScrollView();
        this.imgBg.addChild(sc);
        this.zoneScrollview = sc;
        this.zoneScrollview.setPosition(5, 5);
    },
    //队伍列表信息处理
    SetTeamlistData: function(data) {
        var zoneModelId = data.teamInfo[0].zoneModelId;
        if (this._GetZoneType() == EnumZoneType.TYPE_LFDR) {
            zoneModelId = Mgr.zoneteam.zoneInfos[0].zoneModelid;
        }
        var listview = Mgr.crossteam.teamListview.Get(zoneModelId);
        if (!listview) {
            listview = Mgr.crossteam.GetListview(381, 300);
            var size = listview.getContentSize();
            listview.setPosition(this.imgDikuang.width - size.width >> 1, -size.height - 30);
            this.imgDikuang.addChild(listview);
            var teamlist = data.teamInfo;
            var len = teamlist.length;
            for (var i = 0; i < len; i++) {
                var item = new DuorenFrameExt(teamlist[i]);
                item.LoadPanel();
                listview.pushBackCustomItem(item);
            }
            Mgr.crossteam.teamListview.Put(zoneModelId, listview);
        } else {
            listview.removeAllItems();
            Mgr.crossteam.UpdateTeamlist(data, listview);
        }
        this.ShowOrHideTeamlist(zoneModelId);
    },
    ShowOrHideTeamlist: function(zoneModelId) {
        var teamlist = Mgr.crossteam.teamListview.Values();
        var len = teamlist.length;
        for (var i = 0; i < len; i++) {
            teamlist[i].visible = false;
        }
        if (this._GetZoneType() == EnumZoneType.TYPE_LFDR) {
            zoneModelId = Mgr.zoneteam.zoneInfos[0].zoneModelid;
        } else {
            zoneModelId = this.selectedItem.data.detail.q_id;
        }
        var list = Mgr.crossteam.teamListview.Get(zoneModelId);
        if (list && !Mgr.crossteam.isInteam) {
            list.visible = true;
        } else if (Mgr.crossteam.isInteam) {
            this._HandleMyteam();
        }
    },
    _HandleMyteam: function() {
        // 这里表示切换到组队状态
        this.ChangeVisible();
        var myTeamInfo = Mgr.crossteam.myTeam;
        var listview = this._GetMyTeamlistview();
        if (listview.getItems().length < 1) {
            for (var i = 0; i < EnumCrossteamType.TEAM_MEM_NUMBER; i++) {
                var item = new DuorenFrameExt(myTeamInfo.memberinfo[i], i);
                item.LoadPanel();
                listview.pushBackCustomItem(item);
            }
            this.SetAutoStartFuben(myTeamInfo.memberinfo);
        }
    },
    ChangeVisible: function() {
        this.imgA.visible = !Mgr.crossteam.isInteam;
        this.imgB.visible = Mgr.crossteam.isInteam;

        if (Mgr.crossteam.isInteam) {
            this.SetAutoJoinOrCreateRoom(false);
        }
    },
    _GetMyTeamlistview: function() {
        var listview = this.myTeamList;
        if (!listview) {
            listview = Mgr.crossteam.GetListview(381, 300);
            var size = listview.getContentSize();
            listview.setPosition(this.imgDikuang.width - size.width >> 1, -size.height - 30);
            this.imgDikuang.addChild(listview);
            this.myTeamList = listview;
        }
        listview.visible = true;
        return listview;
    },

    UpdateInformation: function(item) {
        cc.log("Mgr.crossteam.isInteam= " + Mgr.crossteam.isInteam);
        this.selectedItem = item;
        if (Mgr.crossteam.isInteam) {
            return;
        }
        var data = item.data;
        this.labFBname.SetString(data.detail.q_name);
        //var msg = {
        //  zoneModelId : data.base.zoneModelid, // 绑定副本模版(0表示所有副本)
        //  startNum : 0, // 第几个开始
        //  num : this.showTeamnum, // 需要显示几个
        //  type : this.isJoin?1:0, // 0所有 1允许加入的队伍
        //}

        // TIP 目测这里表示为组队状态

        this._RequestZoneTeamInfo();
        this.ChangeVisible();
        this.ClearData();
    },
    _RequestZoneTeamInfo: function() {
        if(!this.selectedItem)
            return;

        var data = this.selectedItem.data;
        var msg = {
            zoneModelId: data.base.zoneModelid, // 绑定副本模版(0表示所有副本)
            startNum: 0, // 第几个开始
            num: this.showTeamnum, // 需要显示几个
            type: this.isJoin ? 1 : 0, // 0所有 1允许加入的队伍
        }
        var type = this._GetZoneType();
        if (type == EnumZoneType.TYPE_LFDR) {
            Mgr.zoneteam.SendReqZoneTeamClientToGameMessage();
        } else if (type == EnumZoneType.TYPE_KFDR) {
            Mgr.crossteam.SendReqCrossTeamsForZoneModelClientToGameMessage(msg);
        }
    },
    SetZoneChallangeNum: function(data) {
        // var str = "今日剩余挑战次数："+data.remainCount/*(this.fightTotal-data.base.crossnum)*/;
        // if(Mgr.uiMgr.GetPanelByType(DuorenPanelExt.PanelName ).zonetype == EnumZoneType.TYPE_LFDR)
        // {
        //    str = "本次活动剩余挑战次数："+data.leftnum;
        // }
        // this.labCue.SetString(str);
    },
    _ButtonEventFunc: function(type) {
        var typee = this._GetZoneType();
        switch (type) {
            case this.btnTypeArr[0]: //创建房间
                {
                    this.doCreateRoom();
                    break;
                }
            case this.btnTypeArr[1]: //快速加入
                {
                    this.doQuickJoin();
                    break;
                }
            case this.btnTypeArr[2]: //开始
                {
                    this._StartZoneFight();
                    break;
                }
            case this.btnTypeArr[3]: //离开房间
                {
                    Mgr.crossteam.isCancelReady = false;
                    if (typee == EnumZoneType.TYPE_LFDR) {
                        Mgr.zoneteam.SendReqZoneTeamLeaveClientToGameMessage();
                    } else if (typee == EnumZoneType.TYPE_KFDR) {
                        Mgr.crossteam.SendReqLeaveCrossTeamClientToGameMessage();
                    }
                    this._RequestZoneTeamInfo();
                    break;
                }
            case this.btnTypeArr[4]: //取消准备
                {
                    Mgr.crossteam.isCancelReady = true;
                    if (this.isReadied) {
                        if (typee == EnumZoneType.TYPE_LFDR) {
                            Mgr.zoneteam.SendReqZoneTeamReadyClientToGameMessage(EnumCrossteamType.STATE_READY_NOT);
                        } else if (typee == EnumZoneType.TYPE_KFDR) {
                            Mgr.crossteam.SendReqChangeStateClientToGameMessage(EnumCrossteamType.STATE_READY_NOT, this.selectedItem.data.base.zoneModelid);
                        }
                    } else {
                        if (typee == EnumZoneType.TYPE_LFDR) {
                            Mgr.zoneteam.SendReqZoneTeamReadyClientToGameMessage(EnumCrossteamType.STATE_READY);
                        } else if (typee == EnumZoneType.TYPE_KFDR) {
                            Mgr.crossteam.SendReqChangeStateClientToGameMessage(EnumCrossteamType.STATE_READY, this.selectedItem.data.base.zoneModelid);
                        }
                    }
                    break;
                }
            case this.btnTypeArr[5]: //自动准备
                {
                    this.SetAutoReady(!this.isAutoReady);
                    break;
                }
            case this.btnTypeArr[6]: //12s倒计时
                {
                    this.SetAutoJoinOrCreateRoom(!this.isAutoCreate);
                    break;
                }
            case this.btnTypeArr[7]: //只显示可加入房间
                {
                    this.SetFilterCanJoinTeam(!this.isJoin);
                    break;
                }
            case this.btnTypeArr[8]: //只允许邀请的玩家加入
                {
                    //TODO
                    var isTeamer = this._GetTeamer();
                    if (!isTeamer) {
                        Mgr.tips.ShowNotice("无权限");
                        return;
                    }

                    this.SetAllowStrangerIn(!this.isInvite);

                    if (!this.isInvite) {
                        if (typee == EnumZoneType.TYPE_LFDR) {
                            Mgr.zoneteam.SendReqZoneTeamChangeConfigToGameMessage(this._inviteType, this._autoType);
                        } else if (typee == EnumZoneType.TYPE_KFDR) {
                            Mgr.crossteam.SendReqChangeCrossTeamConfigToGameMessage(this._inviteType, this._autoType);
                        }
                    } else {
                        if (typee == EnumZoneType.TYPE_LFDR) {
                            Mgr.zoneteam.SendReqZoneTeamChangeConfigToGameMessage(this._inviteType, this._autoType);
                        } else if (typee == EnumZoneType.TYPE_KFDR) {
                            Mgr.crossteam.SendReqChangeCrossTeamConfigToGameMessage(this._inviteType, this._autoType);
                        }
                    }
                    break;
                }
            case this.btnTypeArr[9]:
                {
                    var isTeamer = this._GetTeamer();
                    if (!isTeamer) {
                        this.isManyuanAutoStart = false;
                        Mgr.tips.ShowNotice("无权限");
                        return;
                    }
                    this.SetAutoStartWhenFull(!this.isManyuanAutoStart);

                    var typee = this._GetZoneType();
                    if (this.isManyuanAutoStart) {
                        if (typee == EnumZoneType.TYPE_LFDR) {
                            Mgr.zoneteam.SendReqZoneTeamChangeConfigToGameMessage(this._inviteType, this._autoType);
                        } else if (typee == EnumZoneType.TYPE_KFDR) {
                            Mgr.crossteam.SendReqChangeCrossTeamConfigToGameMessage(this._inviteType, this._autoType);
                        }
                    } else {
                        if (typee == EnumZoneType.TYPE_LFDR) {
                            Mgr.zoneteam.SendReqZoneTeamChangeConfigToGameMessage(this._inviteType, this._autoType);
                        } else if (typee == EnumZoneType.TYPE_KFDR) {
                            Mgr.crossteam.SendReqChangeCrossTeamConfigToGameMessage(this._inviteType, this._autoType);
                        }
                    }
                }
            default:
                break;
        }
    },
    //满员自动开始副本
    SetAutoStartFuben: function(list) {
        if (!this.isManyuanAutoStart) return;
        if (list.length != EnumCrossteamType.TEAM_MEM_NUMBER) return;

        for (var i = 0; i < list.length; i++) {
            if (!list[i].isReady) return;
        }

        this._StartZoneFight();
    },
    _StartZoneFight: function() {
        var items = this.myTeamList.getItems();
        for (var i = 0; i < items.length; i++) {
            var data = items[i].data;
            if (data && items[i].isTeam && data.isReady != EnumCrossteamType.STATE_READY) {
                Mgr.tips.ShowNotice("有玩家处于未准备状态，请等待玩家准备");
                return;
            }
        }
        var type = this._GetZoneType();
        if (type == EnumZoneType.TYPE_LFDR) {
            Mgr.zoneteam.SetStartZoneTeamCountDown();
        } else if (type == EnumZoneType.TYPE_KFDR) {
            Mgr.crossteam.SendReqStartCrossTeamZoneClientToGameMessage(this.selectedItem.data.base.zoneModelid);
        }
    },
    UpdateButtonState: function(index, data) {
        var btn01 = this.btnArr[2] //开始按钮
        var btn02 = this.btnArr[4] //准备按钮
        if (index == EnumCrossteamType.TEAM_CAPTAIN) {
            btn01.visible = true;
            btn02.visible = false;
        } else {
            btn01.visible = false;
            btn02.visible = true;
            btn02.setTitleText("准备");
            this.isReadied = false;
            if (data.isReady == EnumCrossteamType.STATE_READY) {
                btn02.setTitleText("取消准备");
                this.isReadied = true;
            }
        }
    },

    // 设置自动准备
    SetAutoReady: function(val) {
        this.isAutoReady = val;
        this.sbtnGouxuan.SetButtonState(val ? this.checkBoxState[0] : this.checkBoxState[1]);
    },
    // 设置自动加入或创建房间
    SetAutoJoinOrCreateRoom: function(val) {
        this.isAutoCreate = val;
        this.sbtnGouxuan1.SetButtonState(val ? this.checkBoxState[0] : this.checkBoxState[1]);

        this.countTime = 12;
        this.labTime.SetString(this.countTime);
        if (this._timer) TimerUtil.ClearTimeout(this._timer);
        this._timer = val ? TimerUtil.TimeUpdate(this._CountDown, this, 1, this.countTime) : null;
    },
    // 只显示可加入房间
    SetFilterCanJoinTeam: function(val) {
        this.isJoin = val;
        this.sbtnGouxuan21.SetButtonState(val ? this.checkBoxState[0] : this.checkBoxState[1]);
        Mgr.crossteam.FilterCanJoinTeam();
    },
    // 只允许邀请的玩家加入
    SetAllowStrangerIn: function(val) {
        this.isInvite = val;
        this.sbtnGouxuan2.SetButtonState(val ? this.checkBoxState[0] : this.checkBoxState[1]);

        this._inviteType = val ? EnumCrossteamType.TEAM_ALLOW : EnumCrossteamType.TEAM_NOY_ALLOW;
    },
    // 满员自动开始
    SetAutoStartWhenFull: function(val) {
        this.isManyuanAutoStart = val;
        this.sbtnGouxuan211.SetButtonState(val ? this.checkBoxState[0] : this.checkBoxState[1]);

        this._autoType = val ? EnumCrossteamType.TEAM_ALLOW : EnumCrossteamType.TEAM_NOY_ALLOW;
    },

    SetManYuanKaiShiCheckBoxState: function(type) {
        this.SetAutoStartWhenFull(type == 1);
        if (this.isManyuanAutoStart) {
            this.sbtnGouxuan211.SetButtonState(this.checkBoxState[0]);
            var isTeamer = this._GetTeamer();
            if (Mgr.crossteam.isInteam && isTeamer) {
                this.SetAutoStartFuben(Mgr.crossteam.myTeam.memberinfo)
            }

        }
    },
    SetYaoQingCheckBoxState: function(type) {
        this.SetAllowStrangerIn(type == 1);
    },

    //创建房间
    doCreateRoom: function() {
        var type = this._GetZoneType();
        if (type == EnumZoneType.TYPE_LFDR) {
            Mgr.zoneteam.SendReqZoneTeamCreatClientToGameMessage(0, 0, EnumZoneType.TYPE_LFDR);
        } else if (type == EnumZoneType.TYPE_KFDR) {
            var msg = {
                zoneModelId: this.selectedItem.data.base.zoneModelid, // 绑定副本模版
                needFightpower: 0, // 所需战斗力
                autoStart: true, // 是否自动开始
                passWord: null, // 队伍密码
            }
            Mgr.crossteam.SendReqCreateCrossTeamClientToGameMessage(msg);
        }
        this.UpdateInformation(this.selectedItem);
    },

    //快速加入
    doQuickJoin: function() {
        var type = this._GetZoneType();
        if (type == EnumZoneType.TYPE_LFDR) {
            var readyNum = this.isAutoReady ? 1 : 0;
            Mgr.zoneteam.SendReqZoneTeamJoinClientToGameMessage(new Long(), readyNum,EnumZoneType.TYPE_LFDR);
        } else if (type == EnumZoneType.TYPE_KFDR) {
            var zoneModelId = this.selectedItem.data.base.zoneModelid;
            var msg = {
                teamid: new Long(), // 队伍Id（id为0表示快速加入）
                zoneModelId: zoneModelId, // 副本模版
                passWord: null, // 队伍密码
            }
            Mgr.crossteam.SendReqJoinCrossTeamClientToGameMessage(msg);
        }
    },

    _CountDown: function() {
        this.countTime--;
        this.labTime.SetString(this.countTime);
        if (this.countTime == 0) {
            this.SetAutoJoinOrCreateRoom(false);


            var zoneModelId = this.selectedItem.data.base.zoneModelid;
            var type = this.zonetype;
            var islianfu = type == EnumZoneType.TYPE_LFDR ? true : false;
            var listview = Mgr.crossteam.teamListview.Get(zoneModelId);
            var randomTeamId = this.GetAdaptConditionTeamInfo(listview);
            if (listview && listview.getItems().length > 0 && randomTeamId) {
                if (islianfu) {
                    this.doQuickJoin();
                } else {
                    if (randomTeamId && randomTeamId.needCheck == 0) {
                        var msg = {
                            teamid: randomTeamId.teamId /*listview.getItems()[0].data.teamId*/ , // 队伍Id（id为0表示快速加入）
                            zoneModelId: zoneModelId, // 副本模版
                            passWord: null, // 队伍密码
                        }
                        Mgr.crossteam.SendReqJoinCrossTeamClientToGameMessage(msg);
                    } else {
                        this.doCreateRoom();
                    }
                }
            } else {
                this.doCreateRoom();
            }
        }
    },
    GetAdaptConditionTeamInfo: function(listview) {
        if (!listview) {
            return false;
        }
        var items = listview.getItems();
        for (var i = 0; i < items.length; i++) {
            var data = items[i].data;
            if (data.memberinfo.length < EnumCrossteamType.TEAM_MEM_NUMBER) {
                return data;
            }
        }
        return false;
    },
    //查看玩家是否为队长
    _GetTeamer: function() {
        var pId = Mgr.player.mainPlayer.sid.toGID();
        var items = this.myTeamList.getItems();
        for (var i = 0; i < items.length; i++) {
            var data = items[i].data;
            if (data && data.memberId.toGID() == pId) {
                if (items[i].index == 0) {
                    return true;
                }
            }
        }
        return false;
    },
    //默认选择当前等级可挑战的最高副本
    ShowDefaultZoneItem: function() {
        if (this._GetZoneType() == EnumZoneType.TYPE_LFDR) {
            return;
        }
        var pLv = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);
        var childes = this.zoneScrollview.getChildren();
        var item = null;
        for (var i = 0; i < childes.length - 1; i++) {
            var data01 = childes[i].data.detail;
            var data02 = childes[i + 1].data.detail;
            if (pLv >= data01.q_level && pLv < data02.q_level) {
                item = childes[i];
                break;
            } else if (pLv < data01.q_level) {
                item = childes[i];
                break;
            } else if (pLv >= childes[childes.length - 1].data.detail.q_level) {
                item = childes[childes.length - 1];
                break;
            }
        }
        if (item) {
            item.ShowDetailEvent(null, 2);
        }
    },
    ClearData: function() {
        if (this.myTeamList) {
            this.myTeamList.removeAllItems();
        }
    },
    SetReward: function() {
        var item = JSON.parse(Q_global.Get(1045).q_string_value);
        for (var i = 0; i < item.length; i++) {
            var data = ItemUtil.ItemIdToItem(item[i].mod, item[i].num);
            if (data) {
                GridUtil.SetItemGrid(this._gridArr[i], data, null, null, null, null, true);
            }
        }
    },
    ShowOrHideComponent: function(isShow) {
        this.imgBg1.visible = isShow;
        this._SetGridVisible(isShow);
    },
    _GetZoneType: function() {
        return Mgr.zoneteam.GetDuorenPanel().zonetype;
    },
    _SetGridVisible: function(isShow) {
        for (var i = 0; i < this._gridArr.length; i++) {
            this._gridArr[i].visible = isShow;
        }

    }
});
DuorenTeamMainExt.PanelName = "DuorenTeamMainExt";
PanelClassDic["DuorenTeamMainExt"] = DuorenTeamMainExt;