var YaoqingMainExt = YaoqingMain.extend ( {
	_className:"YaoqingMainExt",
	isShowTween : true,
	btnCount:[0,1,2],
	btnArr:[],
	listviewArr:[],
	_currentIndex:0,
	checkBoxState:[ MUICheckBox.STATE_CHECK , MUICheckBox.STATE_UNCHECK],
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.layoutCom.layoutType = MLLAYOUT_C;
	},
	Init:function()
	{
		YaoqingMain.prototype.Init.call(this);
		this.labCue.SetColor(EnumFontFormat.COMMON_COLOR08);
		this._AddListview();
		this._HandleButton();
		this._ChangeList(this.btnCount[0]);
	},
	_HandleButton:function()
	{
		var self = this;
		this.btnArr = [this.sbtnFujin,this.sbtnGuild,this.sbtnFriend];
		this.btnClose.addClickEventListener(function() {
			EngineMgr.uiMgr.HidePanel( self );
		} );
		this.btnShuaxin.addClickEventListener(function (){
			self.RequiestPlayerData();
		});
		for(var i = 0; i<this.btnArr.length; i++)
		{
			this.btnArr[i].type = i;
			this.btnArr[i].addTouchEventListener( function (target,state) {
				if(state == ccui.Widget.TOUCH_ENDED)
				{
					self._ChangeList(target.type);
				}
			} );
		}
	},
	_AddListview:function()
	{
		for(var i = 0; i < 3; i++ )
		{
			var listview = Mgr.crossteam.GetListview(852,300);
			listview.index = i;
			listview.setPosition(this.imgDikuang.x,93);
			this.addChild(listview);
			this.listviewArr.push(listview);
		}
	},
	RequiestPlayerData:function()
	{
		var friendData = Mgr.friend.friendList;
		var len = friendData.Size();
		var playerIds = [];
		for(var i = 0; i < len; i++ )
		{
			var data = friendData.Values()[i];
			if(data.state && !this._CheckIsInZoneMap(data.mapId))
			{
				if(!this._JugementInTeam(data.playerId))
				{
					playerIds.push(data.playerId);
				}
			}
		}
		if(playerIds.length > 0)
		{
			this._SendRequistPlayerBrifInfo(playerIds,EnumBriefType.TEAM_INVISITE);
		}
        else
        {
            this.listviewArr[this.btnCount[2]].removeAllItems();
        }
		//请求帮会成员
		var guildId = Mgr.player.mainPlayer.guildId;
		if(guildId.hValue!=0)
		{
			Mgr.guild.SendReqGuildGetMemberListMessage();
		}
		//请求本地图玩家信息（附近）
		Mgr.team.SendReqMapSearchPlayerInfoGameMessage();
	},
	GetInvisiteGuildList:function(msg)
	{
		var list = msg.memberList
		var len = list.length;
		var playerIds = [];
		for(var i = 0; i < len; i++ )
		{
			var data = list[i];
			if(data.isOnline && !this._CheckIsInZoneMap(data.mapModelId) && !data.playerId.Equal(Mgr.player.mainPlayer.sid))
			{
                if(!this._JugementInTeam(data.playerId))
                {
                    playerIds.push(data.playerId);
                }
			}
		}
		if(playerIds.length > 0)
		{
			this._SendRequistPlayerBrifInfo(playerIds,EnumBriefType.TEAM_GUILD_INVISITE);
		}
        else
        {
            this.listviewArr[this.btnCount[1]].removeAllItems();
        }
	},
	SetMapSearchedPlayerInfo:function(msg)
	{
		var playerIds = [];
		for ( var i = 0; i != msg.mapplayerinfo.length; i++ )
		{
			if ( msg.mapplayerinfo[i].teamstate == 0 && !msg.mapplayerinfo[i].playerid.Equal(Mgr.player.mainPlayer.sid) )
			{
                if(!this._JugementInTeam(msg.mapplayerinfo[i].playerid))
                {
                    playerIds.push(msg.mapplayerinfo[i].playerid);
                }
			}
		}
        if(playerIds.length>0)
        {
            this._SendRequistPlayerBrifInfo(playerIds,EnumBriefType.TEAM_MAP_INVISITE);
        }
        else
        {
            this.listviewArr[this.btnCount[0]].removeAllItems();
        }
	},
	_SendRequistPlayerBrifInfo:function(playerIds,type)
	{
		Mgr.player.SendReqPlayerBriefMessage(playerIds,type);
	},
	SetInvisiteFriendList:function(msg)
	{
		this.listviewArr[this.btnCount[2]].removeAllItems();
		var data = msg.playerBriefs;
		var len = data.length;
		for( var i = 0; i < len;i++ )
		{
			if(this._CheckPlayerLevel(data[i]))
			{
				var item = new YaoqingListExt(data[i]);
				item.LoadPanel();
				this.listviewArr[this.btnCount[2]].pushBackCustomItem(item);
			}
		}
		this._ChangeList(this._currentIndex);
	},
	SetInvisiteGuildList:function(msg)
	{
		this.listviewArr[this.btnCount[1]].removeAllItems();
		var data = msg.playerBriefs;
		var len = data.length;
		for( var i = 0; i < len;i++ )
		{
			if(this._CheckPlayerLevel(data[i]))
			{
				var item = new YaoqingListExt(data[i]);
				item.LoadPanel();
				this.listviewArr[this.btnCount[1]].pushBackCustomItem(item);
			}
		}
		this._ChangeList(this._currentIndex);
	},
	SetInvisiteSearchedList:function(msg)
	{
		this.listviewArr[this.btnCount[0]].removeAllItems();
		var data = msg.playerBriefs;
		var len = data.length;
		for( var i = 0; i < len;i++ )
		{
			if(this._CheckPlayerLevel(data[i]))
			{
				var item = new YaoqingListExt(data[i]);
				item.LoadPanel();
				this.listviewArr[this.btnCount[0]].pushBackCustomItem(item);
			}
		}
		this._ChangeList(this._currentIndex);
	},
	_ChangeList:function(type)
	{
		this._currentIndex = type;
		for (var i = 0; i < this.btnArr.length; i ++)
		{
			if(type == i)
			{
				this.listviewArr[i].visible = true;
				this.btnArr[i].SetButtonState(this.checkBoxState[0]);
				this.labCue.visible = true;
				if(this.listviewArr[i].getItems().length > 0)
				{
					this.labCue.visible = false;
				}
			}
			else
			{
				this.listviewArr[i].visible = false;
				this.btnArr[i].SetButtonState(this.checkBoxState[1]);
			}
		}
	},
	_CheckIsInZoneMap:function(mapid)
	{
		var zoneList = Mgr.dataMgr.GetZoneList();
		for(var i = 0; i <zoneList.length; i++)
		{
			var q_mapid = zoneList[i].q_mapid.substring(1,zoneList[i].q_mapid.length-1);
			if(q_mapid == mapid)
			{
				return true;
			}
		}
		return false;
	},
	_JugementInTeam:function(playerId)
	{
        var teamplayer = Mgr.crossteam.myTeam.memberinfo;
        for( var i = 0; i < teamplayer.length; i++ )
        {
            if(teamplayer[i].memberId.toGID() == playerId.toGID())
            {
                return true;
            }
        }
        var list = Mgr.crossteam.teamList.Values();
        for(var j = 0; j <list.length; j++)
        {
            var teamplayer = list[j].memberinfo;
            for( var i = 0; i < teamplayer.length; i++ )
            {
                if(teamplayer[i].memberId.toGID() == playerId.toGID())
                {
                    return true;
                }
            }
        }
		return false;
	},
	_CheckPlayerLevel:function(data)
	{
		var currentZoneData = Q_zone.Get(Mgr.crossteam.myTeam.zoneModelId);
		if (currentZoneData &&data.level >= currentZoneData.q_level)
		{
			return true;
		}
		return false;
	},
	OnShow:function()
	{
		this.RequiestPlayerData();
	}
} );
YaoqingMainExt.PanelName = "YaoqingMainExt";
PanelClassDic["YaoqingMainExt"] = YaoqingMainExt;
