var FubenWinExt = FubenWin.extend ( {
	_className:"FubenWinExt",
	_rawardCon:null,
	_timerNum:0,
	_time:0,
	_zoneModelId:0,
	modelPanelType:2,
	_glow:null,
	_normalPos:null,
    _maskScrollView:null,
    starMc:null,
    fog1Mc:null,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.showLayerType = UIMgr.PANEL_LAYER_TOP;
		//this.setSwallowTouches(true);
	},
	
	Init: function () {
		TuojiguaMain.prototype.Init.call(this);
		this.imgStar.visible = false;
		this.imgYan.visible = false;
		this._HandleButton();
		this._InitProperty();
	},
	_HandleButton:function()
	{
		var self = this;
		this.btnGo.addClickEventListener(function (event){
			self.NextZone();
		});
		this.btnOk.addClickEventListener(function (event){
				self.OutZone();
		});
	},
	_InitProperty:function()
	{
		this.imgGlowZhongxin.y += 20;
		this._normalPos = {
			jian:this.imgJian.getPosition(),
			left:this.imgRight.getPosition(),
			right:this.imgLeft.getPosition(),
			center:this.imgTitleCircl.getPosition(),
		}
		this.imgWin.setAnchorPoint(0.5,0.5);
		this.imgWin.x += this.imgWin.width/2;
		this.imgWin.y += this.imgWin.height/2;
		this.imgTitlebg.setAnchorPoint(0.5,0.5);
		this.imgTitlebg.x += this.imgTitlebg.width/2;
		this.imgTitlebg.y += this.imgTitlebg.height/2;
	},
	_AddMask:function()
	{
		if(this._maskScrollView)
		{
			this._StartActions();
			return;
		}
		var size = this.imgGlow.getContentSize();
		this.imgGlow.visible = false;
		this._maskScrollView = Mgr.crossteam.GetScrollView();
		this._maskScrollView.setContentSize(size);
		this._maskScrollView.x = -size.width/2;
		this._maskScrollView.setInnerContainerSize(size);
		this.imgGlowZhongxin.addChild(this._maskScrollView);
		var self = this;
		if(!this._glow)
		{
			Mgr.uiMgr.LoadOtherRes( "other/danrenfuben" ,
				{
					Callback:function()
					{
						var glow = new ccui.ImageView("other/danrenfuben/image/action/lay.png",1);
						glow.setPosition(size.width/2,0);
						self._glow = glow;
						self._maskScrollView.addChild(self._glow);
						self._StartActions();
					},
					ErrCallback:function(){
						// complete();
					}
				});
		}
		else
		{
			this._StartActions();
		}
	},
    SetInfo:function(zoneModelId,zoneType){
		this._zoneModelId = zoneModelId;
        this._zoneType = zoneType || Mgr.zone.GetCurrentZoneType();
		this.UpdateRaward();

		if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_WD){
			this._time = 5;
		}else{
			this._time = 10;
		}
		this.OnTimer();
		TimerUtil.ClearTimeUpdate(this._timerNum, this);
		this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

		this.UpdateBtnState();
	},

	OutZone:function(){
		if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_WD){
			Mgr.zone.SendReqZoneOutToGameMessage();
		}
		else if(this._zoneType == EnumZoneType.TYPE_KFDR)
		{
            //Mgr.cross.SendReqQuitClientToFightMessage();
            /// 离开队伍
            Mgr.crossteam.SendReqLeaveCrossTeamClientToGameMessage();
		}
		else if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_LFDR)
		{
			Mgr.zone.SendReqZoneOutToGameMessage();
		}
		else{
			Mgr.zone.SendReqZoneOutToGameMessage();
		}
		Mgr.drop.ClearZoneDrop();
		Mgr.uiMgr.HidePanel(this);
	},

	NextZone:function(){
		if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_WD){
			Mgr.zonejianghu.NextWending();
		}
		else if(this._zoneType == EnumZoneType.TYPE_KFDR)
		{
            //Mgr.cross.SendReqQuitClientToFightMessage();
            if(Mgr.crossteam.isAutoRepeat){
                Mgr.crossteam.SendReqStartCrossTeamZoneClientToGameMessage(Mgr.crossteam.curzoneModelId);
            }
		}
		else if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_LFDR)
		{
			Mgr.zone.SendReqZoneOutToGameMessage();
		}
		else{
			Mgr.zone.SendReqZoneOutToGameMessage();
		}
		Mgr.drop.ClearZoneDrop();
		Mgr.uiMgr.HidePanel(this);
	},
	
	UpdateRaward:function(){
		if(this._rawardCon == null){
			UIUtil.UIRemoveSelf(this.gridItem);
			this._rawardCon = new TaskRewardsGridCon();
			this.imgBg.addChild(this._rawardCon);
		}
		this._rawardCon.Clear();
		var rawardStr = "";
		var rawardStrFirst = "";
		if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_JQ){
			if(this._zoneModelId != 0 && Mgr.zone.StoryIsFirst(this._zoneModelId) != 1){
				var zoneData = Q_story.Get(this._zoneModelId);
				if(zoneData)
					rawardStr = zoneData.q_first_reward;
			}
		}else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_JJ
            || Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_QINGYUAN
		){
			var zoneData = Q_story.Get(this._zoneModelId);
			if(zoneData)
				rawardStr = zoneData.q_reward;
		}else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_WD){
			var zoneData = Q_temple.Get(this._zoneModelId);
			if(zoneData)
				rawardStr = zoneData.q_reward_daily;
			if( this._zoneModelId > Mgr.zonejianghu.jianghuMaxWave )//需要显示首通奖励
				rawardStrFirst = zoneData.q_reward_first;
		}else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_LFDR){
			var zoneData = Q_global.Get(1045);
			if(zoneData)
				rawardStr = zoneData.q_string_value;
		}else if(this._zoneType == EnumZoneType.TYPE_KFDR){
			var zoneData = Q_raid.Get(this._zoneModelId);
			if(zoneData)
			{
				rawardStr = zoneData.q_daily_reward
			}
			var data = Mgr.crossteam._zoneListData.Get(this._zoneModelId);
			if( data && data.base.isFirst == 1 )//需要显示首通奖励
			{
				rawardStrFirst = zoneData.q_first_reward;
			}
        }else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_VIP){
            var zoneData = Q_story.Get(this._zoneModelId);
            if(zoneData)
                rawardStr = zoneData.q_reward;
        }
		var dropRawards = Mgr.drop.GetDropSimpleItemInfos(this._zoneModelId);
		if( rawardStr == "" && rawardStrFirst == "" && dropRawards == null ){
			this._rawardCon.setVisible(false);
			this.labJiangli.setVisible(false);
        }else{
			this.labJiangli.setVisible(true);
			var rawards = [];
			if( rawardStr != ""&&rawardStr )
				rawards = JSON.parse( rawardStr );
			if( rawardStrFirst != "" )
			{
				var rawardFirsts = JSON.parse( rawardStrFirst );
				for ( i = 0; i < rawards.length ; i ++){
					for ( j = 0; j < rawardFirsts.length ; j ++){
						if(rawards[ i ].mod == rawardFirsts[ j ].mod){
							rawards[ i ].num += rawardFirsts[ j ].num;
							rawardFirsts.splice(j,1);
							break;
						}
					}
				}
				rawards = rawards.concat(rawardFirsts);
			}
			var count = 0;
			var i = 0;

			if( rawards ){
				for ( i = 0; i < rawards.length ; i ++){
					var item = ItemUtil.ItemIdToItem(rawards[ i ].mod,rawards[ i ].num,rawards[ i ].bind);
					this._rawardCon.AddComItem(item,this.gridItem);
					count++;
				}
			}

			if( dropRawards && this._zoneType != EnumZoneType.TYPE_KFDR){
				for ( i = 0; i < dropRawards.length ; i ++){
					var item = ItemUtil.ItemIdToItem(dropRawards[ i ].itemModelId,dropRawards[ i ].num);
					this._rawardCon.AddComItem(item,this.gridItem);
					count++;
				}
			}

			if ( count > 0 ){
				this._rawardCon.Layout( this.gridItem.uiWidth * count, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight );
				this._rawardCon.x = ( this.imgBg.uiWidth - this.gridItem.uiWidth * count ) / 2;
				this._rawardCon.y = this.gridItem.y;
				this._rawardCon.setVisible(true);
			}
		}
	},
	
	UpdateBtnState:function(){
		if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_JQ){
			this.btnGo.setVisible(false);
			this.btnOk.x = (this.imgBg.uiWidth - this.btnOk.uiWidth)/2;
			this.btnOk.setTitleText("我知道了");
        }else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_JJ
            || Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_VIP){
			this.btnGo.setVisible(false);
			this.btnOk.x = (this.imgBg.uiWidth - this.btnOk.uiWidth)/2;
			this.btnOk.setTitleText("我知道了");
		}else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_WD){
			this.btnGo.setVisible(true);
			this.btnOk.x = this.btnOk.initX;
			this.btnOk.setTitleText("我知道了");
		}else if(this._zoneType == EnumZoneType.TYPE_KFDR){
			this.btnGo.setVisible(true);
			this.btnOk.x = this.btnOk.initX;
			this.btnOk.setTitleText("退出队伍");
		}
		else if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_LFDR)
		{
			this.btnGo.setVisible(false);
			this.btnOk.x = (this.imgBg.uiWidth - this.btnOk.uiWidth)/2;
			this.btnOk.setTitleText("退出队伍");
		}
		else{
			this.btnOk.setTitleText("我知道了");
		}
	},

	OnTimer:function () {
		this._time--;
		if( this._time == 0 ){
			this.NextZone();		//这里改成next  问鼎江湖自动走下一关
			return;
		}
		this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ this._time ] ));
	},
	
	OnShow:function(){
		this.ShowActive();
	},
	
	OnHide:function(){
		this._super();
        TimerUtil.ClearTimeUpdate(this._timerNum, this);
        this._timerNum = null;

        if(this._rawardCon)
        {
            this._rawardCon.Clear();
        }
		this._zoneModelId = 0;
		this.HideAction();
	},
	_StartActions:function()
	{
		this._SetParticEffect();
        this._StartLineAction();
		var time = 0.3;
		//背光光效
		this._glow.opacity = 0;
		var fadeIn = cc.fadeIn(time);
		var rotateby = new cc.RotateBy(10, 360).repeatForever();
		this._glow.runAction(rotateby);
		this._glow.runAction(fadeIn);
		//剑
		this.imgJian.opacity = 0;
		this.imgJian.y = this._normalPos.jian.y-20;
		var fadeIn = cc.fadeIn(time);
		var moveBy = cc.moveBy(time,0,20);
		var spawn = cc.spawn(fadeIn,moveBy);
		this.imgJian.runAction(spawn);
		//left
		var gap = 20;
		this.imgRight.opacity = 0;
		this.imgRight.setPosition(this._normalPos.left.x+gap,this._normalPos.left.y-gap);
		var fadeIn = cc.fadeIn(time);
		var moveBy = cc.moveBy(time,-gap,gap);
		var spawn = cc.spawn(fadeIn,moveBy);
		this.imgRight.runAction(spawn);
		//right
		this.imgLeft.opacity = 0;
		this.imgLeft.setPosition(this._normalPos.right.x-gap,this._normalPos.right.y-gap);
		var fadeIn = cc.fadeIn(time);
		var moveBy = cc.moveBy(time,gap,gap);
		var spawn = cc.spawn(fadeIn,moveBy);
		this.imgLeft.runAction(spawn);
		//center
		this.imgTitleCircl.opacity = 0;
		this.imgTitleCircl.y-=10;
		var fadeIn = cc.fadeIn(time);
		var moveBy = cc.moveBy(time,0,10);
		var spawn = cc.spawn(fadeIn,moveBy);
		this.imgTitleCircl.runAction(spawn);
		//scale
		var scale01 = 0.8;
		var scale02 = 1;
		this.imgTitlebg.scale = scale01;
		this.imgTitlebg.opacity = 0;
		var fadeIn = cc.fadeIn(time);
		var scaleTo = cc.scaleTo(time,scale02,scale02);
		var spawn = cc.spawn(fadeIn,scaleTo);
		this.imgTitlebg.runAction(spawn);

		this.imgWin.opacity = 0;
		this.imgWin.scale = scale01-0.2;
		var fadeIn = cc.fadeIn(time);
		var scaleTo = cc.scaleTo(time,scale02,scale02);
		var spawn = cc.spawn(fadeIn,scaleTo);
		this.imgWin.runAction(spawn);
	},
    _StartLineAction:function()
	{
        this.imgLine.stopAllActions();
        this.imgLineGlow.stopAllActions();
        var time = 2,self = this;
        this.imgLineGlow.x = this.imgLine.x;
        this.imgLineGlow.opacity = 0;
        this.imgLine.opacity = 0;
        var gap = this.imgLine.width - this.imgLineGlow.width;
        var fadeIn = cc.fadeIn(time/2);
        var moveBy01 = cc.moveBy(time/2,1/3*gap,0);
        var moveBy02 = cc.moveBy(time,1/3*gap,0);
        var delay    = cc.delayTime(time/2);
        var moveBy03 = cc.moveBy(time,1/3*gap,0);
        var fadeOut  = cc.fadeOut(time)
        var spawn01 = cc.spawn(fadeIn,moveBy01);
        var spawn02 = cc.spawn(moveBy03,fadeOut);
        var delayt  = cc.delayTime(time);
        var callback = cc.callFunc(function(target)
        {
            self._StartLineAction();
        },this);
        var sequenc = cc.sequence(spawn01,moveBy02,delay,spawn02,delayt,callback);
        this.imgLineGlow.runAction(sequenc);
        var delay02 = cc.delayTime(5/2*time)
        var fadeOut02 = cc.fadeOut(time/2);
        var sequence = cc.sequence(fadeIn.clone(),delay02,fadeOut02);
        this.imgLine.runAction(sequence);
	},
	_SetParticEffect:function()
	{
        //星星球形粒子动画
        this.starMc = new TweenParticleMovie(this.imgStar, 1, 0.5, 240, 200);
        this.starMc.x = this.imgStar.x+311;
        this.starMc.y = this.imgStar.y-177;
        this.addChild(this.starMc,this.imgCircl.getLocalZOrder());
        this.starMc.setAngle(90, 30);
        this.starMc.play();
        //烟雾球形粒子动画
        this.fog1Mc = new TweenParticleMovie(this.imgYan, 4, 0.5);
        this.fog1Mc.x = 131;
        this.fog1Mc.y = 53;
        this.imgCircl.addChild(this.fog1Mc);
        this.fog1Mc.setRound();
        this.fog1Mc.setAngle(90, 35);
        this.fog1Mc.play();
	},
	_StopActions:function()
	{
        this.starMc.removeThisAll();
        this.fog1Mc.removeThisAll();
        this.starMc.removeFromParent();
        this.fog1Mc.removeFromParent();
        this.starMc=null;
        this.fog1Mc=null;
		this._glow.stopAllActions();
        this.imgLine.stopAllActions();
        this.imgLineGlow.stopAllActions();
	},

	ShowActive:function(){
		this._AddMask();
	},

	HideAction:function(){
        this._StopActions();
	},
} );
FubenWinExt.PanelName = "FubenWinExt";
PanelClassDic["FubenWinExt"] = FubenWinExt;
