var TaskRewardsGridCon = ccui.Widget.extend(/** @lends cc.Node# */{
	_size:2,
	
	ctor: function(){
		this._super();
	},
	
	AddComItem:function( item, mirrorGrid, size ){
		if (item != null)
		{
			var tipStr;
			var bmp;
			var grid = new GridItem();
			grid.ParseJson( mirrorGrid.jsonobj );
			grid.Init();
			grid.retain();
			this.addChild( grid );
			var itemSize=arguments[2]?arguments[2]:ResUrl.ITEM_SIZE_60; //设置size
			if ( item != null )
			{
				grid.SetItemInfo( item, GridTypeEnum.SHOWITEM, true, itemSize );
				grid.addClickEventListener(function(){
                    ItemUtil.ShowTips(item,1);
				});
			}
		}
	},
	
	Layout:function( conW, conH, titleW, titleH, horizontalGap, verticalGap, isLeftLayout ){
		var childrenArr = this.getChildren();
		var hGap=arguments[4]?arguments[4]:0;
		var vGap=arguments[5]?arguments[5]:0;
		var wNum = Math.floor( (conW+hGap)/(titleW+hGap) );
		var hNum = Math.floor( (conH+vGap)/(titleH+vGap) );
		var layoutNum = ( isLeftLayout ? -1 : 1);
		for( var i = 0; i < childrenArr.length; i++ )
		{
			childrenArr[i].x = layoutNum * i%wNum*(titleW+hGap);
			childrenArr[i].y = parseInt(i/wNum)*(titleH+vGap);
		}
	},

	Clear:function(){
		var childrenArr = this.getChildren();
		for(var i = 0; i < childrenArr.length; i++){
			childrenArr[i].Clear();
			UIUtil.UIRemoveSelf(childrenArr[i]);
		}
	}
});