///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//213201,ReqEnterJianghuNextToGame 前端请求进入问鼎江湖下一层

// 接收消息
//213101,ResJianghuInfoToClient 问鼎江湖面板数据信息 
//213102,ResJianghuResultToClient 问鼎江湖副本挑战结果


////////////////////
// 问鼎江湖面板数据信息  //
////////////////////
var ResJianghuInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.sweepNums = 0; // 已扫荡次数
        this.historyMaxStep = 0; // 历史通关最高层数
        this.nowFinishStep = 0; // 今日已经通关的层数
	},

	getId:function(){
		return 213101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.sweepNums);
        _buf.WriteVarInt(this.historyMaxStep);
        _buf.WriteVarInt(this.nowFinishStep);
	},
	
	reading:function( _buf ){
        this.sweepNums = _buf.ReadVarInt();
        this.historyMaxStep = _buf.ReadVarInt();
        this.nowFinishStep = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zonejianghu.RecvResJianghuInfoToClientMessage(this);
	},

});
////////////////////
// 问鼎江湖副本挑战结果 //
////////////////////
var ResJianghuResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.stepId = 0; // 层数ID
        this.result = 0; // 1挑战成功 2挑战失败
	},

	getId:function(){
		return 213102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.stepId);
        _buf.WriteByte(this.result);
	},
	
	reading:function( _buf ){
        this.stepId = _buf.ReadVarInt();
        this.result = _buf.ReadByte();
	},

	action:function(){
		Mgr.zonejianghu.RecvResJianghuResultToClientMessage(this);
	},

});
////////////////////
// 前端请求进入问鼎江湖下一层 //
////////////////////
var ReqEnterJianghuNextToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 213201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(213101, ResJianghuInfoToClientMessage);
MESSAGE_POOL.Add(213102, ResJianghuResultToClientMessage);

