var ZoneteamModMgr = ZoneteamModMgr || cc.Class.extend({
    _zoneListData:null,
    teamList:null,
    zoneInfos:null,
    _playerPanelArr:[],
    isInZoneFight:false,
    ctor:function() {
        this._zoneListData = new HashMap();

        this.$teamInfo = {};
    },
    GetZoneTeamInfo:function(type){
        return this.$teamInfo[type]
    },
    //队伍列表信息
    RecvResZoneTeamInfoGameToClinetMessage:function(msg) {
        /// 情缘副本
        if(msg.zonetype == EnumZoneType.TYPE_QINGYUAN){
            this.$teamInfo[msg.zonetype] = cc.extend(msg,{
                getTeamId:function(){
                    return this.teamid;
                },
                getMyTeam:function(){
                    return this.getPlayerTeamInfo(Mgr.player.mainPlayer.sid)
                },
                getPlayerTeamInfo:function(playerId){
                    return this.teamInfo.find(v=>v.memberinfo.findIndex(vv=>vv.memberId.Equal(playerId)) != -1)
                },
                isCaptain:function(){
                    var myTeam = this.getMyTeam()
                    return myTeam && myTeam.memberinfo[0].memberId.Equal(Mgr.player.mainPlayer.sid)
                },
                updateTeamInfo:function(teamInfo){
                    var index = this.teamInfo.findIndex(v=>teamInfo.teamId.Equal(v.teamId))
                    if(index != -1){
                        this.teamInfo[index] = teamInfo
                    }else{
                        this.teamInfo.push(teamInfo)
                    }
                },
            })
            GameEventMgr.DispatchEvent(EnumEventType.GAME_ZONETEAM_UPDATE_TEAMINFO,msg)
            return
        }

        msg.teamInfo = this._HandleTeamInfoMembers(msg.teamInfo);
        msg.teamInfo.sort(function(a,b){return a.memberinfo.length - b.memberinfo.length;});
        var teamlist = msg.teamInfo;
        var len = teamlist.length;
        var mainPanel = this.GetDuorenPanel().mainPanel;
        mainPanel.SetZoneChallangeNum(msg);
        this._SetMyteam(msg.teamInfo);
        if(len>0 )
        {
            mainPanel.SetTeamlistData(msg);
        }
        else if(len == 0)
        {
            var listview = Mgr.crossteam.teamListview.Values()[0];
            if(listview)
            {
                listview.removeAllItems();
            }
        }
        Mgr.crossteam.teamList.Clear();
        for(var i = 0; i < len; i++ )
        {
            Mgr.crossteam.teamList.Put(teamlist[i].teamId,teamlist[i]);
        }
        mainPanel.ChangeVisible();
        if(!Mgr.crossteam.isInteam)
        {
            if(mainPanel.myTeamList)
            {
                mainPanel.myTeamList.removeAllItems();
                mainPanel.myTeamList.visible = false;
            }
        }
        else
        {
            var teamInfo = Mgr.crossteam.teamList.Get(msg.teamid);
            var data = {teamInfo:teamInfo}
            this._UpdateTheTeamInfo(data);
        }
        //var panel = Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName);
        //if (panel && panel.curSubType == TeamEnum.PANEL_TEAM_QUICK_TEAM)
        //	panel.curSubPanel.SetRaidFbData(msg.teamInfo);
    },

    //刷新队伍信息
    RecvResZoneTeamInfoRefreshGameToClinetMessage:function(msg) {
        /// 情缘副本
        if(msg.zonetype == EnumZoneType.TYPE_QINGYUAN){
            if(this.$teamInfo[msg.zonetype]){
                this.$teamInfo[msg.zonetype].updateTeamInfo(msg.teamInfo)
            }

            GameEventMgr.DispatchEvent(EnumEventType.GAME_ZONETEAM_UPDATE_TEAMINFO,msg)
            return
        }

        if(msg.teamInfo.memberinfo.length > 0)
        {
            this._SetMyteam([msg.teamInfo]);
            this._UpdateTheTeamInfo(msg);
        }
    },

    RecvResTeamMemberStatusGameToClinetMessage:function(msg) {
    },
    //邀请玩家
    RecvResZoneTeamInvitePlayerToClinetMessage:function(msg) {
        if(Mgr.plugset.GetSysSetInfo().banInviteTeam)
        {
            return;
        }
        EngineMgr.uiMgr.ShowPanelByType(YaoqingCueExt.PanelName,UIMgr.PANEL_LAYER_TOP);
        var panel = Mgr.uiMgr.GetPanelByType(YaoqingCueExt.PanelName);
        if(panel)
        {
            msg.zoneModel = msg.zonemodelid;
            msg.job = Mgr.player.mainPlayer.job == 2 ? 1 : 2
            panel.SetInformation(msg);
        }
    },
    //请求组队队伍面板信息
    SendReqZoneTeamClientToGameMessage:function(type) {
        var msg = new ReqZoneTeamClientToGameMessage();
        msg.zonetype = type || EnumZoneType.TYPE_LFDR;
        Mgr.msgMgr.Send(msg);
    },
    //创建队伍
    SendReqZoneTeamCreatClientToGameMessage:function(onlyInvite,autoStart,type) {
        var msg = new ReqZoneTeamCreatClientToGameMessage();
        msg.autoStart = autoStart;
        msg.onlyInvite = onlyInvite;
        msg.zonetype = type || EnumZoneType.TYPE_LFDR;
        Mgr.msgMgr.Send(msg);
    },
    //改变设置
    SendReqZoneTeamChangeConfigToGameMessage:function(onlyInvite,autoStart,zonetype) {
        var msg = new ReqZoneTeamChangeConfigToGameMessage();
        msg.zonetype = zonetype || EnumZoneType.TYPE_LFDR;
        msg.onlyInvite = onlyInvite;
        msg.autoStart = autoStart;
        Mgr.msgMgr.Send(msg);
    },
    //加入队伍
    SendReqZoneTeamJoinClientToGameMessage:function(teamid,autoready,zonetype) {
        var msg = new ReqZoneTeamJoinClientToGameMessage();
        msg.zonetype = zonetype || EnumZoneType.TYPE_LFDR;
        msg.teamid = teamid;
        msg.autoready = autoready;
        Mgr.msgMgr.Send(msg);
    },
    //邀请玩家
    SendReqZoneTeamInvitePlayerToGameMessage:function(invitePlayerId,zonetype) {
        var msg = new ReqZoneTeamInvitePlayerToGameMessage()
        msg.zonetype = zonetype || EnumZoneType.TYPE_LFDR;
        msg.invitePlayerId = invitePlayerId;
        Mgr.msgMgr.Send(msg);
    },
    //改变准备状态
    SendReqZoneTeamReadyClientToGameMessage:function(zonetype) {
        var msg = new ReqZoneTeamReadyClientToGameMessage();
        msg.zonetype = zonetype || EnumZoneType.TYPE_LFDR;
        Mgr.msgMgr.Send(msg);
    },
    //玩家离队
    SendReqZoneTeamLeaveClientToGameMessage:function(zonetype) {
        var msg = new ReqZoneTeamLeaveClientToGameMessage();
        msg.zonetype = zonetype || EnumZoneType.TYPE_LFDR;
        Mgr.msgMgr.Send(msg);
    },
    //踢出玩家
    SendReqZoneTeamPickClientToGameMessage:function(playerid,zonetype) {
        var msg = new ReqZoneTeamPickClientToGameMessage();
        msg.zonetype = zonetype || EnumZoneType.TYPE_LFDR;
        msg.playerid = playerid;
        Mgr.msgMgr.Send(msg);
    },
    // 请求开始多人副本
    SendReqZoneTeamStarClientToGameMessage:function(zonetype) {
        var msg = new ReqZoneTeamStarClientToGameMessage();
        msg.zonetype = zonetype || EnumZoneType.TYPE_LFDR;
        Mgr.msgMgr.Send(msg);
        Mgr.zone.SetCurrentZoneType(EnumZoneType.TYPE_LFDR);
    },

    SendReqZoneTeamInviteResultToGameMessage:function(teamId,result,type) {
        var msg = new ReqZoneTeamInviteResultToGameMessage();
        msg.zonetype = type || EnumZoneType.TYPE_LFDR;
        msg.teamId = teamId;
        msg.result = result;
        Mgr.msgMgr.Send(msg);
    },
    //跟随
    SendReqZoneTeamFollowClientToGameMessage:function(zonetype) {
        var msg = new ReqZoneTeamFollowClientToGameMessage();
        msg.zonetype = zonetype || EnumZoneType.TYPE_LFDR;
        Mgr.msgMgr.Send(msg);
    },
    SendReqZoneTeamInviteNoticeClinetToGameMessage:function(zonetype) {
        var msg = new ReqZoneTeamInviteNoticeClinetToGameMessage();
        msg.zonetype = zonetype || EnumZoneType.TYPE_LFDR;
        Mgr.msgMgr.Send(msg);
    },
    //倒计时放在进入副本之前（进入副本前没有广播信息，这里只有队长能看到）
    SetStartZoneTeamCountDown:function()
    {
        this.SendReqZoneTeamStarClientToGameMessage();
        //Mgr.uiMgr.HidePanelByType(DuorenPanelExt.PanelName);
        //EngineMgr.uiMgr.ShowPanelByType(FubenTimeCueExt.PanelName,UIMgr.PANEL_LAYER_TOP);
        //var timePanel = Mgr.uiMgr.GetPanelByType(FubenTimeCueExt.PanelName);
        //timePanel.ShowBeginTime(6,EnumZoneType.TYPE_LFDR, this.SendReqZoneTeamStarClientToGameMessage,EnumZoneType.TYPE_LFDR,this);
    },
    /// 前端请求购买次数
    SendReqZoneTeamBuyClinetToGameMessage:function(type){
        var msg = new ReqZoneTeamBuyClinetToGameMessage()
        msg.zonetype = type || EnumZoneType.TYPE_LFDR;
        Mgr.msgMgr.Send(msg);
    },
    RequestZoneListData:function()
    {
        Mgr.zone.SendReqZoneBasicObtainToGameMessage(EnumZoneType.TYPE_LFDR);
    },
    HandleZoneListData:function(data)
    {
        cc.log("data=====lf=> "+JSON.stringify(data));
        this.zoneInfos = data;
        for(var i = 0; i < data.length; i++ )
        {
            var obj = {base:data[i],detail:Q_zone.Get(data[i].zoneModelid),item:Q_raid.Get(data[i].zoneModelid)};
            this._zoneListData.Put(data[i].zoneModelid,obj);
        }
        this._SetZonelistData(this._zoneListData);
    },
    _SetZonelistData:function(data)
    {
        Mgr.crossteam.SetZonelistData(data);
    },
    GetDuorenPanel:function()
    {
        return Mgr.uiMgr.GetPanelByType(DuorenPanelExt.PanelName);
    },
    _SetMyteam:function(msg)
    {
        if(!msg)
        {
            Mgr.crossteam.isInteam = false;
            Mgr.crossteam.myTeam = null;
            return;
        }
        var teamlist = msg;
        var len = teamlist.length;
        var pId = Mgr.player.mainPlayer.sid.toGID();
        for ( var i = 0; i < len; i++ )
        {
            var memberlist = teamlist[i].memberinfo;
            var len2 = memberlist.length;
            for ( var j = 0; j < len2; j++ )
            {
                if(memberlist[j].memberId.toGID() == pId)
                {
                    Mgr.crossteam.isInteam = true;
                    teamlist[i].zoneModelId = 9001;
                    Mgr.crossteam.myTeam =teamlist[i];
                    if(memberlist[j].job == EnumCrossteamType.TEAM_CAPTAIN)//队长，自动准备
                    {
                        this.SendReqZoneTeamReadyClientToGameMessage(EnumCrossteamType.STATE_READY);
                    }
                    var yqMainPanel = Mgr.uiMgr.GetPanelByType(YaoqingMainExt.PanelName);
                    if(yqMainPanel && yqMainPanel.visible)
                    {
                        yqMainPanel.RequiestPlayerData();
                    }
                    return;
                }
            }
        }
        this._SetMyteam(false);
    },
    //更新某只队伍信息
    _UpdateTheTeamInfo:function(data)//ShowOrHideTeamlist
    {
        var teamData = data.teamInfo;
        var mainPanel = this.GetDuorenPanel().mainPanel;
        //玩家所在队伍
        if(teamData.teamId.toGID() == Mgr.crossteam.myTeam.teamId.toGID())
        {
            var myTeamList = mainPanel.myTeamList;//listview
            if(myTeamList&&myTeamList.getItems().length>0)
            {
                var oldList = myTeamList.getItems();
                var newList = teamData.memberinfo;
                for( var i = 0; i < EnumCrossteamType.TEAM_MEM_NUMBER; i++)
                {
                    oldList[i].UpdateFrameData(newList[i]);
                }
            }
            else
            {
                mainPanel.ShowOrHideTeamlist(teamData.zoneModelId);
            }
            mainPanel.SetYaoQingCheckBoxState(data.teamInfo.onlyInvite);
            mainPanel.SetManYuanKaiShiCheckBoxState(data.teamInfo.autoStart);
        }
        //非玩家所在队伍,1:找到队伍所在副本,2:找到队列中的该队伍
        var listView = Mgr.crossteam.teamListview.Get(teamData.zoneModelId);
        if(listView)
        {
            var items = listView.getItems();
            for(var i = 0; i < items.length; i++ )
            {
                if(items[i].data.teamId.toGID() == teamData.teamId.toGID())
                {
                    items[i].UpdateFrameData(teamData);
                    break;
                }
            }
        }
    },
    _HandleTeamInfoMembers:function(teamInfo)
    {
        var arr = [];
        for(var i = 0; i <teamInfo.length;i++)
        {
            if(teamInfo[i].memberinfo.length>0)
            {
                arr.push(teamInfo[i]);
            }
        }
        return arr;
    },
});