﻿/**
 * UIButton控件，按钮控件
 */

var MUIButton = ccui.Button.extend( {
	ptype:"",
	_soundName:null,
	ctor:function(){
		this.ptype = EnumPanelType.BUTTON;
		this._super();
	},
	Init:function(){
		//解析按钮数据
		UIParseUtil.ParseButton( this , this.jsonobj);
		this.AddChildren();
		UIComponentUtil.AddMouseEventComponent( this );
		//this.setTitleFontSize(18);
		this.setTitleFontName(GameFont.DEFAULT);//默认字体（黑体）by zfs
		this.setZoomScale( -0.15 );//缩放小一点
		this.setPressedActionEnabled(true);
		var self=this;

		this._soundName="button_click";
		this.addTouchEventListener(function (tar,type) {
			if(type==0&&self._soundName)
				Mgr.gameSoundMgr.PlaySound(self._soundName,SoundType.UI,false);
            if ( type == ccui.Widget.TOUCH_BEGAN )
            {
                var action = cc.tintTo(0.05, 150,150,150);
                this.runAction(action);
            }
            else if( type == ccui.Widget.TOUCH_MOVED)
            {
                // var action = cc.tintTo(0.05, 255,255,255);
                // this.runAction(action);
                // var pos= target.getTouchMovePosition();
                // var distance = pos.x - target.pp.x ;
            }
            else if( type == ccui.Widget.TOUCH_ENDED)
            {
                var action = cc.tintTo(0.05, 255,255,255);
                this.runAction(action);
            }
            else if(type == ccui.Widget.TOUCH_CANCELED){
                var action = cc.tintTo(0.05, 255,255,255);
                this.runAction(action);
			}
        });
//		cc.log( "this._normalSprStr:" + this._normalSprStr );
	},
	/**
	 *设置字体颜色
	 * @param color:0xff00ff
	 * @constructor
     */
	SetTitleTextColor:function(color)
	{
		var co = UIUtil.GetCCColor( color , 255);
		this.setTitleColor(co);
	},
	SetTitleTextFontSize:function(sizeNum)
	{
		this.setTitleFontSize(sizeNum);
	},
	GetNormalTextureSize:function (){
		return this._normalTextureSize;
	},
	//描边颜色，描边大小
	SetMiaoBian:function(color,size)
	{

	},
	SetContentSize:function (width , height){
		ccui.Button.prototype.setContentSize.call( this , width , height );
		this.uiWidth = this.width;
		this.uiHeight = this.height;
	},
	GetText:function () {
		return this.jsonobj.buttonText;
	},
	SetSoundName:function (name) {
		this._soundName=name;
    }
} );