﻿/**
 * 添加指定元素到数组，会检测重复
 * @param arr
 * @param elt
 * @return 操作是否成功
 */
var AddArrayElement = function( arr, elt ){
	var len = arr.length;
	for ( var i = 0; i < len; ++i ){
		if ( elt === arr[i] ){
			return false;
		}
	}
	arr.push( elt );
	return true; 
};

/**
 * 移除数组指定的元素
 * @param arr
 * @param elt
 * @return 操作是否成功
 */
var DelArrayElement = function( arr, elt ){
	var len = arr.length;
	for ( var i = 0; i < len; ++i ){
		if ( elt === arr[i] ){
			arr.splice( i, 1 );
			return true;
		}
	}
	return false; 
};



/**
 * 数组中是否有指定元素
 * @param arr
 * @param elt
 */
var HasArrayElement = function( arr, elt ){
	var len = arr.length;
	for ( var i = 0; i < len; ++i ){
		if ( elt === arr[i] ){
			return true;
		}
	}
	return false;
};