﻿/**
 * UI 解析类
 */
var MLUIParseUtil = MLUIParseUtil ||
{
	ParsePanel:function (widget , json){
	},
	ParseLabel:function (widget , json){

	},
	ParseCheckBox:function (widget , json){


	},
	ParseEdit:function (widget , json){

	},
	ParseGrid:function (widget , json){

	},
	ParseGridGroup:function (widget , json){

	},
	ParseImageLabel:function (widget , json){

	},
	ParseProgressBar:function (widget , json){

	},
	ParseScrollPanel:function (widget , json){

	},
	ParseSlider:function (widget , json , isChild){
		this.WidgetAttributes(widget , json);
//		var widget = new MUISlider();
		if(isChild == null)
			widget._isChild = isChild;
		widget._type = json.type;

		var upBtnJson = this.GetButtonJson( 0 , [ json.btn1UpImage ] );
		var downBtnJson = this.GetButtonJson( 0 , [ json.btn2UpImage ] );
		var scrollBtnJson = this.GetButtonJson( json.cursorDownType , json.cursorUpImages );
		var scrollBtnIconJson = this.GetImageJson(0 , [ json.cursorUpbtn ] );

		var bgImgJson = this.GetImageJson( 0 , json.images);

		var upBtn = new MUIButton();
		var downBtn = new MUIButton();
		var scrollBtn = new MUIButton();
		var scrollImg = new MUIImage();
		var bgImg = new MUIImage();

		this.ParseButton(upBtn , upBtnJson);
		this.ParseButton(downBtn , downBtnJson);
		this.ParseButton(scrollBtn , scrollBtnJson);
		this.ParseImage(bgImg , bgImgJson);
		this.ParseImage( scrollImg, scrollBtnIconJson);

		upBtn.x = 100;
		downBtn.x = 200;
		scrollBtn.x = 300;
		scrollImg.x = 400;

		widget.addChild( bgImg );
		widget.addChild( upBtn );
		widget.addChild( downBtn );
		widget.addChild( scrollBtn );
		widget.addChild( scrollImg );
	},
	LoadTextures:function (images){

	},
	LoadTexture:function (imgUrl){

	},
	SetBaseAttributes:function (widget , json){
		widget.id = json.id;
		widget.x = json.Position.X;
		widget.initX = widget.x;
		widget.y = json.Position.Y;
		widget.initY = widget.y;
		var wid = json["Size"].X;
		var hei = json["Size"].Y;
		widget.initWidth = wid;
		widget.initHeight = hei;
		widget.uiWidth = wid;
		widget.uiHeight = hei;
		widget.bindData = json["bindData"];
		widget.setContentSize(cc.size( wid , hei));
		
		widget.setAnchorPoint(cc.p(0, 0));

		if(json.tipsId != null && json.tipsId != "")
		{
			UIComponentUtil.AddTipsComponent( widget );
			widget.SetTips( json.tipsId );
		}
	},
	GetButtonJson:function ( upType , up , downType , down , disableType , disable){
		if(upType == null){
			upType = -1;
			up = [];
		}
		if(downType == null){
			downType = -1;
			down = [];
		}
		if(disableType == null){
			disableType = -1;
			disable = [];
		}
		var json = {
				"downType": -1,
				"downImages": [],
				"overType": -1,
				"childs": [],
				"disableType": -1,
				"id": "sliderbtn",
				"overImages": [],
				"type": "Button",
				"disableImages": [],
				"upType": 0,
				"backgroundType": -1,
				"AnchorPoint": {
					"ScaleY": 0,
					"ScaleX": 0
				},
				"upImages": [],
				"images": [],
				"Position": {
					"X": 0,
					"Y": 0
				},
				"bindData": {},
				"tipsId": "",
				"Size": {
					"X": 40,
					"Y": 40
				}
		};
		json.upType = upType;
		json.upImages = up;

		json.downType = downType;
		json.downImages = down;

		json.disableType = disableType;
		json.disableImages = disable;
		return json;
	},
	GetImageJson:function (btype , images , scale , rect){
		if(scale == null){
			scale = false;
			rect = cc.rect(0, 0, 0, 0);
		}
		if(btype == null)
			btype = 0;
		var image = {
				"type": "Image",
				"backgroundType": 0,
				"AnchorPoint": {
					"ScaleY": 0,
					"ScaleX": 0
				},
				"childs": [],
				"id": "imgBG2",
				"images": [],
				"Position": {
					"X": 0,
					"Y": 0
				},
				"bindData": {},
				"tipsId": "",
				"Size": {
					"X": 100,
					"Y": 100
				},
				"Scale9Height": 1,
				"Scale9Width": 1,
				"Scale9Enable": true,
				"Scale9OriginX": 20,
				"Scale9OriginY": 20
		};
		image.backgroundType = btype;
		image.images = images;
		image.Scale9Enable = scale;
		image.Scale9OriginX = rect.x;
		image.Scale9OriginY = rect.y;
		image.Scale9Width = rect.width;
		image.Scale9Height = rect.height;
		return image;
	}
};
