var Q_baishen = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 符鬼ID_注灵级别 */
        self.q_id = data.ReadString();
        /** 符鬼名称 */
        self.q_name = data.ReadString();
        /** 升到下一级需要的好感度 */
        self.q_levelup = data.ReadInt();
        /** 直接升级基础概率（万分比） */
        self.q_up_rate = data.ReadInt();
        /** 每100点经验提高概率（万分比） */
        self.q_add_rate = data.ReadInt();
        /** 保底概率（直接升级概率大于这个，才生效） */
        self.q_save_rate = data.ReadInt();
        /** 生命值 */
        self.q_max_hp = data.ReadInt();
        /** 攻击力 */
        self.q_attack = data.ReadInt();
        /** 防御力 */
        self.q_defence = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_baishen.list = Q_baishen.list|| [];
	/** 配置数据索引*/
	Q_baishen.map = Q_baishen.map || {};
	
	/** 设置配置数据*/
	Q_baishen.SetData = Q_baishen.SetData || function( data ){

		var list = Q_baishen.list;
		var map = Q_baishen.map;

		Q_baishen.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_baishen();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_baishen.GetList = Q_baishen.GetList || function(){
		return Q_baishen.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_baishen.Get = Q_baishen.Get || function( id ){
		return Q_baishen.map[ id ];
	};
})();