var Q_character = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 等级 */
        self.q_level = data.ReadInt();
        /** 该级升级所需的经验总值（注意：本值是总值，不是增量值） */
        self.q_exp = data.ReadLong();
        /** 属性类型 */
        self.q_attribute = data.ReadString();
        /** 自动回复生命值（每5秒） */
        self.q_auto_recover_hp = data.ReadInt();
        /** 本级自动领悟的技能（格式：职业|技能ID) */
        self.q_auto_addskill = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_character.list = Q_character.list|| [];
	/** 配置数据索引*/
	Q_character.map = Q_character.map || {};
	
	/** 设置配置数据*/
	Q_character.SetData = Q_character.SetData || function( data ){

		var list = Q_character.list;
		var map = Q_character.map;

		Q_character.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_character();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_level)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_character.GetList = Q_character.GetList || function(){
		return Q_character.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_character.Get = Q_character.Get || function( id ){
		return Q_character.map[ id ];
	};
})();