var Q_character_attribute = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 主角类型 */
        self.q_modelID = data.ReadInt();
        /** 名字 */
        self.q_job = data.ReadString();
        /** 性别（性别1男，2女） */
        self.q_sex = data.ReadInt();
        /** 模型动作编号 */
        self.q_actionID = data.ReadInt();
        /** 模型声效编号 */
        self.q_soundID = data.ReadInt();
        /** 默认平砍技能 */
        self.q_skillID = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_character_attribute.list = Q_character_attribute.list|| [];
	/** 配置数据索引*/
	Q_character_attribute.map = Q_character_attribute.map || {};
	
	/** 设置配置数据*/
	Q_character_attribute.SetData = Q_character_attribute.SetData || function( data ){

		var list = Q_character_attribute.list;
		var map = Q_character_attribute.map;

		Q_character_attribute.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_character_attribute();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_modelID)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_character_attribute.GetList = Q_character_attribute.GetList || function(){
		return Q_character_attribute.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_character_attribute.Get = Q_character_attribute.Get || function( id ){
		return Q_character_attribute.map[ id ];
	};
})();