var Q_dragon_ball = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 活动ID（不能重复，正式服上线后，数据需保留1个月才清理一次，活动ID为永久使用，使用过1次后永久不可继续使用,一条活动配置一期） 注意 1-300之间的ID 都已使用 */
        self.q_id = data.ReadInt();
        /** 活动名称，显示在面板上的活动名字 */
        self.q_name = data.ReadString();
        /** 平台标识（不填表示不限，多个用分好隔开。例如：360wan;youxi) */
        self.q_pingtai = data.ReadString();
        /** 活动类型（0：充值累计） */
        self.q_activity_type = data.ReadInt();
        /** 区别老新服（1新区：开服时间为新服才出现的活动。2旧：开服时间大于5天才出现的活动，0通用） */
        self.q_listimage = data.ReadInt();
        /** 开区多少天后才出来活动 */
        self.q_open_day = data.ReadInt();
        /** 服务器限制，日期前（含日期）开启的服务器才显示该活动   20151212-000000 */
        self.q_serve_limit = data.ReadString();
        /** 领取类型：1表示活动期间每天领取2表示活动期间总共领取3表示活动期间每周领取，奖励领取次数-1无限领取,填其他的表示可以领取多少次,4根据全服VIP人数判定领奖次数（对应q_reward_num的VIP等级） */
        self.q_reward_type = data.ReadInt();
        /** 奖励领取次数-1无限领取,填其他的表示可以领取多少次  */
        self.q_reward_num = data.ReadInt();
        /** 参与时间 &领取奖励时间 [[时间配置类型],[开始时间，结束时间]]    [[1],[yyyyMMddHHmmss，yyyyMMddHHmmss]]       [[2],[开服天数，开服天数]]    [[3],[合服天数，合开服天数，合服次数（-1表示每次合服生效，其他表示合服次数），合服规则(0表示等于前面配置的合服次数 1表示大于等于前面配置的合服次数,VIP活动用到)]] 永久填-1 */
        self.q_timingstart = data.ReadString();
        /** 活动内容介绍，显示在面板上的活动介绍，策划配置。控制在22个字以内。需要支持html代码 */
        self.q_info = data.ReadString();
        /** 活动期间每天需要类型的元宝数（个数即是天数），比如7天的：[1000,2000,3000,......] */
        self.q_day_need_gold = data.ReadString();
        /** 活动期间每天强势点亮的元宝数（个数即是天数），比如7天的：[10000,20000,30000,......] */
        self.q_day_light_gold = data.ReadString();
        /** 每日奖励数据：json字符串(这个长度和需要元宝是一样的)。[{"mod":-5,"num":5888,"bind":1}]#[.........] */
        self.q_day_reward = data.ReadString();
        /** 超级奖励json字符串 */
        self.q_reward = data.ReadString();
        /** resflag例子：[title:57.png,background:1.png,cellhead:meirendengji.png,cellname:dugulingke_0.png,cellnums:3jie.png]      ：title ：为置顶背景图 （other/huodong/tongyong/image/title/ 程序已写）  zhuansheng:; */
        self.q_resflag = data.ReadString();
        /** paging：标签id;标签小图标资源名;标签名(标签上的图片名字);子面板类型     排序；标签页图标；标签页名字；活动类型 */
        self.q_paging = data.ReadString();
        /** 活动顺序（1表示默认在第一排显示，相同的则按照活动ID顺序表示） */
        self.q_top = data.ReadInt();
        /** 是否独立入口（0或者不填，在充值面板内。1,icon名字，1表示有独立入口，以及ICON的名字，调用面板ID) 奖励领取完后，面板消失。第三个值配面板类型（这个值相同的活动会出现在一个面板里面）1_首冲，2_排行榜，3_精彩活动 4 双11  5合服活动 6 转盘兑换  7 天命推演兑换  8：元旦活动】 9 春节活动 10成就活动 15:战斗力提升  9003：全平台充值   16：月末活动 */
        self.q_icon = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_dragon_ball.list = Q_dragon_ball.list|| [];
	/** 配置数据索引*/
	Q_dragon_ball.map = Q_dragon_ball.map || {};
	
	/** 设置配置数据*/
	Q_dragon_ball.SetData = Q_dragon_ball.SetData || function( data ){

		var list = Q_dragon_ball.list;
		var map = Q_dragon_ball.map;

		Q_dragon_ball.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_dragon_ball();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_dragon_ball.GetList = Q_dragon_ball.GetList || function(){
		return Q_dragon_ball.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_dragon_ball.Get = Q_dragon_ball.Get || function( id ){
		return Q_dragon_ball.map[ id ];
	};
})();