var Q_escort = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 级别 */
        self.q_id = data.ReadInt();
        /** 名称 */
        self.q_name = data.ReadString();
        /** 移动速度 */
        self.q_speed = data.ReadInt();
        /** 发布NPC */
        self.q_npc_accept = data.ReadInt();
        /** 结束NPC */
        self.q_npc_end = data.ReadInt();
        /** 移动所需保持距离 */
        self.q_distance = data.ReadInt();
        /** 远离失败时间（秒） */
        self.q_time_faraway = data.ReadInt();
        /** 护送总时间（秒 */
        self.q_time_total = data.ReadInt();
        /** 奖励 */
        self.q_reward = data.ReadString();
        /** 死亡损失比例(百分比分子） */
        self.q_dead = data.ReadInt();
        /** 死亡最大损失比例(百分比分子） */
        self.q_dead_max = data.ReadInt();
        /** 进阶消耗的充值元宝 */
        self.q_cost = data.ReadInt();
        /** 护送时是否播放公告(0:否，1：是） */
        self.q_notice = data.ReadInt();
        /** 路径点三维数组(坐标点是无阻挡) */
        self.q_paths = data.ReadString();
        /** 护送的地图id序列：[1,2,3] */
        self.q_mapIds = data.ReadString();
        /** 护送对应的monsterId */
        self.q_monsterID = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_escort.list = Q_escort.list|| [];
	/** 配置数据索引*/
	Q_escort.map = Q_escort.map || {};
	
	/** 设置配置数据*/
	Q_escort.SetData = Q_escort.SetData || function( data ){

		var list = Q_escort.list;
		var map = Q_escort.map;

		Q_escort.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_escort();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_escort.GetList = Q_escort.GetList || function(){
		return Q_escort.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_escort.Get = Q_escort.Get || function( id ){
		return Q_escort.map[ id ];
	};
})();