var Q_fashion = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 称号ID */
        self.q_id = data.ReadInt();
        /** 类型（角色时装：1，武器时装：2，战甲：3） */
        self.q_type = data.ReadInt();
        /** 称号名称 */
        self.q_name = data.ReadString();
        /** 时装名字美术资源 */
        self.q_name_show = data.ReadInt();
        /** 时装图标展示 */
        self.q_item_show = data.ReadInt();
        /** 称号资源编号（场景特效及面板暂时资源编号命名一致） */
        self.q_art = data.ReadString();
        /** 时装来源 */
        self.q_introduce = data.ReadString();
        /** 激活条件[ [类型，目标值], [类型，目标值]]类型需与程序确定     */
        self.q_activate = data.ReadString();
        /** 激活所需道具ID [[道具ID，道具数量]] */
        self.q_activate_item = data.ReadString();
        /** 每次激活时限(秒)【-1为永久激活】 */
        self.q_time = data.ReadInt();
        /** 激活就有的属性 */
        self.q_attribute = data.ReadString();
        /** 佩戴才有的属性 */
        self.q_attribute_puton = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_fashion.list = Q_fashion.list|| [];
	/** 配置数据索引*/
	Q_fashion.map = Q_fashion.map || {};
	
	/** 设置配置数据*/
	Q_fashion.SetData = Q_fashion.SetData || function( data ){

		var list = Q_fashion.list;
		var map = Q_fashion.map;

		Q_fashion.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_fashion();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_fashion.GetList = Q_fashion.GetList || function(){
		return Q_fashion.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_fashion.Get = Q_fashion.Get || function( id ){
		return Q_fashion.map[ id ];
	};
})();