var Q_ghost = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 符鬼编号 */
        self.q_id = data.ReadInt();
        /** 神器名称 */
        self.q_name = data.ReadString();
        /** 开放顺序 */
        self.q_order = data.ReadInt();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 对应的神器资源编号 */
        self.q_artifact = data.ReadInt();
        /** 神器界面神器名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 神器头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 神器面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用神器造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 神器特效资源编号 */
        self.q_effect = data.ReadInt();
        /** 神器描述文本 */
        self.q_introduce = data.ReadString();
        /** 基础生命值 */
        self.q_maxHp = data.ReadInt();
        /** 基础攻击力 */
        self.q_attack = data.ReadInt();
        /** 基础防御力 */
        self.q_defense = data.ReadInt();
        /** 基础命中值 */
        self.q_hit = data.ReadInt();
        /** 基础闪避值 */
        self.q_dodge = data.ReadInt();
        /** 基础暴击值 */
        self.q_crit = data.ReadInt();
        /** 基础抗暴值 */
        self.q_antiCrit = data.ReadInt();
        /** 是否可变身(1:ke ) */
        self.q_change = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_ghost.list = Q_ghost.list|| [];
	/** 配置数据索引*/
	Q_ghost.map = Q_ghost.map || {};
	
	/** 设置配置数据*/
	Q_ghost.SetData = Q_ghost.SetData || function( data ){

		var list = Q_ghost.list;
		var map = Q_ghost.map;

		Q_ghost.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_ghost();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_ghost.GetList = Q_ghost.GetList || function(){
		return Q_ghost.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_ghost.Get = Q_ghost.Get || function( id ){
		return Q_ghost.map[ id ];
	};
})();