var Q_ghost_inject = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 符鬼等阶_属性位 */
        self.q_id = data.ReadString();
        /** 符鬼ID */
        self.q_ghost = data.ReadInt();
        /** 符鬼阶数 */
        self.q_level = data.ReadInt();
        /** 符鬼属性位 */
        self.q_num = data.ReadInt();
        /** 生命值 */
        self.q_maxHp = data.ReadInt();
        /** 攻击力 */
        self.q_attack = data.ReadInt();
        /** 防御力 */
        self.q_defense = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadInt();
        /** 造成的伤害加成比例（万分比分子） */
        self.q_hurt_add = data.ReadInt();
        /** 造成的暴击伤害加成比例（万分比分子） */
        self.q_crit_add = data.ReadInt();
        /** 激活所需道具 */
        self.q_item_inject = data.ReadInt();
        /** 激活道具数量 */
        self.q_indect_num = data.ReadInt();
        /** 突破所需道具 */
        self.q_item_break = data.ReadInt();
        /** 突破所需道具数量 */
        self.q_break_num = data.ReadInt();
        /** 激活成功率（百分比分子） */
        self.q_success = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_ghost_inject.list = Q_ghost_inject.list|| [];
	/** 配置数据索引*/
	Q_ghost_inject.map = Q_ghost_inject.map || {};
	
	/** 设置配置数据*/
	Q_ghost_inject.SetData = Q_ghost_inject.SetData || function( data ){

		var list = Q_ghost_inject.list;
		var map = Q_ghost_inject.map;

		Q_ghost_inject.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_ghost_inject();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_ghost_inject.GetList = Q_ghost_inject.GetList || function(){
		return Q_ghost_inject.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_ghost_inject.Get = Q_ghost_inject.Get || function( id ){
		return Q_ghost_inject.map[ id ];
	};
})();