var Q_ghost_up = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 神器模型_等阶 */
        self.q_modelID = data.ReadString();
        /** 神器模型 */
        self.q_id = data.ReadInt();
        /** 等阶 */
        self.q_level = data.ReadInt();
        /** 神器名称 */
        self.q_name = data.ReadString();
        /** 是否是最高等阶(0:不是；1：是） */
        self.q_ismax = data.ReadInt();
        /** 进阶操作所需人物等级 */
        self.q_up_figure_level = data.ReadInt();
        /** 进阶消耗材料ID */
        self.q_up_item_id = data.ReadInt();
        /** 单次进阶需要材料数量 */
        self.q_up_once_num = data.ReadInt();
        /** 单次进阶需要消耗银两数量 */
        self.q_up_once_cost = data.ReadInt();
        /** 总消耗材料数量 */
        self.q_up_item_num = data.ReadInt();
        /** 进阶成功是否全服公告（0不公告，1公告） */
        self.q_notice = data.ReadInt();
        /** 获取的神器技能 */
        self.q_skill_id = data.ReadInt();
        /** 神器对应的战斗力 */
        self.q_fight = data.ReadInt();
        /** 可镶嵌的宝石类型 */
        self.q_gem = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_ghost_up.list = Q_ghost_up.list|| [];
	/** 配置数据索引*/
	Q_ghost_up.map = Q_ghost_up.map || {};
	
	/** 设置配置数据*/
	Q_ghost_up.SetData = Q_ghost_up.SetData || function( data ){

		var list = Q_ghost_up.list;
		var map = Q_ghost_up.map;

		Q_ghost_up.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_ghost_up();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_modelID)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_ghost_up.GetList = Q_ghost_up.GetList || function(){
		return Q_ghost_up.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_ghost_up.Get = Q_ghost_up.Get || function( id ){
		return Q_ghost_up.map[ id ];
	};
})();