var Q_glyph_warding = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 怪物波数 */
        self.q_id = data.ReadInt();
        /** 关卡挑战时间(单位：秒） */
        self.q_time = data.ReadInt();
        /** 刷新的怪物ID */
        self.q_monster = data.ReadInt();
        /** 怪物数量 */
        self.q_num = data.ReadInt();
        /** 刷怪坐标点X */
        self.q_x = data.ReadInt();
        /** 刷怪坐标点Y */
        self.q_y = data.ReadInt();
        /** 路径格式：[[坐标1，坐标1],[坐标2，坐标2],[坐标3，坐标3]] */
        self.q_way = data.ReadString();
        /** 扫荡到本关卡所需银两 */
        self.q_mop_up = data.ReadInt();
        /** 首次通关奖励 */
        self.q_reward_first = data.ReadString();
        /** 通关奖励 */
        self.q_reward = data.ReadString();
        /** 展示奖励 */
        self.q_reward_show = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_glyph_warding.list = Q_glyph_warding.list|| [];
	/** 配置数据索引*/
	Q_glyph_warding.map = Q_glyph_warding.map || {};
	
	/** 设置配置数据*/
	Q_glyph_warding.SetData = Q_glyph_warding.SetData || function( data ){

		var list = Q_glyph_warding.list;
		var map = Q_glyph_warding.map;

		Q_glyph_warding.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_glyph_warding();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_glyph_warding.GetList = Q_glyph_warding.GetList || function(){
		return Q_glyph_warding.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_glyph_warding.Get = Q_glyph_warding.Get || function( id ){
		return Q_glyph_warding.map[ id ];
	};
})();