var Q_item = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 物品ID */
        self.q_id = data.ReadInt();
        /** 物品名称(最大九个汉字。支持_后缀，后缀部分在客户端不予显示) */
        self.q_name = data.ReadString();
        /** 物品类型 */
        self.q_type = data.ReadInt();
        /** 同子类型物品等级 */
        self.q_rank = data.ReadInt();
        /** 物品子类型(编号） */
        self.q_location = data.ReadInt();
        /** 佩戴职业需求（0通用，1男角色，2女角色） */
        self.q_job = data.ReadInt();
        /** 绑定类型（0不绑定；1获得时绑定；2使用后绑定） */
        self.q_bind = data.ReadInt();
        /** 最大叠加数量（0或1均为不可叠加，最大可以填9999） */
        self.q_max = data.ReadInt();
        /** 商店是否回收（0不回收，0回收） */
        self.q_sell = data.ReadInt();
        /** 出售给商店价格 */
        self.q_sell_price = data.ReadInt();
        /** 出售时是否弹出二次确认面板（0不弹出，1弹出） */
        self.q_sell_confirm = data.ReadInt();
        /** 回收价格（在商店最近出售列表里重新购回价格） */
        self.q_recycle = data.ReadInt();
        /** 是否可丢弃（0不可丢弃，1可丢弃） */
        self.q_drop = data.ReadInt();
        /** 丢弃时是否弹出二次确认面板（0不弹出，1弹出） */
        self.q_drop_confirm = data.ReadInt();
        /** 是否允许被拖放至物品快捷栏（0不允许，1允许） */
        self.q_shortcut = data.ReadInt();
        /** 佩戴部位 */
        self.q_kind = data.ReadInt();
        /** 使用等级需求(注意：资源线装备的为对应资源线的等阶） */
        self.q_level = data.ReadInt();
        /** 装备最大可强化等级 */
        self.q_max_strengthen = data.ReadInt();
        /** 药品使用冷却时间（单位：毫秒） */
        self.q_cooldown = data.ReadInt();
        /** 药品公共冷却层级 */
        self.q_cooldown_level = data.ReadInt();
        /** 公共冷却时间 */
        self.q_cooldown_type = data.ReadInt();
        /** 使用后触发脚本编号 */
        self.q_script = data.ReadInt();
        /** 使用后学会技能编号 */
        self.q_skill = data.ReadInt();
        /** 使用后打开礼包表编号 */
        self.q_gift = data.ReadInt();
        /** 掉出时发送的公告类型（0不发送公告；1面向个人发送聊天框内公告；2面向个人发送聊天框内与屏幕上方双重公告；3面向全服发送聊天框内公告；4面向全服发送聊天框内与屏幕上方双重公告） */
        self.q_notice = data.ReadInt();
        /** 是否记录产出与操作日志（0不记录；1记录） */
        self.q_log = data.ReadInt();
        /** 物品天生的名字颜色（0白色，1绿色，2蓝色，3紫色，4橙色，5红色） */
        self.q_default = data.ReadInt();
        /** 物品类型描述 */
        self.q_append = data.ReadString();
        /** 物品描述信息（本处需要支持html标记）<font color="#e56a10">温馨提示  红色 df2505  <br/> */
        self.q_describe = data.ReadString();
        /** 物品微图标资源编号 */
        self.q_tiny_icon = data.ReadInt();
        /** 是否自动使用（1是，0否） */
        self.q_auto_use = data.ReadInt();
        /** 道具是否可批量使用(0否，1是) */
        self.q_whether_batch = data.ReadInt();
        /** 道具是否可进入仓库（1否，0是） */
        self.q_save_warehouse = data.ReadInt();
        /** 物品使用上限 */
        self.q_item_limit = data.ReadInt();
        /** 产出途径描述 */
        self.q_output = data.ReadString();
        /** 0默认,1跨服优先,2原服跨服都执行 */
        self.q_crossUse = data.ReadInt();
        /** 调取玩家背包数据时可掉落道具（0表示不可掉落，其他表示最大可掉落数量） */
        self.q_drop_num = data.ReadInt();
        /** 熔炼值(0:不可熔炼） */
        self.q_melt_num = data.ReadInt();
        /** 道具获取途径（1：商城，2：世界BOSS，3：剧情副本，4：进阶副本，5：组队副本） */
        self.q_get_approach = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_item.list = Q_item.list|| [];
	/** 配置数据索引*/
	Q_item.map = Q_item.map || {};
	
	/** 设置配置数据*/
	Q_item.SetData = Q_item.SetData || function( data ){

		var list = Q_item.list;
		var map = Q_item.map;

		Q_item.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_item();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_item.GetList = Q_item.GetList || function(){
		return Q_item.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_item.Get = Q_item.Get || function( id ){
		return Q_item.map[ id ];
	};
})();