var Q_magical_update = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 神兵编号_阶数 */
        self.q_id = data.ReadString();
        /** 神兵编号 */
        self.q_modelID = data.ReadInt();
        /** 品阶阶数 */
        self.q_quality_level = data.ReadInt();
        /** 品阶名称 */
        self.q_name = data.ReadString();
        /** 品阶字体颜色（支持html语法） */
        self.q_name_color = data.ReadString();
        /** 位置1灵石ID */
        self.q_runestone_one = data.ReadInt();
        /** 位置2灵石ID */
        self.q_runestone_two = data.ReadInt();
        /** 位置3灵石ID */
        self.q_runestone_three = data.ReadInt();
        /** 位置4灵石ID */
        self.q_runestone_four = data.ReadInt();
        /** 位置5灵石ID */
        self.q_runestone_five = data.ReadInt();
        /** 位置6灵石ID */
        self.q_runestone_six = data.ReadInt();
        /** 生命值 */
        self.q_maxHp = data.ReadInt();
        /** 物理攻击 */
        self.q_attack = data.ReadInt();
        /** 物理防御 */
        self.q_defense = data.ReadInt();
        /** 魔法攻击 */
        self.q_magAttack = data.ReadInt();
        /** 魔法防御 */
        self.q_magDefence = data.ReadInt();
        /** 攻击速度值增加 */
        self.q_attackSpeed = data.ReadInt();
        /** 移动速度值增加 */
        self.q_moveSpeed = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 无视物理防御 */
        self.q_negDefence = data.ReadInt();
        /** 无视魔法防御 */
        self.q_negMagDefence = data.ReadInt();
        /** 吸血值 */
        self.q_suck = data.ReadInt();
        /** 神圣伤害 */
        self.q_holyDamage = data.ReadInt();
        /** 治疗效果加成百分比（万分比分子） */
        self.q_healingBonus = data.ReadInt();
        /** 释放技能所需能量消耗降低百分比（万分比分子） */
        self.q_mpLower = data.ReadInt();
        /** 生命恢复（每5秒自动恢复生命值） */
        self.q_auto_recover_hp = data.ReadInt();
        /** 灵力恢复（战斗中每5秒恢复灵力值） */
        self.q_auto_recovery_mp_fight = data.ReadInt();
        /** 技能等级额外提高 */
        self.q_skill_up = data.ReadInt();
        /** 抵抗沉默几率（万分比分子） */
        self.q_resist_silence = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_magical_update.list = Q_magical_update.list|| [];
	/** 配置数据索引*/
	Q_magical_update.map = Q_magical_update.map || {};
	
	/** 设置配置数据*/
	Q_magical_update.SetData = Q_magical_update.SetData || function( data ){

		var list = Q_magical_update.list;
		var map = Q_magical_update.map;

		Q_magical_update.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_magical_update();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_magical_update.GetList = Q_magical_update.GetList || function(){
		return Q_magical_update.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_magical_update.Get = Q_magical_update.Get || function( id ){
		return Q_magical_update.map[ id ];
	};
})();