var Q_manor = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 地图ID */
        self.q_id = data.ReadInt();
        /** 地图名称美术字体资源编号 */
        self.q_artistic_font = data.ReadInt();
        /** 中立势力模型 */
        self.q_neutral = data.ReadInt();
        /** 护旗卫兵ID */
        self.q_monster = data.ReadInt();
        /** 护旗卫兵数量 */
        self.q_num = data.ReadInt();
        /** 胜利方奖励(占领多个领地，但仅能领取一次） */
        self.q_win_rewar = data.ReadString();
        /** 失败方奖励(一个领地都没占有，但仅能领取一次） */
        self.q_lose_reward = data.ReadString();
        /** 占领后每日奖励 */
        self.q_daily_bonus = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_manor.list = Q_manor.list|| [];
	/** 配置数据索引*/
	Q_manor.map = Q_manor.map || {};
	
	/** 设置配置数据*/
	Q_manor.SetData = Q_manor.SetData || function( data ){

		var list = Q_manor.list;
		var map = Q_manor.map;

		Q_manor.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_manor();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_manor.GetList = Q_manor.GetList || function(){
		return Q_manor.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_manor.Get = Q_manor.Get || function( id ){
		return Q_manor.map[ id ];
	};
})();