var Q_mining = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 顺序 */
        self.q_id = data.ReadInt();
        /** 展示资源(前端用到，需要界面展示的道具，1为展示，0为不展示） */
        self.q_show = data.ReadInt();
        /** 道具生成 */
        self.q_item_set = data.ReadString();
        /** 必出道具 */
        self.q_must = data.ReadInt();
        /** 掉落比重 */
        self.q_rate = data.ReadInt();
        /** 挖掘次数间隔必定出该道具 */
        self.q_period = data.ReadInt();
        /** 本服挖掘次数间隔必定出该道具（仅算元宝挖掘次数） */
        self.q_period_all = data.ReadInt();
        /** 掉落所需最低等级 */
        self.q_level_min = data.ReadInt();
        /** 掉落所需最高等级 */
        self.q_level_max = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_mining.list = Q_mining.list|| [];
	/** 配置数据索引*/
	Q_mining.map = Q_mining.map || {};
	
	/** 设置配置数据*/
	Q_mining.SetData = Q_mining.SetData || function( data ){

		var list = Q_mining.list;
		var map = Q_mining.map;

		Q_mining.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_mining();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_mining.GetList = Q_mining.GetList || function(){
		return Q_mining.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_mining.Get = Q_mining.Get || function( id ){
		return Q_mining.map[ id ];
	};
})();