var Q_psychic_addition = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 系统类型_通灵ID_星级 */
        self.q_id = data.ReadString();
        /** 系统类型（1：坐骑，2：骑兵，3：美人，4：光翼） */
        self.q_type = data.ReadInt();
        /** 通灵ID */
        self.q_model = data.ReadInt();
        /** 星级 */
        self.q_level = data.ReadInt();
        /** 生命值 */
        self.q_max_hp = data.ReadInt();
        /** 攻击力 */
        self.q_attack = data.ReadInt();
        /** 防御力 */
        self.q_defence = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_psychic_addition.list = Q_psychic_addition.list|| [];
	/** 配置数据索引*/
	Q_psychic_addition.map = Q_psychic_addition.map || {};
	
	/** 设置配置数据*/
	Q_psychic_addition.SetData = Q_psychic_addition.SetData || function( data ){

		var list = Q_psychic_addition.list;
		var map = Q_psychic_addition.map;

		Q_psychic_addition.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_psychic_addition();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_psychic_addition.GetList = Q_psychic_addition.GetList || function(){
		return Q_psychic_addition.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_psychic_addition.Get = Q_psychic_addition.Get || function( id ){
		return Q_psychic_addition.map[ id ];
	};
})();