var Q_psychic_up = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 系统类型_通灵ID_星级 */
        self.q_id = data.ReadString();
        /** 系统类型（1：坐骑，2：骑兵，3：美人，4：光翼） */
        self.q_type = data.ReadInt();
        /** 通灵ID */
        self.q_model = data.ReadInt();
        /** 星级 */
        self.q_level = data.ReadInt();
        /** 是否是最高等阶(0:不是；1：是） */
        self.q_ismax = data.ReadInt();
        /** 进阶操作所需系统等阶 */
        self.q_up_figure_level = data.ReadInt();
        /** 进阶消耗材料ID */
        self.q_up_item_id = data.ReadInt();
        /** 单次进阶需要材料数量 */
        self.q_up_once_num = data.ReadInt();
        /** 单次进阶需要消耗银两数量 */
        self.q_up_once_cost = data.ReadInt();
        /** 总消耗材料数量 */
        self.q_up_item_num = data.ReadInt();
        /** 进阶成功是否全服公告（0不公告，1公告） */
        self.q_notice = data.ReadInt();
        /** 获取的技能 */
        self.q_skill_id = data.ReadInt();
        /** 通灵名称 */
        self.q_name = data.ReadString();
        /** 开放顺序 */
        self.q_order = data.ReadInt();
        /** 对应的通灵资源编号 */
        self.q_artifact = data.ReadInt();
        /** 通灵界面通灵名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 通灵面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用通灵造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 通灵描述文本 */
        self.q_introduce = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_psychic_up.list = Q_psychic_up.list|| [];
	/** 配置数据索引*/
	Q_psychic_up.map = Q_psychic_up.map || {};
	
	/** 设置配置数据*/
	Q_psychic_up.SetData = Q_psychic_up.SetData || function( data ){

		var list = Q_psychic_up.list;
		var map = Q_psychic_up.map;

		Q_psychic_up.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_psychic_up();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_psychic_up.GetList = Q_psychic_up.GetList || function(){
		return Q_psychic_up.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_psychic_up.Get = Q_psychic_up.Get || function( id ){
		return Q_psychic_up.map[ id ];
	};
})();