var Q_system_activity = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 系统ID */
        self.q_id = data.ReadInt();
        /** 活动名称 */
        self.q_name = data.ReadString();
        /** 活动区服类型（0：本服，1：联服，2:平台） 帮派答题为1 */
        self.q_server_type = data.ReadInt();
        /** 开区天数格式 [[天数，小时，分钟]] 优先于q_time */
        self.q_open_days = data.ReadString();
        /** 是否受合区天数影响（0不,  1 受影响） */
        self.q_isjoinday = data.ReadInt();
        /** 开区多少天后才开放,和q_open_days互斥的 优先于q_time */
        self.q_open_limit = data.ReadInt();
        /** 活动开启时间，格式： [ [星期,小时，分钟],[]]（注意：星期天是7） */
        self.q_time = data.ReadString();
        /** 时限(秒) */
        self.q_time_limit = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_system_activity.list = Q_system_activity.list|| [];
	/** 配置数据索引*/
	Q_system_activity.map = Q_system_activity.map || {};
	
	/** 设置配置数据*/
	Q_system_activity.SetData = Q_system_activity.SetData || function( data ){

		var list = Q_system_activity.list;
		var map = Q_system_activity.map;

		Q_system_activity.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_system_activity();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_system_activity.GetList = Q_system_activity.GetList || function(){
		return Q_system_activity.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_system_activity.Get = Q_system_activity.Get || function( id ){
		return Q_system_activity.map[ id ];
	};
})();