var Q_vip = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** VIP等级 */
        self.q_level = data.ReadInt();
        /** 升到这一级所需VIP经验 */
        self.q_exp = data.ReadInt();
        /** 每天自动获得的VIP经验 */
        self.q_exp_free = data.ReadInt();
        /** 交易税率百分比分子（默认35） */
        self.q_deal_tax_rate = data.ReadInt();
        /** 装备合成强化成功率加成（万分比分子） */
        self.q_equipt_success = data.ReadInt();
        /** 签到奖励额外倍数 */
        self.q_sign_reward_multiple = data.ReadInt();
        /** 打怪额外经验加成 （万分比分子） */
        self.q_exp_monster = data.ReadInt();
        /** 补签次数 */
        self.q_sign_extra = data.ReadInt();
        /** 护送经验加成（百分比分子）  */
        self.q_exp_husong = data.ReadInt();
        /** 是否免费一键完成日常任务 */
        self.q_daily_free = data.ReadInt();
        /** 冠级别（1：蓝 2：紫 3： 金） */
        self.q_crest = data.ReadInt();
        /** 聊天级别（1：紫金，2：土豪金） */
        self.q_talk = data.ReadInt();
        /** Vip每周奖励的道具ID */
        self.q_vip_week_reward = data.ReadInt();
        /** VIP每周可领取的道具数量 */
        self.q_vip_week_num = data.ReadInt();
        /** VIP周礼包（每个等级都有，且都可领取） */
        self.q_week_gift = data.ReadString();
        /** VIP至尊礼包购买价格（元宝） */
        self.q_exalted_expend = data.ReadInt();
        /** VIP至尊礼包 */
        self.q_exalted_gift_reward = data.ReadString();
        /** 达到VIP 即可领取的奖励 */
        self.q_vip_once_reward = data.ReadString();
        /** VIP属性 */
        self.q_attribute = data.ReadString();
        /** 描述名字 */
        self.q_introduce_name = data.ReadString();
        /** 描述 */
        self.q_introduce = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_vip.list = Q_vip.list|| [];
	/** 配置数据索引*/
	Q_vip.map = Q_vip.map || {};
	
	/** 设置配置数据*/
	Q_vip.SetData = Q_vip.SetData || function( data ){

		var list = Q_vip.list;
		var map = Q_vip.map;

		Q_vip.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_vip();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_level)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_vip.GetList = Q_vip.GetList || function(){
		return Q_vip.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_vip.Get = Q_vip.Get || function( id ){
		return Q_vip.map[ id ];
	};
})();