var Q_vitality = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 活跃度类型编号 */
        self.q_id = data.ReadInt();
        /** 任务类型说明 */
        self.q_introduce = data.ReadString();
        /** 次数 */
        self.q_time = data.ReadInt();
        /** 显示所需人物等级 */
        self.q_level = data.ReadInt();
        /** 显示所需完成任务 */
        self.q_quest = data.ReadInt();
        /** 完成1次次数获得的活跃度 */
        self.q_vitality = data.ReadInt();
        /** 奖励的道具（JSON） */
        self.q_item = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_vitality.list = Q_vitality.list|| [];
	/** 配置数据索引*/
	Q_vitality.map = Q_vitality.map || {};
	
	/** 设置配置数据*/
	Q_vitality.SetData = Q_vitality.SetData || function( data ){

		var list = Q_vitality.list;
		var map = Q_vitality.map;

		Q_vitality.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_vitality();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_vitality.GetList = Q_vitality.GetList || function(){
		return Q_vitality.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_vitality.Get = Q_vitality.Get || function( id ){
		return Q_vitality.map[ id ];
	};
})();