var AchievementMainExt = AchievementMain.extend ( {
    _className:"AchievementMainExt",
    cellPanel:null,
    cellList:null,
    ctor:function(){
        this._super();
    },

    Init:function () {
        AchievementMain.prototype.Init.call( this );
        Mgr.achievement.achievementMainPanel = this;

        this.labCue11.setTouchEnabled(true);
        this.labCue11.addTouchEventListener(function(sender,type){
            if ( type == ccui.Widget.TOUCH_ENDED )
            {
                Mgr.uiMgr.ShowPanelByType(ChengHaoPanelExt.PanelName);
            }
        });

        this.btnWenhao.addClickEventListener(function (target) {
            Mgr.uiMgr.ShowPanelByType(ChengHaoPanelExt.PanelName);
        });

        var tableView = new cc.TableView(this,cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
        tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
        tableView.setDelegate(this);
        tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
        this.imgBg.addChild(tableView);
        this.tableView = tableView;
        this.tableView.reloadData();
    },

    SetData:function (type, idArr) {
        idArr = idArr || [];
        this.type = type;
        this.data = idArr;

        this.tableView.reloadData();

        this.InitMain(type,idArr);
    },

    InitMain:function (type, idArr) {
        var nowNum = Mgr.achievement.achievementTypeNowPointHash.Get(type);
        var maxNum = Mgr.achievement.AchievementTypePointHash().Get(type);
        nowNum = nowNum || 0;
        this.progJindutiao.setPercent(nowNum/maxNum*100);
        this.labNumber.SetText(TextUtil.FormatStr( this.labNumber.GetHtmlText(), [ nowNum, maxNum ] ));
        this.labNumber.EnableOutline(EnumFontFormat.COMMON_COLOR11,1);

        var showInfo = Q_achievement.Get(idArr[0]);
        var data = Q_title.Get(showInfo.q_title_show);
        if(this.showMode){
            SkillEffect.Delete(this.showMode);
        }
        this.showMode = EffectUtil.GetShowEffect(data.q_art, EffectUtil.ENUM_TYPE_UI, true ,-1);
        this.showMode.x = this.imgChenghao.uiWidth / 2;
        this.showMode.y = this.imgChenghao.uiHeight / 2;
        this.imgChenghao.addChild(this.showMode);
    },

    RefreshCellAndMain:function (id) {
        // TODO 这个也可以过滤下，其实吧无所谓啦
        this.InitMain(this.type,this.data);

        for(var i=0,length = this.data.length;i!=length;i++){
            if(this.data[i] == id){
                var cell =  this.tableView.cellAtIndex(i);
                if(cell && cell.item)  cell.item.Update();
                break;
            }
        }
    },

    tableCellSizeForIndex:function(sender,index){
        // 加点间距
        return cc.size(790,120);//cc.size(790,114);
    },

    tableCellAtIndex:function(sender,index){
        var cell = sender.dequeueCell();
        if (!cell) {
            cell = new cc.TableViewCell();
        }
        if(!cell.item){
            var item=new AchievementListExt();
            item.LoadPanel();

            cell.addChild(item)
            cell.item = item;
        }
        var id = this.data[index];
        var data = Q_achievement.Get(id);
        cell.item.SetData(data);
        return cell;
    },

    numberOfCellsInTableView:function(sender){
        return this.data ? this.data.length : 0;
    },
} );
AchievementMainExt.PanelName = "AchievementMainExt";
PanelClassDic["AchievementMainExt"] = AchievementMainExt;
