var WarehouseMainExt = WarehouseMain.extend ( {
	_className:"WarehouseMainExt",
    whItems:null,
    whItemLists:null,
    bpItemLists:null,
    gridListnum:null,

	ctor:function(){
		this._super();
		this.itemLists = new Array();
		this.whItemLists = new HashMap();
		this.bpItemLists = new HashMap();
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -28;
	},

	Init:function(){
        WarehouseMain.prototype.Init.call( this );
        this.imgXiaoguo.visible = false;
        this.imgXiaoguo1.visible = false;
        this.scrpan1.visible = false;
        this.scrpan11.visible = false;

        var self = this;
        Mgr.store.warehousePanel = self;
        Mgr.backpack.warehousePanel = self;
        Mgr.store.SendReqStoreGetItemsMessage(EnumStore.NORMAL);

        var gridnuminfo = Mgr.backpack.gridNumInfo;
        var num = gridnuminfo.GetOpendNum() + gridnuminfo.GetLockNum();
        while ((num % 5) != 0){
            num ++;
        }
        this.gridListnum = num / 5;

        self.InitAllGrid();
		this.btnClose.addClickEventListener(function(event){
			Mgr.uiMgr.HidePanel(self);
		});

		this.btnZhengli.addClickEventListener(function (event) {
            var backpack = Mgr.uiMgr.GetPanelByType(BackpackPanelExt.PanelName);
            backpack.Startsort();
        });

        this.btnZhengli1.addClickEventListener(function (event) {
            self.StartSort();
        });
	},

	InitAllGrid:function () {
        //仓库格子
        var tableView1 = new cc.TableView(this,cc.size(this.scrpan1.uiWidth, this.scrpan1.uiHeight-24));
        tableView1.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
        tableView1.setDelegate(this);
        tableView1.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
        tableView1.x=this.scrpan1.x;
        tableView1.y=this.scrpan1.y;
        tableView1.uiWidth=this.scrpan1.uiWidth;
        tableView1.uiHeight=this.scrpan1.uiHeight;
        // this.removeChild(this.scrpan1);
        this.scrpan1=tableView1;
        this.addChild(tableView1);
        tableView1.reloadData();

        //背包格子
        var tableView11 = new cc.TableView(this,cc.size(this.scrpan11.uiWidth, this.scrpan11.uiHeight-24));
        tableView11.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
        tableView11.setDelegate(this);
        tableView11.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
        tableView11.x=this.scrpan11.x;
        tableView11.y=this.scrpan11.y;
        tableView11.uiWidth=this.scrpan11.uiWidth;
        tableView11.uiHeight=this.scrpan11.uiHeight;
        // this.removeChild(this.scrpan11);
        this.scrpan11=tableView11;
        this.addChild(tableView11);
        tableView11.reloadData();
    },

    OnShow:function () {
        this.InitBPItems();
        this.RefreshBPPanel();
    },

    StartSort:function () {
        var warsehousevo = Mgr.store.wareHouseInforVo;
        if (warsehousevo.GetEnableSort())
        {
            warsehousevo.BeginSort();
            Mgr.store.SendReqStoreClearUpMessage(EnumStore.NORMAL);
        }
        else
        {
            Mgr.tips.ShowNotice( warsehousevo.GetSortTime() );
        }
    },

    InitWHItems:function () {
        this.whItemLists.Clear();
        var items = this.whItems;
        for(var i = 0, len = items.length; i < len; i++){
            var item = items[i];
            this.whItemLists.Put(item.gridId, item);
        }
    },

    InitBPItems:function () {
        this.bpItemLists.Clear();
        var vo = Mgr.backpack.backpackVO;
        var items = vo.GetItemInfoHash().Values();
        for(var i = 0, len = items.length; i < len; i++){
            var item = items[i];
            this.bpItemLists.Put(item.gridId, item);
        }
    },

    GetBPEmptyGrid:function () {
	    var items = this.bpItemLists;
        var keys = this.bpItemLists.Keys();
        keys.sort(function (a, b) { return b - a; });
        var max = keys[0];
        for(var i = 1; i <= max; i++){
            if(items.Get(i) == null){
                return i;
            }
        }
        return (parseInt(max) + 1);
    },

    GetWHEmptyGrid:function () {
        var items = this.whItemLists;
        var keys = this.whItemLists.Keys();
        keys.sort(function (a, b) { return b - a; });
        var max = keys[0];
        for(var i = 1; i <= max; i++){
            if(items.Get(i) == null){
                return i;
            }
        }
        return (parseInt(max) + 1);
    },

    GetBPItemByGid:function (gid) {
        return this.bpItemLists.Get(gid);
    },

    GetWHItemByGid:function (gid) {
        return this.whItemLists.Get(gid);
    },

    isBPClicked:false,
    isWHClicked:false,

    BPClickEvent:function (target) {
	    if(this.isBPClicked){
	        this.isBPClicked = false;
            ItemUtil.ShowTips(target.itemInfo,target.gridType);
        }
    },

    WHClickEvent:function (target) {
        if(this.isWHClicked){
            this.isWHClicked = false;
            ItemUtil.ShowTips(target.itemInfo,target.gridType);
        }
    },

    SetBPCellDataByIdx:function (cell,idx) {
	    var self = this;
	    var gid;
        for(var i = 0, len = cell.gridList.length; i < len; i++){
            gid = (idx * len + i) + 1;
            var item = self.GetBPItemByGid(gid);
            if(item){
                GridUtil.SetItemGrid(cell.gridList[i], item);
                cell.gridList[i].itemInfo = item;
            }else {
                cell.gridList[i].Clean();
                cell.gridList[i].gridData = null;
            }
            cell.gridList[i].gridType = GridTypeEnum.STOREBACKPACK;
            cell.gridList[i].addClickEventListener(function (target) {
                if(self.isBPClicked){
                    self.isBPClicked = false;
                    if(target.itemInfo){
                        var gid = self.GetWHEmptyGrid();
                        var mid = target.itemInfo.itemId;
                        Mgr.store.SendReqBagToStoreMessage(mid, gid, EnumStore.NORMAL);
                    }
                }else {
                    TimerUtil.SetTimeout(self, self.BPClickEvent, 250, target);
                    self.isBPClicked = true;
                }
            });
        }
    },

    SetWHCellDataByIdx:function (cell,idx) {
        var self = this;
        var gid;
        for(var i = 0, len = cell.gridList.length; i < len; i++){
            gid = (idx * len + i) + 1;
            var item = self.GetWHItemByGid(gid);
            if(item){
                GridUtil.SetItemGrid(cell.gridList[i], item);
                cell.gridList[i].itemInfo = item;
            }else {
                cell.gridList[i].Clean();
                cell.gridList[i].gridData = null;
            }
            cell.gridList[i].gridType = GridTypeEnum.STORE;
            cell.gridList[i].addClickEventListener(function (target) {
                if(self.isWHClicked){
                    self.isWHClicked = false;
                    if(target.itemInfo){
                        var gid = self.GetBPEmptyGrid();
                        var mid = target.itemInfo.itemId;
                        Mgr.store.SendReqStoreToBagMessage(mid, gid, EnumStore.NORMAL);
                    }
                }else {
                    TimerUtil.SetTimeout(self, self.WHClickEvent, 250, target);
                    self.isWHClicked = true;
                }
            });
        }
    },

    RefreshBPPanel:function () {
        for(var i = 0; i < 6; i++){
            var cell = this.scrpan11.cellAtIndex(i);
            if( cell )
                this.SetBPCellDataByIdx(cell.item, i);
        }
    },

    RefreshWHPanel:function () {
        for(var i = 0; i < 6; i++){
            var cell = this.scrpan1.cellAtIndex(i);
            if( cell )
                this.SetWHCellDataByIdx(cell.item, i);
        }
    },

    AddWHItem:function (item, gid) {
        this.whItemLists.Put(gid, item);
    },

    RemoveWHItem:function (mid) {
	    var lists = this.whItemLists;
        var keys = this.whItemLists.Keys();
        for(var i = 0, len = keys.length; i < len; i++){
            var key = keys[i];
            var item = lists.Get(key);
            if(item.itemId.Equal(mid)){
                cc.log("ready to remove wh   ");
                var cellidx;
                var idx;
                if(key % 5 == 0){
                    cellidx = Math.floor(key / 5) - 1;
                    idx = 4;
                }else {
                    cellidx = Math.floor(key / 5);
                    idx = (key % 5) - 1;
                }
                lists.Remove(key);
                var cell = this.scrpan1.cellAtIndex(cellidx);
                var grid = cell.item.gridList[idx];
                grid.Clean();
                grid.itemInfo = null;
                cc.log("remove wh success" + "   mid  " + mid + "   cellidx   " + cellidx + "   idx  " + idx + "grid" + grid.itemInfo);
                break;
            }
        }
    },

    AddBPItem:function (item, gid) {
        this.bpItemLists.Put(gid, item);
    },

    RemoveBPItem:function (mid) {
        var lists = this.bpItemLists;
        var keys = this.bpItemLists.Keys();
        for(var i = 0, len = keys.length; i < len; i++){
            var key = keys[i];
            var item = lists.Get(key);
            if(item && item.itemId.Equal(mid)){
                cc.log("ready to remove bp   " + item.itemId);
                var cellidx;
                var idx;
                if(key % 5 == 0){
                    cellidx = Math.floor(key / 5) - 1;
                    idx = 4;
                }else {
                    cellidx = Math.floor(key / 5);
                    idx = (key % 5) - 1;
                }
                this.bpItemLists.Remove(key);
                var cell = this.scrpan11.cellAtIndex(cellidx);
                var grid = cell.item.gridList[idx];
                grid.Clean();
                grid.itemInfo = null;
                cc.log("remove bp success" + "   mid  " + mid + "   cellidx   " + cellidx + "   idx  " + idx);
                break;
            }
        }
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(498,96);
    },
    tableCellAtIndex: function (table, idx) {
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item=new BackGridListExt();
            item.LoadPanel();
            cell.item=item;
            cell.addChild(item);
        }

        if(table == this.scrpan1){
            this.SetWHCellDataByIdx(cell.item, idx);
        }

        if(table == this.scrpan11){
            this.SetBPCellDataByIdx(cell.item, idx);
        }
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.gridListnum;
    }
} );
WarehouseMainExt.PanelName = "WarehouseMainExt";
PanelClassDic["WarehouseMainExt"] = WarehouseMainExt;
