﻿var BuffType = BuffType || {
    /**
     * 护盾（每次受到固定伤害）护盾血量配置在q_effect_maxvalue，固定伤害值配置在q_effect_value   q_other 奖励红包  【货币类型，货币值，红包数
     */
    BUFF_SHIELD_1:907,
    /**
     * 护盾（每次受到固定伤害）护盾血量配置在q_effect_maxvalue，固定伤害值配置在q_effect_value   q_other 配置ROLL点道具
     */
    BUFF_SHIELD_2:910,
};


var BuffModMgr = BuffModMgr || cc.Class.extend({
	ctor:function() {	
	},
	/**
	 * 同步主玩家全部buff
	 * @param msg
	 */
	RecvResBuffsMessage:function(msg) {
		Mgr.mainPlayer.RemoveAllBuff();
		// if( debuffpanel )
		// 	debuffpanel.removeAllDeBuffShow();
		// _buffpanel.removeAllBuffShow();

		if( Mgr.mainPlayer ){
			Mgr.mainPlayer.nBuffState = msg.fightState;
			var len = msg.buff.length;
			for( var i = 0; i < len; i++ ){
				var vo = new BuffVo(msg.buff[i]);
				var model = vo.Model();
				if(model){
					if( model.q_cast_type == 0 )
						continue;
					Mgr.mainPlayer.AddBuff(vo);
					Mgr.player.roleHeadPanel.AddBuff(vo);
					// if (vo.showPosType == 2)
					// 	debuffpanel.addDeBuffShow(vo);
					// else if (vo.showPosType == 1)
					// {
					// 	_buffpanel.addBuffShow(vo);
					// }
				}
			}
		}
	},

	RecvResAddBuffMessage:function(msg) {
		var tar = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		var src = Mgr.sceneObj.FindObject( msg.sourceId.toGID() );
		if( tar ){
			tar.nBuffState = msg.fightState;
			var vo = new BuffVo( msg.buff );
			var model = vo.Model();
			if( model ){
				if( model.q_cast_type == 0 )
					return;
				tar.AddBuff( vo );

				if( tar == Mgr.mainPlayer ){
					Mgr.player.roleHeadPanel.AddBuff(vo);
// 					Mgr.promptMgr.addPersonInfo(PersonalNoticeTypeEnum.Success, BuffUtil.getBuffPrompt(buffm, vo.value, vo.percent, srcV));
//
// 					// 负面BUFF, 屏幕中添加图标
// 					if (vo.showPosType == 2)
// 					{
// 						debuffpanel.addDeBuffShow(vo);
// 					}
// 					else if (vo.showPosType == 1)
// 					{
// 						_buffpanel.addBuffShow(vo);
// 					}
//
// 					if( BuffUtil.isBuffExist( Mgr.mainPlayerV.buffState, BuffStateEnum.HUNLUAN ) )
// 					{
// 						startRandomPos = Mgr.mainPlayerV.position;
// 						randomMove();
// 					}
//
// 					if ( msg.buff.buffModelId == BuffUtil.MID_NIGHTESCORT )
// 						Mgr.onHookMgr.showNightProPanel();
				}
                Mgr.map.UpdateBuff(tar);
			}
		}
	},

	RecvResRemoveBuffMessage:function(msg) {
		var tar = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		if( tar ){
			tar.nBuffState = msg.fightState;
			var vo = tar.DelBuff( msg.buffId );
			if ( vo != null )
			{
				var mid = vo.ModelId();
				if( tar == Mgr.mainPlayer ){
					 if( vo.ShowPosType() == 2 )
						 Mgr.player.roleHeadPanel.RemoveBuff(msg.buffId);
					 else if (vo.showPosType == 1){
//					 	_buffpanel.removeBuffShow(msg.buffId);
					 }else{
					// 	_buffpanel.removeBuffShow(msg.buffId);
					// 	debuffpanel.removeDeBuffShow(msg.buffId);
					 }
				}
			}
            Mgr.map.UpdateBuff(tar);
		}
	},

	RecvResBuffInfoMessage:function(msg) {
		cc.log( "Buff信息" + msg.remain + "  "  + msg.value);
	},

	RecvResChangeBuffMessage:function(msg) {
        // cc.log("Buff改变: " + JSON.stringify(msg))
		var tar = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		var src = Mgr.sceneObj.FindObject( msg.sourceId.toGID() );
		if( tar ){
			tar.nBuffState = msg.fightState;
			var vo = new BuffVo( msg.buff );
			var model = vo.Model();
			if( model ){
				if( model.q_cast_type == 0 )
					return;
				tar.UpdateBuff( vo );

				if( tar == Mgr.mainPlayer ){
					Mgr.player.roleHeadPanel.AddBuff(vo);
// 					Mgr.promptMgr.addPersonInfo(PersonalNoticeTypeEnum.Success, BuffUtil.getBuffPrompt(buffm, vo.value, vo.percent, srcV));
//
// 					// 负面BUFF, 屏幕中添加图标
// 					if (vo.showPosType == 2)
// 					{
// 						debuffpanel.updateDeBuff(vo);
// 					}
// 					else if (vo.showPosType == 1)
// 					{
// 						_buffpanel.updateBuff(vo);
// 					}
				}
                Mgr.map.UpdateBuff(tar);
			}
		}
	},

	RecvResShowBuffInfoMessage:function(msg) {
		var tar = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		if( tar ){
			var len = msg.buffs.length;
			for( var i = 0; i < len; i++ ){
				tar.AddBuff( new BuffVo( msg.buffs[i] ) );
			}
		}
	},

	SendReqRemoveBuffMessage:function(msg) {	
	},

	SendReqBuffInfoMessage:function(buffId) {
		var msg = new ReqBuffInfoMessage();
		msg.buffId = buffId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqShowBuffInfoMessage:function(playerId) {
		var msg = new ReqShowBuffInfoMessage();
		msg.personId = playerId;
		Mgr.msgMgr.Send(msg);
	}
});

var BuffVo = BuffVo || cc.Class.extend({
		_buffInfo:null,
		_endTime:0,
		ctor:function(info){
			this._buffInfo = info;
			if( info.remaime == -1 )
				this._endTime = -1;
			else{
				this._endTime = TimerUtil.GetTimer + info.remaime * 1000;
			}
		},

		EndTime:function () {
			return this._endTime;
		},

		ModelId:function(){
			return this._buffInfo.buffModelId;
		},

		Sid:function(){
			return this._buffInfo.buffId;
		},

		Value:function(){
			return this._buffInfo.value;
		},

		Percent:function(){
			return this._buffInfo.percent;
		},

		/**
		 * 叠加层数
		 */
		Overlay:function(){
			return this._buffInfo.overlay;
		},

		Model:function(){
			return Q_buff.Get( this._buffInfo.buffModelId );
		},

		BuffName:function () {
			var m = this.Model();
			if (m == null)
				return "未知buff";
			return m.q_buff_name;
		},

		/**
		 * 剩余秒数
         */
		RemainSec:function () {
			if( this._endTime == -1 )
				return -1;
			var t = 0;
			t = ( this._endTime - TimerUtil.GetTimer ) / 1000;
			if( t < 0 )
				t = 0;
			return t;
		},

		ToTalSec:function () {
			return this._buffInfo.totalTime;
		},

		/**
		 * 显示位置 0不显示 1 头像下面 2屏幕正中
		 * @return
		 *
		 */
		ShowPosType:function()	{
			var m = this.Model();
			if (m == null)
				return 0;

			return m.q_show_type;
		},
	});

var BuffUtil = BuffUtil || {
		sizeArray:["/20.png","/24.png","/36.png"],
		IsBuffExist:function( buffState, type ){
			return ( (buffState & type ) != 0 );
		},

		/**
		 * 是否有指定的一个或多个BUFF
		 * @param tar:Scene_fight_object
		 * @param buffs:Array
         */
		CheckHaveBuff:function( tar, buffs ){
			if( tar.buffs ){
				var len = tar.buffs.length;
				for( var i = 0; i < len; i++ ){
					for( var j = 0; j < buffs.length; j++ ){
						if( tar.buffs[i].ModelId == buffs[j] )
							return true;
					}
				}
			}
			return false;
		},

		BuffInfoToVo:function( infos ){
			if ( !infos ){return [];}
			var buffs = [];
			var len = infos.length;
			for(var i = 0; i < len; i++){
				buffs.push(new BuffVo(infos[i]));
			}
			return buffs;
		},
		GetBuffIco:function(mid ,sizeType){
			if(!sizeType)
			sizeType=0;
			var url = "res/ui/icon/buff/"+mid+"/"+this.sizeArray[sizeType];
			var image = new MUIBackgroundImage();
			LoadMgr.LoadImage( url , image , LoadPriority_Common, {complete:image.CallLoaded, completeParam:[image]} );
			if (sizeType == 0)
			{
				image.width = 20;
				image.height = 20;
			}
			else if (sizeType == 1)
			{
				image.width = 24;
				image.height = 24;
			}
			else if (sizeType == 2)
			{
				image.width = 36;
				image.height = 36;
			}
			return image;
		}
	};

var BuffStateEnum = BuffStateEnum || {
		/**
		 * 禁止移动
		 */
		JINZHI_MOVE:0x00000001,
		/**
		 * 禁止生命恢复
		 */
		JINZHISHENGMINGHUOFU:0x00000002,
		/**
		 * 禁止灵力恢复
		 */
		JINZHILINGLIHUIFU:0x00000004,
		/**
		 * 禁止体力恢复
		 */
		JINZHITILIHUIFU:0x00000008,
		/**
		 * 睡眠
		 */
		SHUIMIAN:0x00000010,
		/**
		 * 禁止攻击
		 */
		JINZHI_ATTACK:0x00000020,
		/**
		 * 无敌
		 */
		WUDI:0x00000040,
		/**
		 * 禁止骑乘
		 */
		JINZHIQICHENG:0x00000080,
		/**
		 * 方向倒置(混乱 乱跑)
		 */
		HUNLUAN:0x00000100,
		/**
		 * 禁止闪避
		 */
		JINZHISHANBI:0x00000200,
		/**
		 * 落马
		 */
		LUOMA:0x00000400,
		/**
		 * 缴械
		 */
		DIAAMOR:0x00000800,
		/**
		 * 反伤
		 */
		FANSHANG:0x00001000,
		/**
		 * PK保护
		 */
		PKBAOHU:0x00002000,
		/**
		 * 吸血
		 */
		XIXUE:0x00004000,
		/**
		 * 多次攻击
		 */
		DUOCIGONGJI:0x00008000,
		/**
		 * 牺牲
		 */
		SACRIFICE:0x00010000,
		/**
		 * 斩杀
		 */
		BEHEADED:0x00020000,
		/**
		 * 禁止跳跃
		 */
		JINZHI_JUMP:0x00040000,
		/**
		 * 回复血量灵力速度改变(必须写1000的倍数)
		 */
		RESTORE_TIME:0x00080000,
		
		/**
		 * 夜间保护
		 */
		NIGHTBAOHU:0x00100000,
		
		/**
		 * 被嘲讽状态
		 */
		CHAOFENG:0x00200000,
		
		/**
		 * 领地战旗战状态
		 */
		CONQUEST:0x00400000,
		
		/**
		 * 吹飞
		 */
		CHUIFEI:0x00800000,
		
		/**
		 * 强行PK
		 */
		FORCEPK:0x01000000,
	};