var CrossModMgr = CrossModMgr || cc.Class.extend({

	_crossIp:null,
	_crossPort:null,
	_userId:null,
	_playerId:null,
	_oldKey:null,
	_crossKey:null,

	ctor:function() {	
	},

	//收到服务器通知进入跨服
	RecvResChangeServerGameToClientMessage:function(msg) {
		cc.log("enter-跨服 msg=> "+JSON.stringify(msg));
		this._crossIp = msg.serverIp;
		this._crossPort = msg.serverPort;
		this._userId = msg.userId;
		this._playerId = msg.playerId;
		this._oldKey = msg.oldserverKey;
		this._crossKey = msg.fightServerKey;
		var self = this;
		var type = msg.fighttype;	//战斗类型(1.10v10 2.多人副本)
		switch( type ){
			case EnumCrossType.TenVSTen:
				break;
			case EnumCrossType.CrossTeam://多人副本
			{
				Mgr.uiMgr.GetPanelByType(DuorenPanelExt.PanelName ).ClosePanel();
				EngineMgr.uiMgr.ShowPanelByType(FubenTimeCueExt.PanelName,UIMgr.PANEL_LAYER_TOP);
				var timePanel = Mgr.uiMgr.GetPanelByType(FubenTimeCueExt.PanelName);
				timePanel.ShowBeginTime(3,EnumZoneType.TYPE_KFDR,self.StartCrossServer,type,self);
			}
				break;
		}
		//先直接传了 这里要根据type显示对应的倒计时后再传 以及处理进入前的逻辑 eg:关闭匹配面板之类
		//this.StartCrossServer(type);
	},

	//登录跨服
	SendReqLoginFightServerClientToFightMessage:function() {
		var msg = new ReqLoginFightServerClientToFightMessage();
		msg.userId = this._userId;
		msg.playerId = this._playerId;
		msg.oldserverKey = this._oldKey;
		msg.fightServerKey = this._crossKey;
		Mgr.msgMgr.Send( msg );
		zz.Log( "SendReqLoginFightServerClientToFightMessage" );
	},

	//前端请求退出跨服
	SendReqQuitClientToFightMessage:function() {
		cc.log("前端请求退出跨服-------------前端请求退出跨服");
		var msg = new ReqQuitClientToFightMessage();
		Mgr.msgMgr.Send( msg );
		Mgr.msgMgr.CloseSocket(true);	//直接关就行了 底层调整为关闭前限把消息发送完了
		this.OnCrossClose();		//主动断开的不会有close事件  自己清一下
	},

	SendReqEnterCrossClientToGameMessage:function(msg) {	
	},

	//开始跨服
	StartCrossServer:function( type ){
		switch ( type )
		{
			case EnumCrossType.CrossTeam:		//这里要移除多人副本图标
			{
				Mgr.zone.SetCurrentZoneType(EnumZoneType.TYPE_KFDR);
				var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
				if(panel)
				{
					panel.UpdateTeamZoneTeamHead();
				}
				break;
			}
			default:
				break;
		}
		Mgr.msgMgr.ConnectCross( this._crossIp, this._crossPort, this.OnCrossConnectSuccess, this.OnCrossConnectErr, this.OnCrossClose );
	},

	OnCrossConnectSuccess:function(){
		Mgr.cross.SendReqLoginFightServerClientToFightMessage();
	},

	OnCrossConnectErr:function(){

	},

	/**
	 * 统一特殊处理的一些东西，在退出跨服的时候		清理一些跨服未同步的状态 关闭一些跨服面板
	 */
	OnCrossClose:function(){
		cc.log("onCrossClose--------------- ");
		Mgr.zone.SetCurrentZoneType(-1);
		if (Mgr.mainPlayer != null)
		{
			// Mgr.crossteam.isInteam = false;		//退出副本不离队
			// Mgr.crossteam.SendReqLeaveCrossTeamClientToGameMessage();
			// Mgr.crossteam.ClearPlayerPanelInZone();
			var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
			if(panel)
			{
				panel.ClearPlayerInZoneTeam();
			}
			//Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName ).ShowOutZoneState();
			if ( Mgr.player.isAutoFight )
				Mgr.player._StopAutoFight();
		}
	},

});
EnumCrossType = {};
EnumCrossType.TenVSTen = 1;
EnumCrossType.CrossTeam = 2;