var BuBuGaoShengAwardExt = BuBuGaoShengAward.extend ( {
    _className:"BuBuGaoShengAwardExt",

    gridList:null,
    MaxGrid:10,            //最多能放7个
    gridW:104,       //格子+间隔
    showList:null,
    boxWith:720,
    scrollpanel:null,
    index:0,
    isScroll:false,
    temp:null,
    ctor:function(){
        this._super();
    },
    Init:function(){
        this._super()

        this.btn1.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));

        this.imgBg1.x-=150;
        var price=Q_lucky_draw_total.Get(1).q_currency_cost;
        price=JSON.parse(price);
        var self=this;
        this.showList=[];
        this.gridList=[this.grid1];
        this.grid1.setTouchEnabled(true);
        this.grid1.setSwallowTouches(true);
        this.grid1.addClickEventListener(function () {
            if(!self.isScroll) {
                Mgr.uiMgr.ShowPanelByType(ItemTipsExt.PanelName, UIMgr.PANEL_LAYER_POP);
                Mgr.tips.normalTip.ShowModel(this.itemInfo.mod);
            }
            self.isScroll=false;
        });

        //this.grid1.setVisible(false);
        this.grid1.setAnchorPoint(0.5,0.5);
        this.grid1.y+=42;


        this.imgbg.setAnchorPoint(0.5,0.5);
        this.imgbg.x+=392;
        this.imgbg.y+=63;
    },
    OnShow:function(){
        this.ShowEffect()
    },
    Update:function(){
        var list=Mgr.step.GetCurrentLayerAwardByBoxId();
        if(list && list[0] && list[0].mod == 888){
            EngineMgr.uiMgr.HidePanel(this)
            return
        }


        //滚动特效
        var self=this;
        if(!this.scrollpanel) {
            this.scrollpanel = new ccui.ScrollView();
            this.scrollpanel.setSize(960, 200);
            this.scrollpanel.setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL);
            this.scrollpanel.setScrollBarEnabled(false);
            this.scrollpanel.setBounceEnabled(true);
            this.scrollpanel.y=-10;
            this.scrollpanel.addTouchEventListener(function (event,type) {
                if(type==1){
                    self.isScroll=true;
                }
            });
            this.imgBg1.addChild( this.scrollpanel);
            this.temp= new cc.Sprite();                       //转换一层不然有问题 可能是事件优先级的问题
            this.scrollpanel.addChild(this.temp);
            this.grid1.retain();
            this.grid1.removeFromParent();
            this.grid1.x=51;
            this.grid1.y=58;
            this.temp.addChild(this.grid1);
            this.grid1.release();
            this.grid1.setSwallowTouches(false);
        }
        this.scrollpanel.setInnerContainerSize(cc.size(list.length*96,84));
        this.scrollpanel.jumpToLeft();
        this.scrollpanel.x=0;
        var star=0;
        if(list.length<this.MaxGrid){
            star= Math.ceil((this.MaxGrid-list.length)/2);
        }
        if(star!=0&&star%2!=0){
            this.scrollpanel.x=-48;
        }
        this.showList=[];
        for(var i=0;i<list.length;++i,++star){
            var grid = this.gridList[star];
            if (!grid) {
                grid = new MUIGrid();
                grid.jsonobj = this.grid1.jsonobj;
                grid.Init();
                grid.setVisible(false);
                grid.InitGrid(GridTypeEnum.STORE);
                grid.setAnchorPoint(0.5,0.5);
                grid.x=96*star+51;
                grid.y=58;
                this.temp.addChild(grid);
                this.gridList[star]=grid;
                grid.setTouchEnabled(true);
                grid.setSwallowTouches(false);
                grid.addClickEventListener(function () {
                    if(!self.isScroll) {
                        Mgr.uiMgr.ShowPanelByType(ItemTipsExt.PanelName, UIMgr.PANEL_LAYER_TOP);
                        Mgr.tips.normalTip.ShowModel(this.itemInfo.mod);
                    }
                    self.isScroll=false;
                });
            }
            grid.Clean();
            //var icon = ItemUtil.GetItemIcon(list[i].mod ,3 );
            var icon = this.getItemIcon(list[i].mod);
            icon.setAnchorPoint(cc.p(0.5,0.5))
            icon.x = (grid.uiWidth ) / 2;
            icon.y = (grid.uiHeight ) / 2;
            grid.SetGridIcon(icon);
            GridUtil.AddItemNumByNum(grid,list[i].num);
            grid.setScale(2);
            grid.itemInfo=list[i];
            this.showList.push(grid);
        }
        this.index=0;
        this._AddEffect();
    },

    getItemIcon:function(mod){
        if(mod == 888){
            var image = new MUIImage()
            UIUtil.LoadImage(image,"other/huodong/bubugaosheng/image/cheng2.png",false,true,function(){
                image.setScale(74/image.width)
            })
            return image
        }else if(mod == 1002){
            var image = new MUIImage();
            UIUtil.LoadImage(image,"other/huodong/bubugaosheng/image/touzixiao.png",false,true,function(){
                image.setScale(74/image.width)
            })
            return image
        }else{
            var image = ItemUtil.GetItemIcon(mod,3);
            return image
        }
    },

    _AddEffect:function(){
        var list=this.showList;
        if(list.length<1){
            this.scrollpanel.jumpToRight();
            return;
        }
        var gird=list.shift();
        if(this.index>5&&list.length>0)
        {
            var percent= (this.index-5)/(Mgr.luckydraw.itemList.length-7);
            this.scrollpanel.scrollToPercentHorizontal(100*percent,0.2,true);
        }
        this.index++;
        gird.setVisible(true);
        var scale=cc.ScaleTo(0.2,1);
        var next=cc.CallFunc(this._AddEffect.bind(this));
        var aa=cc.Sequence(scale,next);
        gird.runAction(aa);

    },
    ShowEffect:function(){
        for(var i=0;i<this.gridList.length;++i){
            if(this.gridList[i]) {
                this.gridList[i].setVisible(false);
                this.gridList[i].stopAllActions();
            }
        }

        this.Update();
    }
} );
BuBuGaoShengAwardExt.PanelName = "BuBuGaoShengAwardExt";
PanelClassDic["BuBuGaoShengAwardExt"] = BuBuGaoShengAwardExt;
