var SignShouChongExt = SignShouChong.extend ( {
	_className:"SignShouChongExt",
    _listView:null,
    _totalNum:null,
    activityList:null,
	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -30;
	},

    Init:function () {
      SignShouChong.prototype.Init.call(this);
      this.btnChongZhi.setTitleText("立即充值");

      if(!this._listView){
          var tableView = new cc.TableView(this,cc.size(this.imgContent.uiWidth, this.imgContent.uiHeight - 4));
          tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
          tableView.setDelegate(this);
          tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
          tableView.uiWidth=this.imgContent.uiWidth;
          tableView.uiHeight=this.imgContent.uiHeight;
          tableView.y = 4;
          this._listView=tableView;
          this.imgContent.addChild(tableView);
      }

      var self = this;
      this.btnClose.addClickEventListener(function () {
          Mgr.uiMgr.HidePanel(self);
      });

      this.btnChongZhi.addClickEventListener(function (target) {
          Mgr.recharge.Recharge(201);
      });
    },

    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        isOpen = isOpen || false;
        this.mainPanelKey = mainPanelKey;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        var list = Mgr.dailyactivity.GetActivityByKey(this.mainPanelKey);
        this.activityList = list;
        this.btnChongZhi.info = list[0];
        this._totalNum = this.activityList ? this.activityList.length : 0;
        this._listView.reloadData();
        this.ShowNeedCell();
    },

    UpdateSingleActivity:function (info) {
        for(var i = 0, len = this.activityList.length; i < len; i++){
            var ac = this.activityList[i];
            if(ac.activityId == info.activityId){
                ac.status = info.status;
                break;
            }
        }

        this._listView.reloadData();
        this.ShowNeedCell();
    },

    ShowNeedCell:function () {
        var index = 0;
        for(var i = 0, len = this.activityList.length;i < len; i++){
            var ac = this.activityList[i];
            if(ac.status == 1){
                index = i;
                break;
            }
        }
        var offsetY = this.CalCulateOffsetY(5, index, 0);
        this._listView.setContentOffset(cc.p(0, offsetY), false);
    },

    CalCulateOffsetY:function (viewShowCount, cellIndex, locationIndex) {
        var viewHeight = this._listView.getViewSize().height;
        var cellHeight = 82;
        var cellCount = this._totalNum;
        var tableTotalHeight = cellHeight * cellCount;
        if(tableTotalHeight > viewHeight) {
            return 0.00 - (cellCount - (cellIndex + viewShowCount - locationIndex + 1)) * cellHeight - cellHeight/2;
        }
        else{
            return viewHeight - tableTotalHeight;
        }
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(489,82);
    },

    tableCellAtIndex: function (table, idx) {
        var info = this.activityList[idx];
        var cell = table.dequeueCell();
        if (!cell) {
            cell = cc.Sprite();
            var item = new SignShouChongListExt();
            item.LoadPanel();
            item.setTouchEnabled(false);
            item.SetData(info);
            cell.item = item;
            cell.addChild(item);
        }
        cell.item.SetData(info);
        return cell;
    },

    numberOfCellsInTableView: function () {
        return this._totalNum;
    }
} );
SignShouChongExt.PanelName = "SignShouChongExt";
PanelClassDic["SignShouChongExt"] = SignShouChongExt;
