var SingleRechargePanelExt = SingleRechargePanelExt || cc.Node.extend({
    cellPanel:null,
    cellList:null,
    totalNum:null,
    activityList:null,

    LoadPanel:function(){
        this.uiWidth = 801;
        this.uiHeight = 503;

        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.uiWidth, this.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.uiWidth=this.uiWidth;
            tableView.uiHeight=this.uiHeight;
            this.cellPanel=tableView;
            this.addChild(tableView);
        }
    },

    SetActivityList:function (infoList, isOpen) {
        this.activityList = infoList;

        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        this.cellList = Mgr.dailyactivity.GetGradeInfoById(this.activityList[0].activityId);
        this.totalNum = this.cellList.length;
        if( isOpen ){
            this.cellPanel.reloadData();
        }
        else{
            this.ReloadData();
        }
    },

    UpdateSingleActivity:function(info){
        this.UpdateActivityInfo(false);     //有的不会发简要信息 直接重刷吧
    },

    ReloadData:function(){
        for( var i = 0, len = this.cellList.length; i < len; i++ ){
            var cell = this.cellPanel.cellAtIndex(i);
            if( cell && cell.item ){
                cell.item.SetData( this.cellList[i] );
            }
        }
    },
    OnHide:function () {

    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(805,115);
    },
    tableCellAtIndex: function (table, idx) {
        var item;
        var ac = this.cellList[idx];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            item = new SingleRechargeListExt();
            item.LoadPanel();
            item.SetData(ac);
            item.setTouchEnabled(false);
            cell.item = item;
            cell.addChild(item);
        }
        cell.item.SetData(ac);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    }
});
SingleRechargePanelExt.PanelName = "SingleRechargePanelExt";
PanelClassDic["SingleRechargePanelExt"] = SingleRechargePanelExt;