var TeHuiLiBaoPanelExt = TeHuiLiBaoPanel.extend ( {
	_className:"TeHuiLiBaoPanelExt",
	buttonList:null,
    awardList:null,
    activityList:null,
    curData:null,
    isAll:false,

	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = 60;
        this.activityList = [];
	},

	Init:function () {
	    var self = this;
		TeHuiLiBaoPanel.prototype.Init.call(this);
        this.imgNumber._align = 2;
        this.imgNumber.x = -145;
		this.buttonList = [this.sbtnLiBao1, this.sbtnLiBao2, this.sbtnLiBao3, this.sbtnLiBao4, this.sbtnLiBao5];
		this.awardList = [this.gridKuang, this.gridKuang1, this.gridKuang2, this.gridKuang3, this.gridKuang4, this.gridKuang5, this.gridKuang6];
		this.guildList = [this.imgGuild1, this.imgGuild2, this.imgGuild3, this.imgGuild4, this.imgGuild5];
        this.btnGuanbi.addClickEventListener(function (target) {
            Mgr.uiMgr.HidePanel(self);
        });

        this.btnGouMai.addClickEventListener(function (target) {
            var price = parseInt(self.curData.GetFlagValue(EnumActivityFlag.F_NEW_PRICE));
            var total = Mgr.mainPlayer.attributeData.TotalGold();
            if(total < price){
                // Mgr.tips.ShowNotice("你的元宝不足");
                AlertExt.NoEnoughGold(price - total);
            }else {
                var status = self.curData.status;
                cc.log("status   :   " + status + "   " + self.curData.activityId);
                if(status > 0){
                    Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.curData.activityId);
                }
            }
        });
    },

    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        isOpen = isOpen || false;
        this.mainPanelKey = mainPanelKey;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        var list = Mgr.dailyactivity.GetActivityByKey(this.mainPanelKey);
        this.activityList = list;
        var filterList = ActivityUtil.GetListByCorrelation(this.activityList);
        this.UpdateButton(filterList);
        if( isOpen ){
            this.curData = filterList[0];
            this.buttonList[0].SetButtonState(MUICheckBox.STATE_CHECK , true);
        }
		this.UpdatePanel();
        this.SetGouMaiBtnState();
	},

    UpdateButton:function (list) {
        var self = this;
        for(var i = 0, len = Math.min(list.length,this.guildList.length); i < len; i++){
            var info = list[i];
            var button = this.buttonList[i];
            if(info.status > 0){
                this.guildList[i].setVisible(true);
            }else {
                this.guildList[i].setVisible(false);
            }
            switch (info.top){
                case 1: button.SetText("宝石\n礼包");break;
                case 2: button.SetText("装备\n礼包");break;
                case 3: button.SetText("宝骑\n礼包");break;
                case 4: button.SetText("易容\n礼包");break;
                case 5: button.SetText("光羽\n礼包");break;
                case 6: button.SetText("材料\n礼包");break;
                case 7: button.SetText("易容\n礼包");break;
                case 8: button.SetText("披风\n礼包");break;
                case 9: button.SetText("幻彩\n礼包");break;
                case 10: button.SetText("披风\n礼包");break;
            }
            button.data = info;
            button.addClickEventListener(function (target) {
                target.SetButtonState(MUICheckBox.STATE_CHECK , true);
                self.curData = target.data;
                self.UpdatePanel();
                self.SetGouMaiBtnState();
            });
        }

        for(var i = list.length; i < this.buttonList.length; i++){
            var button = this.buttonList[i];
            // this.buttonList[i].setVisible(false);
            this.guildList[i].setVisible(false);
            this.imgLiBao.removeChild(button);
        }
    },

    UpdatePanel:function () {
        var price = this.curData.GetFlagValue(EnumActivityFlag.F_NEW_PRICE);
        var power = this.curData.GetFlagValue(EnumActivityFlag.F_POWER);
        var show = this.curData.GetFlagValue(EnumActivityFlag.F_BACKGROUND);
        this.imgNumber.SetText(price);
        this.imgNumber2.SetText(power);
        // UIUtil.LoadImage(this.imgYiRongShu, "other/tehuilibao/word/" + show);
        this.UpdateView();
        this.UpdateReward();
    },

    UpdateView:function(){
        var top = this.curData.top;
        var str = "";
        var modelUrl;
        var modelX = 10;
        var modelY = 0;
        var modelAction = "stand5";
        var imgName = "";
        var scale = 1.2;
        switch (top){
            case 1:     //宝石
                str = "5级攻击宝石";
                modelUrl = "84";
                modelY = 100;
                imgName = "wuji";
                break;
            case 2:     //武器
                str = "干将剑";
                modelUrl = "54";
                imgName = "ganjiangjian";
                break;
            case 3:     //宝骑
                str = "宝骑直升丹";
                modelUrl = "roleshow/part/attendanthorse/5";
                modelAction = "stand";
                modelY = 90;
                modelX = 25;
                imgName = "baoqidan";
                break;
            case 4:     //易容
                str = "紫衣龙王";
                modelUrl = "roleshow/player/1124";
                modelAction = "stand";
                imgName = "zhengui";
                break;
            case 5:     //光羽
                str = "光羽";
                modelUrl = "roleshow/part/wing/103";
                modelAction = "stand";
                imgName = "guangyulibao";
                break;
            case 6:     //材料特惠礼包
                str = "材料礼包";
                modelUrl = "93";
                imgName = "baoqidan";
                modelY = 100;
                break;
            case 7:     //易容
                str = "东煌剑心";
                modelUrl = "roleshow/player/1128";
                modelAction = "stand";
                imgName = "zhengui";
                break;
            case 8:     //披风
                str = "墨云遮天";
                modelUrl = "roleshow/part/pifeng/1002";
                modelAction = "stand";
                imgName = "pifengguajian";
                modelX = 70;
                break;
            case 9:     //幻彩戒子
                str = "幻彩戒子";
                modelUrl = "111";
                imgName = "jiezhi";
                modelY = 100;
                break;
            case 10:     //披风
                str = "剑起微澜";
                modelUrl = "roleshow/part/pifeng/1003";
                modelAction = "stand";
                imgName = "shipin";
                break;
        }
        this.labZiShang.SetText(str);
        UIUtil.LoadImage( this.imgYiRongShu, TextUtil.ConectParam( "other/tehuilibao/word/{@}.png", [imgName] ));

        if( !this._showEffect ){
            this._showEffect = new MAnimationObject();
            this.imgModel.addChild(this._showEffect);
        }
        this._showEffect.x = modelX;
        this._showEffect.y = modelY;
        this._showEffect.scale = scale;
        this._showEffect.SetResUrlBase( "res/animation/effect/ui/" + modelUrl );
        this._showEffect.DoAction(modelAction, 0, EnumDefaultResType.NONE);
    },

    UpdateReward:function () {
        var awards = this.curData.GetRewardList();
        var len = awards.length;
        for(var i = 0; i < len; i++){
            var award = awards[i];
            var grid = this.awardList[i];
            if(!grid){
                grid = new MUIGrid();
                grid.retain();
                grid.ParseJson(this.gridKuang.jsonobj);
                grid.Init();
                this.imgDi.addChild(grid);
                this.awardList.push(grid);
            }
            grid.visible = true;
            GridUtil.SetItemGrid(grid, award);
        }

        for(var i = len; i < this.awardList.length; i++){
            this.awardList[i].visible = false;
        }
    },

    SetGouMaiBtnState:function () {
        var status = this.curData.status;
        if(status > 0){
            this.btnGouMai.setTitleText("立即购买");
            Filter.UnGray(this.btnGouMai);
        }else {
            this.btnGouMai.setTitleText("已领取");
            Filter.GrayScale(this.btnGouMai);
        }
    },

    UpdateSingleActivity:function (info) {
        for(var i = 0, len = this.activityList.length; i < len; i++){
            var ac = this.activityList[i];
            if(ac.activityId == info.activityId){
                ac.status = info.status;
                break;
            }
        }

        var list = ActivityUtil.GetListByCorrelation(this.activityList);
        this.UpdateButton(list);
        this.SetGouMaiBtnState();
        this.CheckIsAll();
    },

    CheckIsAll:function () {
        for(var i = 0, len = this.activityList.length; i < len; i++){
            var ac = this.activityList[i];
            if(ac.status > 0){
                this.isAll = false;
                break;
            }else {
                this.isAll = true;
            }
        }

        if(this.isAll){
            var panel = Mgr.map.miniMapPanel;
            panel.firstBtns.splice(panel.firstBtns.indexOf(panel.btnTehui), 1);
            panel.imgBtnBg.removeChild(panel.btnTehui);
            panel.ResetButtonPos();
        }
    },

    OnHide:function(){
        this._super();
        if( this._showEffect ){
            this._showEffect.Dispose();
            this._showEffect = null;
        }
    }
} );
TeHuiLiBaoPanelExt.PanelName = "TeHuiLiBaoPanelExt";
PanelClassDic["TeHuiLiBaoPanelExt"] = TeHuiLiBaoPanelExt;
