var XianShiHuiKuiMainExt = XianShiHuiKuiMain.extend ( {
	_className:"XianShiHuiKuiMainExt",
	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = 50;
	},

	Init:function () {
		XianShiHuiKuiMain.prototype.Init.call(this);
		this.btnHuiKui.setVisible(false);
		this.grid1.setVisible(false);
		this.lab1.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);

		this.rewardsArr = [];

		var self = this;
		this.btnClose.addClickEventListener(function (sender) {
			Mgr.uiMgr.HidePanel(self);
        });
		this.btnGouMai.addClickEventListener(function (sender) {
            if(self.activity.status != 1){
                return;
            }

            Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.activity.activityId, 1);
        });
    },

    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        isOpen = isOpen || false;
        this.mainPanelKey = mainPanelKey;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        var list = Mgr.dailyactivity.GetActivityByKey(this.mainPanelKey);
        this.activity = list[0];

        var need = this.activity.special[0].beanInfo.need;
        var cost = this.activity.special[0].beanInfo.gold;
        UIUtil.ConnectLabelHtmlText(this.lab1, [need]);
        UIUtil.ConnectLabelHtmlText(this.lab11, [cost]);

        var rewards = this.activity.GetRewardList();
        for(var i = 0; i < rewards.length; i++){
            if(!this.rewardsArr[i]){
                var grid = UIUtil.CloneUI(this.grid1);
                if(grid.parent){
                    grid.removeFromParent();
                }
                this.rewardsArr.push(grid);
                this.addChild(grid);
            }
            var grid = this.rewardsArr[i];
            GridUtil.SetItemGrid(grid, rewards[i]);
        }

        this.ResetGridPos();

        if(!this._timer){
            var leftTime = this.activity.endTime - parseInt(Mgr.login.GetServerTime()/1000);
            var str = TimeUtil.SecondToDHMS2(leftTime);
            this.imgTime1.SetText(str);
            this._timer = TimerUtil.TimeUpdate(function () {
                leftTime--;
                var str = TimeUtil.SecondToDHMS2(leftTime);
                this.imgTime1.SetText(str);
            }, this, 1, leftTime);
        }

        switch (this.activity.status){
            case 1:
                Filter.UnGray(this.btnGouMai);
                this.btnGouMai.setTouchEnabled(true);
                break;
            case 2:
                Filter.GrayScale(this.btnGouMai);
                this.btnGouMai.setTouchEnabled(false);
                break;
        }
    },

    ResetGridPos:function () {
        var contentWidth = 350;
        var offset = 0;
        if(this.rewardsArr.length == 1){
            var grid  = this.rewardsArr[0];
            grid.x = this.grid1.x + contentWidth / 2 - this.grid1.uiWidth;
            return;
        }else {
            offset = (contentWidth - this.rewardsArr.length * this.grid1.uiWidth) / (this.rewardsArr.length - 1);
        }
        offset = offset > 0 ? offset : 0;

        for(var i = 0; i < this.rewardsArr.length; i++){
            var grid  = this.rewardsArr[i];
            grid.x = this.grid1.x + (grid.uiWidth + offset) * i;
        }
    },
} );
XianShiHuiKuiMainExt.PanelName = "XianShiHuiKuiMainExt";
PanelClassDic["XianShiHuiKuiMainExt"] = XianShiHuiKuiMainExt;
