var DuihuanListExt = DuihuanList.extend ( {
	_className:"DuihuanListExt",
	ctor:function(){
		this._super();
	},

	Init:function () {
		var self = this;
        DuihuanList.prototype.Init.call(this);
		this.gridAward.removeFromParent();
		this.gridAward1.removeFromParent();
		this.btnGet.addClickEventListener(function (target) {
			if(self.detail.status == 1){
				// var itemInfoArr = JSON.parse(self.detail.special[0].beanInfo.items);
				// var holdNumArr = [];
				// for(var i = 0, len = itemInfoArr.length; i < len; i++){
				// 	var itemInfo = itemInfoArr[i];
				// 	holdNumArr[i] = parseInt(Mgr.backpack.GetItemNumber(itemInfo[0]) / itemInfo[1]);
				// }
				// holdNumArr.sort(function (a, b) { return a - b; });
				// var nowNum = self.detail.allTimes - self.detail.rewardTimes;
				// var maxNum = holdNumArr[0] > nowNum ? nowNum : holdNumArr[0];

				// AlertExt.Show( "你确定要兑换" + maxNum + "次吗？", TipsEnum.BUTTON_SURE_AND_FALSE, {
				// 	_onFunc:function(){
				// 		Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.detail.activityId, maxNum);
				// 	},
				// });
                Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.detail.activityId, 1);
			}
		});
		this.btnGet.setSwallowTouches(false);
	},
	SetData:function (info) {
		this.ClearImgList();
		this.awardList = [];

		this.detail = info;
		this.labCue.SetHtmlText(info.introduction + TextUtil.AddColor("（"+ info.rewardTimes+"/"+info.allTimes + "）", "2ed515"));

		var startX = this.gridAward.initX;
		if( info.special && info.special.length ){
			var exchange = info.special[0].beanInfo;
			var needItems = JSON.parse(exchange.items);
			for(var i = 0, len = needItems.length; i < len; i++){
				var grid = new MUIGrid();
				grid.ParseJson(this.gridAward.jsonobj);
				grid.Init();
				var item = ItemUtil.ItemIdToItem(needItems[i][0], needItems[i][1]);
				GridUtil.SetItemGrid(grid, item);
				grid.x = startX;
				startX += (this.gridAward.uiWidth + 2);
				this.imgList.addChild(grid);
				this.awardList.push(grid);
				grid.setSwallowTouches(false);
			}

			startX += 20;
			this.img1.visible = true;
			this.img1.x = startX;
			startX += this.img1.uiWidth + 20;
		}

		var awards = info.GetRewardList();
		if( awards ){
			for(var i = 0, len = awards.length; i < len; i++){
				var grid = new MUIGrid();
				grid.ParseJson(this.gridAward.jsonobj);
				grid.Init();
				var item = awards[i];
				GridUtil.SetItemGrid(grid, item);
				grid.x = startX;
				startX += (this.gridAward.uiWidth + 2);
				this.imgList.addChild(grid);
				this.awardList.push(grid);
				grid.setSwallowTouches(false);
			}
		}
		this.SetButtonStatus(info.status);
	},

	SetButtonStatus:function (status) {
		switch (status){
			case 0:
				this.btnGet.setTitleText("已兑换");
				Filter.GrayScale(this.btnGet);
				break;
			case 1:
				this.btnGet.setTitleText("兑换");
				Filter.UnGray(this.btnGet);
				break;
			case 2:
				this.btnGet.setTitleText("兑换");
				Filter.GrayScale(this.btnGet);
				break;
		}
	},

	ClearImgList:function () {
		if(this.awardList && this.awardList.length > 0){
			for(var i = 0; i < this.awardList.length; i++){
				var grid = this.awardList[i];
				this.imgList.removeChild(grid);
			}
		}
	}
} );
DuihuanListExt.PanelName = "DuihuanListExt";
PanelClassDic["DuihuanListExt"] = DuihuanListExt;
