var JinJieListExt = JinJieList.extend ( {
	_className:"JinJieListExt",
    awardList:null,
    // awardPanel:null,
	ctor:function(){
		this._super();
	},

    Init:function () {
	    var self = this;
        JinJieList.prototype.Init.call(this);
        this.gridAward.visible = false;
        this.btnGet.addClickEventListener(function (target) {
            if(self.detail.status == 1){
                Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.detail.activityId, 1);
            }
        });
        this.btnGet.setSwallowTouches(false);
    },
    SetData:function (info) {
        this.ClearImgList();
        this.awardList = [];

        // if(!this.awardPanel){
        //     this.awardPanel= new ccui.ListView();
        //     this.awardPanel.setSize(cc.size(this.imgList.uiWidth - this.btnGet.uiWidth - 50, this.imgList.uiHeight));
        //     this.awardPanel.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        //     this.awardPanel.setItemsMargin(2);
        //     this.awardPanel.setBounceEnabled(true);
        //     this.awardPanel.setScrollBarEnabled(false);
        //     this.awardPanel.x += 10;
        //     this.awardPanel.y -= 3;
        //     this.imgList.addChild(this.awardPanel);
        // }
        // this.awardPanel.removeAllItems();

        this.detail = info;
        this.labCue.SetHtmlText(info.introduction);
        var awards = info.GetRewardList();
        if( awards ){
            for(var i = 0, len = awards.length; i < len; i++){
                var grid = new MUIGrid();
                grid.ParseJson(this.gridAward.jsonobj);
                grid.Init();
                var item = awards[i];
                GridUtil.SetItemGrid(grid, item);
                this.imgList.addChild(grid);
                this.awardList.push(grid);
                grid.setSwallowTouches(false);
            }
        }
        this.SetGridPos();
        this.SetButtonStatus(info.status);
    },

    SetButtonStatus:function (status) {
        switch (status){
            case 0:
                this.btnGet.setTitleText("已领取");
                Filter.GrayScale(this.btnGet);
                break;
            case 1:
                this.btnGet.setTitleText("领奖");
                Filter.UnGray(this.btnGet);
                break;
            case 2:
                this.btnGet.setTitleText("领奖");
                Filter.GrayScale(this.btnGet);
                break;
        }
    },

    SetGridPos:function () {
        for(var i = 0, len = this.awardList.length; i < len; i++){
            var grid = this.awardList[i];
            grid.x = this.gridAward.x + (this.gridAward.uiWidth + 2) * i;
        }
    },

    ClearImgList:function () {
        if(this.awardList && this.awardList.length > 0){
            for(var i = 0; i < this.awardList.length; i++){
                var grid = this.awardList[i];
                this.imgList.removeChild(grid);
            }
        }
    },
} );
JinJieListExt.PanelName = "JinJieListExt";
PanelClassDic["JinJieListExt"] = JinJieListExt;
