var DebugPanelExt = DebugPanel.extend ( {
	_className:"DebugPanelExt",
	taijinum:1,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
	},

	Init:function(){
		DebugPanel.prototype.Init.call( this );

		var self = this;

		this.scrpanGM.visible = false;
		this.scrpanLog.visible = false;
		//动态代码面板
		this.btnCode.addClickEventListener(function (event){
			self.ChangePanel( self.btnCode );
		});
		//快捷GM命令面板
		this.btnCommand.addClickEventListener(function (event){
			self.ChangePanel( self.btnCommand );
		});
		//日志面板
		this.btnLog.addClickEventListener(function (event){
			self.ChangePanel( self.btnLog );
		});

		this.btnClose.addClickEventListener( function(){
			Mgr.uiMgr.HidePanel(self);
		});
		//动态执行代码 主要用于实时修改变量值 打印日志等 方便调试
		this.btnRunCode.addClickEventListener( function(){
			var codeStr = self.editCode.GetText();
			try{
				if( codeStr ){
					eval(codeStr);
				}
			}
			catch (err){
				cc.log( "执行代码异常：" );
				cc.log( err + "  ----- >  " + codeStr );
			}
		});

		var self = this;
		//-------------------------------------	添加一些常用GM测试命令 免得手机不方便输入
		this.btnLevel.addClickEventListener( function(){
//			var command = "&level " + ( Mgr.player.mainPlayer.attributeData.level + 10 );
			var command = "&tjzd " + self.taijinum + " " + 5;
			Mgr.gm.SendReqGmCommandMessage( command );
			self.taijinum++;
		});
		//-------------------------------------	End

	},

	TextFieldEvent: function (textField, type) {
		switch (type) {
			case ccui.TextField.EVENT_ATTACH_WITH_IME:
				var self = this;
				this.inputListener = cc.EventListener.create({event: cc.EventListener.KEYBOARD,
					onKeyPressed:function( keyCode, event ){
						self.OnKeyDown.call(self, keyCode, event);
					}
				});
				cc.eventManager.addListener( this.inputListener,this.editCode);
				break;
			case ccui.TextField.EVENT_DETACH_WITH_IME:
				if( this.inputListener )
					cc.eventManager.removeListener( this.inputListener );
				this.inputListener = null;
				break;
			default:
				break;
		}
	},

	OnKeyDown:function( keyCode, event ){
		if( keyCode == cc.KEY.enter ){
			this.editCode.SetText(this.editCode.GetText() + "\n");
		}
	},

	ChangePanel:function(btn){
		this.scrpanGM.visible = false;
		this.scrpanPanel.visible = false;
		this.scrpanLog.visible = false;
		this.btnRunCode.visible = false;
		switch (btn){
			case this.btnCode:
				this.scrpanPanel.visible = true;
				this.btnRunCode.visible = true;
				break;
			case this.btnLog:
				this.scrpanLog.visible = true;
				cc.log(Profiler.GetLogStr(true));
				break;
			case this.btnCommand:
				this.scrpanGM.visible = true;
				break;
		}
	}
} );
DebugPanelExt.PanelName = "DebugPanelExt";
PanelClassDic["DebugPanelExt"] = DebugPanelExt;
