﻿var DropModMgr = DropModMgr || cc.Class.extend({ 
	_dropZoneModelid:0,
		_dropMapModelid:0,
		_dropSimpleItemInfos:null,
    uniqueId:null,

	dropItemList:null,
    delayTime:null,


	ctor:function() {
		this.dropItemList = [];
	},

	ClearZoneDrop:function () {
		this._dropZoneModelid = 0;
		this._dropMapModelid = 0
		this._dropSimpleItemInfos = null;
	},

	GetDropSimpleItemInfos:function (zoneModelId) {
		if( zoneModelId == this._dropZoneModelid ){
			var itemHash = new HashMap();
			if( this._dropSimpleItemInfos ){
				for (var i = 0; i < this._dropSimpleItemInfos.length ; i ++){
					var iteminfo = itemHash.Get(this._dropSimpleItemInfos[ i ].itemModelId);
					if(iteminfo == null){
						itemHash.Put(this._dropSimpleItemInfos[ i ].itemModelId, this._dropSimpleItemInfos[ i ]);
					}else{
						iteminfo.num += this._dropSimpleItemInfos[ i ].num;
						itemHash.Put(iteminfo.itemModelId, iteminfo);
					}
				}
			}
			return itemHash.Values();
		}else{
			return null;
		}
	},

	AddDropItemFlyToPlayer:function(item, length){
        // this.delayTime += 0.2;
        var pushV = false;
        var grid = null;
        for(var i = 0; i < this.dropItemList.length; i++){
            if(!this.dropItemList[i].isShow){
                grid = this.dropItemList[i];
                pushV = true;
            }
        }

        if(!pushV){
            var newGrid = new MUIGrid();
            var json = {"images":["public/grid/xiaokuang.png"],
                "backgroundType":0,
                "type":"Grid",
                "childs":[],
                "AnchorPoint":{"ScaleX":0,"ScaleY":0},
                "id":"gridAward",
                "tipsId":"",
                "Size":{"Y":62,"X":62},
                "bindData":{},
                "Position":{"Y":200,"X":90}};
            newGrid.ParseJson(json);
            newGrid.Init();
            newGrid.isShow = true;
            // Mgr.uiMgr.addChild(newGrid, 100000);
            Mgr.sceneLayer.AddBottom(newGrid);
            this.dropItemList.push(newGrid);
            grid = newGrid;
        }
        grid.setScale(0.3);
        grid.isShow = true;
        grid.visible = true;
        var width = 0.8*grid.uiWidth;
        // grid.x = ToolBase.GetWinWidth()/2 - grid.uiWidth*length/2 + grid.uiWidth*item.pos;
        // grid.y = ToolBase.GetWinHeight()/2 - 200;
        grid.x = Mgr.mainPlayer.x - width*5/2 + width*(item.pos%5);
        grid.y = Mgr.mainPlayer.y - 100 + width*(Math.ceil(item.pos/5));
        var coinInfo = {};
        coinInfo.itemModelId = item.itemModelId;
        coinInfo.itemNum = item.num;
        coinInfo.itemBind = item.isbind;
        GridUtil.SetItemGrid(grid, coinInfo);
        var delay = new cc.DelayTime(4);
        // var action1 = new cc.MoveBy(0.5, cc.p(0, 100));
        // var action2 = new cc.MoveTo(1, cc.p(ToolBase.GetWinWidth()/2, ToolBase.GetWinHeight()/2));
        var action2 = new cc.MoveTo(1, cc.p(Mgr.mainPlayer.x, Mgr.mainPlayer.y + 50));
        var action3 = cc.scaleTo(1, 0.5);
        var mySpawn = cc.spawn(action2, action3);

        var action = cc.sequence([delay, mySpawn,
            new cc.CallFunc(function(){
                grid.isShow = false;
                grid.Clean();
                grid.visible = false;
                // this.delayTime -= 0.2;
                // if(this.delayTime < 0)
                //     this.delayTime = 0;
            }, this)
        ]);
        grid.runAction(action);
	},

	RecvResDropBackpackToClientMessage:function (msg) {
		cc.log("======RecvResDropBackpackToClientMessage=======")
		var itemInfo = msg.simpleItemInfos;
		for(var i = 0; i < itemInfo.length; i++){
			var item = {itemModelId:itemInfo[i].itemModelId, num:itemInfo[i].num, pos:i};
			this.AddDropItemFlyToPlayer(item,  itemInfo.length);
		}
		if(this._dropSimpleItemInfos && this._dropZoneModelid == msg.zoneModelid && this._dropMapModelid == msg.mapModelid){
			this._dropSimpleItemInfos = this._dropSimpleItemInfos.concat(msg.simpleItemInfos);
		}else{
			this._dropSimpleItemInfos = msg.simpleItemInfos;
		}
		this._dropZoneModelid = msg.zoneModelid;
		this._dropMapModelid = msg.mapModelid;

		if(Mgr.uiMgr.IsPanelShowByName(FubenWinExt.PanelName)){
			Mgr.uiMgr.GetPanelByType(FubenWinExt.PanelName).UpdateRaward();
		}
		if(Mgr.uiMgr.IsPanelShowByName(WendingCueExt.PanelName)){
			Mgr.uiMgr.GetPanelByType(WendingCueExt.PanelName).UpdateRaward();
		}
	},

	RecvResDropRollItemInfoMessage:function(msg) {
		cc.log("发送Roll点物品信息")
		this.uniqueId = msg.rollInfo.uniqueId;
        var panel = EngineMgr.uiMgr.ShowPanelByType(BossRollPanelExt.PanelName);
        panel.SetData(msg.rollInfo);
	},

    RecvResRollPointResultMessage:function(msg){
		if(msg.uniqueId.Equal(this.uniqueId))
        	Mgr.tips.ShowNotice("您本次投掷出" + TextUtil.AddColor(msg.point, "0x01ab25") + "点");
	},

    RecvResRollItemMaxPointInfoMessage:function(msg){
        // cc.log("发送Roll点最大的玩家信 （广播） " + msg.point)
        // cc.log(msg.uniqueId  +  "  "  + this.uniqueId)
        // if(msg.uniqueId.Equal(this.uniqueId))
        //     Mgr.tips.ShowNotice("恭喜" + msg.playername + "投掷最大点数" + TextUtil.AddColor(msg.point, "0x01ab25") + "获得礼包");
	},

	SendReqRollPointMessage:function(uniqueId, type) {
		var msg = new ReqRollPointMessage();
		msg.uniqueId = uniqueId;
		msg.type = type;
        Mgr.msgMgr.Send(msg);
	}
});