var JinglianMainExt = JinglianMain.extend ( {
	_className:"JinglianMainExt",

	_gridArr : null,
	_stoneGridArr :null,
	AutoRefine : null,

	_curSelector:null,

	_sendProp:null,

	// effect
	effects:null,

	ctor:function(){
		this._super();
		this.AutoRefine = false;
		this._sendProp = false;
		this.effects = [];
	},

	Init:function() {
		var self = this;
		JinglianMain.prototype.Init.call(this);

		this._InitParam();

		this.btnRefine.addClickEventListener(function (event){   // 精炼
			self._ChangeAutoRefineState(false);
			self.AutoRefineHeader();
		});
		this.btnAutoRefine.addClickEventListener(function (event){  //自动精炼
			self._ChangeAutoRefineState(true);
			self.AutoRefineHeader();
		});
		this.btnQuxiao.addClickEventListener(function (event){  //自动精炼
			self._ChangeAutoRefineState(false);
		});

		this.AddEffect();
	},
    InitSubTabConfig:function(){
        return [
            { type : EnumItemType.Equip	,text : "角色" },
            { type : EnumItemType.Equip_Shutong	,text : "书童" },
        ]
    },
    OnShow:function(){
        this._super();
        this.AddEffect();
    },
    OnHide:function(){
        this._super();
        this.StopEffect();
    },
	AddEffect:function () {
		// effect
		var url = "other/duanzhao/image/effect/refine/star.png";
		var effect_star = ParticleEffect.Create(this.imgEffect,url,3,800,40,80);
		effect_star.SetFade(0.2,0.6);
		effect_star.SetMove(1);
		effect_star.Play();
		this.effects.push(effect_star);

		var url = "other/duanzhao/image/effect/refine/fogray.png";
		var effect_forray = ParticleEffect.Create(this.imgEffect,url,3,800,40,60);
		effect_forray.SetFade(0.3,0.7);
		effect_forray.SetMove(1);
		effect_forray.Play();
		this.effects.push(effect_forray);

		url = "other/duanzhao/image/effect/refine/fog.png";
		var effect_flog = ParticleEffect.Create(this.imgEffect1,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(30,0);
		effect_flog.Play();
		this.effects.push(effect_flog);

		effect_flog = ParticleEffect.Create(this.imgEffect1,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(160,0);
		effect_flog.Play();
		this.effects.push(effect_flog);

		// rotate
		this.imgWai.setAnchorPoint(0.5,0.5);
		this.imgWai.setPosition(this.orginPt1);
		var act1 = cc.RotateBy(1.0, -10);
		this.imgWai.runAction(cc.repeatForever(act1));

		this.imgNei.setAnchorPoint(0.5,0.5);
		this.imgNei.setPosition(this.orginPt2);
		var act2 = cc.RotateBy(1.0, 30);
		this.imgNei.runAction(cc.repeatForever(act2));

	},

	StopEffect:function () {
		for ( var i = 0; i != this.effects.length; i++ ) {
			this.effects[i].Dispose();
		}
		this.effects = [];
		this.imgWai.stopAllActions();
		this.imgNei.stopAllActions()
	},
	_ChangeAutoRefineState:function (auto) {
		this.btnRefine.visible = !auto;
		this.btnAutoRefine.visible = !auto;
		this.AutoRefine = auto;
	},

	SetData:function (itemType) {
        itemType = itemType || this._itemType;
        this._itemType = itemType;

        this.SetEquips();
		//获取装备精炼信息
		//var idArr = JSON.parse( Q_global.Get( 1006 ).q_string_value );
//		Mgr.equipRefine.SendReqEquipRefineInfoToGameMessage(EnumItemType.Equip/*parseInt(idArr[0])*/ );   // 装备精炼系统类型（其实就是资源线类型 -1为人物装备 ，0表示发送所有装备精炼信息）
		Mgr.equipRefine.SendReqEquipRefineInfoToGameMessage(-1/*parseInt(idArr[0])*/ );   // 装备精炼系统类型（其实就是资源线类型 -1为人物装备 ，0表示发送所有装备精炼信息）
	},

	AutoRefineHeader:function () {
		var equipV = this.gridItem.equipV;
		if ( !equipV ) {
			this.AutoRefine = false;
			Mgr.tips.ShowNotice( "请选者一件装备");
			return;
		}
		var mark = DuanzaoUtil.GetRefineMark( equipV.itemModelId )
		if ( mark == RefineMrakEnum.UN_BAGNUM ) {
			this.AutoRefine = false;
			Mgr.tips.ShowNotice( "没有可用的精炼石");
			this._ChangeAutoRefineState(false);
			return;
		}
		if ( mark == RefineMrakEnum.MAX_REFINE ) {
			this.AutoRefine = false;
			Mgr.tips.ShowNotice( "精炼已满，提升装备品质可以继续精炼");
			this._ChangeAutoRefineState(false);
			return;
		}
		if ( mark == RefineMrakEnum.MAX_REFINE_AND_QUILITY ) {
			this.AutoRefine = false;
			Mgr.tips.ShowNotice( "精炼已至极限");
			this._ChangeAutoRefineState(false);
			return;
		}

		var sysType = this._itemType; // 装备精炼系统类型（其实就是资源线类型 -1为人物装备）
		var equipLocation = Q_item.Get( equipV.itemModelId ).q_kind; // 装备子类型
		var itemIds = []; // 精炼道具唯一ID long
		var hash = DuanzaoUtil.GetRefineStoneHash( equipV.itemModelId );
		var list = hash.Values();
		for ( var i = 0; i != list.length; i++ ) {
			if ( list[i].maxNum >= list[i].usedNum ) {
				var bagList = Mgr.backpack.GetItemsByMid( list[i].item.q_id, true );
				for ( var j = 0; j != bagList.length; j++ ) {
					itemIds.push( bagList[j].itemId);
				}
			}
		}
		Mgr.equipRefine.SendReqEquipRefineChangeToGameMessage( sysType, equipLocation, itemIds );
	},

	_InitPosition:function()
	{
		this.x = 0;
		this.y = 0;
	},

	_InitParam:function() {
		this._InitPosition();

		this.lab1.SetString("");
		this.imgtanhao.visible = false;
		this.labName.SetString("");
		this.labNumber.visible = false;
		this.labLevel.visible = false;
		this.labGongji1.SetString("");
		this.labFangyu1.SetString("");
		this.labHp1.SetString("");
		this.imgNumber.SetString(0);
		this.imgSelect.visible = false;

		this.orginPt1 = cc.p(this.imgWai.x + this.imgWai.width/2, this.imgWai.y + this.imgWai.height/2);
		this.orginPt2 = cc.p(this.imgNei.x + this.imgNei.width/2, this.imgNei.y + this.imgNei.height/2);

		this._SetGridBindType();
		this._SetLabelLink();
	},

	_SetGridBindType:function () {
		//equip grid enum
		this._gridArr = [
			{obj:this.gridEquip1,type:EnumEquipPos.EQUIP_WEAPONS},//武器0
			{obj:this.gridEquip2,type:EnumEquipPos.EQUIP_CLOTHES},//衣服1
			{obj:this.gridEquip3,type:EnumEquipPos.EQUIP_BRACELET_LEFT},//护手
			{obj:this.gridEquip4,type:EnumEquipPos.EQUIP_HUFU_LEFT}, //左护符6
			{obj:this.gridEquip5,type:EnumEquipPos.EQUIP_RING_LEFT}, //左戒指8
			{obj:this.gridEquip6,type:EnumEquipPos.EQUIP_BELT},//腰带3
			{obj:this.gridEquip7,type:EnumEquipPos.EQUIP_HUTUI},//护腿
			{obj:this.gridEquip8,type:EnumEquipPos.EQUIP_SHOES}, //鞋子5
			{obj:this.gridEquip9,type:EnumEquipPos.EQUIP_HUFU_RIGHT}, //右护符7
			{obj:this.gridEquip10,type:EnumEquipPos.EQUIP_RING_RIGHT} //右戒指9
		];
		//stone grid enum
		this._stoneGridArr = [
			{obj:this.gridItem2, type:StoneAttributeEnum.ATTACK},//攻击
			{obj:this.gridItem3,type:StoneAttributeEnum.DEFENSE},//防御
			{obj:this.gridItem4,type:StoneAttributeEnum.HP} //生命
		];
	},

	// label链接
	_SetLabelLink:function () {
		//帮会副本链接
		this.labCue1.setTouchEnabled(true);
		this.labCue1.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);

				var _type = GuildEnum.PANEL_LIST;
				if ( !Mgr.player.mainPlayer.guildId.IsZero() )
					_type = GuildEnum.PANEL_BOSS;
				Mgr.uiMgr.ShowPanelByType(GuildPanelExt.PanelName).ChangePanel(_type);
				Mgr.uiMgr.HidePanelByType(DuanzaoPanelExt.PanelName);
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});

		//获取途径
		this.labCue2.setTouchEnabled(true);
		this.labCue2.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);
				EngineMgr.uiMgr.ShowPanelByType(EquipGetExt.PanelName,UIMgr.PANEL_LAYER_TOP);
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});
	},

	SetEquips:function()
	{
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			var equipV = Mgr.equip.GetEquipByType(this._itemType,this._gridArr[i].type);
			this._SetEquip( this._gridArr[i].obj, equipV );

			// 及时更新部位装备 , 更换装备的情况
			if ( this.gridItem.equipV ) {
				var temp = Q_item.Get(this.gridItem.equipV.itemModelId);
				if ( temp.q_kind == this._gridArr[i].type )
					this.gridItem.equipV = equipV;
			}
		}

		if ( this.gridItem.equipV )
			this.SetCenterEquip();
		else
			this._AutoSelect();
		this.UpdataWarn();
	},

	_AutoSelect:function () {
		var _equipV = null;
		var _grid = null;
		var _bestSelArr = [];
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			var grid = this._gridArr[i].obj;
			var data = grid.equipV;
			// no exist
			if ( !data )
				continue;

			// 默认选着一个
			if ( _equipV == null ) {
				_equipV = data;
				_grid = grid;
			}

			// 是否还能精炼
			if ( DuanzaoUtil.IsEnableRefine( data.itemModelId ) )
				_bestSelArr.push( [data,grid] );
		}

		// 如果存在优选装备
		if ( _bestSelArr.length > 0 ) {
			_equipV = _bestSelArr[0][0];
			_grid = _bestSelArr[0][1];

			// for (var i = 0; i != _bestSelArr.length; i++) {
			// 	_equipV = ( _equipV.strenthenLv > _bestSelArr[i].strenthenLv ) ? _bestSelArr[i] : _equipV;
			// }
		}

		this.gridItem.equipV = _equipV;
		this.SetCenterEquip();

		// select effect
		if ( _grid ) {
			// 清除上一次效果
			if ( this._curSelector )
				this._SetSelectEffect(this._curSelector, false)
			this._curSelector = _grid;
			this._SetSelectEffect( _grid, true )
		}
	},

	_SetSelectEffect:function (grid, visible) {
		if ( !grid.select ) {
			var icon = new MUIImage();
			icon.ParseJson(this.imgSelect.jsonobj);
			icon.Init();
			icon.setPosition(this.imgSelect.getPosition());
			grid.addChild(icon);
			grid.select = icon;
		}
		grid.reorderChild(grid.select, 3);
		grid.select.visible = visible;
	},

	_SetEquip:function ( grid, equipV ) {
		grid.Clean();
        grid.equipV = equipV;
		if ( equipV ) {
			// ico
			// var icon = ItemUtil.GetItemIcon(equipV.itemModelId, ResUrl.ITEM_SIZE_60)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = equipV.itemModelId;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);

			// level
//			if (equipV.strenthenLv > 0) {
//
//				var level = new MUILabel();
//				level.ParseJson(this.lab1.jsonobj);
//				level.Init();
//				var str = "+" + String(equipV.strenthenLv);
//				level.SetString(str);
//				level.setPosition(this.lab1.getPosition());
//				grid.AddDisplay(level);
//			}
		}
		// callback
		var self = this;
		grid.setTouchEnabled(true);
		grid.addTouchEventListener(function (sender, type) {
			if (type == ccui.Widget.TOUCH_ENDED) {
				if ( sender.equipV ) {
					if ( self._curSelector )
						self._SetSelectEffect( self._curSelector, false );

					self._curSelector = sender;
					self._SetSelectEffect( sender, true )

					self.gridItem.equipV = sender.equipV;
					self.SetCenterEquip();
				}
				else
					Mgr.tips.ShowNotice( "没有装备!");
			}
		});
	},

	SetCenterEquip:function () {
		var grid = this.gridItem;
		grid.Clean();
		if ( grid.equipV ) {
			// name
			var equipC = Q_item.Get( grid.equipV.itemModelId );
			cc.assert(null != equipC, "data is unexist in Q_item!  itemModelId: " + grid.equipV.itemModelId);
			this.labName.SetString( equipC.q_name );
			var color=ItemUtil.GetNameColorById(grid.equipV.itemModelId);
			if(color)
				this.labName.SetColor(color[0]);

			// icon
			// var icon = ItemUtil.GetItemIcon(grid.equipV.itemModelId)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = grid.equipV.itemModelId;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);
			grid.equipV = grid.equipV;

			// callback
			var self = this;
			grid.setTouchEnabled(true);
			grid.addTouchEventListener(function (sender, type) {
				if (type == ccui.Widget.TOUCH_ENDED) {
					var item = ItemUtil.ItemInfoToItem(sender.equipV);
					GridUtil.SetGridInteraction( sender, GridInteractionType.ITEMSHOW, item );
				}
			});
			this._SetStones();
		}
	},

	_SetStones:function () {
		var fighting = 0;
		var equipV = this.gridItem.equipV;
		if ( equipV ) {
			var stoneHash = DuanzaoUtil.GetRefineStoneHash( equipV.itemModelId );
			for ( var i = 0; i != this._stoneGridArr.length; i++ ) {
				var type = this._stoneGridArr[i].type;
				var obj = stoneHash.Get( parseInt( type ) );
				if ( obj ) {
					var grid = this._stoneGridArr[i].obj;
					grid.Clean();

					var equipC = Q_item.Get( equipV.itemModelId );
					// icon

					// var icon = ItemUtil.GetItemIcon(obj.item.q_id, ResUrl.ITEM_SIZE_46)
					// icon.x = (grid.uiWidth - icon.width) / 2;
					// icon.y = (grid.uiHeight - icon.height) / 2;
					// grid.SetGridIcon(icon);
                    var coinInfo = {};
                    coinInfo.itemModelId = obj.item.q_id;
                    // coinInfo.itemNum = price;
                    // coinInfo.itemBind = itemInfo.q_bind;
                    GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);
					var data = { quility:equipC.q_rank, equipLocation:equipC.q_kind, stoneLocation:obj.item.q_location, mid:obj.item.q_id };
					grid.data = data;

					// callback
					var self = this;
					grid.setTouchEnabled(true);
					grid.addTouchEventListener(function (sender, type) {
						if (type == ccui.Widget.TOUCH_ENDED) {
							var panel = Mgr.uiMgr.ShowPanelByType(JinglianRefineStoneExt.PanelName);
							panel.SetDate(sender.data.quility, sender.data.equipLocation, sender.data.stoneLocation);

							// pos
							var pt = cc.p( sender.x + sender.width + 20, sender.y + sender.height + 10 );
							pt = UIUtil.LocalToGlobel( self, pt, Mgr.uiMgr.GetLayerByType(panel.showLayerType) );
							panel.setAnchorPoint(0, 1);
							panel.x = pt.x;
							panel.y = pt.y;
						}
					});

					// num
                    var labNumber = UIUtil.CloneUI(this.labNumber);
                    grid.AddDisplay(labNumber);
                    labNumber.SetText(obj.usedNum + "/" + obj.maxNum);

                    var labLevel = UIUtil.CloneUI(this.labLevel);
                    grid.AddDisplay(labLevel);
                    labLevel.SetText(obj.bagNum);

					// attr
					var attrV = DuanzaoUtil.GetAttributeV(obj.item.q_id, 0);
					var attr = attrV.value * obj.usedNum;
					if (this._stoneGridArr[i].type == StoneAttributeEnum.ATTACK) {  //攻击
						this.labGongji1.SetString(attr);
					}
					if (this._stoneGridArr[i].type == StoneAttributeEnum.DEFENSE) {  // 防御
						this.labFangyu1.SetString(attr);
					}
					if (this._stoneGridArr[i].type == StoneAttributeEnum.HP) {  // 生命
						this.labHp1.SetString(attr);
					}

					// figjting
					var fo = Mgr.attributeMgr.GetAttributeRate(attrV.type, 0);
					if (fo)
						fighting += parseInt(fo * attrV.value * obj.usedNum);
				}
			}
		}
		// fighting
		this.imgNumber.SetString(fighting);
	},

	UpdataWarn:function () {
		for ( var i = 0; i != this._gridArr.length; i++ ) {
			var boo = false;
			var grid = this._gridArr[i].obj;
			if ( grid.equipV ) {
				if (DuanzaoUtil.IsEnableRefine(grid.equipV.itemModelId))
					var isExist = boo = true;
			}

			this._SetGridState( grid, boo );
		}
	},

	_SetGridState:function ( widget, boo ) {
		if ( !widget.warn ) {
			var icon = new MUIImage();
			icon.ParseJson(this.imgtanhao.jsonobj);
			icon.Init();
			icon.setPosition(this.imgtanhao.getPosition());
			widget.addChild(icon);
			widget.warn = icon;
		}
		widget.reorderChild(widget.warn, 10);
		widget.warn.visible = boo;
	},
} );
JinglianMainExt.PanelName = "JinglianMainExt";
PanelClassDic["JinglianMainExt"] = JinglianMainExt;
