var XiangqianMainExt = XiangqianMain.extend ( {
	_className:"XiangqianMainExt",

	_gridArr : null,
	_gridArr1:null,
	_smallGridArr : null,
	_stoneGridArr : null,

	_curSelector:null,

	// effect
	effects:null,

	ctor:function(){
		this._super();

		this._gridArr = [];
		this._gridArr1 = {};
		this._smallGridArr = [];
		this._stoneGridArr = [];
		this.effects = [];
	},

	Init:function()
	{
		XiangqianMain.prototype.Init.call(this);
		this._InitParam();
	},
    InitSubTabConfig:function(){
        return [
            { type : EnumItemType.Equip	,text : "角色" },
            { type : EnumItemType.Equip_Shutong	,text : "书童" },
        ]
    },
    OnShow:function(){
        this._super();
        this.AddEffect();
    },
    OnHide:function(){
        this._super();
        this.StopEffect();
    },
	AddEffect:function () {
		// effect
		var url = "other/duanzhao/image/effect/inlay/star.png";
		var effect_star = ParticleEffect.Create(this.imgEffect1,url,1,300,90,120);
		effect_star.SetRotate(1.0 , 30);
		effect_star.SetFade(0.2,0.6);
		effect_star.SetRadiusRandomShow();
		effect_star.Play();
		this.effects.push(effect_star);

		url = "other/duanzhao/image/effect/inlay/fog.png";
		var effect_flog = ParticleEffect.Create(this.imgEffect2,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(30,0);
		effect_flog.Play();
		this.effects.push(effect_flog);

		effect_flog = ParticleEffect.Create(this.imgEffect2,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(160,0);
		effect_flog.Play();
		this.effects.push(effect_flog);

		var effect_ani = new MAnimationObject();
		effect_ani.sResUrlBase = "res/animation/swf/duanzao/1/";
		effect_ani.DoAction("stand5", 0, EnumDefaultResType.NONE);
		this.imgEffect3.addChild(effect_ani,0, 100);
		this.effects.push(effect_ani);

		// // animal
		// var effect_ani = AnimationEffect.Create(this.imgEffect,12);
		// effect_ani.Play();
	},

	StopEffect:function () {
		for ( var i = 0; i != this.effects.length; i++ ) {
			this.effects[i].Dispose();
		}
		this.effects = [];
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			var grid = this._gridArr[i];
			this._EndWarn(grid);
		}
	},

	_InitPosition:function() {
		this.x = 0;
		this.y = 0;
	},

	_InitParam:function(){
		this._InitPosition();
		this._SetLabelLink();
		this._SetGridBindType();

		this.imgGantanhao.visible = false;
		this.lab1.visible = false;
		this.imgQianghua.visible = false;
		this.imgSelect.visible = false;

		this.imgGantanhao1.visible = false;
		this.labLv.visible = false;
		this.labLv2.visible = false;
		this.labLv3.visible = false;

        this.imgJia.visible = false;
        this.imgJia1.visible = false;
        this.imgJia2.visible = false;
        this.gridItem2._imgJia = this.imgJia;
        this.gridItem1._imgJia = this.imgJia1;
        this.gridItem3._imgJia = this.imgJia2;

		this.imgUnOpen.visible = false;
		this.labEquipName.visible = false;
//		this.labGongji.visible = false;

		this.gridIcon.visible = false;
		this.gridIcon1.visible = false;
		this.gridIcon2.visible = false;
		this._smallGridArr = [ this.gridIcon, this.gridIcon1, this.gridIcon2 ];

//		this.btnShengji.visible = false;
//		this.btnXiangqian.visible = false;
//		this.btnXiangqian1.visible = false;
	},

	_SetGridBindType:function () {
		 //  equip grid enum
		 this.gridEquip1.equipType = EnumEquipPos.EQUIP_WEAPONS;
		 this.gridEquip2.equipType = EnumEquipPos.EQUIP_CLOTHES;
		 this.gridEquip3.equipType = EnumEquipPos.EQUIP_BRACELET_LEFT;
		 this.gridEquip4.equipType = EnumEquipPos.EQUIP_HUFU_LEFT;
		 this.gridEquip5.equipType = EnumEquipPos.EQUIP_RING_LEFT;
		 this.gridEquip6.equipType = EnumEquipPos.EQUIP_BELT;
		 this.gridEquip7.equipType = EnumEquipPos.EQUIP_HUTUI;
		 this.gridEquip8.equipType = EnumEquipPos.EQUIP_SHOES;
		 this.gridEquip9.equipType = EnumEquipPos.EQUIP_HUFU_RIGHT;
		 this.gridEquip10.equipType = EnumEquipPos.EQUIP_RING_RIGHT;
		 this._gridArr = [this.gridEquip1,this.gridEquip2,this.gridEquip3,this.gridEquip4,this.gridEquip5,
			 this.gridEquip6,this.gridEquip7,this.gridEquip8,this.gridEquip9,this.gridEquip10];

		// stone grid enum
		this.gridItem1.stoneType = StoneAttributeEnum.ATTACK;
		this.gridItem2.stoneType = StoneAttributeEnum.HP;
		this.gridItem3.stoneType = StoneAttributeEnum.DEFENSE;
		this._stoneGridArr = [this.gridItem1, this.gridItem2, this.gridItem3];

        var stoneAttr = [StoneAttributeEnum.ATTACK,StoneAttributeEnum.HP,StoneAttributeEnum.DEFENSE];
        var btnsTihuan = [this.imgTiHuan,this.imgTiHuan1,this.imgTiHuan2];
        var btnsChaixie = [this.imgChaiXie,this.imgChaiXie1,this.imgChaiXie2];
        var gridItems = [this.gridItem1,this.gridItem2,this.gridItem3];
        for(var i=0;i<3;i++){
            btnsTihuan[i]._stoneType = stoneAttr[i];
            btnsChaixie[i]._stoneType = stoneAttr[i];
            gridItems[i]._stoneType = stoneAttr[i];

            btnsTihuan[i].setTouchEnabled(true);
            btnsChaixie[i].setTouchEnabled(true);
            gridItems[i].setTouchEnabled(true);
            gridItems[i].addClickEventListener(this._OnBtnClicked_Tihuan.bind(this,false));
            btnsTihuan[i].addClickEventListener(this._OnBtnClicked_Tihuan.bind(this,true));
            btnsChaixie[i].addClickEventListener(this._OnBtnClicked_ChaiXie.bind(this));
        }

        this.labAttrs = {}
        this.labAttrs[StoneAttributeEnum.ATTACK] = this.labGongji;
        this.labAttrs[StoneAttributeEnum.HP] = this.labShengMing;
        this.labAttrs[StoneAttributeEnum.DEFENSE] = this.labFangYu;

        // 装备按钮事件监听
        for(var k=1;k<=10;++k){
            this["imgDi" + k].index = k - 1;
            this["imgDi" + k].setTouchEnabled(true);
            this["imgDi" + k].addClickEventListener(this._OnBtnClicked_Equip.bind(this));
        }

        this.gridItem.setTouchEnabled(true);
        this.gridItem.addClickEventListener(function (sender) {
            var equipType = sender.equipType;
            var gem = Mgr.gem.GetInlayStonesExt(this._itemType,equipType);
            var refine = DuanzaoUtil.GetRefineStoneHash(sender.equipV.itemModelId);
            var equips = Mgr.equip.GetEquipsByType(EnumItemType.Equip);
            var suit = SuitMakeUtil.GetSuitAttr(equips);
            var panel = Mgr.uiMgr.ShowPanelByType(EquipTipsPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
            panel.setLocalZOrder(10000);
            panel.Updatedata(sender.equipV, GridTypeEnum.EQUIP, {gem: gem, refine: refine, suit: suit});
        }.bind(this));

        // 创建界面
        //var children = this.gridEquip1.getChildren();
        //var length = children.length;

        //for(var k=1;k<=10;++k){
        //    var gridItem = this["gridEquip" + k]
        //    for(var kk=0,vv=children[kk];kk<length;vv = children[++kk]){
        //        if(!vv.id) continue;
        //        if(k != 0) {
        //            var obj = Mgr.uiMgr.CloneUI(vv);
        //            gridItem.addChild(obj);
        //            gridItem[vv.id] = obj;
        //        }else{
        //            gridItem[vv.id] = vv;
        //        }
        //    }
        //}
    },

    ///选中装备
    _OnBtnClicked_Equip:function(sender){
        var index = sender.index;
        var gridEquip = this._gridArr[index];
        var equipType = gridEquip.equipType;

        if ( gridEquip.equipV ) {
            if ( this._curSelector )
                this._SetSelectEffect( this._curSelector, false )

            this._curSelector = gridEquip;
            this._SetSelectEffect( gridEquip, true );

            this.gridItem.equipV = gridEquip.equipV;
            this.gridItem.equipType = gridEquip.equipType;
            this.SetCenterEquip();
        }
        //else
        //    Mgr.tips.ShowNotice( "没有装备!");
    },
    /// 宝石替换/更换
    /// @canTihuan 增加可选，装备按钮在宝石顶级的时候不能弹出替换，替换按钮能
    _OnBtnClicked_Tihuan:function(canTihuan,sender){
        var stoneType = sender._stoneType;
        var equipType = this.gridItem.equipType;

        var equipGrid = this._GetEquipGridByType(equipType);
        var equipV = equipGrid.equipV;

        if ( !equipV ) {
            Mgr.tips.ShowNotice( "请选择一件装备");
            return;
        }

        var markV = DuanzaoUtil.GetStoenGridMarkVExt(this._itemType, equipType, stoneType);

        if ( markV.type == StoneGridMarkEnum.UNUP ) {
            Mgr.tips.ShowNotice( "升级材料不足!");
            return;
        }

        if ( (canTihuan && markV.type == null )
            ||markV.type == StoneGridMarkEnum.INLAY || markV.type == StoneGridMarkEnum.UNINLAY ) { //镶嵌
            var panel = Mgr.uiMgr.ShowPanelByType(XiangqianBagExt.PanelName);
            panel.SetData(this._itemType,equipType, stoneType);
        }
        if(markV.type == StoneGridMarkEnum.REPLACE ){
            var panel = Mgr.uiMgr.ShowPanelByType(XiangqianBagExt.PanelName);
            panel.SetData(this._itemType,equipType, stoneType,StoneGridMarkEnum.REPLACE);
        }
    },
    /// 宝石拆卸/拆下/拆除
    _OnBtnClicked_ChaiXie:function(sender){
        var stoneType = sender._stoneType;
        var equipType = this.gridItem.equipType;

        var equipGrid = this._GetEquipGridByType(equipType);
        var equipV = equipGrid.equipV;

        if ( !equipV ) {
            Mgr.tips.ShowNotice( "请选择一件装备");
            return;
        }

        var markV = DuanzaoUtil.GetStoenGridMarkVExt(this._itemType, equipType, stoneType);

        if ( markV.type== StoneGridMarkEnum.INLAY || markV.type == StoneGridMarkEnum.UNINLAY ) { //镶嵌
            return;
        }

        var operate = 2;
        var itemType = this._itemType;
        var equipType = equipType;
        var sid = new Long();
        var pos = 0;
        var stoneEnum = DuanzaoUtil.GetStoneCondition();
        for(var i = 0; i != stoneEnum.length; i++){
            if(stoneType == stoneEnum[i].type){
                pos = stoneEnum[i].pos;
                break;
            }
        }
        Mgr.gem.SendReqGemChangeToGameMessage(operate, itemType, equipType, sid, pos);
    },

	_SetLabelLink:function () {
		this.labCue1.setTouchEnabled(true);
		this.labCue1.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);
				Mgr.uiMgr.GetPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_COMPOSE);
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});
	},

	SetData:function (itemType) {
        this._itemType = itemType;

        this.LayOutGrids();
		// 请求宝石数据
		Mgr.gem.SendReqGemInfoToGameMessage(itemType);
	},

	SetEquips:function()
	{
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			var grid = this._gridArr[i];
            var equipV = Mgr.equip.GetEquipByType(this._itemType,this._gridArr[i].equipType);
			this._SetEquip( grid, equipV );

			// 及时更新部位装备 , 更换装备的情况
			if ( this.gridItem.equipV ) {
				var temp = Q_item.Get(this.gridItem.equipV.itemModelId);
				if ( temp.q_kind == grid.equipType )
					this.gridItem.equipV = equipV;
			}
		}
		this.UpdataWarn();
	},

	_AutoSelect:function () {
		var _equipV = null;
		var _grid = null;
		var _bestSelArr = [];
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			var grid = this._gridArr[i];
			var data = grid.equipV;
			// unexist equip
			if ( !data )
				continue;

			// 默认选着一个
			if ( !_equipV ) {
				_equipV = data;
				_grid = grid;
			}

            var mark = DuanzaoUtil.GetEquipGridMarkExt(this._itemType, grid.equipType );
			if ( mark != StoneGridMarkEnum.NORMAL ) {
				_bestSelArr.push( [data, grid]);
			}
		}

		//如果存在优选装备
		if ( _bestSelArr.length > 0 ) {
			_equipV = _bestSelArr[0][0];
			_grid = _bestSelArr[0][1];
		}

		// 暂时不要这个需求
		// for ( var i = 0; i != _bestSelArr.length; i++ ) {
		// 	_equipV = ( _equipV.strenthenLv > _bestSelArr[i].strenthenLv ) ? _equipV : _bestSelArr[i];
		// }

		this.gridItem.equipV = _equipV;
		this.gridItem.equipType = _grid && _grid.equipType;
		this.SetCenterEquip();

		// select effect
		if ( _grid ) {
			// 清除上一次效果
			if ( this._curSelector )
				this._SetSelectEffect(this._curSelector, false)
			this._curSelector = _grid;
			this._SetSelectEffect( _grid, true )
		}
	},

	_SetSelectEffect:function (grid, visible) {
		if ( !grid.select ) {
			var icon = new MUIImage();
			icon.ParseJson(this.imgSelect.jsonobj);
			icon.Init();
			icon.setPosition(this.imgSelect.getPosition());
			grid.addChild(icon);
			grid.select = icon;
		}
		grid.reorderChild(grid.select, 3);
		grid.select.visible = visible;
	},

	_SetEquip:function ( grid, equipV ) {
		grid.Clean();
        grid.equipV = equipV;

		if ( equipV ) {
			// ico
			// var icon = ItemUtil.GetItemIcon(equipV.itemModelId, ResUrl.ITEM_SIZE_60)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = equipV.itemModelId;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);

            // equip name
            var labName = new MUILabel();
            labName.ParseJson(this.labEquipName.jsonobj);
            labName.Init();
            labName.x = this.labEquipName.x + this.labEquipName.uiWidth / 2;
            labName.y = this.labEquipName.y + this.labEquipName.GetHeight() / 2;
            labName.setAnchorPoint(cc.p(0.5,0.5))
            labName.SetTextAlign(1)
            grid.AddDisplay(labName);
            labName.SetText(Q_item.Get(equipV.itemModelId).q_name);
            labName.setScale(Math.min(1,120 / labName._textWidth));
		}

		// callback
		var self = this;
		grid.setTouchEnabled(true);
		grid.addTouchEventListener(function (sender, type) {
			if (type == ccui.Widget.TOUCH_ENDED) {
				if ( sender.equipV ) {
					if ( self._curSelector )
						self._SetSelectEffect( self._curSelector, false )

					self._curSelector = sender;
					self._SetSelectEffect( sender, true );

					self.gridItem.equipV = sender.equipV;
					self.gridItem.equipType = sender.equipType;
					self.SetCenterEquip();
				}
				//else
				//	Mgr.tips.ShowNotice( "没有装备!");
			}
		});
	},

	SetCenterEquip:function () {
		var grid = this.gridItem;
		grid.Clean();
		if ( grid.equipV ) {
			// icon
			// var icon = ItemUtil.GetItemIcon(grid.equipV.itemModelId)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = grid.equipV.itemModelId;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);
			grid.equipV = grid.equipV;
		}
		this.SetStones();
		this._ShowFighting();
		this.UpdataWarn2();
	},

	SetStones:function () {
		for (var i = 0; i != this._stoneGridArr.length; i++) {
			var grid = this._stoneGridArr[i];
            // grid.itemBind = false;
            // grid.SortImage();
			var equipType = this.gridItem.equipType;
			if ( equipType == undefined && this.gridItem.equipV ) {
				var equipC = Q_item.Get(this.gridItem.equipV.itemModelId);
				cc.assert(null != equipC, "Q_item Item can't be nil!  mid: " + this.gridItem.equipV.itemModelId);
				equipType = equipC.q_kind;
			}

			if ( equipType != undefined ) {
				grid.equipType = equipType;
				grid.stoneType = this._stoneGridArr[i].stoneType;

				var stoneC = null;
				var data = Mgr.gem.GetInlayStoneExt(this._itemType,equipType,grid.stoneType );
				stoneC = data ? Q_item.Get( data.mid ) : null;
                var list = Mgr.gem.GetInlayStonesExt(this._itemType,equipType);

				this._SetStone(grid, stoneC);
			}
			else{
                this._SetStone(grid, null);
			}
		}
	},

	_SetStone:function ( grid, stoneC ) {
		grid.Clean();
        grid._imgJia.visible = false;
		if ( stoneC ) {
			// icon
			// var icon = ItemUtil.GetItemIcon(stoneC.q_id);
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
			grid.stoneC = stoneC;
            var coinInfo = {};
            coinInfo.itemModelId = grid.stoneC.q_id;
            GridUtil.SetItemGrid(grid, coinInfo, null, null, null, false);
			// grid.itemBind = Mgr.gem._inlayStonesHash.Get(grid.equipType).Get(stoneC.q_id).isbind;

            var gemDate = Mgr.gem.GetInlayStoneById(this._itemType,grid.equipType,stoneC.q_id);

            if(gemDate && gemDate.isbind) GridUtil.AddLock(grid);

			// stone level
			var _level = new MUILabel();
			_level.ParseJson(this.labLv.jsonobj);
			_level.Init();
			_level.setPosition(this.labLv.getPosition());
			grid.AddDisplay(_level);
			var str = String(stoneC.q_rank) + "级";
			_level.SetString(str);

			// attr
//			var attribute = new MUILabel();
//			attribute.ParseJson(this.labGongji.jsonobj);
//			attribute.Init();
//			attribute.setPosition(this.labGongji.getPosition());
//			grid.AddDisplay(attribute);

			var attrV = DuanzaoUtil.GetAttributeV(stoneC.q_id, stoneC.q_rank);
			str = attrV.str + "+" + attrV.value;
			this.labAttrs[grid.stoneType].SetString(str);
		}
		else {
			// 是否开启
			var markV = DuanzaoUtil.GetStoenGridMarkVExt(this._itemType, grid.equipType, grid.stoneType);
			if ( markV.type == StoneGridMarkEnum.UNOPEN ) {
				// lock icon
				var icon = new MUILabel();
				icon.ParseJson(this.imgUnOpen.jsonobj);
				icon.Init();
				icon.setPosition(this.imgUnOpen.getPosition());
				icon.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
				icon.SetText(markV.extra ? "强化+" + markV.extra +"\n可开启" : "未开放");
                icon.y += 7;
				grid.AddDisplay(icon);
			}else{
               grid._imgJia.visible = true;
			}

            this.labAttrs[grid.stoneType].SetString("");
		}

		// btn 建立
		this._AddButton(grid );
	},

	_GetEquipGridByType:function (equipType) {
		var grid  = null;
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			grid = this._gridArr[i];
			if ( grid.equipType == equipType )
				break;
		}
		return grid;
	},

	_AddButton:function ( grid) {
	    return;

		var markV = DuanzaoUtil.GetStoenGridMarkVExt(this._itemType, grid.equipType, grid.stoneType);
		if ( markV.type != StoneGridMarkEnum.NORMAL && markV.type != StoneGridMarkEnum.UNOPEN ) {
			// create button
			var btn = new MUIButton();
			btn.ParseJson(this.btnShengji.jsonobj);
			btn.Init();
			btn.type = markV.type;
			btn.setTitleText( markV.str );
			//
			if(markV.type == StoneGridMarkEnum.REPLACE){
                var btn1 = new MUIButton();
                btn1.ParseJson(this.btnShengji.jsonobj);
                btn1.Init();
                btn1.setTitleText("替换");

                btn.x = btn1.x = grid.width + 10;
                if (grid == this.gridItem3)
                    btn.x = btn1.x = 0 - btn1.width - 10;
                btn1.y = btn.height/2;
                btn.y = btn1.y -  btn.height;

                grid.AddDisplay(btn1);
                btn1.setEnabled(true);
                btn1.setTouchEnabled(true);
                btn1.addTouchEventListener(function(sender, type){
                    var stoneGrid = sender.parent;
                	if(type == ccui.Widget.TOUCH_ENDED){//替换
                        var panel = Mgr.uiMgr.ShowPanelByType(XiangqianBagExt.PanelName);
                        panel.SetData(this._itemType,stoneGrid.equipType, stoneGrid.stoneType, StoneGridMarkEnum.REPLACE);
					}
				});
			}
			else{
                //pos
                btn.x = grid.width + 10;
                if ( grid == this.gridItem3 ) {
                    btn.x = 0 - btn.width - 10;
                }
                btn.y = 0;
			}
			grid.AddDisplay( btn );
			btn.setEnabled(true);

			// callback
			btn.setTouchEnabled(true);
			btn.addTouchEventListener(function(sender, type){
				if (type == ccui.Widget.TOUCH_ENDED) {

					var stoneGrid = sender.parent;
					var page = stoneGrid.parent.parent;

					var equipGrid = page._GetEquipGridByType(stoneGrid.equipType);
					var equipV = equipGrid.equipV;
					if ( !equipV ) {
						Mgr.tips.ShowNotice( "请选者一件装备");
						return;
					}

					if ( sender.type == StoneGridMarkEnum.UNUP ) {
						Mgr.tips.ShowNotice( "升级材料不足!");
						return;
					}

					if ( sender.type == StoneGridMarkEnum.INLAY || sender.type == StoneGridMarkEnum.UNINLAY ) { //镶嵌
						var panel = Mgr.uiMgr.ShowPanelByType(XiangqianBagExt.PanelName);
						panel.SetData(this._itemType,stoneGrid.equipType, stoneGrid.stoneType);
					}
					else{   // 拆卸
                        var stoneGrid = sender.parent;
                        var operate = 2;
                        var itemType = this._itemType;
                        var equipType = stoneGrid.equipType;
                        var sid = new Long();
                        var pos = 0;
                        var stoneEnum = DuanzaoUtil.GetStoneCondition();
                        for(var i = 0; i != stoneEnum.length; i++){
                            if(stoneGrid.stoneType == stoneEnum[i].type){
                                pos = stoneEnum[i].pos;
                                break;
                            }
                        }
                        Mgr.gem.SendReqGemChangeToGameMessage(operate, itemType, equipType, sid, pos);
                    }
				}
			});
		}
	},

	LayOutGrids:function () {
		// set small grid
		for ( var i = 0; i != this._gridArr.length; i++ ) {
			var equipType = this._gridArr[i].equipType;

			var smallGrids = this._gridArr[i].smallGridList;
			if (!smallGrids)
				smallGrids = [];

			// create
			var count = 0;
			var list = Mgr.gem.GetInlayStonesExt(this._itemType,equipType);
            var len = smallGrids.length;
//			for ( var j = 0; j != list.length; j++ ) {
			for ( var j = 0; j < 3; j++ ) {
				var grid = null;
				if ( j < len )
					grid = smallGrids[j];
				else {
					grid = this._CreateGrid( count, this._gridArr[i] );
					grid.equipType = this._gridArr[i].equipType;
					smallGrids.push( grid );
				}
                if(list[j]){
                    var stoneC = Q_item.Get( list[j].mid );
                    this._SetSmallGrid( grid, list[j].mid, stoneC );
                }else{
                    this._SetSmallGrid( grid);
                }

				++count;
			}
            //if(smallGrids.length > list.length){
            //    for(var k = smallGrids.length - 1; k >= list.length; k--){
            //        var grid = smallGrids[k];
            //        smallGrids.pop(k);
            //        this._gridArr[i].removeChild(grid);
            //    }
            //}
			this._gridArr[i].smallGridList = smallGrids;
		}
		this.SetEquips();
		if ( this.gridItem.equipV )
			this.SetCenterEquip();
		else
			this._AutoSelect();
	},

	_CreateGrid:function ( order, grid ) {
		var grid_inlay = this._smallGridArr[order].Clone();
		var pos = this._smallGridArr[order].getPosition();
		grid_inlay.setPosition(pos);
		grid.addChild(grid_inlay);
		return grid_inlay;
	},

	_SetSmallGrid:function ( grid, mid, stoneC ) {
		grid.Clean();
		// ico
		if(stoneC){
            // var icon = ItemUtil.GetItemIcon(mid);
            // grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = mid;
            GridUtil.SetItemGrid(grid, coinInfo, null, null, null, false);
            // var sX = grid.width/icon.width;
            // var sY = grid.height/icon.height;
            // icon.setScaleX(sX);
            // icon.setScaleY(sY);
            // var scale = {sx:sX, sy:sY};
				// if(Mgr.gem._inlayStonesHash.Get(grid.equipType).Get(mid).isbind){
            //     GridUtil.AddLock(grid, scale);
            // }
            // icon.x = (grid.width - icon.width*sX) / 2;
            // icon.y = (grid.height - icon.height*sY) / 2;
		}
	},

	_ShowFighting:function () {
		var add_fighting = 0;
		var equip = this.gridItem.equipV;
		if ( equip ) {
			var equipC = Q_item.Get(this.gridItem.equipV.itemModelId);
			cc.assert(null != equipC, "Q_item Item can't be nil!  mid: " + this.gridItem.equipV.itemModelId);
			var stonesCache = Mgr.gem.GetInlayStonesExt(this._itemType, equipC.q_kind );
			for ( var i = 0; i != stonesCache.length; i++ ) {
				//累加战斗力
				var info = stonesCache[i].stoneC;
				if ( info ) {
					var attrV = DuanzaoUtil.GetAttributeV( info.q_id, info.q_rank );
					var fo = Mgr.attributeMgr.GetAttributeRate(attrV.type, 0);
					add_fighting += parseInt(fo * attrV.value);
				}
			}
		}
		this.labZhanDouLi.FormatHtmlText( add_fighting );
//		this.imgNumber.FormatHtmlText( add_fighting );
	},

	UpdataWarn:function () {
		// equip
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			var grid = this._gridArr[i];

			this._EndWarn(grid);
			var markV = DuanzaoUtil.GetEquipGridMarkExt(this._itemType, grid.equipType );
			if  ( markV == StoneGridMarkEnum.INLAY ) {
				this._StartWarn(grid, 1);
			}
			else if  ( markV == StoneGridMarkEnum.REPLACE ) {
				this._StartWarn(grid, 2);
			}
		}
		this.UpdataWarn2();
	},

	UpdataWarn2:function () {
		// stone
		for ( var i = 0; i != this._stoneGridArr.length; i++ ) {
			var equipType = this.gridItem.equipType;
			if ( equipType == undefined && this.gridItem.equipV ) {
				var itemC = Q_item.Get(this.gridItem.equipV.itemModelId);
				cc.assert(null != itemC, "data is unexist in Q_item!  mid: " + this.gridItem.equipV.itemModelId);
				equipType = itemC.q_kind;
			}

			var boo = false;
			if ( equipType != undefined ) {
				var mark = DuanzaoUtil.GetStoenGridMarkVExt(this._itemType, equipType, this._stoneGridArr[i].stoneType );
				if ( mark.type == StoneGridMarkEnum.INLAY || mark.type == StoneGridMarkEnum.REPLACE ) {
					boo = true;
				}
			}
			this._SetGridState( this._stoneGridArr[i], this.imgGantanhao1, boo );
		}
	},

	_EndWarn:function (grid) {
		if (grid.warn) {
			grid.warn.visible = false;
			grid.warn.stopAllActions();
		}
	},

	_StartWarn:function (grid, type) {
		if ( !grid.warn ) {
			// 可镶嵌
			var icon = new MUILabel();
			icon.ParseJson(this.imgQianghua.jsonobj);
			icon.Init();
			icon.setPosition(this.imgQianghua.getPosition());
			grid.addChild(icon, 1, 20);
			grid.warn = icon;
		}

		if ( type == 1 ) {   // 可镶嵌
			grid.warn.SetString("可镶嵌")
		}
		else {     // 可升级
			grid.warn.SetString("可替换")
		}

		grid.warn.visible = true;
		grid.warn.setOpacity(255);
		grid.warn.setPosition(this.imgQianghua.getPosition());
		grid.reorderChild(grid.warn, 10);

		// action
		var actionTo = cc.moveBy(1, cc.p(0, grid.height / 4));
		var trace = cc.callFunc(this._OnTrace, this);
		var out = cc.fadeOut(0.5);
		var ina = cc.fadeIn(0.5);
		var rep = cc.sequence(actionTo, out, trace, ina).repeatForever();
		grid.warn.runAction(rep);
	},

	_OnTrace:function (sender) {
		var pos = this.imgQianghua.getPosition();
		sender.x = pos.x;
		sender.y = pos.y;
	},

	_SetGridState:function ( widget, img, boo ) {
		if ( !widget.warn ) {
			var icon = new MUIImage();
			icon.ParseJson(img.jsonobj);
			icon.Init();
			icon.setPosition(img.getPosition());
			widget.addChild(icon);
			widget.warn = icon;
		}
		widget.warn.visible = boo;
		widget.reorderChild(widget.warn, 10);
	},
} );
XiangqianMainExt.PanelName = "XiangqianMainExt";
PanelClassDic["XiangqianMainExt"] = XiangqianMainExt;
