var GonggaoMainExt = GonggaoMain.extend ( {
	_className:"GonggaoMainExt",
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.ALPHABLACK;
		this.showLayerType = UIMgr.PANEL_LAYER_TOP;
	},
	Init:function() {
		var self = this;
		GonggaoMain.prototype.Init.call(this);
		this.setLocalZOrder(1000);
		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});

		self._scrDetail = new ccui.ScrollView();
		self._scrDetail.setSize(this.labCue1.uiWidth,this.img1.uiHeight + this.labCue1.uiHeight);
		self._scrDetail.setScrollBarEnabled(false);
		self._scrDetail.setBounceEnabled(true);
		self._scrDetail.setPosition(self.labCue1.getPosition());
		self.labCue1.parent.addChild(self._scrDetail);
		self.labCue1.removeFromParent(false);
		self.labCue1.x = 0;
		self.labCue1.y = 0;
		self._scrDetail.addChild(self.labCue1);
		this.SetData(null);

		this.img1.visible = false;
	},
	
	OnShow:function(){
		ChannelUtil.RequestNotice();
	},

	SetData:function(data){
		if( data && data.length ){
			var content = data[0].content.replace(/&nbsp;/g," ");
			this.labCue1.SetText(content);
		}
		else{
			this.labCue1.SetText("暂无公告");
		}
		var panelH = this.img1.uiHeight + this.labCue1.initHeight;
		var h = this.labCue1.GetTextHeight();
		this.labCue1.SetUISize(this.labCue1.uiWidth, Math.max(h,panelH));
		this.labCue1.setPosition(cc.p(0,0	));
		this._scrDetail.setInnerContainerSize(cc.size(this.labCue1.uiWidth, h>panelH?h:panelH));
	},
} );
GonggaoMainExt.PanelName = "GonggaoMainExt";
PanelClassDic["GonggaoMainExt"] = GonggaoMainExt;
