/**
 * Created by Merlin on 2016/5/30.
 */
var FightUtil = FightUtil || {
        // 显示对象战斗施法特效
        DoSkillEffectUser:function(src, dst, skillm, dir, fightState, tarPos){
            if(src.GetHide && src.GetHide()) return;

            if (src.IsDeadState())
                return;
            Profiler.LogFight("DoSkillEffectUser");
            var srcPlayer = (src instanceof ScenePlayer) ? src : null;
            var isJump = false;
            var skillp = Q_skill_public.Get(skillm.q_skillID);
            tarPos = dst ? dst.GetGridPt() : (tarPos || src.GetGridPt());

            if( !isJump && fightState != -1 ){
                if( src.CheckState( EnumActionType.RUN ) ){
                    src.StopMove();
                }
            }

            var ret = false;
            if( dst ){
                src.TurnToObj(dst);
            }
            if( srcPlayer && skillp.q_attack_id ) {   //根据配置播动作
                ret = src.SetStateShowAttack(skillp.q_attack_id, dir);
            }
            else if( !srcPlayer ){
                src.SetStateShowAttack(1);
            }
            Profiler.LogFight("DoSkillEffectUser", true);
            Profiler.LogFight("DoSkillEffectUser - PlaySoundSkill");
            if( src == Mgr.mainPlayer)
                Mgr.gameSoundMgr.PlaySoundSkill(skillm.q_skillID);
            Profiler.LogFight("DoSkillEffectUser - PlaySoundSkill", true);
            if( skillm.q_skill_user == 4 ){         //符鬼技能

            }
            else if( skillm.q_skill_user == 2 ){    //怪物技能

            }
            else if( skillm.q_skill_user == 1 ){    //人物技能
                switch (skillm.q_skillID){
                    // 基础技能
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 21:
                    case 22:
                    case 23:
                    case 24:
                    {
                        Profiler.LogFight("DoSkillEffectUser - DoRoleBaseSkill");
                        this.DoRoleBaseSkill( src, skillp.q_attack_id, skillm.q_skillID );
                        Profiler.LogFight("DoSkillEffectUser - DoRoleBaseSkill", true);
                    }
                    default:
                        if( skillp && skillp.q_use_effect ){
                            Profiler.LogFight("DoSkillEffectUser - DoUseSpecialEffect");
                            this.DoUseSpecialEffect( src, tarPos, skillp.q_use_effect, skillm.q_delay_time );
                            Profiler.LogFight("DoSkillEffectUser - DoUseSpecialEffect", true);
                        }
                        break;
                }
            }
        },

        /**
         * 普攻循环播放处理
         * @param scrBasePlayer
         * @param fightListId
         * @param isRide
         *
         */
        DoRoleBaseSkill:function ( player, attackId, skillId ){
        	if( player == null )
                return;
            var job =  SceneObjUtil.MODEL_SEX_HASH.Get(player.nBodyResId);
           if( !job )
               job = player.nJobId;

            var effId = 1000 + job * 100 + attackId;
            this.ShowBodySkillEffect(player, effId, true, false);
        },

        /// 显示战斗对象施法弹道和命中特效
        DoSkillEffectOther:function(src, dst, skillm){
            if (src == null || skillm == null)
                return;

            if (src.IsDeadState())
                return;

            var srcPlayer = (src instanceof ScenePlayer) ? src : null;
            var delayTime = skillm.q_delay_time;
            var islocus = true;
            if (islocus)  {// 弹道类特效
                var effectID = 10013;//10011;//skillm.q_skillID;
                if (this.IsHideEff(src)){
                    return;
                }

                var effect = SkillEffect.Create(effectID, EffectUtil.ENUM_TYPE_LOCUS, true, MDirection.UP, -1);
                effect.bNeedRotate = true;
                Mgr.sceneLayer.AddTop(effect);
                var startpt = src.GetPixPt();
                startpt.y -= (src.GetStandHeight() / 2);
                effect.SetPixPt(startpt);

                var distance = 0;
                var time = 0;
                var speed = 700;
                if (dst != null) {
                    distance = ToolMap.CalcDistance(dst.GetPixPt(), src.GetPixPt());
                    time = distance * 1000 / speed;
                    if (time == 0)
                        time = 1;
                    zz.Log("setTweenMoveToTarget , time:" + time + " distance:" + distance + " speed:" + speed);
                    effect.SetTweenMoveToTarget(src, dst, skillm, time);
                } else  {// 空放
//				Vector2 srcpixPt = src.GetPixPt();
//				Vector2 tarPt = new Vector2(pos.x, pos.y);
//				srcpixPt.y -= (src.standHeight / 2);
//				tarPt.y -= (src.standHeight / 2);
//				float angle = Mathf.Atan2(tarPt.y - srcpixPt.y, tarPt.x - srcpixPt.x);
//
//				//Vector2 truePos = new Vector2(srcpixPt.x + Mathf.Cos(angle) * 1000, srcpixPt.y + Mathf.Sin(angle) * 1000);
//				Vector2 truePos = new Vector2(srcpixPt.x + Mathf.Cos(angle) * 1000, srcpixPt.y + Mathf.Sin(angle) * 1000);
//
//				if (skillm.q_skillID == SkillMID.D_3008_YOULINGJIA || skillm.q_skillID == SkillMID.D_3007_JITIYINSHEN)
//					truePos = tarPt;
//
//				distance = ToolMap.calcDistance(truePos, srcpixPt);
//				time = distance / speed;
//				//DebugTool.Log("setTweenMoveToDir , time:" + time + " distance:" + distance + " speed:" + speed);
//				effect.setTweenMoveToDir(src, truePos, skillm, time);
                }
                //effect.show( delayTime );
                // 技能音效 ty
                //var locusSoundID :int = getSkillLocusSoundID( effectID );
                //if ( locusSoundID != -1 )
                //	Mgr.musicMgr.playSoundSkillLocus(locusSoundID);
            } else {
                // 直接命中类特效（非弹道）
                if (dst == null) {// 无攻击对象
                    if (this.IsHideEff(src))
                        return;

                    var effid = this.GetSkillEffectId(src, skillm.q_skillID);
                    var eff = SkillEffect.Create(effid, EffectUtil.ENUM_TYPE_HIT, false, -1, 0, 1.0, delayTime);
                    Mgr.sceneLayer.AddTop(eff);
                    // eff.setPosition(pos.x, pos.y);
                } else {
                    // 有攻击对象
                    this.ShowAttackedEffect(src, dst, skillm);
                }
            }
            //var soundid:int = getSkillSoundId( skillm.q_skillID, srcV );
            //if ( soundid != -1 )
            //	Mgr.musicMgr.playSoundSkillUer(soundid, 0, (srcV is BasePlayerV) == false);
        },

        // 空地命中特效
        ShowAttackedEffect:function(src, dst, skillm){
            if (dst == null || !sys.isObjectValid(dst))
                return;

            if (!dst.visible)
                return;

            if (src == null || !sys.isObjectValid(src))
                    return;

            if (!src.visible)
                return;
            Profiler.LogFight("RecvResAttackResultMessage - ShowAttackedEffect");
            var effid;
            if (src instanceof SceneMonster || src instanceof ScenePet) {
                effid = parseInt(skillm.q_hit_effect);
                if (effid > 0)
                    this.ShowBodyHitEffect(src, dst, effid);
            } else if (src instanceof ScenePlayer) {
                effid = this.GetSkillEffectId(skillm.q_skillID);
                this.ShowBodyHitEffect(src, dst, effid);
                //int soundId = getSkillHitSoundID( skillm.q_skillID ,fightV);
                //if ( soundId != -1 )
                //	FrameDispatcher.setTimeout( Mgr.musicMgr.playSoundSkillHit, delayTime, soundId );
            }
            Profiler.LogFight("RecvResAttackResultMessage - ShowAttackedEffect", true);
        },

        //这里主要只是做了个伤害分段拆分
        CreateFightResultEffect:function (src, tar, damage, resultType ) {
            Profiler.LogFight("RecvResAttackResultMessage - CreateFightResultEffect");
            resultType = ( src instanceof ScenePet ) ? EnumResultType.PET : resultType;
            resultType = damage == 0 ? EnumResultType.MISS : resultType;
            this.CreateDamageShow(src, tar, damage, resultType);
            Profiler.LogFight("RecvResAttackResultMessage - CreateFightResultEffect", true);
        },

        CreateDamageShow:function(src, tar, damage, resultType){
        	damage = parseInt(damage);
            var isMainPlayer = ( tar == Mgr.mainPlayer );
            var spr = BloodSpr.Create();
            spr.SetData( damage, resultType, isMainPlayer );
            spr.x = tar.x;
            spr.y = tar.y + 70; //固定偏移
            
            if( tar.blood ){
            	tar.blood.speed.setSpeed(2);
            }

            var callback = new cc.CallFunc( this.OnShowDamageEnd, spr, tar );
            var seq;
            if( isMainPlayer ){
                var scaleNum = ( resultType == EnumResultType.CRIT ? 1.1 : 1.2 );
                var scale = new cc.ScaleTo( .1, scaleNum );
                if( resultType == EnumResultType.CRIT ){
                    seq = new cc.Sequence( scale, new cc.EaseExponentialOut(new cc.ScaleTo( .5, 1 )), new cc.EaseExponentialIn( new cc.MoveBy( .3, 30, -30) ), callback);
                }
                else {
                    seq = new cc.Sequence( scale, new cc.EaseExponentialOut( new cc.ScaleTo( .2, 1 ) ), new cc.EaseExponentialIn( new cc.MoveBy( .5, 70, resultType == EnumResultType.MISS ? 70 : -70) ), callback);
                }
            }
            else {
                // spr.x += ToolBase.RamdonRangeInt( -50, 50 );
                // spr.y += ToolBase.RamdonRangeInt( -50, 50 );
                // var radius;
                // if( src == null )
                // 	radius = FightUtil.DirToRadian(0);
                // else
                // 	radius = FightUtil.PosToRadian(src.GetPixPt(), tar.GetPixPt());
                // var disRate = 1;
                // if( resultType == EnumResultType.MISS ){
                //     disRate = 0.6;
                // }
                // var p = cc.pForAngle(radius);
                // cc.pMultIn( p, 180 );
                // disRate = 1.3;
                // //因为是增量位移 所以y要取反  如果是用MoveTo那加起来就行了
                // var spawn = new cc.Spawn( new cc.MoveBy( 0.3, p.x * disRate, -p.y * disRate ), new cc.ScaleTo( 0.3, 0.7 ) );
                // seq = new cc.Sequence( new cc.EaseExponentialOut( new cc.MoveBy( .5, p.x, -p.y ) ), spawn, new cc.CallFunc( this.OnShowDamageEnd, spr, tar ));
                spr.x += ToolBase.RamdonRangeInt( -50, 50 );
                spr.y += ToolBase.RamdonRangeInt( -50, 50 );
                var radius;
                if( src == null )
                    radius = FightUtil.DirToRadian(0);
                else
                    radius = FightUtil.PosToRadian(src.GetPixPt(), tar.GetPixPt());
                // var disRate = 1;
                // if( resultType == EnumResultType.MISS ){
                //     disRate = 0.6;
                // }
                var p = cc.pForAngle(radius);
                cc.pMultIn( p, 130 );
                //因为是增量位移 所以y要取反  如果是用MoveTo那加起来就行了
                var spawn = new cc.Spawn( new cc.MoveBy( 0.6, 0, 120 ), new cc.FadeTo( 0.6, 100 ) );
                seq = new cc.Sequence( new cc.EaseExponentialOut( new cc.MoveBy( .5, p.x, -p.y ) ), spawn, new cc.CallFunc( this.OnShowDamageEnd, spr, tar ));
            }
            
            tar.blood = spr;
            spr.speed = new cc.Speed(seq, 1);
            spr.runAction( spr.speed );
            Mgr.sceneLayer.AddTop( spr );
        },

        OnShowDamageEnd:function( spr, tar ){
           if( tar.blood == spr )
                tar.blood = null;
            BloodSpr.Delete(spr);
        },

        // 弹道特效飞行完成后的回调（命中后的爆炸特效）
        CallbackEffectTweenEnd:function(endskilleff, skillm, srcgid, dstgid) {
            //zz.Log("effectTweenEndCallback , skillm:" + skillm.q_skillName + " srcgid:" + srcgid + " dstgid:" + dstgid);
            var src = Mgr.sceneObj.FindObject(srcgid);
            var dst = Mgr.sceneObj.FindObject(dstgid);
            var effectID = 10033;//this.GetSkillEffectId(src, skillm.q_skillID);

            if (dst == null){// 无攻击对象，播放
                //zz.Log("effectTweenEndCallback , (dst == null)");
//			var hitEffect = SkillEffect.Create(effectID, EffectUtil.ENUM_TYPE_HIT, false, -1);
//			hitEffect.setName("SkillEffect hit" + effectID);
//			//hitEffect.setDisplayLevel( 1 );
//			Mgr.sceneLayer.AddTop(hitEffect);
//			hitEffect.setPosition(endskilleff.x, endskilleff.y);
            } else {// 有攻击对象，播放命中特效
                this.ShowBodyHitEffect(src, dst, effectID, false);
            }
        },

        ShowBodySkillEffect:function(src, effid, isStand5, isBottom, speed, pathtype, delay){
            if (src == null)
                return;

            if (this.IsHideEff(src))
                return;

            if (isBottom == undefined)
                isBottom = false;
            if (speed == undefined)
                speed = 1;
            if (isStand5 == undefined)
                isStand5 = true;
            if (pathtype == undefined)
                pathtype = EffectUtil.ENUM_TYPE_UER;
            delay = delay || 0;

            var eff = null;
            if (isStand5)
                eff = SkillEffect.Create(effid, pathtype, true, src.nCurDirection, 0, speed, delay);
            else
                eff = SkillEffect.Create(effid, pathtype, false, -1, 0, speed, delay);

            if (isBottom) {
                src.AddBottomChild(eff);
            } else {
                src.AddTopChild(eff);
            }
        },

        ShowSceneSkillEffect:function(src, effid, isStand5, isBottom, delay, pixelPos, rotation, scale, speed, pathtype){
            if (this.IsHideEff(src))
                return;

            if (isBottom == undefined)
                isBottom = false;
            if (speed == undefined)
                speed = 1;
            if (isStand5 == undefined)
                isStand5 = true;
            if (pathtype == undefined)
                pathtype = EffectUtil.ENUM_TYPE_UER;
            rotation = rotation || 0;
            pixelPos = pixelPos || src;
            scale = scale || 1;

            var eff = null;
            if (isStand5)
                eff = SkillEffect.Create(effid, pathtype, true, src.nCurDirection, 0, speed, delay);
            else
                eff = SkillEffect.Create(effid, pathtype, false, -1, 0, speed, delay);

            eff.rotation = rotation;
            eff.x = pixelPos.x;
            eff.y = pixelPos.y;
            if( scale < 0 )     //小于0就翻转x
                eff.setFlippedX(true);
            else
                eff.SetScale( scale );

            if (isBottom) {
                Mgr.sceneLayer.AddBottom(eff);
            } else {
                Mgr.sceneLayer.AddTop(eff);
            }
        },



        GetSkillEffectId:function(skillId) {
            var id = 1;
            if( SkillUtil.IsBaseSkill(skillId) ){
                if( Math.random() > 0.6 )
                    id = 4;
            }
            else
                id = 3;
            return id;
        },

        ShowBodyHitEffect:function(src, dst, effid, isStand5, isBottom, speed, delayTime){
            if (dst == null)
                return;

            if (isBottom == undefined)
                isBottom = false;
            if (speed == undefined)
                speed = 1;
            if (delayTime == undefined)
                delayTime = 0;
            if (isStand5 == undefined)
                isStand5 = false;

            if (this.IsHideEff(src))
                return;

            var eff = null;
            if (isStand5)
                eff = SkillEffect.Create(effid, EffectUtil.ENUM_TYPE_HIT, true, dst.nCurDirection, -1, speed, delayTime);
            else
                eff = SkillEffect.Create(effid, EffectUtil.ENUM_TYPE_HIT, false, -1, 0, speed, delayTime);

            eff.y = dst.GetHeight() * 0.5;

            if (isBottom) {
                dst.AddBottomChild(eff);
            } else {
                dst.AddTopChild(eff);
            }
        },

        // 是否隐藏特效
        IsHideEff:function(fight){
            if( fight === Mgr.mainPlayer )
                return false;

            return !Mgr.map.isShowSkill;
        },

        /**
         * 将方向转为 弧度
         * @param dir
         * @return
         *
         */
        DirToRadian:function( dir ) {
            return ( dir - 2 ) * 0.25 * Math.PI;
        },

        /**
         * 将方向转为 弧度 带45°角透视
         * @param dir
         * @return
         *
         */
        DirToRadian45:function( dir ) {
            var radian = ( dir - 2 ) * 0.25 * Math.PI;
            switch(dir)
            {
                case MDirection.RIGHT_UP:
                    radian += 0.1;
                    break;
                case MDirection.RIGHT_DOWN:
                    radian -= 0.3;
                    break;
                case MDirection.LEFT_DOWN:
                    radian += 0.3;
                    break;
                case MDirection.LEFT_UP:
                    radian -= 0.1;
                    break;
            }
            return radian;
        },

        /**
         * 根据弧度和距离计算目标点	基于opengl坐标体系
         * @param center	原点坐标
         * @param radian	弧度
         * @param dis		距离
         * @return
         *
         */
        GetTargetPointGL:function(center, radian, dis ){
            return new cc.p( Math.round( center.x + dis * Math.cos( radian ) ), Math.round( center.y - dis * Math.sin( radian ) ) );
        },
        
        /**
         * 根据弧度和距离计算目标点
         * @param center	原点坐标
         * @param radian	弧度
         * @param dis		距离
         * @return
         *
         */
        GetTargetPoint:function(center, radian, dis ){
        	return new cc.p( Math.round( center.x + dis * Math.cos( radian ) ), Math.round( center.y + dis * Math.sin( radian ) ) );
        },

        /**
         * 通过两点坐标计算弧度
         * @param start
         * @param end
         * @return
         *
         */
        PosToRadian:function(start, end){
            return Math.atan2( end.y - start.y, end.x - start.x );
        },

        PosToDir:function(start, end){
            var radian = this.PosToRadian(start, end);
            return this.RadianToDir(radian);
        },
        RadianToDir:function(radian){
            var dir = Math.round( radian / ( 0.25 * Math.PI ) + 2 );
            if( dir < 0 )
                dir += 8;
            return dir;
        },

        /**
         * 弧度转为角度
         * @param radian
         * @return
         *
         */
        RadianToAngle:function( radian ){
            return radian * 180 / Math.PI;
        },

        /**
         * 将角度转为 弧度
         * @param angle
         * @return
         *
         */
        AngleToRadian:function( angle ){
            return Math.PI/180 * angle;
        },

        DoUseSpecialEffect:function( src, tarPos, useEffect, delayTime ){
            if (this.IsHideEff(src))
                return;

            var effType = 0;
            var effArr = useEffect.split(",");
            var jobId = SceneObjUtil.MODEL_SEX_HASH.Get(src.nBodyResId);
            jobId = jobId || src.nJobId;
            if( effArr.length > 0 ){
                if( effArr.length > jobId )
                    effType = parseInt(effArr[jobId]);
                else
                    effType = parseInt(effArr[effArr.length - 1]);
            }

            var dispt;
            var radian;
            var delayArr;
            var effId;
            var dir = src.nCurDirection;
            var isBottom;
            var srcPixel = cc.p(src.x, src.y);
            var beginPos;
            var endPos;
            switch( effType ){
                case 3:
                    var offBegin = ( dir == 0 || dir == 4 ) ? -200 : 0;
                    var offEnd = ( dir == 0 || dir == 4 ) ? 300 : 500;
                    effId = 10003;
                    radian = this.DirToRadian45(dir);
                    beginPos = this.GetTargetPointGL( srcPixel, radian, offBegin - 250);
                    endPos = this.GetTargetPointGL( srcPixel, radian, offEnd - 50 );
                    this.ShowEffectFlyToPos( beginPos, endPos, effId, 800, dir, delayTime, 1.2);
                    this.ShowSceneSkillEffect( src, 10006, false, true, delayTime + 200, srcPixel, this.RadianToAngle( radian + Math.PI * 0.5 ));

                    var tempPos = this.GetTargetPointGL( srcPixel, radian - Math.PI * 0.5, 180 );
                    beginPos = this.GetTargetPointGL( tempPos, radian, offBegin - 175);
                    endPos = this.GetTargetPointGL( tempPos, radian, offEnd - 175 );
                    this.ShowEffectFlyToPos( beginPos, endPos, effId, 720, dir, delayTime + 50, 1.2);
                    this.ShowSceneSkillEffect( src, 10006, false, true, delayTime + 200, this.GetTargetPointGL( tempPos, radian, -75), this.RadianToAngle( radian + Math.PI * 0.5 ));

                    tempPos = this.GetTargetPointGL( srcPixel, radian + Math.PI * 0.5, 180 );
                    beginPos = this.GetTargetPointGL( tempPos, radian, offBegin - 250);
                    endPos = this.GetTargetPointGL( tempPos, radian, offEnd - 250 );
                    this.ShowEffectFlyToPos( beginPos, endPos, effId, 720, dir, delayTime + 100, 1.2);
                    this.ShowSceneSkillEffect( src, 10006, false, true, delayTime + 200, this.GetTargetPointGL( tempPos, radian, -150), this.RadianToAngle( radian + Math.PI * 0.5 ));
                    break;
                case 5:
                    this.ShowSceneSkillEffect( src, 103, false, false, delayTime);

                    this.ShowSceneSkillEffect( src, 104, false, false, delayTime + 1000, null, 0, 2 );

                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(345), 500 );
                    this.ShowSceneSkillEffect( src, 101, false, false, delayTime + 1500, dispt);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(50), 450 );
                    this.ShowSceneSkillEffect( src, 101, false, false, delayTime + 1500, dispt);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(140), 550 );
                    this.ShowSceneSkillEffect( src, 101, false, false, delayTime + 1500, dispt);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(200), 500 );
                    this.ShowSceneSkillEffect( src, 101, false, false, delayTime + 1500, dispt);

                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(260), 200 );
                    this.ShowSceneSkillEffect( src, 102, false, false, delayTime + 1500, dispt, 0, Math.random() * 0.6 + 0.5);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(320), 250 );
                    this.ShowSceneSkillEffect( src, 102, false, false, delayTime + 1500, dispt, 0, Math.random() * 0.6 + 0.5);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(0), 260 );
                    this.ShowSceneSkillEffect( src, 102, false, false, delayTime + 1500, dispt, 0, Math.random() * 0.6 + 0.5);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(90), 200 );
                    this.ShowSceneSkillEffect( src, 102, false, false, delayTime + 1500, dispt, 0, Math.random() * 0.6 + 0.5);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(110), 170 );
                    this.ShowSceneSkillEffect( src, 102, false, false, delayTime + 1500, dispt, 0, Math.random() * 0.6 + 0.5);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(170), 280 );
                    this.ShowSceneSkillEffect( src, 102, false, false, delayTime + 1500, dispt, 0, Math.random() * 0.6 + 0.5);
                    break;
                case 4:
                case 7:
                    if ( effType == 7 )
                        effId = 20002;
                    else
                        effId = 10004;

                    isBottom = false;
                    var angle = 0;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(angle), 130 );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime, dispt, 0, 0.9);
                    angle += 180;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(angle), 130 );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime, dispt, 0, 0.9);
                    angle += 70;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(angle), 130 );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime, dispt, 0, 0.9);

                    angle = -30;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(angle), 152 );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime, dispt);
                    angle += 110;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(angle), 100 );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime, dispt);
                    angle += 130;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(angle), 186 );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime, dispt);

                    angle = -130;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(angle), 220 );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime, dispt, 0, 1.1);
                    angle = -10;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(angle), 250 );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime, dispt, 0, 0.9);
                    angle = 140;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(angle), 200 );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime, dispt, 0, 1.1);

                    break;
                case 10:
                    delayArr = [0, 400, 800, 1200, 1600, 2000];
                    Array.Shuffle(delayArr);
                    effId = 20005;
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(Math.random()*360), ToolBase.RamdonRangeInt(-100, 100) );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime + delayArr[0], dispt);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(Math.random()*20 + 25), ToolBase.RamdonRangeInt(250, 350) );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime + delayArr[1], dispt);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(Math.random()*20 + 105), ToolBase.RamdonRangeInt(300, 350) );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime + delayArr[2], dispt);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(Math.random()*20 + 185), ToolBase.RamdonRangeInt(250, 350) );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime + delayArr[3], dispt);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(Math.random()*20 + 265), ToolBase.RamdonRangeInt(300, 350) );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime + delayArr[4], dispt);
                    dispt = this.GetTargetPointGL( srcPixel, this.AngleToRadian(Math.random()*20 + 345), ToolBase.RamdonRangeInt(250, 400) );
                    this.ShowSceneSkillEffect( src, effId, false, isBottom, delayTime + delayArr[5], dispt);

                    var startX = srcPixel.x - 500;
                    var startY = srcPixel.y + 400;
                    var endX = srcPixel.x + 500;
                    var endY = srcPixel.y;
                    for( var i = 0; i < 40; i++ ){
                        beginPos = cc.p( ToolBase.RamdonRangeInt( startX, endX ), ToolBase.RamdonRangeInt( startY, endY ) );
                        endPos = this.GetTargetPointGL( beginPos, Math.PI * 0.5 + Math.random() * 0.5, ToolBase.RamdonRangeInt( 600, 800 ) );
                        this.ShowEffectFlyToPos( beginPos, endPos, 20006, ToolBase.RamdonRangeInt( 1000, 1400 ), dir, delayTime + i * 55, ToolBase.RamdonRangeFloat(0.8, 1));
                    }
                    break;
                case 17:
                    dispt = ToolMap.GridPt2PixPt(tarPos.x, tarPos.y, true);
                    dispt.y = -dispt.y;
                    isBottom = dir == 0;
                    this.ShowSceneSkillEffect( src, jobId * 10000 + 20, false, isBottom, delayTime, cc.p(dispt.x - 50, dispt.y + 110));
                    this.ShowSceneSkillEffect( src, jobId * 10000 + 20, false, isBottom, delayTime + 160, cc.p(dispt.x + 50, dispt.y + 60));
                    this.ShowSceneSkillEffect( src, jobId * 10000 + 21, false, isBottom, delayTime + 240, cc.p(dispt.x + 70, dispt.y + 40));
                    this.ShowSceneSkillEffect( src, jobId * 10000 + 21, false, isBottom, delayTime + 400, cc.p(dispt.x - 30, dispt.y + 40));
                    this.ShowSceneSkillEffect( src, jobId * 10000 + 21, false, isBottom, delayTime + 560, cc.p(dispt.x + 40, dispt.y + 100));
                    this.ShowSceneSkillEffect( src, jobId * 10000 + 22, false, true, delayTime + 720, cc.p(dispt.x , dispt.y + 70));

                    this.ShowBodySkillEffect( src, jobId * 10000 + 23, false );
                    this.ShowBodySkillEffect( src, jobId * 10000 + 24, false, false, 0, EffectUtil.ENUM_TYPE_UER, 700 );
                    src.HideBody(800);
                    break;
                default:
                    if( effType )
                        zz.Error("Warning: attack id is not handle " + effType );
                    break;
            }
        },

        /**
         * 播放一个飞向指定地点的特效
         * @param start
         * @param end
         * @param effid
         * @param time
         * @param dir
         * @param delay
         * @param scale
         * @param pathtype
         * @param isStand5
         * @param isRotate
         * @constructor
         */
        ShowEffectFlyToPos:function( start, end, effid, time, dir, delay, scale, pathtype, isStand5, isRotate ) {

            isRotate = isRotate || false;
            isStand5 = isStand5 != false;
            pathtype = pathtype || EffectUtil.ENUM_TYPE_UER;

            var eff = null;
            if (isStand5)
                eff = SkillEffect.Create(effid, pathtype, true, dir, time, 0, delay);
            else
                eff = SkillEffect.Create(effid, pathtype, false, -1, time, 0, delay);
            eff.setPosition(start.x, start.y);
            eff.SetScale(scale);
            var moveto = new cc.EaseCubicActionOut(cc.moveTo(time / 1000, end));
            var delayAction = cc.delayTime(delay / 1000);
            var sequence = cc.sequence(delayAction, moveto);
            eff.runAction(sequence);
            Mgr.sceneLayer.AddTop(eff);
        },

        /**
         * 在一定范围内随机播放特效
         * @param effId
         * @param pixelPos
         * @param range
         * @param count
         * @param isStand5
         * @param interval
         * @param delay
         * @param isBottom
         * @param pathtype
         * @constructor
         */
        ShowSceneRangeEffect:function(effId, pixelPos, range, count, isStand5, interval, delay, isBottom, pathtype){
            count = count || 1;
            interval = interval || 0;
            isStand5 = isStand5 !=false;
            delay = delay || 0;
            isBottom = isBottom || false;
            pathtype = pathtype || EffectUtil.ENUM_TYPE_UER;

            var eff = null;
            for( var i = 0; i < count; i++ ){
                if (isStand5)
                    eff = SkillEffect.Create(effid, pathtype, true, dir, time, 0, delay + i * interval);
                else
                    eff = SkillEffect.Create(effid, pathtype, false, -1, time, 0, delay + i * interval);
                eff.setPosition( ToolBase.RamdonRangeInt( pixelPos.x - range, pixelPos.x + range ), ToolBase.RamdonRangeInt( pixelPos.y - range, pixelPos.y + range ) );
                if( isBottom )
                    Mgr.sceneLayer.AddBottom( eff );
                else
                    Mgr.sceneLayer.AddTop(eff);
            }
        },
    };