var ApplyFriendPanelExt = ApplyFriendPanel.extend ( {
	_className:"ApplyFriendPanelExt",
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
		this.layoutCom.layoutType = MLLAYOUT_C;
	},
	Init:function()
	{
		ApplyFriendPanel.prototype.Init.call(this);
		this._SetLocalProperty();
		this._HandleButton();
		this._AddListview();
	},
	_SetLocalProperty:function()
	{
		this.listview = null;
	},
	_HandleButton:function()
	{
		var self = this;
		this.btnNo.addClickEventListener(function()
		{
			self._SendFriendMsg(0);
		});
		this.btnYes.addClickEventListener(function()
		{
			self._SendFriendMsg(1);
		});
		this.btnClose.addClickEventListener(function()
		{
			Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).GetNewFriendApplyNotice(Mgr.friend.applyList.Size());
			Mgr.uiMgr.HidePanel(self);
		});
	},
	//一次不能向服务器发送太多消息，这里每十条发送一次，中间隔两秒
	_SendFriendMsg:function(type)
	{
		var time = 2;
		var items = this.listview.getItems();
		var len = items.length;
		var count01 = Math.floor(len/10);
		var count02 = len%10;
		if(count01>0)
		{
			var mm = count01,gap = 10;
			this.schedule(function()
			{
				for(var i = (mm-1)*gap; i<mm*gap;i++)
				{
					items[i].SendFriendMsg(type);
				}
				if(mm-1>0)
				{
					mm--;
				}
			},time,count01-1);
		}
		for (var i = 0; i < count02; i++)
		{
			items[count01*10+i].SendFriendMsg(type);
		}
	},
	_AddListview:function()
	{
		var listView = new ccui.ListView();
		listView.setContentSize(cc.size(this.imgBg.width,this.imgBg.height-this.img2.height-12));
		listView.setBounceEnabled(true);
		listView.setScrollBarEnabled(false);
		listView.setPosition(1,3);
		this.imgBg.addChild(listView);
		this.listview = listView;
	},
	UpdateApplyList:function(msg)
	{
		this.listview.removeAllItems();
		var data = msg.playerBriefs;
		for ( var i = 0; i < data.length; i++ )
		{
			var friend = Mgr.friend.friendList.Get(data[i].playerid);
			if(friend){continue;}
			var item = new ApplyFriendListExt();
			item.LoadPanel();
			item.UpdataInfo(data[i]);
			this.listview.pushBackCustomItem(item);
		}
	},
	OnShow:function()
	{
		var data = Mgr.friend.applyList;
		Mgr.player.SendReqPlayerBriefMessage(data.Values(),EnumBriefType.FRIEND_APPLY);
		Mgr.friend.SendReqApplyListInfoMessage();
	}
} );
ApplyFriendPanelExt.PanelName = "ApplyFriendPanelExt";
PanelClassDic["ApplyFriendPanelExt"] = ApplyFriendPanelExt;
