var FacePanelExt = FacePanel.extend ( {
	_className:"FacePanelExt",
	_sizee:null,
	_tableview:null,
	_itemWidth:85,
    _faceWidth:82,
    _faceHeight:82,
	_buttonIndex:[0,1],
	_pos01:cc.p(0,0),
	_pos02:cc.p(0,0),
    _isFaceview:true,
    _scrollview:null,
    _btnStates : [ MUICheckBox.STATE_CHECK , MUICheckBox.STATE_UNCHECK],
	ctor:function(){
		this._super();
	},
	Init:function()
	{
		FacePanel.prototype.Init.call(this);
		this._SetLocalProperty();
        this._HandleTableview();
		this._SetTouchListener();
		this._HandleButton();
        this._AddScrollview();
	},
	_SetLocalProperty:function()
	{
		this.listener = null;
		this.inputEditPanel = null;
		this.inputEdit = null;
		this.btnArr = [this.sbtnFace,this.sbtnEquip];
		//
		var gap = 7;
		//this.setContentSize(570,this.height);
        this.setContentSize(833,this.height);
		this.imgLine.x = 122;
		this.sbtnFace.scale = 0.8;
		this.sbtnEquip.scale = 0.8;
		this.btnBack.scale = 0.8;
		this.sbtnFace.setPosition(7,this.height-this.sbtnFace.height*this.sbtnFace.scale - gap);
		this.sbtnEquip.setPosition(7,this.sbtnFace.y-this.sbtnEquip.height*this.sbtnEquip.scale);
		this.sbtnEquip.SetText("背包");
		this.btnBack.x = 7;
		this._sizee = cc.size(this.width-125,this.height-23);
	},
	_HandleButton:function()
	{
		var self = this;
		this.btnBack.addClickEventListener(function()
		{
			self._HideSelf();
		});
		this.sbtnFace.addClickEventListener(function()
		{
            self._isFaceview = true;
			self._HandleButtonEvent();
		});
		this.sbtnEquip.addClickEventListener(function()
		{
            self._isFaceview = false;
			self._HandleButtonEvent();
		});
	},
    _HandleButtonEvent:function()
    {
        this._ControlView();
    } ,
	_SetFaceEvent:function(data, state)
	{
        this._GetInputEdit().string += data;
	},
	_SetItemsEvent:function(item, state)
	{
		if(state == ccui.Widget.TOUCH_ENDED)
		{
			var itemm = Q_item.Get(item.itemModelId);
			var itemVo = new ShowHyperVo();
			itemVo.type = EnumLinkType.ITEM;
			itemVo.hexsid = item.itemId.hexValue;
			itemVo.mid = item.itemModelId;
			itemVo.str = "["+itemm.q_name+"]";
			itemVo.color = ColorUtil.NumToHtmlC(ItemUtil.GetItemNamecolor(item));
			itemVo.pos = this._GetInputEdit().string.length;
			this._GetInputEdit().setString(this._GetInputEdit().string+itemVo.str);
			this.inputEditPanel.SetExtraReqInfo(itemVo);
		}
	},
	_GetInputEdit:function()
	{
		if(this.inputEditPanel._className == FriendPanelExt.PanelName)
		{
			this.inputEdit = this.inputEditPanel.editCue;
		}
		else if(this.inputEditPanel._className == ChatPanelExt.PanelName)
		{
			this.inputEdit = this.inputEditPanel.editCue;
		}
		return this.inputEdit;
	},
	ShowFacePanel:function(pos,panel,type)
	{
        if(type == 1)
        {
            this.setContentSize(570,this.height);
        }
        else
        {
            this.setContentSize(833,this.height);
        }
        this._sizee = cc.size(this.width-125,this.height-23);
		this.setPosition(pos.x-this.width*3/4,pos.y+80);
		if(this.x<0){this.x = 0;}
		if(this.y+this.height>ToolBase.GetWinHeight()){this.y = ToolBase.GetWinHeight()-this.height;}
		this.inputEditPanel = panel;
		this.setLocalZOrder(1000);
        this.UpdateTableview();
	},
	_SetTouchListener:function()
	{
		var self = this;
		this.listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: function (touch, event) {
				var pos = touch.getLocation();
				if(pos.x<self.x ||pos.x>self.x+self.width ||pos.y<self.y||pos.y>self.y+self.height)
				{
					self.listener.setSwallowTouches(false);
					self._HideSelf();
				}
				return true;
			},
			onTouchMoved: function (touch, event) {
			},
			onTouchEnded: function (touch, event) {
			},
			onTouchCancelled: function (touch, event) {
			}
		});
		cc.eventManager.addListener(this.listener, this);
	},
	_HideSelf:function()
	{
		EngineMgr.uiMgr.HidePanel(this);
	},
	OnHide:function()
	{
		this._super();
		this.listener.setSwallowTouches(false);
	},
	OnShow:function()
	{
		this.listener.setSwallowTouches(true);
        this._ControlView();
	},
    _ControlView:function()
    {
        if(this._isFaceview)
        {
            this._scrollview.visible = true;
            this._tableview.visible = false;
            this.sbtnFace.SetButtonState(this._btnStates[0]);
			this.sbtnEquip.SetButtonState(this._btnStates[1]);
            this.sbtnFace.SetTextColor(EnumFontFormat.COMMON_COLOR05);
            this.sbtnEquip.SetTextColor(EnumFontFormat.COMMON_COLOR03);
        }
        else
        {
            this.UpdateTableview();
            this._scrollview.visible = false;
            this._tableview.visible = true;
            this.sbtnFace.SetButtonState(this._btnStates[1]);
            this.sbtnEquip.SetButtonState(this._btnStates[0]);
			this.sbtnFace.SetTextColor(EnumFontFormat.COMMON_COLOR03);
			this.sbtnEquip.SetTextColor(EnumFontFormat.COMMON_COLOR05);
        }
    },
    _AddScrollview:function()
    {
        var sc = Mgr.crossteam.GetScrollView();
        sc.setContentSize(this._sizee);
        sc.setPosition(130,15);
        sc.setInnerContainerSize(this._sizee);
        this.addChild(sc);
        this._scrollview = sc;
        this._GetChatAnimation();
    },
	_HandleTableview: function ()
	{
		var size = this._sizee;
		var tableview = new cc.TableView(this,cc.size(size.width,size.height));
		tableview.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
		tableview.setDelegate(this);
		tableview.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
		tableview.setPosition(130,15);
		tableview.reloadData();
		tableview.setBounceable(true);
		this.addChild(tableview);
		this._tableview = tableview;
	},
	UpdateTableview:function()
	{
        if(this._tableview)
        {
            this._tableview.reloadData();
        }
        if(this._scrollview)
        {
            this._ResetChatAnimationPosition();
        }
	},
	tableCellTouched: function (table, cell) {
	},

	tableCellSizeForIndex: function (table, idx) {
		return cc.size(this._sizee.width,this._itemWidth);
	},
	tableCellAtIndex: function (table, idx) {
		var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item = this._GetBackpackItem(idx);
            cell.item=item;
            cell.addChild(item);
        } else {
            cell.item.UpdateInfo(idx);
        }
		return cell;
	},
	numberOfCellsInTableView: function (table)
    {
        var items = Mgr.backpack.GetItems();
        var hor = Math.floor(this._sizee.width/this._itemWidth);
        var hLen = Math.ceil(items.length/hor);
        return hLen;
	},
	_GetBackpackItem:function(index)
	{
		var self = this;
		var count = 0;
		var gap = 2;
		var itemWidth = this._itemWidth;
		var hor = Math.floor(this._sizee.width/itemWidth);
		var items = Mgr.backpack.GetItems();
        items.sort( function (a,b) {a.itemModelId - b.itemModelId});
		var layer = new cc.Layer();
		layer.setContentSize(cc.size(this._sizee.width,itemWidth));
		for(var i = index*hor; i < index*hor+hor; i++ )
		{
			if(items[i])
			{
				var icon = GridUtil.SetItemGrid(null,items[i],ResUrl.ITEM_SIZE_60,null,null,false);
				icon.setPosition(count%hor*(itemWidth+gap),0);
				layer.addChild(icon);
				icon.data = items[i];
				icon.setTouchEnabled(true);
				icon.setSwallowTouches(false);
				icon.addTouchEventListener(function(target,state)
				{
					self._SetItemsEvent(target.data,state);
				});
				count++;
			}
		}
		layer.UpdateInfo = function(index)
		{
            var items = Mgr.backpack.GetItems();
            items.sort( function (a,b) {a.itemModelId - b.itemModelId});
            var hor = Math.floor(self._sizee.width/itemWidth);
			count = 0;
			layer.removeAllChildren();
			for(var i = index*hor; i <index*hor+hor; i++)
			{
				if(items[i])
				{
					var icon = GridUtil.SetItemGrid(null,items[i],ResUrl.ITEM_SIZE_60,null,null,false);
					icon.setPosition(count%hor*(itemWidth+gap),0);
					layer.addChild(icon);
					icon.data = items[i];
					icon.setTouchEnabled(true);
					icon.setSwallowTouches(false);
					icon.addTouchEventListener(function(target,state)
					{
						self._SetItemsEvent(target.data,state);
					});
					count++;
				}
			}
		}
		return layer;
	},
    _GetChatAnimation:function()
    {
        var self = this;
        var hor = Math.floor(this._sizee.width/this._faceWidth);
        var layer = cc.Layer.create();
        layer.setContentSize(this._sizee);
        this._scrollview.addChild(layer);
        var listHead = Mgr.chat.faceAniRes;
        for(var i = 0,len = listHead.length; i < len; i++ )
        {
            var sp = Mgr.chat.GetChatAnimationByIndex(i);
            var layout = ccui.Layout.create();
            layout.setContentSize(sp.getContentSize());
            sp.setPosition(layout.width/2,layout.height/2);
			layout.scale = 2;
            layout.addChild(sp);
            layout.setPosition(i%hor*(this._faceWidth) + 15,layer.height-this._faceHeight*(Math.floor(i/hor)+1));
            layer.addChild(layout);
            layout.setTouchEnabled(true);
            var m = (i+1);
            var str ="00"+m;
            if(m>=10&&m<100){str = "0"+m;}
            if(m>=100){str = m;}
            layout.data = "#10"+str;
            layout.addTouchEventListener(function(target,state)
            {
                if(state == ccui.Widget.TOUCH_ENDED)
                {
                    self._SetFaceEvent(target.data,state);
                }
            });
        }
    },
    _ResetChatAnimationPosition:function()
    {
        var parent = this._scrollview.getChildren()[0];
        var childs = parent.getChildren();
        var hor = Math.floor(this._sizee.width/this._faceWidth);
        for(var i = 0,len = childs.length; i < len; i++ )
        {
            childs[i].setPosition(i%hor*(this._faceWidth) + 15,parent.height-this._faceHeight*(Math.floor(i/hor)+1));
        }
    }
} );
FacePanelExt.PanelName = "FacePanelExt";
PanelClassDic["FacePanelExt"] = FacePanelExt;

















