var DuihuanMainExt = DuihuanMain.extend ( {
	_className:"DuihuanMainExt",

    _vScrollView:null,
    _frameList:[],
    _height:null,

	ctor:function(){
		this._super();
	},

    Init:function(){
        DuihuanMain.prototype.Init.call(this);
        this._frameList = [];
        this.InitView();
        Mgr.shop.duihuanPanel = this;
    },

    InitView:function(){
        if(!this._vScrollView){
            this._vScrollView = new ccui.ScrollView();
            this._vScrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._vScrollView.setTouchEnabled(true);					//触摸开启
            this._vScrollView.inertiaScrollEnabled = true; 			//滚动惯性
            this._vScrollView.setScrollBarEnabled(false);				//滚动条
            this._vScrollView.setBounceEnabled(true);					//边界回弹
            // this._vScrollView.setScrollBarAutoHideTime(1);
            this.imgBg.addChild(this._vScrollView);
        }
    },

    ShowFrame:function(){
        //this.ClearVScrollView();
        // var list = Q_shop_data.GetList();
        var listShop = Mgr.shop.GetGoodsByHs(EnumShopType.EXCHANGE_SHOP);
        if (listShop == null) {
            // Mgr.shop.witeShop=2;
            Mgr.shop.duihuanPanel = this;
            Mgr.shop.SendReqShopListMessage(EnumShopType.EXCHANGE_SHOP);
            return;
        }
        // list=JSON.parse(list);
        for(var i = 0; i != listShop.length; i++){
            if(!this._frameList[i]){
                var btnCall = new FulidatingDuihuanExt();
                btnCall.LoadPanel();
                btnCall.x = 0;
                btnCall.y = btnCall.uiHeight*(listShop.length-i-1);

                this._height = btnCall.uiHeight;

                this._frameList.push(btnCall);
                this._vScrollView.addChild(btnCall);
            }
            this._frameList[i].SetData(listShop[i]);
        }

        this._vScrollView.setSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
        this._vScrollView.setInnerContainerSize(cc.size(this.imgBg.uiWidth, listShop.length * this._height));
    },

	OnShow:function(){
        Mgr.shop.duihuanPanel = this;
        Mgr.shop.SendReqShopListMessage(EnumShopType.EXCHANGE_SHOP);
        // this.ShowFrame();
    },

    OnHide:function(){
        this._super();
        Mgr.shop.duihuanPanel = null;
    }
} );
DuihuanMainExt.PanelName = "DuihuanMainExt";
PanelClassDic["DuihuanMainExt"] = DuihuanMainExt;
