var TaijiActivitiesListExt = TaijiActivitiesList.extend ( {
	_className:"TaijiActivitiesListExt",
	_id:0,
	_type:0,
	_isGray:false,
	_crayNum:-1,
	ctor:function(){
		this._super();
	},
	
	Init:function(){
		TaijiActivitiesList.prototype.Init.call( this );
        this.setTouchEnabled(false);
        this.imgList.setSwallowTouches(false);

		this.imgGaoliang.setVisible(false);
        this.imgList.setZoomScale(0);
		var self = this;
        this.imgList.addTouchEventListener(function (sender,type) {
            if ( type == ccui.Widget.TOUCH_BEGAN ){
                sender._startPos = sender.getTouchBeganPosition();
            }else if ( type == ccui.Widget.TOUCH_ENDED ){
                var endPos = sender.getTouchEndPosition();

                if(Math.abs(endPos.y - sender._startPos.y) > 20) return;

                Mgr.gossip.taijiPanel.activityPanel.SetCurActiveShow(self._id);
            }
        })

		this.btnGo.addClickEventListener(function () {
			if(self._type == EnumZoneActiveType.TYPE_GUARDCPITAL){
				Mgr.guardcpital.isGoToActive = true;
				Mgr.guardcpital.Fly2ActivityArea();
			}else if(self._type == EnumZoneActiveType.TYPE_SWORD){
				Mgr.sword.SendReqEnterSwordZoneMessage();
			}else if(self._type == EnumZoneActiveType.TYPE_HUSONG){
				Mgr.convoy.SendReqConvoyTransferToGameMessage();
			}else if(self._type == EnumZoneActiveType.TYPE_GUILD){
				Mgr.chat.curChatChannel = EnumChatChannelType.FACTION;
				Mgr.chat.ShowHideChatPanel(true);
			}else if(self._type == EnumZoneActiveType.TYPE_ZONE){
				Mgr.zoneteam.RequestZoneListData();
			}else if(self._type == EnumZoneActiveType.TYPE_GUILDBOSS_JY){
				//阻击后援（精英）
			}else if(self._type == EnumZoneActiveType.TYPE_WORLDBOSS){
				//世界首领
                var isOpen = BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP1,BtnGroupUtil.MINIMAP1_WORLDBOSS);
                if(isOpen)
                {
                    Mgr.monster.SendReqQueryBossListMessage(0);
                }
			}else if(self._type == EnumZoneActiveType.TYPE_GUILDBOSS){
				var isGuild = !Mgr.player.mainPlayer.guildId.IsZero();
				if(isGuild)
					Mgr.uiMgr.ShowPanelByType( GuildPanelExt.PanelName ).ChangePanel(GuildEnum.PANEL_BOSS);
				else{
                    Mgr.uiMgr.ShowPanelByType( GuildPanelExt.PanelName ).ChangePanel(GuildEnum.PANEL_LIST);
                    Mgr.tips.ShowNotice("请先加入一个帮会");
                }
            }else if(self._type == EnumZoneActiveType.TYPE_MASTERBUCKET){
                MasterBucketUtil.Fly2ActivityArea();
            }
			else if( self._type == EnumZoneActiveType.TYPE_ZHUJIANTIANXIA ){	//铸剑天下
				Mgr.map.SendReqGoldMapTransMessage(1003);
                Mgr.monster.showType = 4;
			}else if( self._type == EnumZoneActiveType.TYPE_ERENGU ){	//恶人谷
				cc.log("erengu");
				Mgr.monster.SendReqQueryBossListMessage(0);
				Mgr.monster.showType = 3;
			}else if(self._type == EnumZoneActiveType.TYPE_KINGGUID
                 || self._type == EnumZoneActiveType.TYPE_KINGNEUTRAL
            ){
                 EngineMgr.uiMgr.ShowPanelByType(TaijiPanelExt.PanelName).ChangeView(EnumGrossipType.TYPE_GUILD);
                 // EngineMgr.uiMgr.ShowPanelByType(TimeActivitiesPanelExt.PanelName);
                return;
            }

			EngineMgr.uiMgr.HidePanelByType(TaijiPanelExt.PanelName);
		});
	},
	
	GetOpenDateStr:function(str){
		var dayArr = JSON.parse(str);
		var dateStr = "";
		for( var j = 0; j < dayArr.length; j++ ){
			var daynum = parseInt(dayArr[j]);
			if( daynum == -1 ){
				dateStr = "天";
				break;
			}
			if(j!=0)
				dateStr+="、";
			dateStr += TextUtil.GetWeekStr(daynum);
		}
		return dateStr;
	},

    SetActivityId:function(v){
        this.data = v;

        var data = v.data;

        var id =data.q_id
        this._id = id;
        this._type = data.q_type;

        UIUtil.LoadButtonImage( this.imgList, "other/richangrenwu/image/bg/" + id + ".png");
        this.labCue.setVisible(false);
        this.imgDikuang.setVisible(false);
        this.imgDikuang2.setVisible(false);
        this.imgOver.setVisible(false);
        this.btnGo.setVisible(false);

        if(data.q_type == 5 && v.state != 0){
            this.btnGo.setVisible(true);
            this.btnGo.setTitleText("护送");
            this.labName.SetHtmlText(TextUtil.FormatStr( this.labName.GetHtmlText(), [ "护送"] ));
        }else {
            this.btnGo.setVisible(false);
            this.labName.SetHtmlText(TextUtil.FormatStr( this.labName.GetHtmlText(), [ data.q_name ] ));
        }

        var textTime = "";
        var colorTime = "0x743804";
        switch(v.state){
            case 0: // 火热进行中
                if(data.q_type == 5){
                    this.btnGo.setTitleText("双倍护送");
                }else {
                    this.btnGo.setTitleText("参加活动");
                }
                this.btnGo.setVisible(true);
                this.imgDikuang.setVisible(true);
                textTime = "火热进行中！活动时间：" + v.nextTime;
                colorTime = "0x78ff00";
                break;
            case 1: // 今日活动即将开启
                textTime = "活动即将开启！活动时间：" + v.nextTime;
                colorTime = "0x78ff00";
                break;
            case 2: // 今日活动
                textTime = "活动时间：" + v.nextTime;
                break;
            case 3: // 以后活动
                textTime = "下次活动时间：" + TimeUtil.GetDateStr(v.nextDate.getTime() / 1000, "MM月dd日 ")
                    + v.nextTime;
                break;
            case 4: // 今日活动已结束
                textTime = "今日活动已经结束！活动时间：" + v.nextTime;
                this.imgOver.setVisible(true);
                break;
            case 5: // 等级不够
                textTime = "活动时间：" + v.nextTime + "（每" + this.GetOpenDateStr(v.data.q_day) + "开启）";

                this.labCue.SetHtmlText(TextUtil.FormatStr( this.labCue.GetHtmlText(), [ data.q_level ] ));
                this.labCue.setVisible(true);
                this.imgDikuang2.setVisible(true);
                this.btnGo.setVisible(false);
                break;
        }
        this.labTime.SetText(textTime);
        this.labTime.SetColor(colorTime);
        //this.labTime.SetHtmlText(TextUtil.FormatStr( this.labTime.GetHtmlText(), [ data.q_time + " （每" + this.GetOpenDateStr(data.q_day) + "开启） " ] ));
        if(this.labCue.visible){
            this.labCue.x = this.labTime.x + this.labTime._textWidth;
        }

        this.SetSelected(Mgr.gossip.taijiPanel.activityPanel._curShowId == id);
    },
    SetSelected:function(selected){
        this.imgGaoliang.visible = selected;
    }
} );
TaijiActivitiesListExt.PanelName = "TaijiActivitiesListExt";
PanelClassDic["TaijiActivitiesListExt"] = TaijiActivitiesListExt;
