var GuildApplyItemExt = GuildApplyItem.extend ( {
	_className:"GuildApplyItemExt",

	_info:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		GuildApplyItem.prototype.Init.call(this);

		this.btnNo.addClickEventListener(function (event){
			self.SendProp( 0 );
		});
		this.btnYes.addClickEventListener(function (event){
			self.SendProp( 1 );
		});
	},

	SendProp:function ( arg ) {
		if ( this._info ) {
			var guildId = Mgr.player.mainPlayer.guildId;
			var applyerId = this._info.applyerId;
			var argee = arg;
			Mgr.guild.SendReqGuildAddMemberMessage( guildId, applyerId, argee );
		}
		else
			cc.log( "Error: applyer info is null ! " );
	},

	SetData:function (data, boo) {
		this.Clear();
		this._info = data;

		// 底板黄红交替
		if (boo)
			this.imgBghuang.setVisible(true);
		else
			this.imgBghong.setVisible(true);

		// name
		this.labName.SetString(data.applyerName);

		// lv
		this.labLevel.SetString(data.applyerLevel);

		// fight
		this.labPower.SetString(data.fightPower);

		// btn
		var personId = Mgr.player.mainPlayer.sid;
		var memberInfo = Mgr.guild.guildMembers.Get( personId );
		cc.assert(null != memberInfo, "guildInfo can't be nil!  personId: " + personId);
		var isAuthority = false;
		var job = memberInfo.guildPowerLevel;
		if ( job == GuildEnum.MEMBER_GUILDER || job == GuildEnum.MEMBER_SECONDGUILDER )
			isAuthority = true;
		this.btnNo.setVisible(isAuthority);
		this.btnYes.setVisible(isAuthority);
	},

	GetData:function () {
		return this._info;
	},

	Clear:function () {
		this.imgBghong.setVisible(false);
		this.imgBghuang.setVisible(false);
		this.imgBgguang.setVisible(false);

		this.labName.SetString("");
		this.labLevel.SetString("");
		this.labPower.SetString("");

		this.btnNo.setVisible(false);
		this.btnYes.setVisible(false);
	},
} );
GuildApplyItemExt.PanelName = "GuildApplyItemExt";
PanelClassDic["GuildApplyItemExt"] = GuildApplyItemExt;
