var GuildDatiTaskPaneExt = GuildDatiTaskPane.extend ( {
	_className:"GuildDatiTaskPaneExt",

    timerId:0,

    time:null,

	ctor:function(){
		this._super();
	},

    Init:function(){
        GuildDatiTaskPane.prototype.Init.call(this);
    },


    onEnter:function(){
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },

    onExit:function(){
        this._super();
        if (this.timerId)
            TimerUtil.ClearTimeUpdate(this.timerId, this);
    },

    InitView:function(){
        UIUtil.ConnectLabelHtmlText(this.labTime1, [0]);
        this.labTime.SetText("00:00:00");

        var activeInfo = Mgr.majorevents.activityHash.Get(EnumZoneActiveType.TYPE_GUILD);
        if(activeInfo){
            var endTime = activeInfo.startTime + activeInfo.endTime - Mgr.login.GetServerTime()/1000;
            this.SetTime(endTime);
        }
	},

    UpdateLabel:function(num){
        UIUtil.ConnectLabelHtmlText(this.labTime1, [num]);
    },

    UpdateView:function(){
    },

    SetTime:function(time){
        this.time = time + Mgr.login.GetServerTime()/1000;
    },

    OnTimer:function(){
        if(this.time){
            var time = Math.ceil(this.time - Mgr.login.GetServerTime()/1000);
            if(time > 0)
                this.labTime.SetText(TextUtil.SecondToHMS2(time));
            else
                this.labTime.SetText(TextUtil.SecondToHMS2(0));
        }
    },
} );
GuildDatiTaskPaneExt.PanelName = "GuildDatiTaskPaneExt";
PanelClassDic["GuildDatiTaskPaneExt"] = GuildDatiTaskPaneExt;
