var GuildTaskPaneExt = GuildTaskPane.extend ( {
	_className:"GuildTaskPaneExt",

    timerId:0,

    time:null,

	ctor:function(){
		this._super();
	},

    Init:function(){
        GuildTaskPane.prototype.Init.call( this );
        // this.imgBg.setTouchEnabled(true);
        // var self = this;
        // this.imgBg.addTouchEventListener(function (sender, type) {
        //     if (type == ccui.Widget.TOUCH_ENDED) {
        //     }
        // });
    },

    onEnter:function(){
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },

    onExit:function(){
        this._super();
        if (this.timerId)
            TimerUtil.ClearTimeUpdate(this.timerId, this);
    },

    InitView:function(list){
        if(Mgr.zone.IsInZoneMap()){
            var zoneType = Mgr.sceneMap.ZoneType();
            if(zoneType == EnumZoneType.TYPE_GUILDBOSS){ // 帮派首领
                this.labFB.SetText("[活动]");
                this.labName.SetText("帮派BOSS");
                var headList = ["通关目标"];
                var backList = [];
                this.InitLabel(headList, list, backList);

                // var activeInfo = Mgr.majorevents.activityHash.Get(EnumZoneActiveType.TYPE_GUILDBOSS);
                // if(activeInfo){
                //     var endTime = activeInfo.startTime + activeInfo.endTime - Mgr.login.GetServerTime()/1000;
                //     this.SetTime(endTime);
                // }
			}
        }
    },

    InitLabel:function(headList, list, backList){
        this.labKill1.SetText("击杀: " + "<u>"+TextUtil.AddColor(Q_monster.Get(list[0].monsterId).q_name + "(0/" + 1 + ")", "24ff13")+"</u>");
        this.monsterId = list[0].monsterId;
        UIUtil.ConnectLabelHtmlText(this.labCue, [list[0].killNums]);
        this.SetTime(list[0].countdowm);
    },

    UpdateLabel:function(monsterId){
	    if(monsterId && this.monsterId){
            this.labKill1.SetText("击杀: " + "<u>"+TextUtil.AddColor(Q_monster.Get(this.monsterId).q_name +
                "(" + 1  + "/" + 1 + ")", "908478")+"</u>");
        }
    },

    UpdateView:function(){

    },

    SetTime:function(time){
        this.time = time + Mgr.login.GetServerTime()/1000;
    },

    OnTimer:function(){
        if(this.time){
            var time = Math.ceil(this.time - Mgr.login.GetServerTime()/1000);
            if(time > 0)
                this.labTime.SetText(TextUtil.SecondToHMS2(time));
            else
                this.labTime.SetText(TextUtil.SecondToHMS2(0));
        }
    },
} );
GuildTaskPaneExt.PanelName = "GuildTaskPaneExt";
PanelClassDic["GuildTaskPaneExt"] = GuildTaskPaneExt;
