var MoshiMainExt = MoshiMain.extend ( {
	_className:"MoshiMainExt",
	_btnTitleArr:[],
	_btnChangeArr:[],
	_imgPos:[81,159,238,317],
	_normalTexture:"other/zhujiemian/image/tanchuang/weixuanzhong.png",
	_selectedTexture:"other/zhujiemian/image/tanchuang/xuanzhong.png",
	_pkModel:[EnumPkMode.PK_MODE_PEACE,EnumPkMode.PK_MODE_GUILD,EnumPkMode.PK_MODE_ALL,EnumPkMode.PK_MODE_SERVER],
	_index:-1,
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.ALPHABLACK;
	},
	Init:function()
	{
		MoshiMain.prototype.Init.call(this);
		this._HandleButton();
	},
	_HandleButton:function()
	{
		var self = this;
		this.btnClose.addClickEventListener(function(){self._CloseSelf();});
		this._btnTitleArr = [this.imgHeping,this.imgBanghui,this.imgQuanti,this.imgBenfu];
		this._btnChangeArr = [this.btnqiehuan11,this.btnqiehuan,this.btnqiehuan1,this.btnqiehuan2];
		for(var i = 0; i < this._btnChangeArr.length; i++ )
		{
			this._btnChangeArr[i].type = this._pkModel[i];
			this._btnChangeArr[i].addClickEventListener(function(target)
			{
				self._HandleChangeModel(target.type);
			});
		}
	},
	_SelectTitleButtn:function(type)
	{
		var self = this;
		for(var i = 0; i < this._btnTitleArr.length; i++)
		{
			if(type == i)
			{
				EngineMgr.uiMgr.GetAsynResByUrl(self._selectedTexture, function(){
					self._btnTitleArr[i].loadTexture(self._selectedTexture,ccui.Widget.PLIST_TEXTURE);
				}, this);
			}
			else
			{
				EngineMgr.uiMgr.GetAsynResByUrl(self._normalTexture, function(){
					self._btnTitleArr[i].loadTexture(self._normalTexture,ccui.Widget.PLIST_TEXTURE);
				}, this);
			}
		}
	},
	_HandleChangeModel:function(type)			//EnumPkMode.PK_MODE_PEACE
	{
		if(type == EnumPkMode.PK_MODE_GUILD && Mgr.player.mainPlayer.guildId.IsZero())
		{
			//type = EnumPkMode.PK_MODE_ALL;//按照之前代码的逻辑，没有帮会切换到this._pkModel[type]，那不是全体模式？
			Mgr.player.SendReqChangePKStateMessage(type);
			return;
		}
		this._index = type;
		for(var i = 0; i < this._btnChangeArr.length; i++ )
		{
			this._btnChangeArr[i].visible = true;
		}
		this._btnChangeArr[this._pkModel.indexOf(type)].visible = false;
		this.img1.y = this._imgPos[3-this._pkModel.indexOf(type)]-40;//this._btnChangeArr[i].getWorldPosition().y+this._btnChangeArr[i].height/2;
		this._SelectTitleButtn(this._pkModel.indexOf(type));
		Mgr.player.SendReqChangePKStateMessage(type);
		var panel = Mgr.uiMgr.GetPanelByType(RoleHeadPanelExt.PanelName);
		panel.ChangeModelText(this._pkModel[type]);
	},
	_CloseSelf:function()
	{
		EngineMgr.uiMgr.HidePanel(this);
	},
	OnShow:function()
	{
		cc.log("Mgr.mainPlayer.curPkMode:"+Mgr.mainPlayer.curPkMode);
		if(this._index != Mgr.mainPlayer.curPkMode){
			this._SelectTitleButtn(Mgr.mainPlayer.curPkMode);
			this._HandleChangeModel(Mgr.mainPlayer.curPkMode);
		}
	}
} );
MoshiMainExt.PanelName = "MoshiMainExt";
PanelClassDic["MoshiMainExt"] = MoshiMainExt;




















