var PifengMainExt = PifengMain.extend ( {
	_className:"PifengMainExt",

    _listView:null,
    _itemList:null,
    _curSelectBtn:null,

    type:null,
    showModelId:null,
    model:null,
    id:null,

    nextOpenCloak:null,

    isActivat:false,
    isFollow:false,

	ctor:function(){
		this._super();
        this._itemList = [];
	},

    Init:function (){
        GenChongMain.prototype.Init.call( this );
        var self = this;
        
        this.setTouchEnabled( false );

        this.btnChuandai.addClickEventListener(function()
        {
            if(self.isActivat){
                if(self.isFollow){
                    Mgr.illusion.SendReqUseIllusionToGameMessage(0, self.type);
                }
                else{
                    Mgr.illusion.SendReqUseIllusionToGameMessage(self.id, self.type);
                }
            }
            else{
                Mgr.illusion.SendReqAddIllusionToGameMessage(self.id, self.type);
            }
        });

        this.labCue3.setTouchEnabled(true);
        this.labCue3.addTouchEventListener(function(sender,type)
        {
            if ( type == ccui.Widget.TOUCH_BEGAN )
            {
            }
            else if ( type == ccui.Widget.TOUCH_ENDED )
            {
            }
            else if ( type == ccui.Widget.TOUCH_CANCELED )
            {
            }
        });
        this.btnLevelup.addClickEventListener(function(event){
            var panel = EngineMgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName);
            panel.ChangePanel(DuanzaoTypeEnum.EQUIP_CLOAK);

            panel.panelMgr[DuanzaoTypeEnum.EQUIP_CLOAK].SetData(self.nextOpenCloak);
        });
        setTimeout(function(){
            self.imgBg.getVirtualRenderer().setBlendFunc( cc.BlendFunc.ALPHA_PREMULTIPLIED );       //etc压缩的时候边缘处理有点问题  先这样简单处理
        }, 500);

        this.InitView();
        // this.InitItem();
    },

    InitView:function(){
        if(!this._listView){
            this._listView = new ccui.ListView();
            this._listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._listView.setTouchEnabled(true);					//触摸开启
            this._listView.inertiaScrollEnabled = false; 			//滚动惯性
            this._listView.setScrollBarEnabled(false);				//滚动条
            this._listView.setBounceEnabled(true);					//边界回弹
            // this._listView.setScrollBarAutoHideTime(1);
            this._listView.addEventListener(this._SelectedBtnEvent);
            this.imgBg1.addChild(this._listView);
        }
    },

    InitItem:function(){
        var list = Q_illusion.GetList();
        list.sort(function(a, b){ return a.q_order - b.q_order; });
        var t = 0;
        for(var i = 0; i < list.length; i++){
            var data = list[i];
            var illusion = Mgr.illusion.GetIllusion(this.type, data.q_id);
            if(data.q_type == this.type && data.q_order > 0 && (illusion ||  data.q_need_id == 0)){
                var item = this._itemList[t];
                if(!item){
                    item  = new PifengFrameExt();
                    item.LoadPanel();
                    item.x = 0;
                    item.y = item.uiHeight*(list.length-i-1);
                    this._height = item.uiHeight;
                    this._listView.addChild(item);
                    this._itemList.push(item);
                }
                item.visible = true;
                item.SetData(data);
                item.isAward = illusion != null;
                item.SetActivat(illusion != null);
                if( Mgr.illusion.IsShowIllusion(this.type, data.q_id) ){
                    if( !this._curSelectBtn )
                        this._curSelectBtn = item;
                    item.SetWear(true);
                }
                else{
                    item.SetWear(false);
                }
                t++;
            }
        }
        this._listView.setSize(cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
        this._listView.setInnerContainerSize(cc.size(this.imgBg1.uiWidth, t * this._height));
        for( ; t < this._itemList.length; t++ ){
            if( this._itemList[t] )
                this._itemList[t].visible = false;
        }
    },

    _SelectedBtnEvent:function(sender, type){
        switch (type) {
            case ccui.ListView.ON_SELECTED_ITEM_END:
                var parent = sender.parent.parent;
                if (parent._curSelectBtn != null) {
                    parent._curSelectBtn.SetSelect(false);
                    parent._curSelectBtn = null;
                }

                var idx = sender.getCurSelectedIndex();
                var btnSelect = sender.getItem(idx);
                parent._curSelectBtn = btnSelect;
                parent.ChangePetInfo();
                btnSelect.SetSelect(true);
                break;
            default:
        }
    },

    SetType:function(type){
        this.type = type;
        if( this._curSelectBtn )
            this._curSelectBtn.SetSelect(false);
        this._curSelectBtn = null;
        this.RefreshPanel();
        this.labShizhuang.SetHtmlText( this.type == HuanhuaType.TYPE_WEAPON ? "神武" : "披风" );
    },

    ChangePetInfo:function(){
        this.labZhandouli1.SetText(this._curSelectBtn.power);
        this.labGongji1.SetText(this._curSelectBtn.attack);
        this.labFangyu1.SetText(this._curSelectBtn.defense);
        this.labHP1.SetText(this._curSelectBtn.hp);
        this.labName1.SetText(this._curSelectBtn.spAttri);
        this.labCue3.SetText(this._curSelectBtn.getPosStr);
        this.ShowModel(this._curSelectBtn.modelId);
        this.imgDiKuang.visible = this._curSelectBtn.isFollow;
        this.id = this._curSelectBtn.id;
        // this.imgDiBg.visible = this._curSelectBtn.isFollow;

        this.showModelId = this._curSelectBtn.modelId;
        this.isActivat = this._curSelectBtn.isActivat;
        this.isFollow = this._curSelectBtn.isFollow;

        if(this.nextOpenCloak){
            if(!Mgr.illusion.GetIllusion(this.type, this.type + "_" + this._curSelectBtn.id))
                this.btnLevelup.visible = false;
            else
                this.btnLevelup.visible = true;
            // this.btnLevelup.visible = true;
        }
        else{
            this.btnLevelup.visible = false;
        }

        this.RefreshBtn();
    },

    RefreshPanel:function(){
	    if(this.nextOpenCloak){
            this.nextOpenCloak = null;
        }

	    this.InitItem();

        if(!this._curSelectBtn){
            this._curSelectBtn = this._itemList[0];
        }
        this._curSelectBtn.SetSelect(true);
        this.ChangePetInfo();
    },

    RefreshBtn:function(){
        if(this.isActivat){
            if(this.isFollow){
                this.btnChuandai.setTitleText("取消")
            }
            else{
                this.btnChuandai.setTitleText("幻化")
            }
        }
        else{
            this.btnChuandai.setTitleText("激活")
        }
    },

    ChangeShow:function(id){
        for(var i = 0; i < this._itemList.length; i++){
            this._itemList[i].SetWear(id == this._itemList[i].id);
        }
        this.ChangePetInfo();
    },

    ShowModel:function(showId){
        var modelId = 0;
        if( this.type == HuanhuaType.TYPE_CLOAK )
            modelId = Mgr.mainPlayer.nJobId*1000 + showId;
        else if( this.type == HuanhuaType.TYPE_WEAPON )
            modelId = showId;
        if(!this.model){
            this.model = new UIModel(modelId, this.type);
            this.model.x = 70;
            this.imgModel.addChild(this.model);
        }
        else{
            this.model.SetModelId(modelId, this.type);
        }
    },
    
    OnShow:function(){
        Mgr.illusion.onIllusionDataChange.add(this.RefreshPanel, this);
        Mgr.illusion.onIllusionShowChange.add(this.ChangeShow, this);
    },
    
    OnHide:function(){
        Mgr.illusion.onIllusionDataChange.remove(this.RefreshPanel, this);
        Mgr.illusion.onIllusionShowChange.remove(this.ChangeShow, this);
    },
} );
PifengMainExt.PanelName = "PifengMainExt";
PanelClassDic["PifengMainExt"] = PifengMainExt;
