var ShenJiangExt = ShenJiang.extend ( {
	_className:"ShenJiangExt",
	ctor:function(){
		this._super();
	},

	Init:function () {
		ShenJiang.prototype.Init.call(this);

		this.myIndex = -1;
		this.myCost = 0;
        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgContent.uiWidth, this.imgContent.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            this.cellPanel=tableView;
            this.imgContent.addChild(tableView);
        }

        var self = this;
        this.labChakan.setTouchEnabled(true);
        this.labChakan.addTouchEventListener(function (sender, type) {
            if(type == ccui.Widget.TOUCH_ENDED){
                var panel = Mgr.uiMgr.ShowPanelByType(PaiHangApplyListExt.PanelName);
                panel.SetData(self.activityList);
            }
        });
    },

    SetActivityList:function (infoList, isOpen) {
        this.activityList = infoList;
        this.totalNum = infoList.length;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        UIUtil.ConnectLabelHtmlText( this.labTime, [this.activityList[0].durationStr] );
        var allRankInfos = [];
        for(var i = 0; i < this.activityList.length; i++) {
            var rankInfos = this.activityList[i].special[0].beanInfo.rankInfos;
            if(rankInfos && rankInfos.length > 0){
                allRankInfos = allRankInfos.concat(rankInfos);
            }
        }
        this.rankInfos = allRankInfos;
        for(var k = 0; k < this.rankInfos.length; k++){
            var rankInfo = allRankInfos[k];
            if(rankInfo.playerid.toGID() == Mgr.player.mainPlayer.sid.toGID()){
                this.myIndex = k+1;
                break;
            }
        }
        var beanInfo = this.activityList[0].special[1].beanInfo;
        if(beanInfo){
            this.myCost = beanInfo.gold;
        }
        UIUtil.ConnectLabelHtmlText(this.labMuQian, [this.myCost]);
        if(this.myIndex > 0){
            UIUtil.ConnectLabelHtmlText(this.labPaiming, [this.myIndex]);
        }else {
            this.labPaiming.SetHtmlText("<font color=\"#3a2707\">我的排名：<font color=\"#dc143c\">未上榜");
        }
        this.cellPanel.reloadData();
    },

    UpdateSingleActivity:function(info){
        for(var i = 0; i < this.activityList.length; i++){
            var ac = this.activityList[i];
            if(ac.activityId == info.activityId){
                this.activityList[i] = info;
                break;
            }
        }

        for(var i = 0; i < this.totalNum; i++){
            var cell = this.cellPanel.cellAtIndex(i);
            if(cell){
                var item = cell.item;
                if(item && item._data.activityId == info.activityId){
                    item.SetData(info, i + 1);
                    break;
                }
            }
        }
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(800,94);
    },
    tableCellAtIndex: function (table, idx) {
        var data = this.activityList[idx];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item = new PaimingExt();
            item.LoadPanel();
            item.setTouchEnabled(false);
            cell.item = item;
            cell.addChild(item);
        }
        cell.item.SetData(data, idx + 1);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    }
} );
ShenJiangExt.PanelName = "ShenJiangExt";
PanelClassDic["ShenJiangExt"] = ShenJiangExt;
