var InvestPlanMainExt = InvestPlanMain.extend ( {
	_className:"InvestPlanMainExt",

	_scrollView:null,
	_viewList:[],
	_isInvest:false,

	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
	},

    Init:function(){
        InvestPlanMain.prototype.Init.call(this);
        this.layoutCom.layoutType = MLLAYOUT_C;

        var self = this;
        this.btnClose.addClickEventListener(function(event){
            EngineMgr.uiMgr.HidePanel(self);
        });

        this.btnGo.addClickEventListener(function(event){
        	if(self._isInvest)
                Mgr.bank.SendReqBankWeekAwardToGameMessage();
        	else
            	Mgr.bank.SendReqBankBuyWeekToGameMessage();
		});
        UIUtil.LoadImage( this.imgCue, "other/touzijihua/word/xuanchuanzi.png" );
    },

	OnShow:function(){
		Mgr.bank.weekInvestpanel = this;
        this.InitView()
	},

	InitView:function(){
		var list = JSON.parse(Q_global.Get(1142).q_string_value);

		for(var i = 0; i < list.length; i++){
			if(!this._viewList[i]){
				var view = new InvestPlanFrameExt();
                view.LoadPanel();
                if(i < 4)
                	view.x = (view.uiWidth + 10 )*i + 16;
                else
                    view.x = (view.uiWidth + 10 )*(i-3) - view.uiWidth/2 + 16;
                view.y = (view.uiHeight + 10 ) * Math.abs((parseInt((7 - i)/4))) + 13;
                this.imgBg.addChild(view);
                this._viewList.push(view);
			}
            this._viewList[i].SetData(i + 1, list[i]);
		}

	},

	RefreshPanel:function(info){
		if(info.indexDay > 0){
            this._isInvest = true;
            if(info.indexDay > info.getRwardNum){
                // this.btnGo.jsonobj.buttonText = "领取";
                // this.btnGo.Init();
                Filter.UnGray(this.btnGo);
                this.btnGo.setTitleText("领取");
            }
            else{
                Filter.GrayScale(this.btnGo);
                this.btnGo.setTitleText("已领取");
			}
		}
		else{
            Filter.UnGray(this.btnGo);
			this._isInvest = false;
            this.btnGo.setTitleText("立即投资");
		}
        var i = 0;
		for(; i < info.getRwardNum; i++){
            this._viewList[i].imgGet.visible = true;
		}
        for(; i < this._viewList.length; i++){
            this._viewList[i].imgGet.visible = false;
        }
	},

	OnHide:function(){
        this._super();
        Mgr.bank.weekInvestpanel = null;
	}

} );
InvestPlanMainExt.PanelName = "InvestPlanMainExt";
PanelClassDic["InvestPlanMainExt"] = InvestPlanMainExt;
