///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//138201,ReqkingneutralClientToGame 请求面板信息
//138202,ReqkingneutralEnterClientToGame 请求进入战场
//138203,ReqGetkingNeutralAwardClientToGame 请求领取王城战每日奖励

// 接收消息
//138101,ReskingneutralGameToClinet 发送皇城站面板信息
//138102,ReskingneutralTopGameToClinet 发送王城战排行榜信息（战场用）
//138103,ReskingneutralTaskGameToClinet 发送王城战战场信息


////////////////////
// 发送皇城站面板信息 //
////////////////////
var ReskingneutralGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.guildname = null; // 帮会名称
        this.captainname = null; // 帮主名称
        this.job = 0; // 帮主职业
        this.isAward = 0; // 领奖(1可领奖2已领取)
	},

	getId:function(){
		return 138101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.guildname);
        _buf.WriteString(this.captainname);
        _buf.WriteByte(this.job);
        _buf.WriteByte(this.isAward);
	},
	
	reading:function( _buf ){
        this.guildname = _buf.ReadString();
        this.captainname = _buf.ReadString();
        this.job = _buf.ReadByte();
        this.isAward = _buf.ReadByte();
	},

	action:function(){
		Mgr.kingneutral.RecvReskingneutralGameToClinetMessage(this);
	},

});
////////////////////
// 发送王城战排行榜信息（战场用） //
////////////////////
var ReskingneutralTopGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.toplist = []; // 排行榜信息 Killtopinfo
	},

	getId:function(){
		return 138102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.toplist.length );
        for (var i = 0; i < this.toplist.length; i++) {
            _buf.WriteBean(this.toplist[i]);
        }
	},
	
	reading:function( _buf ){
        var toplist_length = _buf.ReadShort();
        for (var i = 0; i < toplist_length; i++) {
            this.toplist[i] = _buf.ReadBean(Killtopinfo);
        }
	},

	action:function(){
		Mgr.kingneutral.RecvReskingneutralTopGameToClinetMessage(this);
	},

});
////////////////////
// 发送王城战战场信息 //
////////////////////
var ReskingneutralTaskGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.mapmodelid = 0; // 地图modelid
        this.remandtime = 0; // 剩余时间
        this.outstatue = 0; // 外城状态（0表示普通城门还没破，1表示普通城门破了传送点出现，2表示石门出现）
        this.playernum = 0; // 帮会剩余人数(内城人数)
        this.npcOwnTime = 0; // Npc持有时间
        this.npcOwnId = null; // Npc持有者Id
        this.npcOwnName = null; // Npc持有者名字
	},

	getId:function(){
		return 138103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.mapmodelid);
        _buf.WriteVarInt(this.remandtime);
        _buf.WriteVarInt(this.outstatue);
        _buf.WriteVarInt(this.playernum);
        _buf.WriteVarInt(this.npcOwnTime);
        _buf.WriteLong(this.npcOwnId);
        _buf.WriteString(this.npcOwnName);
	},
	
	reading:function( _buf ){
        this.mapmodelid = _buf.ReadVarInt();
        this.remandtime = _buf.ReadVarInt();
        this.outstatue = _buf.ReadVarInt();
        this.playernum = _buf.ReadVarInt();
        this.npcOwnTime = _buf.ReadVarInt();
        this.npcOwnId = _buf.ReadLong();
        this.npcOwnName = _buf.ReadString();
	},

	action:function(){
		Mgr.kingneutral.RecvReskingneutralTaskGameToClinetMessage(this);
	},

});
////////////////////
// 请求面板信息 //
////////////////////
var ReqkingneutralClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 138201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求进入战场 //
////////////////////
var ReqkingneutralEnterClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 138202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取王城战每日奖励 //
////////////////////
var ReqGetkingNeutralAwardClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 138203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(138101, ReskingneutralGameToClinetMessage);
MESSAGE_POOL.Add(138102, ReskingneutralTopGameToClinetMessage);
MESSAGE_POOL.Add(138103, ReskingneutralTaskGameToClinetMessage);

