///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//DrawRecordPublicInfo public同步游戏服抽奖记录
//DrawRecordInfo 抽奖记录信息

// 请求消息
//167201,ReqLuckyDrawInfoClientToGame 抽奖面板信息
//167202,ReqLuckyDrawPerformClientToGame 请求开始抽奖
//167203,ReqLuckyDrawPerNewformClientToGame 请求开始抽奖（新的请求抽奖）
//167204,ReqLuckDrawBatterRewardToClinet 幸运抽奖3连击（类型4的抽奖）领奖

// 接收消息
//167101,ResLuckyDrawInfoGameToClient 返回抽奖面板信息
//167102,ResLuckyDrawResultGameToClient 抽奖结果
//167103,ResShenJiBoxLuckyDrawRecordToClinet 返回个人抽奖记录
//167104,ResLuckyDrawOwnNumsToClinet 告诉前端可用抽奖次数(充值抽奖等)
//167105,ResPrizePoolEnetrYanbaoNumToClinet 发送奖池元宝数量
//167107,ResLuckDrawBatterInfoToClinet 幸运抽奖3连击（类型4的抽奖）
//167106,ResLuckyDrawRouletteInfoGameToClient 幸运转盘的面板消息（需要根据消息的道具展示面板）


var DrawRecordPublicInfo = cc.Class.extend({
	ctor:function(){
		this.drawTime = 0; // 抽奖时间(秒)
        this.serverKey = 0; // 抽奖玩家serverkey
        this.playerId = null; // 玩家Id
        this.playerName = null; // 玩家名字
        this.briefItemInfo = null; // 简要道具信息
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.drawTime);
        _buf.WriteVarInt(this.serverKey);
        _buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteBean(this.briefItemInfo);
	},
	
	reading:function( _buf ){
		this.drawTime = _buf.ReadVarInt();
        this.serverKey = _buf.ReadVarInt();
        this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.briefItemInfo = _buf.ReadBean(BriefItemInfo);
	},
});
var DrawRecordInfo = cc.Class.extend({
	ctor:function(){
		this.drawTime = 0; // 抽奖时间(秒)
        this.serverKey = 0; // 抽奖玩家serverkey
        this.playerId = null; // 玩家Id
        this.playerName = null; // 玩家名字
        this.briefItemInfo = null; // 简要道具信息
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.drawTime);
        _buf.WriteVarInt(this.serverKey);
        _buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteBean(this.briefItemInfo);
	},
	
	reading:function( _buf ){
		this.drawTime = _buf.ReadVarInt();
        this.serverKey = _buf.ReadVarInt();
        this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.briefItemInfo = _buf.ReadBean(BriefItemInfo);
	},
});
////////////////////
// 返回抽奖面板信息 //
////////////////////
var ResLuckyDrawInfoGameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.storeId = 0; // 对应的仓库ID,0表示没有
        this.luckyDrawType = 0; // 抽奖类型
        this.luckyDrawNums = 0; // 可抽奖次数
        this.blessValue = 0; // 祝福值(部分抽奖有)
        this.records = []; // 对应类型的奖励记录列表(全服记录) DrawRecordInfo
        this.RecordBests = []; // 极品抽奖记录 DrawRecordInfo
        this.discountInfo = []; // 打折信息(折扣，开始时间，结束时间) int
	},

	getId:function(){
		return 167101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.storeId);
        _buf.WriteVarInt(this.luckyDrawType);
        _buf.WriteVarInt(this.luckyDrawNums);
        _buf.WriteVarInt(this.blessValue);
        _buf.WriteUShort( this.records.length );
        for (var i = 0; i < this.records.length; i++) {
            _buf.WriteBean(this.records[i]);
        }
        _buf.WriteUShort( this.RecordBests.length );
        for (var i = 0; i < this.RecordBests.length; i++) {
            _buf.WriteBean(this.RecordBests[i]);
        }
        _buf.WriteUShort( this.discountInfo.length );
        for (var i = 0; i < this.discountInfo.length; i++) {
            _buf.WriteVarInt(this.discountInfo[i]);
        }
	},
	
	reading:function( _buf ){
        this.storeId = _buf.ReadVarInt();
        this.luckyDrawType = _buf.ReadVarInt();
        this.luckyDrawNums = _buf.ReadVarInt();
        this.blessValue = _buf.ReadVarInt();
        var records_length = _buf.ReadUShort();
        for (var i = 0; i < records_length; i++) {
            this.records[i] = _buf.ReadBean(DrawRecordInfo);
        }
        var RecordBests_length = _buf.ReadUShort();
        for (var i = 0; i < RecordBests_length; i++) {
            this.RecordBests[i] = _buf.ReadBean(DrawRecordInfo);
        }
        var discountInfo_length = _buf.ReadUShort();
        for (var i = 0; i < discountInfo_length; i++) {
            this.discountInfo[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.luckydraw.RecvResLuckyDrawInfoGameToClientMessage(this);
	},

});
////////////////////
// 抽奖结果 //
////////////////////
var ResLuckyDrawResultGameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.items = []; // 奖励物品信息列表 TempItemInfo
        this.luckyDrawType = 0; // 抽奖类型
	},

	getId:function(){
		return 167102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
        _buf.WriteVarInt(this.luckyDrawType);
	},
	
	reading:function( _buf ){
        var items_length = _buf.ReadUShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(TempItemInfo);
        }
        this.luckyDrawType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.luckydraw.RecvResLuckyDrawResultGameToClientMessage(this);
	},

});
////////////////////
// 返回个人抽奖记录 //
////////////////////
var ResShenJiBoxLuckyDrawRecordToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.records = []; // 奖励记录列表 DrawRecordInfo
        this.luckyDrawType = 0; // 抽奖类型
	},

	getId:function(){
		return 167103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.records.length );
        for (var i = 0; i < this.records.length; i++) {
            _buf.WriteBean(this.records[i]);
        }
        _buf.WriteVarInt(this.luckyDrawType);
	},
	
	reading:function( _buf ){
        var records_length = _buf.ReadUShort();
        for (var i = 0; i < records_length; i++) {
            this.records[i] = _buf.ReadBean(DrawRecordInfo);
        }
        this.luckyDrawType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.luckydraw.RecvResShenJiBoxLuckyDrawRecordToClinetMessage(this);
	},

});
////////////////////
// 告诉前端可用抽奖次数(充值抽奖等) //
////////////////////
var ResLuckyDrawOwnNumsToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.ownNums = []; // 类型对应的可抽奖次数(类型-次数) int
	},

	getId:function(){
		return 167104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.ownNums.length );
        for (var i = 0; i < this.ownNums.length; i++) {
            _buf.WriteVarInt(this.ownNums[i]);
        }
	},
	
	reading:function( _buf ){
        var ownNums_length = _buf.ReadUShort();
        for (var i = 0; i < ownNums_length; i++) {
            this.ownNums[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.luckydraw.RecvResLuckyDrawOwnNumsToClinetMessage(this);
	},

});
////////////////////
// 发送奖池元宝数量 //
////////////////////
var ResPrizePoolEnetrYanbaoNumToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.luckyDrawType = 0; // 抽奖类型
        this.prizePoolEnetrYanbaoNum = 0; // 奖池元宝数量
	},

	getId:function(){
		return 167105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.luckyDrawType);
        _buf.WriteVarInt(this.prizePoolEnetrYanbaoNum);
	},
	
	reading:function( _buf ){
        this.luckyDrawType = _buf.ReadVarInt();
        this.prizePoolEnetrYanbaoNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.luckydraw.RecvResPrizePoolEnetrYanbaoNumToClinetMessage(this);
	},

});
////////////////////
// 幸运抽奖3连击（类型4的抽奖） //
////////////////////
var ResLuckDrawBatterInfoToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.remain = 0; // 可领奖次数
        this.molecule = 0; // 分子
        this.denominator = 0; // 分母
	},

	getId:function(){
		return 167107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.remain);
        _buf.WriteVarInt(this.molecule);
        _buf.WriteVarInt(this.denominator);
	},
	
	reading:function( _buf ){
        this.remain = _buf.ReadVarInt();
        this.molecule = _buf.ReadVarInt();
        this.denominator = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.luckydraw.RecvResLuckDrawBatterInfoToClinetMessage(this);
	},

});
////////////////////
// 幸运转盘的面板消息（需要根据消息的道具展示面板） //
////////////////////
var ResLuckyDrawRouletteInfoGameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.freeLuckyDrawNums = 0; // 可抽奖次数
        this.freeLuckyDrawTime = 0; // 可获得免费抽奖次数的时间戳
        this.score = 0; // 积分
        this.records = []; // 对应类型的奖励记录列表(全服记录) DrawRecordInfo
        this.playerRecords = []; // 个人抽奖记录 DrawRecordInfo
        this.drawItems = []; // 抽奖可获得的道具 BriefItemInfo
	},

	getId:function(){
		return 167106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.freeLuckyDrawNums);
        _buf.WriteVarInt(this.freeLuckyDrawTime);
        _buf.WriteVarInt(this.score);
        _buf.WriteUShort( this.records.length );
        for (var i = 0; i < this.records.length; i++) {
            _buf.WriteBean(this.records[i]);
        }
        _buf.WriteUShort( this.playerRecords.length );
        for (var i = 0; i < this.playerRecords.length; i++) {
            _buf.WriteBean(this.playerRecords[i]);
        }
        _buf.WriteUShort( this.drawItems.length );
        for (var i = 0; i < this.drawItems.length; i++) {
            _buf.WriteBean(this.drawItems[i]);
        }
	},
	
	reading:function( _buf ){
        this.freeLuckyDrawNums = _buf.ReadVarInt();
        this.freeLuckyDrawTime = _buf.ReadVarInt();
        this.score = _buf.ReadVarInt();
        var records_length = _buf.ReadUShort();
        for (var i = 0; i < records_length; i++) {
            this.records[i] = _buf.ReadBean(DrawRecordInfo);
        }
        var playerRecords_length = _buf.ReadUShort();
        for (var i = 0; i < playerRecords_length; i++) {
            this.playerRecords[i] = _buf.ReadBean(DrawRecordInfo);
        }
        var drawItems_length = _buf.ReadUShort();
        for (var i = 0; i < drawItems_length; i++) {
            this.drawItems[i] = _buf.ReadBean(BriefItemInfo);
        }
	},

	action:function(){
		Mgr.luckydraw.RecvResLuckyDrawRouletteInfoGameToClientMessage(this);
	},

});
////////////////////
// 抽奖面板信息 //
////////////////////
var ReqLuckyDrawInfoClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.luckyDrawType = 0; // 抽奖类型
	},

	getId:function(){
		return 167201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.luckyDrawType);
	},
	
	reading:function( _buf ){
        this.luckyDrawType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求开始抽奖 //
////////////////////
var ReqLuckyDrawPerformClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.luckyDrawType = 0; // 抽奖类型
        this.num = 0; // 抽奖次数(前端自己传数据来1到XXX)
	},

	getId:function(){
		return 167202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.luckyDrawType);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.luckyDrawType = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
	},

});
////////////////////
// 请求开始抽奖（新的请求抽奖） //
////////////////////
var ReqLuckyDrawPerNewformClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.luckyDrawType = 0; // 抽奖类型
        this.itemid = []; // 物品唯一id long
        this.itemnum = []; // 对应物品数量 int
	},

	getId:function(){
		return 167203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.luckyDrawType);
        _buf.WriteUShort( this.itemid.length );
        for (var i = 0; i < this.itemid.length; i++) {
            _buf.WriteLong(this.itemid[i]);
        }
        _buf.WriteUShort( this.itemnum.length );
        for (var i = 0; i < this.itemnum.length; i++) {
            _buf.WriteVarInt(this.itemnum[i]);
        }
	},
	
	reading:function( _buf ){
        this.luckyDrawType = _buf.ReadVarInt();
        var itemid_length = _buf.ReadUShort();
        for (var i = 0; i < itemid_length; i++) {
            this.itemid[i] = _buf.ReadLong();
        }
        var itemnum_length = _buf.ReadUShort();
        for (var i = 0; i < itemnum_length; i++) {
            this.itemnum[i] = _buf.ReadVarInt();
        }
	},

});
////////////////////
// 幸运抽奖3连击（类型4的抽奖）领奖 //
////////////////////
var ReqLuckDrawBatterRewardToClinetMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 167204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(167101, ResLuckyDrawInfoGameToClientMessage);
MESSAGE_POOL.Add(167102, ResLuckyDrawResultGameToClientMessage);
MESSAGE_POOL.Add(167103, ResShenJiBoxLuckyDrawRecordToClinetMessage);
MESSAGE_POOL.Add(167104, ResLuckyDrawOwnNumsToClinetMessage);
MESSAGE_POOL.Add(167105, ResPrizePoolEnetrYanbaoNumToClinetMessage);
MESSAGE_POOL.Add(167107, ResLuckDrawBatterInfoToClinetMessage);
MESSAGE_POOL.Add(167106, ResLuckyDrawRouletteInfoGameToClientMessage);

