var XunBaoPanelExt = XunBaoPanel.extend ( {
	_className:"XunBaoPanelExt",
    gridArr:null,
    costLabelArr:null,
    logType:0,//0全服1个人
    logList:[],
    logView:null,
	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
        this.layoutCom.layoutOffy = -30;
	},
    Init:function(){
        XunBaoPanel.prototype.Init.call(this);
        this.gridArr = [this.grid1, this.grid2, this.grid3, this.grid4, this.grid5, this.grid6, this.grid7, this.grid9, this.grid14, this.grid13, this.grid12,
            this.grid11, this.grid10, this.grid8];
        this.costLabelArr = [this.lab1, this.lab4, this.lab5];
        this.InitPanel();
        var self = this;
        this.sbtn1.addClickEventListener(function () {
            self.logType = 0;
            self.ShowLogByType(self.logType);
        });
        this.sbtn2.addClickEventListener(function () {
            self.logType = 1;
            self.ShowLogByType(self.logType);
        });
        this.btn1.addClickEventListener(function(){
            self.StartLuckyDraw(1);
        });

        this.btn4.addClickEventListener(function () {
            self.StartLuckyDraw(10);
        });
        this.btn2.addClickEventListener(function(){
            self.StartLuckyDraw(50);
        });
        this.btn31.addClickEventListener(function(){
            //打开仓库
            Mgr.store.SendReqStoreGetItemsMessage(EnumStore.LUCKY);
            Mgr.uiMgr.ShowPanelByType(CangKuPanelExt.PanelName);
        });
        this.btnClose.addClickEventListener(function(){
            EngineMgr.uiMgr.HidePanelByType(XunBaoPanelExt.PanelName);
        });
        this.btn3.addClickEventListener(function(){
            EngineMgr.uiMgr.ShowPanelByType(ShuiJingShopPanelExt.PanelName);
        });
    },

    OnShow:function () {
        Mgr.luckydraw.SendReqLuckyDrawInfoClientToGameMessage(EnumLucky.FIND);
        Mgr.store.SendReqStoreGetItemsMessage(EnumStore.LUCKY);
    },

    InitPanel:function () {
        Mgr.luckydraw.xunBaoPanel = this;
        Mgr.store.xunBaoPanel = this;
        //处理界面
        this.btn1.setTitleText("寻宝一次");
        this.btn4.setTitleText("寻宝十次");
        this.imgWord.setVisible(false);
        this.imgCue.setVisible(false);
        this.imgCue1.setVisible(false);
        //初始化展示物
        var showInfo = Q_global.Get(1044).q_string_value;
        showInfo=JSON.parse(showInfo);
        for(var i = 0, len = this.gridArr.length; i < len; i++){
            var item = ItemUtil.ItemIdToItem(showInfo[i][0].mod, showInfo[i][0].num);
            GridUtil.SetItemGrid(this.gridArr[i], item);
        }

        //加记录ListView
        if(!this.logView){
            var tableView = new cc.TableView(this,cc.size(this.imgDi2.uiWidth, this.imgDi2.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.x=this.imgDi2.x;
            tableView.y=this.imgDi2.y;
            tableView.uiWidth=this.imgDi2.uiWidth;
            tableView.uiHeight=this.imgDi2.uiHeight;
            this.logView=tableView;
            this.addChild(tableView);
        }

        this.RefreshPanel();
    },

    RefreshPanel:function () {
        //获取消费物
        var costInfo = Q_lucky_draw_total.Get(1);
        var costItemInfo = JSON.parse(costInfo.q_item);
        for(var i = 0, len = this.costLabelArr.length; i < len; i++){
            this.costLabelArr[i].SetString(costItemInfo[i][2]);
        }
        //获取当前拥有物品数
        var attribute = Mgr.mainPlayer.attributeData;
        var backpack = Mgr.backpack;
        this.labGold1.SetString(attribute.TotalGold());
        this.lab11.SetString(attribute.GetAttribute(EnumMoney.CRYSTAL, AttributeData.Money));
        this.lab6.SetString(backpack.GetItemNumber(costItemInfo[0][1]));
        if(this.logView){
            this.logView.reloadData();
        }
    },

    UpdateRedWarm:function (bool) {
        this.imgCue.setVisible(bool)
    },

    StartLuckyDraw:function (num) {
        Mgr.luckydraw.index = num;

        var costInfo = Q_lucky_draw_total.Get(1);
        var costItemInfo = JSON.parse(costInfo.q_item);
        // var costPriceInfo = JSON.parse(costInfo.q_currency_cost);
        var holdNum = Mgr.backpack.GetItemNumber(costItemInfo[0][1]);
        if(holdNum < num){
            // var html = TextUtil.FormatStr("道具不足，确认花费" + TextUtil.AddColor("{1}元宝购买{2}*{3}", "2ed515"),
            //     [costPriceInfo[0][2] * (num - holdNum), "寻宝卡", num - holdNum]);
            // AlertExt.Show(html, TipsEnum.BUTTON_SURE_AND_FALSE, {
            //     _onFunc:function(){
            //         Mgr.luckydraw.SendReqLuckyDrawPerformClientToGameMessage(EnumLucky.FIND, num);
            //     }
            // }, 1);
            var panel = Mgr.uiMgr.ShowPanelByType(GouMaiPanelExt.PanelName);
            panel.BuyCard(costItemInfo[0][1], num - holdNum);
        }else {
            Mgr.luckydraw.SendReqLuckyDrawPerformClientToGameMessage(EnumLucky.FIND, num);
        }
    },

    ShowLogByType:function (type, allInfo, personInfo) {
        if(allInfo)
            this.allInfo = allInfo;
        if(personInfo)
            this.personInfo = personInfo;

        this.logList = [];
        if(type == 0 && this.allInfo){
            this.logList = this.allInfo.records;
        }else if(type == 1 && this.personInfo){
            this.logList = this.personInfo.records;
        }
        this.logView.reloadData();
    },

    SetLogInfoByIdx:function (cell, idx) {
        var info = this.logList[idx];
        if(info){
            var item = Q_item.Get(info.briefItemInfo.itemModelId);
            cell.SetHtmlText(TextUtil.FormatStr(cell.GetHtmlText(), [info.playerName, "神秘宝藏",
                TextUtil.AddColor(item.q_name + "*" + info.briefItemInfo.num, ItemUtil.GetNameColorById(info.briefItemInfo.itemModelId))]));
            cell.setVisible(true);
            cell.dot.setVisible(true);
        }else {
            cell.setVisible(false);
            cell.dot.setVisible(false);
        }
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(this.imgWord.uiWidth,this.imgWord.uiHeight);
    },
    tableCellAtIndex: function (table, idx) {
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item= this.labName.clone();
            var dot = this.imgDian.clone();
            item.dot = dot;
            cell.item=item;
            cell.addChild(item);
            cell.addChild(dot);
        }
        this.SetLogInfoByIdx(cell.item, idx);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.logList ? this.logList.length : 0;
    }
} );
XunBaoPanelExt.PanelName = "XunBaoPanelExt";
PanelClassDic["XunBaoPanelExt"] = XunBaoPanelExt;
