///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//MajorEventInfo 活动信息

// 请求消息

// 接收消息
//159101,ResSendMajorEventsInfo 发送活动信息
//159102,ResSendChangeMajorEventInfo 发送改变的活动信息


var MajorEventInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 活动类型
        this.startTime = 0; // 开始时间(时间戳,秒)
        this.endTime = 0; // 结束时间(时间戳,秒)
        this.status = 0; // 活动状态,0未开始,1进行中,2结束
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.startTime);
        _buf.WriteVarInt(this.endTime);
        _buf.WriteVarInt(this.status);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.startTime = _buf.ReadVarInt();
        this.endTime = _buf.ReadVarInt();
        this.status = _buf.ReadVarInt();
	},
});
////////////////////
// 发送活动信息 //
////////////////////
var ResSendMajorEventsInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.majoreventsinfo = []; // 活动信息列表 MajorEventInfo
	},

	getId:function(){
		return 159101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.majoreventsinfo.length );
        for (var i = 0; i < this.majoreventsinfo.length; i++) {
            _buf.WriteBean(this.majoreventsinfo[i]);
        }
	},
	
	reading:function( _buf ){
        var majoreventsinfo_length = _buf.ReadShort();
        for (var i = 0; i < majoreventsinfo_length; i++) {
            this.majoreventsinfo[i] = _buf.ReadBean(MajorEventInfo);
        }
	},

	action:function(){
		Mgr.majorevents.RecvResSendMajorEventsInfoMessage(this);
	},

});
////////////////////
// 发送改变的活动信息 //
////////////////////
var ResSendChangeMajorEventInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.majoreventinfo = null; // 单个活动信息
	},

	getId:function(){
		return 159102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.majoreventinfo);
	},
	
	reading:function( _buf ){
        this.majoreventinfo = _buf.ReadBean(MajorEventInfo);
	},

	action:function(){
		Mgr.majorevents.RecvResSendChangeMajorEventInfoMessage(this);
	},

});
// 接收消息注册
MESSAGE_POOL.Add(159101, ResSendMajorEventsInfoMessage);
MESSAGE_POOL.Add(159102, ResSendChangeMajorEventInfoMessage);

