var MapMainExt = MapMain.extend ( {
	_className:"MapMainExt",

	areaMapImg:null,
    _mapScrollView:null,
	_itemScrollView:null,
    _linesListView:null,

	_itemBtnList:null,

    _lineItemsList:null,
    curSelectListItem:null,
    _lines:[],
    _curLine:-1,

    _monsterTipsList:null,
    _npcTipsList:null,
    _transferTipsList:null,

    _xEdit:null,
    _yEdit:null,


    _mainPlayerTips:null,

    minMapSize:null,

    _curSelectItem:null,

    _listener:null,
    _touchMove:false,

    _drawNode:null,

	ctor:function(){
		this._super();
		this._itemBtnList = [];
		this._monsterTipsList = [];
		this._npcTipsList = [];
		this._transferTipsList = [];
		this._lineItemsList = [];
	},

    Init:function(){
        MapMain.prototype.Init.call( this );

        this.labMapName.visible = false;
        this.labPK.visible = false;
        // this.labZuobiao.visible = false;
        this.imgFrame1.visible = false;
        this.imgFrame2.visible = false;

        this.imgBg1.visible = false;

        var self = this;
        this.sbtnGrade.addClickEventListener(function(event){
            if(this.GetState() == "check"){
                Mgr.map.SendReqGetLinesMessage();
                self.imgBg1.visible = true;
            }
            else{
                self.imgBg1.visible = false;
            }
        });

        // this.btnGuaji.addClickEventListener(function(event){
        //     if(self._curSelectItem){
        //         if(!self.nCurMoveParam)
        //             self.nCurMoveParam = new AutoPathParam();
        //         Mgr.mainPlayer.oCtrlAutoPath.RunToPt(cc.p(parseInt(self._curSelectItem._x), parseInt(self._curSelectItem._y)), self.nCurMoveParam, true);
        //         self._curSelectItem.SetSelect(false);
        //         self._curSelectItem = null;
        //         // var path = Mgr.mainPlayer.oMoveRule._pathList;
        //
        //         // var path = Mgr.mainPlayer.oCtrlAutoPath.aMovePaths;
        //         // cc.log("---------------Path------------" + path.length + "   " + path);
        //     }else if(self.editShuru.getString() && self.editShuru1.getString()){
        //         var pos = cc.p(parseInt(self.editShuru.getString()), parseInt(self.editShuru1.getString()));
        //         if(pos.x >=0 && pos.x <= Mgr.sceneMap.nCurSceneW && pos.y >=0 && pos.y <= Mgr.sceneMap.nCurSceneH){
        //             var gridPt = ToolMap.PixPt2GridPt(pos.x, Mgr.sceneMap.nCurSceneH - pos.y);
        //             Mgr.mainPlayer.oCtrlAutoPath.RunToPt(gridPt, self.nCurMoveParam, true);
        //             self.editShuru.setString("");
        //             self.editShuru1.setString("");
        //         }
        //         else{
        //             Mgr.tips.ShowNotice("您输入的坐标超出了地图最大范围，无法前往",TipsEnum.TYPE_STATIC, null ,0x00008b, 20);
        //             self.editShuru.setString("");
        //             self.editShuru1.setString("");
        //         }
        //     }
        // });

        // this._xEdit = new MUINumberEdit();
        // this._xEdit.jsonobj=this.editShuru.jsonobj;
        // this._xEdit.Init();
        // this.imgBg2.removeChild(this.editShuru);
        // this.imgBg2.addChild(this._xEdit);
        //
        // this._yEdit = new MUINumberEdit();
        // this._yEdit.jsonobj=this.editShuru1.jsonobj;
        // this._yEdit.Init();
        // this.imgBg2.removeChild(this.editShuru1);
        // this.imgBg2.addChild(this._yEdit);
        // this.editShuru.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC);
        // this.editShuru1.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC);
    },

    OnShow:function(){
        this.InitLine();
        this.RefreshAreaMap();
    	this.RefreshItemsAndTips();
        this.InitPlayerTip();
        // this.RefreshNpcTips();
        this.RefreshTransferTips();
	},

    Updata:function(){
        if(this._mainPlayerTips){
            this._mainPlayerTips.setPosition(this.posConvertMaxToMinMap(Mgr.mainPlayer.x, -Mgr.mainPlayer.y));
            if(this._drawNode)
                this._drawNode.clear();
            if(Mgr.mainPlayer.oMoveRule._pathList){
                // cc.log(Mgr.mainPlayer.oMoveRule._pathList[0].x + "   " + Mgr.mainPlayer.oMoveRule._pathList[0].y);
                this.DrawPath(Mgr.mainPlayer.oMoveRule._pathList);
            }
        }
    },

    InitLine:function(){
        this.labXian.SetHtmlText(Mgr.sceneMap.line + "线");
    },

    InitPlayerTip:function(){
        if(!this._mainPlayerTips){
            var tip = new MUIImage();
            tip.ParseJson(this.imgJiantou.jsonobj);
            tip.Init();
            tip.setAnchorPoint(cc.p(0.5, 0));
            this.areaMapImg.addChild(tip);
            this._mainPlayerTips = tip;
        }
        this._mainPlayerTips.setPosition(this.posConvertMaxToMinMap(Mgr.mainPlayer.x, -Mgr.mainPlayer.y));
    },

	RefreshAreaMap:function(){
    	var self = this;
        if(!this._mapScrollView){
            this._mapScrollView = new ccui.ScrollView();
            this._mapScrollView.setDirection(ccui.ScrollView.DIR_BOTH);//视图滚动方向
            this._mapScrollView.setTouchEnabled(true);					//触摸开启
            this._mapScrollView.inertiaScrollEnabled = false; 			//滚动惯性
            this._mapScrollView.setScrollBarEnabled(false);				//滚动条
            this._mapScrollView.setBounceEnabled(false);					//边界回弹
            // this._mapScrollView.setScrollBarAutoHideTime(1);
            this.imgBg.addChild(this._mapScrollView);
            this._mapScrollView.setPosition(cc.p(5, 5));
        }

    	if(!this.areaMapImg){
    		this.areaMapImg = new ccui.ImageView();
            this.areaMapImg.setPosition(cc.p(0, 0));
            this.areaMapImg.setAnchorPoint(cc.p(0, 0));
    		// this.imgBg.addChild(this.areaMapImg);
            this._mapScrollView.addChild(this.areaMapImg);
        }

        // EngineMgr.uiMgr.GetAsynResByUrl(Mgr.sceneMap.sUrlThumbnails, function () {
        //     self.areaMapImg.loadTexture(Mgr.sceneMap.sUrlThumbnails, ccui.Widget.LOCAL_TEXTURE);
        // }, self.areaMapImg);
        this.areaMapImg.loadTexture(Mgr.sceneMap.sUrlThumbnails, ccui.Widget.LOCAL_TEXTURE);

        this.minMapSize = this.areaMapImg.getContentSize();
        // cc.log(this.minMapSize.width +"  "+ this.minMapSize.height);

        this._mapScrollView.setSize(cc.size(this.imgBg.uiWidth - 10, this.imgBg.uiHeight - 10));
        this._mapScrollView.setInnerContainerSize(cc.size(this.minMapSize.width, this.minMapSize.height));

        cc.log("nMapId: " + Mgr.sceneMap.nMapId + " sMapName: " + Mgr.sceneMap.sMapName);

        if(!this._listener){
            this._listener = cc.EventListener.create({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: false,

                onTouchBegan:function(touch, event){
                    var target = event.getCurrentTarget();
                    var locationPos = target.convertToNodeSpace(touch.getLocation());
                    self._touchBeginPt = locationPos;
                    self._touchMove = false;
                    return true;
                },
                onTouchMoved:function(touch, event){
                    var target = event.getCurrentTarget();
                    var locationPos = target.convertToNodeSpace(touch.getLocation());
                    if(Math.abs(self._touchBeginPt.x - locationPos.x) < 5 && Math.abs(self._touchBeginPt.y - locationPos.y) < 5)
                        self._touchMove = false;
                    else
                        self._touchMove = true;
                },
                onTouchEnded:function(touch, event){
                    // cc.log("-------------end");
                    if(!self._touchMove){
                        var target = event.getCurrentTarget();
                        var locationPos = target.convertToNodeSpace(touch.getLocation());
                        var pos = self.posConvertMinToMaxMap(locationPos.x, locationPos.y);

                        var minpos = self.posConvertMaxToMinMap(pos.x, -pos.y);
                        var x = minpos.x - self.areaMapImg.x;
                        var y = minpos.y - self.areaMapImg.y;
                        // cc.log("areaMapImg pos : " + pos.x +"  " + pos.y);
                        if(x < 0 || x > self.imgBg.uiWidth || y < 0 || pos.y > self.imgBg.uiHeight)
                            return;
                        var gridPt = ToolMap.PixPt2GridPt(pos.x, -pos.y);
                        // cc.log("gridPt : " + gridPt.x +"  " + gridPt.y);
                        if(!self.nCurMoveParam)
                            self.nCurMoveParam = new AutoPathParam();
                        Mgr.mainPlayer.oCtrlAutoPath.RunToPt(gridPt, self.nCurMoveParam, false);
                    }
                }
            });
            cc.eventManager.addListener(this._listener, this.areaMapImg);
        }
	},


	RefreshItemsAndTips:function(){
        if(!this._itemScrollView){
            this._itemScrollView = new ccui.ListView();
            this._itemScrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._itemScrollView.setTouchEnabled(true);					//触摸开启
            this._itemScrollView.inertiaScrollEnabled = false; 			//滚动惯性
            this._itemScrollView.setScrollBarEnabled(false);				//滚动条
            this._itemScrollView.setBounceEnabled(true);					//边界回弹
            // this._itemScrollView.setScrollBarAutoHideTime(1);
            this._itemScrollView.addEventListener(this._SelectedItemEvent);
            this.img1.addChild(this._itemScrollView);
        }

		var areaMapInfo = Q_minimapshow.Get(Mgr.sceneMap.nMapId);

		if(!areaMapInfo)
		    return;
        var monsterInfo = areaMapInfo.q_monster_coord;
        // if(!monsterInfo)
        //     return;

        var i = 0;
		// cc.log(monsterInfo + " length:" + monsterInfo.length);
        var str, id, x, y;
        while(monsterInfo && monsterInfo.length){
            if(monsterInfo.indexOf(";") > 0)
                str = monsterInfo.substring(0, monsterInfo.indexOf(";"));
            else
                str = monsterInfo.substring(0, monsterInfo.length);
            // cc.log(str);
            id = str.substring(0, str.indexOf("_"));
            x = str.substring(str.indexOf("_") + 1, str.lastIndexOf("_"));
            y = str.substring(str.lastIndexOf("_") + 1, str.length);
            // cc.log("id:" + id + " x:" + x + " y:" + y);

            //item初始化
            if(!this._itemBtnList[i]){
                var frame = new MonsterFrameExt();
                frame.LoadPanel();
                frame.x = 0;
                frame.y = this.img1.uiHeight - (i + 1)*frame.uiHeight;
                this.height = frame.uiHeight;
                this._itemBtnList.push(frame);
                this._itemScrollView.addChild(frame);
            }
            this._itemBtnList[i].visible = true;
            this._itemBtnList[i].SetData(id, x, y);

            //怪在小地图的标签初始化
            if(!this._monsterTipsList[i]){
                var tip = new MUIImage();
                tip.ParseJson(this.imgNpc.jsonobj);
                tip.Init();
                tip.setAnchorPoint(cc.p(0.5, 0.5));
                this.areaMapImg.addChild(tip);
                this._monsterTipsList.push(tip);
                var label = new MUILabel();
                label.ParseJson(this.labName.jsonobj);
                label.Init();
                label.setAnchorPoint(cc.p(0.5, 0.5));
                label.x = 10;
                label.y = -label.uiHeight/2;
                tip.addChild(label);
                tip.label = label;
            }
            var info = Q_monster.Get(id);
            this._monsterTipsList[i].visible = true;
            this._monsterTipsList[i].setPosition(this.posConvertMaxToMinMap(ToolMap.GridPt2PixPt(x, y, true).x, ToolMap.GridPt2PixPt(x, y, true).y));
            this._monsterTipsList[i].label.SetHtmlText(info.q_name + "(" + info.q_grade +")");

            if(monsterInfo.indexOf(";") > 0)
                monsterInfo = monsterInfo.substring(monsterInfo.indexOf(";") + 1, monsterInfo.length);
            else
                monsterInfo = "";
            i++;
            // cc.log(monsterInfo);
        }

        this._itemScrollView.setSize(cc.size(this.img1.uiWidth, this.img1.uiHeight));
        this._itemScrollView.setInnerContainerSize(cc.size(this.img1.uiWidth, this.height * i));

        for(; i < this._itemBtnList.length; i++){
            this._itemBtnList[i].visible = false;
            this._monsterTipsList[i].visible = false;
        }
	},

    RefreshNpcTips:function(){
        // cc.log("-------RefreshNpcTips");
	    var npcInfoslist = Q_npc.list;
	    var x, y;
	    // cc.log("----------------" + this.sMapName);
	    // cc.log(" npcInfoslist  :" + npcInfoslist.length);
        var j = 0;
	    for(var i = 0; i < npcInfoslist.length; i++){
	        if(npcInfoslist[i].q_map ==  Mgr.sceneMap.nMapId){
                if(!this._npcTipsList[j]){
                    var tip = new MUIImage();
                    tip.ParseJson(this.imgNpc.jsonobj);
                    tip.Init();
                    tip.setAnchorPoint(cc.p(0.5, 0.5));
                    this.areaMapImg.addChild(tip);
                    this._npcTipsList.push(tip);
                    var label = new MUILabel();
                    label.ParseJson(this.labName.jsonobj);
                    label.Init();
                    label.setAnchorPoint(cc.p(0.5, 0.5));
                    label.x = 10;
                    label.y = -label.uiHeight/2;
                    tip.addChild(label);
                    tip.label = label;
                }
                x = npcInfoslist[i].q_x;
                y = npcInfoslist[i].q_y;
                this._npcTipsList[j].visible = true;
                this._npcTipsList[j].setPosition(this.posConvertMaxToMinMap(ToolMap.GridPt2PixPt(x, y, true).x, ToolMap.GridPt2PixPt(x, y, true).y));
                this._npcTipsList[j].label.SetHtmlText(npcInfoslist[i].q_name);
                j++;
            }
        }
        for(; j < this._npcTipsList.length; j++){
            this._npcTipsList[j].visible = false;
        }
    },

    RefreshTransferTips:function(){
        var len = Mgr.sceneMap.transferArr.length;

        var i = 0;
        for( ; i < len; i++ ){
            var model = Mgr.sceneMap.transferArr[i];
            if(!this._transferTipsList[i]){
                var tip = new MUIImage();
                tip.ParseJson(this.imgIcon2.jsonobj);
                tip.Init();
                tip.setAnchorPoint(cc.p(0.5, 0.5));
                this.areaMapImg.addChild(tip);
                this._transferTipsList.push(tip);
                var label1 = new MUILabel();
                label1.ParseJson(this.labName1.jsonobj);
                label1.Init();
                label1.setAnchorPoint(cc.p(0.5, 0.5));
                label1.x = 10;
                label1.y = label1.uiHeight/2;
                tip.addChild(label1);
                tip.label1 = label1;

                var label2 = new MUILabel();
                label2.ParseJson(this.labName1.jsonobj);
                label2.Init();
                label2.setAnchorPoint(cc.p(0.5, 0.5));
                label2.x = 10;
                label2.y = -label2.uiHeight/2;
                tip.addChild(label2);
                tip.label2 = label2;
            }
            var x = model.q_tran_from_x;
            var y = model.q_tran_from_y;
            this._transferTipsList[i].visible = true;
            this._transferTipsList[i].setPosition(this.posConvertMaxToMinMap(ToolMap.GridPt2PixPt(x, y, true).x, ToolMap.GridPt2PixPt(x, y, true).y));
            var mapInfo = Q_map.Get(model.q_tran_to_map);
            this._transferTipsList[i].label1.SetHtmlText(mapInfo.q_map_name);
            var info = Q_minimapshow.Get(model.q_tran_to_map);
            if(!info){
                this._transferTipsList[i].label2.visible = false;
                return;
            }
            this._transferTipsList[i].label2.visible = true;
            this._transferTipsList[i].label2.SetHtmlText("(" + info.q_min_lv + "-" + info.q_max_lv + "级)");
        }

        for(; i < this._transferTipsList.length; i++){
            this._transferTipsList[i].visible = false;
        }
    },

    RefreshLines:function(lines){
        this._lines = lines;
        if(!this._linesListView){
            this._linesListView = new ccui.ListView();
            this._linesListView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._linesListView.setTouchEnabled(true);					//触摸开启
            this._linesListView.inertiaScrollEnabled = false; 			//滚动惯性
            this._linesListView.setScrollBarEnabled(false);				//滚动条
            this._linesListView.setBounceEnabled(true);					//边界回弹
            // this._itemScrollView.setScrollBarAutoHideTime(1);
            this._linesListView.addEventListener(this._SelectedLineEvent);
            this.imgBg1.addChild(this._linesListView);
        }
        var item;
        var i = 0;
        for( ; i < this._lines.length; i++){
            if(!this._lineItemsList[i]){
                item = new MapXianLuMainExt();
                item.LoadPanel();
                item.x = 0;
                item.y = item.uiHeight * i;
                this.width = item.uiWidth;
                this.height = item.uiHeight;
                this._linesListView.addChild(item);
                this._lineItemsList.push(item);
            }
            if(Mgr.sceneMap.line == lines[i]){
                this.curSelectListItem = this._lineItemsList[i];
                this.curSelectListItem.SetSelect(true);
            }
            this._lineItemsList[i].visible = true;
            this._lineItemsList[i].SetData(lines[i]);
        }
        this._linesListView.setSize(cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
        this._linesListView.setInnerContainerSize(cc.size(this.width, this.height * this._lines.length));
        for(; i < this._lineItemsList.length; i++){
            this._lineItemsList[i].visible = false;
        }
    },

    _SelectedItemEvent:function(sender, type){
        switch (type) {
            case ccui.ListView.ON_SELECTED_ITEM_END:
                var parent = sender.parent.parent;
                if ( parent._curSelectItem != null) {
                    parent._curSelectItem.SetSelect(false);
                    parent._curSelectItem = null;
                }

                var idx = sender.getCurSelectedIndex();
                var itemSelect = sender.getItem(idx);
                itemSelect.SetSelect(true);
                parent._curSelectItem = itemSelect;

                if(!parent.nCurMoveParam)
                    parent.nCurMoveParam = new AutoPathParam(AutoPathParam.ENDDO_AUTO_FIGHT);
                Mgr.mainPlayer.oCtrlAutoPath.RunToPt(cc.p(parseInt(parent._curSelectItem._x), parseInt(parent._curSelectItem._y)), parent.nCurMoveParam, true);
                // parent._curSelectItem.SetSelect(false);
                // parent._curSelectItem = null;
                break;
            default:
                break;
        }
    },

    _SelectedLineEvent:function(sender, type){
        switch (type) {
            case ccui.ListView.ON_SELECTED_ITEM_END:
                var parent = sender.parent.parent;
                if ( parent.curSelectListItem != null) {
                    parent.curSelectListItem.SetSelect(false);
                    parent.curSelectListItem = null;
                }
                var idx = sender.getCurSelectedIndex();
                var itemSelect = sender.getItem(idx);
                parent.curSelectListItem = itemSelect;
                parent.labXian.SetHtmlText(itemSelect.line + "线");
                Mgr.map.SendReqSelectLineMessage(itemSelect.line);
                itemSelect.SetSelect(true);
                parent.imgBg1.visible = false;
                parent.sbtnGrade.SetButtonState("uncheck");
                break;
            default:
                break;
        }
    },


    posConvertMaxToMinMap:function(px, py){
        var x = px * this.minMapSize.width / Mgr.sceneMap.nCurSceneW;
        var y = py * this.minMapSize.height / Mgr.sceneMap.nCurSceneH;
        // cc.log(px, py);
        // cc.log(this.minMapSize.width / Mgr.sceneMap.nCurSceneW, this.minMapSize.height / Mgr.sceneMap.nCurSceneH);
        return cc.p(x, this.minMapSize.height - y);
    },

    posConvertMinToMaxMap:function(px, py){
        var x = px * Mgr.sceneMap.nCurSceneW / this.minMapSize.width;
        var y = py * Mgr.sceneMap.nCurSceneH / this.minMapSize.height;
        // cc.log(px, py);
        // cc.log(this.minMapSize.width / Mgr.sceneMap.nCurSceneW, this.minMapSize.height / Mgr.sceneMap.nCurSceneH);
        return cc.p(x, y - Mgr.sceneMap.nCurSceneH);
    },

    DrawPath:function(path){
        if(path && path.length){
            if(!this._drawNode){
                if(!this.areaMapImg)
                    return;
                this._drawNode = new cc.DrawNode();
                this.areaMapImg.addChild(this._drawNode);
            }
            this._drawNode.drawLine(this.posConvertMaxToMinMap(Mgr.mainPlayer.x, -Mgr.mainPlayer.y),
                this.posConvertMaxToMinMap(path[0].x, -path[0].y), cc.color(255, 255, 0, 255));
            for(var i = 1; i < path.length; i++){
                this._drawNode.drawLine(this.posConvertMaxToMinMap(path[i - 1].x, -path[i - 1].y),
                    this.posConvertMaxToMinMap(path[i].x, -path[i].y), cc.color(255, 255, 0, 255));
            }
        }
    },

    OnHide:function(){
        this._super();
        if(this._listener){
            cc.eventManager.removeListener(this._listener);
            this._listener = null;
        }
    },
} );
MapMainExt.PanelName = "MapMainExt";
PanelClassDic["MapMainExt"] = MapMainExt;