var MonsterFrameExt = MonsterFrame.extend ( {
	_className:"MonsterFrameExt",

    _x:null,
    _y:null,

	ctor:function(){
		this._super();
	},

    Init:function(){
        MonsterFrame.prototype.Init.call( this );
    },

	SetData:function(id, x, y){
        this._x = x;
        this._y = y;
    	var monsterInfo = Q_monster.Get(id);
    	if(!monsterInfo)
    	    return;
        this.labName.SetHtmlText(monsterInfo.q_name);
        // this.labLv.SetHtmlText(TextUtil.FormatStr(this.labLv.GetHtmlText(), [monsterInfo.q_grade]));
        this.labLv.SetHtmlText(TextUtil.FormatStr(this.labLv.GetHtmlText(),[monsterInfo.q_grade, monsterInfo.q_grade]));

        var self = this;
        var HeadImageUrl = "other/head/monster/" + monsterInfo.q_head_resid + ".png";

        //"other/ditu/image/guaitouxiang.png" 加载完后回调
        EngineMgr.uiMgr.GetAsynResByUrl("other/ditu/image/guaitouxiang.png", function () {
            self.imgHead.loadTexture(HeadImageUrl, ccui.Widget.PLIST_TEXTURE);
        }, self.imgHead);
	},

    SetSelect:function(bool){
		if(bool)
			this.sbtnFrame.SetButtonState("check");
		else
            this.sbtnFrame.SetButtonState("uncheck");
	}


} );
MonsterFrameExt.PanelName = "MonsterFrameExt";
PanelClassDic["MonsterFrameExt"] = MonsterFrameExt;
