var WorldMapPanelExt = WorldMapPanel.extend ( {
	_className:"WorldMapPanelExt",

	clipping:null,
    _vScrollView:null,

    _btnArray:null,
    isInWorld:false,

    _mapTips:null,

	ctor:function(){
		this._super();

        this._btnArray = [];
        this._mapTips = new HashMap();
	},

    Init:function(){
        WorldMapPanel.prototype.Init.call( this );
        // this.panPanel1.visible = false;

        this.imgHeadBg.setLocalZOrder(11);
        this.imgHeadBg.setAnchorPoint(cc.p(0.5, 0.5));
        this.imgHeadBg.removeFromParent();
        this.panPanel1.addChild(this.imgHeadBg);

        this._InitParm();
        this.ClippingMap();
    },

    OnShow:function(){
        this.RefreshMapTips();
    },

    _InitParm:function(){
        this.choiceType = MapTypeEnum.TYPE_AREA;

        this._btnArray = [
            {btn:this.btnMap,    name:"京城",             id:116,     tran_id:1},
            {btn:this.btnMap1,   name:"渡口集市",         id:100,     tran_id:2},
            {btn:this.btnMap2,   name:"桃花菀",           id:105,     tran_id:6},
            {btn:this.btnMap4,   name:"陈家沟",           id:888,     tran_id:4},
            {btn:this.btnMap5,   name:"白桦林雅居",       id:127,     tran_id:8},
            {btn:this.btnMap6,   name:"雪域",             id:134,     tran_id:10},
            {btn:this.btnMap7,   name:"白桦林南山",       id:128,     tran_id:1},
            {btn:this.btnMap8,   name:"皇山",             id:130,     tran_id:14},
            {btn:this.btnMap9,   name:"枯木山庄",         id:103,     tran_id:12},
            {btn:this.btnMap10,   name:"塔冢",            id:106,     tran_id:21},
            {btn:this.btnMap11,  name:"秦淮",             id:132,     tran_id:23},
            {btn:this.btnMap12,  name:"松山",             id:133,     tran_id:24},
            {btn:this.btnMap13,  name:"瀑布·沉船秘藏",   id:129,     tran_id:27},
            // {btn:this.btnMap14,  name:"黑店",             id:136,     tran_id:1},
            // {btn:this.btnMap15,  name:"京城", id:116},
            // {btn:this.btnMap16,  name:"京城", id:116},
            // {btn:this.btnMap17,  name:"京城", id:116},
            // {btn:this.btnMap18,  name:"京城", id:116},
            // {btn:this.btnMap19,  name:"京城", id:116},
            // {btn:this.btnMap20,  name:"京城", id:116},
            // {btn:this.btnMap21,  name:"京城", id:116}
        ];

        this._btnPosArray = [
        ]
    },

	ClippingMap:function(){
        // if(!this.clipping){
         //    var rect = new cc.DrawNode();
         //    rect.drawRect(
         //        cc.p(this.x + 5, this.y + 5), // 起点
         //        cc.p(this.uiWidth - 5, this.uiHeight - 5),// 起点的对角点
         //        cc.color(255,255, 255, 255), // 填充颜色
         //        1,// 线粗
         //        cc.color(255,255, 255, 255)// 线颜色
         //    );
        //
         //    cc.log(this.x+"  "+ this.y +"  "+  this.uiWidth + "  "+this.uiHeight);
         //    this.clipping = new cc.ClippingNode();
         //    this.clipping.setStencil(rect);
         //    this.clipping.setInverted(false);
         //    this.addChild(this.clipping);
         //    this.panPanel1.removeFromParent();
         //    this.clipping.addChild(this.panPanel1);
		// }
		if(!this._vScrollView){
            this._vScrollView = new ccui.ScrollView();
            this._vScrollView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);//视图滚动方向
            this._vScrollView.setTouchEnabled(true);					//触摸开启
            this._vScrollView.inertiaScrollEnabled = false; 			//滚动惯性
            this._vScrollView.setScrollBarEnabled(false);				//滚动条
            this._vScrollView.setBounceEnabled(false);					//边界回弹
            // this._vScrollView.setScrollBarAutoHideTime(1);
            this.addChild(this._vScrollView);
            this._vScrollView.setPosition(cc.p(5, 5));
            this.panPanel1.removeFromParent();
            this._vScrollView.addChild(this.panPanel1);
            this.panPanel1.setPosition(cc.p(0,0));

            this._vScrollView.setSize(cc.size(this.uiWidth - 10, this.uiHeight - 10));
            this._vScrollView.setInnerContainerSize(cc.size(this.panPanel1.uiWidth, this.panPanel1.uiHeight));
		}
	},

    RefreshMapTips:function(){
	    var self = this;
        this.isInWorld = false;
	    for(var i = 0; i < this._btnArray.length; i++){
            var mapinfo = Q_minimapshow.Get(this._btnArray[i].id);
            // cc.log("id: " + this._btnArray[i].name + "  mapinfo: " + mapinfo.q_min_lv);
            if(!this._mapTips.Get(i)){
                var tip = new WorldMapNameExt();
                tip.LoadPanel();
                tip.setAnchorPoint(cc.p(0.5, 0.5));
                tip.setLocalZOrder(10);
                tip.x = this._btnArray[i].btn.x + this._btnArray[i].btn.uiWidth/2;
                tip.y = this._btnArray[i].btn.y + this._btnArray[i].btn.uiHeight/2 + 30;
                tip.SetData(this._btnArray[i].name, mapinfo.q_min_lv, mapinfo.q_max_lv, this._btnArray[i].id);
                this.panPanel1.addChild(tip);
                this._btnArray[i].btn.tip = tip;
                this._mapTips.Put(i, tip);
            }

            this._btnArray[i].btn.tip.SetPk(MapUtil.isMapCanPK(this._btnArray[i].id));

            if(this._btnArray[i].id == Mgr.sceneMap.nMapId){
                this.isInWorld = true;
                this.imgHeadBg.visible = true;
                this.imgHeadBg.x = this._btnArray[i].btn.x + this._btnArray[i].btn.uiWidth/2;
                this.imgHeadBg.y = this._btnArray[i].btn.y + this._btnArray[i].btn.uiHeight/2  + this._btnArray[i].btn.tip.uiHeight/2 - 10;
            }


            if(Mgr.mainPlayer.attributeData.level < mapinfo.q_min_lv){
                Filter.GrayScale(this._btnArray[i].btn);
                Filter.GrayScale(this._btnArray[i].btn.tip);
                this._btnArray[i].btn.tip.LockMap(true);
            }
            else{
                Filter.UnGray(this._btnArray[i].btn);
                Filter.UnGray(this._btnArray[i].btn.tip);
                this._btnArray[i].btn.tip.LockMap(false);
            }
            (function(i){
                self._btnArray[i].btn.addClickEventListener(function(event){
                    // Mgr.map.SendReqJumpTransMessage(self._btnArray[i].tran_id);
                    Mgr.map.SendReqGoldMapTransMessage(self._btnArray[i].id);
                    EngineMgr.uiMgr.HidePanelByType(WorldMapMainExt.PanelName);
                });
            })(i);
        }
        if(!this.isInWorld)
            this.imgHeadBg.visible = false;
    },

    OnHide:function(){
        this._super();
    },

} );
WorldMapPanelExt.PanelName = "WorldMapPanelExt";
PanelClassDic["WorldMapPanelExt"] = WorldMapPanelExt;
