var MarriagePanelExt = MarriagePanel.extend ( {
    _className:"MarriagePanelExt",
    ctor:function(){
        this._super();
        this.modelPanelType = 2
    },
    Init:function(){
        this._super();

        this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));

        /// 表白墙
        this.btn2.addClickEventListener(_=>{
            EngineMgr.uiMgr.HidePanel(this)
            EngineMgr.uiMgr.ShowPanelByType(BiaoBaiQiangPanelExt.PanelName)
        });
        /// 前往结婚
        this.btn1.addClickEventListener(_=>{
            MarriageUtil.RunToMatchmaker(_=>{
                EngineMgr.uiMgr.HidePanel(this)
            })
        });

        /// 设置称号
        var titleId = 15003
        this.imgChengHao.setAnchorPoint(cc.p(0.5,0.5))
        this.imgChengHao.x += this.imgChengHao.width / 2
        this.imgChengHao.y += this.imgChengHao.height / 2
        this.imgChengHao.scale = 1.5
        Mgr.title.SetTitleImage(this.imgChengHao,titleId)
        var titleC = Q_title.Get(titleId)
        var fightPower = Mgr.fightpower.GetFightPower(titleC.q_attribute)
        this.imglab1.SetText(fightPower)
        // 逗比设计
        var xHeight = this.img1.height / 2
        var xWidth = this.img1.width / 3
        this.$headArr = Array.from({length:6},(v,k)=>{
            v = new MarriageHeadExt()
            v.LoadPanel()
            this.img1.addChild(v)
            v.x = xWidth / 2 + k % 3 * xWidth - v.width / 2
            v.y = this.img1.height - Math.floor(k / 3) * xHeight - xHeight / 2 - v.height / 2
            return v
        })
    },
    OnShow:function(){
        this._super();

        var MI = Mgr.marriage.GetMarriageInfo()
        if(MI){
            EngineMgr.uiMgr.HidePanel(this)
            EngineMgr.uiMgr.ShowPanelByType(BiaoBaiQiangPanelExt.PanelName)
            return
        }
        this.OnTimer()
        this.$timer = TimerUtil.TimeUpdate(this.OnTimer, this, 1, cc.REPEAT_FOREVER);

        /// UPDATE PHOTO 每天更新
        var config = [
            "ZP_03.png"
            ,"ZP_06.png"
            ,"ZP_09.png"
            ,"ZP_12.png"
            ,"ZP_19.png"
            ,"ZP_21.png"
            ,"ZP_24.png"
            ,"ZP_30.png"
            ,"ZP_33.png"
            ,"ZP_36.png"
        ]

        var getDate = new Date();
        getDate.setHours(0);
        getDate.setMinutes(0);
        getDate.setSeconds(0);
        getDate.setMilliseconds(0);

        var seed = getDate.getTime()
        var list = config.map((v,k)=>{
            seed = ( seed * 9301 + 49297 ) % 233280;
            return { file : v, value : seed / ( 233280.0 ) }
        })
        list.sort(function(a,b){ return b.value - a.value})
        this.$headArr.forEach((v,k)=>v.SetData(list[k]))
    },
    OnHide:function(){
        this._super();

        if(this.$timer) TimerUtil.ClearTimeUpdate(this.$timer);
    },
    OnTimer:function(){
        var describe = MarriageUtil.GetActivityTime()
        UIUtil.ConnectLabelHtmlText(this.lab1,[describe])
    },
} );
MarriagePanelExt.PanelName = "MarriagePanelExt";
PanelClassDic["MarriagePanelExt"] = MarriagePanelExt;
