var MarriageSendFlowerExt = MarriageSendFlower.extend ( {
    _className:"MarriageSendFlowerExt",
    ctor:function(){
        this._super();
        this.modelPanelType = 2
    },
    Init:function(){
        this._super();

        this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));

        this.btnArr = [
            { labName : this.labName1	,lab : this.labNum		, btn : this.btnMianFei		,},
            { labName : this.labName2	,lab : this.labNum1		, btn : this.btnZengSong		,},
            { labName : this.labName3	,lab : this.labNum11		, btn : this.btnZengSong1		,},
            { labName : this.labName4	,lab : this.labNum111		, btn : this.btnZengSong2		,},
        ]

        UIUtil.ConnectLabelHtmlText(this.labNotice,["每天前5次赠送可获得好友回礼哦！"])

        var globalC = Q_global.Get(20027)
        var config = JSON.parse(globalC.q_string_value)
        this.$config = config;

        this.btnArr.forEach((v,k)=>{
            var c = config[k]
            var itemC = Q_item.Get(c[0])
            var amount = Mgr.backpack.GetItemNumber(itemC.q_id)
            UIUtil.ConnectLabelHtmlText(v.labName,[itemC.q_name])
            UIUtil.ConnectLabelHtmlText(v.lab,[amount,1])
            v.btn.addClickEventListener(this.RequestSendFlower.bind(this,k))
        })
    },
    OnShow:function(){
        this._super();
        GameEventMgr.AddEventListener(this,new ResSendFlowersResultToClientMessage().getId(),_=>{
            this.UpdateItemNumber()
        })
    },
    OnHide:function(){
        this._super();
        GameEventMgr.RemoveEventListener(this);
    },
    RequestSendFlower:function(index){
        var c = this.$config[index];

        var itemC = Q_item.Get(c[0])
        var amount = Mgr.backpack.GetItemNumber(itemC.q_id)
        if(amount == 0){
            ShopUtil.QuickBuyItem(itemC.q_id,false,_=>{
                Mgr.friend.SendReqSendFlowersToGameMessage(
                    this.$playerInfo.playerId
                    , index
                )
            })
            return
        }

        Mgr.friend.SendReqSendFlowersToGameMessage(
            this.$playerInfo.playerId
            , index
        )
    },
    SetData:function(playerInfo){
        this.$playerInfo = playerInfo;

        UIUtil.ConnectLabelHtmlText(this.labName,[playerInfo.name])
        UIUtil.LoadImage(this.imgHead, ResUrl.GetSmallPlayerHeadUrl(playerInfo.sex),false,true);
    },
    UpdateItemNumber:function(){
        this.btnArr.forEach((v,k)=>{
            var c = this.$config[k]
            var amount = Mgr.backpack.GetItemNumber(c[0])
            UIUtil.ConnectLabelHtmlText(v.lab,[amount,1])
        })
    },
} );
MarriageSendFlowerExt.PanelName = "MarriageSendFlowerExt";
PanelClassDic["MarriageSendFlowerExt"] = MarriageSendFlowerExt;
