///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ConfessionInfo 表白信息
//ConfessionRankingInfo 表白排行榜信息

// 请求消息
//118201,ReqPropose 玩家发起求婚
//118202,ReqProposeResponse 求婚回应
//118203,ReqChangeToken 更换信物
//118204,ReqDivorce 发起离婚
//118205,ReqDivorceResponse 离婚回应
//118206,ReqVisitWedding 确认参加婚礼观礼
//118207,ReqChangMarryExterior 请求改变结婚外显
//118208,ReqBuyGift 请求购买结婚投资
//118209,ReqGetGift 请求领取结婚投资
//118210,ReqAgainPropose 玩家再次求婚,其实就是花钱领取奖励
//118211,ReqConfessionPanelInfo 请求表白墙信息
//118212,ReqConfessionToPlayer 请求表白
//118213,ReqConfessionRanking 请求表白排行信息
//118214,ReqMarriageZhuFu 请求祝福和送花

// 接收消息
//118101,ResProposeNotice 被求婚者通知
//118102,ResMarriagePanel 结婚面板
//118103,ResDivorceNotice 被离婚者通知
//118104,ResChangeTokenSuc 更换信物成功
//118105,ResProposeValidSuc 求婚请求验证成功
//118106,ResNoticeVisitor 通知观礼者
//118107,ResVisitZoneMarryInfo 通知观礼者这个副本里哪两个人结婚
//118108,ResMarryExteriorInfo 发送婚姻外观信息
//118109,ResMarryGiftInfo 发送结婚投资状态信息
//118110,ResConfessionPanelInfo 请求表白墙信息
//118111,ResConfessionRanking 返回排行信息
//118112,ResMarriageNoticePanel 返回结婚通知面板给全服玩家
//118113,ResConfessionInfoBroadcast 表白结果广播


var ConfessionInfo = cc.Class.extend({
	ctor:function(){
		this.sendPlayerName = null; // 表白者名字
        this.receivePlayerName = null; // 被表白者名字
        this.itemModel = 0; // 赠送到道具类型
        this.time = 0; // 表白时间
        this.content = null; // 表白内容
	},

	writing:function( _buf ){
		_buf.WriteString(this.sendPlayerName);
        _buf.WriteString(this.receivePlayerName);
        _buf.WriteVarInt(this.itemModel);
        _buf.WriteVarInt(this.time);
        _buf.WriteString(this.content);
	},

	reading:function( _buf ){
		this.sendPlayerName = _buf.ReadString();
        this.receivePlayerName = _buf.ReadString();
        this.itemModel = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
        this.content = _buf.ReadString();
	},
});
var ConfessionRankingInfo = cc.Class.extend({
	ctor:function(){
		this.playerId = null; // 玩家id
        this.playerName = null; // 玩家名字
        this.sendNum = 0; // 表白次数
        this.receiveNum = 0; // 收到次数
        this.num = 0; // 数量
        this.rank = 0; // 排名 从0开始 -1表示没上榜
        this.job = 0; // 职业
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.sendNum);
        _buf.WriteVarInt(this.receiveNum);
        _buf.WriteVarInt(this.num);
        _buf.WriteVarInt(this.rank);
        _buf.WriteByte(this.job);
	},

	reading:function( _buf ){
		this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.sendNum = _buf.ReadVarInt();
        this.receiveNum = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.rank = _buf.ReadVarInt();
        this.job = _buf.ReadByte();
	},
});
////////////////////
// 被求婚者通知 //
////////////////////
var ResProposeNoticeMessage = cc.Class.extend( {
	ctor:function(){
		this.fromPlayerId = null; // 来源玩家Id
        this.fromPlayerName = null; // 来源玩家名字
        this.marriageType = 0; // 婚姻类型,1,2,3
	},

	getId:function(){
		return 118101;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.fromPlayerId);
        _buf.WriteString(this.fromPlayerName);
        _buf.WriteVarInt(this.marriageType);
	},

	reading:function( _buf ){
        this.fromPlayerId = _buf.ReadLong();
        this.fromPlayerName = _buf.ReadString();
        this.marriageType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.marriage.RecvResProposeNoticeMessage(this);
	},

});
////////////////////
// 结婚面板 //
////////////////////
var ResMarriagePanelMessage = cc.Class.extend( {
	ctor:function(){
		this.marryId = null; // 唯一Id
        this.playerName1 = null; // 玩家1名字
        this.playerJob1 = 0; // 玩家1职业
        this.playerName2 = null; // 玩家2名字
        this.playerJob2 = 0; // 玩家2职业
        this.playerLevelA = 0; // 玩家1等级
        this.playerLevelB = 0; // 玩家2等级
        this.marriageType = 0; // 婚姻类型,1,2,3
        this.marryTime = 0; // 结婚时间戳（秒）
        this.divorceTime = 0; // 离婚时间戳（秒）
        this.sendType = 0; // 发送状态 0 登录 1结婚 2离婚
        this.resDataA = []; // 玩家1的婚姻资源线数据（婚姻资源线类型，等级，婚姻资源线类型，等级......） int
        this.resDataB = []; // 玩家2的婚姻资源线数据（婚姻资源线类型，等级，婚姻资源线类型，等级......） int
        this.playerFightPowerA = null; // 玩家1战斗力
        this.playerFightPowerB = null; // 玩家2战斗力
        this.playerId1 = null; // 玩家1唯一ID
        this.playerId2 = null; // 玩家2唯一ID
	},

	getId:function(){
		return 118102;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.marryId);
        _buf.WriteString(this.playerName1);
        _buf.WriteByte(this.playerJob1);
        _buf.WriteString(this.playerName2);
        _buf.WriteByte(this.playerJob2);
        _buf.WriteVarInt(this.playerLevelA);
        _buf.WriteVarInt(this.playerLevelB);
        _buf.WriteVarInt(this.marriageType);
        _buf.WriteVarInt(this.marryTime);
        _buf.WriteVarInt(this.divorceTime);
        _buf.WriteByte(this.sendType);
        _buf.WriteUShort( this.resDataA.length );
        for (var i = 0; i < this.resDataA.length; i++) {
            _buf.WriteVarInt(this.resDataA[i]);
        }
        _buf.WriteUShort( this.resDataB.length );
        for (var i = 0; i < this.resDataB.length; i++) {
            _buf.WriteVarInt(this.resDataB[i]);
        }
        _buf.WriteLong(this.playerFightPowerA);
        _buf.WriteLong(this.playerFightPowerB);
        _buf.WriteLong(this.playerId1);
        _buf.WriteLong(this.playerId2);
	},

	reading:function( _buf ){
        this.marryId = _buf.ReadLong();
        this.playerName1 = _buf.ReadString();
        this.playerJob1 = _buf.ReadByte();
        this.playerName2 = _buf.ReadString();
        this.playerJob2 = _buf.ReadByte();
        this.playerLevelA = _buf.ReadVarInt();
        this.playerLevelB = _buf.ReadVarInt();
        this.marriageType = _buf.ReadVarInt();
        this.marryTime = _buf.ReadVarInt();
        this.divorceTime = _buf.ReadVarInt();
        this.sendType = _buf.ReadByte();
        var resDataA_length = _buf.ReadUShort();
        for (var i = 0; i < resDataA_length; i++) {
            this.resDataA[i] = _buf.ReadVarInt();
        }
        var resDataB_length = _buf.ReadUShort();
        for (var i = 0; i < resDataB_length; i++) {
            this.resDataB[i] = _buf.ReadVarInt();
        }
        this.playerFightPowerA = _buf.ReadLong();
        this.playerFightPowerB = _buf.ReadLong();
        this.playerId1 = _buf.ReadLong();
        this.playerId2 = _buf.ReadLong();
	},

	action:function(){
		Mgr.marriage.RecvResMarriagePanelMessage(this);
	},

});
////////////////////
// 被离婚者通知 //
////////////////////
var ResDivorceNoticeMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 118103;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

	action:function(){
		Mgr.marriage.RecvResDivorceNoticeMessage(this);
	},

});
////////////////////
// 更换信物成功 //
////////////////////
var ResChangeTokenSucMessage = cc.Class.extend( {
	ctor:function(){
		this.itemModel = 0; // 定情信物Id
	},

	getId:function(){
		return 118104;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.itemModel);
	},

	reading:function( _buf ){
        this.itemModel = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.marriage.RecvResChangeTokenSucMessage(this);
	},

});
////////////////////
// 求婚请求验证成功 //
////////////////////
var ResProposeValidSucMessage = cc.Class.extend( {
	ctor:function(){
		this.toPlayerId = null; // 对方玩家Id
        this.toPlayerName = null; // 对方玩家名称
	},

	getId:function(){
		return 118105;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.toPlayerId);
        _buf.WriteString(this.toPlayerName);
	},

	reading:function( _buf ){
        this.toPlayerId = _buf.ReadLong();
        this.toPlayerName = _buf.ReadString();
	},

	action:function(){
		Mgr.marriage.RecvResProposeValidSucMessage(this);
	},

});
////////////////////
// 通知观礼者 //
////////////////////
var ResNoticeVisitorMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneId = null; // 副本唯一Id，需回传给服务器
        this.pname1 = null; // 玩家1名字
        this.pname2 = null; // 玩家2名字
        this.pid1 = null; // 玩家1Id
        this.pid2 = null; // 玩家2Id
	},

	getId:function(){
		return 118106;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.zoneId);
        _buf.WriteString(this.pname1);
        _buf.WriteString(this.pname2);
        _buf.WriteLong(this.pid1);
        _buf.WriteLong(this.pid2);
	},

	reading:function( _buf ){
        this.zoneId = _buf.ReadLong();
        this.pname1 = _buf.ReadString();
        this.pname2 = _buf.ReadString();
        this.pid1 = _buf.ReadLong();
        this.pid2 = _buf.ReadLong();
	},

	action:function(){
		Mgr.marriage.RecvResNoticeVisitorMessage(this);
	},

});
////////////////////
// 通知观礼者这个副本里哪两个人结婚 //
////////////////////
var ResVisitZoneMarryInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.pid = []; // 哪些人结婚 long
	},

	getId:function(){
		return 118107;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.pid.length );
        for (var i = 0; i < this.pid.length; i++) {
            _buf.WriteLong(this.pid[i]);
        }
	},

	reading:function( _buf ){
        var pid_length = _buf.ReadUShort();
        for (var i = 0; i < pid_length; i++) {
            this.pid[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.marriage.RecvResVisitZoneMarryInfoMessage(this);
	},

});
////////////////////
// 发送婚姻外观信息 //
////////////////////
var ResMarryExteriorInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 玩家id
        this.exteriorId = 0; // 结婚外显id
	},

	getId:function(){
		return 118108;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteVarInt(this.exteriorId);
	},

	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.exteriorId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.marriage.RecvResMarryExteriorInfoMessage(this);
	},

});
////////////////////
// 发送结婚投资状态信息 //
////////////////////
var ResMarryGiftInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // -1未购买-2全部领完了 （领取状态2进制为1已领取）
        this.AId = null; // Aid
        this.timeA = []; // A获得投资时间 int
        this.BId = null; // Bid
        this.timeB = []; // B获得投资时间 int
	},

	getId:function(){
		return 118109;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.state);
        _buf.WriteLong(this.AId);
        _buf.WriteUShort( this.timeA.length );
        for (var i = 0; i < this.timeA.length; i++) {
            _buf.WriteVarInt(this.timeA[i]);
        }
        _buf.WriteLong(this.BId);
        _buf.WriteUShort( this.timeB.length );
        for (var i = 0; i < this.timeB.length; i++) {
            _buf.WriteVarInt(this.timeB[i]);
        }
	},

	reading:function( _buf ){
        this.state = _buf.ReadVarInt();
        this.AId = _buf.ReadLong();
        var timeA_length = _buf.ReadUShort();
        for (var i = 0; i < timeA_length; i++) {
            this.timeA[i] = _buf.ReadVarInt();
        }
        this.BId = _buf.ReadLong();
        var timeB_length = _buf.ReadUShort();
        for (var i = 0; i < timeB_length; i++) {
            this.timeB[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.marriage.RecvResMarryGiftInfoMessage(this);
	},

});
////////////////////
// 请求表白墙信息 //
////////////////////
var ResConfessionPanelInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 1所有的表白，2我的表白，3对我的表白
        this.start = 0; // 开始的索引
        this.infos = []; // 表白内容 ConfessionInfo
        this.length = 0; // 数据总长度
	},

	getId:function(){
		return 118110;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.start);
        _buf.WriteUShort( this.infos.length );
        for (var i = 0; i < this.infos.length; i++) {
            _buf.WriteBean(this.infos[i]);
        }
        _buf.WriteVarInt(this.length);
	},

	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.start = _buf.ReadVarInt();
        var infos_length = _buf.ReadUShort();
        for (var i = 0; i < infos_length; i++) {
            this.infos[i] = _buf.ReadBean(ConfessionInfo);
        }
        this.length = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.marriage.RecvResConfessionPanelInfoMessage(this);
	},

});
////////////////////
// 返回排行信息 //
////////////////////
var ResConfessionRankingMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 1男榜 2女榜
        this.ranks = []; // 榜单 ConfessionRankingInfo
        this.myRank = null; // 我的排行榜信息
	},

	getId:function(){
		return 118111;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteUShort( this.ranks.length );
        for (var i = 0; i < this.ranks.length; i++) {
            _buf.WriteBean(this.ranks[i]);
        }
        _buf.WriteBean(this.myRank);
	},

	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        var ranks_length = _buf.ReadUShort();
        for (var i = 0; i < ranks_length; i++) {
            this.ranks[i] = _buf.ReadBean(ConfessionRankingInfo);
        }
        this.myRank = _buf.ReadBean(ConfessionRankingInfo);
	},

	action:function(){
		Mgr.marriage.RecvResConfessionRankingMessage(this);
	},

});
////////////////////
// 返回结婚通知面板给全服玩家 //
////////////////////
var ResMarriageNoticePanelMessage = cc.Class.extend( {
	ctor:function(){
		this.marryId = null; // 唯一Id
        this.playerName1 = null; // 玩家1名字
        this.playerJob1 = 0; // 玩家1职业
        this.playerName2 = null; // 玩家2名字
        this.playerJob2 = 0; // 玩家2职业
	},

	getId:function(){
		return 118112;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.marryId);
        _buf.WriteString(this.playerName1);
        _buf.WriteByte(this.playerJob1);
        _buf.WriteString(this.playerName2);
        _buf.WriteByte(this.playerJob2);
	},

	reading:function( _buf ){
        this.marryId = _buf.ReadLong();
        this.playerName1 = _buf.ReadString();
        this.playerJob1 = _buf.ReadByte();
        this.playerName2 = _buf.ReadString();
        this.playerJob2 = _buf.ReadByte();
	},

	action:function(){
		Mgr.marriage.RecvResMarriageNoticePanelMessage(this);
	},

});
////////////////////
// 表白结果广播 //
////////////////////
var ResConfessionInfoBroadcastMessage = cc.Class.extend( {
	ctor:function(){
		this.senderId = null; // 表白玩家id
        this.senderName = null; // 表白玩家名字
        this.reciverId = null; // 被标靶玩家的id
        this.reciverName = null; // 被表白玩家名字
        this.itemModel = 0; // 表白道具
        this.content = null; // 表白内容
	},

	getId:function(){
		return 118113;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.senderId);
        _buf.WriteString(this.senderName);
        _buf.WriteLong(this.reciverId);
        _buf.WriteString(this.reciverName);
        _buf.WriteVarInt(this.itemModel);
        _buf.WriteString(this.content);
	},

	reading:function( _buf ){
        this.senderId = _buf.ReadLong();
        this.senderName = _buf.ReadString();
        this.reciverId = _buf.ReadLong();
        this.reciverName = _buf.ReadString();
        this.itemModel = _buf.ReadVarInt();
        this.content = _buf.ReadString();
	},

	action:function(){
		Mgr.marriage.RecvResConfessionInfoBroadcastMessage(this);
	},

});
////////////////////
// 玩家发起求婚 //
////////////////////
var ReqProposeMessage = cc.Class.extend( {
	ctor:function(){
		this.toPlayerId = null; // 对方玩家Id
        this.marriageType = 0; // 婚姻类型,1,2,3
        this.validType = 0; // 验证类型(0第一次 1第二次)
	},

	getId:function(){
		return 118201;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.toPlayerId);
        _buf.WriteVarInt(this.marriageType);
        _buf.WriteByte(this.validType);
	},

	reading:function( _buf ){
        this.toPlayerId = _buf.ReadLong();
        this.marriageType = _buf.ReadVarInt();
        this.validType = _buf.ReadByte();
	},

});
////////////////////
// 求婚回应 //
////////////////////
var ReqProposeResponseMessage = cc.Class.extend( {
	ctor:function(){
		this.fromPlayerId = null; // 求婚者玩家Id
        this.marriageType = 0; // 婚姻类型,1,2,3
        this.isAgree = 0; // 是否同意(0不同意 1同意)
	},

	getId:function(){
		return 118202;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.fromPlayerId);
        _buf.WriteVarInt(this.marriageType);
        _buf.WriteByte(this.isAgree);
	},

	reading:function( _buf ){
        this.fromPlayerId = _buf.ReadLong();
        this.marriageType = _buf.ReadVarInt();
        this.isAgree = _buf.ReadByte();
	},

});
////////////////////
// 更换信物 //
////////////////////
var ReqChangeTokenMessage = cc.Class.extend( {
	ctor:function(){
		this.itemModel = 0; // 信物Id
	},

	getId:function(){
		return 118203;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.itemModel);
	},

	reading:function( _buf ){
        this.itemModel = _buf.ReadVarInt();
	},

});
////////////////////
// 发起离婚 //
////////////////////
var ReqDivorceMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 0协议离婚 1强制离婚
	},

	getId:function(){
		return 118204;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},

	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 离婚回应 //
////////////////////
var ReqDivorceResponseMessage = cc.Class.extend( {
	ctor:function(){
		this.isAgree = 0; // 是否同意(0不同意 1同意)
	},

	getId:function(){
		return 118205;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.isAgree);
	},

	reading:function( _buf ){
        this.isAgree = _buf.ReadByte();
	},

});
////////////////////
// 确认参加婚礼观礼 //
////////////////////
var ReqVisitWeddingMessage = cc.Class.extend( {
	ctor:function(){
		this.marryId = null; // 婚礼唯一Id
	},

	getId:function(){
		return 118206;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.marryId);
	},

	reading:function( _buf ){
        this.marryId = _buf.ReadLong();
	},

});
////////////////////
// 请求改变结婚外显 //
////////////////////
var ReqChangMarryExteriorMessage = cc.Class.extend( {
	ctor:function(){
		this.exteriorId = 0; // 0不使用
	},

	getId:function(){
		return 118207;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.exteriorId);
	},

	reading:function( _buf ){
        this.exteriorId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求购买结婚投资 //
////////////////////
var ReqBuyGiftMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 118208;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

});
////////////////////
// 请求领取结婚投资 //
////////////////////
var ReqGetGiftMessage = cc.Class.extend( {
	ctor:function(){
		this.day = 0; // 第几天
	},

	getId:function(){
		return 118209;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.day);
	},

	reading:function( _buf ){
        this.day = _buf.ReadVarInt();
	},

});
////////////////////
// 玩家再次求婚,其实就是花钱领取奖励 //
////////////////////
var ReqAgainProposeMessage = cc.Class.extend( {
	ctor:function(){
		this.toPlayerId = null; // 对方玩家Id
        this.marriageType = 0; // 婚姻类型,1,2,3
        this.validType = 0; // 验证类型(0第一次 1第二次)
	},

	getId:function(){
		return 118210;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.toPlayerId);
        _buf.WriteVarInt(this.marriageType);
        _buf.WriteByte(this.validType);
	},

	reading:function( _buf ){
        this.toPlayerId = _buf.ReadLong();
        this.marriageType = _buf.ReadVarInt();
        this.validType = _buf.ReadByte();
	},

});
////////////////////
// 请求表白墙信息 //
////////////////////
var ReqConfessionPanelInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 1所有的表白，2我的表白，3对我的表白
        this.start = 0; // 开始索引 0开始
        this.limit = 0; // 请求的长度
	},

	getId:function(){
		return 118211;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.start);
        _buf.WriteVarInt(this.limit);
	},

	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.start = _buf.ReadVarInt();
        this.limit = _buf.ReadVarInt();
	},

});
////////////////////
// 请求表白 //
////////////////////
var ReqConfessionToPlayerMessage = cc.Class.extend( {
	ctor:function(){
		this.reciveId = null; // 目标玩家的id
        this.itemModel = 0; // 表白道具
        this.content = null; // 表白内容
	},

	getId:function(){
		return 118212;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.reciveId);
        _buf.WriteVarInt(this.itemModel);
        _buf.WriteString(this.content);
	},

	reading:function( _buf ){
        this.reciveId = _buf.ReadLong();
        this.itemModel = _buf.ReadVarInt();
        this.content = _buf.ReadString();
	},

});
////////////////////
// 请求表白排行信息 //
////////////////////
var ReqConfessionRankingMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 1男榜 2女榜
	},

	getId:function(){
		return 118213;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},

	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 请求祝福和送花 //
////////////////////
var ReqMarriageZhuFuMessage = cc.Class.extend( {
	ctor:function(){
		this.marryId = null; // 婚礼唯一Id
        this.opType = 0; // 1送祝福 2送花
	},

	getId:function(){
		return 118214;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.marryId);
        _buf.WriteVarInt(this.opType);
	},

	reading:function( _buf ){
        this.marryId = _buf.ReadLong();
        this.opType = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(118101, ResProposeNoticeMessage);
MESSAGE_POOL.Add(118102, ResMarriagePanelMessage);
MESSAGE_POOL.Add(118103, ResDivorceNoticeMessage);
MESSAGE_POOL.Add(118104, ResChangeTokenSucMessage);
MESSAGE_POOL.Add(118105, ResProposeValidSucMessage);
MESSAGE_POOL.Add(118106, ResNoticeVisitorMessage);
MESSAGE_POOL.Add(118107, ResVisitZoneMarryInfoMessage);
MESSAGE_POOL.Add(118108, ResMarryExteriorInfoMessage);
MESSAGE_POOL.Add(118109, ResMarryGiftInfoMessage);
MESSAGE_POOL.Add(118110, ResConfessionPanelInfoMessage);
MESSAGE_POOL.Add(118111, ResConfessionRankingMessage);
MESSAGE_POOL.Add(118112, ResMarriageNoticePanelMessage);
MESSAGE_POOL.Add(118113, ResConfessionInfoBroadcastMessage);

