var HunJiePanelExt = HunJiePanel.extend ( {
    _className:"HunJiePanelExt",
    ctor:function(){
        this._super();

        this.$type = EnumMarryResline.RING
    },
    Init:function(){
        this._super();

        UIUtil.ConnectLabelHtmlText(this.labnun	,[
            "1、结婚戒指可通过与异性结婚获取\n"
            + "2、婚戒材料可通过举办婚宴或者赴会其他玩家的婚宴获取"
        ])

        this.btnShuaXin.addClickEventListener(_=>{
            OpenFuncUtil.OpenMailPanel()
        })
        this.btnQiuHun.addClickEventListener(this.OnReqUpgrade.bind(this))
        this.btnQiuHun1.addClickEventListener(this.OnReqAutoUpgrade.bind(this))
        /// 星级
        this.sbtnArr = [this.sbtn1,this.sbtn2,this.sbtn3,this.sbtn4,this.sbtn5,this.sbtn6,this.sbtn7,this.sbtn8,this.sbtn9,this.sbtn10,]
        this.sbtnArr.forEach(v=>v.setTouchEnabled(false))
        var item = ItemUtil.ItemIdToItem(50007, 1, 0);
        GridUtil.SetItemGrid(this.grid11, item,false,false,false,true,false);
    },
    OnShow:function(){
        this._super();
        this.UpdateView()

        GameEventMgr.AddEventListener(this,new ResMarriagePanelMessage().getId(),this.OnResMarriagePanelMessage.bind(this))
        GameEventMgr.AddEventListener(this,new ResMarriageResInfoToClientMessage().getId(),this.OnResMarriageResInfoToClientMessage.bind(this))
        GameEventMgr.AddEventListener(this,new ResMarriageResResultToClientMessage().getId(),this.OnResMarriageResResultToClientMessage.bind(this))

        Mgr.marriageres.SendReqMarriageResInfoToGameMessage(this.$type)

        this.OnResMarriageResInfoToClientMessage()
        this.UpdateUpgradeInfo()
    },
    OnHide:function(){
        this._super();
        GameEventMgr.RemoveEventListener(this);
        this.OnCancelAutoUpgrade()
    },

    OnCancelAutoUpgrade:function(){
        this.$autoUpgrading = false
        this.btnQiuHun1.setTitleText(this.$autoUpgrading ? "取消" : "自动升级")
    },
    /// 升级
    OnReqUpgrade:function(){
        MarriageUtil.RequestUpgradeResLine(this.$type,false,_=>{
            /// 条件不足取消自动进阶
            this.OnReqAutoUpgrade(this.btnQiuHun1)
        })
    },
    /// 自动进阶
    OnReqAutoUpgrade:function(sender){
        this.$autoUpgrading = !this.$autoUpgrading;
        sender.setTitleText(this.$autoUpgrading ? "取消" : "自动升级")
        /// 进阶
        if(this.$autoUpgrading){
            this.OnReqUpgrade()
        }
    },
    OnResMarriagePanelMessage:function(msg){
        this.OnResMarriageResInfoToClientMessage()
        this.UpdateView()
    },
    OnResMarriageResResultToClientMessage:function(msg){
        if(msg.marriageResType != this.$type) return;

        /// 自动浇水
        TimerUtil.SetTimeout(this,function(){
            if(!this.$autoUpgrading) return;

            this.OnReqUpgrade();
        },150)
    },
    OnResMarriageResInfoToClientMessage:function(){
        var data = Mgr.marriageres.GetResInfoByType(this.$type)
        var level = 0,exp = 0
        if(data){
            level = data.level
            exp = data.exp
        }

        /// 星级
        this.sbtnArr.forEach((v,k)=>{
            v.SetButtonState(((k + 1) <= level)?"check":"uncheck");
        })

        var curProposalC = Q_marry_ring.Get(level)
        var nextProposalC = Q_marry_ring.Get(level + 1) || curProposalC

        /// 表白经验
        this.prog3.setPercent(100 * exp / (nextProposalC ? nextProposalC.q_exp : 0xFFFFFFFF))
//        UIUtil.ConnectLabelHtmlText(this.lab11	,[level])
        UIUtil.ConnectLabelHtmlText(this.labwords	,[level])
        UIUtil.ConnectLabelHtmlText(this.labn	,[exp,nextProposalC ? nextProposalC.q_exp : "???"])
        // 我的属性
        var fightpower = 0, hp=0, dp=0, at=0
        if(curProposalC){
            fightpower = Mgr.fightpower.GetFightPower(curProposalC.q_attribute)

            let attr = ParseUtil.FormatFastJsonStr(curProposalC.q_attribute);
            let attrObj = JSON.parse(attr);
            if(attrObj){
                hp = attrObj[EnumAttribute.MAX_BASEHP]
                dp = attrObj[EnumAttribute.DEFEND]
                at = attrObj[EnumAttribute.ATTACK]
            }
        }
        var nhp=0, ndp=0, nat=0
        if(nextProposalC){
            let attr = ParseUtil.FormatFastJsonStr(nextProposalC.q_attribute);
            let attrObj = JSON.parse(attr);
            if(attrObj){
                nhp = attrObj[EnumAttribute.MAX_BASEHP]
                ndp = attrObj[EnumAttribute.DEFEND]
                nat = attrObj[EnumAttribute.ATTACK]
            }
        }

        UIUtil.ConnectLabelHtmlText(this.labShengMing	,[hp])
        UIUtil.ConnectLabelHtmlText(this.labFangYu		,[dp])
        UIUtil.ConnectLabelHtmlText(this.labGongji		,[at])
        UIUtil.ConnectLabelHtmlText(this.labShengMing1	,[nhp])
        UIUtil.ConnectLabelHtmlText(this.labFangYu1		,[ndp])
        UIUtil.ConnectLabelHtmlText(this.labGongji1		,[nat])

        this.imglab1.SetText(Math.floor(fightpower))

        this.UpdateUpgradeInfo()
    },
    UpdateUpgradeInfo:function(){
        var baseC = Q_marry_base.Get(this.$type)

        var data = JSON.parse(baseC.q_item_cost)

        if(data.length == 0) return

        var itemId = data[0][0]


        var num = Mgr.backpack.GetItemNumber(itemId, true );

        var item = ItemUtil.ItemIdToItem(itemId, num, 0);
        GridUtil.SetItemGrid(this.grid1, item);
        this.labnum.visible = false
        //UIUtil.ConnectLabelHtmlText(this.labnum	,[num,1])
    },
    UpdateView:function(){
        //var activated = MarriageUtil.CheckMarriageRESActivated(this.$type)
        var activated = true // MarriageUtil.CheckMarriageRESActivated(this.$type)
        this.imgActivate.visible = activated
        this.imgUnActivate.visible = !activated
    },
} );
HunJiePanelExt.PanelName = "HunJiePanelExt";
PanelClassDic["HunJiePanelExt"] = HunJiePanelExt;
