var PaiHangPanelExt = (function(){
    var Cell1 = cc.TableViewCell.extend({
        ctor:function(){
            this._super();
        },
        SetData:function(){
            if(!this.container){
                let c = new PaiHangListBtsExt();
                c.LoadPanel();
                this.addChild(c)
                this.container = c
            }

            this.container.SetData.apply(this.container,arguments)
        },
    })
    var Cell2 = cc.TableViewCell.extend({
        ctor:function(width,height){
            this._super();
            this.width = width
            this.height = height
        },
        SetData:function(){
            if(!this.container){
                let c = new PaiHangListFlagExt();
                c.LoadPanel();
                c.setAnchorPoint(cc.p(0.5,0.5))
                c.x = this.width / 2
                c.y = this.height / 2
                this.addChild(c)
                this.container = c
            }

            this.container.SetData.apply(this.container,arguments)
        },
    })

    var Cell3 = cc.TableViewCell.extend({
        ctor:function(){
            this._super();
        },
        SetData:function(){
            if(!this.container){
                let c = new PaiHangListExt();
                c.LoadPanel();
                this.addChild(c)
                this.container = c
            }

            this.container.SetData.apply(this.container,arguments)
        },
    })
    return PaiHangPanel.extend ( {
        _className:"PaiHangPanelExt",
        ctor:function(){
            this._super();
            this.modelPanelType = 2
        },
        Init:function(){
            this._super();

            this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this))

            /// 称号
            Mgr.title.SetTitleImage(this.imgTitle,15006)

            /// 排行类型
            var size = this.imgBtns.getContentSize();
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.reloadData();
            tableView.CellWidth = size.width
            tableView.CellHeight = 80
            tableView.CellClass = Cell1

            this.imgBtns.addChild(tableView);
            this.tableView1 = tableView;

            /// 排行数据1
            var size = this.imgCubes.getContentSize();
            size.width += 50
            size.height += 50
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL);
            tableView.setDelegate(this);
            tableView.setTouchEnabled(false);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.reloadData();
            tableView.x -= 25
            tableView.y -= 25
            tableView.CellWidth = size.width / 3
            tableView.CellHeight = size.height
            tableView.CellClass = Cell2

            this.imgCubes.addChild(tableView);
            this.tableView2 = tableView;

            /// 排行数据2
            var size = this.imgLists.getContentSize();
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.reloadData();
            tableView.CellWidth = size.width
            tableView.CellHeight = 80
            tableView.CellClass = Cell3

            this.imgLists.addChild(tableView);
            this.tableView3 = tableView;

            /// self
            let c = new PaiHangListExt();
            c.LoadPanel();
            this.imgSelf.addChild(c)
            this.$container = c
        },
        OnShow:function(){
            this._super();

            GameEventMgr.AddEventListener(this,new ResToplistToClientMessage().getId(),this.OnResToplistToClientMessage.bind(this))


            this.OnTabSelected({type:PaiHangBangUtil.QINGYUAN});
        },
        OnHide:function(){
            this._super();
            GameEventMgr.RemoveEventListener(this);
        },
        OnResToplistToClientMessage:function(msg){
            if(this.tableView1.CellData.findIndex(v=>v.type == msg.meTopInfo.toptype) == -1) return;

            var indexMap = [1,0,2]
            this.tableView2.CellData = Array.from({length:3},(v,k)=>msg.topInfolist[indexMap[k]])
            this.tableView3.CellData = msg.topInfolist.slice(3,msg.topInfolist.length)
//            this.tableView3.CellData = msg.topInfolist
            this.tableView2.reloadData()
            this.tableView3.reloadData()

            this.$container.SetData(msg.meTopInfo,true)
        },
        OnTabSelected:function(data){
            this.selectedTab = data.type
            this.ReloadTab();

            this.RequestToplistToGameMessage(this.selectedTab)
        },
        RequestToplistToGameMessage:function(type){
            Mgr.top.SendReqToplistToGameMessage(0,type, 0,99,0);
        },
        ReloadTab:function(data){
            this.tableView1.CellData =  [
                { type : PaiHangBangUtil.QINGYUAN, name : "情\t缘"},
            ]
            this.tableView1.reloadData()

            var viewSize = this.tableView1.getViewSize();
            var size = this.tableView1.getContentSize();

            this.tableView1.setTouchEnabled(viewSize.height <= size.height);
        },
        tableCellSizeForIndex:function(sender,index){
            return cc.size(sender.CellWidth,sender.CellHeight);
        },
        tableCellAtIndex:function(sender,index){
            var cell = sender.dequeueCell();
            if (!cell) {
               cell = new sender.CellClass(sender.CellWidth,sender.CellHeight);
            }

            cell.SetData(sender.CellData[index],this);
            return cell;
        },
        numberOfCellsInTableView:function(sender){
            return sender.CellData ? sender.CellData.length : 0;
        },
    } );
})()
PaiHangPanelExt.PanelName = "PaiHangPanelExt";
PanelClassDic["PaiHangPanelExt"] = PaiHangPanelExt;
