var QinYiMMPanelExt = QinYiMMPanel.extend ( {
    _className:"QinYiMMPanelExt",
    ctor:function(){
        this._super();
        this.modelPanelType = 2
    },
    Init:function(){
        this._super();

        this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));
        this.btnQiuHun.addClickEventListener(_=>{
            var data = this.data;
            if(data.status == 1){
                Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(data.activityId, 1);
            }
        });

        this.gridArr = [ this.grid1 ]
        this.$X = this.grid1.x + this.grid1.width / 2
        this.$Y = this.grid1.y + this.grid1.height / 2
    },
    OnShow:function(){
        this._super();
        this.UpdateView();
    },
    OnHide:function(){
        this._super();
    },
    UpdateView:function(){
        var globalC = Q_global.Get(20026)

        var awards = JSON.parse(globalC.q_string_value)

        for(let i = 0;i < Math.max(this.gridArr.length,awards.length);++i){
            let grid = this.gridArr[i]
            if(!grid){
                grid = UIUtil.CloneUI(this.grid1)
                this.grid1.parent.addChild(grid)
                this.gridArr[i] = grid;
            }
            if(awards[i]){
                var item = ItemUtil.ItemConfigToItem(awards[i]);
                GridUtil.SetItemGrid(grid, item);

                grid.visible = true
            }else{
                grid.visible = false
            }
        }
        /// 显示的
        var array = this.gridArr.filter(v=>v.visible);
        var interval = 90
        var width = array.length * interval / 2
        array.forEach((v,k)=>{
            v.x = this.$X - width + k * interval
        })
    },
    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        this.UpdateStatus();
    },
    UpdateSingleActivity:function(){
        this.UpdateStatus()
    },
    UpdateStatus:function(){
        var activityVo = MarriageUtil.GetQYMMActivity();
        this.data = activityVo
        switch(activityVo.status){
            case 0:
                this.btnQiuHun.setTitleText("已领取");
                Filter.GrayScale(this.btnQiuHun);
                break;
            case 1:
                this.btnQiuHun.setTitleText("购买");
                Filter.UnGray(this.btnQiuHun);
                break;
            case 2:
                this.btnQiuHun.setTitleText("购买");
                Filter.GrayScale(this.btnQiuHun);
                break;
        }
    },
} );
QinYiMMPanelExt.PanelName = "QinYiMMPanelExt";
PanelClassDic["QinYiMMPanelExt"] = QinYiMMPanelExt;
