var XiangSiPanelExt = XiangSiPanel.extend ( {
    _className:"XiangSiPanelExt",
    ctor:function(){
        this._super();

        this.$type = EnumMarryResline.MISS
    },
    GetAutoBuy:function(){
        return this.sbtn1.GetState() === "check"
    },
    Init:function(){
        this._super();

        this.btnQiuHun.addClickEventListener(this.OnBtnAutoUpgrade.bind(this))
        this.sbtn1.addTouchEventListener(function(sender,type){
            if (type == ccui.Widget.TOUCH_ENDED) {
                sender.SetButtonState(sender.GetState() === "check"?"uncheck":"check");
            }
        })
        this.btnWenHao.addClickEventListener(_=>{
            AlertTipsExt.Show(
                "1.每天可以免费浇灌自己的相思树<font color='#0900d1'>3次<font color='#3a2707'>.\n\n"
                + "2.相思树祝福值满后,自动提升等级,增加人物属性.\n\n"
                + "3.伴侣的相思树<font color='#0900d1'>50%<font color='#3a2707'>的属性增加到角色身上,离婚后这部分属性消失.\n\n"
            );
        })
    },

    OnShow:function(){
        GameEventMgr.AddEventListener(this,new ResMarriagePanelMessage().getId(),this.OnResMarriageResInfoToClientMessage.bind(this))
        GameEventMgr.AddEventListener(this,new ResMarriageResInfoToClientMessage().getId(),this.OnResMarriageResInfoToClientMessage.bind(this))
        GameEventMgr.AddEventListener(this,new ResMarriageResResultToClientMessage().getId(),this.OnResMarriageResResultToClientMessage.bind(this))

        Mgr.marriageres.SendReqMarriageResInfoToGameMessage(this.$type)

        this.OnResMarriageResInfoToClientMessage()
    },
    OnHide:function(){
        GameEventMgr.RemoveEventListener(this);
        this.OnCancelAutoUpgrade()
    },
    OnCancelAutoUpgrade:function(){
        this.$autoUpgrading = false
        this.btnQiuHun.setTitleText(this.$autoUpgrading ? "取消" : "自动浇水")
    },
    OnBtnAutoUpgrade:function(sender){
        this.$autoUpgrading = !this.$autoUpgrading;

        sender.setTitleText(this.$autoUpgrading ? "取消" : "自动浇水")
        /// 进阶
        if(this.$autoUpgrading){
            this.RequestUpgrade()
        }
    },
    OnResMarriageResResultToClientMessage:function(msg){
        if(msg.marriageResType != this.$type) return;

        /// 自动浇水
        TimerUtil.SetTimeout(this,function(){
            if(!this.$autoUpgrading) return;

            this.RequestUpgrade();
        },150)
    },
    OnResMarriageResInfoToClientMessage:function(){
        var data = Mgr.marriageres.GetResInfoByType(this.$type)
        var level = 0,exp = 0
        if(data){
            level = data.level
            exp = data.exp
        }

        UIUtil.ConnectLabelHtmlText(this.labword11	,[level])

        /// TA的表白等级
        var marriageInfo = Mgr.marriage.GetMarriageInfo()
        if(marriageInfo){
            let oLevel = marriageInfo.getResLevel(this.$type)
            UIUtil.ConnectLabelHtmlText(this.labword1	,[oLevel])
        }else{
            this.labword1.SetText("暂无伴侣")
        }

        var curAureoleC = Q_marry_tree.Get(level)
        var nextAureoleC = Q_marry_tree.Get(level + 1) || curAureoleC
        /// 更新属性和战斗力
        var fightpower = 0, hp=0, dp=0, at=0
        if(curAureoleC){
            fightpower = Mgr.fightpower.GetFightPower(curAureoleC.q_attribute)

            let attr = ParseUtil.FormatFastJsonStr(curAureoleC.q_attribute);
            let attrObj = JSON.parse(attr);
            hp = attrObj[EnumAttribute.MAX_BASEHP]
            dp = attrObj[EnumAttribute.DEFEND]
            at = attrObj[EnumAttribute.ATTACK]
        }

        // TA的表白等级
        var ohp="", odp="", oat=""
        var marriageInfo = Mgr.marriage.GetMarriageInfo()
        do{
            if(!marriageInfo) break;

            var oLevel = marriageInfo.getResLevel(this.$type)
            var oCurAureoleC = Q_marry_tree.Get(oLevel)
            if(oCurAureoleC){
                let per =  oCurAureoleC.q_attribute_partner / 100
                fightpower += parseInt(Mgr.fightpower.GetFightPower(oCurAureoleC.q_attribute) * per)

                ohp=0, odp=0, oat=0

                let attr = ParseUtil.FormatFastJsonStr(oCurAureoleC.q_attribute);
                let attrObj = JSON.parse(attr);
                if(attrObj){
                    ohp = attrObj[EnumAttribute.MAX_BASEHP] * per
                    odp = attrObj[EnumAttribute.DEFEND] * per
                    oat = attrObj[EnumAttribute.ATTACK] * per
                }
                ohp = "\t<font color='#f0d36e'>(伴侣+" + Math.floor(ohp) + ")"
                odp = "\t<font color='#f0d36e'>(伴侣+" + Math.floor(odp) + ")"
                oat = "\t<font color='#f0d36e'>(伴侣+" + Math.floor(oat) + ")"
            }
        }while(false)

        UIUtil.ConnectLabelHtmlText(this.labShengMing	,[hp + ohp])
        UIUtil.ConnectLabelHtmlText(this.labFangYu		,[dp + odp])
        UIUtil.ConnectLabelHtmlText(this.labGongji		,[at + oat])

        UIUtil.ConnectLabelHtmlText(this.labn	,[exp,nextAureoleC ? nextAureoleC.q_exp : "???"])
        this.prog3.setPercent(100 * exp / (nextAureoleC ? nextAureoleC.q_exp : 0xFFFFFFFF))
        this.imglab1.SetText(Math.floor(fightpower))

        /// 更新升级需要道具信息
        var baseC = Q_marry_base.Get(this.$type)
        var itemCosts = JSON.parse(baseC.q_item_cost)

        if(itemCosts.length != 0){
            let itemId = itemCosts[0][0]
            let num = Mgr.backpack.GetItemNumber(itemId, true );
            let item = ItemUtil.ItemIdToItem(itemId, num, 0);
            GridUtil.SetItemGrid(this.grid1, item);
        }

        UIUtil.ConnectLabelHtmlText(this.labnun	,[data ? data.freeUpNm : 0])
    },

    RequestUpgrade:function(){
        MarriageUtil.RequestUpgradeResLine(this.$type,this.GetAutoBuy(),_=>{
            this.OnBtnAutoUpgrade(this.btnQiuHun)
        })
    },
} );
XiangSiPanelExt.PanelName = "XiangSiPanelExt";
PanelClassDic["XiangSiPanelExt"] = XiangSiPanelExt;
