///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//MarriageResInfo 婚姻资源线数据

// 请求消息
//150201,ReqMarriageResInfoToGame 请求婚姻资源线信息
//150202,ReqMarriageResAddToGame 请求激活
//150203,ReqMarriageResUpToGame 请求升阶

// 接收消息
//150101,ResMarriageResInfoToClient 发送婚姻资源线信息
//150102,ResMarriageResResultToClient 发送升阶信息
//150103,ResMarriageResAddResultToClient 发送激活结果


var MarriageResInfo = cc.Class.extend({
	ctor:function(){
		this.marriageResType = 0; // 类型(1婚戒，2表白，3相思，4光环)
        this.level = 0; // 当前阶数或者等级
        this.exp = 0; // 当前升级经验或者祝福值
        this.freeUpNm = 0; // 免费进阶次数每日
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.marriageResType);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.exp);
        _buf.WriteVarInt(this.freeUpNm);
	},

	reading:function( _buf ){
		this.marriageResType = _buf.ReadVarInt();
        this.level = _buf.ReadVarInt();
        this.exp = _buf.ReadVarInt();
        this.freeUpNm = _buf.ReadVarInt();
	},
});
////////////////////
// 发送婚姻资源线信息 //
////////////////////
var ResMarriageResInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.marriageResInfo = null; // 婚姻资源线数据
	},

	getId:function(){
		return 150101;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.marriageResInfo);
	},

	reading:function( _buf ){
        this.marriageResInfo = _buf.ReadBean(MarriageResInfo);
	},

	action:function(){
		Mgr.marriageres.RecvResMarriageResInfoToClientMessage(this);
	},

});
////////////////////
// 发送升阶信息 //
////////////////////
var ResMarriageResResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.marriageResType = 0; // 类型(1婚戒，2表白，3相思，4光环)
        this.result = 0; // 升阶是否成功（1成功0失败）
	},

	getId:function(){
		return 150102;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.marriageResType);
        _buf.WriteVarInt(this.result);
	},

	reading:function( _buf ){
        this.marriageResType = _buf.ReadVarInt();
        this.result = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.marriageres.RecvResMarriageResResultToClientMessage(this);
	},

});
////////////////////
// 发送激活结果 //
////////////////////
var ResMarriageResAddResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.marriageResType = 0; // 类型(1婚戒，2表白，3相思，4光环)
	},

	getId:function(){
		return 150103;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.marriageResType);
	},

	reading:function( _buf ){
        this.marriageResType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.marriageres.RecvResMarriageResAddResultToClientMessage(this);
	},

});
////////////////////
// 请求婚姻资源线信息 //
////////////////////
var ReqMarriageResInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.marriageResType = 0; // 类型(1婚戒，2表白，3相思，4光环)
	},

	getId:function(){
		return 150201;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.marriageResType);
	},

	reading:function( _buf ){
        this.marriageResType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求激活 //
////////////////////
var ReqMarriageResAddToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.marriageResType = 0; // 类型(1婚戒，2表白，3相思，4光环)
	},

	getId:function(){
		return 150202;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.marriageResType);
	},

	reading:function( _buf ){
        this.marriageResType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求升阶 //
////////////////////
var ReqMarriageResUpToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.marriageResType = 0; // 类型(1婚戒，2表白，3相思，4光环)
        this.costType = 0; // 消耗类型（0是道具，1是免费）
	},

	getId:function(){
		return 150203;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.marriageResType);
        _buf.WriteVarInt(this.costType);
	},

	reading:function( _buf ){
        this.marriageResType = _buf.ReadVarInt();
        this.costType = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(150101, ResMarriageResInfoToClientMessage);
MESSAGE_POOL.Add(150102, ResMarriageResResultToClientMessage);
MESSAGE_POOL.Add(150103, ResMarriageResAddResultToClientMessage);

