var MeltingModMgr = MeltingModMgr || cc.Class.extend({

	isTips:null,

	_lastValue:null,
	_isMelted:null,

	isAutoMelting:false,

	ctor:function() {
		this.isTips = true;
		this._isMelted = false;
		this._lastValue = 0;
	},

	RecvResMeltingInfoToClientMessage:function(msg) {
		cc.log(" RecvResMeltingInfoToClientMessage!!! " + JSON.stringify(msg));

		var panel = EngineMgr.uiMgr._GetPanelByName(DuanzaoPanelExt.PanelName);
		if (panel) {
			var page = panel.panelMgr[DuanzaoTypeEnum.EQUIP_MELTING];
			if ( page )
				page.UpdateMelting( msg.meltingLevel, msg.meltingExp );
		}

		// 累计熔炼值
		var total_value = 0;
		for ( var i = 0; i != msg.meltingLevel; i++ ) {
			var data = Q_melt_attribute.Get(i);
			if ( !data ) {
				zz.Error(" data is not in Q_melt_attribute, level : " + i);
				continue;
			}
			total_value += data.q_exp;
		}
		total_value +=  msg.meltingExp;

		// 获取熔炼值提示 (后端提示相对好一些)
		if ( Mgr.melting._isMelted ) {
			this._isMelted = false;

			var value = total_value - this._lastValue;
			if ( value > 0 ) {
				var str = "熔炼成功，获得" + value + "点熔炼值";
				Mgr.tips.ShowNotice(str);
			}
		}
		this._lastValue = total_value;
	},

	SendReqMeltingToGameMessage:function( list ) {
		cc.log(" SendReqMeltingToGameMessage!!! ");
		var msg = new ReqMeltingToGameMessage();
		msg.itemList = list;
		Mgr.msgMgr.Send( msg );
	}, 

	SendReqOpenMeltingToGameMessage:function() {
		cc.log(" SendReqOpenMeltingToGameMessage!!! ");
		var msg = new ReqOpenMeltingToGameMessage();
		Mgr.msgMgr.Send( msg );
	}
});