var ChangeNamePanelExt = ChangeNamePanel.extend ( {
	_className:"ChangeNamePanelExt",
	_itemsNum:0,
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
	},
	Init:function()
	{
		ChangeNamePanel.prototype.Init.call(this);
		this._SetBaseProperty();
		this._HandleButton();
		this._SetGridInfo();
	},
	_HandleButton:function()
	{
		var self = this;
		this.btnClose.addClickEventListener(function(){
			EngineMgr.uiMgr.HidePanel(self);
		});
		//确定
		this.btn1.addClickEventListener(function()
		{
			self._ChangeName();
		});
	},
	_SetGridInfo:function()
	{
		var data01 = ItemUtil.ItemIdToItem(101,1);
		GridUtil.SetItemGrid(this.grid1,data01,null,null,null,null,false);
	},
	_ChangeName:function()
	{
		if(this._itemsNum>0)
		{
			var name = this.editName.string;
			Mgr.player.SendReqPlayerChangeNameMessage(name);
		}
		else
		{
			Mgr.tips.ShowNotice("改名卡不足");
		}
	},
	_SetBaseProperty:function()
	{
		this.editName.setPlaceHolder("请输入新名称");
		this.editName.setPlaceholderFontColor(UIUtil.GetCCColor(EnumFontFormat.COMMON_COLOR08));
		this.editName.setFontSize(EnumFontFormat.FONTSIZE_TIP);
		this.editName.setTextColor(UIUtil.GetCCColor(EnumFontFormat.COMMON_COLOR08));

		this.labTitle.SetColor(EnumFontFormat.COMMON_COLOR02);
		this.labCue.SetColor(EnumFontFormat.COMMON_COLOR02);
		this.btn1.SetTitleTextColor(EnumFontFormat.COMMON_COLOR05);
		this.btn1.SetTitleTextFontSize(EnumFontFormat.FONTSIZE_BUTTON);
		this.labNumber.setLocalZOrder(100);
		this.labNumber1.setLocalZOrder(100);
		this.labNumber.SetColor(EnumFontFormat.COMMON_COLOR04);
		this.labNumber1.SetColor(EnumFontFormat.COMMON_COLOR04);
	},
	OnShow:function()
	{
		var num = Mgr.backpack.GetItemNumber(101);
		this.labNumber.SetColor(EnumFontFormat.COMMON_COLOR09);
		if(num>0)
		{
			this.labNumber.SetColor(EnumFontFormat.COMMON_COLOR04);
		}
		this._itemsNum = num;
		this.labNumber.SetString(num);
	}
} );
ChangeNamePanelExt.PanelName = "ChangeNamePanelExt";
PanelClassDic["ChangeNamePanelExt"] = ChangeNamePanelExt;



