var NewEquipCueExt = NewEquipCue.extend ( {
	_className:"NewEquipCueExt",
	_equips:[],
	_isMoving:false,
	ctor:function(){
		this._super();
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -(ToolBase.GetWinHeight() / 3);
	},
	Init:function()
	{
		var self = this;
		NewEquipCue.prototype.Init.call(this);

		this.labCue.SetColor(EnumFontFormat.COMMON_COLOR09);
	},
	_SetLocalProperty:function()
	{
		this._gridEquipArr =[
			{grid:this.gridEquip0,originPos:this.gridEquip0.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_WEAPONS},
			{grid:this.gridEquip1,originPos:this.gridEquip1.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_CLOTHES},
			{grid:this.gridEquip2,originPos:this.gridEquip2.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_BRACELET_LEFT},
			{grid:this.gridEquip3,originPos:this.gridEquip3.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_BELT},
			{grid:this.gridEquip4,originPos:this.gridEquip4.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_HUTUI},
			{grid:this.gridEquip5,originPos:this.gridEquip5.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_SHOES},
			{grid:this.gridEquip6,originPos:this.gridEquip6.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_HUFU_LEFT},
			{grid:this.gridEquip7,originPos:this.gridEquip7.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_RING_LEFT},
			{grid:this.gridEquip8,originPos:this.gridEquip8.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_HUFU_RIGHT},
			{grid:this.gridEquip9,originPos:this.gridEquip9.getPosition(),isMoving:false,type:EnumEquipPos.EQUIP_RING_RIGHT}
		]
	},
	_InitPosition:function()
	{
		if (!this._gridEquipArr)
		{
			this._SetLocalProperty();
			this._EquipedEquipment();
		}
		var self = this;
		var time = 0.3;
		this.scale = 0;
		var scaleTo = cc.scaleTo(time, 1, 1);
		var dTime = 2;
		var delay  = cc.delayTime(dTime);
		var callFunc= cc.callFunc(function(target)
		{
			self._isMoving = false;
			target._equips.splice(0);
			target.visible = false;
		});
		var sequence = cc.sequence(scaleTo,delay,callFunc);
		this.runAction(sequence);
	},
	ShowNewEquipment:function(msg)
	{
		if(this._isMoving)
		{
			return;
		}
		this._isMoving = true;
		this.visible = true;
		this._InitPosition();//播放弹出动画
		var itemico = null;
		var index = 0;
		var self = this;
		for (var i = 0; i < this._gridEquipArr.length; i++ )
		{
			var q_kind = Q_item.Get(msg.equip.itemModelId).q_kind;
			if(this._gridEquipArr[i].type == q_kind)
			{
				index = i;
				itemico = GridUtil.SetItemGrid(this._gridEquipArr[i].grid,msg.equip,null,null,null,null,false);
				break;
			}
		}
		//return;
		if( itemico && !this._gridEquipArr[index].isMoving)
		{
			this._gridEquipArr[index].isMoving = true;
			itemico.visible = false;
			var gapH = 200,delayTime = 0.5;
			var opos = itemico.getPosition();
			itemico.setPosition(-gapH,opos.y+gapH);
			itemico.setLocalZOrder(100);
			this.scheduleOnce(function()
			{
				itemico.visible = true;
				var moveTo = cc.moveTo(delayTime,opos.x,opos.y);
				var callFunc = cc.callFunc(function()
				{
					self._gridEquipArr[index].isMoving = false;
				},this);
				var sequence = cc.sequence(moveTo,callFunc);
				itemico.runAction(sequence);
			},delayTime);
		}
	},
	//已经穿戴的装备
	_EquipedEquipment:function()
	{
		var data01 = Mgr.player.mainPlayer;
		var equips = data01.equips;
		for ( var i = 0; i < equips.length; i++ )
		{
			var q_item = Q_item.Get(equips[i].itemModelId);
			for(var j = 0; j < this._gridEquipArr.length;j++)
			{
				if(this._gridEquipArr[j].type == q_item.q_kind)
				{
					GridUtil.SetItemGrid(this._gridEquipArr[j].grid,equips[i], null,null, null, null, false);
					break;
				}
			}
		}
	}
} );


NewEquipCueExt.PanelName = "NewEquipCueExt";
PanelClassDic["NewEquipCueExt"] = NewEquipCueExt;