///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//FightAttributeInfo 个人战斗属性（参与属性计算的）
//BasisAttriInfo 个人基本属性项（HP和等级之类）
//CurrencyInfo 货币类型信息
//PlayerResLineInfo 通用资源线展示
//PlayerUseItem 玩家使用的加属性类道具
//PlayerAppearanceInfo 玩家外观展示信息
//PlayerEquipsInfo 玩家装备信息
//MyPlayerInfo 本人玩家详细信息
//PlayerBriefInfo 玩家外观展示信息

// 请求消息
//103201,ReqRevive 回城复活
//103202,ReqLocalRevive 原地复活
//103203,ReqChangePKState 请求更改pk状态
//103204,ReqAutoStart 请求挂机开始
//103205,ReqAutoEnd 请求挂机结束
//103206,ReqPlayerChangeName 玩家修改名字
//103207,ReqPlayerBrief 玩家简要信息
//103208,ReqPlayerNonageRegister 玩家防沉迷注册身份证
//103209,ReqNonageTime 请求防沉迷时间
//103210,ReqOthersPlayerInfo 查看他人信息
//103211,ReqChangeWin 改变游戏窗口大小
//103212,ReqPhoneVerificationReward 请求电话验证状态领奖
//103213,ReqRechargeInfo 请求我的充值信息
//103214,ReqChangePlayerFashion 请求更换我的时装造型
//103215,ReqPublicPlayerBrief 获取跨服玩家简要信息
//103216,ReqPlayerChangeNameTime 请求改名冷却剩余时间
//103217,ReqChangePlayerNonageState 请求改变玩家防沉迷状态改变
//103218,ReqAppRecharegeOrder 请求服务器充值订单号

// 接收消息
//103101,ResMyPlayerInfo 本人玩家信息
//103102,ResPlayerAddExp 玩家增加经验
//103103,ResPersonalNotice 个人通知
//103105,BroadcastPlayerAttriChange 广播人物基本属性变化消息(HP,等级。。。)
//103106,ResPlayerAttributesChange 个人属性值变化(攻击防御等)
//103107,ResPlayerBrief 玩家简要信息
//103108,ResSyncServerTime 同步服务端时间给客户端
//103109,ResPlayerStateChange 玩家战斗状态改变
//103110,ResChangePKState 更改pk状态
//103111,ResChangePlayerNameToClient 玩家改名，完成后通知客户端
//103112,ResAutoStartState 返回挂机状态
//103113,RespopuGuide 通用弹出引导
//103114,ResPlayerDie 玩家死亡消息
//103115,ResReviveSuccess 复活成功
//103116,ResPlayerNonageState 玩家防沉迷状态改变
//103117,NonagePrompt 防沉迷提示信息
//103118,ResPlayerNonageTime 玩家防沉迷在线时间
//103119,ResPlayerNonageRegister 玩家防沉迷注册返回消息
//103121,ResPhoneVerificationStatus 电话验证状态
//103122,ResCountdownToClient 展示倒计时状态
//103123,ResRechargeInfo 请求我的充值信息
//103124,ResTotalOnlineTime 发送玩家在线时间
//103125,ReskillnumToClient 发送玩家杀人数量,决定名字颜色
//103126,ResServerPlayerNumToClinet 通知前端服务器人数
//103128,BroadcastFightAttriChange 广播人物战斗属性变化消息(攻击，防御。。。)
//103129,ResPlayerCurrencyInfo 人物基本货币改变信息
//103130,ResPlayerOfflinePluginTime 离线挂机剩余时间
//103131,ResPlayerChangeNameTime 改名冷却剩余时间
//103132,ResPlayerPluginRecord 挂机结算
//103133,ResTodayGoldCostToClinet 发送今日元宝消耗给前端
//103134,ResPlayerFactionChangeToRound 发送今日元宝消耗给前端
//103135,ResNotEnoughGoldChange 发送给前端：元宝不足
//103136,ResAppRecharegeOrder 请求服务器充值订单号


var FightAttributeInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 属性类型()
        this.value = 0; // 属性值
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarLong(this.value);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.value = _buf.ReadVarLong();
	},
});
var BasisAttriInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 属性类型()
        this.value = 0; // 属性值
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarLong(this.value);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.value = _buf.ReadVarLong();
	},
});
var CurrencyInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 属性类型()
        this.value = 0; // 属性值
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.value);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.value = _buf.ReadVarInt();
	},
});
var PlayerResLineInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 资源线类型
        this.modelid = 0; // 资源线modelid(当前阶数)
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteByte(this.modelid);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadByte();
        this.modelid = _buf.ReadByte();
	},
});
var PlayerUseItem = cc.Class.extend({
	ctor:function(){
		this.itemModelId = 0; // 道具ID
        this.itemNum = 0; // 属道具数量
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.itemModelId);
        _buf.WriteVarInt(this.itemNum);
	},
	
	reading:function( _buf ){
		this.itemModelId = _buf.ReadVarInt();
        this.itemNum = _buf.ReadVarInt();
	},
});
var PlayerAppearanceInfo = cc.Class.extend({
	ctor:function(){
		this.job = 0; // 玩家职业
        this.disguiseId = 0; // 易容
        this.armorId = 0; // 光翼
        this.weaponRideid = 0; // 光武携带id
	},

	writing:function( _buf ){
		_buf.WriteByte(this.job);
        _buf.WriteVarInt(this.disguiseId);
        _buf.WriteVarInt(this.armorId);
        _buf.WriteVarInt(this.weaponRideid);
	},
	
	reading:function( _buf ){
		this.job = _buf.ReadByte();
        this.disguiseId = _buf.ReadVarInt();
        this.armorId = _buf.ReadVarInt();
        this.weaponRideid = _buf.ReadVarInt();
	},
});
var PlayerEquipsInfo = cc.Class.extend({
	ctor:function(){
		this.equips = []; // 装备信息列表 ItemInfo
        this.equipType = 0; // 装备类型
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.equips.length );
        for (var i = 0; i < this.equips.length; i++) {
            _buf.WriteBean(this.equips[i]);
        }
        _buf.WriteVarInt(this.equipType);
	},
	
	reading:function( _buf ){
		var equips_length = _buf.ReadUShort();
        for (var i = 0; i < equips_length; i++) {
            this.equips[i] = _buf.ReadBean(ItemInfo);
        }
        this.equipType = _buf.ReadVarInt();
	},
});
var MyPlayerInfo = cc.Class.extend({
	ctor:function(){
		this.personId = null; // 角色Id
        this.name = null; // 角色名字
        this.mapModelId = 0; // 角色所在地图模版
        this.x = 0; // 角色所在X
        this.y = 0; // 角色所在Y
        this.dir = 0; // 人物面对方向
        this.exp = 0; // 角色经验
        this.pkState = 0; // 角色PK状态
        this.nonage = 0; // 玩家防沉迷状态 0-非防沉迷 1-正常 2-疲劳 3-不健康
        this.attributeList = []; // 角色战斗属性信息 FightAttributeInfo
        this.basisAttriInfos = []; // 角色基本属性信息（HP和等级） BasisAttriInfo
        this.currencyInfos = []; // 角色货币信息 CurrencyInfo
        this.job = 0; // 玩家职业
        this.curFashion = []; // 时装ID int
        this.fightpower = 0; // 战斗力
        this.viplevel = 0; // vip等级
        this.gmLevel = 0; // gm等级(0非GM 1最高权限2部分封号禁言权限)
        this.cellnum = 0; // 背包格子数
        this.guildId = null; // 帮会Id
        this.playerEquipInfos = []; // 玩家装备信息列表 PlayerEquipsInfo
        this.items = []; // 背包物品信息列表 ItemInfo
        this.killnum = 0; // 杀人数量,0是白色名字,2个以下是黄色名字,3个以上是红色
        this.isGreyname = 0; // 是否灰名,0不是灰,,大于0灰色时间(灰色优先级高于白色和黄色)
        this.playerUseItems = []; // 玩家本身使用的加属性道具列表(比如人物属性丹药),坐骑和其他的资源线不在这里 PlayerUseItem
        this.useTitleModel = 0; // 穿戴的称号modelid
        this.spouseName = null; // 配偶名字
        this.serverKey = 0; // serverKey
        this.playerResLineInfo = []; // 通用资源线简要信息列表 PlayerResLineInfo
        this.disguiseId = 0; // 当前展示的易容ID
        this.armorShowId = 0; // 当前展示的战甲ID
        this.headTitleId = 0; // 头衔modelId
        this.gossipLevel = 0; // 穿戴的太极阵等级
        this.suitRank = 0; // 当前激活的品质套装阶数
        this.reincarnatelv = 0; // 当前转生等级
        this.showIllusionInfo = []; // 幻化系统的外显 ShowIllusionInfo
        this.marryExteriorId = 0; // 当前展示的结婚造型modelid
        this.innateModel = 0; // 萌化外显model
        this.charmNum = 0; // 魅力值
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteString(this.name);
        _buf.WriteVarInt(this.mapModelId);
        _buf.WriteShort(this.x);
        _buf.WriteShort(this.y);
        _buf.WriteByte(this.dir);
        _buf.WriteVarLong(this.exp);
        _buf.WriteVarInt(this.pkState);
        _buf.WriteByte(this.nonage);
        _buf.WriteUShort( this.attributeList.length );
        for (var i = 0; i < this.attributeList.length; i++) {
            _buf.WriteBean(this.attributeList[i]);
        }
        _buf.WriteUShort( this.basisAttriInfos.length );
        for (var i = 0; i < this.basisAttriInfos.length; i++) {
            _buf.WriteBean(this.basisAttriInfos[i]);
        }
        _buf.WriteUShort( this.currencyInfos.length );
        for (var i = 0; i < this.currencyInfos.length; i++) {
            _buf.WriteBean(this.currencyInfos[i]);
        }
        _buf.WriteByte(this.job);
        _buf.WriteUShort( this.curFashion.length );
        for (var i = 0; i < this.curFashion.length; i++) {
            _buf.WriteVarInt(this.curFashion[i]);
        }
        _buf.WriteVarLong(this.fightpower);
        _buf.WriteByte(this.viplevel);
        _buf.WriteByte(this.gmLevel);
        _buf.WriteShort(this.cellnum);
        _buf.WriteLong(this.guildId);
        _buf.WriteUShort( this.playerEquipInfos.length );
        for (var i = 0; i < this.playerEquipInfos.length; i++) {
            _buf.WriteBean(this.playerEquipInfos[i]);
        }
        _buf.WriteUShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
        _buf.WriteByte(this.killnum);
        _buf.WriteByte(this.isGreyname);
        _buf.WriteUShort( this.playerUseItems.length );
        for (var i = 0; i < this.playerUseItems.length; i++) {
            _buf.WriteBean(this.playerUseItems[i]);
        }
        _buf.WriteVarInt(this.useTitleModel);
        _buf.WriteString(this.spouseName);
        _buf.WriteVarInt(this.serverKey);
        _buf.WriteUShort( this.playerResLineInfo.length );
        for (var i = 0; i < this.playerResLineInfo.length; i++) {
            _buf.WriteBean(this.playerResLineInfo[i]);
        }
        _buf.WriteByte(this.disguiseId);
        _buf.WriteByte(this.armorShowId);
        _buf.WriteByte(this.headTitleId);
        _buf.WriteVarInt(this.gossipLevel);
        _buf.WriteVarInt(this.suitRank);
        _buf.WriteVarInt(this.reincarnatelv);
        _buf.WriteUShort( this.showIllusionInfo.length );
        for (var i = 0; i < this.showIllusionInfo.length; i++) {
            _buf.WriteBean(this.showIllusionInfo[i]);
        }
        _buf.WriteVarInt(this.marryExteriorId);
        _buf.WriteVarInt(this.innateModel);
        _buf.WriteVarInt(this.charmNum);
	},

	reading:function( _buf ){
		this.personId = _buf.ReadLong();
        this.name = _buf.ReadString();
        this.mapModelId = _buf.ReadVarInt();
        this.x = _buf.ReadShort();
        this.y = _buf.ReadShort();
        this.dir = _buf.ReadByte();
        this.exp = _buf.ReadVarLong();
        this.pkState = _buf.ReadVarInt();
        this.nonage = _buf.ReadByte();
        var attributeList_length = _buf.ReadUShort();
        for (var i = 0; i < attributeList_length; i++) {
            this.attributeList[i] = _buf.ReadBean(FightAttributeInfo);
        }
        var basisAttriInfos_length = _buf.ReadUShort();
        for (var i = 0; i < basisAttriInfos_length; i++) {
            this.basisAttriInfos[i] = _buf.ReadBean(BasisAttriInfo);
        }
        var currencyInfos_length = _buf.ReadUShort();
        for (var i = 0; i < currencyInfos_length; i++) {
            this.currencyInfos[i] = _buf.ReadBean(CurrencyInfo);
        }
        this.job = _buf.ReadByte();
        var curFashion_length = _buf.ReadUShort();
        for (var i = 0; i < curFashion_length; i++) {
            this.curFashion[i] = _buf.ReadVarInt();
        }
        this.fightpower = _buf.ReadVarLong();
        this.viplevel = _buf.ReadByte();
        this.gmLevel = _buf.ReadByte();
        this.cellnum = _buf.ReadShort();
        this.guildId = _buf.ReadLong();
        var playerEquipInfos_length = _buf.ReadUShort();
        for (var i = 0; i < playerEquipInfos_length; i++) {
            this.playerEquipInfos[i] = _buf.ReadBean(PlayerEquipsInfo);
        }
        var items_length = _buf.ReadUShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(ItemInfo);
        }
        this.killnum = _buf.ReadByte();
        this.isGreyname = _buf.ReadByte();
        var playerUseItems_length = _buf.ReadUShort();
        for (var i = 0; i < playerUseItems_length; i++) {
            this.playerUseItems[i] = _buf.ReadBean(PlayerUseItem);
        }
        this.useTitleModel = _buf.ReadVarInt();
        this.spouseName = _buf.ReadString();
        this.serverKey = _buf.ReadVarInt();
        var playerResLineInfo_length = _buf.ReadUShort();
        for (var i = 0; i < playerResLineInfo_length; i++) {
            this.playerResLineInfo[i] = _buf.ReadBean(PlayerResLineInfo);
        }
        this.disguiseId = _buf.ReadByte();
        this.armorShowId = _buf.ReadByte();
        this.headTitleId = _buf.ReadByte();
        this.gossipLevel = _buf.ReadVarInt();
        this.suitRank = _buf.ReadVarInt();
        this.reincarnatelv = _buf.ReadVarInt();
        var showIllusionInfo_length = _buf.ReadUShort();
        for (var i = 0; i < showIllusionInfo_length; i++) {
            this.showIllusionInfo[i] = _buf.ReadBean(ShowIllusionInfo);
        }
        this.marryExteriorId = _buf.ReadVarInt();
        this.innateModel = _buf.ReadVarInt();
        this.charmNum = _buf.ReadVarInt();
	},
});
var PlayerBriefInfo = cc.Class.extend({
	ctor:function(){
		this.playerid = null; // 玩家id
        this.playerName = null; // 玩家Name
        this.serverid = 0; // 玩家区id
        this.fightpower = 0; // 玩家战斗力
        this.level = 0; // 玩家等级
        this.job = 0; // 玩家职业
        this.curFashion = []; // 时装Id int
        this.guildName = null; // 帮会名字
        this.playerSkillInfos = []; // 玩家技能 SkillInfo
        this.fightAttributeInfos = []; // 角色战斗属性信息(需要计算的都在里面，比如攻击，移动，防御，maxhp) FightAttributeInfo
        this.basisAttriInfos = []; // 角色基本属性信息（HP和等级） BasisAttriInfo
        this.playerEquipInfos = []; // 玩家装备信息列表 PlayerEquipsInfo
        this.playerUseItems = []; // 玩家本身使用的加属性道具列表(比如人物属性丹药),坐骑和其他的资源线不在这里 PlayerUseItem
        this.spouseName = null; // 配偶名字
        this.marryItemId = 0; // 信物Id
        this.marryTime = 0; // 结婚时间戳
        this.tencentDomain = 0; // 腾讯登陆渠道
        this.tencentVip = 0; // 腾讯登陆渠道对应vip等级
        this.disguiseId = 0; // 当前展示的易容ID
        this.armorShowId = 0; // 当前展示的战甲ID
        this.headTitleId = 0; // 头衔modelId
        this.useTitleModel = 0; // 穿戴的称号modelid
        this.reslineInfo = []; // 资源线信息 ReslineDataInfo
        this.refineSysInfos = []; // 装备精炼信息 RefineSysInfo
        this.gemInfos = []; // 宝石信息 GemInfo
        this.equipSuitInfos = []; // 装备套装信息 EquipPosSuitInfo
        this.armorAttList = []; // 战甲淬炼的属性丹数量列表(索引0表示道具ID，1表示数量，依次类推) int
        this.armorActivateTime = 0; // (战甲)激活的时间(-1表示永久) 秒
        this.disguiseInfoList = []; // 已激活的易容数据 DisguiseInfo
        this.reincarnatelv = 0; // 当前转生等级
        this.godArmDataInfo = []; // 神兵信息 GodArmDataInfo
        this.illusionDataInfos = []; // 整个幻化数据信息 IllusionDataInfo
        this.wingModel = 0; // 穿戴的王者造型modelid
        this.armorEquipInfo = []; // 光羽装备信息 ArmorEquipInfo
        this.marryExteriorId = 0; // 当前展示的结婚造型modelid
        this.innateModel = 0; // 萌化外显model
        this.equipDazzlingInfo = []; // 装备耀晶信息 EquipDazzlingInfo
        this.aureoleId = 0; // 婚姻光环外显ID
        this.marriageId = null; // 婚姻ID
        this.charmNum = 0; // 魅力值
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.serverid);
        _buf.WriteVarLong(this.fightpower);
        _buf.WriteVarInt(this.level);
        _buf.WriteByte(this.job);
        _buf.WriteUShort( this.curFashion.length );
        for (var i = 0; i < this.curFashion.length; i++) {
            _buf.WriteVarInt(this.curFashion[i]);
        }
        _buf.WriteString(this.guildName);
        _buf.WriteUShort( this.playerSkillInfos.length );
        for (var i = 0; i < this.playerSkillInfos.length; i++) {
            _buf.WriteBean(this.playerSkillInfos[i]);
        }
        _buf.WriteUShort( this.fightAttributeInfos.length );
        for (var i = 0; i < this.fightAttributeInfos.length; i++) {
            _buf.WriteBean(this.fightAttributeInfos[i]);
        }
        _buf.WriteUShort( this.basisAttriInfos.length );
        for (var i = 0; i < this.basisAttriInfos.length; i++) {
            _buf.WriteBean(this.basisAttriInfos[i]);
        }
        _buf.WriteUShort( this.playerEquipInfos.length );
        for (var i = 0; i < this.playerEquipInfos.length; i++) {
            _buf.WriteBean(this.playerEquipInfos[i]);
        }
        _buf.WriteUShort( this.playerUseItems.length );
        for (var i = 0; i < this.playerUseItems.length; i++) {
            _buf.WriteBean(this.playerUseItems[i]);
        }
        _buf.WriteString(this.spouseName);
        _buf.WriteVarInt(this.marryItemId);
        _buf.WriteVarInt(this.marryTime);
        _buf.WriteVarInt(this.tencentDomain);
        _buf.WriteVarInt(this.tencentVip);
        _buf.WriteByte(this.disguiseId);
        _buf.WriteByte(this.armorShowId);
        _buf.WriteByte(this.headTitleId);
        _buf.WriteVarInt(this.useTitleModel);
        _buf.WriteUShort( this.reslineInfo.length );
        for (var i = 0; i < this.reslineInfo.length; i++) {
            _buf.WriteBean(this.reslineInfo[i]);
        }
        _buf.WriteUShort( this.refineSysInfos.length );
        for (var i = 0; i < this.refineSysInfos.length; i++) {
            _buf.WriteBean(this.refineSysInfos[i]);
        }
        _buf.WriteUShort( this.gemInfos.length );
        for (var i = 0; i < this.gemInfos.length; i++) {
            _buf.WriteBean(this.gemInfos[i]);
        }
        _buf.WriteUShort( this.equipSuitInfos.length );
        for (var i = 0; i < this.equipSuitInfos.length; i++) {
            _buf.WriteBean(this.equipSuitInfos[i]);
        }
        _buf.WriteUShort( this.armorAttList.length );
        for (var i = 0; i < this.armorAttList.length; i++) {
            _buf.WriteVarInt(this.armorAttList[i]);
        }
        _buf.WriteVarInt(this.armorActivateTime);
        _buf.WriteUShort( this.disguiseInfoList.length );
        for (var i = 0; i < this.disguiseInfoList.length; i++) {
            _buf.WriteBean(this.disguiseInfoList[i]);
        }
        _buf.WriteVarInt(this.reincarnatelv);
        _buf.WriteUShort( this.godArmDataInfo.length );
        for (var i = 0; i < this.godArmDataInfo.length; i++) {
            _buf.WriteBean(this.godArmDataInfo[i]);
        }
        _buf.WriteUShort( this.illusionDataInfos.length );
        for (var i = 0; i < this.illusionDataInfos.length; i++) {
            _buf.WriteBean(this.illusionDataInfos[i]);
        }
        _buf.WriteVarInt(this.wingModel);
        _buf.WriteUShort( this.armorEquipInfo.length );
        for (var i = 0; i < this.armorEquipInfo.length; i++) {
            _buf.WriteBean(this.armorEquipInfo[i]);
        }
        _buf.WriteVarInt(this.marryExteriorId);
        _buf.WriteVarInt(this.innateModel);
        _buf.WriteUShort( this.equipDazzlingInfo.length );
        for (var i = 0; i < this.equipDazzlingInfo.length; i++) {
            _buf.WriteBean(this.equipDazzlingInfo[i]);
        }
        _buf.WriteVarInt(this.aureoleId);
        _buf.WriteLong(this.marriageId);
        _buf.WriteVarInt(this.charmNum);
	},

	reading:function( _buf ){
		this.playerid = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.serverid = _buf.ReadVarInt();
        this.fightpower = _buf.ReadVarLong();
        this.level = _buf.ReadVarInt();
        this.job = _buf.ReadByte();
        var curFashion_length = _buf.ReadUShort();
        for (var i = 0; i < curFashion_length; i++) {
            this.curFashion[i] = _buf.ReadVarInt();
        }
        this.guildName = _buf.ReadString();
        var playerSkillInfos_length = _buf.ReadUShort();
        for (var i = 0; i < playerSkillInfos_length; i++) {
            this.playerSkillInfos[i] = _buf.ReadBean(SkillInfo);
        }
        var fightAttributeInfos_length = _buf.ReadUShort();
        for (var i = 0; i < fightAttributeInfos_length; i++) {
            this.fightAttributeInfos[i] = _buf.ReadBean(FightAttributeInfo);
        }
        var basisAttriInfos_length = _buf.ReadUShort();
        for (var i = 0; i < basisAttriInfos_length; i++) {
            this.basisAttriInfos[i] = _buf.ReadBean(BasisAttriInfo);
        }
        var playerEquipInfos_length = _buf.ReadUShort();
        for (var i = 0; i < playerEquipInfos_length; i++) {
            this.playerEquipInfos[i] = _buf.ReadBean(PlayerEquipsInfo);
        }
        var playerUseItems_length = _buf.ReadUShort();
        for (var i = 0; i < playerUseItems_length; i++) {
            this.playerUseItems[i] = _buf.ReadBean(PlayerUseItem);
        }
        this.spouseName = _buf.ReadString();
        this.marryItemId = _buf.ReadVarInt();
        this.marryTime = _buf.ReadVarInt();
        this.tencentDomain = _buf.ReadVarInt();
        this.tencentVip = _buf.ReadVarInt();
        this.disguiseId = _buf.ReadByte();
        this.armorShowId = _buf.ReadByte();
        this.headTitleId = _buf.ReadByte();
        this.useTitleModel = _buf.ReadVarInt();
        var reslineInfo_length = _buf.ReadUShort();
        for (var i = 0; i < reslineInfo_length; i++) {
            this.reslineInfo[i] = _buf.ReadBean(ReslineDataInfo);
        }
        var refineSysInfos_length = _buf.ReadUShort();
        for (var i = 0; i < refineSysInfos_length; i++) {
            this.refineSysInfos[i] = _buf.ReadBean(RefineSysInfo);
        }
        var gemInfos_length = _buf.ReadUShort();
        for (var i = 0; i < gemInfos_length; i++) {
            this.gemInfos[i] = _buf.ReadBean(GemInfo);
        }
        var equipSuitInfos_length = _buf.ReadUShort();
        for (var i = 0; i < equipSuitInfos_length; i++) {
            this.equipSuitInfos[i] = _buf.ReadBean(EquipPosSuitInfo);
        }
        var armorAttList_length = _buf.ReadUShort();
        for (var i = 0; i < armorAttList_length; i++) {
            this.armorAttList[i] = _buf.ReadVarInt();
        }
        this.armorActivateTime = _buf.ReadVarInt();
        var disguiseInfoList_length = _buf.ReadUShort();
        for (var i = 0; i < disguiseInfoList_length; i++) {
            this.disguiseInfoList[i] = _buf.ReadBean(DisguiseInfo);
        }
        this.reincarnatelv = _buf.ReadVarInt();
        var godArmDataInfo_length = _buf.ReadUShort();
        for (var i = 0; i < godArmDataInfo_length; i++) {
            this.godArmDataInfo[i] = _buf.ReadBean(GodArmDataInfo);
        }
        var illusionDataInfos_length = _buf.ReadUShort();
        for (var i = 0; i < illusionDataInfos_length; i++) {
            this.illusionDataInfos[i] = _buf.ReadBean(IllusionDataInfo);
        }
        this.wingModel = _buf.ReadVarInt();
        var armorEquipInfo_length = _buf.ReadUShort();
        for (var i = 0; i < armorEquipInfo_length; i++) {
            this.armorEquipInfo[i] = _buf.ReadBean(ArmorEquipInfo);
        }
        this.marryExteriorId = _buf.ReadVarInt();
        this.innateModel = _buf.ReadVarInt();
        var equipDazzlingInfo_length = _buf.ReadUShort();
        for (var i = 0; i < equipDazzlingInfo_length; i++) {
            this.equipDazzlingInfo[i] = _buf.ReadBean(EquipDazzlingInfo);
        }
        this.aureoleId = _buf.ReadVarInt();
        this.marriageId = _buf.ReadLong();
        this.charmNum = _buf.ReadVarInt();
	},
});
////////////////////
// 本人玩家信息 //
////////////////////
var ResMyPlayerInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.myPlayerInfo = null; // 本人玩家信息
	},

	getId:function(){
		return 103101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.myPlayerInfo);
	},
	
	reading:function( _buf ){
        this.myPlayerInfo = _buf.ReadBean(MyPlayerInfo);
	},

	action:function(){
		Mgr.player.RecvResMyPlayerInfoMessage(this);
	},

});
////////////////////
// 玩家增加经验 //
////////////////////
var ResPlayerAddExpMessage = cc.Class.extend( {
	ctor:function(){
		this.exp = 0; // 玩家增加经验
        this.reason = 0; // 玩家增加经验原因ID
	},

	getId:function(){
		return 103102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarLong(this.exp);
        _buf.WriteVarInt(this.reason);
	},
	
	reading:function( _buf ){
        this.exp = _buf.ReadVarLong();
        this.reason = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResPlayerAddExpMessage(this);
	},

});
////////////////////
// 个人通知 //
////////////////////
var ResPersonalNoticeMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 属性类型(1.错误 2.提示 3.成功 4.跑马灯)
        this.contentId = 0; // 信息Id
        this.content = null; // 信息内容
        this.values = []; // 数值 string
	},

	getId:function(){
		return 103103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteVarInt(this.contentId);
        _buf.WriteString(this.content);
        _buf.WriteUShort( this.values.length );
        for (var i = 0; i < this.values.length; i++) {
            _buf.WriteString(this.values[i]);
        }
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.contentId = _buf.ReadVarInt();
        this.content = _buf.ReadString();
        var values_length = _buf.ReadUShort();
        for (var i = 0; i < values_length; i++) {
            this.values[i] = _buf.ReadString();
        }
	},

	action:function(){
		Mgr.player.RecvResPersonalNoticeMessage(this);
	},

});
////////////////////
// 广播人物基本属性变化消息(HP,等级。。。) //
////////////////////
var BroadcastPlayerAttriChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 玩家id
        this.basisAttriInfo = null; // 变更的属性
	},

	getId:function(){
		return 103105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteBean(this.basisAttriInfo);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.basisAttriInfo = _buf.ReadBean(BasisAttriInfo);
	},

	action:function(){
		Mgr.player.RecvBroadcastPlayerAttriChangeMessage(this);
	},

});
////////////////////
// 个人属性值变化(攻击防御等) //
////////////////////
var ResPlayerAttributesChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.attributeChangeReason = 0; // 变化的属性原因
        this.modelId = 0; // 模型Id
        this.attributeChangeList = []; // 变化的属性列表 FightAttributeInfo
	},

	getId:function(){
		return 103106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.attributeChangeReason);
        _buf.WriteVarInt(this.modelId);
        _buf.WriteUShort( this.attributeChangeList.length );
        for (var i = 0; i < this.attributeChangeList.length; i++) {
            _buf.WriteBean(this.attributeChangeList[i]);
        }
	},
	
	reading:function( _buf ){
        this.attributeChangeReason = _buf.ReadVarInt();
        this.modelId = _buf.ReadVarInt();
        var attributeChangeList_length = _buf.ReadUShort();
        for (var i = 0; i < attributeChangeList_length; i++) {
            this.attributeChangeList[i] = _buf.ReadBean(FightAttributeInfo);
        }
	},

	action:function(){
		Mgr.player.RecvResPlayerAttributesChangeMessage(this);
	},

});
////////////////////
// 玩家简要信息 //
////////////////////
var ResPlayerBriefMessage = cc.Class.extend( {
	ctor:function(){
		this.playerBriefs = []; // 玩家简要信息 PlayerBriefInfo
        this.controlType = 0; // 控件类型
	},

	getId:function(){
		return 103107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.playerBriefs.length );
        for (var i = 0; i < this.playerBriefs.length; i++) {
            _buf.WriteBean(this.playerBriefs[i]);
        }
        _buf.WriteByte(this.controlType);
	},
	
	reading:function( _buf ){
        var playerBriefs_length = _buf.ReadUShort();
        for (var i = 0; i < playerBriefs_length; i++) {
            this.playerBriefs[i] = _buf.ReadBean(PlayerBriefInfo);
        }
        this.controlType = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvResPlayerBriefMessage(this);
	},

});
////////////////////
// 同步服务端时间给客户端 //
////////////////////
var ResSyncServerTimeMessage = cc.Class.extend( {
	ctor:function(){
		this.timestamp = 0; // unix时间戳（单位:秒）
        this.isSameDay = 0; // 是否跨天(0不是1为跨天)
	},

	getId:function(){
		return 103108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.timestamp);
        _buf.WriteByte(this.isSameDay);
	},
	
	reading:function( _buf ){
        this.timestamp = _buf.ReadVarInt();
        this.isSameDay = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvResSyncServerTimeMessage(this);
	},

});
////////////////////
// 玩家战斗状态改变 //
////////////////////
var ResPlayerStateChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // 玩家战斗状态 0-进入 1-退出
	},

	getId:function(){
		return 103109;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.state);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvResPlayerStateChangeMessage(this);
	},

});
////////////////////
// 更改pk状态 //
////////////////////
var ResChangePKStateMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.pkState = 0; // pk状态
        this.auto = 0; // 是否自动切换
	},

	getId:function(){
		return 103110;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteVarInt(this.pkState);
        _buf.WriteVarInt(this.auto);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.pkState = _buf.ReadVarInt();
        this.auto = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResChangePKStateMessage(this);
	},

});
////////////////////
// 玩家改名，完成后通知客户端 //
////////////////////
var ResChangePlayerNameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 角色ID
        this.newname = null; // 新名字
        this.result = 0; // 返回结果，0失败，1成功
	},

	getId:function(){
		return 103111;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.newname);
        _buf.WriteByte(this.result);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.newname = _buf.ReadString();
        this.result = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvResChangePlayerNameToClientMessage(this);
	},

});
////////////////////
// 返回挂机状态 //
////////////////////
var ResAutoStartStateMessage = cc.Class.extend( {
	ctor:function(){
		this.result = 0; // 挂机状态， 1-挂机 0-未挂机
	},

	getId:function(){
		return 103112;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.result);
	},
	
	reading:function( _buf ){
        this.result = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvResAutoStartStateMessage(this);
	},

});
////////////////////
// 通用弹出引导 //
////////////////////
var RespopuGuideMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 引导id
	},

	getId:function(){
		return 103113;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvRespopuGuideMessage(this);
	},

});
////////////////////
// 玩家死亡消息 //
////////////////////
var ResPlayerDieMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 死亡的角色Id
        this.autoRevive = 0; // 是否自动复活(1自动 0不自动)
        this.autoTime = 0; // 自动复活时间
        this.monstermodelid = 0; // 怪物模型ID
        this.attackerid = null; // 攻击者玩家ID
        this.attackername = null; // 攻击者玩家名字
        this.position = null; // 死亡位置
        this.time = 0; // 死亡时间
        this.panel = 0; // 是否弹出复活面板(1弹出 0不弹出)
	},

	getId:function(){
		return 103114;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteByte(this.autoRevive);
        _buf.WriteByte(this.autoTime);
        _buf.WriteVarInt(this.monstermodelid);
        _buf.WriteLong(this.attackerid);
        _buf.WriteString(this.attackername);
        _buf.WriteBean(this.position);
        _buf.WriteVarInt(this.time);
        _buf.WriteByte(this.panel);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.autoRevive = _buf.ReadByte();
        this.autoTime = _buf.ReadByte();
        this.monstermodelid = _buf.ReadVarInt();
        this.attackerid = _buf.ReadLong();
        this.attackername = _buf.ReadString();
        this.position = _buf.ReadBean(Position);
        this.time = _buf.ReadVarInt();
        this.panel = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvResPlayerDieMessage(this);
	},

});
////////////////////
// 复活成功 //
////////////////////
var ResReviveSuccessMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
	},

	getId:function(){
		return 103115;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
	},

	action:function(){
		Mgr.player.RecvResReviveSuccessMessage(this);
	},

});
////////////////////
// 玩家防沉迷状态改变 //
////////////////////
var ResPlayerNonageStateMessage = cc.Class.extend( {
	ctor:function(){
		this.nonage = 0; // 玩家防沉迷状态 0-非防沉迷 1-正常 2-疲劳 3-不健康
	},

	getId:function(){
		return 103116;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.nonage);
	},
	
	reading:function( _buf ){
        this.nonage = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvResPlayerNonageStateMessage(this);
	},

});
////////////////////
// 防沉迷提示信息 //
////////////////////
var NonagePromptMessage = cc.Class.extend( {
	ctor:function(){
		this.content = 0; // 提示玩家进入沉迷状态
	},

	getId:function(){
		return 103117;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.content);
	},
	
	reading:function( _buf ){
        this.content = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvNonagePromptMessage(this);
	},

});
////////////////////
// 玩家防沉迷在线时间 //
////////////////////
var ResPlayerNonageTimeMessage = cc.Class.extend( {
	ctor:function(){
		this.time = 0; // 玩家防沉迷在线时间
	},

	getId:function(){
		return 103118;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.time = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResPlayerNonageTimeMessage(this);
	},

});
////////////////////
// 玩家防沉迷注册返回消息 //
////////////////////
var ResPlayerNonageRegisterMessage = cc.Class.extend( {
	ctor:function(){
		this.result = 0; // 玩家防沉迷注册结果返回， 1-成功 2-未成年 3-身份证错误
	},

	getId:function(){
		return 103119;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.result);
	},
	
	reading:function( _buf ){
        this.result = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvResPlayerNonageRegisterMessage(this);
	},

});
////////////////////
// 电话验证状态 //
////////////////////
var ResPhoneVerificationStatusMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型 1电话领奖 2小游戏领奖
        this.status = 0; // 0未验证 1已验证 2已领奖
	},

	getId:function(){
		return 103121;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteVarInt(this.status);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.status = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResPhoneVerificationStatusMessage(this);
	},

});
////////////////////
// 展示倒计时状态 //
////////////////////
var ResCountdownToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 角色ID
        this.time = 0; // 倒计时时间(秒)
        this.type = 0; // 倒计时类型1,是头上冒字
	},

	getId:function(){
		return 103122;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteVarInt(this.time);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.time = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResCountdownToClientMessage(this);
	},

});
////////////////////
// 请求我的充值信息 //
////////////////////
var ResRechargeInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.day = 0; // 今日充值
        this.month = 0; // 当月充值
        this.all = 0; // 总充值
        this.allMax = 0; // 总充值最大
	},

	getId:function(){
		return 103123;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.day);
        _buf.WriteVarInt(this.month);
        _buf.WriteVarInt(this.all);
        _buf.WriteVarInt(this.allMax);
	},
	
	reading:function( _buf ){
        this.day = _buf.ReadVarInt();
        this.month = _buf.ReadVarInt();
        this.all = _buf.ReadVarInt();
        this.allMax = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResRechargeInfoMessage(this);
	},

});
////////////////////
// 发送玩家在线时间 //
////////////////////
var ResTotalOnlineTimeMessage = cc.Class.extend( {
	ctor:function(){
		this.time = 0; // 总在线时间(秒)
        this.daytime = 0; // 当天在线时间(秒)
        this.openTime = 0; // 开区时间（时间戳，秒）
        this.joinTime = 0; // 合区时间（时间戳，秒）
        this.joinNum = 0; // 合区次数
	},

	getId:function(){
		return 103124;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.time);
        _buf.WriteVarInt(this.daytime);
        _buf.WriteVarInt(this.openTime);
        _buf.WriteVarInt(this.joinTime);
        _buf.WriteByte(this.joinNum);
	},
	
	reading:function( _buf ){
        this.time = _buf.ReadVarInt();
        this.daytime = _buf.ReadVarInt();
        this.openTime = _buf.ReadVarInt();
        this.joinTime = _buf.ReadVarInt();
        this.joinNum = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvResTotalOnlineTimeMessage(this);
	},

});
////////////////////
// 发送玩家杀人数量,决定名字颜色 //
////////////////////
var ReskillnumToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.killnum = 0; // 杀人数量,0是白色名字,2个以下是黄色名字,3个以上是红色
        this.isGreyname = 0; // 是否灰名,0不是灰,,大于0灰色时间(灰色优先级高于白色和黄色)
	},

	getId:function(){
		return 103125;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteByte(this.killnum);
        _buf.WriteByte(this.isGreyname);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.killnum = _buf.ReadByte();
        this.isGreyname = _buf.ReadByte();
	},

	action:function(){
		Mgr.player.RecvReskillnumToClientMessage(this);
	},

});
////////////////////
// 通知前端服务器人数 //
////////////////////
var ResServerPlayerNumToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.num = 0; // 服务器人数
	},

	getId:function(){
		return 103126;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.num = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResServerPlayerNumToClinetMessage(this);
	},

});
////////////////////
// 广播人物战斗属性变化消息(攻击，防御。。。) //
////////////////////
var BroadcastFightAttriChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 玩家id
        this.attributeChange = null; // 变更的属性
	},

	getId:function(){
		return 103128;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteBean(this.attributeChange);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.attributeChange = _buf.ReadBean(FightAttributeInfo);
	},

	action:function(){
		Mgr.player.RecvBroadcastFightAttriChangeMessage(this);
	},

});
////////////////////
// 人物基本货币改变信息 //
////////////////////
var ResPlayerCurrencyInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.currencyInfo = null; // 货币信息
	},

	getId:function(){
		return 103129;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.currencyInfo);
	},
	
	reading:function( _buf ){
        this.currencyInfo = _buf.ReadBean(CurrencyInfo);
	},

	action:function(){
		Mgr.player.RecvResPlayerCurrencyInfoMessage(this);
	},

});
////////////////////
// 离线挂机剩余时间 //
////////////////////
var ResPlayerOfflinePluginTimeMessage = cc.Class.extend( {
	ctor:function(){
		this.remainTime = 0; // 剩余挂机时间秒
	},

	getId:function(){
		return 103130;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.remainTime);
	},
	
	reading:function( _buf ){
        this.remainTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResPlayerOfflinePluginTimeMessage(this);
	},

});
////////////////////
// 改名冷却剩余时间 //
////////////////////
var ResPlayerChangeNameTimeMessage = cc.Class.extend( {
	ctor:function(){
		this.remainTime = 0; // 改名冷却剩余
	},

	getId:function(){
		return 103131;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.remainTime);
	},
	
	reading:function( _buf ){
        this.remainTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResPlayerChangeNameTimeMessage(this);
	},

});
////////////////////
// 挂机结算 //
////////////////////
var ResPlayerPluginRecordMessage = cc.Class.extend( {
	ctor:function(){
		this.pluginTime = 0; // 挂机时间
        this.remainTime = 0; // 剩余时间
        this.exp = 0; // 挂机获得经验
        this.items = []; // 挂机获得道具 SimpleItemInfo
	},

	getId:function(){
		return 103132;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.pluginTime);
        _buf.WriteVarInt(this.remainTime);
        _buf.WriteVarLong(this.exp);
        _buf.WriteUShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
	},
	
	reading:function( _buf ){
        this.pluginTime = _buf.ReadVarInt();
        this.remainTime = _buf.ReadVarInt();
        this.exp = _buf.ReadVarLong();
        var items_length = _buf.ReadUShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(SimpleItemInfo);
        }
	},

	action:function(){
		Mgr.player.RecvResPlayerPluginRecordMessage(this);
	},

});
////////////////////
// 发送今日元宝消耗给前端 //
////////////////////
var ResTodayGoldCostToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.costNums = 0; // 元宝数量
	},

	getId:function(){
		return 103133;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.costNums);
	},
	
	reading:function( _buf ){
        this.costNums = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResTodayGoldCostToClinetMessage(this);
	},

});
////////////////////
// 发送今日元宝消耗给前端 //
////////////////////
var ResPlayerFactionChangeToRoundMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 玩家id
        this.faction = 0; // 阵营
	},

	getId:function(){
		return 103134;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteVarInt(this.faction);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.faction = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResPlayerFactionChangeToRoundMessage(this);
	},

});
////////////////////
// 发送给前端：元宝不足 //
////////////////////
var ResNotEnoughGoldChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型
        this.gold = 0; // 缺少元宝数
	},

	getId:function(){
		return 103135;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteVarInt(this.gold);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.gold = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.player.RecvResNotEnoughGoldChangeMessage(this);
	},

});
////////////////////
// 请求服务器充值订单号 //
////////////////////
var ResAppRecharegeOrderMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // 状态码
        this.orderId = null; // 订单号
        this.moneys = 0; // 充值金额 分
        this.ext = null; // 扩展参数
        this.productId = null; // 商品id
        this.productName = null; // 商品名
        this.productDesc = null; // 商品描述
	},

	getId:function(){
		return 103136;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.state);
        _buf.WriteString(this.orderId);
        _buf.WriteVarInt(this.moneys);
        _buf.WriteString(this.ext);
        _buf.WriteString(this.productId);
        _buf.WriteString(this.productName);
        _buf.WriteString(this.productDesc);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadVarInt();
        this.orderId = _buf.ReadString();
        this.moneys = _buf.ReadVarInt();
        this.ext = _buf.ReadString();
        this.productId = _buf.ReadString();
        this.productName = _buf.ReadString();
        this.productDesc = _buf.ReadString();
	},

	action:function(){
		Mgr.player.RecvResAppRecharegeOrderMessage(this);
	},

});
////////////////////
// 回城复活 //
////////////////////
var ReqReviveMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 103201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 原地复活 //
////////////////////
var ReqLocalReviveMessage = cc.Class.extend( {
	ctor:function(){
		this.itemmodelid = 0; // 使用复活道具modelid
        this.type = 0; // 0自动使用玫瑰，1手动使用玫瑰复活
	},

	getId:function(){
		return 103202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.itemmodelid);
        _buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.itemmodelid = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 请求更改pk状态 //
////////////////////
var ReqChangePKStateMessage = cc.Class.extend( {
	ctor:function(){
		this.pkState = 0; // pk状态
        this.auto = 0; // 是否自动切换
	},

	getId:function(){
		return 103203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.pkState);
        _buf.WriteVarInt(this.auto);
	},
	
	reading:function( _buf ){
        this.pkState = _buf.ReadVarInt();
        this.auto = _buf.ReadVarInt();
	},

});
////////////////////
// 请求挂机开始 //
////////////////////
var ReqAutoStartMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 103204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求挂机结束 //
////////////////////
var ReqAutoEndMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 103205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 玩家修改名字 //
////////////////////
var ReqPlayerChangeNameMessage = cc.Class.extend( {
	ctor:function(){
		this.name = null; // 玩家名字
        this.sex = 0; // 玩家性别(0.女 1.男)
	},

	getId:function(){
		return 103206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.name);
        _buf.WriteByte(this.sex);
	},
	
	reading:function( _buf ){
        this.name = _buf.ReadString();
        this.sex = _buf.ReadByte();
	},

});
////////////////////
// 玩家简要信息 //
////////////////////
var ReqPlayerBriefMessage = cc.Class.extend( {
	ctor:function(){
		this.personIds = []; // 角色Id long
        this.controlType = 0; // 控件类型
	},

	getId:function(){
		return 103207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.personIds.length );
        for (var i = 0; i < this.personIds.length; i++) {
            _buf.WriteLong(this.personIds[i]);
        }
        _buf.WriteByte(this.controlType);
	},
	
	reading:function( _buf ){
        var personIds_length = _buf.ReadUShort();
        for (var i = 0; i < personIds_length; i++) {
            this.personIds[i] = _buf.ReadLong();
        }
        this.controlType = _buf.ReadByte();
	},

});
////////////////////
// 玩家防沉迷注册身份证 //
////////////////////
var ReqPlayerNonageRegisterMessage = cc.Class.extend( {
	ctor:function(){
		this.name = null; // 名字
        this.idCard = null; // 证件号码
	},

	getId:function(){
		return 103208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.name);
        _buf.WriteString(this.idCard);
	},
	
	reading:function( _buf ){
        this.name = _buf.ReadString();
        this.idCard = _buf.ReadString();
	},

});
////////////////////
// 请求防沉迷时间 //
////////////////////
var ReqNonageTimeMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 103209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 查看他人信息 //
////////////////////
var ReqOthersPlayerInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
	},

	getId:function(){
		return 103210;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
	},

});
////////////////////
// 改变游戏窗口大小 //
////////////////////
var ReqChangeWinMessage = cc.Class.extend( {
	ctor:function(){
		this.win_high = 0; // 窗口高像素
        this.win_width = 0; // 窗口宽像素
	},

	getId:function(){
		return 103211;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.win_high);
        _buf.WriteVarInt(this.win_width);
	},
	
	reading:function( _buf ){
        this.win_high = _buf.ReadVarInt();
        this.win_width = _buf.ReadVarInt();
	},

});
////////////////////
// 请求电话验证状态领奖 //
////////////////////
var ReqPhoneVerificationRewardMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型 1电话领奖 2小游戏领奖
	},

	getId:function(){
		return 103212;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 请求我的充值信息 //
////////////////////
var ReqRechargeInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 103213;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求更换我的时装造型 //
////////////////////
var ReqChangePlayerFashionMessage = cc.Class.extend( {
	ctor:function(){
		this.fashionId = 0; // 时装Id
	},

	getId:function(){
		return 103214;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.fashionId);
	},
	
	reading:function( _buf ){
        this.fashionId = _buf.ReadByte();
	},

});
////////////////////
// 获取跨服玩家简要信息 //
////////////////////
var ReqPublicPlayerBriefMessage = cc.Class.extend( {
	ctor:function(){
		this.personIds = []; // 角色Id long
        this.controlType = 0; // 控件类型
        this.targetServerkey = 0; // 要查看的玩家的serverkey,没有就写0
	},

	getId:function(){
		return 103215;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.personIds.length );
        for (var i = 0; i < this.personIds.length; i++) {
            _buf.WriteLong(this.personIds[i]);
        }
        _buf.WriteByte(this.controlType);
        _buf.WriteVarInt(this.targetServerkey);
	},
	
	reading:function( _buf ){
        var personIds_length = _buf.ReadUShort();
        for (var i = 0; i < personIds_length; i++) {
            this.personIds[i] = _buf.ReadLong();
        }
        this.controlType = _buf.ReadByte();
        this.targetServerkey = _buf.ReadVarInt();
	},

});
////////////////////
// 请求改名冷却剩余时间 //
////////////////////
var ReqPlayerChangeNameTimeMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 103216;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求改变玩家防沉迷状态改变 //
////////////////////
var ReqChangePlayerNonageStateMessage = cc.Class.extend( {
	ctor:function(){
		this.nonage = 0; // 玩家防沉迷状态 0-非防沉迷 1-正常 2-疲劳 0.5收益  3-不健康 0收益
	},

	getId:function(){
		return 103217;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.nonage);
	},
	
	reading:function( _buf ){
        this.nonage = _buf.ReadByte();
	},

});
////////////////////
// 请求服务器充值订单号 //
////////////////////
var ReqAppRecharegeOrderMessage = cc.Class.extend( {
	ctor:function(){
		this.gold = 0; // 商品id 对应表里的
	},

	getId:function(){
		return 103218;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gold);
	},
	
	reading:function( _buf ){
        this.gold = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(103101, ResMyPlayerInfoMessage);
MESSAGE_POOL.Add(103102, ResPlayerAddExpMessage);
MESSAGE_POOL.Add(103103, ResPersonalNoticeMessage);
MESSAGE_POOL.Add(103105, BroadcastPlayerAttriChangeMessage);
MESSAGE_POOL.Add(103106, ResPlayerAttributesChangeMessage);
MESSAGE_POOL.Add(103107, ResPlayerBriefMessage);
MESSAGE_POOL.Add(103108, ResSyncServerTimeMessage);
MESSAGE_POOL.Add(103109, ResPlayerStateChangeMessage);
MESSAGE_POOL.Add(103110, ResChangePKStateMessage);
MESSAGE_POOL.Add(103111, ResChangePlayerNameToClientMessage);
MESSAGE_POOL.Add(103112, ResAutoStartStateMessage);
MESSAGE_POOL.Add(103113, RespopuGuideMessage);
MESSAGE_POOL.Add(103114, ResPlayerDieMessage);
MESSAGE_POOL.Add(103115, ResReviveSuccessMessage);
MESSAGE_POOL.Add(103116, ResPlayerNonageStateMessage);
MESSAGE_POOL.Add(103117, NonagePromptMessage);
MESSAGE_POOL.Add(103118, ResPlayerNonageTimeMessage);
MESSAGE_POOL.Add(103119, ResPlayerNonageRegisterMessage);
MESSAGE_POOL.Add(103121, ResPhoneVerificationStatusMessage);
MESSAGE_POOL.Add(103122, ResCountdownToClientMessage);
MESSAGE_POOL.Add(103123, ResRechargeInfoMessage);
MESSAGE_POOL.Add(103124, ResTotalOnlineTimeMessage);
MESSAGE_POOL.Add(103125, ReskillnumToClientMessage);
MESSAGE_POOL.Add(103126, ResServerPlayerNumToClinetMessage);
MESSAGE_POOL.Add(103128, BroadcastFightAttriChangeMessage);
MESSAGE_POOL.Add(103129, ResPlayerCurrencyInfoMessage);
MESSAGE_POOL.Add(103130, ResPlayerOfflinePluginTimeMessage);
MESSAGE_POOL.Add(103131, ResPlayerChangeNameTimeMessage);
MESSAGE_POOL.Add(103132, ResPlayerPluginRecordMessage);
MESSAGE_POOL.Add(103133, ResTodayGoldCostToClinetMessage);
MESSAGE_POOL.Add(103134, ResPlayerFactionChangeToRoundMessage);
MESSAGE_POOL.Add(103135, ResNotEnoughGoldChangeMessage);
MESSAGE_POOL.Add(103136, ResAppRecharegeOrderMessage);

