﻿var PlayerModMgr = PlayerModMgr || cc.Class.extend({

	// 免费原地复活所限人物等级设定
	FREE_RELIFE_LEVEL:45,
	RELIFE_ITEM_ID:null,
	RELIFE_MONEY:null,
	//主玩家信息
	mainPlayer:null,

	//一些主界面放在这里
	roleHeadPanel:null,
	shortPanel:null,
	
	_expInMinute:null,
	_expTimeNum:0,
	_exitRemainTime:0,//离线挂机剩余时间
	isCanChangeName:true,
	firstExpTime:0,

    rechargeInfo:null,

	ctor:function() {
//		this._super();
		this.mainPlayer = {};
		this.mainPlayer.attributeData = new AttributeData();		//攻击 防御等

        /// 兼容
        //this.mainPlayer.equips = [];
        cc.defineGetterSetter(this.mainPlayer,"equips",function(){
            return Mgr.equip.GetEquipsByType(EnumItemType.Equip).concat();
        },function(){});
	},

	RecvResMyPlayerInfoMessage:function(msg) {
		zz.Log( "!!!!!!!收到主玩家消息!!");
		var myinfo = msg.myPlayerInfo;
		var mainPlayer = this.mainPlayer;
		mainPlayer.sid = myinfo.personId;
		mainPlayer.sceneobjgid = mainPlayer.sid.toGID();
		mainPlayer.name = myinfo.name;
		mainPlayer.job = myinfo.job;
		mainPlayer.guildId = myinfo.guildId;
		mainPlayer.serverKey = myinfo.serverKey;;
		mainPlayer.wCurMapID = myinfo.mapModelId;
//		if( !Mgr.sceneMgr.isChangeMap )	//切地图中收到这个消息应该是跨服返回的时候 在切完的时候更新坐标就行了
//			mainPlayer.ptTile = MapUtil.pixel2GridPt( myinfo.x, myinfo.y );
		mainPlayer.x = myinfo.x;
		mainPlayer.y = myinfo.y;
		mainPlayer.godEquipSuitId = myinfo.godEquipSuitId;
		mainPlayer.playerResLineInfo = myinfo.playerResLineInfo;
		mainPlayer.curFashion=myinfo.curFashion;
//		mainPlayer.updateFacade();
		mainPlayer.isGM = myinfo.gmLevel > 0;
		GameConfig.current.IS_GM = myinfo.gmLevel > 0;
		mainPlayer.VIP = myinfo.viplevel;
		mainPlayer.killnum = myinfo.killnum;
		mainPlayer.isGreyname = myinfo.isGreyname;
		mainPlayer.objinfotype = SceneObjectType.MAINPLAYER;
		mainPlayer.disguiseId = myinfo.disguiseId;
		mainPlayer.armorShowId = myinfo.armorShowId;
		mainPlayer.spouseName = myinfo.spouseName;
		mainPlayer.marryExteriorId = myinfo.marryExteriorId;
		// 解析更新服务器发送过来的属性list
		for ( var i = 0; i < myinfo.attributeList.length; i++ )
		{
			var temp = myinfo.attributeList[i];
			mainPlayer.attributeData.UpdateAttribute( temp.type, temp.value, AttributeData.Fight );
		}
		for ( var i = 0; i < myinfo.basisAttriInfos.length; i++ )
		{
			var temp = myinfo.basisAttriInfos[i];
			mainPlayer.attributeData.UpdateAttribute( temp.type, temp.value, AttributeData.Base );
		}
		for ( var i = 0; i < myinfo.currencyInfos.length; i++ )
		{
			var temp = myinfo.currencyInfos[i];
			mainPlayer.attributeData.UpdateAttribute( temp.type, temp.value, AttributeData.Money );
		}
		mainPlayer.curExp = myinfo.exp;
		mainPlayer.nDirection = myinfo.dir;
		mainPlayer.fightpower = myinfo.fightpower;
//		var areaObj = PlayerUtil.getAreaInfo(myinfo.name);
//		if (areaObj != null)
//		{
//			mainPlayer.areaStr = areaObj.str;
//			mainPlayer.areaId = areaObj.num;
//		}
		mainPlayer.attrItem = myinfo.playerUseItems;
		mainPlayer.titleId =  myinfo.useTitleModel;
		mainPlayer.headTitleId =  myinfo.headTitleId;
		mainPlayer.gossipLevel = myinfo.gossipLevel;

        mainPlayer.showIllusionInfo = myinfo.showIllusionInfo;
		
		Mgr.shop.SendShopMessage();
		Mgr.friend.SendReqFriendListInfoMessage();
		Mgr.title.SendReqHeadTitleInfoMessage();
		if ( !Mgr.player.mainPlayer.guildId.IsZero() ) {
			Mgr.guild.SendReqGuildGetMemberListMessage();
			Mgr.guild.SendReqGuildSkillInfoMessage();
			Mgr.guild.SendReqApplyListMessage();
		}
		Mgr.sceneObj.CreateObject( mainPlayer );

		if( Mgr.login.j_createRole )
			ChannelUtil.OnGame_Login(true);
		Mgr.login.j_createRole = false;
		ChannelUtil.OnGame_Login();

		// 新功能开放初始化
		BtnGroupUtil.CheckInit();

		Mgr.backpack.RecItemInfos( msg.myPlayerInfo.items , msg.myPlayerInfo.cellnum );
		this.UpdatePkMode( myinfo.pkState );
		//刷新技能
		this.UpdateMainPlayerPanel();
		Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName ).ShowOrHideTeamChatButton();
		Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName ).ShowOrHideGuildChatButton();
		Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).ShowOrHideRideButton();

		//初始化在线  离线时间
        Mgr.sign.SendReqOpenOnlineRewardsToGameMessage();
        Mgr.offlineres.SendReqOpenOfflineAwardPanelMessage();

        Mgr.weal.SendReqGetLandInfoToGameMessage();
        Mgr.illusion.SendReqIllusionDataInfoToGameMessage(HuanhuaType.TYPE_PET);

        Mgr.equip.InitEquip(myinfo.playerEquipInfos);

        Mgr.bank.SendReqBankInfoToGameMessage(1);
        Mgr.bank.SendReqBankInfoToGameMessage(2);
        Mgr.monster.SendReqQueryBossListMessage(0);
	},
	UpdateMainPlayerPanel:function (){
		this.roleHeadPanel.UpdatePanel();
		this.shortPanel.UpdateBaseInfo();
	},
	UpdateFightPower:function(){
		this.roleHeadPanel.UpdateFightPower();
	},
	ShowShortChatState:function(){
		this.shortPanel.ShowChatState();
	},
	ShowShortBtnState:function(){
		this.shortPanel.ShowBtnState();
	},
	RecvResPlayerAddExpMessage:function(msg) {
		if( !this.mainPlayer )
			return;

		if( msg.exp == -1 ){
			return;
		}
		var addExp = msg.exp - this.mainPlayer.curExp;
		this.mainPlayer.curExp = msg.exp;

		if( this.shortPanel )
			this.shortPanel.UpdateExp();
        if(msg.reason==125 && Mgr.player.isAutoFight && addExp > 0){
            this._expInMinute += addExp;
		}
	},

    RecvResPersonalNoticeMessage:function(msg) {
        //这里以前是页游一些跨服的美术字提示
        if(msg.contentId > 0) return;

        var info = TextUtil.FormatStr(msg.content, msg.values, true);

        // TODO 没找个这个颜色的替换规则，先随便写一个
         var index = info.indexOf("<font color=\"#");
         if(index == 0
            && msg.type != EnumSystemInfoType.GUILD_ANSWER
            ){
             info = info.replace(/<font color=\"#(.{6})/,"<font color=\"#13db97")
         }
        // TODO END

        switch(msg.type){
            case EnumSystemInfoType.ERROR:
            case EnumSystemInfoType.SUCCESS:
            case EnumSystemInfoType.MOUSEPOS:
                //个人提示
                Mgr.tips.ShowNotice(info);
                break;
            case EnumSystemInfoType.NORMAL:
                Mgr.tips.ShowNotice(info);
                // Mgr.friend.SendReqApplyListInfoMessage();

                Mgr.chat.OnRecvClientMesage(EnumChatChannelType.SYSTEM,info);
                break;
            case EnumSystemInfoType.SROLL:
                Mgr.tips.ShowNotice(info, TipsEnum.TYPE_MARQUEE);
                break;
            case EnumSystemInfoType.GUILD_ANSWER:
                //Mgr.chat.OnRecvClientMesage(EnumChatChannelType.FACTION,info);
                Mgr.chat.OnRecvClientMesage(EnumSystemInfoType.GUILD_ANSWER,info);
                break;
            case EnumSystemInfoType.CHAT_WORLD:
                //跨服组队公告
                if(msg.values[0] == this.mainPlayer.name) {
                    Mgr.tips.ShowNotice("已发送寻求战友公告，请耐心等待");
                    Mgr.chat.OnRecvClientMesage(EnumChatChannelType.SYSTEM,info);
                }else{
                    Mgr.chat.OnRecvClientMesage(EnumChatChannelType.SYSTEM,info);
                }
                break;
            case EnumSystemInfoType.CHAT_TEAM:
            case EnumSystemInfoType.CHAT_BULL:
            case EnumSystemInfoType.CHAT_ROLLINFO:
                 Mgr.chat.OnRecvClientMesage(EnumChatChannelType.SYSTEM,info);
                 break;
            case EnumSystemInfoType.CHAT_ROLE:
                if(Mgr.chat.isShowRole)
                    Mgr.chat.OnRecvClientMesage(EnumChatChannelType.SYSTEM,info);
                break;
			case EnumSystemInfoType.MOUSEPOS_TURE:
                Mgr.tips.ShowNotice(info);
            default:
                break;
        }
    },
	//attack defend movespped
	RecvBroadcastFightAttriChangeMessage:function(msg) {
		var obj = Mgr.sceneObj.FindObject(msg.playerid.toGID());
		if( obj )
		{
			switch( msg.attributeChange.type )
			{
				case EnumAttribute.MAX_BASEHP:
					obj.UpdateHp(obj.nCurHp, msg.attributeChange.value);
					break;
				case EnumAttribute.MOVE_SPEED:
					obj.SetMoveSpeed(msg.attributeChange.value);
					break;
			}
			if( obj instanceof SceneMainPlayer )
			{
				switch( msg.attributeChange.type )
				{
					case EnumAttribute.MAX_BASEHP:
						if( this.roleHeadPanel )
							this.roleHeadPanel.UpdateHpBar();
						// Mgr.shortcutMgr.updateHpBar();
						// Mgr.attributeMgr.updatePlayerInfoPanel();
						// checkShowLifeDangerous();
						break;
					case EnumAttribute.MOVE_SPEED:	//更新serverCheck移动速度  不然走不了路
						Mgr.map.preActionSpeed = Math.max( Mgr.map.preActionSpeed, msg.attributeChange.value );
						break;
				}
				this.UpdateEquipPanelExtAttributeData();
			}
		}
	},

	//attack defend movespped
	RecvResPlayerAttributesChangeMessage:function(msg) {
		var attribAddMap = new HashMap();
		for (var i = 0; i < msg.attributeChangeList.length; i++)
		{
			var compareVal  = Mgr.mainPlayer.attributeData.UpdateAttribute( msg.attributeChangeList[i].type, msg.attributeChangeList[i].value, AttributeData.Fight );

			if ( compareVal < 0 )
			{
				attribAddMap.Put( msg.attributeChangeList[i].type, Math.abs( compareVal ) );
			}
		}

		Mgr.mainPlayer.SetMoveSpeed(Mgr.mainPlayer.attributeData.moveSpeed);
		Mgr.mainPlayer.UpdateHp(Mgr.mainPlayer.attributeData.curHp, Mgr.mainPlayer.attributeData.maxBaseHp);

		// if ( attribAddMap.size() > 0 )
		// {
		// 	var addKeys = attribAddMap.Keys();
		// 	var j;
		// 	if (msg.attributeChangeReason == 52 || msg.attributeChangeReason == 2 || msg.attributeChangeReason == 8 )// 52是装备
		// 	{
		// 		for ( j = 0; j < addKeys.length; j++)
		// 		{
		// 			addv = attribAddMap.get(addKeys[j]);
		// 			FrameDispatcher.setTimeout(FloatingText.showUp,j*500, Mgr.attributeMgr.getAttrNameStr(addKeys[j]) + ' +' + Mgr.attributeMgr.getAttrValueStr(addKeys[j],addv),new Point(),ColorUtil.N_GREEN_UINT, 14, true, FloatingText.TYPE_UPLEFT_HIDE);
		// 		}
		// 	}
		// }

		// if ( Mgr.uiMgr.isPanelShowByType( PlayerPanelExt) )
		// 	Mgr.attributeMgr.updatePlayerInfoPanel();//刷新属性界面
		this.UpdateEquipPanelExtAttributeData();
		if( this.roleHeadPanel )
			this.roleHeadPanel.UpdateHpBar();
		// checkShowLifeDangerous();
		// Mgr.shortcutMgr.updateHpBar();
		//this.UpdateMainPlayerPanel();
	},
	//hp, level
	RecvBroadcastPlayerAttriChangeMessage:function(msg){
		var obj = Mgr.sceneObj.FindObject(msg.playerid.toGID());
		if( obj )
		{
			switch( msg.basisAttriInfo.type )
			{
				case EnumBaseAttribute.LEVEL:
					if ( obj.nCurLevel < msg.basisAttriInfo.value ) {
						EffectUtil.LevelUpEffect(obj);
					}
					obj.UpdateLevel(msg.basisAttriInfo.value);
					break;
				case EnumBaseAttribute.HP:
					obj.UpdateHp(msg.basisAttriInfo.value);
					break;
				default:break;
			}
			if( obj instanceof SceneMainPlayer )
			{
				this.mainPlayer.attributeData.UpdateAttribute(msg.basisAttriInfo.type, msg.basisAttriInfo.value, AttributeData.Base);//派发升级事件之前，先把等级升上去，要不然功能开放表取到的还是原来的等级
				switch( msg.basisAttriInfo.type )
				{
					case EnumBaseAttribute.LEVEL:
						GameEvent.playerLevelUp.dispatch();
                        BtnGroupUtil.MainPlayerLevelUpHandler();//检查新功能开放
						ChannelUtil.OnGame_LevelUp();
						// Mgr.shortcutMgr.updateExpBar();
						// Mgr.worldBossMgr.reqQueryBossListMsg();
						// Mgr.onHookMgr.isNeedCheckAutoBuyHp = true;
						// Mgr.shopMgr.reqShopItemListMessage( ShopUtil.SHOP_TYPE_BODY );
						// Mgr.backpackMgr.checkStrongerEquip();
						Mgr.dailyactivity.SendReqDailyActivitiesBriefInfoMessage();//升级了先刷下活动哎呀
						break;
					case EnumBaseAttribute.HP:
						if( this.roleHeadPanel )
							this.roleHeadPanel.UpdateHpBar();
						// Mgr.shortcutMgr.updateHpBar();
						// Mgr.attributeMgr.updatePlayerInfoPanel();
						// checkShowLifeDangerous();
						break;
					case EnumBaseAttribute.NUQI:
						if( this.shortPanel )
							this.shortPanel.UpdateNuqi(msg.basisAttriInfo.value);
						break;
				}
				this.UpdateEquipPanelExtAttributeData();
			}
		}
	},

	//money
	RecvResPlayerCurrencyInfoMessage:function(msg){
		this.mainPlayer.attributeData.UpdateAttribute( msg.currencyInfo.type, msg.currencyInfo.value, AttributeData.Money );
		if( this.roleHeadPanel )
			this.roleHeadPanel.UpdatePanel();

		var panel = Mgr.uiMgr.GetPanelByType( ShortcutPanelExt.PanelName );
		if ( panel )
			TimerUtil.SetTimeout( panel, panel.CurrencyChange, 1000);

		ElseStrongUtil.OnConditionChanged();
	},

	RecvResPlayerBriefMessage:function(msg) {
        // 数据兼容
        for(var i = 0;i!=msg.playerBriefs.length;++i){
            var v = msg.playerBriefs[i];
            var equips = [];
            for(var ii=0;ii!=v.playerEquipInfos.length;++i){
                var vv = v.playerEquipInfos[ii];
                if(vv.equipType == EnumItemType.Equip){
                    equips = vv.equips;
                    break;
                }
            }
            v.equips = equips;
        }

		switch (msg.controlType)
		{
			case EnumBriefType.FRIEND_APPLY :
			{
				Mgr.uiMgr.GetPanelByType(ApplyFriendPanelExt.PanelName).UpdateApplyList(msg);
				break;
			}
			case EnumBriefType.HEAD_MENUE :
			{
				// 聊天栏玩家基本信息
				var panel = EngineMgr.uiMgr.ShowPanelByType(MenuPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
				if ( panel && panel.visible)
				{
					panel.UpdateInformation(msg);
				}
				break;
			}
			case EnumBriefType.TEAM_INVISITE :
			{
				// 好友组队（对人跨服副本）
				var panel = Mgr.uiMgr.GetPanelByType(YaoqingMainExt.PanelName);
				if ( panel && panel.visible)
				{
					panel.SetInvisiteFriendList(msg);
				}
				break;
			}
			case EnumBriefType.TEAM_GUILD_INVISITE :
			{
				// 帮会成员组队（对人跨服副本）
				var panel = Mgr.uiMgr.GetPanelByType(YaoqingMainExt.PanelName);
				if ( panel && panel.visible)
				{
					panel.SetInvisiteGuildList(msg);
				}
				break;
			}
			case EnumBriefType.PAIHANB :
			{
				var panel = Mgr.uiMgr.ShowPanelByType( OtherRolePanelExt.PanelName,UIMgr.PANEL_LAYER_POP );
				panel.SetData(msg.playerBriefs[0], EnumDetails.OPEN_MODE_NORMAL);
				break;
			}
			case EnumBriefType.TEAM_MAP_INVISITE :
			{
				// 帮会
				var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
				if ( panel && Mgr.uiMgr.IsPanelShow(panel) && panel.showPanel.SetPlayerBriefMsg )
					panel.showPanel.SetPlayerBriefMsg(msg.playerBriefs[0]);

				// 组队信息查看信息
				var panel = Mgr.uiMgr.GetPanelByType(TeamMemberInfoPanelExt.PanelName);
				if ( panel && panel.SetPlayerBriefMsg )
					panel.SetPlayerBriefMsg(msg.playerBriefs[0]);

				// 神机宝箱
				var panel = Mgr.uiMgr.GetPanelByType(ShenjiBoxPanelExt.PanelName);
				if ( panel && Mgr.uiMgr.IsPanelShow(panel) && panel.SetPlayerBriefMsg )
					panel.SetPlayerBriefMsg(msg.playerBriefs[0]);

				var panel = Mgr.uiMgr.GetPanelByType(YaoqingMainExt.PanelName);
				if(panel && panel.visible)
				{
					panel.SetInvisiteSearchedList(msg);
				}
				break;
			}
            case EnumBriefType.ARENA:
            {
                Mgr.arena.RecvResPlayerBriefMessage(msg);
                break;
            }
            case EnumBriefType.MARRIAGE:{
                let MI = Mgr.marriage.GetMarriageInfo()
                if(MI) MI.setTargetBrief(msg.playerBriefs[0])
                break;
            }
			default :
			{
				break;
			}
		}
	},

	RecvResSyncServerTimeMessage:function(msg) {	
	},

	RecvResPlayerStateChangeMessage:function(msg) {
		Mgr.mainPlayer.isInFightState = (msg.state == 0);
	},

	RecvResChangePKStateMessage:function(msg) {
		if( msg.personId.Equal(Mgr.mainPlayer.oSid) ){
			this.UpdatePkMode(msg.pkState);
		}
	},
	UpdatePkMode:function(value){
		//UpdateRoleHeadPanel();
		Mgr.mainPlayer.curPkMode = value;
		var headpanel = Mgr.uiMgr.GetPanelByType(RoleHeadPanelExt.PanelName);
		if( headpanel )
			headpanel.ChangeModelText(value);
	},

	CanAttackPlayer:function(player){
		if( !player )
			return false;
		var map = Q_map.Get(Mgr.sceneMap.nMapId);
		if( map ){
			if( map.q_map_safe == 1 )//安全区
				return false;
			else if( map.q_map_pkprotection ){
				if( Mgr.mainPlayer.nCurLevel < 30 || player.nCurLevel < 30 )
					return false;
			}
		}
		if( !this.CheckPkMode(player) )
			return false;
		if( player.IsSafeArea() )
			return false;
		return true;
	},

	CheckPkMode:function(player){
		switch (Mgr.mainPlayer.curPkMode){
			case EnumPkMode.PK_MODE_TEAM:
				return ( !player.teamId || !player.teamId.Equal(Mgr.mainPlayer.teamId) );
			case EnumPkMode.PK_MODE_GUILD:
				return ( !player.guildId || !player.guildId.Equal(Mgr.mainPlayer.guildId) );
			case EnumPkMode.PK_MODE_ALL:
				return true;
			case EnumPkMode.PK_MODE_EVIL:
				return player.killNum >= 3;
			case EnumPkMode.PK_MODE_PEACE:		//红名灰名并且非同组同帮
				return ((player.killNum >= 3 || player.pkValue > 0) && ( !player.teamId || !player.teamId.Equal(Mgr.mainPlayer.teamId) ) && ( !player.guildId || !player.guildId.Equal(Mgr.mainPlayer.guildId) ));
			case EnumPkMode.PK_MODE_SERVER:
				return Mgr.mainPlayer.serverKey != player.serverKey;
		}
		return false;
	},

	//改名
	RecvResChangePlayerNameToClientMessage:function(msg) {
	},

	RecvResAutoStartStateMessage:function(msg) {
		if( msg.result == 1 )
			this._StartAutoFight();
		else
			this._StopAutoFight();
	},

	RecvRespopuGuideMessage:function(msg) {	
	},

	RecvResPlayerDieMessage:function(msg) {
		var obj = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		if( obj ){
			if( obj == Mgr.mainPlayer){
				if(msg.autoRevive == 1){
                    //复活倒计时
                    var panel = Mgr.uiMgr.ShowPanelByType(HuSongAliveTimeExt.PanelName,UIMgr.PANEL_LAYER_POP);
                    panel.SetTime(msg.autoTime);
				}
				if(msg.panel){
                    var panel = Mgr.uiMgr.ShowPanelByType(FuhuoPanelExt.PanelName,UIMgr.PANEL_LAYER_POP);
                    panel.SetData(msg);
                }
			}
			obj.DoDeadState();
			Mgr.map.CheckTargetOnRemove(obj);
		}
	},

	RecvResReviveSuccessMessage:function(msg) {
		var obj = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		if( obj ){
			obj.DoReviveState();
		}
	},

	RecvResPlayerNonageStateMessage:function(msg) {	
	},

	RecvNonagePromptMessage:function(msg) {
		if( msg.content > 0 ){
			var str;
			switch (msg.content){
				case 528:
					str = "您已累计在线1小时，请合理安排游戏时间。";
					break;
				case 529:
					str = "您已累计在线2小时，请合理安排游戏时间。";
					break;
				case 530:
					str = "您已累计在线3小时，您已进入疲劳游戏时间，游戏收益变为正常的50%，请您下线休息。";
					break;
				case 531:
					str = "您已累计在线3.5小时，您已进入疲劳游戏时间，游戏收益变成正常的50%，请您下线休息。";
					break;
				case 532:
					str = "您已累计在线4小时，您已进入疲劳游戏时间，游戏收益变成正常的50%，请您下线休息。";
					break;
				case 533:
					str = "您已累计在线4.5小时，您已进入疲劳游戏时间，游戏收益变成正常的50%，请您下线休息。";
					break;
				case 534:
					str = "您已累计在线5小时，您已进入不健康游戏时间，游戏收益变为0，请下线休息。";
					break;
				case 535:
					str = "您当前已经进入疲劳游戏时间，游戏收益变成正常的50%，请您合理安排游戏时间";
					break;
				case 536:
					str = "由于您是未成年人，将被纳入防沉迷系统，3小时内收益经验正常，3-5小时内收益经验减半，5小时后收益经验为零";
					break;
			}
			if( str )
				AlertExt.Show(str);
		}
	},

	RecvResPlayerNonageTimeMessage:function(msg) {	
	},

	RecvResPlayerNonageRegisterMessage:function(msg) {	
	},

	RecvResOthersPlayerInfoMessage:function(msg) {
	},

	RecvResPhoneVerificationStatusMessage:function(msg) {	
	},

	RecvResCountdownToClientMessage:function(msg) {	
	},

	RecvResRechargeInfoMessage:function(msg) {
        cc.log("收到充值消息！！！" + msg.day);
        this.rechargeInfo = msg;
	},

	RecvResTotalOnlineTimeMessage:function(msg) {
        this.TotalOnlineTime = msg;
        BtnGroupUtil.CheckInit();
	},

	RecvReskillnumToClientMessage:function(msg) {
		var player = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		if( player ){
			player.killNum = msg.killnum;
			player.pkValue = msg.isGreyname;
			if( player.oNameBar )
				player.oNameBar.UpdateNameColor(player.killNum, player.pkValue);
		}
	},
	RecvResPlayerChangeNameTimeMessage:function(msg)
	{
		if(msg.remainTime != 0)
		{
			var timeStr = TimeUtil.SecondToDHMS(msg.remainTime);
			var str = "冷却中，"+timeStr+"后可再次改名";
			Mgr.tips.ShowNotice(str);
		}
		else
		{
			EngineMgr.uiMgr.ShowPanelByType(ChangeNamePanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
		}
	},
	RecvResPlayerOfflinePluginTimeMessage:function(msg) {
		this._exitRemainTime = msg.remainTime
		if(Mgr.gossip.taijiPanel && Mgr.uiMgr.IsPanelShow( Mgr.gossip.taijiPanel )){
			Mgr.gossip.taijiPanel.UpdateTime();
		}
	},
	
	RecvResPlayerPluginRecordMessage:function(msg) {
		Mgr.uiMgr.ShowPanelByType(TuojiguaMainExt.PanelName);
		Mgr.uiMgr.GetPanelByType(TuojiguaMainExt.PanelName).SetInfo(msg.pluginTime,msg.remainTime,msg.exp,msg.items);
	},

	RecvResTodayGoldCostToClinetMessage:function(msg){
		cc.log( "今日消费元宝 ------> " + msg.costNums );
		//这里刷新限时回馈消费活动红点
        var list = Mgr.dailyactivity.GetActivityByKey(EnumActivityKey.M_XSHK);
        if(list && list[0].special) {
            var need = list[0].special[0].beanInfo.need;
            Mgr.map.miniMapPanel.UpdateXSHKWarn(msg.costNums >= need);
        }
	},

    RecvResAppRecharegeOrderMessage:function(msg){
		cc.log(JSON.stringify(msg));
        if(msg.state == 1){
            ChannelUtil.Recharge({
                orderId :msg.orderId,
                moneys :msg.moneys / 100,		//分转为元
                ext :msg.ext,
                productId:msg.productId,
                productName:msg.productName,
                productDesc:msg.productDesc,
            })
        }else{
            cc.error("RecvResAppRecharegeOrderMessageMessage",msg.state )
        }
    },

	SendReqPlayerChangeNameTimeMessage:function() {
		var msg = new ReqPlayerChangeNameTimeMessage();
		Mgr.msgMgr.Send(msg);
	},

    SendReqAppRecharegeOrderMessage:function(id){
        var msg = new ReqAppRecharegeOrderMessage();
        msg.gold = id;

        Mgr.msgMgr.Send(msg);
    },

	//add-12-12
    RecvResNotEnoughGoldChangeMessage:function (msg) {
		AlertExt.NoEnoughGold(msg.gold);
    },

	SendReqReviveMessage:function() {
        var msg = new ReqReviveMessage();
        Mgr.msgMgr.Send(msg);
	},

	SendReqLocalReviveMessage:function() {
        var msg = new ReqLocalReviveMessage();
        msg.type = 1;
        Mgr.msgMgr.Send(msg);
	},

	SendReqChangePKStateMessage:function(mode) {
		//if( value == EnumPkMode.PK_MODE_TEAM && Mgr.team.teamInfo == null )
		//	return false;
		//if( value == EnumPkMode.PK_MODE_GUILD && Mgr.mainPlayer.guildId.IsZero() )
		//	return false;

		var msg = new ReqChangePKStateMessage();
		msg.pkState = mode;
		Mgr.msgMgr.Send( msg );
	},

	SendReqAutoStartMessage:function() {
		Mgr.msgMgr.Send(new ReqAutoStartMessage());
	},

	SendReqAutoEndMessage:function() {
		Mgr.msgMgr.Send(new ReqAutoEndMessage());
	},
	//改名
	SendReqPlayerChangeNameMessage:function(name, sex) {
		var msg = new ReqPlayerChangeNameMessage();
		if(name){
            msg.name = name;
            msg.sex = 0;
		}
		else{
            msg.name = null;
            msg.sex = sex;
		}
		Mgr.msgMgr.Send(msg);
	},

	SendReqPlayerBriefMessage:function(listId,type) {
		var msg=new ReqPlayerBriefMessage();
		msg.personIds=listId;
		msg.controlType=type;
		Mgr.msgMgr.Send( msg );
	},

	SendReqPlayerNonageRegisterMessage:function(msg) {	
	},

	SendReqNonageTimeMessage:function(msg) {	
	},

	SendReqOthersPlayerInfoMessage:function(id) {
		var msg = new ReqOthersPlayerInfoMessage();
		msg.personId=id;
		Mgr.msgMgr.Send( msg );
	},

	SendReqChangeWinMessage:function(msg) {	
	},

	SendReqPhoneVerificationRewardMessage:function(msg) {	
	},

	SendReqRechargeInfoMessage:function() {
		Mgr.msgMgr.Send(new ReqRechargeInfoMessage());
	},

	SendReqChangePlayerFashionMessage:function(msg) {	
	},

	SendResPersonalNoticePublicToGameMessage:function(msg) {	
	},

	UpdateNuqiValue:function(){
		var value = this.mainPlayer.attributeData.GetAttribute( EnumBaseAttribute.NUQI, AttributeData.Base );
		this.mainPlayer.attributeData.UpdateAttribute(EnumBaseAttribute.NUQI, value + AttributeData.Nuqi_One_Value, AttributeData.Base);
		if( this.shortPanel )
			this.shortPanel.UpdateNuqi();
	},
	
	ClickScenePlayer:function( player ){
		if( !player || player == Mgr.mainPlayer )
			return;

		if( player.IsDeadState() ){
			Mgr.tips.ShowNotice("目标已被击败");
			return;
		}
		var map = Q_map.Get(Mgr.sceneMap.nMapId);
		if( map ){
			if( map.q_map_safe == 1 ){
				Mgr.tips.ShowNotice("很抱歉，安全区内禁止攻击其他玩家");
				return;
			}
			else if( map.q_map_pkprotection ){
				if( Mgr.mainPlayer.nCurLevel < 51 || player.nCurLevel < 51 )
				{
					Mgr.tips.ShowNotice("很抱歉，你或对方玩家正处于新手保护期");
					return;
				}
			}
		}
		if( player.IsSafeArea() ){
			Mgr.tips.ShowNotice("当前PK模式，无法对其造成伤害");
			return;
		}
		//pk模式允许则攻击玩家
		if( Mgr.player.CheckCanAttack( Mgr.mainPlayer.curPkMode, player ) ){
			Mgr.mainPlayer.oCtrlAutoFight.SetLockAutoAttackTarget(player);
		}
		else{
			Mgr.tips.ShowNotice("很抱歉，当前PK模式不能对玩家造成伤害");
		}
	},
	/************************* pvp *******************************/
	/**
	 * 根据玩家得到能攻击他的pk模式	善恶>帮会>组队>全体
	 * @param player
	 * @constructor
	 */
	GetPkModel:function(player){
		if( player ){
			if( this.CheckCanAttack(EnumPkMode.PK_MODE_EVIL, player ) )
				return EnumPkMode.PK_MODE_EVIL;
			else if( this.CheckCanAttack(EnumPkMode.PK_MODE_GUILD, player ) )
				return EnumPkMode.PK_MODE_GUILD;
			else if( this.CheckCanAttack(EnumPkMode.PK_MODE_TEAM, player ) )
				return EnumPkMode.PK_MODE_TEAM;
			else if( this.CheckCanAttack(EnumPkMode.PK_MODE_ALL, player ) )
				return EnumPkMode.PK_MODE_ALL;
		}
		return EnumPkMode.PK_MODE_PEACE;
	},
	//检测能否攻击
	CheckCanAttack:function(mode, player){
		if( !player || player.IsDeadState() )
			return false;
		switch(mode){
			case EnumPkMode.PK_MODE_ALL:
				return true;
			case EnumPkMode.PK_MODE_TEAM:
				return !Mgr.team.IsTeamMember( player.oSid );
			case EnumPkMode.PK_MODE_GUILD:
				return !Mgr.mainPlayer.guildId.Equal( player.oSid );
			case EnumPkMode.PK_MODE_EVIL:
			case EnumPkMode.PK_MODE_PEACE:
				return player.killNum >= 3 || player.pkValue > 0;
		}
		return false;
	},

	/***
	 * 角色是否存在叹号操作
	 * @param subType
	 * @returns {boolean}
	 * @constructor
	 */
	IsMarkBySubType:function (subType, isCheckGold) {
		// 角色
		if ( subType == undefined || subType == -1 ) {
			var isShow01 = Mgr.title.ShowTouxianRedPoint(Mgr.title.cTouxian);
			var isShow02 = Mgr.title.RefreshTitleMgrArr();
			if(isShow01 || isShow02)
			{
				return true;
			}
		}

		// 战甲
		if ( subType == undefined || subType == 0 ) {
			if(Mgr.armor.isOpen && !Mgr.armor.isOldedTime)
			{
				var isShow = Mgr.armor.JugementZhanjiaToolsEnough();
				if ( isShow)
				{
					return true;
				}
			}
		}

        // 神兵
        if ( subType == undefined || subType == -2 ) {
            var isOpen = BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_SHNEBING);
            if(isOpen && Mgr.godarm.IsEnableUp()){
            	return true;
			}
        }

		// 坐骑
		if ( subType == undefined || subType == EnumResline.HORSE  ) {
			var mgr = Mgr.resline.GetMgrByType(EnumResline.HORSE);
			var isOpen = BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_JINJIE,BtnGroupUtil.JINJIE_HOURSE);
			if ( mgr.IsEnableUp(isCheckGold)  && isOpen) {
				return true;
			}
		}
		// 法器
		if ( subType == undefined || subType == EnumResline.DRAGON  ) {
			var mgr = Mgr.resline.GetMgrByType(EnumResline.DRAGON);
			var isOpen = BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_JINJIE,BtnGroupUtil.JINJIE_FAQI);
			if ( mgr.IsEnableUp(isCheckGold) && isOpen) {
				return true;
			}
		}
		// 光武
		if ( subType == undefined || subType == EnumResline.GUANGWU  ) {
			var mgr = Mgr.resline.GetMgrByType(EnumResline.GUANGWU);
			var isOpen = BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_JINJIE,BtnGroupUtil.JINJIE_GUANGWU);
			if ( mgr.IsEnableUp(isCheckGold) && isOpen) {
				return true;
			}
		}
        // 武学
        if ( subType == undefined || subType == EnumResline.WUXUE  ) {
            var mgr = Mgr.resline.GetMgrByType(EnumResline.WUXUE);
            var isOpen = BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_WUXUE);
            if ( mgr.IsEnableUp(isCheckGold) && isOpen) {
                return true;
            }
        }
        // 脚印
        if ( subType == undefined || subType == EnumResline.STEP  ) {
            var mgr = Mgr.resline.GetMgrByType(EnumResline.STEP);
            var isOpen = BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_SHUTONG,BtnGroupUtil.SHUTONG_JIAOYING);
            if ( mgr.IsEnableUp(isCheckGold) && isOpen) {
                return true;
            }
        }

        // 剑灵
        if ( subType == undefined || subType == EnumResline.JIANLING  ) {
            var mgr = Mgr.resline.GetMgrByType(EnumResline.JIANLING);
            var isOpen = BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_SHUTONG,BtnGroupUtil.SHUTONG_JIANLING);
            if ( mgr.IsEnableUp(isCheckGold) && isOpen) {
                return true;
            }
        }

		return false;
	},

		/***
		 * 书童界面是否存在叹号操作
		 * @param subType
		 * @returns {boolean}
         * @constructor
         */
		IsMarkBySubType2:function (subType, isCheckGold) {
            // 新书童
            if (subType == undefined || subType == 0) {
                return false
                var equips = Mgr.backpack.GetItemsByType(EnumItemType.Equip_Shutong);
                if(equips.find(function(v){
                    return ItemUtil.GetFightPowerFromCurrent(v) > 0;
                })) return true;
            }

			// 书童进阶
//			if ( subType == undefined || subType == EnumResline.SHUTONG  ) {
//				var mgr = Mgr.resline.GetMgrByType(EnumResline.SHUTONG);
//				if ( mgr.IsEnableUp(isCheckGold) ) {
//					return true;
//				}
//			}
			// 宝骑进阶
			if ( subType == undefined || subType == EnumResline.BAOQI  ) {
				var mgr = Mgr.resline.GetMgrByType(EnumResline.BAOQI);
				if ( mgr.IsEnableUp(isCheckGold) ) {
					return true;
				}
			}
			return false;
		},

	/************************* pvp *******************************/

	/************************* 自动战斗  Start 这里只作状态相关处理 真正的战斗放到auto_fight_ctrl里了 *******************************/
	isAutoFight:false,
	StartOrStopAutoFight:function () {
		if(this.isAutoFight)
			this.TryStopAutoFight();
		else
			this.TryStartAutoFight();
	},
	TryStartAutoFight:function () {
		if(Mgr.sceneMap.bChangingState)
			return;
		this.SendReqAutoStartMessage();
	},
	//这里包一层是为了一些特殊处理 比如剧情等前端自动执行 无关后端
	TryStopAutoFight:function () {
		this.SendReqAutoEndMessage();
	},
	_StartAutoFight:function () {
		Mgr.mainPlayer.ClearActiveState();
		this.isAutoFight = true;
		this._expInMinute = 0;
		if( this._expTimeNum == 0 )
			this._expTimeNum = TimerUtil.TimeUpdate(this.OnExpTimer, this, 60);
		this.shortPanel.UpdateAutoFightState();
	},
	_StopAutoFight:function () {
		if( this.isAutoFight ){
			this.isAutoFight = false;

			if( this._expTimeNum != 0 )
				TimerUtil.ClearTimeUpdate(this._expTimeNum, this);
			this._expTimeNum = 0;
			// // 脱离挂机还原之前的PK状态
			// if (beforePkMode >= EnumPKMode.PK_MODE_PEACE && beforePkMode <= EnumPKMode.PK_MODE_EVIL)
			// {
			// 	Mgr.pvpMgr.reqPkModeMessage(beforePkMode, true, 1);
			// }
			// beforePkMode = -1;
		}
		Mgr.mainPlayer.oCtrlAutoFight.ClearLockAutoAttackTarget();
		this.shortPanel.UpdateAutoFightState();
	},
		
	OnAutoFight:function () {
		// CheckUseDrug();
		// CheckUseExp();
		if( Mgr.mainPlayer.IsActiveState() ){	//手动操作状态
			return;
		}
		if( Mgr.sceneMap.bChangingState )
			return;
		if( this.isAutoFight && !Mgr.mainPlayer.IsMoving() ){
			this.AutoFight();
		}
	},

	AutoFight:function(){
		var fightCtrl = Mgr.mainPlayer.oCtrlAutoFight;
		var tar;
		if(!Mgr.npc.isCollection){//采集中就先不忙打怪
			if( fightCtrl.nAutoAttackGID != 0 ){
				tar = Mgr.sceneObj.FindObject( fightCtrl.nAutoAttackGID );
				if( tar ){
					if( (tar instanceof SceneMonster) && !Mgr.kingguild.canAttackMonster() ){		//不能打怪了 清空自动攻击怪物目标
						fightCtrl.ClearLockAutoAttackTarget();
					}
					else if( !tar.IsDeadState() )
						return;
				}
			}
			tar = Mgr.sceneObj.GetNearestPlayer(this.CanAttackPlayer.bind(this));		//优先击杀玩家
			if( !tar && Mgr.kingguild.canAttackMonster() )
				tar = Mgr.sceneObj.GetNearestMonster();
			if(tar){
				Mgr.map.SelTarget(tar);
				fightCtrl.SetLockAutoAttackTarget(tar);
				return;
			}
		}

        // 守卫京城活动挂机要捡宝箱
        if(Mgr.guardcpital.CheckAutoCollectChests()) return;
	},
	
	//玩家属性发生变化，更新角色界面玩家属性显示（20161026 by zfs)
	UpdateEquipPanelExtAttributeData:function()
	{
		var equipPanel = EngineMgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName);
		if ( equipPanel && equipPanel._equipPanel )
		{
			equipPanel._equipPanel.UpdateInfo();
		}
	},
	
	OnExpTimer:function () {
        var showStr = this._expInMinute.toString();
		if( this._expInMinute == 0 ){
			showStr = "";
		}
		else if(this._expInMinute > 10000){
			showStr = parseInt(this._expInMinute/10000) + "w";
		}
		this._expInMinute = 0;
		Mgr.player.shortPanel.UpdateExpShow(showStr);
	},
	/************************* 自动战斗  End *******************************/
});
