var QiannengdanTipsExt = QiannengdanTips.extend ( {
	_className:"QiannengdanTipsExt",
	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.ALPHABLACK;
	},

	Init:function() {
		var self = this;
		QiannengdanTips.prototype.Init.call(this);

		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
			Mgr.uiMgr.HidePanelByType(HuoquTujingCueExt.PanelName);
		});

		this.btnGo.addClickEventListener(function (event){
			if ( this.useMark ) {  // 使用
				if (this.limit) {
					Mgr.tips.ShowNotice("当前使用数量已达到上限");
					return;
				}
				var ownNum =  Mgr.backpack.GetItemsByMid( this.mid );
				Mgr.backpack.SendReqUseItemMessage(ownNum[0].itemId, 1);
			}
			else {
				if ( !Mgr.uiMgr.IsPanelShowByName(HuoquTujingCueExt.PanelName) ) {
					var panel = Mgr.uiMgr.ShowPanelByType(HuoquTujingCueExt.PanelName);
					panel.SetItemMid(this.mid);
					panel.SetDepend(self);
				}
			}
		});
	},

	SetData:function (type) {
		var mgr = Mgr.resline.GetMgrByType(type);

		var layer = mgr.curShowLayer;
		var stars = mgr.GetCurShowStars();

		var danArr = mgr.GetDanDataArr();
		var mid = danArr[0][0];
		var maxNum = danArr[0][1];

		// next
		var danArr_next = mgr.GetDanDataArr(layer + 1);
		var maxNum_next = danArr_next[0][1];
		if ( maxNum_next <= 0 )
			maxNum_next = maxNum;

		var danNumArr = mgr.GetDanNumArr();
		var usedNum = danNumArr[0];
		var ownNum =  Mgr.backpack.GetItemNumber( mid, true );
		this.btnGo.useMark = ownNum > 0;
		this.btnGo.limit = usedNum > maxNum;
		this.btnGo.mid = mid;
		if ( ownNum > 0 )
			this.btnGo.setTitleText( "使用" );
		else
			this.btnGo.setTitleText( "获取" );


		UIUtil.ConnectLabelHtmlText(this.labNum, [usedNum, maxNum]);
		UIUtil.ConnectLabelHtmlText(this.labNum1, [ownNum]);

		var reslinename = mgr.GetResLineName();
		UIUtil.ConnectLabelHtmlText(this.labCue1,[reslinename]);
		UIUtil.ConnectLabelHtmlText(this.labCue2,[reslinename]);
		UIUtil.ConnectLabelHtmlText(this.labjichu, [maxNum_next]);

		var attrType = [
			{label:this.labGongji1, type:EnumAttribute.ATTACK},
			{label:this.labFangyu1, type:EnumAttribute.DEFEND},
			{label:this.labHp1, type:EnumAttribute.MAX_BASEHP},
		];
		for ( var i = 0; i != attrType.length; i++ ) {
			var _value = mgr.GetQnDanAttribute(0, layer, stars, mid, usedNum, attrType[i].type );
			UIUtil.ConnectLabelHtmlText(attrType[i].label, [_value]);
		}

		// get route
		var item = Q_item.Get(mid);
		this.labCue6.SetString(item.q_output);
		//UIUtil.ConnectLabelHtmlText(this.labCue6, [item.q_output])

		UIUtil.ConnectLabelHtmlText(this.labName, [item.q_name])

		// icon
		var grid = this.gridIcon;
		var icon = ItemUtil.GetItemIcon(mid)
		icon.x = (grid.uiWidth - icon.width) / 2;
		icon.y = (grid.uiHeight - icon.height) / 2;
		grid.SetGridIcon(icon);
	},
} );
QiannengdanTipsExt.PanelName = "QiannengdanTipsExt";
PanelClassDic["QiannengdanTipsExt"] = QiannengdanTipsExt;
