var ShuXingDanMainExt = ShuXingDanMain.extend ( {
	_className:"ShuXingDanMainExt",
	_itemArr:null,
	itemsInfo:null,
	playerUsedInfo:null,
	holditemsInfo:null,
	ctor:function(){
		this._super();
		this._itemArr = [];
		this.itemsInfo = [];
		this.holditemsInfo = new HashMap();
        this.modelPanelType = MUIPanelModelType.ALPHABLACK;
	},

	Init:function () {
		ShuXingDanMain.prototype.Init.call(this);
        var self = this;
        this.InitGrid();
        this.SetPosition();
		this.btnClose.addClickEventListener(function (event) {
			Mgr.uiMgr.HidePanel(self);
        });
		//获取
		this.btn1.addClickEventListener(function (event) {
			if(!Mgr.uiMgr.IsPanelShowByName(HuoquTujingCueExt.PanelName)){
                var panel = Mgr.uiMgr.ShowPanelByType(HuoquTujingCueExt.PanelName, Mgr.uiMgr.PANEL_LAYER_TOP);
                panel.SetItemMid(self.itemsInfo[0][0]);//先注释掉，等配置
                panel.SetDepend(self);
			}
        });
		//使用
		this.btn2.addClickEventListener(function (event) {
			var count = 0;
			for(var i = 0; i < self._itemArr.length; i++){
				var itemInfo = self._itemArr[i].info;
				var holdNum = itemInfo[0];
				var usedNum = itemInfo[1];
				var maxLimit = itemInfo[2];
				var mid = itemInfo[3][0];
				var need = maxLimit - usedNum;
                var canUse = 0;
                if(need > holdNum){
                	canUse = holdNum;
				}else {
                	canUse = need;
				}
				if(canUse > 0){
                	count++;
					var item = self.holditemsInfo.Get(mid)[1];
					Mgr.backpack.SendReqUseItemMessage(item.itemId, canUse);
				}
			}
			if(count <= 0){
				Mgr.tips.ShowNotice("没有属性丹或已达上限");
			}
        });
    },

	OnShow:function () {
        this.RefreshPanel();
    },

	InitGrid:function () {
		var data = JSON.parse(Q_global.Get(1190).q_string_value);
		this.itemsInfo = data;
		for(var i = 0, len = data.length; i < len; i++){
			var item = new ShuXingDanGridExt();
			item.LoadPanel();
			this._itemArr.push(item);
			this.addChild(item);
		}
    },

	RefreshPanel:function () {
		this.GetHoldItems();

		for(var i = 0; i< this._itemArr.length; i++){
			var item = this._itemArr[i];
            var usednum = 0;
            var holdnum = this.holditemsInfo.Get(this.itemsInfo[i][0])[0];
            for(var j = 0; j < this.playerUsedInfo.length; j++){
                var info = this.playerUsedInfo[j];
                if(info.itemModelId == this.itemsInfo[i][0]){
                    usednum = info.itemNum;
                }
            }
            item.SetData(this.itemsInfo[i], usednum, holdnum);
		}
    },

	SetPosition:function () {
		//暂时先这样写
		var arr1 = [this._itemArr[0], this._itemArr[1], this._itemArr[2]];
        var arr2 = [this._itemArr[3], this._itemArr[4], this._itemArr[5]];
        for(var i = 0; i < 3; i++){
            arr1[i].y = 320;
            arr2[i].y = 110;
        	arr1[i].x += 110 + 240 * i;
            arr2[i].x += 110 + 240 * i;
		}
    },

	GetHoldItems:function () {
        this.playerUsedInfo = Mgr.player.mainPlayer.attrItem;
		var items = Mgr.backpack.backpackVO.GetItemInfoHash().Values();
		for(var i = 0; i < this.itemsInfo.length; i++){
			var info = this.itemsInfo[i];
			var totalCount = 0;
			var curItem = null;
			for(var j = 0, len = items.length; j < len; j++){
				var data = items[j];
				if(info[0] == data.itemModelId){
					totalCount += data.itemNum;
					curItem = data;
				}
			}
			this.holditemsInfo.Put(info[0], [totalCount, curItem]);
		}
    },
} );
ShuXingDanMainExt.PanelName = "ShuXingDanMainExt";
PanelClassDic["ShuXingDanMainExt"] = ShuXingDanMainExt;
