var ZhanjiaMainExt = ZhanjiaMain.extend ( {
	_className:"ZhanjiaMainExt",
	_gridArr:[],
	_cuilianItem:null,
	_zanjiaTableData:[],
	_index:0,
	_showModelId:0,
	_currentModleId:0,
	_overTime:0,
	_activateTime:0,
	_zhanjiaData:null,
	_maxTagArr:[],
	_mgr:null,
	_nResid:0,
    itemInfo:[],
	ctor:function(){
		this._super();
	},
	Init:function()
	{
		ZhanjiaMain.prototype.Init.call(this);
		this._SetBaseProperty();
		this._InitLocalProperty();
		this._HandleButton();
		this.SetProperty();
		this.InitLabZhanjiaCue();
	},
	_SetBaseProperty:function()
	{
		var color01 = EnumFontFormat.COMMON_COLOR02, fontsize01 = EnumFontFormat.FONTSIZE_BUTTON;
		this.btnVip.setTitleFontSize(fontsize01);//穿戴
		this.btnVip.setTitleColor(UIUtil.GetCCColor(color01));
		this.btnCue.setTitleFontSize(fontsize01);//淬炼
		this.btnCue.setTitleColor(UIUtil.GetCCColor(color01));
		this.btnShuxing.setTitleFontSize(fontsize01);//查看VIP
		this.btnShuxing.setTitleColor(UIUtil.GetCCColor(EnumFontFormat.COMMON_COLOR01));
		var zorder = 100;
		this.labMax.setLocalZOrder(zorder);
		this.labMax.SetColor(EnumFontFormat.COMMON_COLOR04);
		this.labMax.EnableOutline();
		this.labMax1.setLocalZOrder(zorder);
		this.labMax1.SetColor(EnumFontFormat.COMMON_COLOR04);
		this.labMax1.EnableOutline();
		this.labMax2.setLocalZOrder(zorder);
		this.labMax2.SetColor(EnumFontFormat.COMMON_COLOR04);
		this.labMax2.EnableOutline();
		this._maxTagArr = [this.labMax,this.labMax1,this.labMax2];
	},
	_InitLocalProperty:function()
	{
		var data = Q_global.Get(1029);
		this._zanjiaTableData = JSON.parse(data.q_string_value);
		this._gridArr = [this.gridItem,this.gridItem1,this.gridItem2];
		this.imgBg.setPosition(20,110);
	},
	_HandleButton:function()
	{
		var self = this;
		var len = this._zanjiaTableData.length;
		this.btnLeft.addClickEventListener(function()
		{
			self._index--;
			if(self._index < 0)
			{
				self._index = len-1;
			}
			self.SetProperty();
		}.bind(this));
		this.btnRight.addClickEventListener(function()
		{
			self._index++;
			if(self._index > len-1)
			{
				self._index = len-1;
			}
			self.SetProperty();
		}.bind(this));
		//淬炼
		this.btnCue.addClickEventListener(function()
		{
			if(Mgr.armor.isOpen && !Mgr.armor.isOldedTime)
			{
				var isHave = self._JugementToolsEnough();
				if(isHave && self._cuilianItem)
				{
					// Mgr.armor.SendReqArmorCuilianToGameMessage(self._cuilianItem.itemModelId,self._cuilianItem.itemNum);
					//&additem 510101 100 false
					for(var i = 0; i < self.itemInfo.length; i++){
						if(self.itemInfo[i].num > 0)
                            Mgr.armor.SendReqArmorCuilianToGameMessage(self.itemInfo[i].id, self.itemInfo[i].num);
					}
				}
			}
			else
			{
				Mgr.tips.ShowNotice("请先激活光羽");
			}
		});
		//vipbutton
		this.btnShuxing.addClickEventListener(function()
		{
			EngineMgr.uiMgr.HidePanelByType(PlayerPanelExt.PanelName);
			var panel = EngineMgr.uiMgr.ShowPanelByType(TaijiPanelExt.PanelName);
			if(panel)
			{
				panel.ShowType(EnumGrossipType.TYPE_DAY)
				panel.ChangeView(EnumGrossipType.TYPE_JIANGLI);
			}
		});
		//前往充值
		this.btnGo.addClickEventListener(function()
		{
			EngineMgr.uiMgr.HidePanelByType(PlayerPanelExt.PanelName);
			OpenFuncUtil.OpenRecharge();
		});
		//穿戴
		this.btnVip.addClickEventListener(function()
		{
			//this._UseHandler();
			//Mgr.armor._RefreshGuangyuRes(this._currentModleId,Mgr.player.mainPlayer.sid); test code
			if(Mgr.armor.isOpen && !Mgr.armor.isOldedTime)
			{
				Mgr.armor.SendReqArmorChangeShowToGameMessage(this._currentModleId);
			}
			else
			{
				Mgr.tips.ShowNotice("请先激活光羽");
			}
		}.bind(this));
	},
	SetProperty:function()
	{
		var data = this._zanjiaTableData[this._index], name = "";
		if(!data){return;}
		for(var i = 0; i < data[1].length; i++ )
		{
			name += data[1].charAt(i) + "\n";
		}
		//if(data[3] != this._nResid)
		//{
		//	this._ShowModel();
		//}
		this.labName.SetString(name);
		if(this._showModelId == data[0])
		{
			this.btnVip.setTitleText("卸下");
			this._currentModleId = 0;
		}
		else
		{
			this.btnVip.setTitleText("穿戴");
			this._currentModleId = data[0];
		}
		this._SetData();
	},
	_SetData:function()
	{
		var str = Q_global.Get(1010).q_string_value;
		var proper = Q_global.Get(1011).q_string_value;
		proper=proper.substring(1,proper.length-1);
		var arr=proper.split(",");
		var attack = 0,defend = 0,hp = 0,a="1",b="2",c="7";
		for(var i = 0; i < arr.length; i++ )
		{
			var item = Q_item_simpact.Get(arr[i]);
			if(!item){return;}
			var attri = item.q_attribute.substring(1,item.q_attribute.length-2);
			var attb  = attri.split(":");
			if(attb[0] == a)
			{
				attack += Number(attb[1])*this._GetArmoredItems(arr[i]);
			}
			else if(attb[0] == b)
			{
				defend += Number(attb[1])*this._GetArmoredItems(arr[i]);
			}
			else if(attb[0] == c)
			{
				hp += Number(attb[1])*this._GetArmoredItems(arr[i]);
			}
		}
		str=str.substring(1,str.length-1);
		var array=str.split(",");
		for(var i=0;i<array.length;++i){
			array[i]=array[i].split(":");
			switch (array[i][0]){
				case a:
					attack += Number(array[i][1]);
					break;
				case b:
					defend += Number(array[i][1]);
					break;
				case c:
					hp += Number(array[i][1]);
					break;
			}
		}
		var str01 = Q_global.Get(35).q_string_value;
		var numb = 0;
		var array=str01.split(";");
		for(var i=0;i<array.length;++i){
			array[i]=array[i].split(",");
			switch (array[i][0]){
				case a:
					numb += attack*Number(array[i][1]);
					break;
				case b:
					numb += defend*Number(array[i][1]);
					break;
				case c:
					numb += hp*Number(array[i][1]);
					break;
			}
		}
		this.labAttack.SetString(attack);
		this.labDef.SetString(defend);
		this.labHp.SetString(hp);
		this.labNumber.SetString(numb);
		//item
		var backpackItemIds = Mgr.backpack.backpackVO.GetItemInfoHash().Values();
		var str = Q_global.Get(1011).q_string_value;
		str=str.substring(1,str.length-1);
		var array=str.split(",");
		this._cuilianItem = null;
		for(var i = 0; i < array.length; i++ )
		{
			var itemdata = ItemUtil.ItemIdToItem(array[i],0);
			var isMax = Mgr.armor.CheckIsMax(array[i]);
			for(var j = 0; j < backpackItemIds.length; j++)
			{
				if(array[i] == backpackItemIds[j].itemModelId)
				{
					var item = backpackItemIds[j];
					itemdata = ItemUtil.ItemIdToItem(item.itemModelId,item.itemNum,item.itemBind);
					break;
				}
			}
			if(isMax)
			{
				GridUtil.SetItemGrid( this._gridArr[i], itemdata, itemdata.itemModelId,itemdata.isbind, null, null, false);
				this._maxTagArr[i].visible = true;
			}
			else
			{
				if(itemdata.itemNum>0)
				{
					this._cuilianItem = itemdata;
				}
				GridUtil.SetItemGrid(this._gridArr[i],itemdata,itemdata.itemModelId,itemdata.isbind,null,null,null,null,true);
				this._maxTagArr[i].visible = false;
				var ishave = false;
				for(var k = 0; k < 3; k++){
					if(this.itemInfo[k] && this.itemInfo[k].id && this.itemInfo[k].id == itemdata.itemModelId){
                        this.itemInfo[k].num = itemdata.itemNum;
                        ishave = true;
                        break;
					}
				}
				if(!ishave)
                	this.itemInfo.push({id:itemdata.itemModelId, num:itemdata.itemNum});
			}
		}
	},
	_GetArmoredItems:function(itemModleId)
	{
		if(!this._zhanjiaData){return 0;}
		var limitNum = Q_item.Get(itemModleId).q_item_limit;
		var attList = this._zhanjiaData.attList;
		for(var i = 0; i < attList.length; i++)
		{
			if(attList[i] == itemModleId && attList[i+1] >= limitNum)
			{
				return limitNum;
			}
			if(attList[i] == itemModleId)
			{
				return attList[i+1];
			}
		}
		return 0;
	},
	_SetTime:function()
	{
		this.unschedule(this._SetCountdownTime);
		if(this._activateTime > 0 && !Mgr.armor.isOldedTime)
		{
			this._SetCountdownTime();
			this.schedule(this._SetCountdownTime,1);
			this.labCue3.SetString("VIP3即可永久获得光羽，激活炫酷外显及属性");
			this._ShowVipButton(true);
		}
		else if (this._activateTime == -1)
		{
			this.labCue3.SetString("淬炼光羽可大量提高角色属性");
			this._ShowVipButton(false);
			this.btnGo.visible = false;
		}
		else
		{
			Mgr.armor.isOpen = false;
			this.InitLabZhanjiaCue();
		}
	},
	_SetCountdownTime:function()
	{
		var time = Q_global.Get(1012).q_string_value;
		time=time.substring(1,time.length-1);
		var array=time.split(",");
		var serverTime = Mgr.login.GetServerTime()/1000;
		var cTime = (this._activateTime + Number(array[0])) - serverTime;
		if( cTime <= 0 )
		{
			Mgr.armor.isOpen = false;
			this._ShowVipButton(false);
			this.unschedule(this._SetCountdownTime);
		}
		var timeStr = TimeUtil.SecondToDHMS2(cTime);
		this.labTimeCue.SetString("过期倒计时："+timeStr);
	},
	PutOnData:function(data)
	{
		this._showModelId = data.showModelId;
		this.SetProperty();
	},
	SetZhanjiaData:function(data)
	{
		this._zhanjiaData = data;
		this._showModelId = data.showModelId;
		this._activateTime = data.activateTime;
		this.SetProperty();
		this._SetTime();
	},
	InitLabZhanjiaCue:function()
	{
		if(!Mgr.armor.isOpen)
		{
			this._ShowVipButton(false);
			this.labCue3.SetString("首冲即可获得光羽，激活炫酷外显及属性");
		}
		else
		{
			this._ShowVipButton(true);
			if(Mgr.armor.isOldedTime)
			{
				this.labCue3.SetString("VIP3即可永久获得光羽，激活炫酷外显及属性");
				this._ShowVipButton(false);
			}
		}
		this.SetProperty();
	},
	_ShowVipButton:function(isShow)
	{
		this.btnShuxing.visible = isShow;
		this.labTimeCue.visible = isShow;
		this.btnGo.visible = !isShow;
	},
	_JugementToolsEnough:function()
	{
		return Mgr.armor.JugementZhanjiaToolsEnough(this._maxTagArr);
	},
	OnShow:function()
	{
		Mgr.armor.SendReqArmorDataInfoToGameMessage();
		this.ShowGuangyuModule();
	},
	ShowGuangyuModule:function()
	{
		var data = this._zanjiaTableData[this._index];
		this._nResid = data[3];

		if( !this._uiModel ){
			this._uiModel = new UIModel(this._nResid, EnumResline.WING)
			this.imgModel.addChild(this._uiModel);
		}
		else{
			this._uiModel.SetModelId(this._reslineModelId);
		}
	},
	OnHide:function(){
		this._super();
		if( this._uiModel )
			this._uiModel.Dispose();
		this._uiModel = null;
	}
} );
ZhanjiaMainExt.PanelName = "ZhanjiaMainExt";
PanelClassDic["ZhanjiaMainExt"] = ZhanjiaMainExt;














