var QiridengluPanelExt = QiridengluPanel.extend ( {
	_className:"QiridengluPanelExt",

	_gridList:null,
	_gridArr:null,

	showReward:null,
	selectGrid:null,
	rewardMap:null,
	modelMap:null,
    landDay:0,

	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
		this.rewardMap = new HashMap();
		this.modelMap = new HashMap();
	},

	Init:function(){
        QiridengluPanel.prototype.Init.call(this);
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -28;

        this.gridCheck.visible = false;
        this.imgGet.visible = false;
        this.btnGet.visible = false;
        this.imgAwardA.visible = false;
        this.imgModel.visible = false;
        this.reorderChild(this.imgAward, 1);
        this.reorderChild(this.imgAward1, 1);
        this.reorderChild(this.imgAward2, 1);
        this.reorderChild(this.imgAward3, 1);
        this.reorderChild(this.imgAward4, 1);
        this.reorderChild(this.imgAward5, 1);
        this.reorderChild(this.imgAward6, 1);

        this.reorderChild(this.imgDayBg, 1);
        this.reorderChild(this.imgDayBg1, 1);
        this.reorderChild(this.imgDayBg11, 1);
        this.reorderChild(this.imgDayBg111, 1);
        this.reorderChild(this.imgDayBg1111, 1);
        this.reorderChild(this.imgDayBg11111, 1);
        this.reorderChild(this.imgDayBg111111, 1);

        this.reorderChild(this.imgModel, 1);
        // this.progJindutiao.setPercent(0);

        this._gridList = [this.grid1, this.grid2, this.grid3, this.grid4, this.grid5, this.grid6, this.grid7];
        this._gridArr = [
			{grid: this.grid1, id: 1, namelab: this.labItemName, day: 1, showId: 0},
			{grid: this.grid2, id: 2, namelab: this.labItemName1, day: 2, showId: 1116},
			{grid: this.grid3, id: 3, namelab: this.labItemName2, day: 3, showId: 0},
			{grid: this.grid4, id: 4, namelab: this.labItemName3, day: 4, showId: 0},
			{grid: this.grid5, id: 5, namelab: this.labItemName4, day: 5, showId: 1126},
			{grid: this.grid6, id: 6, namelab: this.labItemName5, day: 6, showId: 0},
			{grid: this.grid7, id: 7, namelab: this.labItemName6, day: 7, showId: 1129}
		];

		this.InitReward();

        self = this;
        this.btnClose.addClickEventListener(function(event){
        	EngineMgr.uiMgr.HidePanel(self);
		});

        this.btnGet.addClickEventListener(function(event){
        	if(self.selectGrid){
                var giftId = self.selectGrid.id;	// 七日登陆礼包ID
                var type = 0;						// 类型:0请求领取普通七日礼包,1请求领取登录器七日礼包
                Mgr.weal.SendReqGetLandRewardToGameMessage(giftId, type);
			}
		});

        for(var j = 0; j != this._gridArr.length; j++){
        	var grid = this._gridArr[j].grid;
            grid.isReceive = false;
            grid.id = this._gridArr[j].id;
            grid.day = this._gridArr[j].day;
        	grid.setTouchEnabled(true);
        	grid.addTouchEventListener(function(sender, type){
        		if(type == ccui.Widget.TOUCH_ENDED){
                    self._SetSelectEffect(sender, true);
        			self.ChangeGird(sender.id);
				}
			});
		}
        this._SetSelectEffect(this.grid1, true);
        // this.ChangeGird(1);
	},

	InitReward:function(){
		this.gridItem.visible = false;
		var posX = this.gridItem.x;
		var posY = this.gridItem.y;
		for(var i = 0; i != this._gridArr.length; i++){
			var grid = this._gridArr[i].grid;
			var node = new cc.Node();
            grid.reward = node;
			var rewardlist = JSON.parse(Q_seven_land.Get(i+1).q_reward);
            // node.x = this.imgModel1.width/2 - (rewardlist.length * this.gridItem.width + 10*(rewardlist.length - 1))/2;
            node.x = this.imgGridBg.x + this.imgGridBg.uiWidth/2 - rewardlist.length * this.gridItem.uiWidth/2 + this.gridItem.uiWidth/2;
            node.y = posY;

            grid.rewardInfo = Q_item.Get(rewardlist[0].mod);
            grid.modelId = rewardlist[0].mod;

            var modelType = grid.rewardInfo.q_type;
            // node.isShowModel = false;
            if(modelType == EnumResline.DISGUISE && this._gridArr[i].showId != 0){
                // node.isShowModel = true;
                // var resid = Q_resline.Get(rewardlist[0].mod).q_scene_show_id;
                // var url = this._getShowModeUrl(modelType, resid);
                var model = new MAnimationObject();
                model.sResUrlBase = "res/animation/effect/ui/roleshow/player/" + this._gridArr[i].showId.toString();
                model.DoAction("stand", 4);
                model.x = this.imgTj.x + this.imgTj.uiWidth/3;
                model.y = this.imgTj.y + this.imgTj.uiHeight/3;
                this.imgTj.addChild(model);
                this.modelMap.Put(this._gridArr[i].id, model);
                node.model = model;
			}

            // var icon = ItemUtil.GetItemIcon(rewardlist[0].mod);
            // icon.x = (grid.uiWidth - icon.width) / 2;
            // icon.y = (grid.uiHeight - icon.height) / 2;
            // grid.SetGridIcon(icon);

            var conItem = new TaskRewardsGridCon();
            node.addChild(conItem);
			for(var j = 0; j != rewardlist.length; j++){
				reward = rewardlist[j];
                if(reward.job && reward.job != Mgr.player.mainPlayer.job)
                    continue;
				var item = ItemUtil.ItemIdToItem(reward.mod, reward.num, reward.bind);
				conItem.AddComItem(item, this.gridItem);
			}
            conItem.Layout(this.gridItem.uiWidth*rewardlist.length, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight);
			node.visible = false;
            this.imgGridBg.addChild(node);
			this.rewardMap.Put(this._gridArr[i].id, node);
		}
	},

    _getShowModeUrl:function (type, resId) {
        var url = "res/animation/effect/ui/roleshow/part/";
        if(type == EnumResline.DISGUISE)
            url = "res/animation/effect/ui/roleshow/player/" + resId.toString();
        else if ( type == EnumResline.DRAGON )
            url += "dragon/" + resId.toString();
        return url;
    },


	ShowInfo:function(){
        if(!this.selectGrid.rewardInfo)
        	return;
        // UIUtil.ConnectLabelHtmlText(this.labDay,[this.selectGrid.day]);
        // UIUtil.ConnectLabelHtmlText(this.labCue1,[this.selectGrid.rewardInfo.q_append]);
        // UIUtil.ConnectLabelHtmlText(this.labCue2,[this.selectGrid.rewardInfo.q_name]);
        var url1 = "";
        var url2 = "";
        var url3 = "";
        switch(this.selectGrid.day){
            case 1:
                url1 = "other/qiredenglu/word/1.png";
                url2 = "other/qiredenglu/word/jinhang4.png";
                url3 = "other/qiredenglu/word/sqzyb.png";
                break;
            case 2:
                url1 = "other/qiredenglu/word/2.png";
                url2 = "other/qiredenglu/word/wuyou.png";
                url3 = "other/qiredenglu/word/sqzyb.png";
                break;
            case 3:
                url1 = "other/qiredenglu/word/3.png";
                url2 = "other/qiredenglu/word/jinhang2.png";
                url3 = "other/qiredenglu/word/sqzyb.png";
                break;
            case 4:
                url1 = "other/qiredenglu/word/4.png";
                url2 = "other/qiredenglu/word/jinhang3.png";
                url3 = "other/qiredenglu/word/sqzyb.png";
                break;
            case 5:
                url1 = "other/qiredenglu/word/5.png";
                url2 = "other/qiredenglu/word/feixue.png";
                url3 = "other/qiredenglu/word/sqzyb.png";
                break;
            case 6:
                url1 = "other/qiredenglu/word/6.png";
                url2 = "other/qiredenglu/word/jinhang.png";
                url3 = "other/qiredenglu/word/sqzyb.png";
                break;
            case 7:
                url1 = "other/qiredenglu/word/7.png";
                url2 = "other/qiredenglu/word/beiyao.png";
                url3 = "other/qiredenglu/word/sqzyb.png";
                break;
        }
        var self = this;
        EngineMgr.uiMgr.GetAsynResByUrl(url1, function () {
            self.imgNum.loadTexture(url1, ccui.Widget.PLIST_TEXTURE);
        }, self.imgNum);
        EngineMgr.uiMgr.GetAsynResByUrl(url3, function () {
            self.imgCue.loadTexture(url3, ccui.Widget.PLIST_TEXTURE);
        }, self.imgCue);
        EngineMgr.uiMgr.GetAsynResByUrl(url2, function () {
            self.imgCue2.loadTexture(url2, ccui.Widget.PLIST_TEXTURE);
        }, self.imgCue2);


	},

	SetData:function(landDay, giftIdlist){
		this.landDay = landDay;
        var length = 0;
        landDay > this._gridArr.length? length = this._gridArr.length : length = landDay;

        for(var j = 0; j != length; j++){
            var grid = this._gridArr[j].grid;
            this._SetWarm(grid);
            for(var i = 0; i != giftIdlist.length; i++){
                if(grid.id == giftIdlist[i]){
                    grid.isReceive = true;
                    this._SetMark(this._gridArr[j]);
                    this.IsShowBtn(grid.id);
                }
                // if(grid.isReceive){
                //     this.progJindutiao.setPercent(100 * (grid.id - 1)/6);
                // }
			}
        }
        for(var i = this._gridArr.length - 1 ; i >= 0; i--){
            var grid = this._gridArr[i].grid;
            if(!grid.isReceive){
                this._SetSelectEffect(grid, true);
                this.ChangeGird(grid.id);
            }
        }
	},

	GetGift:function(day){
		for(var i = this._gridArr.length - 1 ; i >= 0; i--){
			var grid = this._gridArr[i].grid;
			if(grid.id == day){
                this._SetMark(this._gridArr[i]);
                this.IsShowBtn(this.selectGrid.id);
			}
			else if(!grid.isReceive){
                this._SetSelectEffect(grid, true);
                this.ChangeGird(grid.id);
			}
		}
	},

	ChangeGird:function(id){
		if(this.showReward){
            this.showReward.visible = false;
            if(this.showReward.model)
            	this.showReward.model.visible = false;
        }
        this.showReward = this.rewardMap.Get(id);
        this.IsShowBtn(id);
        this.ShowModel(id);
        this.ShowInfo();
        this.ShowAction(this.showReward, cc.p(-100, 0), 0.3);
        this.ShowAction(this.imgDay, cc.p(-100, 0), 0.3);
        this.ShowAction(this.imgCue, cc.p(-100, 0), 0.3);
        this.ShowAction(this.imgCue2, cc.p(0, -50), 0.3);
		if(this.showReward){
            this.showReward.visible = true;
            if(this.showReward.model)
                this.showReward.model.visible = true;
		}
	},

	ShowModel:function(id){
		if(this.modelMap.Get(id)){
            this.imgTj.visible = true;
            this.imgModel1.x = this.width/3;
		}
		else{
            this.imgTj.visible = false;
            this.imgModel1.x = this.width/2 - this.imgModel1.width/2;
		}
	},

	ShowAction:function(node, pos, time){
		node.setOpacity(0);
		var sposX = node.x;
		var sposY = node.y;
		node.x = node.x + pos.x;
		node.y = node.y + pos.y;

		var moveTo = cc.moveTo(time, cc.p(sposX, sposY));
		var fadeIn = cc.fadeIn(time);
		var spawn = cc.Spawn(moveTo, fadeIn);
		node.runAction(spawn);
	},

	IsShowBtn:function(day){
        if(this.landDay >= day && !this.selectGrid.isReceive)
            this.btnGet.visible = true;
        else
            this.btnGet.visible = false;
	},

    _SetSelectEffect:function (grid, visible) {
        if(self.selectGrid &&  self.selectGrid.select)
            self.selectGrid.select.visible = false;
        if ( !grid.select ) {
            var icon = new MUIImage();
            icon.ParseJson(this.gridCheck.jsonobj);
            icon.Init();
            icon.setPosition(this.gridCheck.getPosition());
            grid.addChild(icon);
            grid.select = icon;
        }
        grid.reorderChild(grid.select, 0);
        grid.select.visible = visible;
        this.selectGrid = grid;
    },

	_SetMark:function(grid){
        if ( !grid.grid.mark ) {
            var icon = new MUIImage();
            icon.ParseJson(this.imgGet.jsonobj);
            icon.Init();
            icon.setPosition(this.imgGet.getPosition());
            grid.grid.addChild(icon);
            grid.grid.mark = icon;
        }
        grid.namelab.visible = false;
        grid.grid.reorderChild(grid.grid.mark, 5);
        grid.grid.isReceive = true;
        if(grid.grid.warm)
            grid.grid.warm.visible = false;
	},

	_SetWarm:function(grid){
		if(!grid.warm){
			var iconWarm = new MUIImage();
			iconWarm.ParseJson(this.imgAwardA.jsonobj);
            iconWarm.Init();
            iconWarm.setPosition(this.imgAwardA.getPosition());
			grid.addChild(iconWarm);
			grid.warm = iconWarm;
		}
		grid.reorderChild(grid.warm, 10);
        grid.warm.visible = true;
	},
} );
QiridengluPanelExt.PanelName = "QiridengluPanelExt";
PanelClassDic["QiridengluPanelExt"] = QiridengluPanelExt;
