var RedPacketMainExt = RedPacketMain.extend ( {
	_className:"RedPacketMainExt",

    listView:null,
	allGold:0,

	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
	},

	Init:function(){
        RedPacketMain.prototype.Init.call(this);
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -28;
        this.labGold1.SetHtmlText(this.allGold);
        this._CreateListView();
		var self = this;
		this.btnClose.addClickEventListener(function(event){
            EngineMgr.uiMgr.HidePanel(self);
		});
	},

    _CreateListView:function(){
        if(this.listView == null){
            var listView = new ccui.ListView();
            listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            listView.setTouchEnabled(true);					//触摸开启
            // listView.inertiaScrollEnabled = false; 			//滚动惯性
            listView.setScrollBarEnabled(false);				//滚动条
            listView.setBounceEnabled(true);					//边界回弹
            // listView.setScrollBarAutoHideTime(1);
            listView.setContentSize(cc.size(this.imgList.width, this.imgList.height));
            listView.setItemsMargin(4);
            this.imgList.addChild(listView);
            this.listView = listView;
        }
    },

	SetData:function(info){
        this.allGold = 0;
        this.InitListView(info);
        this.labGold1.SetHtmlText(this.allGold);
	},

    InitListView:function(info){
        var items = this.listView.getItems();
        for(var i = 0; i < items.length; i++){
            if(i<info.length){
                items[i].SetData(info[i]);
                // items[i].x = 0;
                // items[i].y = items[i].imgList.height*i;
                this.allGold += info[i].receiverNum;
            }
        }
        for(; i < info.length; i++){
            var item = new RedPacketListInfo1Ext();
            item.LoadPanel();
            item.SetData(info[i]);
            this.listView.pushBackCustomItem(item);
            // item.x = 0;
            // item.y = item.imgList.height*i;
            // this.listView.addChild(item);
            this.allGold += info[i].receiverNum;
        }
    },

	OnHide:function(){
        this._super();
        // this.listView.removeAllChildren(true);
        // if(this.listView){
        //     this.removeChild(this.listView);
        //     this.listView = null;
        // }
	},
} );
RedPacketMainExt.PanelName = "RedPacketMainExt";
PanelClassDic["RedPacketMainExt"] = RedPacketMainExt;
