var RedPacketPanelExt = RedPacketPanel.extend ( {
	_className:"RedPacketPanelExt",

    timeId:-1,
    _time:0,

	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
	},

    Init:function(){
        RedPacketPanel.prototype.Init.call(this);

        var self = this;
        this.btnClose.addClickEventListener(function(event){
            EngineMgr.uiMgr.HidePanel(self);
        });

        this.btnChai.addClickEventListener(function(event){
            // Mgr.redpacket.SendReqOpenRedPacketPanelMessage(self.uniqueId);
            Mgr.redpacket.SendReqGetRedPacketMessage(self.uniqueId);
            EngineMgr.uiMgr.HidePanel(self);
        });
    },

    SetData:function(info) {
        this.uniqueId = info.uniqueId;
        this.labCue.SetString(info.senderName);
        UIUtil.ConnectLabelHtmlText(this.labGold, [info.itemNum]);
        this._time = 15;
        TimerUtil.ClearTimeUpdate(this.timeId, this);
        this.timeId = TimerUtil.TimeUpdate(this.Update, this, 1);
    },

    Update:function(){
        this._time --;
        UIUtil.ConnectLabelHtmlText(this.labTime, [this._time]);
        if(this._time < 1){
            // Mgr.redpacket.SendReqOpenRedPacketPanelMessage(this.uniqueId);
            Mgr.redpacket.SendReqGetRedPacketMessage(this.uniqueId);
            EngineMgr.uiMgr.HidePanel(this);
        }
    },

    OnHide:function(){
        this._super();
        TimerUtil.ClearTimeUpdate(this.timeId, this);
        this.timeId = -1;
    },
} );
RedPacketPanelExt.PanelName = "RedPacketPanelExt";
PanelClassDic["RedPacketPanelExt"] = RedPacketPanelExt;
