﻿var ReceiveType = ReceiveType || {
    /**
     * 不能领取
     */
    CANT_RECEIVE:0,
    /**
     * 等待领取
     */
    WAIT_RECEIVE:1,
    /**
     * 已领取
     */
    BE_RECEIVE:2,

};



var SignModMgr = SignModMgr || cc.Class.extend({
	signInfo:null,
    signWarn:null,
	onlineTime:0,
	onlineinfos:null,

	timeId:0,

    _curTime:null,
    _passTime:null,
    _diff:null,

    _is_5_receive:ReceiveType.CANT_RECEIVE,
    _is_30_receive:ReceiveType.CANT_RECEIVE,
    _is_60_receive:ReceiveType.CANT_RECEIVE,
    _is_120_receive:ReceiveType.CANT_RECEIVE,
	_isReceive:null,

	signPanel:null,
	onLinePanel:null,

	ctor:function() {
        this.signInfo = {};
        // this._isReceive = [{time:300, type:ReceiveType.CANT_RECEIVE}, {time:1800, type:ReceiveType.CANT_RECEIVE},
        //     				{time:3600, type:ReceiveType.CANT_RECEIVE}, {time:7200, type:ReceiveType.CANT_RECEIVE}];
        // this._isReceive = new HashMap();
        // this._isReceive.Put(300, ReceiveType.CANT_RECEIVE);
        // this._isReceive.Put(1800, ReceiveType.CANT_RECEIVE);
        // this._isReceive.Put(3600, ReceiveType.CANT_RECEIVE);
        // this._isReceive.Put(7200, ReceiveType.CANT_RECEIVE);
	},

	RecvResSendSignInfoToClientMessage:function(msg) {
        var panel = Mgr.uiMgr.GetPanelByType( MiniMapPanelExt.PanelName );
	    if(!msg.isSign){
	        this.signWarn = true;
        }
        // else if(msg.rechargeSign != 1 && msg.signNum == 1 && Mgr.player.rechargeInfo && Mgr.player.rechargeInfo.day){
        //     this.signWarn = true;
        // }
        else{
            this.signWarn = false;
        }
        if (panel)
            panel.UpdataFuliWarn(FuliTypeEnum.TYPE_SIGN);
		this.signInfo.signNum = msg.signNum;
        this.signInfo.isSign = msg.isSign;
        this.signInfo.rechargeSign = msg.rechargeSign;
        this.signInfo.signSumAward = msg.signSumAward;
        this.signInfo.isRecharge = Mgr.player.rechargeInfo.day;


        if(this.signPanel)
        	this.signPanel.UpdateFrame(this.signInfo);
	},

	RecvResSendSignResultToClientMessage:function(msg) {
		cc.log("--------------RecvResSendSignResultToClientMessage------------");
	},

	RecvResSignSumAwardResultToClientMessage:function(msg) {	
	},

    RecvResSendRechargeSignInfoToClientMessage:function(msg){
        cc.log("收到充值签到消息！！！" + msg.mark + "  " + msg.allRechargeDays);
    },

	RecvResOnlineRewardsToClientMessage:function(msg) {
        this.onlineTime = msg.onlinetime;
        this.onlineinfos = msg.infos;
        if (this.onLinePanel)
            this.onLinePanel.SetData(msg.onlinetime, msg.infos);
        //更新领取状态
        this.CantReceive();
        this.UpdataOnlineWarn();
        if (this.onLinePanel)
            this.onLinePanel.RefrechTip();

        TimerUtil.ClearTimeUpdate(this.timeId, this);
        this._curTime = Mgr.login.GetServerTime();
        this._passTime = this._curTime;
        if (!(this._is_5_receive == ReceiveType.BE_RECEIVE && this._is_30_receive == ReceiveType.BE_RECEIVE &&
                this._is_60_receive == ReceiveType.BE_RECEIVE && this._is_120_receive == ReceiveType.BE_RECEIVE))
            this.timeId = TimerUtil.TimeUpdate(this.Updata, this, 1);
        else if (this.onLinePanel && this.onLinePanel.isOpen)
            this.timeId = TimerUtil.TimeUpdate(this.Updata, this, 1);
    },
    //add-12-12
    RecvResSendRechargeSignInfoToClientMessage:function (msg) {
        
    },

	Updata:function(){
        this._curTime = Mgr.login.GetServerTime();
        this.onlineTime += (this._curTime - this._passTime)/1000;
        this._passTime = this._curTime;


        if(this.onlineTime >=300 && this._is_5_receive == ReceiveType.CANT_RECEIVE){
            this._is_5_receive = ReceiveType.WAIT_RECEIVE;
            this.UpdataOnlineWarn();
            if (this.onLinePanel)
                this.onLinePanel.RefrechTip();
        }
        if(this.onlineTime >=1800 && this._is_30_receive == ReceiveType.CANT_RECEIVE){
            this._is_30_receive = ReceiveType.WAIT_RECEIVE;
            this.UpdataOnlineWarn();
            if (this.onLinePanel)
                this.onLinePanel.RefrechTip();
        }
        if(this.onlineTime >=3600 && this._is_60_receive == ReceiveType.CANT_RECEIVE){
            this._is_60_receive = ReceiveType.WAIT_RECEIVE;
            this.UpdataOnlineWarn();
            if (this.onLinePanel)
                this.onLinePanel.RefrechTip();
        }
        if(this.onlineTime >=7200 && this._is_120_receive == ReceiveType.CANT_RECEIVE){
            this._is_120_receive = ReceiveType.WAIT_RECEIVE;
            this.UpdataOnlineWarn();
            if (this.onLinePanel)
                this.onLinePanel.RefrechTip();
        }

        if(this._is_5_receive == ReceiveType.WAIT_RECEIVE || this._is_30_receive == ReceiveType.WAIT_RECEIVE ||
            this._is_60_receive == ReceiveType.WAIT_RECEIVE || this._is_120_receive == ReceiveType.WAIT_RECEIVE){
            if(this.onLinePanel == null)
                TimerUtil.ClearTimeUpdate(this.timeId,this);
            if(this.onLinePanel&&!this.onLinePanel.isOpen)
                TimerUtil.ClearTimeUpdate(this.timeId,this);
        }

        if(this.onLinePanel)
        	this.onLinePanel.Update(this.onlineTime);
	},

    UpdataOnlineWarn:function(){
        var panel = Mgr.uiMgr.GetPanelByType( MiniMapPanelExt.PanelName );
        if ( panel )
            panel.UpdataFuliWarn(FuliTypeEnum.TYPE_ONLINE);
    },

	CantReceive:function(){
        this._is_5_receive = ReceiveType.CANT_RECEIVE;
        this._is_30_receive = ReceiveType.CANT_RECEIVE;
        this._is_60_receive = ReceiveType.CANT_RECEIVE;
        this._is_120_receive = ReceiveType.CANT_RECEIVE;
        for(var i = 0;i!= this.onlineinfos.length; i++){
            switch(this.onlineinfos[i].timetype){
                case 300:
                	this._is_5_receive = ReceiveType.BE_RECEIVE;
                    break;
                case 1800:
                    this._is_30_receive = ReceiveType.BE_RECEIVE;
                    break;
                case 3600:
                    this._is_60_receive = ReceiveType.BE_RECEIVE;
                    break;
                case 7200:
                    this._is_120_receive = ReceiveType.BE_RECEIVE;
                    break;
                default:
                    break;
            }
		}
        if(this.onlineTime >=300 && this._is_5_receive == ReceiveType.CANT_RECEIVE)
            this._is_5_receive = ReceiveType.WAIT_RECEIVE;
        if(this.onlineTime >=1800 && this._is_30_receive == ReceiveType.CANT_RECEIVE)
            this._is_30_receive = ReceiveType.WAIT_RECEIVE;
        if(this.onlineTime >=3600 && this._is_60_receive == ReceiveType.CANT_RECEIVE)
            this._is_60_receive = ReceiveType.WAIT_RECEIVE;
        if(this.onlineTime >=7200 && this._is_120_receive == ReceiveType.CANT_RECEIVE)
            this._is_120_receive = ReceiveType.WAIT_RECEIVE;
	},

	IsShowOnLineWarn:function(){
		if(this._is_5_receive == ReceiveType.WAIT_RECEIVE || this._is_30_receive == ReceiveType.WAIT_RECEIVE ||
			this._is_60_receive == ReceiveType.WAIT_RECEIVE ||this._is_120_receive == ReceiveType.WAIT_RECEIVE)
			return true;
		return false;
	},

	RecvResExtractRewardToClientMessage:function(msg) {
        // if(this.onLinePanel)
        // 	this.onLinePanel.PrintResInfos(msg.infos);
        //
        this.SendReqOpenOnlineRewardsToGameMessage();
	},

	SendReqSignInfoToGameMessage:function(type) {
	    type = undefined ? 0 : type;
	    var msg = new ReqSignInfoToGameMessage();
	    msg.type = type;
        Mgr.msgMgr.Send(msg);
	},

	SendReqSignToGameMessage:function(type, signNum) {
        var msg = new ReqSignToGameMessage();
        msg.type = type;
        msg.signNum = signNum;
        Mgr.msgMgr.Send(msg);
	},

	SendReqSignAddToGameMessage:function(msg) {	
	},

	SendReqSignSumAwardToGameMessage:function(msg) {	
	},

    SendRechargeSignToGameMessage:function(signDay){
	    var msg = new ReqRechargeSignToGameMessage();
	    msg.signDay = signDay;
	    Mgr.msgMgr.Send(msg);
    },

	SendReqGetOnlineRewardsToGameMessage:function(time) {
	    cc.log("======SendReqGetOnlineRewardsToGameMessage=====" + time)
        var msg = new ReqGetOnlineRewardsToGameMessage(time) ;
	    msg.time = time;
        Mgr.msgMgr.Send(msg);
	},

	SendReqOpenOnlineRewardsToGameMessage:function() {
        Mgr.msgMgr.Send(new ReqOpenOnlineRewardsToGameMessage());
	}
});