var ShichangMainExt = ShichangMain.extend ( {
	_className:"ShichangMainExt",
	menuList:null,
	menuPanel:null,
	centorScrpan:null,
	menuH:82,
	cNum:-1,
	minMenuList:null,                     //储存所有的子按钮
	usMinMenu:null,                      //当前用到的子按钮
	ctor:function(){
		this._super();
	},
	Init:function(){
		ShichangMain.prototype.Init.call( this );
		this.usMinMenu=[];
		this.minMenuList=[];

		this.editTxt.setPlaceHolder("输入物品名字");
		this.editTxt.setPlaceholderFontColor(UIUtil.GetCCColor(0xac8557));
		this.editTxt.setTextColor(UIUtil.GetCCColor(0x3a2707));

		//这里 自己加个容器
		var tableView = new cc.TableView(this,cc.size(792, 375));

		tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
		tableView.setDelegate(this);
		tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
		tableView.y=8;
		tableView.x=15;
		this.imgBg.addChild(tableView);
		tableView.reloadData();
		tableView.setBounceable(false);
		this.centorScrpan=tableView;
		//加两个阻挡的控件吞噬事件
        this.imgTitle.setTouchEnabled(true);
        this.imgTitle.setSwallowTouches(true);
        this.imgSwallow.setTouchEnabled(true);
        this.imgSwallow.setSwallowTouches(true);
		//还有个按钮的面板
		this.menuPanel= new ccui.ScrollView();
		this.menuPanel.setSize(235,445);
		this.menuPanel.setScrollBarEnabled(false);
		this.menuPanel.setBounceEnabled(false);
		this.menuPanel.x=-250;
		this.imgBg.addChild(this.menuPanel);

		this.sbtnEquip.visible = false;
		this.sbtnGem.visible = false;
		this.sbtnCailiao.visible = false;
		this.sbtnQita.visible = false;

		this.menuList = new Array();
		for(var i=0; i<StallUtil.MENU_TYPE_ARR.length; i++){
			var button = this.sbtnEquip.clone();
			button.labEquip.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
			button.labEquip.SetText(StallUtil.MENU_TEXT_ARR[i]);
			button.imgTag.visible = false;
			this.menuList[i] = button;
		}
		//this.menuList=[this.sbtnEquip,this.sbtnGem,this.sbtnCailiao,this.sbtnQita];
		for(var i=0;i<this.menuList.length;++i){
			//先装到容器里面
			this.menuList[i].retain();
			this.removeChild(this.menuList[i]);
			this.menuPanel.addChild(this.menuList[i]);
			this.menuList[i].y=365-i*this.menuH;
			this.menuList[i].x=0;
			this.menuList[i].release();
			this._InitMenuFunc(i);
		}
		var self=this;
		this.sbtnPaixu.addClickEventListener(function(target){
			var state=false;
			if(target.GetState()=="uncheck")
			state=true;
			StallUtil.SortByPrice(1,state);
		});
		this.sbtnPaixu1.addClickEventListener(function(target){
			var state=false;
			if(target.GetState()=="uncheck")
				state=true;
			StallUtil.SortByPrice(0,state);
		});
		this.btnGo.addClickEventListener(function(){
			var str=self.editTxt.getString();
			if(str==""){
                Mgr.tips.ShowNotice("请输入正确的物品名字");
                return;
			}
			Mgr.stall.SendReqStallSearchMessage(str);
		});
	},
	SetData:function(infoList){
		var money=Mgr.player.mainPlayer.attributeData.gold;
		if(money>100000)
		money=Math.floor(money/10000)+"万";
		this.labMoney.SetString(money);
		Mgr.stall.findGoodsList=infoList;
		if(infoList.length>0)
			this.labCue1.setVisible(false);
		else
			this.labCue1.setVisible(true);
		this.centorScrpan.reloadData();
	},
	_InitMenuFunc:function(i){
		var self=this;
		this.menuList[i].addClickEventListener(function(target){
			cc.log(i);
			self.ChangeMenu(i);
		});
	},
	ChangeMin:function(){
		for(var i=0;i<this.usMinMenu.length;++i){
			this.usMinMenu[i].SetState(false);
		}
	},
    SetText:function (index) {
		if(index==2){
            this.labCue1.SetString("暂无物品出售");
            this.labCue1.x=343;
		}else {
            this.labCue1.SetString("暂时没有搜索到你想要的道具");
            this.labCue1.x=243;
		}
    },

	ChangeMenu:function(idx){
		var type=StallUtil.GetMainType(idx);
        this.menuList[idx].SetButtonState("check",true);
		//移掉原来的小按钮
		for(var i=0;i<this.usMinMenu.length;++i){
			this.usMinMenu[i].removeFromParent();
		}
		this.menuPanel.setInnerContainerSize(cc.size(235,445));
		for(var i=0;i<this.menuList.length;++i){
			this.menuList[i].y=365-i*this.menuH;
		}
		this.usMinMenu=[];
		if(this.cNum!=idx) {
			this.cNum = idx;
			this.imgTag.retain();
			this.imgTag.removeFromParent();
			this.imgTag.x = 166;
			this.imgTag.y = 30;
			this.menuList[idx].addChild(this.imgTag);
			this.imgTag.release();
			if(StallUtil.MAX_TYPE_ARR[idx]){
                Mgr.stall.SendReqStallGoodsOpenMessage(StallUtil.MAX_TYPE_ARR[idx], type[0][0]);
			}else {
                Mgr.stall.SendReqStallGoodsOpenMessage(type[0][0]);
			}
			if (type[0]) {
                this.imgTag.setVisible(true);
				var menu = this.menuList[idx];
				for (var i = 0; i < type[0].length; i++) {
					if (!this.minMenuList[i]) {
						this.minMenuList[i] = new TaenWeiItemListExt();
						this.minMenuList[i].LoadPanel();
						this.minMenuList[i].retain();
					}
					this.minMenuList[i].y = -(i + 1) * 84;
					this.minMenuList[i].x = 15;
					menu.addChild(this.minMenuList[i]);
					var infor;
                    if(StallUtil.MAX_TYPE_ARR[idx]){
                    	infor = [StallUtil.MAX_TYPE_ARR[idx],type[0][i]];
                    }else {
                        infor = [type[0][i]];
                    }
					this.minMenuList[i].SetInfor(infor, type[1][i]);
					this.usMinMenu[i] = this.minMenuList[i];
				}
				for (var i = idx + 1; i < this.menuList.length; ++i) {
					this.menuList[i].y -= type[0].length * 84;
				}
			}else {
                this.imgTag.setVisible(false);
			}
			this.ChangeMin();
			if (this.usMinMenu[0]) {
				this.usMinMenu[0].SetState(true);
			}
		}
		else {
			this.cNum=-1;
            //改变箭头方向
		}
		//设置滚动视图
		var menuCountH=this.menuH*this.menuList.length+84*this.usMinMenu.length;
		if(menuCountH<445) menuCountH=445;
		var dif=menuCountH-this.menuPanel.getInnerContainerSize().height;
		this.menuPanel.setInnerContainerSize(cc.size(235,menuCountH));
		for(var i=0;i<this.menuList.length;++i){
			this.menuList[i].y+=dif;
		}

	},
	tableCellTouched: function (table, cell) {
		cc.log("touch");
	},

	tableCellSizeForIndex: function (table, idx) {
		return cc.size(787,118);
	},
	tableCellAtIndex: function (table, idx) {
		var cell = table.dequeueCell();
		if (!cell) {
			cell=cc.Sprite();
			var item=new ShichangListExt();
			item.LoadPanel();
			item.SetData(Mgr.stall.findGoodsList[idx]);
			cell.item=item;
			cell.addChild(item);
		} else {
			cell.item.SetData(Mgr.stall.findGoodsList[idx]);
		}
		return cell;
	},
	numberOfCellsInTableView: function (table) {
		return Mgr.stall.findGoodsList?Mgr.stall.findGoodsList.length:0;
	}
} );
ShichangMainExt.PanelName = "ShichangMainExt";
PanelClassDic["ShichangMainExt"] = ShichangMainExt;
