var TaskInfoItemExt = TaskInfoItem.extend ( {
	_className:"TaskInfoItemExt",
	data:null,
	_isNextTask:false,
	_detailInfo:null,
	_taskState:null,
	ctor:function(data,isnexttask){
		this._super();
		this.data = data;
		this._isNextTask = isnexttask;
		this._detailInfo = Q_mission_base.Get( data.taskModelId );
	},
	Init:function()
	{
		TaskInfoItem.prototype.Init.call(this);

        this.imgWancheng.visible = false;
		this.setContentSize(this.width,this.height+2);
		this._SetInformation();
		this.setTouchEnabled(true);
		this.addTouchEventListener(function(target,state)
		{
			switch( state ){
				case ccui.Widget.TOUCH_BEGAN:
					this.imgXuanzhong.visible = true;
					break;
				case ccui.Widget.TOUCH_ENDED:
					if(this._taskState == EnumTaskState.STATE_UNSUBMIT && this._detailInfo.q_mission_mainType != EnumTaskType.TYPE_MAIN
					&& this._detailInfo.q_mission_mainType != EnumTaskType.TYPE_DAY && this._detailInfo.q_mission_mainType != EnumTaskType.TYPE_GUILD
						&& this._detailInfo.q_mission_mainType != EnumTaskType.CONQUER){
						Mgr.task.SendReqfinishTaskMessage(this.data.taskModelId);
					}
					else if( this._isNextTask ){
						this._StartGuaji();
					}
					else{
						this._HandleButtonEvent();
					}
					Mgr.player.ShowShortChatState();
				case ccui.Widget.TOUCH_CANCELED:
					this.imgXuanzhong.visible = false;
					break;
			}
		}.bind(this));
		this.imgXuanzhong.visible = false;
	},
	_HandleButtonEvent:function()
	{
		this._HandleCurrentTask();
	},
	UpdateData:function(data,isnexttask)
	{
		this._isNextTask = isnexttask;
		this.data = data;
		this._detailInfo = Q_mission_base.Get( data.taskModelId );
		this._SetInformation();
	},
	_SetInformation:function()
	{
        this._taskState = TaskUtil.CheckTaskComplate(this.data.taskModelId, this.data);

        this.imgWancheng.visible = false;
		var taskData = this._detailInfo,str = "",bostr = "";
		var descStr = this._detailInfo.q_finish_describe.replace(/：/g,"");
		if( taskData.q_mission_type == NpcSubTaskType.TASK_MONSTER || taskData.q_mission_type == NpcSubTaskType.TASK_COLLECT_PROPS ){
			//任务进度
			var rate = TaskUtil.GetTaskComplate(this.data.taskModelId, this.data);
			if (rate && rate.length > 0)
			{
				var descArr = descStr.split(";");
				for( var i = 0; i < rate.length; i++ ){
					var subrate = rate[i];
					descStr = descArr[i];
					// str = "(" + subrate[0] + "/" + subrate[1] + ")";
					str = TextUtil.AddColor("(" + subrate[0] + "/" + subrate[1] + ")", "76fd56");
					if( subrate[0] < subrate[1] ){
						break;		//显示最后一个未完成的条件
					}
				}
			}
		}
		if(this._detailInfo.q_completions>0)
		{
			bostr = TextUtil.AddColor("(" + 0 + "/" + this._detailInfo.q_completions + ")", "0xf2a757");
			if(this._detailInfo.q_mission_mainType == EnumTaskType.TYPE_GUILD)
			{
				bostr = TextUtil.AddColor("(" + ( Mgr.task.guildTaskTimes ) + "/" + this._detailInfo.q_completions + ")", "0xf2a757");
			}
			else if(this._detailInfo.q_mission_mainType == EnumTaskType.TYPE_DAY)
			{
				bostr = TextUtil.AddColor("(" + ( Mgr.task.dailyTaskTimes ) + "/" + this._detailInfo.q_completions + ")", "0xf2a757");
			}
			else if(this._detailInfo.q_mission_mainType == EnumTaskType.CONQUER){
                bostr = TextUtil.AddColor("(" + ( Mgr.task.rewardTaskTimes ) + "/" + this._detailInfo.q_completions + ")", "0xf2a757");
			}
		}

        if(taskData.q_mission_mainType == EnumTaskType.TYPE_MAIN){
			if(taskData.q_mission_type == NpcSubTaskType.TASK_TALK){
                this.labDesc.SetString("交谈:" + descStr + str);
			}
			else if(taskData.q_mission_type == NpcSubTaskType.TASK_MONSTER){
                this.labDesc.SetString("挑战:" + "<u>" + descStr + str + "</u>");
			}
			else if(taskData.q_mission_type == NpcSubTaskType.TASK_COLLECT_PROPS){
                this.labDesc.SetString("采集:" + descStr + str);
			}
			else
            	this.labDesc.SetString(descStr+str);
		}
		else if(str == ""){
            if(this._taskState == EnumTaskState.STATE_UNSUBMIT)
                this.labDesc.SetString("挑战:" + descStr + TextUtil.AddColor("(" + 1 + "/" + 1 + ")", "76fd56"));
            else
                this.labDesc.SetString("挑战:" + descStr + TextUtil.AddColor("(" + 0 + "/" + 1 + ")", "76fd56"));
		}
		else{
            this.labDesc.SetString("击杀:" + "<u>" + TextUtil.AddColor(TextUtil.RemoveHTMLTag(descStr)+str, "76fd56") + "</u>");
		}
		if(this._isNextTask)
		{
			var gj = TextUtil.AddColor("(前往挂机)", "76fd56");
			this.labDesc.SetString(this._detailInfo.q_needLevel+"级可接任务"+gj);
		}
		if(taskData.q_mission_mainType == EnumTaskType.TYPE_MAIN)
		{
			this.labTitle.SetString(TextUtil.AddColor("[主] " + this._detailInfo.q_name, "0xf2a757")+ bostr);
		}
		else{
            var titleStr = "", strName = "";
            if(this._detailInfo.q_mission_id > 60000 && this._detailInfo.q_mission_id < 61000)
            	str = "进阶副本";
            else if(this._detailInfo.q_mission_id > 61000 && this._detailInfo.q_mission_id < 62000)
                str = "剧情副本";
            else if(this._detailInfo.q_mission_id > 62000 && this._detailInfo.q_mission_id < 63000)
                str = "经验副本";
            else if(this._detailInfo.q_mission_id > 63000 && this._detailInfo.q_mission_id < 64000)
                str = "问鼎江湖";
			if(taskData.q_mission_mainType == EnumTaskType.TYPE_BRANCH){
                titleStr = TextUtil.AddColor("[支] "+ str, "ffed88");
                if(this._taskState == EnumTaskState.STATE_UNSUBMIT){
                    // this.labTitle.SetString(titleStr + TextUtil.AddColor("(已完成)", "76fd56"));
                    this.labTitle.SetString(titleStr);
                    this.imgWancheng.visible = true;
                }
                else{
                    this.labTitle.SetString(titleStr + TextUtil.AddColor("(未完成)", "fe2323"));
                    this.imgWancheng.visible = false;
                }
			}
			// else if(taskData.q_mission_mainType == EnumTaskType.TYPE_DAY)
             //    titleStr = TextUtil.AddColor("[日] "+ str, "ffed88");
			// else if(taskData.q_mission_mainType == EnumTaskType.TYPE_GUILD)
             //    titleStr = TextUtil.AddColor("[帮] "+ str, "ffed88");
			else{
                titleStr = TextUtil.AddColor(this._detailInfo.q_name+bostr, "ffed88");
                this.labTitle.SetString(titleStr);
			}
		}
	},
	_SetNextTaskShow:function()
	{

	},
	_HandleCurrentTask:function()
	{
        var type = this._detailInfo.q_mission_mainType;
        switch(type){
            case EnumTaskType.CONQUER:
                TaskUtil.ShowConquerMissionPanel(this.data);
                break;
            default:
                Mgr.task.AutoTask(this.data.taskModelId);
                break;
        }
	},
	_StartGuaji:function()
	{
		var pLevel = Mgr.player.mainPlayer.attributeData.GetAttribute( EnumBaseAttribute.LEVEL , AttributeData.Base );
		var gjData = Q_target.Get( pLevel );
		if ( !gjData )
		{
			var list = Q_target.GetList();
			gjData = list[list.length - 1];
		}
		var points = JSON.parse( gjData.q_target );
		var pos = cc.p(points[0][0],points[0][1]);
		Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(gjData.q_mapid, pos, AutoPathParam.CreateAutoFight(), null, true);	//   taskPath == null 不会走传送 所以传个 "" 过去
	},
} );
TaskInfoItemExt.PanelName = "TaskInfoItemExt";
PanelClassDic["TaskInfoItemExt"] = TaskInfoItemExt;

var TaskInfoItemExtClientOnly = TaskInfoItem.extend({
    _className: "TaskInfoItemExtClientOnly",
    data: null,
    ctor: function(data) {
        this._super();

        this.data = data;
    },
    Init: function() {
        TaskInfoItem.prototype.Init.call(this);

        this.height += 2

        this._SetInformation();

        this.setTouchEnabled(true);
        this.addTouchEventListener(this._OnTouched);
		this.imgXuanzhong.visible = false;
    },

    UpdateData:function(data){
        this.data = data.taskInfo;
        this._SetInformation();
    },

    _OnTouched:function(target,state){
		switch( state ){
			case ccui.Widget.TOUCH_BEGAN:
				this.imgXuanzhong.visible = true;
				break;
			case ccui.Widget.TOUCH_ENDED:
				var taskData = this.data;
				switch(taskData.q_mission_mainType){
					case EnumTaskType.CLIENT_CONVOY:
						Mgr.convoy.ContinueConvoy();
						Mgr.player.ShowShortChatState();
						break;
					default:
						break;
				}
			case ccui.Widget.TOUCH_CANCELED:
				this.imgXuanzhong.visible = false;
				break;
		}
    },

    _SetInformation:function(){
        var taskData = this.data;
        switch(taskData.q_mission_mainType){
            case EnumTaskType.CLIENT_CONVOY:
                this.labTitle.SetString(taskData.title);
                this.labDesc.SetString(taskData.des);
                this.imgWancheng.visible = false;
                break;
            default:
                this.labTitle.SetString(taskData.title || "【奇怪的标记】");
                this.labDesc.SetString(taskData.des || "奇怪的描述");
                break;
        }
    },
});

TaskInfoItemExtClientOnly.PanelName = "TaskInfoItemExtClientOnly";
PanelClassDic["TaskInfoItemExtClientOnly"] = TaskInfoItemExtClientOnly;