var TaskNpcTalkMainExt = TaskNpcTalkMain.extend ( {
	_className:"TaskNpcTalkMainExt",
	_autoTimeId:-1,
	_time:0,
	gridList:null,
	_taskData:null,
	_npcId:-1,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_L;
		Mgr.npc.SetNpcPanel(this);
	},
	Init:function()
	{
		TaskNpcTalkMain.prototype.Init.call( this );
		this.gridList=[this.gridItem,this.gridItem1,this.gridItem2];
        this.gridItem.setTouchEnabled(true);
        this.gridItem1.setTouchEnabled(true);
        this.gridItem2.setTouchEnabled(true);

		this.labCue.SetLeading(7);
		
		this.labJiangli.SetString("奖励");
		var self=this;
		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanelByType( TaskNpcTalkMainExt.PanelName );
		});

		this.btnGet.addClickEventListener(function () {
            self._time = 0;
			self.OnGetHandler();
		});
	},
	SetData:function (npcData,taskData) {
		this._taskData = taskData;
		if(npcData)
		{
			this._npcId = npcData.q_id;
		}
		this.labName.SetString(npcData.q_name);
		this.imgBg.setVisible(false);
        this.imgDi.setVisible(true);
		this.imgDikuang1.setVisible(false);
		if(taskData){
			this.labTitle.setVisible(true);
			this.labTitle.SetString(taskData.q_name);

			if( taskData.q_deal_mission ){
				var seg = Q_mission_segment.Get(taskData.q_deal_mission);
				if( seg ){
					this.labCue.SetString( seg.q_npcTalk_information );
				}
			}
			else{
				this.labCue.SetString(taskData.q_describe);
			}

			var status = Mgr.task.GetTaskState(taskData.q_mission_id);
			if (status == EnumTaskState.STATE_UNGET){
				this.btnGet.setTitleText("接受");
			}
			else if (status == EnumTaskState.STATE_UNSUBMIT) {
				this.btnGet.setTitleText("领取奖励");
			}
			else{
                this.btnGet.setTitleText("确定");
			}

			//15秒后自动执行任务
			// this._autoTimeId = TimerUtil.SetTimeout(this, this.OnGetHandler, 15000);
			this._time = 15;
			UIUtil.ConnectLabelHtmlText(this.labTimeCue,[TimeUtil.SecondToDHMS2(this._time)]);
            if(this._autoTimeId != -1){
                TimerUtil.ClearTimeUpdate(this._autoTimeId, this);
                this._autoTimeId = -1;
			}
            this._autoTimeId = TimerUtil.TimeUpdate(this.OnGetHandler, this, 1);
			var info=Q_mission_reword.Get(taskData.q_reword_id);
			if(info){
				this.imgBg.setVisible(true);
				this.imgDikuang1.setVisible(true);
				this.ShowReword(info.q_reward);
			}
		}else {
			this.labCue.SetString(npcData.q_dialog);
			this.labTitle.setVisible(false);
			this.imgDi.setVisible(false);
            this.btnGet.setTitleText("确定");

            /// 不知道写哪儿了，如果是护送第二个NPC
            var data  = JSON.parse(Q_global.Get(1113).q_string_value);
            if(this._npcId == data[2] && Mgr.convoy.isHuSong){
                var result = Mgr.convoy.GetThisTimeConvoyReward();

                var reward = [];
                reward.push({ mod:-3,num:result.exp});
                reward.push({ mod:-5,num:result.gold});

                this.imgBg.setVisible(true);
                this.imgDikuang1.setVisible(true);
                this.ShowReword(JSON.stringify(reward));

                this.btnGet.setTitleText("领取奖励");
            }
		}
	},

	OnGetHandler:function(){
		this._time--;
		var panel = Mgr.uiMgr.GetPanelByType(TaskNpcTalkMainExt.PanelName);
		UIUtil.ConnectLabelHtmlText(this.labTimeCue,[TimeUtil.SecondToDHMS2(this._time)]);
		var data  = JSON.parse(Q_global.Get(1113).q_string_value);
		if(this._npcId == data[2])
		{
			Mgr.convoy.SendReqConvoyOpenMidToGameMessage(2);
		}
		if(this._time < 1){
            if( this._taskData){
                var id = this._taskData.q_mission_id;
                var status = Mgr.task.GetTaskState(id);
                if (status == EnumTaskState.STATE_UNGET)
                    Mgr.task.SendReqAcceptTaskMessage(id);
                else if (status == EnumTaskState.STATE_UNSUBMIT) {
                    Mgr.task.SendReqfinishTaskMessage(id);
                }
            }
            EngineMgr.uiMgr.HidePanelByType( TaskNpcTalkMainExt.PanelName );
		}
	},

	ShowReword:function(date){
		var array = JSON.parse( date );
		var idx=0;
		for(var i=0;i<3;++i){
           this.gridList[i].setVisible(false);
		}
		if(array.length == 1)
		{
			idx = 1;
		}
		for(var i=0;i<array.length;++i){
			if(array[i].job?(array[i].job==Mgr.player.mainPlayer.job):true){
				var grid= this.gridList[idx];
				if(!grid){
					return;          //就只显示三个
				}
                grid.setVisible(true);
				var data01 = ItemUtil.ItemIdToItem(array[i].mod,array[i].num);
				GridUtil.SetItemGrid(grid,data01,null,null,null,null,true);

                //var icon = ItemUtil.GetItemIcon(array[i].mod , ResUrl.ICON_TYPE_ITEM );
                //icon.x = (grid.uiWidth - icon.width) / 2;
                //icon.y = (grid.uiHeight - icon.height) / 2;
				//grid.SetGridIcon( icon );
				//var mod=array[i].mod;
				//grid.addClickEventListener(function () {
				//    Mgr.uiMgr.ShowPanelByType(ItemTipsExt.PanelName, UIMgr.PANEL_LAYER_POP);
				//    Mgr.tips.normalTip.ShowModel(mod);
				//});
				idx++;
			}
		}
	},

	OnHide:function(){
		this._super();
        TimerUtil.ClearTimeUpdate(this._autoTimeId, this);
        this._autoTimeId = -1;
	},
} );
TaskNpcTalkMainExt.PanelName = "TaskNpcTalkMainExt";
PanelClassDic["TaskNpcTalkMainExt"] = TaskNpcTalkMainExt;
