var TeamHeadpanelExt = TeamHeadpanel.extend ( {
	_className:"TeamHeadpanelExt",
	playerId:null,
	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		TeamHeadpanel.prototype.Init.call(this);
		this.imgMan.visible = false;
		this.imgWoman.visible = false;
		this.SetSelected(false);
		this.setTouchEnabled(true);
		this.setSwallowTouches(true);
		this.addTouchEventListener(function(target,state)
		{
			if(state == ccui.Widget.TOUCH_ENDED)
			{
				self.HandleSelfTouchEvent(state);
			}
		});
	},

	SetData:function (info)
	{
		var isLeader = info.memberId.Equal( Mgr.team.leaderId );
		this.playerId = info.memberId;
		this.imgFlag.visible = isLeader;
		this.labName.SetString(info.memberName);
		this.labLv.SetString(info.memberLevel);
		this.labLv.x = this.imgYuan1.x +(this.imgYuan1.width-this.labLv.width)/2;
		// sex
		var job = info.appearanceInfo.job;
		if ( job == 1 )
			this.imgMan.visible = true;
		else if ( job == 2 )
			this.imgWoman.visible = true;
	},
	RefreshPlayerInformation:function(data,index,dataRe)
	{
		this.playerId = dataRe.memberId;
		this.labName.SetString(dataRe.name);
		this.labLv.SetString(dataRe.level);
		this.labLv.x = this.imgYuan1.x +(this.imgYuan1.width-this.labLv.width)/2;
		this._SetHpPercent(data.nCurHp,data.nMaxHp);
		this.imgFlag.visible = false;
		this.imgMan.visible = false;
		this.imgWoman.visible = false;
		var job = data.nJobId;
		if ( job == 1 )
		{
			this.imgMan.visible = true;
		}
		else if( job == 2 )
		{
			this.imgWoman.visible = true;
		}
		if(index == EnumCrossteamType.TEAM_CAPTAIN)
		{
			this.imgFlag.visible = true;
		}
	},
	_SetHpPercent:function(cHp,mHp)
	{
		if(mHp != 0)
		{
			this.progHp.setPercent(cHp/mHp*100);
		}
	},
	HandleSelfTouchEvent:function()
	{
		var list = Mgr.task._taskTrackPanel.imgHeadBg.getChildren();
		for(var i = 0; i <list.length; i++ )
		{
			var name = list[i].labName.GetString();
			if(name == this.labName.GetString())
			{
				list[i].SetSelected(true);
			}
			else
			{
				list[i].SetSelected(false);
			}
		}
		if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_LFDR||Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_KFDR)
		{
			return;
		}
		if(this.playerId.Equal(Mgr.player.mainPlayer.sid))
		{
			return;
		}
		var isLeader = Mgr.team.leaderId.Equal(Mgr.player.mainPlayer.sid)
		EngineMgr.uiMgr.ShowPanelByType(TeamTuchInfoExt.PanelName,UIMgr.PANEL_LAYER_TOP);
		var pos = this.getWorldPosition();
		Mgr.uiMgr.GetPanelByType(TeamTuchInfoExt.PanelName).ShowPanelByPos(pos,this,isLeader);
	},
	SetSelected:function(isSelected)
	{
		this.imgGaoliang.visible = isSelected;
	}
} );
TeamHeadpanelExt.PanelName = "TeamHeadpanelExt";
PanelClassDic["TeamHeadpanelExt"] = TeamHeadpanelExt;
