var TeQuanFrameExt = TeQuanFrame.extend ( {
	_className:"TeQuanFrameExt",

    rewardGridList:null,
    type:null,
    _time:null,
    isOpen:false,
    _curTime:null,
    _value:null,
    _name:null,


	ctor:function(){
		this._super();
        this.rewardGridList = [];
        this.type = -1;
        this._time = 0;
        this.isOpen = false;
        this._curTime = 0;
        this._value = null;
        this._name = null;
	},

    Init:function(){
        TeQuanFrame.prototype.Init.call(this);

        this.btnGet.visible = false;
        this.btnXufei.visible = false;
        this.gridAward.visible = false;
        this.labTime.visible = false;

        var self = this;
        this.btnCue.addClickEventListener(function(event){
            AlertExt.Show(TextUtil.FormatStr("是否花费{@}元购买" + self._name, [self._value]),TipsEnum.BUTTON_SURE_AND_FALSE, {
                _onFunc:function(){
                    Mgr.recharge.Recharge(self.type + 100);
                },
            },1);
            // if(Mgr.player.mainPlayer.attributeData.TotalGold() >= self._value){
            //     AlertExt.Show(TextUtil.FormatStr("是否花费{@}元购买" + self._name, [self._value]),TipsEnum.BUTTON_SURE_AND_FALSE, {
            //         _onFunc:function(){
            //             Mgr.special.SendReqAppRecharegeOrderMessage(self.type);
            //         },
            //     },1);
            // }
            // else{
            //     // Mgr.tips.ShowNotice("元宝不足");
            //     AlertExt.NoEnoughGold(self._value - Mgr.player.mainPlayer.attributeData.TotalGold() );
            // }
        });

        this.btnGet.addClickEventListener(function(event){
            Mgr.special.SendReqGetSpecialAwardToGameMessage(self.type);
        });

        this.btnXufei.addClickEventListener(function(event){
            AlertExt.Show(TextUtil.FormatStr("是否花费{@}元购买"+ self._name, [self._value]),TipsEnum.BUTTON_SURE_AND_FALSE, {
                _onFunc:function(){
                    Mgr.recharge.Recharge(self.type + 100);
                },
            },1);
            // if(Mgr.player.mainPlayer.attributeData.TotalGold() >= self._value){
            //     AlertExt.Show(TextUtil.FormatStr("是否花费{@}元购买"+ self._name, [self._value]),TipsEnum.BUTTON_SURE_AND_FALSE, {
            //         _onFunc:function(){
            //             Mgr.special.SendReqAppRecharegeOrderMessage(self.type);
            //         },
            //     },1);
            // }
            // else{
            //     // Mgr.tips.ShowNotice("元宝不足");
            //     AlertExt.NoEnoughGold(self._value - Mgr.player.mainPlayer.attributeData.TotalGold() );
            // }
        });
    },

    SetData:function(info) {
	    this.type = info.q_id;// + 100;
	    cc.log("=======this.type==== " + this.type)
        this._value = parseInt(info.q_value)/MGameDefine.RECHARGE_RATE;
	    this._name = info.q_name;

	    var self = this;
	    var url = "";
        var url1 = "";
        switch(this.type){
            case 1:
                url = "other/zhizuntequan/word/zttq.png";
                url1 = "other/zhizuntequan/word/jyjc.png";
                break;
            case 2:
                url = "other/zhizuntequan/word/bjtq.png";
                url1 = "other/zhizuntequan/word/shjm.png";
                break;
            case 3:
                url = "other/zhizuntequan/word/hjtq.png";
                url1 = "other/zhizuntequan/word/shjc.png";
                break;
        }
        // EngineMgr.uiMgr.GetAsynResByUrl(url, function () {
        //     self.imgCue.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
        // }, self.imgCue);
        UIUtil.LoadImage(self.imgCue, url);
        // EngineMgr.uiMgr.GetAsynResByUrl(url1, function () {
        //     self.imgCue1.loadTexture(url1, ccui.Widget.PLIST_TEXTURE);
        // }, self.imgCue1);
        UIUtil.LoadImage(self.imgCue1, url1);
        var url2 = "other/zhizuntequan/image/di" + this.type +".png"
        // EngineMgr.uiMgr.GetAsynResByUrl(url2, function () {
        //     self.imgBg1.loadTexture(url2, ccui.Widget.PLIST_TEXTURE);
        // }, self.imgBg1);
        UIUtil.LoadImage(self.imgBg1, url2);

	    this.imglabNum.SetString(info.q_value/MGameDefine.RECHARGE_RATE);
	    this.btnCue.setTitleText("成为" + info.q_name);

	    var power = parseInt(Mgr.fightpower.GetFightPower(info.q_attribute));
	    this.labZhanli.SetHtmlText(TextUtil.FormatStr(this.labZhanli.GetHtmlText(), [power]));

	    this.InitView(JSON.parse(info.q_gift));
    },

    InitView:function(list){
        for(var i = 0; i < list.length; i++){
            if(!this.rewardGridList[i]){
                var grid = new MUIGrid();
                grid.ParseJson(this.gridAward.jsonobj);
                grid.Init();
                grid.x = this.gridAward.x + grid.uiWidth * i;
                grid.y = this.gridAward.y;
                this.imgBg1.addChild(grid);
                this.rewardGridList.push(grid);
            }
            var coinInfo = {};
            coinInfo.itemModelId = list[i].mod;
            coinInfo.itemNum = list[i].num;
            coinInfo.itemBind = list[i].bind;
            GridUtil.SetItemGrid(this.rewardGridList[i],coinInfo);
        }

    },

    RefreshPanel:function(info){
	    this._time = info.time;
        this.isOpen = true;
	    switch(info.state){
            case SpecialReceiveType.CANT_GET:
                if(info.time > 0){
                    Filter.GrayScale(this.btnGet);
                    this.btnCue.visible = false;
                    this.labTime.visible = true;
                    this.btnGet.visible = true;
                    this.btnXufei.visible = true;
                    this.labXiaohao.visible = false;
                    // this.imgGold2.visible = false;
                    this.imglabNum.visible = false;
                    this.labRmb.visible = false;
                }
                else{
                    Filter.GrayScale(this.btnGet);
                    this.btnCue.visible = true;
                    this.labTime.visible = false;
                    this.btnGet.visible = false;
                    this.btnXufei.visible = false;
                    this.labXiaohao.visible = true;
                    // this.imgGold2.visible = true;
                    this.imglabNum.visible = true;
                    this.labRmb.visible = true;
                }
                break;
            case SpecialReceiveType.CAN_GET:
                Filter.UnGray(this.btnGet);
                this.btnCue.visible = false;
                this.labTime.visible = true;
                this.btnGet.visible = true;
                this.btnXufei.visible = true;
                this.labXiaohao.visible = false;
                // this.imgGold2.visible = false;
                this.imglabNum.visible = false;
                this.labRmb.visible = false;
                break;
            case SpecialReceiveType.IS_GET:
                break;
        }
    },

    UpdateTime:function(passTime){
	    this._time -= (Mgr.login.GetServerTime() - passTime)/1000;
	    var time = Math.round(this._time);

        this._day = parseInt(time/86400);
        this._hour = parseInt(time/3600)%24;
        this._minute = parseInt(time/60)%60;
        this._second = time%60;
        var str = this._day + "天 " + this._hour + ":" + this._minute + ":" + this._second;
        this.labTime.SetHtmlText(TextUtil.FormatStr(this.labTime.GetHtmlText(), [str]));
    }
} );
TeQuanFrameExt.PanelName = "TeQuanFrameExt";
PanelClassDic["TeQuanFrameExt"] = TeQuanFrameExt;
