/// 掌门斗宝
var MasterBucketUtil = MasterBucketUtil || {
    nGatherNum : 0,

    /// 检查活动是否开启
    CheckActivityIsOpen:function(){
        /// 先检查玩家是否在活动地图
        if(!this.CheckPlayerInActivityMap()) return false;

//        var list = Q_timing.GetList();
//        var curDate = Mgr.login.GetServerDate();
//        var today = curDate.getDay();
//        var hour = 21//curDate.getHours();
//        var minutes = 31//curDate.getMinutes();
//        var time = hour * 60 + minutes; //
//        for(var k=0,length = list.length,v=list[k];k!=length;v=list[++k]){
//            if(v.q_type == EnumZoneActiveType.TYPE_MASTERBUCKET){ //
//                var dayArr = JSON.parse(v.q_day);
//                var timeArr =  v.q_time.match(/[0-9]+/g);
//                for (var vv of dayArr) {
//                    var day = parseInt(vv);
//                    if (day == 7) day = 0;
//                    if (day == -1 ) day = today; //
//                    // 如果在活动时间内
//                    if(today == day
//                        && (parseInt(timeArr[0]) * 60 + parseInt(timeArr[1]) < time)
//                        && (time < parseInt(timeArr[2]) * 60 + parseInt(timeArr[3]))
//                    ){
//                        var startTime = new Date(curDate);
//                        startTime.setHours(parseInt(timeArr[0]));
//                        startTime.setMinutes(parseInt(timeArr[1]));
//                        var endTime = new Date(curDate);
//                        endTime.setHours(parseInt(timeArr[2]));
//                        endTime.setMinutes(parseInt(timeArr[3]));
//                        return {
//                            type : v.q_type,
//                            startTime : startTime.getTime(),
//                            endTime : endTime.getTime() - startTime.getTime(),
//                            status : 0,
//                        };
//                    }
//                }
//            }
//        }

        var data = Mgr.majorevents.GetActivityInfoByType(EnumZoneActiveType.TYPE_MASTERBUCKET);
        if(!data) return false;

        var curTime = Mgr.login.GetServerTime() / 1000;

        if(curTime < data.startTime || curTime > data.startTime + data.endTime) return false;

        return data;
    },

    /// 检查玩家是否活动区域
    CheckPlayerInActivityMapArea:function(){
        var conf = Q_global.Get(1123);
        var data = JSON.parse(conf.q_string_value);
        for(var k=0,length=data.length,v=data[k];k!=length;v=data[++k]){
            if(Mgr.sceneMap.nMapId == v[0]){
                var curPos = Mgr.mainPlayer.GetPixPt();
                var target = ToolMap.GridPt2PixPt(v[1],v[2],true);
                if(ToolMap.CalcDistance(curPos, target) < v[3]){
                    return true;
                }
            }
        }
        return false;
    },
    /// 检查玩家是否在活动地图
    CheckPlayerInActivityMap:function(){
        var conf = Q_global.Get(1123);
        var data = JSON.parse(conf.q_string_value);
        for(var k=0,length=data.length,v=data[k];k!=length;v=data[++k]){
            if(Mgr.sceneMap.nMapId == v[0]){
                return true;
            }
        }
        return false;
    },

    Fly2ActivityArea:function(){
        var conf = Q_global.Get(1123);
        var data = JSON.parse(conf.q_string_value);

        if(!data) return;

        /// 如果在活动地图内,择近
        if(this.CheckPlayerInActivityMap()){
            var curMapId = Mgr.sceneMap.nMapId;
            var index = null;
            var curPos = Mgr.mainPlayer.GetGridPt();
            for(var k=0,length=data.length,v=data[k];k!=length;v=data[++k]){
                if(curMapId == v[0]){
                    if(index != null){
                        if(ToolMap.CalcDistance(curPos, cc.p(v[1],v[2]))
                            < ToolMap.CalcDistance(curPos, cc.p(data[index][1],data[index][2]))){
                            index = k;
                        }
                    }else{
                        index = k;
                    }
                }
            }
            if(index != null) this.AutoPath2ActivityRange(index);
        }else{
            this.AutoPath2ActivityRange(Math.floor(Math.random() * data.length));
        }
    },
    /// 自动寻路到活动范围
    /// @index 配置的索引
    AutoPath2ActivityRange:function(index){
        var confMap = Q_global.Get(1123);
        var confNpc = Q_global.Get(1125);

        if(!confMap || !confNpc) return;

        var data = JSON.parse(confMap.q_string_value);
        var map = data ? data[index] : null;
        var npc = confNpc.q_int_value;

        if(!map || !npc) return;

        // 走过去
        //Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(map[0], cc.p(map[1],map[2]),
        //    AutoPathParam.CreateSelectNpc(npc), true);

        /// 飞过去
        var targetPixel = ToolMap.GridPt2PixPt(map[1],map[2], true);
        if(Mgr.sceneMap.nMapId == map[0]){
            Mgr.map.SendReqSameMapFlyMoveMessage(new Position(targetPixel.x, targetPixel.y));
        }else{
            Mgr.map.SendReqSmallFlyShoesMessage( map[0], targetPixel );
        }
    },

    GetGatherCount:function(){
        var conf = Q_global.Get(1128);
        var total =  conf.q_int_value;
        return [this.nGatherNum,total];
    },

    UpdateGatherCount:function(count){
        this.nGatherNum = count;

        Mgr.task._taskTrackPanel.UpdateView();
    }
}