///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//157201,ReqUpGradeInfoToGame 请求成长礼包信息
//157202,ReqUpGradeRewardToGame 请求领取等级成长礼包
//157203,ReqGetLandInfoToGame 请求七日登陆信息
//157204,ReqGetLandRewardToGame 请求领取七日登陆礼包
//157205,ReqFeedBackToGame 请求提交意见反馈
//157206,ReqFirstRechargeAwardToGame 发送领取首冲奖励信息

// 接收消息
//157101,ResUpGradeInfoToGame 成长礼包信息
//157102,ResGetLandInfoToGame 七日登陆信息
//157103,ResUpGradeRewardToClinet 成功领取成长礼包消息
//157104,ResGetLandRewardToClinet 成功领取七日登陆礼包消息
//157105,ResFeedBackToClinet 意见反馈信息
//157106,ResFirstRechargeInfoToClient 发送首冲信息


////////////////////
// 成长礼包信息 //
////////////////////
var ResUpGradeInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.giftId = []; // 已领取过的礼包id int
	},

	getId:function(){
		return 157101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.giftId.length );
        for (var i = 0; i < this.giftId.length; i++) {
            _buf.WriteVarInt(this.giftId[i]);
        }
	},
	
	reading:function( _buf ){
        var giftId_length = _buf.ReadShort();
        for (var i = 0; i < giftId_length; i++) {
            this.giftId[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.weal.RecvResUpGradeInfoToGameMessage(this);
	},

});
////////////////////
// 七日登陆信息 //
////////////////////
var ResGetLandInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.landDay = 0; // 累计登陆天数
        this.giftId = []; // 已领取过的礼包id列表 int
        this.logingiftIds = []; // 七日登陆(登录器)礼包ID列表 int
	},

	getId:function(){
		return 157102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.landDay);
        _buf.WriteShort( this.giftId.length );
        for (var i = 0; i < this.giftId.length; i++) {
            _buf.WriteVarInt(this.giftId[i]);
        }
        _buf.WriteShort( this.logingiftIds.length );
        for (var i = 0; i < this.logingiftIds.length; i++) {
            _buf.WriteVarInt(this.logingiftIds[i]);
        }
	},
	
	reading:function( _buf ){
        this.landDay = _buf.ReadVarInt();
        var giftId_length = _buf.ReadShort();
        for (var i = 0; i < giftId_length; i++) {
            this.giftId[i] = _buf.ReadVarInt();
        }
        var logingiftIds_length = _buf.ReadShort();
        for (var i = 0; i < logingiftIds_length; i++) {
            this.logingiftIds[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.weal.RecvResGetLandInfoToGameMessage(this);
	},

});
////////////////////
// 成功领取成长礼包消息 //
////////////////////
var ResUpGradeRewardToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.giftId = 0; // 成长礼包ID
	},

	getId:function(){
		return 157103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.giftId);
	},
	
	reading:function( _buf ){
        this.giftId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.weal.RecvResUpGradeRewardToClinetMessage(this);
	},

});
////////////////////
// 成功领取七日登陆礼包消息 //
////////////////////
var ResGetLandRewardToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.giftId = 0; // 七日登陆礼包ID
	},

	getId:function(){
		return 157104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.giftId);
	},
	
	reading:function( _buf ){
        this.giftId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.weal.RecvResGetLandRewardToClinetMessage(this);
	},

});
////////////////////
// 意见反馈信息 //
////////////////////
var ResFeedBackToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.submit = 0; // 0表示可以提意见,1表示不能
	},

	getId:function(){
		return 157105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.submit);
	},
	
	reading:function( _buf ){
        this.submit = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.weal.RecvResFeedBackToClinetMessage(this);
	},

});
////////////////////
// 发送首冲信息 //
////////////////////
var ResFirstRechargeInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.day = 0; // 当前首冲第几天
        this.rechargeGold = 0; // 今天累计充值金额
        this.receiveAwards = []; // 今天已领取的档次金额 int
	},

	getId:function(){
		return 157106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.day);
        _buf.WriteVarInt(this.rechargeGold);
        _buf.WriteShort( this.receiveAwards.length );
        for (var i = 0; i < this.receiveAwards.length; i++) {
            _buf.WriteVarInt(this.receiveAwards[i]);
        }
	},
	
	reading:function( _buf ){
        this.day = _buf.ReadVarInt();
        this.rechargeGold = _buf.ReadVarInt();
        var receiveAwards_length = _buf.ReadShort();
        for (var i = 0; i < receiveAwards_length; i++) {
            this.receiveAwards[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.weal.RecvResFirstRechargeInfoToClientMessage(this);
	},

});
////////////////////
// 请求成长礼包信息 //
////////////////////
var ReqUpGradeInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 157201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取等级成长礼包 //
////////////////////
var ReqUpGradeRewardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.giftId = 0; // 成长礼包ID
	},

	getId:function(){
		return 157202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.giftId);
	},
	
	reading:function( _buf ){
        this.giftId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求七日登陆信息 //
////////////////////
var ReqGetLandInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 157203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取七日登陆礼包 //
////////////////////
var ReqGetLandRewardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.giftId = 0; // 七日登陆礼包ID
        this.type = 0; // 类型:0请求领取普通七日礼包,1请求领取登录器七日礼包
	},

	getId:function(){
		return 157204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.giftId);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.giftId = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 请求提交意见反馈 //
////////////////////
var ReqFeedBackToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.satisfied = 0; // 满意度
        this.context = null; // 提交的意见
	},

	getId:function(){
		return 157205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.satisfied);
        _buf.WriteString(this.context);
	},
	
	reading:function( _buf ){
        this.satisfied = _buf.ReadVarInt();
        this.context = _buf.ReadString();
	},

});
////////////////////
// 发送领取首冲奖励信息 //
////////////////////
var ReqFirstRechargeAwardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.day = 0; // 当前首冲第几天
        this.gold = 0; // 领取的档次金额
	},

	getId:function(){
		return 157206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.day);
        _buf.WriteVarInt(this.gold);
	},
	
	reading:function( _buf ){
        this.day = _buf.ReadVarInt();
        this.gold = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(157101, ResUpGradeInfoToGameMessage);
MESSAGE_POOL.Add(157102, ResGetLandInfoToGameMessage);
MESSAGE_POOL.Add(157103, ResUpGradeRewardToClinetMessage);
MESSAGE_POOL.Add(157104, ResGetLandRewardToClinetMessage);
MESSAGE_POOL.Add(157105, ResFeedBackToClinetMessage);
MESSAGE_POOL.Add(157106, ResFirstRechargeInfoToClientMessage);

