var GouMaiPanelExt = GouMaiPanel.extend ( {
	_className:"GouMaiPanelExt",
	_curType:0,
	_curPrice:0,
	_selectNum:1,
	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.ALPHABLACK;
	},

	Init:function () {
		GouMaiPanel.prototype.Init.call(this);

        var ee=new MUINumberEdit();
        ee.jsonobj=this.labBuyNums.jsonobj;
        ee.Init();
        this.imgList.removeChild(this.labBuyNums);
        this.imgList.addChild(ee);
        this.labBuyNums=ee;
        this.labBuyNums.setString(this._selectNum);
        // self.labBuyNums.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC );
        this.labBuyNums.setDelegate(this);
        this.labBuyNums.setPlaceHolder(1);

		var self = this;
		this.btnClose.addClickEventListener(function (sender) {
			Mgr.uiMgr.HidePanel(self);
        });

		this.btnBuy.addClickEventListener(function (sender) {
			if(self._curType == 0){
				var shopItem = Mgr.shop.GetShopItemByMid(self._mid, EnumShopType.GOLD_SHOP);

                var gold = Mgr.mainPlayer.attributeData.GetAttribute(EnumMoney.GOLD, AttributeData.Money);
				var bindGold = Mgr.mainPlayer.attributeData.GetAttribute(EnumMoney.TIME_GOLD, AttributeData.Money);

				var needGold = 0;
                var moneyType = EnumMoney.TIME_GOLD;
                if(shopItem.price * self._selectNum  <= bindGold){
                    moneyType = EnumMoney.TIME_GOLD;
				}else if(shopItem.price * self._selectNum <= gold){
                    moneyType = EnumMoney.GOLD;
				}else {
                    moneyType = 0;
                    needGold = shopItem.price * self._selectNum - gold;
				}

				if(moneyType != 0){
                    Mgr.shop.SendReqBuyItemMessage(
                        EnumShopType.GOLD_SHOP,
                        shopItem.itemModelId,
                        shopItem.shopItemId,
                        shopItem.shopItemSid,
                        shopItem.moneyInfo,
                        moneyType,
                        self._selectNum
                    );
                    if(self._callBack){
                    	self._callBack();
					}
				}else {
                    AlertExt.NoEnoughGold(needGold);
				}

				Mgr.uiMgr.HidePanel(self);
			}else if(self._curType == 1){
				if(self._data){
					var socre = Mgr.mainPlayer.attributeData.GetAttribute(EnumMoney.LUCKY_GOLD, AttributeData.Money);
					if(socre < self._curPrice * self._selectNum){
						Mgr.tips.ShowNotice("积分不足!!!");
					}else {
						Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self._data.activityId, self._selectNum);
                        Mgr.uiMgr.HidePanel(self);
					}
				}
			}
        });

		this.btnJia.addClickEventListener(function (sender) {
			self._selectNum++;
            self.labBuyNums.setString(self._selectNum);
			self.RefreshPrice();
        });

		this.btnJian.addClickEventListener(function (sender) {
			self._selectNum--;
			self._selectNum = self._selectNum > 1 ? self._selectNum : 1;
            self.labBuyNums.setString(self._selectNum);
			self.RefreshPrice();
        });
    },

	BuyCard:function (mid, num) {
		num = num || 1;
		this._curType = 0;
		this._selectNum = num;
		this._mid = mid;
        this.labBuyNums.setString(num);
		this.labKuaisugoumai.SetText("快速购买");
		UIUtil.LoadImage(this.imgGold1, "public/image/yuanbao.png", false, true);
		UIUtil.LoadImage(this.imgGold11, "public/image/yuanbao.png", false, true);
		var item = ItemUtil.ItemIdToItem(mid);
		GridUtil.SetItemGrid(this.gridItem, item);
        var shopItem = Mgr.shop.GetShopItemByMid(mid, EnumShopType.GOLD_SHOP);
		UIUtil.ConnectLabelHtmlText(this.labName, [shopItem.name]);
		this._curPrice = shopItem.price;
		this.RefreshPrice();
    },

	BuyItem:function (data) {
		this._data = data;
		this._curType = 1;
        this._selectNum = 1;
        this.labBuyNums.setString(1);
        this.labKuaisugoumai.SetText("兑换商城");
        UIUtil.LoadImage(this.imgGold1, "other/xingyunzhuanpan/image/jinbida.png", false, true);
        UIUtil.LoadImage(this.imgGold11, "other/xingyunzhuanpan/image/jinbida.png", false, true);
        var item = data.GetRewardList()[0];
		GridUtil.SetItemGrid(this.gridItem, item);
        var q_item = Q_item.Get(item.itemModelId);
        UIUtil.ConnectLabelHtmlText(this.labName, [q_item.q_name]);
        var str = data.special[0].beanInfo.items;
        var strArr = str.split(",");
        var needScore = strArr[1].replace("]", "").replace("]", "");//string类型
		needScore = parseInt(needScore);
		this._curPrice = needScore;
		this.RefreshPrice();
    },

	AddCallBack:function (callBack) {
		this._callBack = callBack;
    },

	RefreshPrice:function () {
        UIUtil.ConnectLabelHtmlText(this.labMoney, [this._curPrice]);
        UIUtil.ConnectLabelHtmlText(this.labMoney1, [this._curPrice * this._selectNum]);
    },

    editBoxTextChanged :function(){
        var ediText = this.labBuyNums.getString();
        if(ediText==""){
        	this._selectNum = 1;
            this.labBuyNums.setString(1);
        	return;
        }else {
            this._selectNum = parseInt(ediText);
		}
        this.RefreshPrice();
    },

	OnHide:function () {
		this._callBack = null;
    }
} );
GouMaiPanelExt.PanelName = "GouMaiPanelExt";
PanelClassDic["GouMaiPanelExt"] = GouMaiPanelExt;
