var YoujianPanelExt = YoujianPanel.extend ( {
	_className:"YoujianPanelExt",
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -28;
	},
	Init:function()
	{
		YoujianPanel.prototype.Init.call(this);
		this._SetLocalProperty();
		this._InitProperty();
		this._HandleButton();
		this.setSwallowTouches(false);
	},
	_SetLocalProperty:function()
	{
		this.youjianPanel = null;
		this.friendPanel = null;
		this.addfriendPanel = null;
		this.FRIEND_PANEL = 0;
		this.ADD_FRIEND_PANEL = 1;
		this.YOUJIAN_PANEL = 2;
		this.panelArr = [];
		this.btnArr = [];
		this.btnLabArr = [];
		this.selectedStateFormat = {
			fontsize:24,
			color:EnumFontFormat.COMMON_COLOR01,
		}
		this.normalStateFormat = {
			fontsize:24,
			color:EnumFontFormat.COMMON_COLOR06,
		}
	},
	_InitProperty:function()
	{
		this.imgTanhao.visible = false;
		this.imgTanhao1.visible = false;
		this.imgTanhao11.visible = false;
	},
	_HandleButton:function()
	{
		var self = this;
		this.btnClose.addClickEventListener(function()
		{
			self.CheckMailReceive();
			self.CheckNewChatReceive();
			EngineMgr.uiMgr.HidePanel(self);
		});
		this.sbtnFriend.addClickEventListener(function()
		{
			self.ChangePanel(self.FRIEND_PANEL);
		});
		this.sbtnTianjia.addClickEventListener(function()
		{
			self.ChangePanel(self.ADD_FRIEND_PANEL);
		});
		this.sbtnYoujian.addClickEventListener(function()
		{
			self.ChangePanel(self.YOUJIAN_PANEL);
		});
		this.btnArr = [this.sbtnFriend,this.sbtnTianjia,this.sbtnYoujian];
		this.btnLabArr = [this.labFriend,this.labFriend1,this.labFriend11];
	},
	//陌生人聊天stranger
	SetStranger:function(data)
	{
		if(!this.friendPanel)
		{
			this.friendPanel = new FriendPanelExt();
			this.friendPanel.LoadPanel();
			this.imgBg.addChild(this.friendPanel);
		}
		this.friendPanel.SetStranger(data);
	},
	ChangePanel:function(type)
	{
		for ( var i = 0; i < this.btnArr.length; i++ )
		{
			if( i == type )
			{
				if(this.panelArr[i])
				{
					this.panelArr[i].visible = true;
				}
				this.btnArr[i].SetButtonState(this.btnArr[i]._btnStates[1]);
				this.btnLabArr[i].SetColor(this.selectedStateFormat.color);
				this.btnLabArr[i].SetFontSize(this.selectedStateFormat.fontsize);
			}
			else
			{
				if(this.panelArr[i])
				{
					this.panelArr[i].visible = false;
				}
				this.btnArr[i].SetButtonState(this.btnArr[i]._btnStates[0]);
				this.btnLabArr[i].SetColor(this.normalStateFormat.color);
				this.btnLabArr[i].SetFontSize(this.normalStateFormat.fontsize);
			}
		}
		switch (type)
		{
			case this.FRIEND_PANEL:
			{
				this.imgTitle.visible = false;
				this.imgFriend.visible = true;
				if(!this.friendPanel)
				{
					this.friendPanel = new FriendPanelExt();
					this.friendPanel.LoadPanel();
					this.imgBg.addChild(this.friendPanel);
				}
				this.friendPanel.OnShow();
				break;
			}
			case this.ADD_FRIEND_PANEL:
			{
				this.imgTitle.visible = false;
				this.imgFriend.visible = true;
				if(!this.addfriendPanel)
				{
					this.addfriendPanel = new AddFriendPanelExt();
					this.addfriendPanel.LoadPanel();
					this.imgBg.addChild(this.addfriendPanel);
				}
				this.addfriendPanel.ChangePlayer();
				this.addfriendPanel.ClearSearchList();
				break;
			}
			case this.YOUJIAN_PANEL:
			{
				this.imgTitle.visible = true;
				this.imgFriend.visible = false;
				if (!this.youjianPanel)
				{
					this.youjianPanel = new YoujianMainExt();
					this.youjianPanel.LoadPanel();
					this.imgBg.addChild(this.youjianPanel);
				}
				this.youjianPanel.OnShow();
				break;
			}
			default:break;
		}
		this.panelArr = [this.friendPanel,this.addfriendPanel,this.youjianPanel];
	},
	//检测邮件领取情况
	CheckMailReceive:function()
	{
		if(this.youjianPanel)
		{
			var isNewMail = false;
			var count = 0;
			var items = Mgr.mail.mailList.Values();
			for(var i = 0,len = items.length; i<len;i++ )
			{
				if(!items[i].isReceive && items[i].items.length > 0)
				{
					isNewMail = true;
					count++
				}
			}
			Mgr.mail._GetShortcutPanel().GetNewMailNotice(isNewMail,count);
			this.imgTanhao11.visible = isNewMail;
		}
	},
	CheckNewChatReceive:function()
	{
		if(!this.imgTanhao.visible)
		{
			Mgr.mail._GetShortcutPanel().ClearNewChatPrivateInfo();
		}
	},
	//检测是否有未读消息
	CheckUnReadChatInfo:function()
	{
		if(this.friendPanel)
		{
			var isNewChat = false;
			var items = this.friendPanel.friendList.getItems();
			for ( var i = 0; i < items.length; i++ )
			{
				if(items[i].GetNewMessageFlag())
				{
					isNewChat = true;
					break;
				}
			}
			var items = this.friendPanel.recentList.getItems();
			for ( var i = 0; i < items.length; i++ )
			{
				if(items[i].GetNewMessageFlag())
				{
					isNewChat = true;
					break;
				}
			}
			var items = this.friendPanel.blackList.getItems();
			for ( var i = 0; i < items.length; i++ )
			{
				if(items[i].GetNewMessageFlag())
				{
					isNewChat = true;
					break;
				}
			}
			if(Mgr.chat.GetNotOnlineChatCount()>0)
			{
				isNewChat = true;
			}
			this.imgTanhao.visible = isNewChat;
		}
	},
	OnShow:function()
	{
		if(this.youjianPanel)
		{
			this.CheckMailReceive();
		}
		Mgr.friend.SendReqFriendListInfoMessage();
	},
	OnHide:function()
	{
		this._super();
		Mgr.friend.isStranger = false;
	},
} );
YoujianPanelExt.PanelName = "YoujianPanelExt";
PanelClassDic["YoujianPanelExt"] = YoujianPanelExt;
