var BossAwardPanelExt = BossAwardPanel.extend ( {
	_className:"BossAwardPanelExt",

    gridList:null,
    gridList2:null,
	rankingList:null,
    _listView1:null,

    ctor:function(){
        this._super();
        this.gridList = [];
        this.gridList2 = [];
    },

    Init:function(){
        FBAwardPanel.prototype.Init.call( this );
        // this.labAwardCue1.visible = false;
        this.gridAward.visible = false;
        // this.gridAward1.visible = false;

        this.InitListView();

		this.labOne.visible = false;
        this.labTwo.visible = false;
        this.labThree.visible = false;
		this.rankingList = [this.labOne, this.labTwo, this.labThree];

        this.confMap = Q_map.Get(Mgr.sceneMap.nMapId);
        this.zoneType = Mgr.sceneMap.ZoneType();
        // this.zoneId = Mgr.sceneMap.GetZoneModelIdByMapId(Mgr.sceneMap.nMapId);

        // this.InitView();
    },

    InitListView:function(){
        if(!this._listView1){
            this._listView1 = new ccui.ListView();
            this._listView1.setDirection(ccui.ScrollView.DIR_HORIZONTAL);//视图滚动方向
            this._listView1.setTouchEnabled(true);					//触摸开启
            this._listView1.inertiaScrollEnabled = false; 			//滚动惯性
            this._listView1.setScrollBarEnabled(false);				//滚动条
            this._listView1.setBounceEnabled(true);					//边界回弹
            this.imgBg1.addChild(this._listView1);
        }
    },

    InitView:function(){
        var reward;
        this.labCue.SetText("伤害前三装备概率5倍");
        if(Mgr.monster.IsInMonsterMap()){
            if(Mgr.sceneMap.nMapId == 1002 || Mgr.sceneMap.nMapId == 1003){
                this.labFB1.SetText("铸剑天下");
                this.labAwardCue.SetText("参与奖励");
                reward = JSON.parse(Q_timing.Get(11).q_item_show);
                this.InitGird(reward, this._listView1, this.imgBg1, this.gridList);
            }
            else if(Mgr.sceneMap.nMapId == 50001 || Mgr.sceneMap.nMapId == 50002){
                this.labFB1.SetText("[BOSS挑战]恶人谷");
                this.labAwardCue.SetText("掉落奖励");
                this.labCue.SetText("危险区域 建议一起挑战");
                var id;
                if(Mgr.sceneMap.nMapId == 50001)
                    id = 10001;
                else
                    id = 10002;
                var reward =JSON.parse(Q_global.Get(id).q_string_value);
                this.InitGird(reward, this._listView1, this.imgBg1, this.gridList);
            }
            else{
                this.labFB1.SetText("世界首领");
                if(!this._listView2){
                    this._listView2 = new ccui.ListView();
                    this._listView2.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
                    this._listView2.setTouchEnabled(true);					//触摸开启
                    this._listView2.inertiaScrollEnabled = true; 			//滚动惯性
                    this._listView2.setScrollBarEnabled(false);				//滚动条
                    this._listView2.setBounceEnabled(true);					//边界回弹
                    this.imgBg.addChild(this._listView2);
                }

                this.labAwardCue.SetText("掉落奖励");
                this.labAwardCue.removeFromParent();
                this._listView2.pushBackCustomItem(this.labAwardCue);
                if(!Mgr.monster.curWorldBossInfo &&  Mgr.monster.GetWorldBossIdByMapId(Mgr.sceneMap.nMapId))
                    return;
                reward = JSON.parse(Q_monster_dropprob.Get(Mgr.monster.curWorldBossInfo.monsterModelId).q_drop_show);
                this.InitGird(reward, this._listView1, this.imgBg1, this.gridList);
                this.imgBg1.removeFromParent();
                this._listView2.pushBackCustomItem(this.imgBg1);

                var label = new MUILabel();
                label.ParseJson(this.labAwardCue.jsonobj);
                label.Init();
                label.SetText("伤害排行奖励");
                this._listView2.pushBackCustomItem(label);
                // var node = cc.Node();
                reward = JSON.parse(Q_global.Get(1162).q_string_value);
                if(!this._listView3){
                    this._listView3 = new ccui.ListView();
                    this._listView3.setDirection(ccui.ScrollView.DIR_HORIZONTAL);//视图滚动方向
                    this._listView3.setTouchEnabled(false);					//触摸开启
                    this._listView3.inertiaScrollEnabled = false; 			//滚动惯性
                    this._listView3.setScrollBarEnabled(false);				//滚动条
                    this._listView3.setBounceEnabled(true);					//边界回弹
                    // node.addChild(this._listView3);
                }
                this.InitGird(reward, this._listView3, this.imgBg1, this.gridList2);
                this._listView2.pushBackCustomItem(this._listView3);

                this._listView2.setSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
                this._listView2.setInnerContainerSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
            }
        }
    },

    InitGird:function(reward, listview, imgBg, gridList){
	    var _height;
        for(var i = 0; i < reward.length; i++){
            if(!gridList[i]){
                var grid = new GridItem();
                grid.ParseJson(this.gridAward.jsonobj);
                grid.Init();
                _height = grid.uiHeight;
                listview.pushBackCustomItem(grid);
                // grid.x += i%4 * (grid.uiWidth + 5);
                // grid.y -= parseInt(i/4) * (grid.uiHeight + 10);
                gridList.push(grid);
            }
            var coinInfo = {};
            coinInfo.itemModelId = reward[i].mod;
            coinInfo.itemNum = reward[i].num;
            coinInfo.itemBind = reward[i].bind;
            GridUtil.SetItemGrid(gridList[i], coinInfo);
        }
        listview.setSize(cc.size(imgBg.uiWidth, imgBg.uiHeight));
        listview.setInnerContainerSize(cc.size(imgBg.uiWidth, reward.length * _height));
    },

    RefreshRanking:function(info){
        var i = 0;
        var len = Math.min(info.BossDamageInfos.length,3);
        for(; i< len; i++){
        	this.rankingList[i].visible = true;
            var pro = Math.ceil(info.BossDamageInfos[i].damage/1000/info.totalDamage*100);
            if(i < 3)
                this.rankingList[i].SetHtmlText(TextUtil.FormatStr(this.rankingList[i].GetHtmlText(),
					[info.BossDamageInfos[i].playerName + "    (" + (pro > 100 ? 100 : pro) + "%)"]));
            else
                break;
        }
        for(; i < 3; i++){
            this.rankingList[i].visible = false;
		}
	},

    UpdateView:function(){
    },
} );
BossAwardPanelExt.PanelName = "BossAwardPanelExt";
PanelClassDic["BossAwardPanelExt"] = BossAwardPanelExt;
