var JingyanFrameExt = JingyanFrame.extend ( {
	_className:"JingyanFrameExt",
	num:0,
	minZoneLv:0,
	maxZoneLv:0,
	isLast:true,//是最后一关
	_zoneid:0,
	ctor:function(){
		this._super();
	},

	InitData:function( zoneid, num, maxLv ){
		UIUtil.LoadImage( this.imgFrame, "other/danrenfuben/image/jiangyanbg/di" + num + ".png")
		this._zoneid = zoneid;
		this.num = num;
		var zoneList = Q_exp_zone.GetList();
		var length = zoneList.length;
		for( var i = maxLv; i < length; i++ )
		{
			if( zoneList[i].q_zone > zoneid ){
				this.isLast = false;
				break;
			}
			if( zoneList[i].q_zone == zoneid ){
				if( zoneList[i].q_id < this.minZoneLv || this.minZoneLv == 0 ){
					this.minZoneLv = zoneList[i].q_id;
				}
				if( zoneList[i].q_id > this.maxZoneLv || this.minZoneLv == 0 ){
					this.maxZoneLv = zoneList[i].q_id;
				}
			}
		}

		this.labCue.SetText(TextUtil.FormatStr( this.labCue.GetHtmlText(), [ this.minZoneLv + "-" + this.maxZoneLv ] ));
		this.imgRight.setVisible(!this.isLast);
		
		var self = this;
		this.addClickEventListener(function () {
			if(self.NeedShow()){
				Mgr.zone.SendReqZoneEnterToGameMessage(self._zoneid);
			}
		});
	},

	UpdataState:function () {
		var curLv = Mgr.zone.jingyanNowWave;
		if( curLv >= this.minZoneLv && curLv <= this.maxZoneLv ){//正在打的关
			this.imgOver.setVisible(false);
			Filter.UnGray(this);
		}else if( curLv < this.minZoneLv ){//还没打的关
			this.imgOver.setVisible(false);
			Filter.GrayScale(this);
		}else if( curLv > this.maxZoneLv ){//已经通了的关
			this.imgOver.setVisible(true);
			Filter.GrayScale(this);
		}
	},

	NeedShow:function(){
		var curLv = Mgr.zone.jingyanNowWave;
		if( curLv >= this.minZoneLv && curLv <= this.maxZoneLv )
			return true;
		else
			return false;
	},
} );
JingyanFrameExt.PanelName = "JingyanFrameExt";
PanelClassDic["JingyanFrameExt"] = JingyanFrameExt;
