var JinjieFubenFrameExt = JinjieFubenFrame.extend ( {
	_className:"JinjieFubenFrameExt",
	_zoneData:null,
	_jinjieZoneData:null,
	_zoneId:0,
	_rawardCon:null,
	_dropCon:null,
	_rawards:null,
	_drops:null,
	_zoneModelId:0,
    _isFirst:1,
	_crossnum:0,
	_paynum:0,
	_needGoldArr:null,
	_needGold:0,
	ctor:function(){
		this._super();
	},

	InitData:function( zoneid, num ){
		this._rawardCon = new TaskRewardsGridCon();
		this._dropCon = new TaskRewardsGridCon();
		this.addChild(this._rawardCon);
		this.addChild(this._dropCon);
		
		// var imageRes = "other/danrenfuben/image/jinjieditu_" + num + ".png";
		// var self=this;
		// EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
		// 	self.imgBg.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
		// }, self.imgBg);
		UIUtil.LoadImage(this.imgBg, "other/danrenfuben/image/jinjiebg/jinjie" + num + ".png");
		this._zoneData = Mgr.dataMgr.GetZoneData(zoneid);
		this._jinjieZoneData = Q_story.Get(zoneid);
		this._zoneId = zoneid;
		this._needGoldArr = JSON.parse(this._jinjieZoneData.q_cost_buy);
		if( this._jinjieZoneData.q_reward )
			this._rawards = JSON.parse( this._jinjieZoneData.q_reward );
		if( this._jinjieZoneData.q_item_show )
			this._drops = JSON.parse( this._jinjieZoneData.q_item_show );
//		this.ShowRaward();

		//this.labLv.SetText(TextUtil.FormatStr( this.labLv.GetHtmlText(), [ this._zoneData.q_level ] ));
		this.labLv.SetText(this._zoneData.q_level+"级");

		UIUtil.UIRemoveSelf(this.gridItem);
		UIUtil.UIRemoveSelf(this.gridItem1);
		UIUtil.UIRemoveSelf(this.gridItem2);

        Mgr.zone.AddbuttonEffect(this.btnTiaozhan, 995, true);

		var self = this;
		this.btnTiaozhan.addClickEventListener(function (event){
			Mgr.zone.SendReqZoneEnterToGameMessage(self._zoneId);
		});
		this.btnSaodang.addClickEventListener(function(event){
			Mgr.zone.SendReqBattleZoneSweepToGameMessage(EnumZoneType.TYPE_JJ, self._zoneModelId);
		});
		this.btnChongzhi.addClickEventListener(function (event){
			if(Mgr.player.mainPlayer.attributeData.gold<self._needGold){
				EngineMgr.uiMgr.ShowPanelByType(GoldCueExt.PanelName);
				return
			}
			Mgr.zone.SendReqPayBattleToGameMessage(self._zoneId);
		});
		this._zoneModelId = this._jinjieZoneData.q_id;
		this.labNumber.SetText(TextUtil.FormatStr( this.labNumber.GetHtmlText(), [ this._jinjieZoneData.q_num_buy ] ));
		this.UpdataPayGoldNum();
		this.UpdateState();
	},

	UpdataPayGoldNum:function(){
		if( this._jinjieZoneData.q_challenge_num - this._crossnum == 0 ){
			var payIndex = Math.min(this._paynum, this._needGoldArr.length-1);
			this._needGold = this._needGoldArr[payIndex][0];
		}
//		this.labNumber.SetText(TextUtil.FormatStr( this.labNumber.GetHtmlText(), [ needGold ] ));
		this.labNumber1.SetText(this._needGold.toString());
	},

	ShowRaward:function(){
		this.labName.SetText(this._zoneData.q_name);
		if( this._rawards == null ){
			this._rawardCon.setVisible(false);
			this.img1.setVisible(false);
		}
		else{
			this.img1.setVisible(true);
			var count = 0;
			if( this._rawards ){
				for ( var i = 0; i < this._rawards.length ; i ++){
					var item = ItemUtil.ItemIdToItem(this._rawards[ i ].mod,this._rawards[ i ].num,this._rawards[ i ].bind);
					this._rawardCon.AddComItem(item,this.gridItem);
					count++;
				}

				if ( count > 0 ){
					this._rawardCon.Layout( this.gridItem.uiWidth * count, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight );
					this._rawardCon.x = ( this.uiWidth - this.gridItem.uiWidth * count ) / 2;
					this._rawardCon.y = this.gridItem.y;
				}
			}
		}

		if( this._drops == null ){
			this._dropCon.setVisible(false);
			this.img2.setVisible(false);
		}
		else{
			this.img2.setVisible(true);
			var count = 0;
			for ( var i = 0; i < this._drops.length ; i ++){
				var item = ItemUtil.ItemIdToItem(this._drops[i][ 0 ],this._drops[i][ 1 ],this._drops[i][ 2 ]);
				this._dropCon.AddComItem(item,this.gridItem2);
				count++;
			}

			if ( count > 0 ){
				this._dropCon.Layout( this.gridItem2.uiWidth * count, this.gridItem2.uiHeight, this.gridItem2.uiWidth, this.gridItem2.uiHeight );
				this._dropCon.x = ( this.uiWidth - this.gridItem2.uiWidth * count ) / 2;
				this._dropCon.y = this.gridItem2.y;
			}
		}
	},

	HideRaward:function(){
		if( this._rawards != null )
			this._rawardCon.Clear();
		if( this._drops != null )
			this._dropCon.Clear();
	},

	UpdateState:function(){
		if(Mgr.player.mainPlayer.attributeData.level < this._zoneData.q_level){
			this.labCue.setVisible(true);
			this.labLv.setVisible(true);
			this.btnTiaozhan.setVisible(false);
            this.btnSaodang.setVisible(false);
			this.btnChongzhi.setVisible(false);
			this.labXiaohao.setVisible(false);
			this.labNumber.setVisible(false);
			this.labNumber1.setVisible(false);
			this.imgGold.setVisible(false);
			this.labOver.setVisible(false);
		}else{
			this.labCue.setVisible(false);
			this.labLv.setVisible(false);

			if( this._jinjieZoneData.q_num_buy - this._paynum > 0 || this._jinjieZoneData.q_challenge_num - this._crossnum > 0 )
			{
				if( this._jinjieZoneData.q_challenge_num - this._crossnum > 0 )
				{
                    if(this._paynum > 0){
                        this.btnTiaozhan.setVisible(false);
                        this.btnSaodang.setVisible(true);
					}
					else{
                        this.btnTiaozhan.setVisible(true);
                        this.btnSaodang.setVisible(false);
					}
					this.btnChongzhi.setVisible(false);
					this.labXiaohao.setVisible(false);
					this.labNumber.setVisible(false);
					this.labNumber1.setVisible(false);
					this.imgGold.setVisible(false);
					this.labOver.setVisible(false);
				}
				else
				{
					this.btnTiaozhan.setVisible(false);
                    this.btnSaodang.setVisible(false);
					this.btnChongzhi.setVisible(true);
					this.labXiaohao.setVisible(true);
					this.labNumber.setVisible(true);
					this.labNumber1.setVisible(true);
					this.imgGold.setVisible(true);
					this.labOver.setVisible(false);
				}
			}
			else{
				this.btnTiaozhan.setVisible(false);
                this.btnSaodang.setVisible(false);
				this.btnChongzhi.setVisible(false);
				this.labXiaohao.setVisible(false);
				this.labNumber.setVisible(false);
				this.labNumber1.setVisible(false);
				this.imgGold.setVisible(false);
				this.labOver.setVisible(true);
			}
		}
	},

	UpdateData:function(zoneInfo){
		if( zoneInfo )
		{
			this._isFirst = zoneInfo.isFirst;
			this._zoneModelId = zoneInfo.zoneModelid;
			this._crossnum = zoneInfo.crossnum;
			this._paynum = zoneInfo.paynum;
			this.labNumber.SetText(TextUtil.FormatStr( this.labNumber.GetHtmlText(), [ this._jinjieZoneData.q_num_buy - this._paynum ] ));
			this.UpdataPayGoldNum();
		}
		this.UpdateState();
	}
} );
JinjieFubenFrameExt.PanelName = "JinjieFubenFrameExt";
PanelClassDic["JinjieFubenFrameExt"] = JinjieFubenFrameExt;
