/**
 * Created by Administrator on 2016/5/11.
 */
var projectVersion = "2017.08.01.070707";

jsb.AssetsManager.State = {
    UNINITED : 0,
    UNCHECKED : 1,
    PREDOWNLOAD_VERSION : 2,
    DOWNLOADING_VERSION : 3,
    VERSION_LOADED : 4,
    PREDOWNLOAD_MANIFEST : 5,
    DOWNLOADING_MANIFEST : 6,
    MANIFEST_LOADED : 7,
    NEED_UPDATE : 8,
    READY_TO_UPDATE : 9,
    UPDATING : 10,
    UNZIPPING : 11,
    UP_TO_DATE : 12,
    FAIL_TO_UPDATE : 13
}

var HotUpdatePanel = cc.Node.extend({
    _am:null,
    layerContainer:null,
    blackBg:null,
    _failCount:0,
    isGetConfig:false,

    onEnter:function(){
        this._super();
        ChannelUtil.Init();
        this.InitUpdatePanel();

        cc.log("Start Update.");
        this._loadingBg.visible = false;
        if (!cc.sys.isNative || !cc.sys.isMobile) {
            this._loadingText.setString( "加载游戏中，请耐心等候" );
            this.UpdateFinish();
            return;
        }
        var self = this;
        var button3 = new ccui.Button();
        button3.setNormalizedPosition(0.5, 0.5);
        button3.setTitleColor(cc.color(121, 134, 153));
        button3.setTitleText("清理缓存");
        button3.setTitleFontName("res/font/dfpyuanw7.ttf");
        button3.setTitleFontSize(24);
        button3.x = cc.visibleRect.topRight.x - 60;
        button3.y = cc.visibleRect.topRight.y - 20;
        button3.setZoomScale(0.2);
        button3.setPressedActionEnabled(true);
        button3.addClickEventListener(function () {
            jsb.fileUtils.removeDirectory(jsb.fileUtils.getWritablePath() + GameConfig.storagePath);
            jsb.fileUtils.removeDirectory(jsb.fileUtils.getWritablePath() + "update_temp/");    //temp 也要移除才行
            jsb.fileUtils.purgeCachedEntries();
            cc.game.restart();
            cc.sys.localStorage.removeItem("LastCdnUrl");
        });
        self.layerContainer.addChild(button3);
        var isLocalTest = ( GameConfig.type == 0 );
        if( isLocalTest ){
            // Create the button
            var button = new ccui.Button();
            button.setNormalizedPosition(0.5, 0.5);
            button.setTitleText("Merlin");
            button.setTitleFontSize(36);
            button.setZoomScale(0.3);
            button.x = cc.visibleRect.center.x;
            button.y = cc.visibleRect.center.y + 100;
            button.setPressedActionEnabled(true);
            button.addClickEventListener(function () {
                button.visible = false;
                button1.visible = false;
                button2.visible = false;
                button3.visible = false;
                button4.visible = false;
                self.ChangeCdn("http://192.168.51.69/phone/")
            });
            self.layerContainer.addChild(button);

            var button1 = new ccui.Button();
            button1.setNormalizedPosition(0.5, 0.5);
            button1.setTitleText("蒋耀均");
            button1.setTitleFontSize(36);
            button1.x = cc.visibleRect.center.x;
            button1.y = cc.visibleRect.center.y;
            button1.setZoomScale(0.3);
            button1.setPressedActionEnabled(true);
            button1.addClickEventListener(function () {
                button.visible = false;
                button1.visible = false;
                button2.visible = false;
                button3.visible = false;
                button4.visible = false;
                self.ChangeCdn("http://192.168.51.112/")
            });
            self.layerContainer.addChild(button1);

            var button2 = new ccui.Button();
            button2.setNormalizedPosition(0.5, 0.5);
            button2.setTitleText("阳邦华");
            button2.setTitleFontSize(36);
            button2.x = cc.visibleRect.center.x;
            button2.y = cc.visibleRect.center.y - 100;
            button2.setZoomScale(0.3);
            button2.setPressedActionEnabled(true);
            button2.addClickEventListener(function () {
                button.visible = false;
                button1.visible = false;
                button2.visible = false;
                button3.visible = false;
                button4.visible = false;
                self.ChangeCdn("http://192.168.51.171/")
            });
            self.layerContainer.addChild(button2);

            var button4 = new ccui.Button();
            button4.setNormalizedPosition(0.5, 0.5);
            button4.setTitleText("廖健宇");
            button4.setTitleFontSize(36);
            button4.x = cc.visibleRect.center.x - 200;
            button4.y = cc.visibleRect.center.y;
            button4.setZoomScale(0.3);
            button4.setPressedActionEnabled(true);
            button4.addClickEventListener(function () {
                button.visible = false;
                button1.visible = false;
                button2.visible = false;
                button3.visible = false;
                button4.visible = false;
                self.ChangeCdn("http://192.168.51.30/web4quick/")
            });
            self.layerContainer.addChild(button4);
        }
        else {
            //this.InitAssetManager();
            this.schedule(this.InitGateWayAndCDNConfig,3);
            // this.InitGateWayAndCDNConfig();
        }

    },

    InitGateWayAndCDNConfig:function(){
        if(typeof u8 == "undefined") {
            this.InitAssetManager();
            return;
        }

        // var GetDevelopInfo = function(key){
        //     key = key || "";
        //
        //     var result;
        //     if (cc.sys.os == cc.sys.OS_ANDROID) {
        //         result = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getU8DevelopInfo", "(Ljava/lang/String;)Ljava/lang/String;", key);
        //     } else if (cc.sys.os == cc.sys.OS_IOS) {
        //         result = jsb.reflection.callStaticMethod("AppController", "getU8DevelopInfo:",key);
        //     }
        //
        //     return result && result != "" ? result : null
        // }
        //
        // var debug = GetDevelopInfo("GAME_DEBUG");
        // if(debug == "true"){
        //    this.InitAssetManager();
        //    return;
        // }

        var onFailed = function(){
            this.InitAssetManager();
        }.bind(this);
        var onSucceed = function(){
            this.InitAssetManager();
        }.bind(this);
        var channelKey = ChannelUtil.GetPlatform()// GetDevelopInfo("U8_ChannelName");
        //GetDevelopInfo("GAME_GATEWAY_URL");

        if(!GameConfig.GATEWAY_URL){
            this.InitAssetManager();
            return;
        }
        this._loadingText.setString( "获取平台参数中，请耐心等候" );
        var url = GameConfig.GATEWAY_URL + "getAllPlatform?pf=" + channelKey;
        cc.log("gate wayurl==>>",url)
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Accept-Charset", "x-user-defined");
        var self = this;
        xhr.onload = function() {
            cc.log("xhr.readyState",xhr.readyState,xhr.status)
            if (xhr.readyState === 4 && xhr.status === 200) {
                cc.log("result==>>",xhr.response);
                try{
                    var result = JSON.parse(xhr.response);
                    if (result && result.state == 0) {
                        if( self.isGetConfig )
                            return;
                        self.isGetConfig = true;
                        var serverList = [];
                        var data = result.data || {};
                        var version = result.version || {};

                        var cdn = data.cdn;
                        var stresver = version.stresver;
                        var dataver = version.dataresver;
                        if(!cdn){
                            onFailed("连接网关失败！")
                            return
                        }

                        var fixPath = function(path){
                            if( path.charAt(path.length -1) != "/")
                                path += "/";
                            return path;
                        }
                        cc.log("准备更新GameConfig.CDN_URL 老的数据" + GameConfig.CDN_URL + "   " + GameConfig.WEB_CDN_URL);
                        GameConfig.CDN_URL = fixPath( cdn );
                        if( dataver )
                            GameConfig.CDN_URL += dataver + "/";
                        GameConfig.WEB_CDN_URL = fixPath( cdn );
                        if( stresver )
                            GameConfig.WEB_CDN_URL += stresver + "/";
                        cc.log("更新GameConfig.CDN_URL" + GameConfig.CDN_URL + "   " + GameConfig.WEB_CDN_URL);

                        onSucceed();
                    }else{
                        onFailed("连接网关失败！！！")
                    }
                }
                catch (e){
                    if(typeof buglyReportException == "function"){
                        // @1 错误信息 @2堆栈
                        var s = "getAllPlatform ---> " + e.message + "\n" + e.stack + "\n" + xhr.response;
                        buglyReportException("getAllPlatform ---> ",s);
                    }
                    onFailed("连接网关失败！！！")
                }
            } else {
                onFailed("连接网关失败！！！")
            }
        }.bind(this);
        xhr.send();
    },

    InitAssetManager:function(){
        this.unschedule(this.InitGateWayAndCDNConfig);
        this._loadingText.setString("正在检测版本信息，请耐心等候");

        //更新存储路径 如果要做微端的形式 这里要与微端的目录分开 不然更新的时候直接全部删除了
        var storagePath = (jsb.fileUtils ? jsb.fileUtils.getWritablePath() + GameConfig.storagePath : "/");
        cc.log('Storage path for remote asset : ' + storagePath);

        /***********  storagePath 更新app的时候删除缓存用的 现在c++根据manifest的版本大小自动删除 这里可以不用了
         var localStorage = cc.sys.localStorage.getItem("storagePath");
         var storageArr;
         if( localStorage ){
            storageArr = JSON.parse(localStorage);
            if(storageArr.indexOf(storagePath) < 0)
                storageArr.push(storagePath);
        }
         else{
            storageArr = [storagePath];
        }
         cc.sys.localStorage.setItem("storagePath", JSON.stringify(storageArr));
         **************************************************************/

        var VERSION_ID = "@version";
        var MANIFEST_ID = "@manifest";
        this.loadState = "start";

        //用于更新热更新服务器地址  正式版这里最好从服务器请求
        var cdnUrl = GameConfig.CDN_URL;

        cc.log("cdn_url --> " + cdnUrl);
        cc.log("SearchPath --> " + JSON.stringify(jsb.fileUtils.getSearchPaths()));

        this._am = new jsb.AssetsManager("", storagePath, this.CompareVersion);
        // this._am.setVersionCompareHandle(this.CompareVersion);
        this._am.retain();
        this._am.setRemoteUrl(cdnUrl);
        // this._am.setVerifyCallback(function(path, asset)
        // {
        //      // var compressed = asset.compressed;
        //      var expectedMD5 = asset.md5;
        //      // var relativePath = asset.path;
        //      // var size = asset.size;
        //      // var fullPath = jsb.fileUtils.fullPathForFilename( relativePath );
        //      var md5 = cc.CRC32.GetCRC32(path);//cc.MD5.GetMD5(url);
        //      return (md5.toString(16) == expectedMD5);
        // });
        if( cc.sys.os === cc.sys.OS_ANDROID ){
            this._am.setMaxConcurrentTask(16);   //某些android机器上同时下载数量过大会导致下载很慢 需要多测试
            cc.log( "Max concurrent tasks count have been limited to 16" );
        }

        this.CheckUpdate(); //不需要玩家确认网络那就直接检测更新
    },

    ChangeCdn:function(url){
        var lastCdn = cc.sys.localStorage.getItem("LastCdnUrl");
        if( !lastCdn )
            lastCdn = GameConfig.CDN_URL;

        if( lastCdn != url ){
            jsb.fileUtils.removeDirectory(jsb.fileUtils.getWritablePath() + GameConfig.storagePath);
        }
        cc.sys.localStorage.setItem("LastCdnUrl", url);
        GameConfig.WEB_CDN_URL = GameConfig.CDN_URL = url;
        this.InitAssetManager();
    },

    InitUpdatePanel:function(){
        this.layerContainer = new cc.Layer();
        var layerContainer = this.layerContainer;
        this.addChild(layerContainer);

        var blackBg = new cc.Node();//ccui.Scale9Sprite("res/ui/image/load/heitiao.png", cc.rect(), cc.rect( 0, 0, 1, 87 ));
        blackBg.x = cc.visibleRect.center.x;
        blackBg.y = 40;
        // blackBg.width = 1334;
        layerContainer.addChild(blackBg);

        this.blackBg = blackBg;

        this._loadingBg = ccui.Scale9Sprite("res/ui/image/load/jindutiao.png", cc.rect(), cc.rect( 32, 0, 1, 26 ));
        this._loadingBg.width = 858;
        this._loadingBg.y = 15;
        blackBg.addChild( this._loadingBg );
        this._loadingBar = new ccui.LoadingBar("res/ui/image/load/jindutiao1.png", 0);
        this._loadingBar.x = this._loadingBg.width * 0.5;
        this._loadingBar.y = 12;
        this._loadingBg.addChild(this._loadingBar);

        this._loadingText = new ccui.Text("", "res/font/dfpyuanw7.ttf", 20);
        this._loadingText.enableOutline(new cc.Color(0,0,0,255), 1);
        this._loadingText.y = 45;
        blackBg.addChild(this._loadingText);

        // this._progressText = new ccui.Text("", "res/font/dfpyuanw7.ttf", 20);
        // this._progressText.enableOutline(new cc.Color(0,0,0,255), 1);
        // this._progressText.y = 25;
        // blackBg.addChild(this._progressText);

        var downText = new ccui.Text("抵制不良游戏，拒绝盗版游戏。注意自我保护，谨防上当受骗。适度游戏宜脑，沉迷游戏伤身。合理安排时间，享受健康生活。", "res/font/dfpyuanw7.ttf", 14);
        downText.enableOutline(new cc.Color(0,0,0,255), 1);
        downText.x=cc.visibleRect.center.x;
        downText.y=12;
        layerContainer.addChild( downText );
    },

    CompareVersion:function(v1, v2){
        cc.log( v1 + " --------- vs --------- " + v2 );
        var arr1 = v1.split(".");
        var arr2 = v2.split(".");
        for( var i = 0; i < arr1.length; i++ ){
            var num1 = parseInt(arr1[i]);
            var num2 = parseInt(arr2[i]);
            if( num1 > num2 ){
                return 1;
            }
            else if( num1 < num2 ){
                return -1;
            }
        }
        return 0;
    },

    GetDownloadSpeed:function(downloadSize){
        if( !this.lastSecond ){
            this.lastSecond = new Date().getTime();
            this.lastLoadSize = 0;
        }
        else
        {
            var now = new Date().getTime();
            var subTime = now - this.lastSecond;
            if( subTime > 1000 ){
                this.lastSpeed = (downloadSize - this.lastLoadSize) / subTime * 1000;
                this.lastLoadSize = downloadSize;
                this.lastSecond = now;
            }
        }
        return this.lastSpeed;
    },

    CheckUpdate:function(){
        if (this._am.getState() === jsb.AssetsManager.State.UNINITED) {
            this._am.loadLocalManifest("project.manifest");

            var manifest = this._am.getLocalManifest();
            if( manifest )
                projectVersion = manifest.getVersion();
        }
        if (!this._am.getLocalManifest() || !this._am.getLocalManifest().isLoaded()){
            cc.log("Fail to load local manifest, step skipped.");
            this.UpdateFinish();
            return;
        }
        this._checkListener = new jsb.EventListenerAssetsManager(this._am, this.CheckCallback.bind(this) );
        cc.eventManager.addListener( this._checkListener, 1);
        this._am.checkUpdate();
    },

    StartUpdate:function(){
        this._loadingBg.visible = true;
        this._loadingText.y = 60;
        this._loadingText.setString("资源文件下载中，请保持游戏处于打开状态");
        this._loadingBar.setPercent(0);

        this._updateListener = new jsb.EventListenerAssetsManager(this._am, this.UpdateCallback.bind(this) );
        cc.eventManager.addListener( this._updateListener, 1);

        if (this._am.getState() === jsb.AssetsManager.State.UNINITED) {
            this._am.loadLocalManifest("project.manifest");

            var manifest = this._am.getLocalManifest();
            if( manifest )
                projectVersion = manifest.getVersion();
        }

        this._am.update();
    },

    CheckCallback:function(event){
        cc.log('Check Update Code: ' + event.getEventCode());
        switch (event.getEventCode()){
            case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST:
                cc.log("No local manifest file found, skip assets update.");
                this._loadingText.setString( "本地文件损坏，请尝试重新下载客户端。" );
                //this.UpdateFinish();            //这里应该修复客户端  new Manifest()直接全部更新
                break;
            case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST:
            case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST:
                cc.log("Fail to download manifest file, update skipped.");
                this._loadingText.setString( "下载更新列表失败" );
                this.UpdateFinish();
                break;
            case jsb.EventAssetsManager.NEW_VERSION_FOUND:
                cc.log("发现新版本, 是否要提示更新");
                this.StartUpdate();
                break;
            case jsb.EventAssetsManager.ALREADY_UP_TO_DATE:;
                cc.log("already up to new version.");
                this._loadingText.setString( "加载游戏中，请耐心等候" );
                this.UpdateFinish();
                break;
            default:
                return;
        }
        cc.eventManager.removeListener(this._checkListener);
        this._checkListener = null;
    },

    UpdateCallback:function(event){
        var failed = false;
        var updateFinished = false;
        switch (event.getEventCode()){
            case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST:
                cc.log("No local manifest file found, skip assets update.");
                this._loadingText.setString( "本地文件损坏，请尝试重新下载客户端。" );
                failed = true;
                //this.UpdateFinish();            //这里可以new Manifest()直接全部更新
                break;
            case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST:
            case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST:
                cc.log("Fail to download manifest file, update skipped.");
                this._loadingText.setString( "下载更新列表失败，请检查网络或稍后重试。" );
                failed = true;
                //this.UpdateFinish();
                break;
            case jsb.EventAssetsManager.UPDATE_PROGRESSION:
                var assetId = event.getAssetId();
                if( !assetId ){
                    var sizePercent = (event.getDownloadedBytes() / event.getTotalBytes() * 100).toFixed(2);
                    var filePercent = (event.getDownloadedFiles() / event.getTotalFiles() * 100).toFixed(2);
                    var speed = this.GetDownloadSpeed(event.getDownloadedBytes());  //计算下载速度  字节
                    sizePercent = ( isFinite( sizePercent ) && !isNaN(sizePercent) ) ? sizePercent : 0;
                    this._loadingBar.setPercent( sizePercent );

                    //cc.log( assetId + "    " + event.getDownloadedBytes() + "/" + event.getTotalBytes() + "  <-------->  " + event.getDownloadedFiles() + "/" + event.getTotalFiles() );
                }
                var msg = event.getMessage();
                if (msg) {
                    cc.log("Updated file: " + msg);
                }
                break;
            case jsb.EventAssetsManager.UPDATE_FINISHED:
                cc.sys.localStorage.setItem("HotUpdateStoragePath", GameConfig.storagePath);
                cc.game.restart();
                break;
            case jsb.EventAssetsManager.ALREADY_UP_TO_DATE:
                cc.log("Update finished.");
                var manifest = this._am.getLocalManifest();
                if( manifest )
                    projectVersion = manifest.getVersion();
                updateFinished = true;
                this._loadingText.setString( "加载游戏中，请耐心等候" );
                this.UpdateFinish();
                break;
            case jsb.EventAssetsManager.UPDATE_FAILED:
                cc.log("Update failed. " + event.getMessage());
                this._loadingText.setString( "正在重新下载失败文件" );
                this._failCount ++;
                if (this._failCount < 5){
                    this._am.downloadFailedAssets();
                }
                else{
                    cc.log("Reach maximum fail count, exit update process");
                    this._loadingText.setString( "更新失败，请尝试切换网络再试" );
                    this._failCount = 0;
                    //this.UpdateFinish();      这里最好显示重试按钮
                }
                break;
            case jsb.EventAssetsManager.ERROR_UPDATING:
                cc.log("Asset update error: " + event.getAssetId() + ", " + event.getMessage());
                //this.UpdateFinish();  这里应该是等待下载完毕后检查失败资源触发UPDATE_FAILED 再downloadFailedAssets
                break;
            case jsb.EventAssetsManager.ERROR_DECOMPRESS:
                cc.log(event.getMessage());
                //this.UpdateFinish();
                failed = true;
                break;
            default:
                break;
        }
        if (failed || updateFinished){
            cc.eventManager.removeListener(this._updateListener);
            this._updateListener = null;
            this._am.release();
            this._am = null;
        }
    },

    UpdateFinish:function(){
        this._loadingBar.setPercent(100);
        cc.log("Load jsList..");
        var gameScene = cc.director.getRunningScene();
        if( gameScene )
            cc.director.getScheduler().schedule(gameScene.LoadGameScript, gameScene, 0, 0, 0, false);       //等待文本渲染 下一帧再加载
    },

    LoadProgress:function(percent){
        this._loadingBg.visible = true;
        this._loadingText.y = 60;
        this._loadingBar.setPercent(percent);
    },

    Dispose:function(){
        this.layerContainer.removeFromParent();
        this.layerContainer = null;
    }
});


